#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 1953
#define LARGE_STATE_COUNT 210
#define SYMBOL_COUNT 309
#define ALIAS_COUNT 5
#define TOKEN_COUNT 138
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 24
#define MAX_ALIAS_SEQUENCE_LENGTH 14
#define PRODUCTION_ID_COUNT 114

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_from = 2,
  anon_sym_import = 3,
  anon_sym_LPAREN = 4,
  anon_sym_RPAREN = 5,
  anon_sym_COMMA = 6,
  anon_sym_as = 7,
  anon_sym_using = 8,
  anon_sym_EQ = 9,
  anon_sym_PERCENTbuiltins = 10,
  anon_sym_PERCENTlang = 11,
  anon_sym_AT = 12,
  anon_sym_namespace = 13,
  anon_sym_LBRACE = 14,
  anon_sym_RBRACE = 15,
  anon_sym_struct = 16,
  anon_sym_func = 17,
  anon_sym_DASH_GT = 18,
  anon_sym_COLON = 19,
  anon_sym_end = 20,
  anon_sym_alloc_locals = 21,
  anon_sym_assert = 22,
  anon_sym_static_assert = 23,
  anon_sym_EQ_EQ = 24,
  anon_sym_let = 25,
  anon_sym_const = 26,
  anon_sym_local = 27,
  anon_sym_tempvar = 28,
  anon_sym_ap = 29,
  anon_sym_PLUS_PLUS = 30,
  anon_sym_jmp = 31,
  anon_sym_rel = 32,
  anon_sym_abs = 33,
  anon_sym_if = 34,
  anon_sym_BANG_EQ = 35,
  sym_inst_ret = 36,
  anon_sym_PLUS_EQ = 37,
  anon_sym_dw = 38,
  anon_sym_with_attr = 39,
  anon_sym_else = 40,
  anon_sym_with = 41,
  anon_sym_return = 42,
  anon_sym_felt = 43,
  anon_sym_codeoffset = 44,
  anon_sym_STAR = 45,
  anon_sym_STAR_STAR = 46,
  anon_sym_AMP = 47,
  anon_sym_DASH = 48,
  anon_sym_new = 49,
  anon_sym_PLUS = 50,
  anon_sym_SLASH = 51,
  anon_sym_and = 52,
  sym_string = 53,
  sym_short_string = 54,
  anon_sym_nondet = 55,
  anon_sym_PERCENT_LBRACE = 56,
  anon_sym_PERCENT_RBRACE = 57,
  anon_sym_fp = 58,
  anon_sym_LBRACK = 59,
  anon_sym_RBRACK = 60,
  anon_sym_DOT = 61,
  anon_sym_cast = 62,
  anon_sym_call = 63,
  sym_number = 64,
  anon_sym_SEMI = 65,
  anon_sym_LF = 66,
  sym_comment = 67,
  anon_sym_use = 68,
  anon_sym_extern = 69,
  anon_sym_type = 70,
  anon_sym_COLON_COLON = 71,
  anon_sym_fn = 72,
  anon_sym_POUND = 73,
  anon_sym_mod = 74,
  anon_sym_enum = 75,
  anon_sym_implicits = 76,
  anon_sym_nopanic = 77,
  anon_sym_ref = 78,
  anon_sym_mut = 79,
  anon_sym_impl = 80,
  anon_sym_of = 81,
  anon_sym_trait = 82,
  anon_sym_u8 = 83,
  anon_sym_i8 = 84,
  anon_sym_u16 = 85,
  anon_sym_i16 = 86,
  anon_sym_u32 = 87,
  anon_sym_i32 = 88,
  anon_sym_u64 = 89,
  anon_sym_i64 = 90,
  anon_sym_u128 = 91,
  anon_sym_i128 = 92,
  anon_sym_u256 = 93,
  anon_sym_i256 = 94,
  anon_sym_isize = 95,
  anon_sym_usize = 96,
  anon_sym_f32 = 97,
  anon_sym_f64 = 98,
  anon_sym_felt252 = 99,
  anon_sym_bool = 100,
  anon_sym_str = 101,
  anon_sym_char = 102,
  anon_sym_LT = 103,
  anon_sym_GT = 104,
  anon_sym_match = 105,
  anon_sym_EQ_GT = 106,
  anon_sym_loop = 107,
  anon_sym__ = 108,
  anon_sym_BANG = 109,
  anon_sym_TILDE = 110,
  anon_sym_AMP_AMP = 111,
  anon_sym_PIPE_PIPE = 112,
  anon_sym_PIPE = 113,
  anon_sym_CARET = 114,
  anon_sym_LT2 = 115,
  anon_sym_LT_EQ = 116,
  anon_sym_GT_EQ = 117,
  anon_sym_LT_LT = 118,
  anon_sym_GT_GT = 119,
  anon_sym_PERCENT = 120,
  anon_sym_DASH_EQ = 121,
  anon_sym_STAR_EQ = 122,
  anon_sym_SLASH_EQ = 123,
  anon_sym_PERCENT_EQ = 124,
  anon_sym_AMP_EQ = 125,
  anon_sym_PIPE_EQ = 126,
  anon_sym_CARET_EQ = 127,
  anon_sym_LT_LT_EQ = 128,
  anon_sym_GT_GT_EQ = 129,
  anon_sym_QMARK = 130,
  anon_sym_DOT_DOT = 131,
  sym__cairo_1_short_string = 132,
  anon_sym_true = 133,
  anon_sym_false = 134,
  sym_self = 135,
  sym_code_line = 136,
  sym__failure = 137,
  sym_program = 138,
  sym_cairo_0_file = 139,
  sym_cairo_1_file = 140,
  sym__cairo_0_statement = 141,
  sym__cairo_0_import_statement = 142,
  sym__import_list = 143,
  sym_aliased_import = 144,
  sym_type_definition = 145,
  sym_builtin_directive = 146,
  sym_lang_directive = 147,
  sym__cairo_0_decorated_definition = 148,
  sym_decorator = 149,
  sym__cairo_0_namespace_definition = 150,
  sym__cairo_0_struct_definition = 151,
  sym__cairo_0_function_definition = 152,
  sym_implicit_arguments = 153,
  sym_arguments = 154,
  sym__cairo_0_expression_statement = 155,
  sym_alloc_locals = 156,
  sym__cairo_0_assert_statement = 157,
  sym__cairo_0_static_assert_statement = 158,
  sym__cairo_0_let_binding = 159,
  sym_const_var_declaration = 160,
  sym_local_var_declaration = 161,
  sym_temp_var_declaration = 162,
  sym_instruction = 163,
  sym_inst_assert_eq = 164,
  sym_inst_jmp_rel = 165,
  sym_inst_jmp_abs = 166,
  sym_inst_jmp_to_label = 167,
  sym_inst_jnz = 168,
  sym_inst_jnz_to_label = 169,
  sym_inst_add_ap = 170,
  sym_inst_data_word = 171,
  sym_label = 172,
  sym__cairo_0_attribute_statement = 173,
  sym__cairo_0_if_statement = 174,
  sym__cairo_0_with_statement = 175,
  sym__cairo_0_return_statement = 176,
  sym__non_identifier_type = 177,
  sym__cairo_0_builtin_type = 178,
  sym__cairo_0_pointer_type = 179,
  sym__cairo_0_tuple_type = 180,
  sym__cairo_0_type = 181,
  sym_named_type = 182,
  sym__cairo_0_expression = 183,
  sym_unary_expression = 184,
  sym_binary_expression = 185,
  sym_assignment_expression = 186,
  sym_hint_expression = 187,
  sym_hint = 188,
  sym_python_code = 189,
  sym_register = 190,
  sym_deref_expression = 191,
  sym_subscript_expression = 192,
  sym_member_expression = 193,
  sym_cast_expression = 194,
  sym_tuple_expression = 195,
  sym__cairo_0_call_expression = 196,
  sym__ref_binding = 197,
  sym_call_instruction = 198,
  sym_typed_identifier = 199,
  sym_dotted_name = 200,
  sym__separator = 201,
  sym__cairo_1_statement = 202,
  sym_use_declaration = 203,
  sym_extern_type_statement = 204,
  sym__use_clause = 205,
  sym_scoped_use_list = 206,
  sym_use_list = 207,
  sym_use_as_clause = 208,
  sym_extern_function_statement = 209,
  sym_attribute_item = 210,
  sym_attribute_arguments = 211,
  sym_mod_item = 212,
  sym_struct_item = 213,
  sym_enum_item = 214,
  sym_enum_variant_list = 215,
  sym_enum_variant = 216,
  sym_field_declaration_list = 217,
  sym_field_declaration = 218,
  sym_const_item = 219,
  sym_type_item = 220,
  sym_block = 221,
  sym__cairo_1_function_definition = 222,
  sym__function_signature = 223,
  sym__cairo_1_function_signature = 224,
  sym_parameter = 225,
  sym_impl_item = 226,
  sym_trait_item = 227,
  sym_let_declaration = 228,
  sym_declaration_list = 229,
  sym__cairo_1_type = 230,
  sym_at_type = 231,
  sym__cairo_1_generic_function = 232,
  sym_generic_type = 233,
  sym_generic_type_with_turbofish = 234,
  sym__cairo_1_type_arguments = 235,
  sym__cairo_1_tuple_type = 236,
  sym_unit_type = 237,
  sym_abstract_type = 238,
  sym__cairo_1_expression_statement = 239,
  sym__cairo_1_expression = 240,
  sym__cairo_1_return_expression = 241,
  sym__cairo_1_if_expression = 242,
  sym__cairo_1_else_clause = 243,
  sym_match_expression = 244,
  sym_match_block = 245,
  sym_match_arm = 246,
  sym_last_match_arm = 247,
  sym_match_pattern = 248,
  sym__cairo_1_loop_expression = 249,
  sym__cairo_1_at_expression = 250,
  sym__pattern = 251,
  sym_tuple_pattern = 252,
  sym_tuple_struct_pattern = 253,
  sym_struct_pattern = 254,
  sym_field_pattern = 255,
  sym__cairo_1_unary_expression = 256,
  sym__cairo_1_binary_expression = 257,
  sym__cairo_1_assignment_expression = 258,
  sym__cairo_1_compound_assignment_expression = 259,
  sym__cairo_1_try_expression = 260,
  sym__cairo_1_call_expression = 261,
  sym__cairo_1_index_expression = 262,
  sym__cairo_1_field_expression = 263,
  sym__cairo_1_parenthesized_expression = 264,
  sym__cairo_1_tuple_expression = 265,
  sym__cairo_1_unit_expression = 266,
  sym__cairo_1_struct_expression = 267,
  sym_field_initializer_list = 268,
  sym_shorthand_field_initializer = 269,
  sym_field_initializer = 270,
  sym_base_field_initializer = 271,
  sym_trait_bounds = 272,
  sym_type_parameters = 273,
  sym_constrained_type_parameter = 274,
  sym__literal = 275,
  sym__literal_pattern = 276,
  sym_scoped_identifier = 277,
  sym_scoped_type_identifier = 278,
  sym_boolean = 279,
  aux_sym_cairo_0_file_repeat1 = 280,
  aux_sym_cairo_1_file_repeat1 = 281,
  aux_sym__import_list_repeat1 = 282,
  aux_sym_builtin_directive_repeat1 = 283,
  aux_sym__cairo_0_decorated_definition_repeat1 = 284,
  aux_sym__cairo_0_struct_definition_repeat1 = 285,
  aux_sym__cairo_0_attribute_statement_repeat1 = 286,
  aux_sym__cairo_0_with_statement_repeat1 = 287,
  aux_sym__cairo_0_tuple_type_repeat1 = 288,
  aux_sym_python_code_repeat1 = 289,
  aux_sym_tuple_expression_repeat1 = 290,
  aux_sym__cairo_0_call_expression_repeat1 = 291,
  aux_sym_dotted_name_repeat1 = 292,
  aux_sym_use_list_repeat1 = 293,
  aux_sym_attribute_arguments_repeat1 = 294,
  aux_sym_enum_variant_list_repeat1 = 295,
  aux_sym_enum_variant_list_repeat2 = 296,
  aux_sym_field_declaration_list_repeat1 = 297,
  aux_sym_block_repeat1 = 298,
  aux_sym__function_signature_repeat1 = 299,
  aux_sym__cairo_1_type_arguments_repeat1 = 300,
  aux_sym__cairo_1_tuple_type_repeat1 = 301,
  aux_sym_match_block_repeat1 = 302,
  aux_sym_tuple_pattern_repeat1 = 303,
  aux_sym_struct_pattern_repeat1 = 304,
  aux_sym__cairo_1_call_expression_repeat1 = 305,
  aux_sym__cairo_1_tuple_expression_repeat1 = 306,
  aux_sym_field_initializer_list_repeat1 = 307,
  aux_sym_type_parameters_repeat1 = 308,
  alias_sym_field_identifier = 309,
  alias_sym_return_type = 310,
  alias_sym_shorthand_field_identifier = 311,
  alias_sym_type = 312,
  alias_sym_type_identifier = 313,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_from] = "from",
  [anon_sym_import] = "import",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_as] = "as",
  [anon_sym_using] = "using",
  [anon_sym_EQ] = "=",
  [anon_sym_PERCENTbuiltins] = "%builtins",
  [anon_sym_PERCENTlang] = "%lang",
  [anon_sym_AT] = "@",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_struct] = "struct",
  [anon_sym_func] = "func",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_COLON] = ":",
  [anon_sym_end] = "end",
  [anon_sym_alloc_locals] = "alloc_locals",
  [anon_sym_assert] = "assert",
  [anon_sym_static_assert] = "static_assert",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_local] = "local",
  [anon_sym_tempvar] = "tempvar",
  [anon_sym_ap] = "ap",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_jmp] = "jmp",
  [anon_sym_rel] = "rel",
  [anon_sym_abs] = "abs",
  [anon_sym_if] = "if",
  [anon_sym_BANG_EQ] = "!=",
  [sym_inst_ret] = "inst_ret",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_dw] = "dw",
  [anon_sym_with_attr] = "with_attr",
  [anon_sym_else] = "else",
  [anon_sym_with] = "with",
  [anon_sym_return] = "return",
  [anon_sym_felt] = "felt",
  [anon_sym_codeoffset] = "codeoffset",
  [anon_sym_STAR] = "*",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_AMP] = "&",
  [anon_sym_DASH] = "-",
  [anon_sym_new] = "new",
  [anon_sym_PLUS] = "+",
  [anon_sym_SLASH] = "/",
  [anon_sym_and] = "and",
  [sym_string] = "string",
  [sym_short_string] = "short_string",
  [anon_sym_nondet] = "nondet",
  [anon_sym_PERCENT_LBRACE] = "%{",
  [anon_sym_PERCENT_RBRACE] = "%}",
  [anon_sym_fp] = "fp",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT] = ".",
  [anon_sym_cast] = "cast",
  [anon_sym_call] = "call",
  [sym_number] = "number",
  [anon_sym_SEMI] = ";",
  [anon_sym_LF] = "\n",
  [sym_comment] = "comment",
  [anon_sym_use] = "use",
  [anon_sym_extern] = "extern",
  [anon_sym_type] = "type",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_fn] = "fn",
  [anon_sym_POUND] = "#",
  [anon_sym_mod] = "mod",
  [anon_sym_enum] = "enum",
  [anon_sym_implicits] = "implicits",
  [anon_sym_nopanic] = "nopanic",
  [anon_sym_ref] = "ref",
  [anon_sym_mut] = "mut",
  [anon_sym_impl] = "impl",
  [anon_sym_of] = "of",
  [anon_sym_trait] = "trait",
  [anon_sym_u8] = "primitive_type",
  [anon_sym_i8] = "primitive_type",
  [anon_sym_u16] = "primitive_type",
  [anon_sym_i16] = "primitive_type",
  [anon_sym_u32] = "primitive_type",
  [anon_sym_i32] = "primitive_type",
  [anon_sym_u64] = "primitive_type",
  [anon_sym_i64] = "primitive_type",
  [anon_sym_u128] = "primitive_type",
  [anon_sym_i128] = "primitive_type",
  [anon_sym_u256] = "primitive_type",
  [anon_sym_i256] = "primitive_type",
  [anon_sym_isize] = "primitive_type",
  [anon_sym_usize] = "primitive_type",
  [anon_sym_f32] = "primitive_type",
  [anon_sym_f64] = "primitive_type",
  [anon_sym_felt252] = "primitive_type",
  [anon_sym_bool] = "primitive_type",
  [anon_sym_str] = "primitive_type",
  [anon_sym_char] = "primitive_type",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_match] = "match",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_loop] = "loop",
  [anon_sym__] = "_",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_LT2] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_QMARK] = "\?",
  [anon_sym_DOT_DOT] = "..",
  [sym__cairo_1_short_string] = "short_string",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_self] = "self",
  [sym_code_line] = "code_line",
  [sym__failure] = "_failure",
  [sym_program] = "program",
  [sym_cairo_0_file] = "cairo_0_file",
  [sym_cairo_1_file] = "cairo_1_file",
  [sym__cairo_0_statement] = "_cairo_0_statement",
  [sym__cairo_0_import_statement] = "import_statement",
  [sym__import_list] = "_import_list",
  [sym_aliased_import] = "aliased_import",
  [sym_type_definition] = "type_definition",
  [sym_builtin_directive] = "builtin_directive",
  [sym_lang_directive] = "lang_directive",
  [sym__cairo_0_decorated_definition] = "decorated_definition",
  [sym_decorator] = "decorator",
  [sym__cairo_0_namespace_definition] = "namespace_definition",
  [sym__cairo_0_struct_definition] = "struct_definition",
  [sym__cairo_0_function_definition] = "function_definition",
  [sym_implicit_arguments] = "implicit_arguments",
  [sym_arguments] = "arguments",
  [sym__cairo_0_expression_statement] = "expression_statement",
  [sym_alloc_locals] = "alloc_locals",
  [sym__cairo_0_assert_statement] = "assert_statement",
  [sym__cairo_0_static_assert_statement] = "static_assert_statement",
  [sym__cairo_0_let_binding] = "let_binding",
  [sym_const_var_declaration] = "const_var_declaration",
  [sym_local_var_declaration] = "local_var_declaration",
  [sym_temp_var_declaration] = "temp_var_declaration",
  [sym_instruction] = "instruction",
  [sym_inst_assert_eq] = "inst_assert_eq",
  [sym_inst_jmp_rel] = "inst_jmp_rel",
  [sym_inst_jmp_abs] = "inst_jmp_abs",
  [sym_inst_jmp_to_label] = "inst_jmp_to_label",
  [sym_inst_jnz] = "inst_jnz",
  [sym_inst_jnz_to_label] = "inst_jnz_to_label",
  [sym_inst_add_ap] = "inst_add_ap",
  [sym_inst_data_word] = "inst_data_word",
  [sym_label] = "label",
  [sym__cairo_0_attribute_statement] = "attribute_statement",
  [sym__cairo_0_if_statement] = "if_statement",
  [sym__cairo_0_with_statement] = "with_statement",
  [sym__cairo_0_return_statement] = "return_statement",
  [sym__non_identifier_type] = "_non_identifier_type",
  [sym__cairo_0_builtin_type] = "builtin_type",
  [sym__cairo_0_pointer_type] = "pointer_type",
  [sym__cairo_0_tuple_type] = "tuple_type",
  [sym__cairo_0_type] = "_cairo_0_type",
  [sym_named_type] = "named_type",
  [sym__cairo_0_expression] = "_cairo_0_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_hint_expression] = "hint_expression",
  [sym_hint] = "hint",
  [sym_python_code] = "python_code",
  [sym_register] = "register",
  [sym_deref_expression] = "deref_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_member_expression] = "member_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym__cairo_0_call_expression] = "call_expression",
  [sym__ref_binding] = "_ref_binding",
  [sym_call_instruction] = "call_instruction",
  [sym_typed_identifier] = "typed_identifier",
  [sym_dotted_name] = "dotted_name",
  [sym__separator] = "_separator",
  [sym__cairo_1_statement] = "_cairo_1_statement",
  [sym_use_declaration] = "use_declaration",
  [sym_extern_type_statement] = "extern_type_statement",
  [sym__use_clause] = "_use_clause",
  [sym_scoped_use_list] = "scoped_use_list",
  [sym_use_list] = "use_list",
  [sym_use_as_clause] = "use_as_clause",
  [sym_extern_function_statement] = "extern_function_statement",
  [sym_attribute_item] = "attribute_item",
  [sym_attribute_arguments] = "attribute_arguments",
  [sym_mod_item] = "mod_item",
  [sym_struct_item] = "struct_item",
  [sym_enum_item] = "enum_item",
  [sym_enum_variant_list] = "enum_variant_list",
  [sym_enum_variant] = "enum_variant",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym_field_declaration] = "field_declaration",
  [sym_const_item] = "const_item",
  [sym_type_item] = "type_item",
  [sym_block] = "block",
  [sym__cairo_1_function_definition] = "function_definition",
  [sym__function_signature] = "_function_signature",
  [sym__cairo_1_function_signature] = "function_signature",
  [sym_parameter] = "parameter",
  [sym_impl_item] = "impl_item",
  [sym_trait_item] = "trait_item",
  [sym_let_declaration] = "let_declaration",
  [sym_declaration_list] = "declaration_list",
  [sym__cairo_1_type] = "_cairo_1_type",
  [sym_at_type] = "at_type",
  [sym__cairo_1_generic_function] = "generic_function",
  [sym_generic_type] = "generic_type",
  [sym_generic_type_with_turbofish] = "generic_type",
  [sym__cairo_1_type_arguments] = "type_arguments",
  [sym__cairo_1_tuple_type] = "tuple_type",
  [sym_unit_type] = "unit_type",
  [sym_abstract_type] = "abstract_type",
  [sym__cairo_1_expression_statement] = "expression_statement",
  [sym__cairo_1_expression] = "_cairo_1_expression",
  [sym__cairo_1_return_expression] = "return_expression",
  [sym__cairo_1_if_expression] = "if_expression",
  [sym__cairo_1_else_clause] = "else_clause",
  [sym_match_expression] = "match_expression",
  [sym_match_block] = "match_block",
  [sym_match_arm] = "match_arm",
  [sym_last_match_arm] = "match_arm",
  [sym_match_pattern] = "match_pattern",
  [sym__cairo_1_loop_expression] = "loop_expression",
  [sym__cairo_1_at_expression] = "at_expression",
  [sym__pattern] = "_pattern",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_tuple_struct_pattern] = "tuple_struct_pattern",
  [sym_struct_pattern] = "struct_pattern",
  [sym_field_pattern] = "field_pattern",
  [sym__cairo_1_unary_expression] = "unary_expression",
  [sym__cairo_1_binary_expression] = "binary_expression",
  [sym__cairo_1_assignment_expression] = "assignment_expression",
  [sym__cairo_1_compound_assignment_expression] = "compound_assignment_expression",
  [sym__cairo_1_try_expression] = "try_expression",
  [sym__cairo_1_call_expression] = "call_expression",
  [sym__cairo_1_index_expression] = "index_expression",
  [sym__cairo_1_field_expression] = "field_expression",
  [sym__cairo_1_parenthesized_expression] = "parenthesized_expression",
  [sym__cairo_1_tuple_expression] = "tuple_expression",
  [sym__cairo_1_unit_expression] = "unit_expression",
  [sym__cairo_1_struct_expression] = "struct_expression",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_shorthand_field_initializer] = "shorthand_field_initializer",
  [sym_field_initializer] = "field_initializer",
  [sym_base_field_initializer] = "base_field_initializer",
  [sym_trait_bounds] = "trait_bounds",
  [sym_type_parameters] = "type_parameters",
  [sym_constrained_type_parameter] = "constrained_type_parameter",
  [sym__literal] = "_literal",
  [sym__literal_pattern] = "_literal_pattern",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_scoped_type_identifier] = "scoped_type_identifier",
  [sym_boolean] = "boolean",
  [aux_sym_cairo_0_file_repeat1] = "cairo_0_file_repeat1",
  [aux_sym_cairo_1_file_repeat1] = "cairo_1_file_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym_builtin_directive_repeat1] = "builtin_directive_repeat1",
  [aux_sym__cairo_0_decorated_definition_repeat1] = "_cairo_0_decorated_definition_repeat1",
  [aux_sym__cairo_0_struct_definition_repeat1] = "_cairo_0_struct_definition_repeat1",
  [aux_sym__cairo_0_attribute_statement_repeat1] = "_cairo_0_attribute_statement_repeat1",
  [aux_sym__cairo_0_with_statement_repeat1] = "_cairo_0_with_statement_repeat1",
  [aux_sym__cairo_0_tuple_type_repeat1] = "_cairo_0_tuple_type_repeat1",
  [aux_sym_python_code_repeat1] = "python_code_repeat1",
  [aux_sym_tuple_expression_repeat1] = "tuple_expression_repeat1",
  [aux_sym__cairo_0_call_expression_repeat1] = "_cairo_0_call_expression_repeat1",
  [aux_sym_dotted_name_repeat1] = "dotted_name_repeat1",
  [aux_sym_use_list_repeat1] = "use_list_repeat1",
  [aux_sym_attribute_arguments_repeat1] = "attribute_arguments_repeat1",
  [aux_sym_enum_variant_list_repeat1] = "enum_variant_list_repeat1",
  [aux_sym_enum_variant_list_repeat2] = "enum_variant_list_repeat2",
  [aux_sym_field_declaration_list_repeat1] = "field_declaration_list_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym__function_signature_repeat1] = "_function_signature_repeat1",
  [aux_sym__cairo_1_type_arguments_repeat1] = "_cairo_1_type_arguments_repeat1",
  [aux_sym__cairo_1_tuple_type_repeat1] = "_cairo_1_tuple_type_repeat1",
  [aux_sym_match_block_repeat1] = "match_block_repeat1",
  [aux_sym_tuple_pattern_repeat1] = "tuple_pattern_repeat1",
  [aux_sym_struct_pattern_repeat1] = "struct_pattern_repeat1",
  [aux_sym__cairo_1_call_expression_repeat1] = "_cairo_1_call_expression_repeat1",
  [aux_sym__cairo_1_tuple_expression_repeat1] = "_cairo_1_tuple_expression_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_return_type] = "return_type",
  [alias_sym_shorthand_field_identifier] = "shorthand_field_identifier",
  [alias_sym_type] = "type",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_PERCENTbuiltins] = anon_sym_PERCENTbuiltins,
  [anon_sym_PERCENTlang] = anon_sym_PERCENTlang,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_func] = anon_sym_func,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_alloc_locals] = anon_sym_alloc_locals,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_static_assert] = anon_sym_static_assert,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_local] = anon_sym_local,
  [anon_sym_tempvar] = anon_sym_tempvar,
  [anon_sym_ap] = anon_sym_ap,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_jmp] = anon_sym_jmp,
  [anon_sym_rel] = anon_sym_rel,
  [anon_sym_abs] = anon_sym_abs,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [sym_inst_ret] = sym_inst_ret,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_dw] = anon_sym_dw,
  [anon_sym_with_attr] = anon_sym_with_attr,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_felt] = anon_sym_felt,
  [anon_sym_codeoffset] = anon_sym_codeoffset,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_and] = anon_sym_and,
  [sym_string] = sym_string,
  [sym_short_string] = sym_short_string,
  [anon_sym_nondet] = anon_sym_nondet,
  [anon_sym_PERCENT_LBRACE] = anon_sym_PERCENT_LBRACE,
  [anon_sym_PERCENT_RBRACE] = anon_sym_PERCENT_RBRACE,
  [anon_sym_fp] = anon_sym_fp,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_cast] = anon_sym_cast,
  [anon_sym_call] = anon_sym_call,
  [sym_number] = sym_number,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_LF] = anon_sym_LF,
  [sym_comment] = sym_comment,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_mod] = anon_sym_mod,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_implicits] = anon_sym_implicits,
  [anon_sym_nopanic] = anon_sym_nopanic,
  [anon_sym_ref] = anon_sym_ref,
  [anon_sym_mut] = anon_sym_mut,
  [anon_sym_impl] = anon_sym_impl,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_trait] = anon_sym_trait,
  [anon_sym_u8] = anon_sym_u8,
  [anon_sym_i8] = anon_sym_u8,
  [anon_sym_u16] = anon_sym_u8,
  [anon_sym_i16] = anon_sym_u8,
  [anon_sym_u32] = anon_sym_u8,
  [anon_sym_i32] = anon_sym_u8,
  [anon_sym_u64] = anon_sym_u8,
  [anon_sym_i64] = anon_sym_u8,
  [anon_sym_u128] = anon_sym_u8,
  [anon_sym_i128] = anon_sym_u8,
  [anon_sym_u256] = anon_sym_u8,
  [anon_sym_i256] = anon_sym_u8,
  [anon_sym_isize] = anon_sym_u8,
  [anon_sym_usize] = anon_sym_u8,
  [anon_sym_f32] = anon_sym_u8,
  [anon_sym_f64] = anon_sym_u8,
  [anon_sym_felt252] = anon_sym_u8,
  [anon_sym_bool] = anon_sym_u8,
  [anon_sym_str] = anon_sym_u8,
  [anon_sym_char] = anon_sym_u8,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_loop] = anon_sym_loop,
  [anon_sym__] = anon_sym__,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_LT2] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [sym__cairo_1_short_string] = sym_short_string,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [sym_self] = sym_self,
  [sym_code_line] = sym_code_line,
  [sym__failure] = sym__failure,
  [sym_program] = sym_program,
  [sym_cairo_0_file] = sym_cairo_0_file,
  [sym_cairo_1_file] = sym_cairo_1_file,
  [sym__cairo_0_statement] = sym__cairo_0_statement,
  [sym__cairo_0_import_statement] = sym__cairo_0_import_statement,
  [sym__import_list] = sym__import_list,
  [sym_aliased_import] = sym_aliased_import,
  [sym_type_definition] = sym_type_definition,
  [sym_builtin_directive] = sym_builtin_directive,
  [sym_lang_directive] = sym_lang_directive,
  [sym__cairo_0_decorated_definition] = sym__cairo_0_decorated_definition,
  [sym_decorator] = sym_decorator,
  [sym__cairo_0_namespace_definition] = sym__cairo_0_namespace_definition,
  [sym__cairo_0_struct_definition] = sym__cairo_0_struct_definition,
  [sym__cairo_0_function_definition] = sym__cairo_0_function_definition,
  [sym_implicit_arguments] = sym_implicit_arguments,
  [sym_arguments] = sym_arguments,
  [sym__cairo_0_expression_statement] = sym__cairo_0_expression_statement,
  [sym_alloc_locals] = sym_alloc_locals,
  [sym__cairo_0_assert_statement] = sym__cairo_0_assert_statement,
  [sym__cairo_0_static_assert_statement] = sym__cairo_0_static_assert_statement,
  [sym__cairo_0_let_binding] = sym__cairo_0_let_binding,
  [sym_const_var_declaration] = sym_const_var_declaration,
  [sym_local_var_declaration] = sym_local_var_declaration,
  [sym_temp_var_declaration] = sym_temp_var_declaration,
  [sym_instruction] = sym_instruction,
  [sym_inst_assert_eq] = sym_inst_assert_eq,
  [sym_inst_jmp_rel] = sym_inst_jmp_rel,
  [sym_inst_jmp_abs] = sym_inst_jmp_abs,
  [sym_inst_jmp_to_label] = sym_inst_jmp_to_label,
  [sym_inst_jnz] = sym_inst_jnz,
  [sym_inst_jnz_to_label] = sym_inst_jnz_to_label,
  [sym_inst_add_ap] = sym_inst_add_ap,
  [sym_inst_data_word] = sym_inst_data_word,
  [sym_label] = sym_label,
  [sym__cairo_0_attribute_statement] = sym__cairo_0_attribute_statement,
  [sym__cairo_0_if_statement] = sym__cairo_0_if_statement,
  [sym__cairo_0_with_statement] = sym__cairo_0_with_statement,
  [sym__cairo_0_return_statement] = sym__cairo_0_return_statement,
  [sym__non_identifier_type] = sym__non_identifier_type,
  [sym__cairo_0_builtin_type] = sym__cairo_0_builtin_type,
  [sym__cairo_0_pointer_type] = sym__cairo_0_pointer_type,
  [sym__cairo_0_tuple_type] = sym__cairo_0_tuple_type,
  [sym__cairo_0_type] = sym__cairo_0_type,
  [sym_named_type] = sym_named_type,
  [sym__cairo_0_expression] = sym__cairo_0_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_hint_expression] = sym_hint_expression,
  [sym_hint] = sym_hint,
  [sym_python_code] = sym_python_code,
  [sym_register] = sym_register,
  [sym_deref_expression] = sym_deref_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym__cairo_0_call_expression] = sym__cairo_0_call_expression,
  [sym__ref_binding] = sym__ref_binding,
  [sym_call_instruction] = sym_call_instruction,
  [sym_typed_identifier] = sym_typed_identifier,
  [sym_dotted_name] = sym_dotted_name,
  [sym__separator] = sym__separator,
  [sym__cairo_1_statement] = sym__cairo_1_statement,
  [sym_use_declaration] = sym_use_declaration,
  [sym_extern_type_statement] = sym_extern_type_statement,
  [sym__use_clause] = sym__use_clause,
  [sym_scoped_use_list] = sym_scoped_use_list,
  [sym_use_list] = sym_use_list,
  [sym_use_as_clause] = sym_use_as_clause,
  [sym_extern_function_statement] = sym_extern_function_statement,
  [sym_attribute_item] = sym_attribute_item,
  [sym_attribute_arguments] = sym_attribute_arguments,
  [sym_mod_item] = sym_mod_item,
  [sym_struct_item] = sym_struct_item,
  [sym_enum_item] = sym_enum_item,
  [sym_enum_variant_list] = sym_enum_variant_list,
  [sym_enum_variant] = sym_enum_variant,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym_field_declaration] = sym_field_declaration,
  [sym_const_item] = sym_const_item,
  [sym_type_item] = sym_type_item,
  [sym_block] = sym_block,
  [sym__cairo_1_function_definition] = sym__cairo_0_function_definition,
  [sym__function_signature] = sym__function_signature,
  [sym__cairo_1_function_signature] = sym__cairo_1_function_signature,
  [sym_parameter] = sym_parameter,
  [sym_impl_item] = sym_impl_item,
  [sym_trait_item] = sym_trait_item,
  [sym_let_declaration] = sym_let_declaration,
  [sym_declaration_list] = sym_declaration_list,
  [sym__cairo_1_type] = sym__cairo_1_type,
  [sym_at_type] = sym_at_type,
  [sym__cairo_1_generic_function] = sym__cairo_1_generic_function,
  [sym_generic_type] = sym_generic_type,
  [sym_generic_type_with_turbofish] = sym_generic_type,
  [sym__cairo_1_type_arguments] = sym__cairo_1_type_arguments,
  [sym__cairo_1_tuple_type] = sym__cairo_0_tuple_type,
  [sym_unit_type] = sym_unit_type,
  [sym_abstract_type] = sym_abstract_type,
  [sym__cairo_1_expression_statement] = sym__cairo_0_expression_statement,
  [sym__cairo_1_expression] = sym__cairo_1_expression,
  [sym__cairo_1_return_expression] = sym__cairo_1_return_expression,
  [sym__cairo_1_if_expression] = sym__cairo_1_if_expression,
  [sym__cairo_1_else_clause] = sym__cairo_1_else_clause,
  [sym_match_expression] = sym_match_expression,
  [sym_match_block] = sym_match_block,
  [sym_match_arm] = sym_match_arm,
  [sym_last_match_arm] = sym_match_arm,
  [sym_match_pattern] = sym_match_pattern,
  [sym__cairo_1_loop_expression] = sym__cairo_1_loop_expression,
  [sym__cairo_1_at_expression] = sym__cairo_1_at_expression,
  [sym__pattern] = sym__pattern,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_tuple_struct_pattern] = sym_tuple_struct_pattern,
  [sym_struct_pattern] = sym_struct_pattern,
  [sym_field_pattern] = sym_field_pattern,
  [sym__cairo_1_unary_expression] = sym_unary_expression,
  [sym__cairo_1_binary_expression] = sym_binary_expression,
  [sym__cairo_1_assignment_expression] = sym_assignment_expression,
  [sym__cairo_1_compound_assignment_expression] = sym__cairo_1_compound_assignment_expression,
  [sym__cairo_1_try_expression] = sym__cairo_1_try_expression,
  [sym__cairo_1_call_expression] = sym__cairo_0_call_expression,
  [sym__cairo_1_index_expression] = sym__cairo_1_index_expression,
  [sym__cairo_1_field_expression] = sym__cairo_1_field_expression,
  [sym__cairo_1_parenthesized_expression] = sym__cairo_1_parenthesized_expression,
  [sym__cairo_1_tuple_expression] = sym_tuple_expression,
  [sym__cairo_1_unit_expression] = sym__cairo_1_unit_expression,
  [sym__cairo_1_struct_expression] = sym__cairo_1_struct_expression,
  [sym_field_initializer_list] = sym_field_initializer_list,
  [sym_shorthand_field_initializer] = sym_shorthand_field_initializer,
  [sym_field_initializer] = sym_field_initializer,
  [sym_base_field_initializer] = sym_base_field_initializer,
  [sym_trait_bounds] = sym_trait_bounds,
  [sym_type_parameters] = sym_type_parameters,
  [sym_constrained_type_parameter] = sym_constrained_type_parameter,
  [sym__literal] = sym__literal,
  [sym__literal_pattern] = sym__literal_pattern,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym_scoped_type_identifier] = sym_scoped_type_identifier,
  [sym_boolean] = sym_boolean,
  [aux_sym_cairo_0_file_repeat1] = aux_sym_cairo_0_file_repeat1,
  [aux_sym_cairo_1_file_repeat1] = aux_sym_cairo_1_file_repeat1,
  [aux_sym__import_list_repeat1] = aux_sym__import_list_repeat1,
  [aux_sym_builtin_directive_repeat1] = aux_sym_builtin_directive_repeat1,
  [aux_sym__cairo_0_decorated_definition_repeat1] = aux_sym__cairo_0_decorated_definition_repeat1,
  [aux_sym__cairo_0_struct_definition_repeat1] = aux_sym__cairo_0_struct_definition_repeat1,
  [aux_sym__cairo_0_attribute_statement_repeat1] = aux_sym__cairo_0_attribute_statement_repeat1,
  [aux_sym__cairo_0_with_statement_repeat1] = aux_sym__cairo_0_with_statement_repeat1,
  [aux_sym__cairo_0_tuple_type_repeat1] = aux_sym__cairo_0_tuple_type_repeat1,
  [aux_sym_python_code_repeat1] = aux_sym_python_code_repeat1,
  [aux_sym_tuple_expression_repeat1] = aux_sym_tuple_expression_repeat1,
  [aux_sym__cairo_0_call_expression_repeat1] = aux_sym__cairo_0_call_expression_repeat1,
  [aux_sym_dotted_name_repeat1] = aux_sym_dotted_name_repeat1,
  [aux_sym_use_list_repeat1] = aux_sym_use_list_repeat1,
  [aux_sym_attribute_arguments_repeat1] = aux_sym_attribute_arguments_repeat1,
  [aux_sym_enum_variant_list_repeat1] = aux_sym_enum_variant_list_repeat1,
  [aux_sym_enum_variant_list_repeat2] = aux_sym_enum_variant_list_repeat2,
  [aux_sym_field_declaration_list_repeat1] = aux_sym_field_declaration_list_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym__function_signature_repeat1] = aux_sym__function_signature_repeat1,
  [aux_sym__cairo_1_type_arguments_repeat1] = aux_sym__cairo_1_type_arguments_repeat1,
  [aux_sym__cairo_1_tuple_type_repeat1] = aux_sym__cairo_1_tuple_type_repeat1,
  [aux_sym_match_block_repeat1] = aux_sym_match_block_repeat1,
  [aux_sym_tuple_pattern_repeat1] = aux_sym_tuple_pattern_repeat1,
  [aux_sym_struct_pattern_repeat1] = aux_sym_struct_pattern_repeat1,
  [aux_sym__cairo_1_call_expression_repeat1] = aux_sym__cairo_1_call_expression_repeat1,
  [aux_sym__cairo_1_tuple_expression_repeat1] = aux_sym__cairo_1_tuple_expression_repeat1,
  [aux_sym_field_initializer_list_repeat1] = aux_sym_field_initializer_list_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_return_type] = alias_sym_return_type,
  [alias_sym_shorthand_field_identifier] = alias_sym_shorthand_field_identifier,
  [alias_sym_type] = alias_sym_type,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENTbuiltins] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENTlang] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_func] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alloc_locals] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tempvar] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ap] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_jmp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rel] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abs] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym_inst_ret] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with_attr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_felt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_codeoffset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_short_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_nondet] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_call] = {
    .visible = true,
    .named = false,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implicits] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nopanic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mut] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_impl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_trait] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i8] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u16] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i16] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u32] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i32] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u64] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i64] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u128] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i128] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u256] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i256] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_isize] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_usize] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_f32] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_f64] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_felt252] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_str] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_char] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_loop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym__cairo_1_short_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [sym_code_line] = {
    .visible = true,
    .named = true,
  },
  [sym__failure] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_cairo_0_file] = {
    .visible = true,
    .named = true,
  },
  [sym_cairo_1_file] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__cairo_0_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_aliased_import] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_builtin_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_lang_directive] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_decorated_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_struct_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_alloc_locals] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_static_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_let_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_const_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_local_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_temp_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_instruction] = {
    .visible = true,
    .named = true,
  },
  [sym_inst_assert_eq] = {
    .visible = true,
    .named = true,
  },
  [sym_inst_jmp_rel] = {
    .visible = true,
    .named = true,
  },
  [sym_inst_jmp_abs] = {
    .visible = true,
    .named = true,
  },
  [sym_inst_jmp_to_label] = {
    .visible = true,
    .named = true,
  },
  [sym_inst_jnz] = {
    .visible = true,
    .named = true,
  },
  [sym_inst_jnz_to_label] = {
    .visible = true,
    .named = true,
  },
  [sym_inst_add_ap] = {
    .visible = true,
    .named = true,
  },
  [sym_inst_data_word] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_attribute_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__non_identifier_type] = {
    .visible = false,
    .named = true,
  },
  [sym__cairo_0_builtin_type] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_type] = {
    .visible = false,
    .named = true,
  },
  [sym_named_type] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_hint_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_hint] = {
    .visible = true,
    .named = true,
  },
  [sym_python_code] = {
    .visible = true,
    .named = true,
  },
  [sym_register] = {
    .visible = true,
    .named = true,
  },
  [sym_deref_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_0_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__ref_binding] = {
    .visible = false,
    .named = true,
  },
  [sym_call_instruction] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_name] = {
    .visible = true,
    .named = true,
  },
  [sym__separator] = {
    .visible = false,
    .named = true,
  },
  [sym__cairo_1_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_type_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__use_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_scoped_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_as_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_function_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_item] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_mod_item] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_item] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_item] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_variant_list] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_variant] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_item] = {
    .visible = true,
    .named = true,
  },
  [sym_type_item] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__function_signature] = {
    .visible = false,
    .named = true,
  },
  [sym__cairo_1_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_impl_item] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_item] = {
    .visible = true,
    .named = true,
  },
  [sym_let_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_type] = {
    .visible = false,
    .named = true,
  },
  [sym_at_type] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_generic_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type_with_turbofish] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_unit_type] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_type] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__cairo_1_return_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_block] = {
    .visible = true,
    .named = true,
  },
  [sym_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_last_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_match_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_loop_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_at_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_struct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_compound_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_try_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_unit_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__cairo_1_struct_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_shorthand_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_base_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_bounds] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym__literal_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_cairo_0_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cairo_1_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_builtin_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__cairo_0_decorated_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__cairo_0_struct_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__cairo_0_attribute_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__cairo_0_with_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__cairo_0_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_python_code_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__cairo_0_call_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dotted_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_variant_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_variant_list_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_signature_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__cairo_1_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__cairo_1_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__cairo_1_call_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__cairo_1_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_return_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_body = 4,
  field_bounds = 5,
  field_condition = 6,
  field_consequence = 7,
  field_definition = 8,
  field_field = 9,
  field_function = 10,
  field_left = 11,
  field_list = 12,
  field_module_name = 13,
  field_name = 14,
  field_operand = 15,
  field_operator = 16,
  field_path = 17,
  field_pattern = 18,
  field_returns = 19,
  field_right = 20,
  field_trait = 21,
  field_type = 22,
  field_type_parameters = 23,
  field_value = 24,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_body] = "body",
  [field_bounds] = "bounds",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_definition] = "definition",
  [field_field] = "field",
  [field_function] = "function",
  [field_left] = "left",
  [field_list] = "list",
  [field_module_name] = "module_name",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_path] = "path",
  [field_pattern] = "pattern",
  [field_returns] = "returns",
  [field_right] = "right",
  [field_trait] = "trait",
  [field_type] = "type",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 1},
  [3] = {.index = 3, .length = 2},
  [4] = {.index = 5, .length = 1},
  [5] = {.index = 6, .length = 1},
  [7] = {.index = 7, .length = 2},
  [9] = {.index = 9, .length = 1},
  [10] = {.index = 10, .length = 1},
  [11] = {.index = 11, .length = 1},
  [12] = {.index = 12, .length = 2},
  [13] = {.index = 14, .length = 1},
  [14] = {.index = 11, .length = 1},
  [15] = {.index = 15, .length = 1},
  [16] = {.index = 14, .length = 1},
  [17] = {.index = 16, .length = 1},
  [18] = {.index = 17, .length = 1},
  [19] = {.index = 12, .length = 2},
  [20] = {.index = 18, .length = 3},
  [21] = {.index = 21, .length = 2},
  [22] = {.index = 23, .length = 1},
  [23] = {.index = 24, .length = 2},
  [24] = {.index = 26, .length = 3},
  [25] = {.index = 23, .length = 1},
  [27] = {.index = 29, .length = 2},
  [28] = {.index = 29, .length = 2},
  [29] = {.index = 31, .length = 1},
  [30] = {.index = 29, .length = 2},
  [31] = {.index = 29, .length = 2},
  [32] = {.index = 32, .length = 3},
  [33] = {.index = 35, .length = 1},
  [34] = {.index = 36, .length = 3},
  [35] = {.index = 39, .length = 2},
  [36] = {.index = 41, .length = 2},
  [37] = {.index = 43, .length = 2},
  [38] = {.index = 45, .length = 2},
  [39] = {.index = 47, .length = 2},
  [40] = {.index = 45, .length = 2},
  [41] = {.index = 47, .length = 2},
  [42] = {.index = 49, .length = 1},
  [43] = {.index = 50, .length = 1},
  [45] = {.index = 51, .length = 1},
  [46] = {.index = 51, .length = 1},
  [47] = {.index = 52, .length = 2},
  [48] = {.index = 54, .length = 3},
  [49] = {.index = 57, .length = 2},
  [52] = {.index = 59, .length = 2},
  [53] = {.index = 11, .length = 1},
  [54] = {.index = 61, .length = 2},
  [55] = {.index = 63, .length = 2},
  [56] = {.index = 63, .length = 2},
  [57] = {.index = 65, .length = 1},
  [58] = {.index = 66, .length = 2},
  [59] = {.index = 68, .length = 2},
  [60] = {.index = 70, .length = 2},
  [61] = {.index = 72, .length = 1},
  [62] = {.index = 70, .length = 2},
  [63] = {.index = 73, .length = 3},
  [64] = {.index = 76, .length = 4},
  [65] = {.index = 80, .length = 2},
  [66] = {.index = 82, .length = 2},
  [67] = {.index = 84, .length = 2},
  [68] = {.index = 86, .length = 2},
  [69] = {.index = 88, .length = 2},
  [70] = {.index = 90, .length = 2},
  [71] = {.index = 49, .length = 1},
  [72] = {.index = 92, .length = 2},
  [73] = {.index = 94, .length = 2},
  [74] = {.index = 96, .length = 2},
  [75] = {.index = 98, .length = 2},
  [76] = {.index = 100, .length = 2},
  [77] = {.index = 102, .length = 2},
  [78] = {.index = 104, .length = 3},
  [80] = {.index = 107, .length = 1},
  [81] = {.index = 108, .length = 3},
  [82] = {.index = 111, .length = 1},
  [83] = {.index = 112, .length = 2},
  [85] = {.index = 114, .length = 2},
  [86] = {.index = 116, .length = 3},
  [87] = {.index = 119, .length = 3},
  [88] = {.index = 122, .length = 3},
  [89] = {.index = 125, .length = 1},
  [90] = {.index = 126, .length = 1},
  [91] = {.index = 127, .length = 2},
  [93] = {.index = 129, .length = 2},
  [94] = {.index = 131, .length = 3},
  [95] = {.index = 134, .length = 3},
  [96] = {.index = 137, .length = 2},
  [97] = {.index = 139, .length = 2},
  [98] = {.index = 141, .length = 1},
  [99] = {.index = 142, .length = 3},
  [100] = {.index = 145, .length = 2},
  [101] = {.index = 147, .length = 2},
  [102] = {.index = 149, .length = 5},
  [103] = {.index = 154, .length = 1},
  [104] = {.index = 155, .length = 2},
  [105] = {.index = 157, .length = 2},
  [106] = {.index = 159, .length = 1},
  [107] = {.index = 160, .length = 5},
  [108] = {.index = 165, .length = 3},
  [109] = {.index = 168, .length = 2},
  [110] = {.index = 170, .length = 2},
  [111] = {.index = 172, .length = 1},
  [112] = {.index = 173, .length = 3},
  [113] = {.index = 176, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_module_name, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [2] =
    {field_definition, 0, .inherited = true},
  [3] =
    {field_left, 0, .inherited = true},
    {field_right, 0, .inherited = true},
  [5] =
    {field_function, 0, .inherited = true},
  [6] =
    {field_returns, 0, .inherited = true},
  [7] =
    {field_operand, 1},
    {field_operator, 0},
  [9] =
    {field_function, 0},
  [10] =
    {field_definition, 1},
  [11] =
    {field_name, 1},
  [12] =
    {field_body, 2},
    {field_name, 1},
  [14] =
    {field_type, 0},
  [15] =
    {field_pattern, 1},
  [16] =
    {field_list, 1},
  [17] =
    {field_argument, 1},
  [18] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [21] =
    {field_module_name, 1},
    {field_name, 3, .inherited = true},
  [23] =
    {field_name, 0},
  [24] =
    {field_name, 1},
    {field_type_parameters, 2},
  [26] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [29] =
    {field_name, 2},
    {field_path, 0},
  [31] =
    {field_pattern, 2},
  [32] =
    {field_alternative, 0, .inherited = true},
    {field_condition, 0, .inherited = true},
    {field_consequence, 0, .inherited = true},
  [35] =
    {field_body, 0, .inherited = true},
  [36] =
    {field_left, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
    {field_right, 0, .inherited = true},
  [39] =
    {field_function, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [41] =
    {field_field, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [43] =
    {field_body, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [45] =
    {field_alias, 2},
    {field_path, 0},
  [47] =
    {field_list, 2},
    {field_path, 0},
  [49] =
    {field_name, 2},
  [50] =
    {field_returns, 2, .inherited = true},
  [51] =
    {field_trait, 1},
  [52] =
    {field_bounds, 2},
    {field_name, 1},
  [54] =
    {field_body, 3},
    {field_bounds, 2},
    {field_name, 1},
  [57] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [59] =
    {field_bounds, 1},
    {field_left, 0},
  [61] =
    {field_left, 1},
    {field_right, 3},
  [63] =
    {field_body, 1},
    {field_name, 0},
  [65] =
    {field_body, 1},
  [66] =
    {field_pattern, 1},
    {field_value, 3},
  [68] =
    {field_pattern, 1},
    {field_type, 3},
  [70] =
    {field_name, 1},
    {field_type, 3},
  [72] =
    {field_returns, 3, .inherited = true},
  [73] =
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [76] =
    {field_body, 4},
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [80] =
    {field_module_name, 1},
    {field_name, 4, .inherited = true},
  [82] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [84] =
    {field_alias, 2},
    {field_name, 0},
  [86] =
    {field_name, 0},
    {field_type, 2},
  [88] =
    {field_bounds, 2},
    {field_left, 1},
  [90] =
    {field_name, 0},
    {field_pattern, 2},
  [92] =
    {field_pattern, 2},
    {field_value, 4},
  [94] =
    {field_pattern, 2},
    {field_type, 4},
  [96] =
    {field_condition, 1},
    {field_consequence, 2},
  [98] =
    {field_body, 2},
    {field_value, 1},
  [100] =
    {field_left, 0},
    {field_right, 2},
  [102] =
    {field_field, 2},
    {field_value, 0},
  [104] =
    {field_field, 0, .inherited = true},
    {field_function, 0},
    {field_value, 0, .inherited = true},
  [107] =
    {field_returns, 4, .inherited = true},
  [108] =
    {field_name, 1},
    {field_type, 4},
    {field_type_parameters, 2},
  [111] =
    {field_returns, 3},
  [112] =
    {field_body, 2},
    {field_name, 0},
  [114] =
    {field_name, 1},
    {field_pattern, 3},
  [116] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [119] =
    {field_pattern, 1},
    {field_type, 3},
    {field_value, 5},
  [122] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 5},
  [125] =
    {field_returns, 5},
  [126] =
    {field_returns, 4},
  [127] =
    {field_name, 0},
    {field_value, 3},
  [129] =
    {field_name, 2},
    {field_pattern, 4},
  [131] =
    {field_pattern, 2},
    {field_type, 4},
    {field_value, 6},
  [134] =
    {field_alternative, 1, .inherited = true},
    {field_condition, 1, .inherited = true},
    {field_consequence, 1, .inherited = true},
  [137] =
    {field_name, 0},
    {field_value, 2},
  [139] =
    {field_function, 0},
    {field_name, 3, .inherited = true},
  [141] =
    {field_returns, 6},
  [142] =
    {field_body, 2},
    {field_name, 0},
    {field_value, 4},
  [145] =
    {field_name, 1},
    {field_value, 3},
  [147] =
    {field_pattern, 0},
    {field_value, 2},
  [149] =
    {field_alternative, 2, .inherited = true},
    {field_condition, 2, .inherited = true},
    {field_consequence, 2, .inherited = true},
    {field_pattern, 0},
    {field_value, 2},
  [154] =
    {field_condition, 2},
  [155] =
    {field_function, 0},
    {field_name, 4, .inherited = true},
  [157] =
    {field_function, 0},
    {field_name, 2},
  [159] =
    {field_returns, 7},
  [160] =
    {field_alternative, 3, .inherited = true},
    {field_condition, 3, .inherited = true},
    {field_consequence, 3, .inherited = true},
    {field_pattern, 1},
    {field_value, 3},
  [165] =
    {field_function, 0},
    {field_name, 2},
    {field_name, 5, .inherited = true},
  [168] =
    {field_function, 0},
    {field_name, 5, .inherited = true},
  [170] =
    {field_function, 0},
    {field_name, 3},
  [172] =
    {field_returns, 8},
  [173] =
    {field_function, 0},
    {field_name, 3},
    {field_name, 6, .inherited = true},
  [176] =
    {field_returns, 9},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [6] = {
    [0] = sym_identifier,
  },
  [8] = {
    [0] = alias_sym_type_identifier,
  },
  [11] = {
    [1] = alias_sym_type_identifier,
  },
  [12] = {
    [1] = alias_sym_type_identifier,
  },
  [13] = {
    [0] = alias_sym_type_identifier,
  },
  [23] = {
    [1] = alias_sym_type_identifier,
  },
  [24] = {
    [1] = alias_sym_type_identifier,
  },
  [25] = {
    [0] = alias_sym_shorthand_field_identifier,
  },
  [26] = {
    [2] = alias_sym_type,
  },
  [28] = {
    [2] = alias_sym_type_identifier,
  },
  [30] = {
    [0] = sym_identifier,
  },
  [31] = {
    [0] = sym_identifier,
    [2] = alias_sym_type_identifier,
  },
  [40] = {
    [0] = sym_identifier,
  },
  [41] = {
    [0] = sym_identifier,
  },
  [44] = {
    [2] = sym_identifier,
  },
  [45] = {
    [1] = alias_sym_type_identifier,
  },
  [47] = {
    [1] = alias_sym_type_identifier,
  },
  [48] = {
    [1] = alias_sym_type_identifier,
  },
  [50] = {
    [3] = alias_sym_type,
  },
  [51] = {
    [1] = alias_sym_type_identifier,
  },
  [52] = {
    [0] = alias_sym_type_identifier,
  },
  [53] = {
    [1] = alias_sym_shorthand_field_identifier,
  },
  [55] = {
    [0] = alias_sym_type_identifier,
  },
  [62] = {
    [1] = alias_sym_type_identifier,
  },
  [63] = {
    [1] = alias_sym_type_identifier,
  },
  [64] = {
    [1] = alias_sym_type_identifier,
  },
  [68] = {
    [0] = alias_sym_field_identifier,
  },
  [69] = {
    [1] = alias_sym_type_identifier,
  },
  [70] = {
    [0] = alias_sym_field_identifier,
  },
  [71] = {
    [2] = alias_sym_shorthand_field_identifier,
  },
  [77] = {
    [2] = alias_sym_field_identifier,
  },
  [79] = {
    [4] = alias_sym_type,
  },
  [81] = {
    [1] = alias_sym_type_identifier,
  },
  [84] = {
    [4] = alias_sym_return_type,
  },
  [85] = {
    [1] = alias_sym_field_identifier,
  },
  [92] = {
    [5] = alias_sym_return_type,
  },
  [93] = {
    [2] = alias_sym_field_identifier,
  },
  [96] = {
    [0] = alias_sym_field_identifier,
  },
  [100] = {
    [1] = alias_sym_field_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__cairo_0_type, 3,
    sym__cairo_0_type,
    alias_sym_return_type,
    alias_sym_type,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 5,
  [8] = 2,
  [9] = 6,
  [10] = 5,
  [11] = 6,
  [12] = 5,
  [13] = 6,
  [14] = 5,
  [15] = 6,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 17,
  [44] = 25,
  [45] = 40,
  [46] = 41,
  [47] = 47,
  [48] = 47,
  [49] = 16,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 42,
  [57] = 18,
  [58] = 19,
  [59] = 20,
  [60] = 21,
  [61] = 22,
  [62] = 23,
  [63] = 24,
  [64] = 26,
  [65] = 27,
  [66] = 28,
  [67] = 29,
  [68] = 30,
  [69] = 31,
  [70] = 32,
  [71] = 33,
  [72] = 50,
  [73] = 34,
  [74] = 35,
  [75] = 36,
  [76] = 37,
  [77] = 38,
  [78] = 39,
  [79] = 79,
  [80] = 51,
  [81] = 52,
  [82] = 53,
  [83] = 54,
  [84] = 55,
  [85] = 85,
  [86] = 79,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 90,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 174,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 181,
  [184] = 184,
  [185] = 184,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 188,
  [191] = 176,
  [192] = 186,
  [193] = 178,
  [194] = 179,
  [195] = 180,
  [196] = 182,
  [197] = 177,
  [198] = 189,
  [199] = 187,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 203,
  [205] = 205,
  [206] = 200,
  [207] = 201,
  [208] = 208,
  [209] = 205,
  [210] = 210,
  [211] = 87,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 210,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 88,
  [224] = 89,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 222,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 226,
  [234] = 222,
  [235] = 219,
  [236] = 226,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 243,
  [255] = 255,
  [256] = 244,
  [257] = 257,
  [258] = 249,
  [259] = 259,
  [260] = 246,
  [261] = 247,
  [262] = 255,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 241,
  [269] = 245,
  [270] = 249,
  [271] = 220,
  [272] = 272,
  [273] = 220,
  [274] = 243,
  [275] = 275,
  [276] = 276,
  [277] = 244,
  [278] = 246,
  [279] = 247,
  [280] = 255,
  [281] = 263,
  [282] = 264,
  [283] = 264,
  [284] = 241,
  [285] = 285,
  [286] = 286,
  [287] = 225,
  [288] = 237,
  [289] = 221,
  [290] = 227,
  [291] = 259,
  [292] = 230,
  [293] = 293,
  [294] = 229,
  [295] = 232,
  [296] = 245,
  [297] = 251,
  [298] = 252,
  [299] = 275,
  [300] = 221,
  [301] = 227,
  [302] = 263,
  [303] = 143,
  [304] = 144,
  [305] = 146,
  [306] = 151,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 122,
  [311] = 311,
  [312] = 137,
  [313] = 139,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 88,
  [387] = 89,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 96,
  [393] = 393,
  [394] = 393,
  [395] = 393,
  [396] = 91,
  [397] = 397,
  [398] = 92,
  [399] = 95,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 87,
  [405] = 397,
  [406] = 110,
  [407] = 397,
  [408] = 109,
  [409] = 409,
  [410] = 403,
  [411] = 130,
  [412] = 401,
  [413] = 89,
  [414] = 136,
  [415] = 170,
  [416] = 402,
  [417] = 417,
  [418] = 418,
  [419] = 99,
  [420] = 88,
  [421] = 169,
  [422] = 171,
  [423] = 107,
  [424] = 121,
  [425] = 425,
  [426] = 133,
  [427] = 135,
  [428] = 117,
  [429] = 123,
  [430] = 116,
  [431] = 167,
  [432] = 157,
  [433] = 111,
  [434] = 158,
  [435] = 435,
  [436] = 119,
  [437] = 159,
  [438] = 160,
  [439] = 418,
  [440] = 161,
  [441] = 441,
  [442] = 118,
  [443] = 329,
  [444] = 330,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 97,
  [449] = 98,
  [450] = 115,
  [451] = 100,
  [452] = 348,
  [453] = 349,
  [454] = 454,
  [455] = 455,
  [456] = 155,
  [457] = 457,
  [458] = 101,
  [459] = 102,
  [460] = 173,
  [461] = 103,
  [462] = 104,
  [463] = 137,
  [464] = 138,
  [465] = 417,
  [466] = 168,
  [467] = 164,
  [468] = 139,
  [469] = 469,
  [470] = 106,
  [471] = 156,
  [472] = 140,
  [473] = 108,
  [474] = 141,
  [475] = 162,
  [476] = 469,
  [477] = 142,
  [478] = 435,
  [479] = 120,
  [480] = 143,
  [481] = 144,
  [482] = 145,
  [483] = 165,
  [484] = 146,
  [485] = 166,
  [486] = 147,
  [487] = 148,
  [488] = 163,
  [489] = 469,
  [490] = 435,
  [491] = 122,
  [492] = 149,
  [493] = 150,
  [494] = 151,
  [495] = 114,
  [496] = 152,
  [497] = 153,
  [498] = 154,
  [499] = 105,
  [500] = 500,
  [501] = 501,
  [502] = 441,
  [503] = 503,
  [504] = 504,
  [505] = 124,
  [506] = 125,
  [507] = 126,
  [508] = 127,
  [509] = 128,
  [510] = 129,
  [511] = 131,
  [512] = 132,
  [513] = 94,
  [514] = 134,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 454,
  [522] = 455,
  [523] = 425,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 518,
  [528] = 528,
  [529] = 112,
  [530] = 530,
  [531] = 113,
  [532] = 445,
  [533] = 446,
  [534] = 534,
  [535] = 447,
  [536] = 457,
  [537] = 537,
  [538] = 537,
  [539] = 539,
  [540] = 537,
  [541] = 504,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 519,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 566,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 503,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 525,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 515,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 542,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 501,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 573,
  [600] = 548,
  [601] = 586,
  [602] = 557,
  [603] = 574,
  [604] = 580,
  [605] = 581,
  [606] = 555,
  [607] = 589,
  [608] = 608,
  [609] = 609,
  [610] = 592,
  [611] = 560,
  [612] = 569,
  [613] = 593,
  [614] = 570,
  [615] = 572,
  [616] = 562,
  [617] = 563,
  [618] = 558,
  [619] = 584,
  [620] = 561,
  [621] = 552,
  [622] = 543,
  [623] = 578,
  [624] = 556,
  [625] = 547,
  [626] = 564,
  [627] = 627,
  [628] = 571,
  [629] = 576,
  [630] = 587,
  [631] = 559,
  [632] = 565,
  [633] = 597,
  [634] = 588,
  [635] = 591,
  [636] = 550,
  [637] = 566,
  [638] = 595,
  [639] = 596,
  [640] = 640,
  [641] = 553,
  [642] = 582,
  [643] = 598,
  [644] = 644,
  [645] = 567,
  [646] = 568,
  [647] = 583,
  [648] = 648,
  [649] = 546,
  [650] = 577,
  [651] = 544,
  [652] = 545,
  [653] = 549,
  [654] = 654,
  [655] = 655,
  [656] = 654,
  [657] = 657,
  [658] = 91,
  [659] = 92,
  [660] = 660,
  [661] = 657,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 664,
  [667] = 665,
  [668] = 668,
  [669] = 669,
  [670] = 662,
  [671] = 671,
  [672] = 669,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 673,
  [686] = 686,
  [687] = 675,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 681,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 675,
  [712] = 676,
  [713] = 706,
  [714] = 674,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 700,
  [719] = 702,
  [720] = 701,
  [721] = 693,
  [722] = 704,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 676,
  [727] = 689,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 680,
  [734] = 696,
  [735] = 717,
  [736] = 698,
  [737] = 731,
  [738] = 732,
  [739] = 739,
  [740] = 708,
  [741] = 709,
  [742] = 742,
  [743] = 724,
  [744] = 742,
  [745] = 745,
  [746] = 730,
  [747] = 682,
  [748] = 748,
  [749] = 112,
  [750] = 750,
  [751] = 750,
  [752] = 752,
  [753] = 753,
  [754] = 128,
  [755] = 755,
  [756] = 756,
  [757] = 752,
  [758] = 753,
  [759] = 759,
  [760] = 760,
  [761] = 129,
  [762] = 131,
  [763] = 125,
  [764] = 132,
  [765] = 765,
  [766] = 759,
  [767] = 94,
  [768] = 765,
  [769] = 769,
  [770] = 755,
  [771] = 124,
  [772] = 134,
  [773] = 126,
  [774] = 774,
  [775] = 113,
  [776] = 774,
  [777] = 777,
  [778] = 127,
  [779] = 779,
  [780] = 780,
  [781] = 781,
  [782] = 782,
  [783] = 781,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 788,
  [790] = 786,
  [791] = 791,
  [792] = 792,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 794,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 798,
  [802] = 797,
  [803] = 799,
  [804] = 800,
  [805] = 805,
  [806] = 806,
  [807] = 807,
  [808] = 806,
  [809] = 807,
  [810] = 805,
  [811] = 811,
  [812] = 811,
  [813] = 805,
  [814] = 814,
  [815] = 815,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 823,
  [824] = 816,
  [825] = 825,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 829,
  [830] = 830,
  [831] = 831,
  [832] = 832,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 819,
  [837] = 837,
  [838] = 838,
  [839] = 825,
  [840] = 826,
  [841] = 828,
  [842] = 829,
  [843] = 830,
  [844] = 844,
  [845] = 845,
  [846] = 837,
  [847] = 847,
  [848] = 820,
  [849] = 849,
  [850] = 850,
  [851] = 851,
  [852] = 818,
  [853] = 845,
  [854] = 854,
  [855] = 815,
  [856] = 856,
  [857] = 821,
  [858] = 822,
  [859] = 817,
  [860] = 847,
  [861] = 851,
  [862] = 854,
  [863] = 834,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 870,
  [871] = 864,
  [872] = 563,
  [873] = 564,
  [874] = 866,
  [875] = 867,
  [876] = 869,
  [877] = 877,
  [878] = 870,
  [879] = 877,
  [880] = 865,
  [881] = 881,
  [882] = 882,
  [883] = 564,
  [884] = 884,
  [885] = 885,
  [886] = 882,
  [887] = 887,
  [888] = 888,
  [889] = 889,
  [890] = 890,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 890,
  [896] = 891,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 899,
  [901] = 889,
  [902] = 902,
  [903] = 903,
  [904] = 904,
  [905] = 902,
  [906] = 906,
  [907] = 906,
  [908] = 904,
  [909] = 909,
  [910] = 898,
  [911] = 911,
  [912] = 887,
  [913] = 913,
  [914] = 914,
  [915] = 914,
  [916] = 916,
  [917] = 917,
  [918] = 916,
  [919] = 919,
  [920] = 913,
  [921] = 921,
  [922] = 922,
  [923] = 923,
  [924] = 563,
  [925] = 921,
  [926] = 926,
  [927] = 892,
  [928] = 919,
  [929] = 922,
  [930] = 894,
  [931] = 911,
  [932] = 903,
  [933] = 893,
  [934] = 897,
  [935] = 917,
  [936] = 884,
  [937] = 937,
  [938] = 909,
  [939] = 888,
  [940] = 89,
  [941] = 941,
  [942] = 942,
  [943] = 943,
  [944] = 944,
  [945] = 88,
  [946] = 943,
  [947] = 947,
  [948] = 942,
  [949] = 949,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 950,
  [954] = 952,
  [955] = 951,
  [956] = 956,
  [957] = 956,
  [958] = 958,
  [959] = 374,
  [960] = 378,
  [961] = 328,
  [962] = 379,
  [963] = 329,
  [964] = 330,
  [965] = 331,
  [966] = 332,
  [967] = 333,
  [968] = 317,
  [969] = 388,
  [970] = 340,
  [971] = 334,
  [972] = 315,
  [973] = 341,
  [974] = 342,
  [975] = 975,
  [976] = 335,
  [977] = 316,
  [978] = 318,
  [979] = 343,
  [980] = 344,
  [981] = 345,
  [982] = 346,
  [983] = 347,
  [984] = 348,
  [985] = 349,
  [986] = 350,
  [987] = 351,
  [988] = 380,
  [989] = 352,
  [990] = 353,
  [991] = 354,
  [992] = 381,
  [993] = 382,
  [994] = 375,
  [995] = 336,
  [996] = 337,
  [997] = 997,
  [998] = 355,
  [999] = 377,
  [1000] = 319,
  [1001] = 357,
  [1002] = 320,
  [1003] = 321,
  [1004] = 314,
  [1005] = 1005,
  [1006] = 322,
  [1007] = 383,
  [1008] = 323,
  [1009] = 1009,
  [1010] = 384,
  [1011] = 385,
  [1012] = 359,
  [1013] = 360,
  [1014] = 361,
  [1015] = 1015,
  [1016] = 362,
  [1017] = 363,
  [1018] = 338,
  [1019] = 324,
  [1020] = 325,
  [1021] = 364,
  [1022] = 365,
  [1023] = 366,
  [1024] = 367,
  [1025] = 368,
  [1026] = 369,
  [1027] = 370,
  [1028] = 326,
  [1029] = 1005,
  [1030] = 1015,
  [1031] = 376,
  [1032] = 327,
  [1033] = 371,
  [1034] = 372,
  [1035] = 373,
  [1036] = 339,
  [1037] = 356,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 1040,
  [1041] = 1041,
  [1042] = 1042,
  [1043] = 1043,
  [1044] = 1043,
  [1045] = 1045,
  [1046] = 1042,
  [1047] = 1047,
  [1048] = 1045,
  [1049] = 1049,
  [1050] = 171,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 170,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 1047,
  [1060] = 1051,
  [1061] = 1058,
  [1062] = 1038,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 169,
  [1066] = 1066,
  [1067] = 1054,
  [1068] = 1068,
  [1069] = 1056,
  [1070] = 1064,
  [1071] = 1052,
  [1072] = 1072,
  [1073] = 1039,
  [1074] = 1074,
  [1075] = 1057,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 1080,
  [1081] = 1081,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 1084,
  [1085] = 1078,
  [1086] = 1080,
  [1087] = 1087,
  [1088] = 1088,
  [1089] = 1079,
  [1090] = 1090,
  [1091] = 1091,
  [1092] = 1092,
  [1093] = 1093,
  [1094] = 1094,
  [1095] = 1095,
  [1096] = 1095,
  [1097] = 1097,
  [1098] = 1098,
  [1099] = 1099,
  [1100] = 1100,
  [1101] = 1101,
  [1102] = 1102,
  [1103] = 1103,
  [1104] = 1104,
  [1105] = 1105,
  [1106] = 1106,
  [1107] = 1107,
  [1108] = 1108,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 1112,
  [1113] = 1113,
  [1114] = 1114,
  [1115] = 1115,
  [1116] = 1116,
  [1117] = 1117,
  [1118] = 1118,
  [1119] = 1119,
  [1120] = 1120,
  [1121] = 1121,
  [1122] = 1107,
  [1123] = 1123,
  [1124] = 1124,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 1128,
  [1129] = 1129,
  [1130] = 1130,
  [1131] = 1131,
  [1132] = 1132,
  [1133] = 1133,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1136,
  [1139] = 1134,
  [1140] = 1131,
  [1141] = 1133,
  [1142] = 1142,
  [1143] = 1130,
  [1144] = 1132,
  [1145] = 1135,
  [1146] = 1142,
  [1147] = 1137,
  [1148] = 1148,
  [1149] = 1149,
  [1150] = 1150,
  [1151] = 1151,
  [1152] = 1152,
  [1153] = 1153,
  [1154] = 1154,
  [1155] = 403,
  [1156] = 1156,
  [1157] = 1157,
  [1158] = 1148,
  [1159] = 1159,
  [1160] = 1160,
  [1161] = 1161,
  [1162] = 1162,
  [1163] = 1163,
  [1164] = 401,
  [1165] = 1165,
  [1166] = 1166,
  [1167] = 1167,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1151,
  [1171] = 1167,
  [1172] = 1149,
  [1173] = 1173,
  [1174] = 1156,
  [1175] = 402,
  [1176] = 1160,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1118,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 1183,
  [1184] = 1184,
  [1185] = 1185,
  [1186] = 1184,
  [1187] = 1187,
  [1188] = 1188,
  [1189] = 1187,
  [1190] = 1190,
  [1191] = 1191,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1124,
  [1198] = 1127,
  [1199] = 1199,
  [1200] = 1104,
  [1201] = 1201,
  [1202] = 1202,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1204,
  [1210] = 1210,
  [1211] = 1110,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1193,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1188,
  [1219] = 1203,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1215,
  [1223] = 1223,
  [1224] = 1224,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 1190,
  [1228] = 1228,
  [1229] = 1212,
  [1230] = 1230,
  [1231] = 1231,
  [1232] = 1232,
  [1233] = 417,
  [1234] = 1234,
  [1235] = 1103,
  [1236] = 1230,
  [1237] = 1237,
  [1238] = 1125,
  [1239] = 1226,
  [1240] = 1240,
  [1241] = 1223,
  [1242] = 1220,
  [1243] = 1210,
  [1244] = 1231,
  [1245] = 1194,
  [1246] = 1099,
  [1247] = 1221,
  [1248] = 1068,
  [1249] = 418,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1252,
  [1253] = 1253,
  [1254] = 1254,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 1257,
  [1258] = 1258,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 1261,
  [1262] = 1252,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1265,
  [1266] = 1266,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1266,
  [1272] = 1272,
  [1273] = 1261,
  [1274] = 1274,
  [1275] = 1267,
  [1276] = 1254,
  [1277] = 1277,
  [1278] = 1278,
  [1279] = 1279,
  [1280] = 1280,
  [1281] = 1269,
  [1282] = 1282,
  [1283] = 1283,
  [1284] = 1280,
  [1285] = 1283,
  [1286] = 1286,
  [1287] = 1287,
  [1288] = 1288,
  [1289] = 1289,
  [1290] = 1257,
  [1291] = 1291,
  [1292] = 1292,
  [1293] = 1293,
  [1294] = 1258,
  [1295] = 1259,
  [1296] = 1260,
  [1297] = 1265,
  [1298] = 1298,
  [1299] = 1299,
  [1300] = 1251,
  [1301] = 1253,
  [1302] = 1257,
  [1303] = 1258,
  [1304] = 1259,
  [1305] = 1260,
  [1306] = 1306,
  [1307] = 1269,
  [1308] = 1253,
  [1309] = 1225,
  [1310] = 1268,
  [1311] = 1274,
  [1312] = 1255,
  [1313] = 1287,
  [1314] = 445,
  [1315] = 1291,
  [1316] = 455,
  [1317] = 457,
  [1318] = 1318,
  [1319] = 1253,
  [1320] = 400,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1277,
  [1327] = 1327,
  [1328] = 1288,
  [1329] = 1298,
  [1330] = 1292,
  [1331] = 1325,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1334,
  [1335] = 1335,
  [1336] = 1336,
  [1337] = 1337,
  [1338] = 1338,
  [1339] = 1163,
  [1340] = 1340,
  [1341] = 1341,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 1344,
  [1345] = 1345,
  [1346] = 1327,
  [1347] = 1347,
  [1348] = 1348,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 1351,
  [1352] = 1352,
  [1353] = 1353,
  [1354] = 1354,
  [1355] = 1355,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1358,
  [1359] = 1355,
  [1360] = 1360,
  [1361] = 1342,
  [1362] = 1362,
  [1363] = 1363,
  [1364] = 1364,
  [1365] = 1365,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 1368,
  [1369] = 1369,
  [1370] = 1370,
  [1371] = 1371,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1377,
  [1378] = 1374,
  [1379] = 1379,
  [1380] = 1334,
  [1381] = 1381,
  [1382] = 1382,
  [1383] = 1383,
  [1384] = 1384,
  [1385] = 1385,
  [1386] = 1386,
  [1387] = 1387,
  [1388] = 1388,
  [1389] = 1337,
  [1390] = 1390,
  [1391] = 1391,
  [1392] = 1392,
  [1393] = 1393,
  [1394] = 1394,
  [1395] = 1395,
  [1396] = 1396,
  [1397] = 1397,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 1400,
  [1401] = 1340,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1375,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 1412,
  [1413] = 1413,
  [1414] = 1364,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 1386,
  [1418] = 1418,
  [1419] = 1419,
  [1420] = 1420,
  [1421] = 1421,
  [1422] = 1385,
  [1423] = 1423,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 1344,
  [1427] = 1427,
  [1428] = 1428,
  [1429] = 1429,
  [1430] = 1430,
  [1431] = 1431,
  [1432] = 1432,
  [1433] = 1433,
  [1434] = 1434,
  [1435] = 1435,
  [1436] = 1436,
  [1437] = 1437,
  [1438] = 1387,
  [1439] = 1439,
  [1440] = 1345,
  [1441] = 1441,
  [1442] = 1442,
  [1443] = 1423,
  [1444] = 1444,
  [1445] = 1444,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 1338,
  [1451] = 1451,
  [1452] = 1393,
  [1453] = 1453,
  [1454] = 1454,
  [1455] = 1347,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 1373,
  [1460] = 1460,
  [1461] = 1418,
  [1462] = 1377,
  [1463] = 1460,
  [1464] = 1464,
  [1465] = 1394,
  [1466] = 1355,
  [1467] = 1396,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1150,
  [1472] = 1427,
  [1473] = 1449,
  [1474] = 1460,
  [1475] = 1475,
  [1476] = 1424,
  [1477] = 1477,
  [1478] = 1478,
  [1479] = 1479,
  [1480] = 1480,
  [1481] = 1481,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1484,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1487,
  [1488] = 1488,
  [1489] = 1489,
  [1490] = 1490,
  [1491] = 1357,
  [1492] = 1492,
  [1493] = 1493,
  [1494] = 1494,
  [1495] = 1495,
  [1496] = 1496,
  [1497] = 441,
  [1498] = 1498,
  [1499] = 1499,
  [1500] = 1500,
  [1501] = 1479,
  [1502] = 454,
  [1503] = 1379,
  [1504] = 1504,
  [1505] = 1400,
  [1506] = 1340,
  [1507] = 1384,
  [1508] = 1508,
  [1509] = 425,
  [1510] = 1510,
  [1511] = 1349,
  [1512] = 1512,
  [1513] = 1431,
  [1514] = 1510,
  [1515] = 1515,
  [1516] = 1516,
  [1517] = 1517,
  [1518] = 1475,
  [1519] = 1519,
  [1520] = 1351,
  [1521] = 1495,
  [1522] = 1522,
  [1523] = 1523,
  [1524] = 1493,
  [1525] = 1525,
  [1526] = 1526,
  [1527] = 1483,
  [1528] = 1352,
  [1529] = 1496,
  [1530] = 1332,
  [1531] = 1531,
  [1532] = 1532,
  [1533] = 1533,
  [1534] = 1534,
  [1535] = 1535,
  [1536] = 1536,
  [1537] = 446,
  [1538] = 1538,
  [1539] = 447,
  [1540] = 1540,
  [1541] = 1535,
  [1542] = 1525,
  [1543] = 1543,
  [1544] = 1544,
  [1545] = 1545,
  [1546] = 1546,
  [1547] = 1547,
  [1548] = 1358,
  [1549] = 1453,
  [1550] = 1550,
  [1551] = 1360,
  [1552] = 1306,
  [1553] = 1343,
  [1554] = 1420,
  [1555] = 1555,
  [1556] = 1556,
  [1557] = 1437,
  [1558] = 1458,
  [1559] = 1559,
  [1560] = 1508,
  [1561] = 1561,
  [1562] = 1562,
  [1563] = 1563,
  [1564] = 1457,
  [1565] = 1565,
  [1566] = 1566,
  [1567] = 1567,
  [1568] = 1568,
  [1569] = 1569,
  [1570] = 1570,
  [1571] = 1571,
  [1572] = 1572,
  [1573] = 1573,
  [1574] = 1574,
  [1575] = 1575,
  [1576] = 1576,
  [1577] = 1577,
  [1578] = 1578,
  [1579] = 1579,
  [1580] = 1580,
  [1581] = 1581,
  [1582] = 1582,
  [1583] = 1583,
  [1584] = 1584,
  [1585] = 1585,
  [1586] = 1586,
  [1587] = 1587,
  [1588] = 1572,
  [1589] = 1589,
  [1590] = 1590,
  [1591] = 1591,
  [1592] = 1592,
  [1593] = 1593,
  [1594] = 1594,
  [1595] = 519,
  [1596] = 1570,
  [1597] = 1577,
  [1598] = 542,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1601,
  [1602] = 1602,
  [1603] = 1603,
  [1604] = 1604,
  [1605] = 1605,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1608,
  [1609] = 1609,
  [1610] = 1610,
  [1611] = 1611,
  [1612] = 1604,
  [1613] = 1613,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 1592,
  [1617] = 1617,
  [1618] = 1618,
  [1619] = 1619,
  [1620] = 1620,
  [1621] = 1621,
  [1622] = 1622,
  [1623] = 1623,
  [1624] = 1624,
  [1625] = 1625,
  [1626] = 1626,
  [1627] = 1627,
  [1628] = 1628,
  [1629] = 1629,
  [1630] = 1630,
  [1631] = 1631,
  [1632] = 1632,
  [1633] = 1633,
  [1634] = 1634,
  [1635] = 1635,
  [1636] = 1636,
  [1637] = 1637,
  [1638] = 1638,
  [1639] = 1639,
  [1640] = 1640,
  [1641] = 1641,
  [1642] = 1609,
  [1643] = 1643,
  [1644] = 1644,
  [1645] = 1615,
  [1646] = 1646,
  [1647] = 1635,
  [1648] = 1583,
  [1649] = 1649,
  [1650] = 1650,
  [1651] = 1651,
  [1652] = 1652,
  [1653] = 1653,
  [1654] = 1654,
  [1655] = 1655,
  [1656] = 1656,
  [1657] = 1657,
  [1658] = 1608,
  [1659] = 1659,
  [1660] = 1650,
  [1661] = 1571,
  [1662] = 1662,
  [1663] = 1663,
  [1664] = 1664,
  [1665] = 1593,
  [1666] = 1594,
  [1667] = 1667,
  [1668] = 1617,
  [1669] = 1585,
  [1670] = 1586,
  [1671] = 1671,
  [1672] = 1672,
  [1673] = 1624,
  [1674] = 1077,
  [1675] = 1675,
  [1676] = 1676,
  [1677] = 1677,
  [1678] = 1678,
  [1679] = 1679,
  [1680] = 1625,
  [1681] = 1681,
  [1682] = 1652,
  [1683] = 1683,
  [1684] = 1653,
  [1685] = 1654,
  [1686] = 1655,
  [1687] = 1687,
  [1688] = 1611,
  [1689] = 1689,
  [1690] = 1690,
  [1691] = 1574,
  [1692] = 1689,
  [1693] = 1628,
  [1694] = 1694,
  [1695] = 1695,
  [1696] = 1696,
  [1697] = 1687,
  [1698] = 1698,
  [1699] = 1699,
  [1700] = 1573,
  [1701] = 1701,
  [1702] = 1681,
  [1703] = 1703,
  [1704] = 1649,
  [1705] = 1694,
  [1706] = 1706,
  [1707] = 1656,
  [1708] = 1575,
  [1709] = 1709,
  [1710] = 1602,
  [1711] = 1698,
  [1712] = 1712,
  [1713] = 1713,
  [1714] = 1663,
  [1715] = 1715,
  [1716] = 1716,
  [1717] = 1717,
  [1718] = 1659,
  [1719] = 1600,
  [1720] = 1720,
  [1721] = 1721,
  [1722] = 1722,
  [1723] = 1723,
  [1724] = 1724,
  [1725] = 1725,
  [1726] = 1723,
  [1727] = 1727,
  [1728] = 1728,
  [1729] = 1729,
  [1730] = 1722,
  [1731] = 1731,
  [1732] = 1732,
  [1733] = 1733,
  [1734] = 1734,
  [1735] = 1735,
  [1736] = 1736,
  [1737] = 1737,
  [1738] = 1727,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1741,
  [1742] = 1742,
  [1743] = 1743,
  [1744] = 1740,
  [1745] = 1745,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1748,
  [1749] = 1749,
  [1750] = 1750,
  [1751] = 1751,
  [1752] = 1752,
  [1753] = 1753,
  [1754] = 1754,
  [1755] = 1755,
  [1756] = 1756,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1760,
  [1761] = 1761,
  [1762] = 1762,
  [1763] = 1763,
  [1764] = 1743,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1769,
  [1770] = 1770,
  [1771] = 1771,
  [1772] = 1772,
  [1773] = 1773,
  [1774] = 1733,
  [1775] = 1775,
  [1776] = 1776,
  [1777] = 1745,
  [1778] = 1752,
  [1779] = 1779,
  [1780] = 1780,
  [1781] = 1741,
  [1782] = 1756,
  [1783] = 1783,
  [1784] = 1760,
  [1785] = 1785,
  [1786] = 1722,
  [1787] = 1787,
  [1788] = 1788,
  [1789] = 1789,
  [1790] = 1790,
  [1791] = 1791,
  [1792] = 1792,
  [1793] = 1793,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1724,
  [1797] = 1775,
  [1798] = 1798,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1723,
  [1806] = 1745,
  [1807] = 1807,
  [1808] = 1722,
  [1809] = 1809,
  [1810] = 1810,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1814,
  [1815] = 1815,
  [1816] = 1780,
  [1817] = 1817,
  [1818] = 1804,
  [1819] = 1819,
  [1820] = 1820,
  [1821] = 1770,
  [1822] = 1822,
  [1823] = 1823,
  [1824] = 1824,
  [1825] = 1747,
  [1826] = 1749,
  [1827] = 1758,
  [1828] = 1828,
  [1829] = 1829,
  [1830] = 1830,
  [1831] = 1750,
  [1832] = 1832,
  [1833] = 1833,
  [1834] = 1834,
  [1835] = 1835,
  [1836] = 1836,
  [1837] = 1837,
  [1838] = 1838,
  [1839] = 1839,
  [1840] = 1840,
  [1841] = 1841,
  [1842] = 1842,
  [1843] = 1843,
  [1844] = 1844,
  [1845] = 1787,
  [1846] = 1846,
  [1847] = 1847,
  [1848] = 1848,
  [1849] = 1829,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1794,
  [1854] = 1836,
  [1855] = 1731,
  [1856] = 1759,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1859,
  [1860] = 1860,
  [1861] = 1861,
  [1862] = 1862,
  [1863] = 1863,
  [1864] = 1864,
  [1865] = 1809,
  [1866] = 1815,
  [1867] = 1834,
  [1868] = 1761,
  [1869] = 1817,
  [1870] = 1870,
  [1871] = 1871,
  [1872] = 1857,
  [1873] = 1873,
  [1874] = 1874,
  [1875] = 1819,
  [1876] = 1876,
  [1877] = 1877,
  [1878] = 1846,
  [1879] = 1879,
  [1880] = 1880,
  [1881] = 1881,
  [1882] = 1828,
  [1883] = 1883,
  [1884] = 1884,
  [1885] = 1848,
  [1886] = 1820,
  [1887] = 1887,
  [1888] = 1888,
  [1889] = 1889,
  [1890] = 1890,
  [1891] = 1823,
  [1892] = 1892,
  [1893] = 1893,
  [1894] = 1894,
  [1895] = 1851,
  [1896] = 1874,
  [1897] = 1870,
  [1898] = 1898,
  [1899] = 1762,
  [1900] = 1900,
  [1901] = 1861,
  [1902] = 1883,
  [1903] = 1735,
  [1904] = 1888,
  [1905] = 1905,
  [1906] = 1801,
  [1907] = 1794,
  [1908] = 1754,
  [1909] = 1909,
  [1910] = 1795,
  [1911] = 1911,
  [1912] = 1884,
  [1913] = 1850,
  [1914] = 1887,
  [1915] = 1915,
  [1916] = 1859,
  [1917] = 1799,
  [1918] = 1918,
  [1919] = 1729,
  [1920] = 1725,
  [1921] = 1734,
  [1922] = 1724,
  [1923] = 1900,
  [1924] = 1924,
  [1925] = 1779,
  [1926] = 1751,
  [1927] = 1832,
  [1928] = 1748,
  [1929] = 1837,
  [1930] = 1864,
  [1931] = 1798,
  [1932] = 1932,
  [1933] = 1840,
  [1934] = 1905,
  [1935] = 1935,
  [1936] = 1852,
  [1937] = 1937,
  [1938] = 1814,
  [1939] = 1746,
  [1940] = 1795,
  [1941] = 1787,
  [1942] = 1942,
  [1943] = 1924,
  [1944] = 1862,
  [1945] = 1889,
  [1946] = 1946,
  [1947] = 1858,
  [1948] = 1924,
  [1949] = 1880,
  [1950] = 1877,
  [1951] = 1800,
  [1952] = 1952,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(80);
      ADVANCE_MAP(
        '!', 147,
        '"', 7,
        '#', 141,
        '%', 160,
        '&', 106,
        '\'', 24,
        '(', 81,
        ')', 82,
        '*', 102,
        '+', 113,
        ',', 83,
        '-', 108,
        '.', 125,
        '/', 116,
        '0', 131,
        ':', 95,
        ';', 137,
        '<', 142,
        '=', 86,
        '>', 144,
        '?', 170,
        '@', 90,
        '[', 122,
        ']', 123,
        '^', 152,
        '{', 91,
        '|', 151,
        '}', 92,
        '~', 148,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(134);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '\n', 138,
        '!', 58,
        '(', 81,
        '*', 101,
        '+', 114,
        ',', 83,
        '-', 107,
        '.', 124,
        '/', 115,
        ':', 94,
        ';', 137,
        '=', 85,
        '[', 122,
        '{', 91,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(138);
      if (lookahead == '*') ADVANCE(101);
      if (lookahead == ',') ADVANCE(83);
      if (lookahead == '/') ADVANCE(46);
      if (lookahead == ':') ADVANCE(94);
      if (lookahead == ';') ADVANCE(137);
      if (lookahead == '=') ADVANCE(84);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '!', 147,
        '#', 141,
        '%', 159,
        '&', 106,
        '\'', 42,
        '(', 81,
        ')', 82,
        '*', 103,
        '+', 114,
        ',', 83,
        '-', 109,
        '.', 124,
        '/', 116,
        '0', 131,
        ':', 57,
        ';', 137,
        '<', 154,
        '=', 86,
        '>', 144,
        '?', 170,
        '@', 90,
        '[', 122,
        ']', 123,
        '^', 152,
        '{', 91,
        '|', 151,
        '}', 92,
        '~', 148,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(134);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 146,
        '#', 141,
        '\'', 42,
        '(', 81,
        ')', 82,
        '*', 100,
        ',', 83,
        '-', 110,
        '.', 45,
        '/', 46,
        '0', 131,
        ':', 95,
        '@', 90,
        '{', 91,
        '}', 92,
        '~', 148,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(134);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '!', 58,
        '%', 159,
        '&', 106,
        '(', 81,
        ')', 82,
        '*', 103,
        '+', 114,
        ',', 83,
        '-', 111,
        '.', 124,
        '/', 116,
        ':', 95,
        ';', 137,
        '<', 154,
        '=', 86,
        '>', 144,
        '?', 170,
        '[', 122,
        ']', 123,
        '^', 152,
        '{', 91,
        '|', 151,
        '}', 92,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 58,
        '(', 81,
        ')', 82,
        '*', 101,
        '+', 112,
        ',', 83,
        '-', 107,
        '.', 124,
        '/', 115,
        ':', 94,
        ';', 137,
        '<', 153,
        '=', 86,
        '>', 143,
        '[', 122,
        ']', 123,
        '{', 91,
        '}', 92,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(117);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(7);
      END_STATE();
    case 8:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == '1') ADVANCE(10);
      if (lookahead == '2') ADVANCE(15);
      if (lookahead == '3') ADVANCE(9);
      if (lookahead == '6') ADVANCE(13);
      if (lookahead == '8') ADVANCE(172);
      if (lookahead == 's') ADVANCE(20);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 9:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == '2') ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 10:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == '2') ADVANCE(17);
      if (lookahead == '6') ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 11:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == '2') ADVANCE(14);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 12:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == '3') ADVANCE(9);
      if (lookahead == '6') ADVANCE(13);
      if (lookahead == 'e') ADVANCE(21);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 13:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == '4') ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 14:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == '5') ADVANCE(9);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 15:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == '5') ADVANCE(16);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 16:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == '6') ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 17:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == '8') ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 18:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == 'e') ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 19:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == 'f') ADVANCE(12);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'u') ADVANCE(8);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 20:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == 'i') ADVANCE(23);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 21:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == 'l') ADVANCE(22);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 22:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == 't') ADVANCE(11);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 23:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == 'z') ADVANCE(18);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 25:
      if (lookahead == '\'') ADVANCE(119);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(25);
      END_STATE();
    case 26:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == '1') ADVANCE(28);
      if (lookahead == '2') ADVANCE(32);
      if (lookahead == '3') ADVANCE(27);
      if (lookahead == '6') ADVANCE(31);
      if (lookahead == '8') ADVANCE(174);
      if (lookahead == 's') ADVANCE(38);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 27:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == '2') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 28:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == '2') ADVANCE(35);
      if (lookahead == '6') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 29:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == '2') ADVANCE(33);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 30:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == '3') ADVANCE(27);
      if (lookahead == '6') ADVANCE(31);
      if (lookahead == 'e') ADVANCE(39);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 31:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == '4') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 32:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == '5') ADVANCE(34);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 33:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == '5') ADVANCE(27);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 34:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == '6') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 35:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == '8') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 36:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == 'e') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 37:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == 'f') ADVANCE(30);
      if (lookahead == 'i') ADVANCE(26);
      if (lookahead == 'u') ADVANCE(26);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 38:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == 'i') ADVANCE(41);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 39:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == 'l') ADVANCE(40);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 40:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == 't') ADVANCE(29);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 41:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == 'z') ADVANCE(36);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 42:
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 43:
      if (lookahead == '+') ADVANCE(97);
      END_STATE();
    case 44:
      if (lookahead == '-') ADVANCE(59);
      if (lookahead == '/') ADVANCE(46);
      if (lookahead == ':') ADVANCE(94);
      if (lookahead == ';') ADVANCE(137);
      if (lookahead == '{') ADVANCE(91);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(44);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 45:
      if (lookahead == '.') ADVANCE(171);
      END_STATE();
    case 46:
      if (lookahead == '/') ADVANCE(139);
      END_STATE();
    case 47:
      if (lookahead == '1') ADVANCE(49);
      if (lookahead == '2') ADVANCE(54);
      if (lookahead == '3') ADVANCE(48);
      if (lookahead == '6') ADVANCE(52);
      if (lookahead == '8') ADVANCE(127);
      if (lookahead == 's') ADVANCE(64);
      END_STATE();
    case 48:
      if (lookahead == '2') ADVANCE(127);
      END_STATE();
    case 49:
      if (lookahead == '2') ADVANCE(56);
      if (lookahead == '6') ADVANCE(127);
      END_STATE();
    case 50:
      if (lookahead == '2') ADVANCE(53);
      END_STATE();
    case 51:
      if (lookahead == '3') ADVANCE(48);
      if (lookahead == '6') ADVANCE(52);
      if (lookahead == 'e') ADVANCE(67);
      END_STATE();
    case 52:
      if (lookahead == '4') ADVANCE(127);
      END_STATE();
    case 53:
      if (lookahead == '5') ADVANCE(48);
      END_STATE();
    case 54:
      if (lookahead == '5') ADVANCE(55);
      END_STATE();
    case 55:
      if (lookahead == '6') ADVANCE(127);
      END_STATE();
    case 56:
      if (lookahead == '8') ADVANCE(127);
      END_STATE();
    case 57:
      if (lookahead == ':') ADVANCE(140);
      END_STATE();
    case 58:
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 59:
      if (lookahead == '>') ADVANCE(93);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(69);
      END_STATE();
    case 61:
      if (lookahead == 'b') ADVANCE(74);
      if (lookahead == 'l') ADVANCE(60);
      if (lookahead == '{') ADVANCE(120);
      if (lookahead == '}') ADVANCE(121);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 63:
      if (lookahead == 'g') ADVANCE(89);
      END_STATE();
    case 64:
      if (lookahead == 'i') ADVANCE(75);
      END_STATE();
    case 65:
      if (lookahead == 'i') ADVANCE(70);
      END_STATE();
    case 66:
      if (lookahead == 'i') ADVANCE(68);
      END_STATE();
    case 67:
      if (lookahead == 'l') ADVANCE(72);
      END_STATE();
    case 68:
      if (lookahead == 'l') ADVANCE(73);
      END_STATE();
    case 69:
      if (lookahead == 'n') ADVANCE(63);
      END_STATE();
    case 70:
      if (lookahead == 'n') ADVANCE(71);
      END_STATE();
    case 71:
      if (lookahead == 's') ADVANCE(88);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(50);
      END_STATE();
    case 73:
      if (lookahead == 't') ADVANCE(65);
      END_STATE();
    case 74:
      if (lookahead == 'u') ADVANCE(66);
      END_STATE();
    case 75:
      if (lookahead == 'z') ADVANCE(62);
      END_STATE();
    case 76:
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(132);
      END_STATE();
    case 77:
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(133);
      END_STATE();
    case 78:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(136);
      END_STATE();
    case 79:
      if (eof) ADVANCE(80);
      ADVANCE_MAP(
        '#', 141,
        '%', 61,
        '&', 105,
        '\'', 25,
        '(', 81,
        ')', 82,
        '*', 101,
        '+', 43,
        ',', 83,
        '-', 110,
        '.', 124,
        '/', 46,
        '0', 131,
        ':', 95,
        ';', 137,
        '<', 142,
        '=', 87,
        '>', 143,
        '@', 90,
        '[', 122,
        '{', 91,
        '}', 92,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(79);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(134);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(96);
      if (lookahead == '>') ADVANCE(145);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(145);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_PERCENTbuiltins);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_PERCENTlang);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(140);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(104);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(104);
      if (lookahead == '=') ADVANCE(162);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(162);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(149);
      if (lookahead == '=') ADVANCE(165);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '0') ADVANCE(131);
      if (lookahead == '=') ADVANCE(161);
      if (lookahead == '>') ADVANCE(93);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(134);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '0') ADVANCE(131);
      if (lookahead == '=') ADVANCE(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(134);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '0') ADVANCE(131);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(134);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(161);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(97);
      if (lookahead == '=') ADVANCE(99);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(99);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(139);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(139);
      if (lookahead == '=') ADVANCE(163);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '"') ADVANCE(117);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(7);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_short_string);
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead == '_') ADVANCE(19);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_short_string);
      if (lookahead == '\'') ADVANCE(119);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(25);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_PERCENT_LBRACE);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PERCENT_RBRACE);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(171);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '2') ADVANCE(136);
      if (lookahead == 'f') ADVANCE(129);
      if (lookahead == 'i') ADVANCE(47);
      if (lookahead == 'u') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(136);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '3') ADVANCE(128);
      if (lookahead == '6') ADVANCE(130);
      if (lookahead == 'e') ADVANCE(135);
      if (lookahead == 'f') ADVANCE(129);
      if (lookahead == 'i') ADVANCE(47);
      if (lookahead == 'u') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'd')) ADVANCE(136);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '4') ADVANCE(136);
      if (lookahead == 'f') ADVANCE(129);
      if (lookahead == 'i') ADVANCE(47);
      if (lookahead == 'u') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(136);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'b') ADVANCE(76);
      if (lookahead == 'f') ADVANCE(51);
      if (lookahead == 'i') ADVANCE(47);
      if (lookahead == 'o') ADVANCE(77);
      if (lookahead == 'u') ADVANCE(47);
      if (lookahead == 'x') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(134);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'f') ADVANCE(51);
      if (lookahead == 'i') ADVANCE(47);
      if (lookahead == 'u') ADVANCE(47);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(132);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'f') ADVANCE(51);
      if (lookahead == 'i') ADVANCE(47);
      if (lookahead == 'u') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'f') ADVANCE(51);
      if (lookahead == 'i') ADVANCE(47);
      if (lookahead == 'u') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(134);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'f') ADVANCE(129);
      if (lookahead == 'i') ADVANCE(47);
      if (lookahead == 'l') ADVANCE(72);
      if (lookahead == 'u') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(136);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'f') ADVANCE(129);
      if (lookahead == 'i') ADVANCE(47);
      if (lookahead == 'u') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(138);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(139);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(156);
      if (lookahead == '>') ADVANCE(158);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(166);
      if (lookahead == '|') ADVANCE(150);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(167);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_LT2);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_LT2);
      if (lookahead == '<') ADVANCE(157);
      if (lookahead == '=') ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(168);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(169);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(164);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(164);
      if (lookahead == '}') ADVANCE(121);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym__cairo_1_short_string);
      if (lookahead == '\'') ADVANCE(118);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym__cairo_1_short_string);
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == '_') ADVANCE(37);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym__cairo_1_short_string);
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(42);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        '_', 1,
        'a', 2,
        'b', 3,
        'c', 4,
        'd', 5,
        'e', 6,
        'f', 7,
        'i', 8,
        'j', 9,
        'l', 10,
        'm', 11,
        'n', 12,
        'o', 13,
        'r', 14,
        's', 15,
        't', 16,
        'u', 17,
        'w', 18,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 2:
      if (lookahead == 'b') ADVANCE(19);
      if (lookahead == 'l') ADVANCE(20);
      if (lookahead == 'n') ADVANCE(21);
      if (lookahead == 'p') ADVANCE(22);
      if (lookahead == 's') ADVANCE(23);
      END_STATE();
    case 3:
      if (lookahead == 'o') ADVANCE(24);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(25);
      if (lookahead == 'h') ADVANCE(26);
      if (lookahead == 'o') ADVANCE(27);
      END_STATE();
    case 5:
      if (lookahead == 'w') ADVANCE(28);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'n') ADVANCE(30);
      if (lookahead == 'x') ADVANCE(31);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '3', 32,
        '6', 33,
        'a', 34,
        'e', 35,
        'n', 36,
        'p', 37,
        'r', 38,
        'u', 39,
      );
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '1', 40,
        '2', 41,
        '3', 42,
        '6', 43,
        '8', 44,
        'f', 45,
        'm', 46,
        's', 47,
      );
      END_STATE();
    case 9:
      if (lookahead == 'm') ADVANCE(48);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(49);
      if (lookahead == 'o') ADVANCE(50);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(51);
      if (lookahead == 'o') ADVANCE(52);
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(54);
      if (lookahead == 'e') ADVANCE(55);
      if (lookahead == 'o') ADVANCE(56);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(57);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(58);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(59);
      if (lookahead == 't') ADVANCE(60);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(61);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == 'y') ADVANCE(63);
      END_STATE();
    case 17:
      if (lookahead == '1') ADVANCE(64);
      if (lookahead == '2') ADVANCE(65);
      if (lookahead == '3') ADVANCE(66);
      if (lookahead == '6') ADVANCE(67);
      if (lookahead == '8') ADVANCE(68);
      if (lookahead == 's') ADVANCE(69);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(70);
      END_STATE();
    case 19:
      if (lookahead == 's') ADVANCE(71);
      END_STATE();
    case 20:
      if (lookahead == 'l') ADVANCE(72);
      END_STATE();
    case 21:
      if (lookahead == 'd') ADVANCE(73);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_ap);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(74);
      END_STATE();
    case 24:
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 25:
      if (lookahead == 'l') ADVANCE(76);
      if (lookahead == 's') ADVANCE(77);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(78);
      END_STATE();
    case 27:
      if (lookahead == 'd') ADVANCE(79);
      if (lookahead == 'n') ADVANCE(80);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_dw);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(81);
      END_STATE();
    case 30:
      if (lookahead == 'd') ADVANCE(82);
      if (lookahead == 'u') ADVANCE(83);
      END_STATE();
    case 31:
      if (lookahead == 't') ADVANCE(84);
      END_STATE();
    case 32:
      if (lookahead == '2') ADVANCE(85);
      END_STATE();
    case 33:
      if (lookahead == '4') ADVANCE(86);
      END_STATE();
    case 34:
      if (lookahead == 'l') ADVANCE(87);
      END_STATE();
    case 35:
      if (lookahead == 'l') ADVANCE(88);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_fp);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(89);
      END_STATE();
    case 39:
      if (lookahead == 'n') ADVANCE(90);
      END_STATE();
    case 40:
      if (lookahead == '2') ADVANCE(91);
      if (lookahead == '6') ADVANCE(92);
      END_STATE();
    case 41:
      if (lookahead == '5') ADVANCE(93);
      END_STATE();
    case 42:
      if (lookahead == '2') ADVANCE(94);
      END_STATE();
    case 43:
      if (lookahead == '4') ADVANCE(95);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_i8);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 46:
      if (lookahead == 'p') ADVANCE(96);
      END_STATE();
    case 47:
      if (lookahead == 'i') ADVANCE(97);
      END_STATE();
    case 48:
      if (lookahead == 'p') ADVANCE(98);
      END_STATE();
    case 49:
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 50:
      if (lookahead == 'c') ADVANCE(100);
      if (lookahead == 'o') ADVANCE(101);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 52:
      if (lookahead == 'd') ADVANCE(103);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(104);
      END_STATE();
    case 54:
      if (lookahead == 'm') ADVANCE(105);
      END_STATE();
    case 55:
      if (lookahead == 'w') ADVANCE(106);
      END_STATE();
    case 56:
      if (lookahead == 'n') ADVANCE(107);
      if (lookahead == 'p') ADVANCE(108);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 58:
      if (lookahead == 'f') ADVANCE(109);
      if (lookahead == 'l') ADVANCE(110);
      if (lookahead == 't') ADVANCE(111);
      END_STATE();
    case 59:
      if (lookahead == 'l') ADVANCE(112);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(113);
      if (lookahead == 'r') ADVANCE(114);
      END_STATE();
    case 61:
      if (lookahead == 'm') ADVANCE(115);
      END_STATE();
    case 62:
      if (lookahead == 'a') ADVANCE(116);
      if (lookahead == 'u') ADVANCE(117);
      END_STATE();
    case 63:
      if (lookahead == 'p') ADVANCE(118);
      END_STATE();
    case 64:
      if (lookahead == '2') ADVANCE(119);
      if (lookahead == '6') ADVANCE(120);
      END_STATE();
    case 65:
      if (lookahead == '5') ADVANCE(121);
      END_STATE();
    case 66:
      if (lookahead == '2') ADVANCE(122);
      END_STATE();
    case 67:
      if (lookahead == '4') ADVANCE(123);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_u8);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(124);
      if (lookahead == 'i') ADVANCE(125);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_abs);
      END_STATE();
    case 72:
      if (lookahead == 'o') ADVANCE(127);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(128);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(129);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(130);
      END_STATE();
    case 77:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 78:
      if (lookahead == 'r') ADVANCE(132);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(133);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(134);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(135);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 83:
      if (lookahead == 'm') ADVANCE(136);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(137);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_f32);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_f64);
      END_STATE();
    case 87:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 88:
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 89:
      if (lookahead == 'm') ADVANCE(140);
      END_STATE();
    case 90:
      if (lookahead == 'c') ADVANCE(141);
      END_STATE();
    case 91:
      if (lookahead == '8') ADVANCE(142);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_i16);
      END_STATE();
    case 93:
      if (lookahead == '6') ADVANCE(143);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_i32);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_i64);
      END_STATE();
    case 96:
      if (lookahead == 'l') ADVANCE(144);
      if (lookahead == 'o') ADVANCE(145);
      END_STATE();
    case 97:
      if (lookahead == 'z') ADVANCE(146);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_jmp);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 100:
      if (lookahead == 'a') ADVANCE(147);
      END_STATE();
    case 101:
      if (lookahead == 'p') ADVANCE(148);
      END_STATE();
    case 102:
      if (lookahead == 'c') ADVANCE(149);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_mod);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_mut);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(150);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 107:
      if (lookahead == 'd') ADVANCE(151);
      END_STATE();
    case 108:
      if (lookahead == 'a') ADVANCE(152);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_rel);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_inst_ret);
      if (lookahead == 'u') ADVANCE(153);
      END_STATE();
    case 112:
      if (lookahead == 'f') ADVANCE(154);
      END_STATE();
    case 113:
      if (lookahead == 't') ADVANCE(155);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_str);
      if (lookahead == 'u') ADVANCE(156);
      END_STATE();
    case 115:
      if (lookahead == 'p') ADVANCE(157);
      END_STATE();
    case 116:
      if (lookahead == 'i') ADVANCE(158);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 118:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 119:
      if (lookahead == '8') ADVANCE(161);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_u16);
      END_STATE();
    case 121:
      if (lookahead == '6') ADVANCE(162);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_u32);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_u64);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 125:
      if (lookahead == 'n') ADVANCE(163);
      if (lookahead == 'z') ADVANCE(164);
      END_STATE();
    case 126:
      if (lookahead == 'h') ADVANCE(165);
      END_STATE();
    case 127:
      if (lookahead == 'c') ADVANCE(166);
      END_STATE();
    case 128:
      if (lookahead == 'r') ADVANCE(167);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_call);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_cast);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_char);
      END_STATE();
    case 133:
      if (lookahead == 'o') ADVANCE(168);
      END_STATE();
    case 134:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 137:
      if (lookahead == 'r') ADVANCE(170);
      END_STATE();
    case 138:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_felt);
      if (lookahead == '2') ADVANCE(172);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_func);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_i128);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_i256);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_impl);
      if (lookahead == 'i') ADVANCE(173);
      END_STATE();
    case 145:
      if (lookahead == 'r') ADVANCE(174);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 147:
      if (lookahead == 'l') ADVANCE(176);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_loop);
      END_STATE();
    case 149:
      if (lookahead == 'h') ADVANCE(177);
      END_STATE();
    case 150:
      if (lookahead == 's') ADVANCE(178);
      END_STATE();
    case 151:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 152:
      if (lookahead == 'n') ADVANCE(180);
      END_STATE();
    case 153:
      if (lookahead == 'r') ADVANCE(181);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 155:
      if (lookahead == 'i') ADVANCE(182);
      END_STATE();
    case 156:
      if (lookahead == 'c') ADVANCE(183);
      END_STATE();
    case 157:
      if (lookahead == 'v') ADVANCE(184);
      END_STATE();
    case 158:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_u128);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_u256);
      END_STATE();
    case 163:
      if (lookahead == 'g') ADVANCE(186);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_with);
      if (lookahead == '_') ADVANCE(188);
      END_STATE();
    case 166:
      if (lookahead == '_') ADVANCE(189);
      END_STATE();
    case 167:
      if (lookahead == 't') ADVANCE(190);
      END_STATE();
    case 168:
      if (lookahead == 'f') ADVANCE(191);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 170:
      if (lookahead == 'n') ADVANCE(192);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 172:
      if (lookahead == '5') ADVANCE(193);
      END_STATE();
    case 173:
      if (lookahead == 'c') ADVANCE(194);
      END_STATE();
    case 174:
      if (lookahead == 't') ADVANCE(195);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_isize);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 178:
      if (lookahead == 'p') ADVANCE(196);
      END_STATE();
    case 179:
      if (lookahead == 't') ADVANCE(197);
      END_STATE();
    case 180:
      if (lookahead == 'i') ADVANCE(198);
      END_STATE();
    case 181:
      if (lookahead == 'n') ADVANCE(199);
      END_STATE();
    case 182:
      if (lookahead == 'c') ADVANCE(200);
      END_STATE();
    case 183:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 184:
      if (lookahead == 'a') ADVANCE(202);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_trait);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_usize);
      END_STATE();
    case 188:
      if (lookahead == 'a') ADVANCE(203);
      END_STATE();
    case 189:
      if (lookahead == 'l') ADVANCE(204);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 191:
      if (lookahead == 'f') ADVANCE(205);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 193:
      if (lookahead == '2') ADVANCE(206);
      END_STATE();
    case 194:
      if (lookahead == 'i') ADVANCE(207);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 196:
      if (lookahead == 'a') ADVANCE(208);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_nondet);
      END_STATE();
    case 198:
      if (lookahead == 'c') ADVANCE(209);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 200:
      if (lookahead == '_') ADVANCE(210);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 202:
      if (lookahead == 'r') ADVANCE(211);
      END_STATE();
    case 203:
      if (lookahead == 't') ADVANCE(212);
      END_STATE();
    case 204:
      if (lookahead == 'o') ADVANCE(213);
      END_STATE();
    case 205:
      if (lookahead == 's') ADVANCE(214);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_felt252);
      END_STATE();
    case 207:
      if (lookahead == 't') ADVANCE(215);
      END_STATE();
    case 208:
      if (lookahead == 'c') ADVANCE(216);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_nopanic);
      END_STATE();
    case 210:
      if (lookahead == 'a') ADVANCE(217);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_tempvar);
      END_STATE();
    case 212:
      if (lookahead == 't') ADVANCE(218);
      END_STATE();
    case 213:
      if (lookahead == 'c') ADVANCE(219);
      END_STATE();
    case 214:
      if (lookahead == 'e') ADVANCE(220);
      END_STATE();
    case 215:
      if (lookahead == 's') ADVANCE(221);
      END_STATE();
    case 216:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 217:
      if (lookahead == 's') ADVANCE(223);
      END_STATE();
    case 218:
      if (lookahead == 'r') ADVANCE(224);
      END_STATE();
    case 219:
      if (lookahead == 'a') ADVANCE(225);
      END_STATE();
    case 220:
      if (lookahead == 't') ADVANCE(226);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_implicits);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 223:
      if (lookahead == 's') ADVANCE(227);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_with_attr);
      END_STATE();
    case 225:
      if (lookahead == 'l') ADVANCE(228);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_codeoffset);
      END_STATE();
    case 227:
      if (lookahead == 'e') ADVANCE(229);
      END_STATE();
    case 228:
      if (lookahead == 's') ADVANCE(230);
      END_STATE();
    case 229:
      if (lookahead == 'r') ADVANCE(231);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_alloc_locals);
      END_STATE();
    case 231:
      if (lookahead == 't') ADVANCE(232);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_static_assert);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 79, .external_lex_state = 2},
  [2] = {.lex_state = 3},
  [3] = {.lex_state = 3},
  [4] = {.lex_state = 4},
  [5] = {.lex_state = 4},
  [6] = {.lex_state = 4},
  [7] = {.lex_state = 4},
  [8] = {.lex_state = 3},
  [9] = {.lex_state = 4},
  [10] = {.lex_state = 4},
  [11] = {.lex_state = 4},
  [12] = {.lex_state = 4},
  [13] = {.lex_state = 4},
  [14] = {.lex_state = 4},
  [15] = {.lex_state = 4},
  [16] = {.lex_state = 79, .external_lex_state = 2},
  [17] = {.lex_state = 79, .external_lex_state = 2},
  [18] = {.lex_state = 79, .external_lex_state = 2},
  [19] = {.lex_state = 79, .external_lex_state = 2},
  [20] = {.lex_state = 79, .external_lex_state = 2},
  [21] = {.lex_state = 79, .external_lex_state = 2},
  [22] = {.lex_state = 79, .external_lex_state = 2},
  [23] = {.lex_state = 79, .external_lex_state = 2},
  [24] = {.lex_state = 79, .external_lex_state = 2},
  [25] = {.lex_state = 79, .external_lex_state = 2},
  [26] = {.lex_state = 79, .external_lex_state = 2},
  [27] = {.lex_state = 79, .external_lex_state = 2},
  [28] = {.lex_state = 79, .external_lex_state = 2},
  [29] = {.lex_state = 79, .external_lex_state = 2},
  [30] = {.lex_state = 79, .external_lex_state = 2},
  [31] = {.lex_state = 79, .external_lex_state = 2},
  [32] = {.lex_state = 79, .external_lex_state = 2},
  [33] = {.lex_state = 79, .external_lex_state = 2},
  [34] = {.lex_state = 79, .external_lex_state = 2},
  [35] = {.lex_state = 79, .external_lex_state = 2},
  [36] = {.lex_state = 79, .external_lex_state = 2},
  [37] = {.lex_state = 79, .external_lex_state = 2},
  [38] = {.lex_state = 79, .external_lex_state = 2},
  [39] = {.lex_state = 79, .external_lex_state = 2},
  [40] = {.lex_state = 79, .external_lex_state = 2},
  [41] = {.lex_state = 79, .external_lex_state = 2},
  [42] = {.lex_state = 79, .external_lex_state = 2},
  [43] = {.lex_state = 79, .external_lex_state = 2},
  [44] = {.lex_state = 79, .external_lex_state = 2},
  [45] = {.lex_state = 79, .external_lex_state = 2},
  [46] = {.lex_state = 79, .external_lex_state = 2},
  [47] = {.lex_state = 79, .external_lex_state = 2},
  [48] = {.lex_state = 79, .external_lex_state = 2},
  [49] = {.lex_state = 79, .external_lex_state = 2},
  [50] = {.lex_state = 79, .external_lex_state = 2},
  [51] = {.lex_state = 79, .external_lex_state = 2},
  [52] = {.lex_state = 79, .external_lex_state = 2},
  [53] = {.lex_state = 79, .external_lex_state = 2},
  [54] = {.lex_state = 79, .external_lex_state = 2},
  [55] = {.lex_state = 79, .external_lex_state = 2},
  [56] = {.lex_state = 79, .external_lex_state = 2},
  [57] = {.lex_state = 79, .external_lex_state = 2},
  [58] = {.lex_state = 79, .external_lex_state = 2},
  [59] = {.lex_state = 79, .external_lex_state = 2},
  [60] = {.lex_state = 79, .external_lex_state = 2},
  [61] = {.lex_state = 79, .external_lex_state = 2},
  [62] = {.lex_state = 79, .external_lex_state = 2},
  [63] = {.lex_state = 79, .external_lex_state = 2},
  [64] = {.lex_state = 79, .external_lex_state = 2},
  [65] = {.lex_state = 79, .external_lex_state = 2},
  [66] = {.lex_state = 79, .external_lex_state = 2},
  [67] = {.lex_state = 79, .external_lex_state = 2},
  [68] = {.lex_state = 79, .external_lex_state = 2},
  [69] = {.lex_state = 79, .external_lex_state = 2},
  [70] = {.lex_state = 79, .external_lex_state = 2},
  [71] = {.lex_state = 79, .external_lex_state = 2},
  [72] = {.lex_state = 79, .external_lex_state = 2},
  [73] = {.lex_state = 79, .external_lex_state = 2},
  [74] = {.lex_state = 79, .external_lex_state = 2},
  [75] = {.lex_state = 79, .external_lex_state = 2},
  [76] = {.lex_state = 79, .external_lex_state = 2},
  [77] = {.lex_state = 79, .external_lex_state = 2},
  [78] = {.lex_state = 79, .external_lex_state = 2},
  [79] = {.lex_state = 79, .external_lex_state = 2},
  [80] = {.lex_state = 79, .external_lex_state = 2},
  [81] = {.lex_state = 79, .external_lex_state = 2},
  [82] = {.lex_state = 79, .external_lex_state = 2},
  [83] = {.lex_state = 79, .external_lex_state = 2},
  [84] = {.lex_state = 79, .external_lex_state = 2},
  [85] = {.lex_state = 79, .external_lex_state = 2},
  [86] = {.lex_state = 79, .external_lex_state = 2},
  [87] = {.lex_state = 3},
  [88] = {.lex_state = 3},
  [89] = {.lex_state = 3},
  [90] = {.lex_state = 79, .external_lex_state = 2},
  [91] = {.lex_state = 3},
  [92] = {.lex_state = 3},
  [93] = {.lex_state = 79, .external_lex_state = 2},
  [94] = {.lex_state = 3},
  [95] = {.lex_state = 3},
  [96] = {.lex_state = 3},
  [97] = {.lex_state = 3},
  [98] = {.lex_state = 3},
  [99] = {.lex_state = 3},
  [100] = {.lex_state = 3},
  [101] = {.lex_state = 3},
  [102] = {.lex_state = 3},
  [103] = {.lex_state = 3},
  [104] = {.lex_state = 3},
  [105] = {.lex_state = 3},
  [106] = {.lex_state = 3},
  [107] = {.lex_state = 3},
  [108] = {.lex_state = 3},
  [109] = {.lex_state = 3},
  [110] = {.lex_state = 3},
  [111] = {.lex_state = 3},
  [112] = {.lex_state = 3},
  [113] = {.lex_state = 3},
  [114] = {.lex_state = 3},
  [115] = {.lex_state = 3},
  [116] = {.lex_state = 3},
  [117] = {.lex_state = 3},
  [118] = {.lex_state = 3},
  [119] = {.lex_state = 3},
  [120] = {.lex_state = 3},
  [121] = {.lex_state = 3},
  [122] = {.lex_state = 3},
  [123] = {.lex_state = 3},
  [124] = {.lex_state = 3},
  [125] = {.lex_state = 3},
  [126] = {.lex_state = 3},
  [127] = {.lex_state = 3},
  [128] = {.lex_state = 3},
  [129] = {.lex_state = 3},
  [130] = {.lex_state = 3},
  [131] = {.lex_state = 3},
  [132] = {.lex_state = 3},
  [133] = {.lex_state = 3},
  [134] = {.lex_state = 3},
  [135] = {.lex_state = 3},
  [136] = {.lex_state = 3},
  [137] = {.lex_state = 3},
  [138] = {.lex_state = 3},
  [139] = {.lex_state = 3},
  [140] = {.lex_state = 3},
  [141] = {.lex_state = 3},
  [142] = {.lex_state = 3},
  [143] = {.lex_state = 3},
  [144] = {.lex_state = 3},
  [145] = {.lex_state = 3},
  [146] = {.lex_state = 3},
  [147] = {.lex_state = 3},
  [148] = {.lex_state = 3},
  [149] = {.lex_state = 3},
  [150] = {.lex_state = 3},
  [151] = {.lex_state = 3},
  [152] = {.lex_state = 3},
  [153] = {.lex_state = 3},
  [154] = {.lex_state = 3},
  [155] = {.lex_state = 3},
  [156] = {.lex_state = 3},
  [157] = {.lex_state = 3},
  [158] = {.lex_state = 3},
  [159] = {.lex_state = 3},
  [160] = {.lex_state = 3},
  [161] = {.lex_state = 3},
  [162] = {.lex_state = 3},
  [163] = {.lex_state = 3},
  [164] = {.lex_state = 3},
  [165] = {.lex_state = 3},
  [166] = {.lex_state = 3},
  [167] = {.lex_state = 3},
  [168] = {.lex_state = 3},
  [169] = {.lex_state = 3},
  [170] = {.lex_state = 3},
  [171] = {.lex_state = 3},
  [172] = {.lex_state = 3},
  [173] = {.lex_state = 3},
  [174] = {.lex_state = 4},
  [175] = {.lex_state = 4},
  [176] = {.lex_state = 4},
  [177] = {.lex_state = 4},
  [178] = {.lex_state = 4},
  [179] = {.lex_state = 4},
  [180] = {.lex_state = 4},
  [181] = {.lex_state = 4},
  [182] = {.lex_state = 4},
  [183] = {.lex_state = 4},
  [184] = {.lex_state = 4},
  [185] = {.lex_state = 4},
  [186] = {.lex_state = 4},
  [187] = {.lex_state = 4},
  [188] = {.lex_state = 4},
  [189] = {.lex_state = 4},
  [190] = {.lex_state = 4},
  [191] = {.lex_state = 4},
  [192] = {.lex_state = 4},
  [193] = {.lex_state = 4},
  [194] = {.lex_state = 4},
  [195] = {.lex_state = 4},
  [196] = {.lex_state = 4},
  [197] = {.lex_state = 4},
  [198] = {.lex_state = 4},
  [199] = {.lex_state = 4},
  [200] = {.lex_state = 4},
  [201] = {.lex_state = 4},
  [202] = {.lex_state = 4},
  [203] = {.lex_state = 4},
  [204] = {.lex_state = 4},
  [205] = {.lex_state = 4},
  [206] = {.lex_state = 4},
  [207] = {.lex_state = 4},
  [208] = {.lex_state = 4},
  [209] = {.lex_state = 4},
  [210] = {.lex_state = 4},
  [211] = {.lex_state = 3},
  [212] = {.lex_state = 4},
  [213] = {.lex_state = 4},
  [214] = {.lex_state = 4},
  [215] = {.lex_state = 4},
  [216] = {.lex_state = 4},
  [217] = {.lex_state = 4},
  [218] = {.lex_state = 4},
  [219] = {.lex_state = 4},
  [220] = {.lex_state = 4},
  [221] = {.lex_state = 4},
  [222] = {.lex_state = 4},
  [223] = {.lex_state = 3},
  [224] = {.lex_state = 3},
  [225] = {.lex_state = 4},
  [226] = {.lex_state = 4},
  [227] = {.lex_state = 4},
  [228] = {.lex_state = 4},
  [229] = {.lex_state = 4},
  [230] = {.lex_state = 4},
  [231] = {.lex_state = 4},
  [232] = {.lex_state = 4},
  [233] = {.lex_state = 4},
  [234] = {.lex_state = 4},
  [235] = {.lex_state = 4},
  [236] = {.lex_state = 4},
  [237] = {.lex_state = 4},
  [238] = {.lex_state = 4},
  [239] = {.lex_state = 4},
  [240] = {.lex_state = 4},
  [241] = {.lex_state = 4},
  [242] = {.lex_state = 4},
  [243] = {.lex_state = 4},
  [244] = {.lex_state = 4},
  [245] = {.lex_state = 4},
  [246] = {.lex_state = 4},
  [247] = {.lex_state = 4},
  [248] = {.lex_state = 4},
  [249] = {.lex_state = 4},
  [250] = {.lex_state = 4},
  [251] = {.lex_state = 4},
  [252] = {.lex_state = 4},
  [253] = {.lex_state = 4},
  [254] = {.lex_state = 4},
  [255] = {.lex_state = 4},
  [256] = {.lex_state = 4},
  [257] = {.lex_state = 4},
  [258] = {.lex_state = 4},
  [259] = {.lex_state = 4},
  [260] = {.lex_state = 4},
  [261] = {.lex_state = 4},
  [262] = {.lex_state = 4},
  [263] = {.lex_state = 4},
  [264] = {.lex_state = 4},
  [265] = {.lex_state = 4},
  [266] = {.lex_state = 4},
  [267] = {.lex_state = 4},
  [268] = {.lex_state = 4},
  [269] = {.lex_state = 4},
  [270] = {.lex_state = 4},
  [271] = {.lex_state = 4},
  [272] = {.lex_state = 4},
  [273] = {.lex_state = 4},
  [274] = {.lex_state = 4},
  [275] = {.lex_state = 4},
  [276] = {.lex_state = 4},
  [277] = {.lex_state = 4},
  [278] = {.lex_state = 4},
  [279] = {.lex_state = 4},
  [280] = {.lex_state = 4},
  [281] = {.lex_state = 4},
  [282] = {.lex_state = 4},
  [283] = {.lex_state = 4},
  [284] = {.lex_state = 4},
  [285] = {.lex_state = 4},
  [286] = {.lex_state = 4},
  [287] = {.lex_state = 4},
  [288] = {.lex_state = 4},
  [289] = {.lex_state = 4},
  [290] = {.lex_state = 4},
  [291] = {.lex_state = 4},
  [292] = {.lex_state = 4},
  [293] = {.lex_state = 4},
  [294] = {.lex_state = 4},
  [295] = {.lex_state = 4},
  [296] = {.lex_state = 4},
  [297] = {.lex_state = 4},
  [298] = {.lex_state = 4},
  [299] = {.lex_state = 4},
  [300] = {.lex_state = 4},
  [301] = {.lex_state = 4},
  [302] = {.lex_state = 4},
  [303] = {.lex_state = 3},
  [304] = {.lex_state = 3},
  [305] = {.lex_state = 3},
  [306] = {.lex_state = 3},
  [307] = {.lex_state = 3},
  [308] = {.lex_state = 3},
  [309] = {.lex_state = 3},
  [310] = {.lex_state = 3},
  [311] = {.lex_state = 3},
  [312] = {.lex_state = 3},
  [313] = {.lex_state = 3},
  [314] = {.lex_state = 4},
  [315] = {.lex_state = 4},
  [316] = {.lex_state = 4},
  [317] = {.lex_state = 4},
  [318] = {.lex_state = 4},
  [319] = {.lex_state = 4},
  [320] = {.lex_state = 4},
  [321] = {.lex_state = 4},
  [322] = {.lex_state = 4},
  [323] = {.lex_state = 4},
  [324] = {.lex_state = 4},
  [325] = {.lex_state = 4},
  [326] = {.lex_state = 4},
  [327] = {.lex_state = 4},
  [328] = {.lex_state = 4},
  [329] = {.lex_state = 4},
  [330] = {.lex_state = 4},
  [331] = {.lex_state = 4},
  [332] = {.lex_state = 4},
  [333] = {.lex_state = 4},
  [334] = {.lex_state = 4},
  [335] = {.lex_state = 4},
  [336] = {.lex_state = 4},
  [337] = {.lex_state = 4},
  [338] = {.lex_state = 4},
  [339] = {.lex_state = 4},
  [340] = {.lex_state = 4},
  [341] = {.lex_state = 4},
  [342] = {.lex_state = 4},
  [343] = {.lex_state = 4},
  [344] = {.lex_state = 4},
  [345] = {.lex_state = 4},
  [346] = {.lex_state = 4},
  [347] = {.lex_state = 4},
  [348] = {.lex_state = 4},
  [349] = {.lex_state = 4},
  [350] = {.lex_state = 4},
  [351] = {.lex_state = 4},
  [352] = {.lex_state = 4},
  [353] = {.lex_state = 4},
  [354] = {.lex_state = 4},
  [355] = {.lex_state = 4},
  [356] = {.lex_state = 4},
  [357] = {.lex_state = 4},
  [358] = {.lex_state = 4},
  [359] = {.lex_state = 4},
  [360] = {.lex_state = 4},
  [361] = {.lex_state = 4},
  [362] = {.lex_state = 4},
  [363] = {.lex_state = 4},
  [364] = {.lex_state = 4},
  [365] = {.lex_state = 4},
  [366] = {.lex_state = 4},
  [367] = {.lex_state = 4},
  [368] = {.lex_state = 4},
  [369] = {.lex_state = 4},
  [370] = {.lex_state = 4},
  [371] = {.lex_state = 4},
  [372] = {.lex_state = 4},
  [373] = {.lex_state = 4},
  [374] = {.lex_state = 4},
  [375] = {.lex_state = 4},
  [376] = {.lex_state = 4},
  [377] = {.lex_state = 4},
  [378] = {.lex_state = 4},
  [379] = {.lex_state = 4},
  [380] = {.lex_state = 4},
  [381] = {.lex_state = 4},
  [382] = {.lex_state = 4},
  [383] = {.lex_state = 4},
  [384] = {.lex_state = 4},
  [385] = {.lex_state = 4},
  [386] = {.lex_state = 4},
  [387] = {.lex_state = 4},
  [388] = {.lex_state = 4},
  [389] = {.lex_state = 79, .external_lex_state = 2},
  [390] = {.lex_state = 79, .external_lex_state = 2},
  [391] = {.lex_state = 79, .external_lex_state = 2},
  [392] = {.lex_state = 5},
  [393] = {.lex_state = 0},
  [394] = {.lex_state = 0},
  [395] = {.lex_state = 0},
  [396] = {.lex_state = 5},
  [397] = {.lex_state = 0},
  [398] = {.lex_state = 5},
  [399] = {.lex_state = 5},
  [400] = {.lex_state = 4},
  [401] = {.lex_state = 79, .external_lex_state = 2},
  [402] = {.lex_state = 79, .external_lex_state = 2},
  [403] = {.lex_state = 79, .external_lex_state = 2},
  [404] = {.lex_state = 5},
  [405] = {.lex_state = 0},
  [406] = {.lex_state = 5},
  [407] = {.lex_state = 0},
  [408] = {.lex_state = 5},
  [409] = {.lex_state = 0},
  [410] = {.lex_state = 79, .external_lex_state = 2},
  [411] = {.lex_state = 5},
  [412] = {.lex_state = 79, .external_lex_state = 2},
  [413] = {.lex_state = 5},
  [414] = {.lex_state = 5},
  [415] = {.lex_state = 5},
  [416] = {.lex_state = 79, .external_lex_state = 2},
  [417] = {.lex_state = 79, .external_lex_state = 2},
  [418] = {.lex_state = 79, .external_lex_state = 2},
  [419] = {.lex_state = 5},
  [420] = {.lex_state = 5},
  [421] = {.lex_state = 5},
  [422] = {.lex_state = 5},
  [423] = {.lex_state = 5},
  [424] = {.lex_state = 5},
  [425] = {.lex_state = 79, .external_lex_state = 2},
  [426] = {.lex_state = 5},
  [427] = {.lex_state = 5},
  [428] = {.lex_state = 5},
  [429] = {.lex_state = 5},
  [430] = {.lex_state = 5},
  [431] = {.lex_state = 5},
  [432] = {.lex_state = 5},
  [433] = {.lex_state = 5},
  [434] = {.lex_state = 5},
  [435] = {.lex_state = 79},
  [436] = {.lex_state = 5},
  [437] = {.lex_state = 5},
  [438] = {.lex_state = 5},
  [439] = {.lex_state = 79, .external_lex_state = 2},
  [440] = {.lex_state = 5},
  [441] = {.lex_state = 79, .external_lex_state = 2},
  [442] = {.lex_state = 5},
  [443] = {.lex_state = 4},
  [444] = {.lex_state = 4},
  [445] = {.lex_state = 79, .external_lex_state = 2},
  [446] = {.lex_state = 79, .external_lex_state = 2},
  [447] = {.lex_state = 79, .external_lex_state = 2},
  [448] = {.lex_state = 5},
  [449] = {.lex_state = 5},
  [450] = {.lex_state = 5},
  [451] = {.lex_state = 5},
  [452] = {.lex_state = 4},
  [453] = {.lex_state = 4},
  [454] = {.lex_state = 79, .external_lex_state = 2},
  [455] = {.lex_state = 79, .external_lex_state = 2},
  [456] = {.lex_state = 5},
  [457] = {.lex_state = 79, .external_lex_state = 2},
  [458] = {.lex_state = 5},
  [459] = {.lex_state = 5},
  [460] = {.lex_state = 5},
  [461] = {.lex_state = 5},
  [462] = {.lex_state = 5},
  [463] = {.lex_state = 5},
  [464] = {.lex_state = 5},
  [465] = {.lex_state = 79, .external_lex_state = 2},
  [466] = {.lex_state = 5},
  [467] = {.lex_state = 5},
  [468] = {.lex_state = 5},
  [469] = {.lex_state = 79},
  [470] = {.lex_state = 5},
  [471] = {.lex_state = 5},
  [472] = {.lex_state = 5},
  [473] = {.lex_state = 5},
  [474] = {.lex_state = 5},
  [475] = {.lex_state = 5},
  [476] = {.lex_state = 79},
  [477] = {.lex_state = 5},
  [478] = {.lex_state = 79},
  [479] = {.lex_state = 5},
  [480] = {.lex_state = 5},
  [481] = {.lex_state = 5},
  [482] = {.lex_state = 5},
  [483] = {.lex_state = 5},
  [484] = {.lex_state = 5},
  [485] = {.lex_state = 5},
  [486] = {.lex_state = 5},
  [487] = {.lex_state = 5},
  [488] = {.lex_state = 5},
  [489] = {.lex_state = 79},
  [490] = {.lex_state = 79},
  [491] = {.lex_state = 5},
  [492] = {.lex_state = 5},
  [493] = {.lex_state = 5},
  [494] = {.lex_state = 5},
  [495] = {.lex_state = 5},
  [496] = {.lex_state = 5},
  [497] = {.lex_state = 5},
  [498] = {.lex_state = 5},
  [499] = {.lex_state = 5},
  [500] = {.lex_state = 0},
  [501] = {.lex_state = 79, .external_lex_state = 2},
  [502] = {.lex_state = 79, .external_lex_state = 2},
  [503] = {.lex_state = 79, .external_lex_state = 2},
  [504] = {.lex_state = 5},
  [505] = {.lex_state = 5},
  [506] = {.lex_state = 5},
  [507] = {.lex_state = 5},
  [508] = {.lex_state = 5},
  [509] = {.lex_state = 5},
  [510] = {.lex_state = 5},
  [511] = {.lex_state = 5},
  [512] = {.lex_state = 5},
  [513] = {.lex_state = 5},
  [514] = {.lex_state = 5},
  [515] = {.lex_state = 79, .external_lex_state = 2},
  [516] = {.lex_state = 0},
  [517] = {.lex_state = 5},
  [518] = {.lex_state = 5},
  [519] = {.lex_state = 79, .external_lex_state = 2},
  [520] = {.lex_state = 5},
  [521] = {.lex_state = 79, .external_lex_state = 2},
  [522] = {.lex_state = 79, .external_lex_state = 2},
  [523] = {.lex_state = 79, .external_lex_state = 2},
  [524] = {.lex_state = 0},
  [525] = {.lex_state = 79, .external_lex_state = 2},
  [526] = {.lex_state = 0},
  [527] = {.lex_state = 5},
  [528] = {.lex_state = 5},
  [529] = {.lex_state = 5},
  [530] = {.lex_state = 4},
  [531] = {.lex_state = 5},
  [532] = {.lex_state = 79, .external_lex_state = 2},
  [533] = {.lex_state = 79, .external_lex_state = 2},
  [534] = {.lex_state = 5},
  [535] = {.lex_state = 79, .external_lex_state = 2},
  [536] = {.lex_state = 79, .external_lex_state = 2},
  [537] = {.lex_state = 0},
  [538] = {.lex_state = 0},
  [539] = {.lex_state = 0},
  [540] = {.lex_state = 0},
  [541] = {.lex_state = 5},
  [542] = {.lex_state = 79, .external_lex_state = 2},
  [543] = {.lex_state = 79, .external_lex_state = 2},
  [544] = {.lex_state = 79, .external_lex_state = 2},
  [545] = {.lex_state = 79, .external_lex_state = 2},
  [546] = {.lex_state = 79, .external_lex_state = 2},
  [547] = {.lex_state = 79, .external_lex_state = 2},
  [548] = {.lex_state = 79, .external_lex_state = 2},
  [549] = {.lex_state = 79, .external_lex_state = 2},
  [550] = {.lex_state = 79, .external_lex_state = 2},
  [551] = {.lex_state = 0},
  [552] = {.lex_state = 79, .external_lex_state = 2},
  [553] = {.lex_state = 79, .external_lex_state = 2},
  [554] = {.lex_state = 79, .external_lex_state = 2},
  [555] = {.lex_state = 79, .external_lex_state = 2},
  [556] = {.lex_state = 79, .external_lex_state = 2},
  [557] = {.lex_state = 79, .external_lex_state = 2},
  [558] = {.lex_state = 79, .external_lex_state = 2},
  [559] = {.lex_state = 79, .external_lex_state = 2},
  [560] = {.lex_state = 79, .external_lex_state = 2},
  [561] = {.lex_state = 79, .external_lex_state = 2},
  [562] = {.lex_state = 79, .external_lex_state = 2},
  [563] = {.lex_state = 79, .external_lex_state = 2},
  [564] = {.lex_state = 79, .external_lex_state = 2},
  [565] = {.lex_state = 79, .external_lex_state = 2},
  [566] = {.lex_state = 79, .external_lex_state = 2},
  [567] = {.lex_state = 79, .external_lex_state = 2},
  [568] = {.lex_state = 79, .external_lex_state = 2},
  [569] = {.lex_state = 79, .external_lex_state = 2},
  [570] = {.lex_state = 79, .external_lex_state = 2},
  [571] = {.lex_state = 79, .external_lex_state = 2},
  [572] = {.lex_state = 79, .external_lex_state = 2},
  [573] = {.lex_state = 79, .external_lex_state = 2},
  [574] = {.lex_state = 79, .external_lex_state = 2},
  [575] = {.lex_state = 79, .external_lex_state = 2},
  [576] = {.lex_state = 79, .external_lex_state = 2},
  [577] = {.lex_state = 79, .external_lex_state = 2},
  [578] = {.lex_state = 79, .external_lex_state = 2},
  [579] = {.lex_state = 79, .external_lex_state = 2},
  [580] = {.lex_state = 79, .external_lex_state = 2},
  [581] = {.lex_state = 79, .external_lex_state = 2},
  [582] = {.lex_state = 79, .external_lex_state = 2},
  [583] = {.lex_state = 79, .external_lex_state = 2},
  [584] = {.lex_state = 79, .external_lex_state = 2},
  [585] = {.lex_state = 79, .external_lex_state = 2},
  [586] = {.lex_state = 79, .external_lex_state = 2},
  [587] = {.lex_state = 79, .external_lex_state = 2},
  [588] = {.lex_state = 79, .external_lex_state = 2},
  [589] = {.lex_state = 79, .external_lex_state = 2},
  [590] = {.lex_state = 79, .external_lex_state = 2},
  [591] = {.lex_state = 79, .external_lex_state = 2},
  [592] = {.lex_state = 79, .external_lex_state = 2},
  [593] = {.lex_state = 79, .external_lex_state = 2},
  [594] = {.lex_state = 79, .external_lex_state = 2},
  [595] = {.lex_state = 79, .external_lex_state = 2},
  [596] = {.lex_state = 79, .external_lex_state = 2},
  [597] = {.lex_state = 79, .external_lex_state = 2},
  [598] = {.lex_state = 79, .external_lex_state = 2},
  [599] = {.lex_state = 79, .external_lex_state = 2},
  [600] = {.lex_state = 79, .external_lex_state = 2},
  [601] = {.lex_state = 79, .external_lex_state = 2},
  [602] = {.lex_state = 79, .external_lex_state = 2},
  [603] = {.lex_state = 79, .external_lex_state = 2},
  [604] = {.lex_state = 79, .external_lex_state = 2},
  [605] = {.lex_state = 79, .external_lex_state = 2},
  [606] = {.lex_state = 79, .external_lex_state = 2},
  [607] = {.lex_state = 79, .external_lex_state = 2},
  [608] = {.lex_state = 0},
  [609] = {.lex_state = 0},
  [610] = {.lex_state = 79, .external_lex_state = 2},
  [611] = {.lex_state = 79, .external_lex_state = 2},
  [612] = {.lex_state = 79, .external_lex_state = 2},
  [613] = {.lex_state = 79, .external_lex_state = 2},
  [614] = {.lex_state = 79, .external_lex_state = 2},
  [615] = {.lex_state = 79, .external_lex_state = 2},
  [616] = {.lex_state = 79, .external_lex_state = 2},
  [617] = {.lex_state = 79, .external_lex_state = 2},
  [618] = {.lex_state = 79, .external_lex_state = 2},
  [619] = {.lex_state = 79, .external_lex_state = 2},
  [620] = {.lex_state = 79, .external_lex_state = 2},
  [621] = {.lex_state = 79, .external_lex_state = 2},
  [622] = {.lex_state = 79, .external_lex_state = 2},
  [623] = {.lex_state = 79, .external_lex_state = 2},
  [624] = {.lex_state = 79, .external_lex_state = 2},
  [625] = {.lex_state = 79, .external_lex_state = 2},
  [626] = {.lex_state = 79, .external_lex_state = 2},
  [627] = {.lex_state = 0},
  [628] = {.lex_state = 79, .external_lex_state = 2},
  [629] = {.lex_state = 79, .external_lex_state = 2},
  [630] = {.lex_state = 79, .external_lex_state = 2},
  [631] = {.lex_state = 79, .external_lex_state = 2},
  [632] = {.lex_state = 79, .external_lex_state = 2},
  [633] = {.lex_state = 79, .external_lex_state = 2},
  [634] = {.lex_state = 79, .external_lex_state = 2},
  [635] = {.lex_state = 79, .external_lex_state = 2},
  [636] = {.lex_state = 79, .external_lex_state = 2},
  [637] = {.lex_state = 79, .external_lex_state = 2},
  [638] = {.lex_state = 79, .external_lex_state = 2},
  [639] = {.lex_state = 79, .external_lex_state = 2},
  [640] = {.lex_state = 0},
  [641] = {.lex_state = 79, .external_lex_state = 2},
  [642] = {.lex_state = 79, .external_lex_state = 2},
  [643] = {.lex_state = 79, .external_lex_state = 2},
  [644] = {.lex_state = 0},
  [645] = {.lex_state = 79, .external_lex_state = 2},
  [646] = {.lex_state = 79, .external_lex_state = 2},
  [647] = {.lex_state = 79, .external_lex_state = 2},
  [648] = {.lex_state = 0},
  [649] = {.lex_state = 79, .external_lex_state = 2},
  [650] = {.lex_state = 79, .external_lex_state = 2},
  [651] = {.lex_state = 79, .external_lex_state = 2},
  [652] = {.lex_state = 79, .external_lex_state = 2},
  [653] = {.lex_state = 79, .external_lex_state = 2},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 5},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 5},
  [658] = {.lex_state = 5},
  [659] = {.lex_state = 5},
  [660] = {.lex_state = 0},
  [661] = {.lex_state = 5},
  [662] = {.lex_state = 5},
  [663] = {.lex_state = 0},
  [664] = {.lex_state = 5},
  [665] = {.lex_state = 5},
  [666] = {.lex_state = 5},
  [667] = {.lex_state = 5},
  [668] = {.lex_state = 5},
  [669] = {.lex_state = 5},
  [670] = {.lex_state = 5},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 5},
  [673] = {.lex_state = 5},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 5},
  [676] = {.lex_state = 5},
  [677] = {.lex_state = 5},
  [678] = {.lex_state = 5},
  [679] = {.lex_state = 5},
  [680] = {.lex_state = 0},
  [681] = {.lex_state = 5},
  [682] = {.lex_state = 5},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 5},
  [685] = {.lex_state = 5},
  [686] = {.lex_state = 5},
  [687] = {.lex_state = 5},
  [688] = {.lex_state = 5},
  [689] = {.lex_state = 0},
  [690] = {.lex_state = 5},
  [691] = {.lex_state = 5},
  [692] = {.lex_state = 0},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 5},
  [695] = {.lex_state = 0},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 5},
  [698] = {.lex_state = 0},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 5},
  [701] = {.lex_state = 0},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 5},
  [704] = {.lex_state = 0},
  [705] = {.lex_state = 0},
  [706] = {.lex_state = 0},
  [707] = {.lex_state = 0},
  [708] = {.lex_state = 0},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 0},
  [711] = {.lex_state = 5},
  [712] = {.lex_state = 5},
  [713] = {.lex_state = 0},
  [714] = {.lex_state = 0},
  [715] = {.lex_state = 5},
  [716] = {.lex_state = 0},
  [717] = {.lex_state = 0},
  [718] = {.lex_state = 5},
  [719] = {.lex_state = 0},
  [720] = {.lex_state = 0},
  [721] = {.lex_state = 0},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 0},
  [724] = {.lex_state = 0},
  [725] = {.lex_state = 5},
  [726] = {.lex_state = 5},
  [727] = {.lex_state = 0},
  [728] = {.lex_state = 5},
  [729] = {.lex_state = 0},
  [730] = {.lex_state = 0},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 0},
  [733] = {.lex_state = 0},
  [734] = {.lex_state = 0},
  [735] = {.lex_state = 0},
  [736] = {.lex_state = 0},
  [737] = {.lex_state = 0},
  [738] = {.lex_state = 0},
  [739] = {.lex_state = 5},
  [740] = {.lex_state = 0},
  [741] = {.lex_state = 0},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 0},
  [744] = {.lex_state = 0},
  [745] = {.lex_state = 0},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 5},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 5},
  [750] = {.lex_state = 5},
  [751] = {.lex_state = 5},
  [752] = {.lex_state = 5},
  [753] = {.lex_state = 5},
  [754] = {.lex_state = 5},
  [755] = {.lex_state = 5},
  [756] = {.lex_state = 5},
  [757] = {.lex_state = 5},
  [758] = {.lex_state = 5},
  [759] = {.lex_state = 5},
  [760] = {.lex_state = 5},
  [761] = {.lex_state = 5},
  [762] = {.lex_state = 5},
  [763] = {.lex_state = 5},
  [764] = {.lex_state = 5},
  [765] = {.lex_state = 5},
  [766] = {.lex_state = 5},
  [767] = {.lex_state = 5},
  [768] = {.lex_state = 5},
  [769] = {.lex_state = 5},
  [770] = {.lex_state = 5},
  [771] = {.lex_state = 5},
  [772] = {.lex_state = 5},
  [773] = {.lex_state = 5},
  [774] = {.lex_state = 5},
  [775] = {.lex_state = 5},
  [776] = {.lex_state = 5},
  [777] = {.lex_state = 5},
  [778] = {.lex_state = 5},
  [779] = {.lex_state = 0},
  [780] = {.lex_state = 0},
  [781] = {.lex_state = 0},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 0},
  [785] = {.lex_state = 0},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 0},
  [788] = {.lex_state = 0},
  [789] = {.lex_state = 0},
  [790] = {.lex_state = 0},
  [791] = {.lex_state = 0},
  [792] = {.lex_state = 0},
  [793] = {.lex_state = 0},
  [794] = {.lex_state = 0},
  [795] = {.lex_state = 0},
  [796] = {.lex_state = 0},
  [797] = {.lex_state = 79},
  [798] = {.lex_state = 79},
  [799] = {.lex_state = 79},
  [800] = {.lex_state = 79},
  [801] = {.lex_state = 79},
  [802] = {.lex_state = 79},
  [803] = {.lex_state = 79},
  [804] = {.lex_state = 79},
  [805] = {.lex_state = 0},
  [806] = {.lex_state = 79},
  [807] = {.lex_state = 79},
  [808] = {.lex_state = 79},
  [809] = {.lex_state = 79},
  [810] = {.lex_state = 0},
  [811] = {.lex_state = 79},
  [812] = {.lex_state = 79},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 79},
  [815] = {.lex_state = 79},
  [816] = {.lex_state = 79},
  [817] = {.lex_state = 79},
  [818] = {.lex_state = 79},
  [819] = {.lex_state = 79},
  [820] = {.lex_state = 79},
  [821] = {.lex_state = 79},
  [822] = {.lex_state = 79},
  [823] = {.lex_state = 79},
  [824] = {.lex_state = 79},
  [825] = {.lex_state = 79},
  [826] = {.lex_state = 79},
  [827] = {.lex_state = 79},
  [828] = {.lex_state = 79},
  [829] = {.lex_state = 79},
  [830] = {.lex_state = 79},
  [831] = {.lex_state = 79},
  [832] = {.lex_state = 79},
  [833] = {.lex_state = 79},
  [834] = {.lex_state = 79},
  [835] = {.lex_state = 79},
  [836] = {.lex_state = 79},
  [837] = {.lex_state = 79},
  [838] = {.lex_state = 79},
  [839] = {.lex_state = 79},
  [840] = {.lex_state = 79},
  [841] = {.lex_state = 79},
  [842] = {.lex_state = 79},
  [843] = {.lex_state = 79},
  [844] = {.lex_state = 79},
  [845] = {.lex_state = 79},
  [846] = {.lex_state = 79},
  [847] = {.lex_state = 79},
  [848] = {.lex_state = 79},
  [849] = {.lex_state = 79},
  [850] = {.lex_state = 79},
  [851] = {.lex_state = 79},
  [852] = {.lex_state = 79},
  [853] = {.lex_state = 79},
  [854] = {.lex_state = 79},
  [855] = {.lex_state = 79},
  [856] = {.lex_state = 79},
  [857] = {.lex_state = 79},
  [858] = {.lex_state = 79},
  [859] = {.lex_state = 79},
  [860] = {.lex_state = 79},
  [861] = {.lex_state = 79},
  [862] = {.lex_state = 79},
  [863] = {.lex_state = 79},
  [864] = {.lex_state = 6},
  [865] = {.lex_state = 6},
  [866] = {.lex_state = 6},
  [867] = {.lex_state = 6},
  [868] = {.lex_state = 1},
  [869] = {.lex_state = 1},
  [870] = {.lex_state = 6},
  [871] = {.lex_state = 1},
  [872] = {.lex_state = 6},
  [873] = {.lex_state = 6},
  [874] = {.lex_state = 1},
  [875] = {.lex_state = 1},
  [876] = {.lex_state = 6},
  [877] = {.lex_state = 6},
  [878] = {.lex_state = 1},
  [879] = {.lex_state = 1},
  [880] = {.lex_state = 1},
  [881] = {.lex_state = 1},
  [882] = {.lex_state = 1},
  [883] = {.lex_state = 1},
  [884] = {.lex_state = 6},
  [885] = {.lex_state = 1},
  [886] = {.lex_state = 1},
  [887] = {.lex_state = 1},
  [888] = {.lex_state = 1},
  [889] = {.lex_state = 1},
  [890] = {.lex_state = 1},
  [891] = {.lex_state = 6},
  [892] = {.lex_state = 1},
  [893] = {.lex_state = 1},
  [894] = {.lex_state = 6},
  [895] = {.lex_state = 6},
  [896] = {.lex_state = 1},
  [897] = {.lex_state = 1},
  [898] = {.lex_state = 6},
  [899] = {.lex_state = 1},
  [900] = {.lex_state = 6},
  [901] = {.lex_state = 6},
  [902] = {.lex_state = 1},
  [903] = {.lex_state = 6},
  [904] = {.lex_state = 6},
  [905] = {.lex_state = 1},
  [906] = {.lex_state = 1},
  [907] = {.lex_state = 6},
  [908] = {.lex_state = 1},
  [909] = {.lex_state = 1},
  [910] = {.lex_state = 1},
  [911] = {.lex_state = 6},
  [912] = {.lex_state = 1},
  [913] = {.lex_state = 6},
  [914] = {.lex_state = 1},
  [915] = {.lex_state = 1},
  [916] = {.lex_state = 1},
  [917] = {.lex_state = 1},
  [918] = {.lex_state = 1},
  [919] = {.lex_state = 1},
  [920] = {.lex_state = 1},
  [921] = {.lex_state = 1},
  [922] = {.lex_state = 6},
  [923] = {.lex_state = 1},
  [924] = {.lex_state = 1},
  [925] = {.lex_state = 1},
  [926] = {.lex_state = 1},
  [927] = {.lex_state = 6},
  [928] = {.lex_state = 1},
  [929] = {.lex_state = 1},
  [930] = {.lex_state = 1},
  [931] = {.lex_state = 1},
  [932] = {.lex_state = 6},
  [933] = {.lex_state = 6},
  [934] = {.lex_state = 6},
  [935] = {.lex_state = 6},
  [936] = {.lex_state = 1},
  [937] = {.lex_state = 1},
  [938] = {.lex_state = 6},
  [939] = {.lex_state = 1},
  [940] = {.lex_state = 79},
  [941] = {.lex_state = 1},
  [942] = {.lex_state = 1},
  [943] = {.lex_state = 6},
  [944] = {.lex_state = 1},
  [945] = {.lex_state = 79},
  [946] = {.lex_state = 6},
  [947] = {.lex_state = 6},
  [948] = {.lex_state = 1},
  [949] = {.lex_state = 1},
  [950] = {.lex_state = 6},
  [951] = {.lex_state = 6},
  [952] = {.lex_state = 6},
  [953] = {.lex_state = 6},
  [954] = {.lex_state = 6},
  [955] = {.lex_state = 6},
  [956] = {.lex_state = 6},
  [957] = {.lex_state = 6},
  [958] = {.lex_state = 6},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 0},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 0},
  [963] = {.lex_state = 0},
  [964] = {.lex_state = 0},
  [965] = {.lex_state = 0},
  [966] = {.lex_state = 0},
  [967] = {.lex_state = 0},
  [968] = {.lex_state = 0},
  [969] = {.lex_state = 0},
  [970] = {.lex_state = 0},
  [971] = {.lex_state = 0},
  [972] = {.lex_state = 0},
  [973] = {.lex_state = 0},
  [974] = {.lex_state = 0},
  [975] = {.lex_state = 6},
  [976] = {.lex_state = 0},
  [977] = {.lex_state = 0},
  [978] = {.lex_state = 0},
  [979] = {.lex_state = 0},
  [980] = {.lex_state = 0},
  [981] = {.lex_state = 0},
  [982] = {.lex_state = 0},
  [983] = {.lex_state = 0},
  [984] = {.lex_state = 0},
  [985] = {.lex_state = 0},
  [986] = {.lex_state = 0},
  [987] = {.lex_state = 0},
  [988] = {.lex_state = 0},
  [989] = {.lex_state = 0},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 0},
  [992] = {.lex_state = 0},
  [993] = {.lex_state = 0},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 0},
  [996] = {.lex_state = 0},
  [997] = {.lex_state = 6},
  [998] = {.lex_state = 0},
  [999] = {.lex_state = 0},
  [1000] = {.lex_state = 0},
  [1001] = {.lex_state = 0},
  [1002] = {.lex_state = 0},
  [1003] = {.lex_state = 0},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 6},
  [1006] = {.lex_state = 0},
  [1007] = {.lex_state = 0},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 6},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 0},
  [1012] = {.lex_state = 0},
  [1013] = {.lex_state = 0},
  [1014] = {.lex_state = 0},
  [1015] = {.lex_state = 6},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 0},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 0},
  [1020] = {.lex_state = 0},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 0},
  [1023] = {.lex_state = 0},
  [1024] = {.lex_state = 0},
  [1025] = {.lex_state = 0},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 0},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 6},
  [1030] = {.lex_state = 6},
  [1031] = {.lex_state = 0},
  [1032] = {.lex_state = 0},
  [1033] = {.lex_state = 0},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 0},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 79},
  [1039] = {.lex_state = 79},
  [1040] = {.lex_state = 79},
  [1041] = {.lex_state = 79},
  [1042] = {.lex_state = 79, .external_lex_state = 2},
  [1043] = {.lex_state = 79, .external_lex_state = 2},
  [1044] = {.lex_state = 79, .external_lex_state = 2},
  [1045] = {.lex_state = 79, .external_lex_state = 2},
  [1046] = {.lex_state = 79, .external_lex_state = 2},
  [1047] = {.lex_state = 79},
  [1048] = {.lex_state = 79, .external_lex_state = 2},
  [1049] = {.lex_state = 79},
  [1050] = {.lex_state = 79},
  [1051] = {.lex_state = 79, .external_lex_state = 2},
  [1052] = {.lex_state = 79, .external_lex_state = 2},
  [1053] = {.lex_state = 79},
  [1054] = {.lex_state = 79, .external_lex_state = 2},
  [1055] = {.lex_state = 79},
  [1056] = {.lex_state = 79, .external_lex_state = 2},
  [1057] = {.lex_state = 79, .external_lex_state = 2},
  [1058] = {.lex_state = 79, .external_lex_state = 2},
  [1059] = {.lex_state = 79},
  [1060] = {.lex_state = 79, .external_lex_state = 2},
  [1061] = {.lex_state = 79, .external_lex_state = 2},
  [1062] = {.lex_state = 79},
  [1063] = {.lex_state = 79, .external_lex_state = 2},
  [1064] = {.lex_state = 79, .external_lex_state = 2},
  [1065] = {.lex_state = 79},
  [1066] = {.lex_state = 79},
  [1067] = {.lex_state = 79, .external_lex_state = 2},
  [1068] = {.lex_state = 79},
  [1069] = {.lex_state = 79, .external_lex_state = 2},
  [1070] = {.lex_state = 79, .external_lex_state = 2},
  [1071] = {.lex_state = 79, .external_lex_state = 2},
  [1072] = {.lex_state = 79},
  [1073] = {.lex_state = 79},
  [1074] = {.lex_state = 79},
  [1075] = {.lex_state = 79, .external_lex_state = 2},
  [1076] = {.lex_state = 79},
  [1077] = {.lex_state = 79},
  [1078] = {.lex_state = 4},
  [1079] = {.lex_state = 4},
  [1080] = {.lex_state = 4},
  [1081] = {.lex_state = 79},
  [1082] = {.lex_state = 79},
  [1083] = {.lex_state = 79},
  [1084] = {.lex_state = 0},
  [1085] = {.lex_state = 4},
  [1086] = {.lex_state = 4},
  [1087] = {.lex_state = 79},
  [1088] = {.lex_state = 79},
  [1089] = {.lex_state = 4},
  [1090] = {.lex_state = 79},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 79},
  [1093] = {.lex_state = 79},
  [1094] = {.lex_state = 79},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 6},
  [1099] = {.lex_state = 6},
  [1100] = {.lex_state = 6},
  [1101] = {.lex_state = 6},
  [1102] = {.lex_state = 6},
  [1103] = {.lex_state = 6},
  [1104] = {.lex_state = 6},
  [1105] = {.lex_state = 6},
  [1106] = {.lex_state = 6},
  [1107] = {.lex_state = 79},
  [1108] = {.lex_state = 6},
  [1109] = {.lex_state = 6},
  [1110] = {.lex_state = 6},
  [1111] = {.lex_state = 6},
  [1112] = {.lex_state = 6},
  [1113] = {.lex_state = 6},
  [1114] = {.lex_state = 6},
  [1115] = {.lex_state = 6},
  [1116] = {.lex_state = 6},
  [1117] = {.lex_state = 6},
  [1118] = {.lex_state = 6},
  [1119] = {.lex_state = 6},
  [1120] = {.lex_state = 6},
  [1121] = {.lex_state = 6},
  [1122] = {.lex_state = 79},
  [1123] = {.lex_state = 6},
  [1124] = {.lex_state = 6},
  [1125] = {.lex_state = 6},
  [1126] = {.lex_state = 6},
  [1127] = {.lex_state = 6},
  [1128] = {.lex_state = 4},
  [1129] = {.lex_state = 6},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 6},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 0},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 0},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 0},
  [1144] = {.lex_state = 6},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 0},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 6},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 79},
  [1154] = {.lex_state = 79},
  [1155] = {.lex_state = 79},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0},
  [1159] = {.lex_state = 0},
  [1160] = {.lex_state = 0},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 0},
  [1163] = {.lex_state = 6},
  [1164] = {.lex_state = 79},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 0},
  [1169] = {.lex_state = 0},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 0},
  [1172] = {.lex_state = 0},
  [1173] = {.lex_state = 79},
  [1174] = {.lex_state = 0},
  [1175] = {.lex_state = 79},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 79},
  [1179] = {.lex_state = 2},
  [1180] = {.lex_state = 79},
  [1181] = {.lex_state = 6},
  [1182] = {.lex_state = 0},
  [1183] = {.lex_state = 0},
  [1184] = {.lex_state = 44},
  [1185] = {.lex_state = 0},
  [1186] = {.lex_state = 44},
  [1187] = {.lex_state = 44},
  [1188] = {.lex_state = 79},
  [1189] = {.lex_state = 44},
  [1190] = {.lex_state = 6},
  [1191] = {.lex_state = 0},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 0},
  [1194] = {.lex_state = 44},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 0},
  [1197] = {.lex_state = 2},
  [1198] = {.lex_state = 2},
  [1199] = {.lex_state = 79},
  [1200] = {.lex_state = 2},
  [1201] = {.lex_state = 3},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 79},
  [1204] = {.lex_state = 0},
  [1205] = {.lex_state = 6},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 0},
  [1208] = {.lex_state = 6},
  [1209] = {.lex_state = 0},
  [1210] = {.lex_state = 44},
  [1211] = {.lex_state = 2},
  [1212] = {.lex_state = 44},
  [1213] = {.lex_state = 0},
  [1214] = {.lex_state = 0},
  [1215] = {.lex_state = 3},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 6},
  [1218] = {.lex_state = 79},
  [1219] = {.lex_state = 79},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 6},
  [1222] = {.lex_state = 3},
  [1223] = {.lex_state = 44},
  [1224] = {.lex_state = 79},
  [1225] = {.lex_state = 6},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 6},
  [1228] = {.lex_state = 6},
  [1229] = {.lex_state = 44},
  [1230] = {.lex_state = 44},
  [1231] = {.lex_state = 44},
  [1232] = {.lex_state = 0},
  [1233] = {.lex_state = 79},
  [1234] = {.lex_state = 6},
  [1235] = {.lex_state = 2},
  [1236] = {.lex_state = 44},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 2},
  [1239] = {.lex_state = 0},
  [1240] = {.lex_state = 6},
  [1241] = {.lex_state = 44},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 44},
  [1244] = {.lex_state = 44},
  [1245] = {.lex_state = 44},
  [1246] = {.lex_state = 2},
  [1247] = {.lex_state = 2},
  [1248] = {.lex_state = 79},
  [1249] = {.lex_state = 0},
  [1250] = {.lex_state = 0},
  [1251] = {.lex_state = 0},
  [1252] = {.lex_state = 2},
  [1253] = {.lex_state = 79, .external_lex_state = 3},
  [1254] = {.lex_state = 3},
  [1255] = {.lex_state = 3},
  [1256] = {.lex_state = 0},
  [1257] = {.lex_state = 0},
  [1258] = {.lex_state = 0},
  [1259] = {.lex_state = 0},
  [1260] = {.lex_state = 0},
  [1261] = {.lex_state = 0},
  [1262] = {.lex_state = 2},
  [1263] = {.lex_state = 6},
  [1264] = {.lex_state = 0},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 0},
  [1267] = {.lex_state = 0},
  [1268] = {.lex_state = 2},
  [1269] = {.lex_state = 0},
  [1270] = {.lex_state = 0},
  [1271] = {.lex_state = 0},
  [1272] = {.lex_state = 0},
  [1273] = {.lex_state = 0},
  [1274] = {.lex_state = 2},
  [1275] = {.lex_state = 0},
  [1276] = {.lex_state = 3},
  [1277] = {.lex_state = 0},
  [1278] = {.lex_state = 44},
  [1279] = {.lex_state = 0},
  [1280] = {.lex_state = 0},
  [1281] = {.lex_state = 0},
  [1282] = {.lex_state = 0},
  [1283] = {.lex_state = 0},
  [1284] = {.lex_state = 0},
  [1285] = {.lex_state = 0},
  [1286] = {.lex_state = 0},
  [1287] = {.lex_state = 3},
  [1288] = {.lex_state = 0},
  [1289] = {.lex_state = 79},
  [1290] = {.lex_state = 0},
  [1291] = {.lex_state = 0},
  [1292] = {.lex_state = 0},
  [1293] = {.lex_state = 0},
  [1294] = {.lex_state = 0},
  [1295] = {.lex_state = 0},
  [1296] = {.lex_state = 0},
  [1297] = {.lex_state = 0},
  [1298] = {.lex_state = 0},
  [1299] = {.lex_state = 44},
  [1300] = {.lex_state = 0},
  [1301] = {.lex_state = 79, .external_lex_state = 3},
  [1302] = {.lex_state = 0},
  [1303] = {.lex_state = 0},
  [1304] = {.lex_state = 0},
  [1305] = {.lex_state = 0},
  [1306] = {.lex_state = 0},
  [1307] = {.lex_state = 0},
  [1308] = {.lex_state = 79, .external_lex_state = 3},
  [1309] = {.lex_state = 2},
  [1310] = {.lex_state = 2},
  [1311] = {.lex_state = 2},
  [1312] = {.lex_state = 3},
  [1313] = {.lex_state = 3},
  [1314] = {.lex_state = 0},
  [1315] = {.lex_state = 0},
  [1316] = {.lex_state = 0},
  [1317] = {.lex_state = 0},
  [1318] = {.lex_state = 1},
  [1319] = {.lex_state = 79, .external_lex_state = 3},
  [1320] = {.lex_state = 0},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 0},
  [1323] = {.lex_state = 44},
  [1324] = {.lex_state = 44},
  [1325] = {.lex_state = 0},
  [1326] = {.lex_state = 0},
  [1327] = {.lex_state = 0},
  [1328] = {.lex_state = 0},
  [1329] = {.lex_state = 0},
  [1330] = {.lex_state = 0},
  [1331] = {.lex_state = 0},
  [1332] = {.lex_state = 0},
  [1333] = {.lex_state = 0},
  [1334] = {.lex_state = 0},
  [1335] = {.lex_state = 0},
  [1336] = {.lex_state = 0},
  [1337] = {.lex_state = 79},
  [1338] = {.lex_state = 2},
  [1339] = {.lex_state = 2},
  [1340] = {.lex_state = 0},
  [1341] = {.lex_state = 79},
  [1342] = {.lex_state = 2},
  [1343] = {.lex_state = 0},
  [1344] = {.lex_state = 0},
  [1345] = {.lex_state = 0},
  [1346] = {.lex_state = 2},
  [1347] = {.lex_state = 0},
  [1348] = {.lex_state = 0},
  [1349] = {.lex_state = 0},
  [1350] = {.lex_state = 0},
  [1351] = {.lex_state = 0},
  [1352] = {.lex_state = 0},
  [1353] = {.lex_state = 0},
  [1354] = {.lex_state = 44},
  [1355] = {.lex_state = 79},
  [1356] = {.lex_state = 6},
  [1357] = {.lex_state = 44},
  [1358] = {.lex_state = 0},
  [1359] = {.lex_state = 79},
  [1360] = {.lex_state = 0},
  [1361] = {.lex_state = 2},
  [1362] = {.lex_state = 0},
  [1363] = {.lex_state = 0},
  [1364] = {.lex_state = 0},
  [1365] = {.lex_state = 79, .external_lex_state = 3},
  [1366] = {.lex_state = 6},
  [1367] = {.lex_state = 79},
  [1368] = {.lex_state = 0},
  [1369] = {.lex_state = 79},
  [1370] = {.lex_state = 0},
  [1371] = {.lex_state = 0},
  [1372] = {.lex_state = 0},
  [1373] = {.lex_state = 6},
  [1374] = {.lex_state = 0},
  [1375] = {.lex_state = 0},
  [1376] = {.lex_state = 0},
  [1377] = {.lex_state = 0},
  [1378] = {.lex_state = 0},
  [1379] = {.lex_state = 2},
  [1380] = {.lex_state = 0},
  [1381] = {.lex_state = 44},
  [1382] = {.lex_state = 0},
  [1383] = {.lex_state = 0},
  [1384] = {.lex_state = 44},
  [1385] = {.lex_state = 6},
  [1386] = {.lex_state = 0},
  [1387] = {.lex_state = 0},
  [1388] = {.lex_state = 0},
  [1389] = {.lex_state = 79},
  [1390] = {.lex_state = 6},
  [1391] = {.lex_state = 0},
  [1392] = {.lex_state = 0},
  [1393] = {.lex_state = 2},
  [1394] = {.lex_state = 0},
  [1395] = {.lex_state = 0},
  [1396] = {.lex_state = 0},
  [1397] = {.lex_state = 0},
  [1398] = {.lex_state = 0},
  [1399] = {.lex_state = 0},
  [1400] = {.lex_state = 0},
  [1401] = {.lex_state = 0},
  [1402] = {.lex_state = 0},
  [1403] = {.lex_state = 0},
  [1404] = {.lex_state = 0},
  [1405] = {.lex_state = 0},
  [1406] = {.lex_state = 0},
  [1407] = {.lex_state = 0},
  [1408] = {.lex_state = 0},
  [1409] = {.lex_state = 0},
  [1410] = {.lex_state = 0},
  [1411] = {.lex_state = 79},
  [1412] = {.lex_state = 0},
  [1413] = {.lex_state = 0},
  [1414] = {.lex_state = 0},
  [1415] = {.lex_state = 0},
  [1416] = {.lex_state = 0},
  [1417] = {.lex_state = 0},
  [1418] = {.lex_state = 79},
  [1419] = {.lex_state = 0},
  [1420] = {.lex_state = 3},
  [1421] = {.lex_state = 0},
  [1422] = {.lex_state = 6},
  [1423] = {.lex_state = 0},
  [1424] = {.lex_state = 3},
  [1425] = {.lex_state = 0},
  [1426] = {.lex_state = 0},
  [1427] = {.lex_state = 0},
  [1428] = {.lex_state = 0},
  [1429] = {.lex_state = 0},
  [1430] = {.lex_state = 6},
  [1431] = {.lex_state = 0},
  [1432] = {.lex_state = 0},
  [1433] = {.lex_state = 6},
  [1434] = {.lex_state = 0},
  [1435] = {.lex_state = 0},
  [1436] = {.lex_state = 6},
  [1437] = {.lex_state = 0},
  [1438] = {.lex_state = 0},
  [1439] = {.lex_state = 0},
  [1440] = {.lex_state = 0},
  [1441] = {.lex_state = 0},
  [1442] = {.lex_state = 0},
  [1443] = {.lex_state = 0},
  [1444] = {.lex_state = 0},
  [1445] = {.lex_state = 0},
  [1446] = {.lex_state = 0},
  [1447] = {.lex_state = 0},
  [1448] = {.lex_state = 44},
  [1449] = {.lex_state = 0},
  [1450] = {.lex_state = 2},
  [1451] = {.lex_state = 44},
  [1452] = {.lex_state = 2},
  [1453] = {.lex_state = 0},
  [1454] = {.lex_state = 6},
  [1455] = {.lex_state = 0},
  [1456] = {.lex_state = 0},
  [1457] = {.lex_state = 79},
  [1458] = {.lex_state = 79},
  [1459] = {.lex_state = 6},
  [1460] = {.lex_state = 79},
  [1461] = {.lex_state = 79},
  [1462] = {.lex_state = 0},
  [1463] = {.lex_state = 79},
  [1464] = {.lex_state = 0},
  [1465] = {.lex_state = 0},
  [1466] = {.lex_state = 79},
  [1467] = {.lex_state = 0},
  [1468] = {.lex_state = 0},
  [1469] = {.lex_state = 0},
  [1470] = {.lex_state = 0},
  [1471] = {.lex_state = 2},
  [1472] = {.lex_state = 0},
  [1473] = {.lex_state = 0},
  [1474] = {.lex_state = 79},
  [1475] = {.lex_state = 0},
  [1476] = {.lex_state = 3},
  [1477] = {.lex_state = 0},
  [1478] = {.lex_state = 0},
  [1479] = {.lex_state = 0},
  [1480] = {.lex_state = 0},
  [1481] = {.lex_state = 0},
  [1482] = {.lex_state = 0},
  [1483] = {.lex_state = 0},
  [1484] = {.lex_state = 0},
  [1485] = {.lex_state = 0},
  [1486] = {.lex_state = 0},
  [1487] = {.lex_state = 0},
  [1488] = {.lex_state = 0},
  [1489] = {.lex_state = 0},
  [1490] = {.lex_state = 0},
  [1491] = {.lex_state = 44},
  [1492] = {.lex_state = 0},
  [1493] = {.lex_state = 0},
  [1494] = {.lex_state = 0},
  [1495] = {.lex_state = 0},
  [1496] = {.lex_state = 0},
  [1497] = {.lex_state = 0},
  [1498] = {.lex_state = 0},
  [1499] = {.lex_state = 0},
  [1500] = {.lex_state = 0},
  [1501] = {.lex_state = 0},
  [1502] = {.lex_state = 0},
  [1503] = {.lex_state = 2},
  [1504] = {.lex_state = 0},
  [1505] = {.lex_state = 0},
  [1506] = {.lex_state = 0},
  [1507] = {.lex_state = 44},
  [1508] = {.lex_state = 0},
  [1509] = {.lex_state = 0},
  [1510] = {.lex_state = 0},
  [1511] = {.lex_state = 0},
  [1512] = {.lex_state = 0},
  [1513] = {.lex_state = 0},
  [1514] = {.lex_state = 0},
  [1515] = {.lex_state = 0},
  [1516] = {.lex_state = 0},
  [1517] = {.lex_state = 0},
  [1518] = {.lex_state = 0},
  [1519] = {.lex_state = 0},
  [1520] = {.lex_state = 0},
  [1521] = {.lex_state = 0},
  [1522] = {.lex_state = 0},
  [1523] = {.lex_state = 0},
  [1524] = {.lex_state = 0},
  [1525] = {.lex_state = 0},
  [1526] = {.lex_state = 0},
  [1527] = {.lex_state = 0},
  [1528] = {.lex_state = 0},
  [1529] = {.lex_state = 0},
  [1530] = {.lex_state = 0},
  [1531] = {.lex_state = 0},
  [1532] = {.lex_state = 0},
  [1533] = {.lex_state = 0},
  [1534] = {.lex_state = 0},
  [1535] = {.lex_state = 0},
  [1536] = {.lex_state = 79, .external_lex_state = 3},
  [1537] = {.lex_state = 0},
  [1538] = {.lex_state = 0},
  [1539] = {.lex_state = 0},
  [1540] = {.lex_state = 0},
  [1541] = {.lex_state = 0},
  [1542] = {.lex_state = 0},
  [1543] = {.lex_state = 0},
  [1544] = {.lex_state = 0},
  [1545] = {.lex_state = 0},
  [1546] = {.lex_state = 79},
  [1547] = {.lex_state = 0},
  [1548] = {.lex_state = 0},
  [1549] = {.lex_state = 0},
  [1550] = {.lex_state = 0},
  [1551] = {.lex_state = 0},
  [1552] = {.lex_state = 2},
  [1553] = {.lex_state = 0},
  [1554] = {.lex_state = 3},
  [1555] = {.lex_state = 0},
  [1556] = {.lex_state = 79},
  [1557] = {.lex_state = 0},
  [1558] = {.lex_state = 79},
  [1559] = {.lex_state = 79},
  [1560] = {.lex_state = 0},
  [1561] = {.lex_state = 0},
  [1562] = {.lex_state = 0},
  [1563] = {.lex_state = 2},
  [1564] = {.lex_state = 79},
  [1565] = {.lex_state = 44},
  [1566] = {.lex_state = 0},
  [1567] = {.lex_state = 0},
  [1568] = {.lex_state = 0},
  [1569] = {.lex_state = 0},
  [1570] = {.lex_state = 0},
  [1571] = {.lex_state = 0},
  [1572] = {.lex_state = 0},
  [1573] = {.lex_state = 6},
  [1574] = {.lex_state = 0},
  [1575] = {.lex_state = 0},
  [1576] = {.lex_state = 0},
  [1577] = {.lex_state = 0},
  [1578] = {.lex_state = 0},
  [1579] = {.lex_state = 0},
  [1580] = {.lex_state = 0},
  [1581] = {.lex_state = 0},
  [1582] = {.lex_state = 0},
  [1583] = {.lex_state = 0},
  [1584] = {.lex_state = 0},
  [1585] = {.lex_state = 0},
  [1586] = {.lex_state = 0},
  [1587] = {.lex_state = 0},
  [1588] = {.lex_state = 0},
  [1589] = {.lex_state = 0},
  [1590] = {.lex_state = 79},
  [1591] = {.lex_state = 79},
  [1592] = {.lex_state = 0},
  [1593] = {.lex_state = 0},
  [1594] = {.lex_state = 0},
  [1595] = {.lex_state = 0},
  [1596] = {.lex_state = 0},
  [1597] = {.lex_state = 0},
  [1598] = {.lex_state = 0},
  [1599] = {.lex_state = 0},
  [1600] = {.lex_state = 0},
  [1601] = {.lex_state = 0},
  [1602] = {.lex_state = 0},
  [1603] = {.lex_state = 0},
  [1604] = {.lex_state = 79},
  [1605] = {.lex_state = 0},
  [1606] = {.lex_state = 0},
  [1607] = {.lex_state = 0},
  [1608] = {.lex_state = 0},
  [1609] = {.lex_state = 0},
  [1610] = {.lex_state = 0},
  [1611] = {.lex_state = 0},
  [1612] = {.lex_state = 79},
  [1613] = {.lex_state = 0},
  [1614] = {.lex_state = 0},
  [1615] = {.lex_state = 0},
  [1616] = {.lex_state = 0},
  [1617] = {.lex_state = 0},
  [1618] = {.lex_state = 0},
  [1619] = {.lex_state = 0},
  [1620] = {.lex_state = 0},
  [1621] = {.lex_state = 0},
  [1622] = {.lex_state = 0},
  [1623] = {.lex_state = 0},
  [1624] = {.lex_state = 0},
  [1625] = {.lex_state = 0},
  [1626] = {.lex_state = 0},
  [1627] = {.lex_state = 0},
  [1628] = {.lex_state = 0},
  [1629] = {.lex_state = 0},
  [1630] = {.lex_state = 0},
  [1631] = {.lex_state = 0},
  [1632] = {.lex_state = 0},
  [1633] = {.lex_state = 0},
  [1634] = {.lex_state = 0},
  [1635] = {.lex_state = 0},
  [1636] = {.lex_state = 0},
  [1637] = {.lex_state = 0},
  [1638] = {.lex_state = 0},
  [1639] = {.lex_state = 0},
  [1640] = {.lex_state = 0},
  [1641] = {.lex_state = 0},
  [1642] = {.lex_state = 0},
  [1643] = {.lex_state = 0},
  [1644] = {.lex_state = 0},
  [1645] = {.lex_state = 0},
  [1646] = {.lex_state = 0},
  [1647] = {.lex_state = 0},
  [1648] = {.lex_state = 0},
  [1649] = {.lex_state = 0},
  [1650] = {.lex_state = 0},
  [1651] = {.lex_state = 0},
  [1652] = {.lex_state = 0},
  [1653] = {.lex_state = 0},
  [1654] = {.lex_state = 0},
  [1655] = {.lex_state = 0},
  [1656] = {.lex_state = 79, .external_lex_state = 2},
  [1657] = {.lex_state = 0},
  [1658] = {.lex_state = 0},
  [1659] = {.lex_state = 0},
  [1660] = {.lex_state = 0},
  [1661] = {.lex_state = 0},
  [1662] = {.lex_state = 6},
  [1663] = {.lex_state = 0},
  [1664] = {.lex_state = 6},
  [1665] = {.lex_state = 0},
  [1666] = {.lex_state = 0},
  [1667] = {.lex_state = 79},
  [1668] = {.lex_state = 0},
  [1669] = {.lex_state = 0},
  [1670] = {.lex_state = 0},
  [1671] = {.lex_state = 0},
  [1672] = {.lex_state = 0},
  [1673] = {.lex_state = 0},
  [1674] = {.lex_state = 0},
  [1675] = {.lex_state = 0},
  [1676] = {.lex_state = 0},
  [1677] = {.lex_state = 0},
  [1678] = {.lex_state = 0},
  [1679] = {.lex_state = 0},
  [1680] = {.lex_state = 0},
  [1681] = {.lex_state = 0},
  [1682] = {.lex_state = 0},
  [1683] = {.lex_state = 0},
  [1684] = {.lex_state = 0},
  [1685] = {.lex_state = 0},
  [1686] = {.lex_state = 0},
  [1687] = {.lex_state = 6},
  [1688] = {.lex_state = 0},
  [1689] = {.lex_state = 0},
  [1690] = {.lex_state = 0},
  [1691] = {.lex_state = 0},
  [1692] = {.lex_state = 0},
  [1693] = {.lex_state = 0},
  [1694] = {.lex_state = 0},
  [1695] = {.lex_state = 0},
  [1696] = {.lex_state = 0},
  [1697] = {.lex_state = 6},
  [1698] = {.lex_state = 0},
  [1699] = {.lex_state = 0},
  [1700] = {.lex_state = 6},
  [1701] = {.lex_state = 0},
  [1702] = {.lex_state = 0},
  [1703] = {.lex_state = 0},
  [1704] = {.lex_state = 0},
  [1705] = {.lex_state = 0},
  [1706] = {.lex_state = 79},
  [1707] = {.lex_state = 79, .external_lex_state = 2},
  [1708] = {.lex_state = 0},
  [1709] = {.lex_state = 0},
  [1710] = {.lex_state = 0},
  [1711] = {.lex_state = 0},
  [1712] = {.lex_state = 0},
  [1713] = {.lex_state = 79},
  [1714] = {.lex_state = 0},
  [1715] = {.lex_state = 0},
  [1716] = {.lex_state = 0},
  [1717] = {.lex_state = 0},
  [1718] = {.lex_state = 0},
  [1719] = {.lex_state = 0},
  [1720] = {.lex_state = 0},
  [1721] = {.lex_state = 0},
  [1722] = {.lex_state = 79},
  [1723] = {.lex_state = 0},
  [1724] = {.lex_state = 0},
  [1725] = {.lex_state = 0},
  [1726] = {.lex_state = 0},
  [1727] = {.lex_state = 0},
  [1728] = {.lex_state = 0},
  [1729] = {.lex_state = 0},
  [1730] = {.lex_state = 79},
  [1731] = {.lex_state = 0},
  [1732] = {.lex_state = 0},
  [1733] = {.lex_state = 0},
  [1734] = {.lex_state = 0},
  [1735] = {.lex_state = 0},
  [1736] = {.lex_state = 0},
  [1737] = {.lex_state = 0},
  [1738] = {.lex_state = 0},
  [1739] = {.lex_state = 0},
  [1740] = {.lex_state = 0},
  [1741] = {.lex_state = 0},
  [1742] = {.lex_state = 0},
  [1743] = {.lex_state = 0},
  [1744] = {.lex_state = 0},
  [1745] = {.lex_state = 0},
  [1746] = {.lex_state = 0},
  [1747] = {.lex_state = 0},
  [1748] = {.lex_state = 0},
  [1749] = {.lex_state = 0},
  [1750] = {.lex_state = 0},
  [1751] = {.lex_state = 0},
  [1752] = {.lex_state = 0},
  [1753] = {.lex_state = 0},
  [1754] = {.lex_state = 0},
  [1755] = {.lex_state = 0},
  [1756] = {.lex_state = 0},
  [1757] = {.lex_state = 0},
  [1758] = {.lex_state = 0},
  [1759] = {.lex_state = 0},
  [1760] = {.lex_state = 0},
  [1761] = {.lex_state = 0},
  [1762] = {.lex_state = 0},
  [1763] = {.lex_state = 0},
  [1764] = {.lex_state = 0},
  [1765] = {.lex_state = 0},
  [1766] = {.lex_state = 0},
  [1767] = {.lex_state = 0},
  [1768] = {.lex_state = 6},
  [1769] = {.lex_state = 6},
  [1770] = {.lex_state = 0},
  [1771] = {.lex_state = 0},
  [1772] = {.lex_state = 0},
  [1773] = {.lex_state = 0},
  [1774] = {.lex_state = 0},
  [1775] = {.lex_state = 0},
  [1776] = {.lex_state = 0},
  [1777] = {.lex_state = 0},
  [1778] = {.lex_state = 0},
  [1779] = {.lex_state = 0},
  [1780] = {.lex_state = 0},
  [1781] = {.lex_state = 0},
  [1782] = {.lex_state = 0},
  [1783] = {.lex_state = 0},
  [1784] = {.lex_state = 0},
  [1785] = {.lex_state = 0},
  [1786] = {.lex_state = 79},
  [1787] = {.lex_state = 0},
  [1788] = {.lex_state = 0},
  [1789] = {.lex_state = 0},
  [1790] = {.lex_state = 0},
  [1791] = {.lex_state = 0},
  [1792] = {.lex_state = 6},
  [1793] = {.lex_state = 0},
  [1794] = {.lex_state = 0},
  [1795] = {.lex_state = 0},
  [1796] = {.lex_state = 0},
  [1797] = {.lex_state = 0},
  [1798] = {.lex_state = 0},
  [1799] = {.lex_state = 0},
  [1800] = {.lex_state = 0},
  [1801] = {.lex_state = 0},
  [1802] = {.lex_state = 0},
  [1803] = {.lex_state = 0},
  [1804] = {.lex_state = 0},
  [1805] = {.lex_state = 0},
  [1806] = {.lex_state = 0},
  [1807] = {.lex_state = 0},
  [1808] = {.lex_state = 79},
  [1809] = {.lex_state = 0},
  [1810] = {.lex_state = 0},
  [1811] = {.lex_state = 0},
  [1812] = {.lex_state = 0},
  [1813] = {.lex_state = 0},
  [1814] = {.lex_state = 0},
  [1815] = {.lex_state = 0},
  [1816] = {.lex_state = 0},
  [1817] = {.lex_state = 0},
  [1818] = {.lex_state = 0},
  [1819] = {.lex_state = 0},
  [1820] = {.lex_state = 0},
  [1821] = {.lex_state = 0},
  [1822] = {.lex_state = 0},
  [1823] = {.lex_state = 0},
  [1824] = {.lex_state = 0},
  [1825] = {.lex_state = 0},
  [1826] = {.lex_state = 0},
  [1827] = {.lex_state = 0},
  [1828] = {.lex_state = 0},
  [1829] = {.lex_state = 0},
  [1830] = {.lex_state = 0},
  [1831] = {.lex_state = 0},
  [1832] = {.lex_state = 79},
  [1833] = {.lex_state = 0},
  [1834] = {.lex_state = 0},
  [1835] = {.lex_state = 0},
  [1836] = {.lex_state = 0},
  [1837] = {.lex_state = 0},
  [1838] = {.lex_state = 0},
  [1839] = {.lex_state = 0},
  [1840] = {.lex_state = 0},
  [1841] = {.lex_state = 0},
  [1842] = {.lex_state = 0},
  [1843] = {.lex_state = 0},
  [1844] = {.lex_state = 0},
  [1845] = {.lex_state = 0},
  [1846] = {.lex_state = 0},
  [1847] = {.lex_state = 0},
  [1848] = {.lex_state = 0},
  [1849] = {.lex_state = 0},
  [1850] = {.lex_state = 0},
  [1851] = {.lex_state = 0},
  [1852] = {.lex_state = 0},
  [1853] = {.lex_state = 0},
  [1854] = {.lex_state = 0},
  [1855] = {.lex_state = 0},
  [1856] = {.lex_state = 0},
  [1857] = {.lex_state = 0},
  [1858] = {.lex_state = 6},
  [1859] = {.lex_state = 0},
  [1860] = {.lex_state = 0},
  [1861] = {.lex_state = 0},
  [1862] = {.lex_state = 0},
  [1863] = {.lex_state = 0},
  [1864] = {.lex_state = 0},
  [1865] = {.lex_state = 0},
  [1866] = {.lex_state = 0},
  [1867] = {.lex_state = 0},
  [1868] = {.lex_state = 0},
  [1869] = {.lex_state = 0},
  [1870] = {.lex_state = 0},
  [1871] = {.lex_state = 0},
  [1872] = {.lex_state = 0},
  [1873] = {.lex_state = 0},
  [1874] = {.lex_state = 0},
  [1875] = {.lex_state = 0},
  [1876] = {.lex_state = 0},
  [1877] = {.lex_state = 0},
  [1878] = {.lex_state = 0},
  [1879] = {.lex_state = 0},
  [1880] = {.lex_state = 0},
  [1881] = {.lex_state = 0},
  [1882] = {.lex_state = 0},
  [1883] = {.lex_state = 0},
  [1884] = {.lex_state = 0},
  [1885] = {.lex_state = 0},
  [1886] = {.lex_state = 0},
  [1887] = {.lex_state = 0},
  [1888] = {.lex_state = 0},
  [1889] = {.lex_state = 0},
  [1890] = {.lex_state = 0},
  [1891] = {.lex_state = 0},
  [1892] = {.lex_state = 0},
  [1893] = {.lex_state = 0},
  [1894] = {.lex_state = 0},
  [1895] = {.lex_state = 0},
  [1896] = {.lex_state = 0},
  [1897] = {.lex_state = 0},
  [1898] = {.lex_state = 0},
  [1899] = {.lex_state = 0},
  [1900] = {.lex_state = 0},
  [1901] = {.lex_state = 0},
  [1902] = {.lex_state = 0},
  [1903] = {.lex_state = 0},
  [1904] = {.lex_state = 0},
  [1905] = {.lex_state = 0},
  [1906] = {.lex_state = 0},
  [1907] = {.lex_state = 0},
  [1908] = {.lex_state = 0},
  [1909] = {.lex_state = 0},
  [1910] = {.lex_state = 0},
  [1911] = {.lex_state = 0},
  [1912] = {.lex_state = 0},
  [1913] = {.lex_state = 0},
  [1914] = {.lex_state = 0},
  [1915] = {.lex_state = 0},
  [1916] = {.lex_state = 0},
  [1917] = {.lex_state = 0},
  [1918] = {.lex_state = 0},
  [1919] = {.lex_state = 0},
  [1920] = {.lex_state = 0},
  [1921] = {.lex_state = 0},
  [1922] = {.lex_state = 0},
  [1923] = {.lex_state = 0},
  [1924] = {.lex_state = 0},
  [1925] = {.lex_state = 0},
  [1926] = {.lex_state = 0},
  [1927] = {.lex_state = 79},
  [1928] = {.lex_state = 0},
  [1929] = {.lex_state = 0},
  [1930] = {.lex_state = 0},
  [1931] = {.lex_state = 0},
  [1932] = {.lex_state = 0},
  [1933] = {.lex_state = 0},
  [1934] = {.lex_state = 0},
  [1935] = {.lex_state = 0},
  [1936] = {.lex_state = 0},
  [1937] = {.lex_state = 6},
  [1938] = {.lex_state = 0},
  [1939] = {.lex_state = 0},
  [1940] = {.lex_state = 0},
  [1941] = {.lex_state = 0},
  [1942] = {.lex_state = 0},
  [1943] = {.lex_state = 0},
  [1944] = {.lex_state = 0},
  [1945] = {.lex_state = 0},
  [1946] = {.lex_state = 0},
  [1947] = {.lex_state = 6},
  [1948] = {.lex_state = 0},
  [1949] = {.lex_state = 0},
  [1950] = {.lex_state = 0},
  [1951] = {.lex_state = 0},
  [1952] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_func] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_alloc_locals] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_static_assert] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_tempvar] = ACTIONS(1),
    [anon_sym_ap] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_jmp] = ACTIONS(1),
    [anon_sym_rel] = ACTIONS(1),
    [anon_sym_abs] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [sym_inst_ret] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_dw] = ACTIONS(1),
    [anon_sym_with_attr] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_felt] = ACTIONS(1),
    [anon_sym_codeoffset] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [sym_short_string] = ACTIONS(1),
    [anon_sym_nondet] = ACTIONS(1),
    [anon_sym_PERCENT_RBRACE] = ACTIONS(1),
    [anon_sym_fp] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_cast] = ACTIONS(1),
    [anon_sym_call] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_mod] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_implicits] = ACTIONS(1),
    [anon_sym_nopanic] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [anon_sym_mut] = ACTIONS(1),
    [anon_sym_impl] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_trait] = ACTIONS(1),
    [anon_sym_u8] = ACTIONS(1),
    [anon_sym_i8] = ACTIONS(1),
    [anon_sym_u16] = ACTIONS(1),
    [anon_sym_i16] = ACTIONS(1),
    [anon_sym_u32] = ACTIONS(1),
    [anon_sym_i32] = ACTIONS(1),
    [anon_sym_u64] = ACTIONS(1),
    [anon_sym_i64] = ACTIONS(1),
    [anon_sym_u128] = ACTIONS(1),
    [anon_sym_i128] = ACTIONS(1),
    [anon_sym_u256] = ACTIONS(1),
    [anon_sym_i256] = ACTIONS(1),
    [anon_sym_isize] = ACTIONS(1),
    [anon_sym_usize] = ACTIONS(1),
    [anon_sym_f32] = ACTIONS(1),
    [anon_sym_f64] = ACTIONS(1),
    [anon_sym_felt252] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_str] = ACTIONS(1),
    [anon_sym_char] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_loop] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_LT2] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [sym__cairo_1_short_string] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_self] = ACTIONS(1),
    [sym_code_line] = ACTIONS(1),
    [sym__failure] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(1807),
    [sym_cairo_0_file] = STATE(1841),
    [sym_cairo_1_file] = STATE(1841),
    [sym__cairo_0_statement] = STATE(85),
    [sym__cairo_0_import_statement] = STATE(631),
    [sym_type_definition] = STATE(628),
    [sym_builtin_directive] = STATE(628),
    [sym_lang_directive] = STATE(628),
    [sym__cairo_0_decorated_definition] = STATE(629),
    [sym_decorator] = STATE(1095),
    [sym__cairo_0_namespace_definition] = STATE(628),
    [sym__cairo_0_struct_definition] = STATE(628),
    [sym__cairo_0_function_definition] = STATE(628),
    [sym__cairo_0_expression_statement] = STATE(628),
    [sym_alloc_locals] = STATE(628),
    [sym__cairo_0_assert_statement] = STATE(628),
    [sym__cairo_0_static_assert_statement] = STATE(628),
    [sym__cairo_0_let_binding] = STATE(650),
    [sym_const_var_declaration] = STATE(628),
    [sym_local_var_declaration] = STATE(628),
    [sym_temp_var_declaration] = STATE(628),
    [sym_instruction] = STATE(628),
    [sym_inst_assert_eq] = STATE(1262),
    [sym_inst_jmp_rel] = STATE(1262),
    [sym_inst_jmp_abs] = STATE(1262),
    [sym_inst_jmp_to_label] = STATE(1262),
    [sym_inst_jnz] = STATE(1262),
    [sym_inst_jnz_to_label] = STATE(1262),
    [sym_inst_add_ap] = STATE(1262),
    [sym_inst_data_word] = STATE(1262),
    [sym_label] = STATE(628),
    [sym__cairo_0_attribute_statement] = STATE(628),
    [sym__cairo_0_if_statement] = STATE(628),
    [sym__cairo_0_with_statement] = STATE(628),
    [sym__cairo_0_return_statement] = STATE(628),
    [sym__cairo_0_expression] = STATE(905),
    [sym_unary_expression] = STATE(905),
    [sym_binary_expression] = STATE(905),
    [sym_assignment_expression] = STATE(905),
    [sym_hint_expression] = STATE(905),
    [sym_hint] = STATE(628),
    [sym_register] = STATE(905),
    [sym_deref_expression] = STATE(905),
    [sym_subscript_expression] = STATE(905),
    [sym_member_expression] = STATE(905),
    [sym_cast_expression] = STATE(905),
    [sym_tuple_expression] = STATE(905),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1262),
    [sym__cairo_1_statement] = STATE(787),
    [sym_use_declaration] = STATE(787),
    [sym_extern_type_statement] = STATE(787),
    [sym_extern_function_statement] = STATE(787),
    [sym_attribute_item] = STATE(787),
    [sym_mod_item] = STATE(787),
    [sym_struct_item] = STATE(787),
    [sym_enum_item] = STATE(787),
    [sym_const_item] = STATE(787),
    [sym_type_item] = STATE(787),
    [sym__cairo_1_function_definition] = STATE(972),
    [sym__cairo_1_function_signature] = STATE(977),
    [sym_impl_item] = STATE(787),
    [sym_trait_item] = STATE(787),
    [sym_let_declaration] = STATE(787),
    [aux_sym_cairo_0_file_repeat1] = STATE(85),
    [aux_sym_cairo_1_file_repeat1] = STATE(787),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1095),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_from] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(13),
    [anon_sym_PERCENTbuiltins] = ACTIONS(15),
    [anon_sym_PERCENTlang] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_struct] = ACTIONS(23),
    [anon_sym_func] = ACTIONS(25),
    [anon_sym_alloc_locals] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_static_assert] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(33),
    [anon_sym_const] = ACTIONS(35),
    [anon_sym_local] = ACTIONS(37),
    [anon_sym_tempvar] = ACTIONS(39),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [sym_inst_ret] = ACTIONS(47),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(61),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(65),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(75),
    [anon_sym_extern] = ACTIONS(77),
    [anon_sym_type] = ACTIONS(79),
    [anon_sym_fn] = ACTIONS(81),
    [anon_sym_POUND] = ACTIONS(83),
    [anon_sym_mod] = ACTIONS(85),
    [anon_sym_enum] = ACTIONS(87),
    [anon_sym_impl] = ACTIONS(89),
    [anon_sym_trait] = ACTIONS(91),
  },
  [2] = {
    [sym_block] = STATE(97),
    [sym__cairo_1_generic_function] = STATE(100),
    [sym_generic_type_with_turbofish] = STATE(1827),
    [sym__cairo_1_expression] = STATE(113),
    [sym__cairo_1_return_expression] = STATE(97),
    [sym__cairo_1_if_expression] = STATE(101),
    [sym_match_expression] = STATE(97),
    [sym__cairo_1_loop_expression] = STATE(102),
    [sym__cairo_1_at_expression] = STATE(97),
    [sym__cairo_1_unary_expression] = STATE(97),
    [sym__cairo_1_binary_expression] = STATE(103),
    [sym__cairo_1_assignment_expression] = STATE(104),
    [sym__cairo_1_compound_assignment_expression] = STATE(105),
    [sym__cairo_1_try_expression] = STATE(97),
    [sym__cairo_1_call_expression] = STATE(106),
    [sym__cairo_1_index_expression] = STATE(97),
    [sym__cairo_1_field_expression] = STATE(107),
    [sym__cairo_1_parenthesized_expression] = STATE(97),
    [sym__cairo_1_tuple_expression] = STATE(97),
    [sym__cairo_1_unit_expression] = STATE(97),
    [sym__cairo_1_struct_expression] = STATE(108),
    [sym__literal] = STATE(97),
    [sym_scoped_identifier] = STATE(109),
    [sym_boolean] = STATE(97),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_EQ] = ACTIONS(97),
    [anon_sym_AT] = ACTIONS(99),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(103),
    [anon_sym_struct] = ACTIONS(97),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_let] = ACTIONS(97),
    [anon_sym_const] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_BANG_EQ] = ACTIONS(103),
    [anon_sym_PLUS_EQ] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(97),
    [anon_sym_DASH] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(97),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_DOT] = ACTIONS(103),
    [sym_number] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(97),
    [anon_sym_extern] = ACTIONS(97),
    [anon_sym_type] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [anon_sym_fn] = ACTIONS(97),
    [anon_sym_POUND] = ACTIONS(103),
    [anon_sym_mod] = ACTIONS(97),
    [anon_sym_enum] = ACTIONS(97),
    [anon_sym_impl] = ACTIONS(97),
    [anon_sym_trait] = ACTIONS(97),
    [anon_sym_u8] = ACTIONS(115),
    [anon_sym_i8] = ACTIONS(115),
    [anon_sym_u16] = ACTIONS(115),
    [anon_sym_i16] = ACTIONS(115),
    [anon_sym_u32] = ACTIONS(115),
    [anon_sym_i32] = ACTIONS(115),
    [anon_sym_u64] = ACTIONS(115),
    [anon_sym_i64] = ACTIONS(115),
    [anon_sym_u128] = ACTIONS(115),
    [anon_sym_i128] = ACTIONS(115),
    [anon_sym_u256] = ACTIONS(115),
    [anon_sym_i256] = ACTIONS(115),
    [anon_sym_isize] = ACTIONS(115),
    [anon_sym_usize] = ACTIONS(115),
    [anon_sym_f32] = ACTIONS(115),
    [anon_sym_f64] = ACTIONS(115),
    [anon_sym_felt252] = ACTIONS(115),
    [anon_sym_bool] = ACTIONS(115),
    [anon_sym_str] = ACTIONS(115),
    [anon_sym_char] = ACTIONS(115),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_match] = ACTIONS(117),
    [anon_sym_loop] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(109),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_PIPE_PIPE] = ACTIONS(103),
    [anon_sym_PIPE] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(97),
    [anon_sym_LT2] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(103),
    [anon_sym_LT_LT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(97),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_DASH_EQ] = ACTIONS(103),
    [anon_sym_STAR_EQ] = ACTIONS(103),
    [anon_sym_SLASH_EQ] = ACTIONS(103),
    [anon_sym_PERCENT_EQ] = ACTIONS(103),
    [anon_sym_AMP_EQ] = ACTIONS(103),
    [anon_sym_PIPE_EQ] = ACTIONS(103),
    [anon_sym_CARET_EQ] = ACTIONS(103),
    [anon_sym_LT_LT_EQ] = ACTIONS(103),
    [anon_sym_GT_GT_EQ] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(103),
    [sym__cairo_1_short_string] = ACTIONS(111),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [sym_self] = ACTIONS(125),
  },
  [3] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(531),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(97),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(103),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(103),
    [anon_sym_PLUS_EQ] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_AMP] = ACTIONS(97),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(97),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(103),
    [anon_sym_DOT] = ACTIONS(103),
    [sym_number] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(103),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_PIPE_PIPE] = ACTIONS(103),
    [anon_sym_PIPE] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(97),
    [anon_sym_LT2] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(103),
    [anon_sym_LT_LT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(97),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_DASH_EQ] = ACTIONS(103),
    [anon_sym_STAR_EQ] = ACTIONS(103),
    [anon_sym_SLASH_EQ] = ACTIONS(103),
    [anon_sym_PERCENT_EQ] = ACTIONS(103),
    [anon_sym_AMP_EQ] = ACTIONS(103),
    [anon_sym_PIPE_EQ] = ACTIONS(103),
    [anon_sym_CARET_EQ] = ACTIONS(103),
    [anon_sym_LT_LT_EQ] = ACTIONS(103),
    [anon_sym_GT_GT_EQ] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(103),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [4] = {
    [sym__cairo_1_statement] = STATE(4),
    [sym_use_declaration] = STATE(4),
    [sym_extern_type_statement] = STATE(4),
    [sym_extern_function_statement] = STATE(4),
    [sym_attribute_item] = STATE(4),
    [sym_mod_item] = STATE(4),
    [sym_struct_item] = STATE(4),
    [sym_enum_item] = STATE(4),
    [sym_const_item] = STATE(4),
    [sym_type_item] = STATE(4),
    [sym_block] = STATE(97),
    [sym__cairo_1_function_definition] = STATE(315),
    [sym__cairo_1_function_signature] = STATE(316),
    [sym_impl_item] = STATE(4),
    [sym_trait_item] = STATE(4),
    [sym_let_declaration] = STATE(4),
    [sym__cairo_1_generic_function] = STATE(100),
    [sym_generic_type_with_turbofish] = STATE(1827),
    [sym__cairo_1_expression_statement] = STATE(4),
    [sym__cairo_1_expression] = STATE(172),
    [sym__cairo_1_return_expression] = STATE(97),
    [sym__cairo_1_if_expression] = STATE(101),
    [sym_match_expression] = STATE(97),
    [sym__cairo_1_loop_expression] = STATE(102),
    [sym__cairo_1_at_expression] = STATE(97),
    [sym__cairo_1_unary_expression] = STATE(97),
    [sym__cairo_1_binary_expression] = STATE(103),
    [sym__cairo_1_assignment_expression] = STATE(104),
    [sym__cairo_1_compound_assignment_expression] = STATE(105),
    [sym__cairo_1_try_expression] = STATE(97),
    [sym__cairo_1_call_expression] = STATE(106),
    [sym__cairo_1_index_expression] = STATE(97),
    [sym__cairo_1_field_expression] = STATE(107),
    [sym__cairo_1_parenthesized_expression] = STATE(97),
    [sym__cairo_1_tuple_expression] = STATE(97),
    [sym__cairo_1_unit_expression] = STATE(97),
    [sym__cairo_1_struct_expression] = STATE(108),
    [sym__literal] = STATE(97),
    [sym_scoped_identifier] = STATE(109),
    [sym_boolean] = STATE(97),
    [aux_sym_block_repeat1] = STATE(4),
    [sym_identifier] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(160),
    [anon_sym_AT] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(166),
    [anon_sym_RBRACE] = ACTIONS(169),
    [anon_sym_struct] = ACTIONS(171),
    [anon_sym_let] = ACTIONS(174),
    [anon_sym_const] = ACTIONS(177),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_STAR] = ACTIONS(186),
    [anon_sym_DASH] = ACTIONS(189),
    [sym_number] = ACTIONS(192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(195),
    [anon_sym_extern] = ACTIONS(198),
    [anon_sym_type] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(204),
    [anon_sym_fn] = ACTIONS(207),
    [anon_sym_POUND] = ACTIONS(210),
    [anon_sym_mod] = ACTIONS(213),
    [anon_sym_enum] = ACTIONS(216),
    [anon_sym_impl] = ACTIONS(219),
    [anon_sym_trait] = ACTIONS(222),
    [anon_sym_u8] = ACTIONS(225),
    [anon_sym_i8] = ACTIONS(225),
    [anon_sym_u16] = ACTIONS(225),
    [anon_sym_i16] = ACTIONS(225),
    [anon_sym_u32] = ACTIONS(225),
    [anon_sym_i32] = ACTIONS(225),
    [anon_sym_u64] = ACTIONS(225),
    [anon_sym_i64] = ACTIONS(225),
    [anon_sym_u128] = ACTIONS(225),
    [anon_sym_i128] = ACTIONS(225),
    [anon_sym_u256] = ACTIONS(225),
    [anon_sym_i256] = ACTIONS(225),
    [anon_sym_isize] = ACTIONS(225),
    [anon_sym_usize] = ACTIONS(225),
    [anon_sym_f32] = ACTIONS(225),
    [anon_sym_f64] = ACTIONS(225),
    [anon_sym_felt252] = ACTIONS(225),
    [anon_sym_bool] = ACTIONS(225),
    [anon_sym_str] = ACTIONS(225),
    [anon_sym_char] = ACTIONS(225),
    [anon_sym_match] = ACTIONS(228),
    [anon_sym_loop] = ACTIONS(231),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [sym__cairo_1_short_string] = ACTIONS(192),
    [anon_sym_true] = ACTIONS(234),
    [anon_sym_false] = ACTIONS(234),
    [sym_self] = ACTIONS(237),
  },
  [5] = {
    [sym__cairo_1_statement] = STATE(11),
    [sym_use_declaration] = STATE(11),
    [sym_extern_type_statement] = STATE(11),
    [sym_extern_function_statement] = STATE(11),
    [sym_attribute_item] = STATE(11),
    [sym_mod_item] = STATE(11),
    [sym_struct_item] = STATE(11),
    [sym_enum_item] = STATE(11),
    [sym_const_item] = STATE(11),
    [sym_type_item] = STATE(11),
    [sym_block] = STATE(97),
    [sym__cairo_1_function_definition] = STATE(315),
    [sym__cairo_1_function_signature] = STATE(316),
    [sym_impl_item] = STATE(11),
    [sym_trait_item] = STATE(11),
    [sym_let_declaration] = STATE(11),
    [sym__cairo_1_generic_function] = STATE(100),
    [sym_generic_type_with_turbofish] = STATE(1827),
    [sym__cairo_1_expression_statement] = STATE(11),
    [sym__cairo_1_expression] = STATE(172),
    [sym__cairo_1_return_expression] = STATE(97),
    [sym__cairo_1_if_expression] = STATE(101),
    [sym_match_expression] = STATE(97),
    [sym__cairo_1_loop_expression] = STATE(102),
    [sym__cairo_1_at_expression] = STATE(97),
    [sym__cairo_1_unary_expression] = STATE(97),
    [sym__cairo_1_binary_expression] = STATE(103),
    [sym__cairo_1_assignment_expression] = STATE(104),
    [sym__cairo_1_compound_assignment_expression] = STATE(105),
    [sym__cairo_1_try_expression] = STATE(97),
    [sym__cairo_1_call_expression] = STATE(106),
    [sym__cairo_1_index_expression] = STATE(97),
    [sym__cairo_1_field_expression] = STATE(107),
    [sym__cairo_1_parenthesized_expression] = STATE(97),
    [sym__cairo_1_tuple_expression] = STATE(97),
    [sym__cairo_1_unit_expression] = STATE(97),
    [sym__cairo_1_struct_expression] = STATE(108),
    [sym__literal] = STATE(97),
    [sym_scoped_identifier] = STATE(109),
    [sym_boolean] = STATE(97),
    [aux_sym_block_repeat1] = STATE(11),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_AT] = ACTIONS(99),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(240),
    [anon_sym_struct] = ACTIONS(242),
    [anon_sym_let] = ACTIONS(244),
    [anon_sym_const] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_return] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_DASH] = ACTIONS(109),
    [sym_number] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(248),
    [anon_sym_extern] = ACTIONS(250),
    [anon_sym_type] = ACTIONS(252),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [anon_sym_fn] = ACTIONS(254),
    [anon_sym_POUND] = ACTIONS(256),
    [anon_sym_mod] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(260),
    [anon_sym_impl] = ACTIONS(262),
    [anon_sym_trait] = ACTIONS(264),
    [anon_sym_u8] = ACTIONS(115),
    [anon_sym_i8] = ACTIONS(115),
    [anon_sym_u16] = ACTIONS(115),
    [anon_sym_i16] = ACTIONS(115),
    [anon_sym_u32] = ACTIONS(115),
    [anon_sym_i32] = ACTIONS(115),
    [anon_sym_u64] = ACTIONS(115),
    [anon_sym_i64] = ACTIONS(115),
    [anon_sym_u128] = ACTIONS(115),
    [anon_sym_i128] = ACTIONS(115),
    [anon_sym_u256] = ACTIONS(115),
    [anon_sym_i256] = ACTIONS(115),
    [anon_sym_isize] = ACTIONS(115),
    [anon_sym_usize] = ACTIONS(115),
    [anon_sym_f32] = ACTIONS(115),
    [anon_sym_f64] = ACTIONS(115),
    [anon_sym_felt252] = ACTIONS(115),
    [anon_sym_bool] = ACTIONS(115),
    [anon_sym_str] = ACTIONS(115),
    [anon_sym_char] = ACTIONS(115),
    [anon_sym_match] = ACTIONS(117),
    [anon_sym_loop] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [sym__cairo_1_short_string] = ACTIONS(111),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [sym_self] = ACTIONS(125),
  },
  [6] = {
    [sym__cairo_1_statement] = STATE(4),
    [sym_use_declaration] = STATE(4),
    [sym_extern_type_statement] = STATE(4),
    [sym_extern_function_statement] = STATE(4),
    [sym_attribute_item] = STATE(4),
    [sym_mod_item] = STATE(4),
    [sym_struct_item] = STATE(4),
    [sym_enum_item] = STATE(4),
    [sym_const_item] = STATE(4),
    [sym_type_item] = STATE(4),
    [sym_block] = STATE(97),
    [sym__cairo_1_function_definition] = STATE(315),
    [sym__cairo_1_function_signature] = STATE(316),
    [sym_impl_item] = STATE(4),
    [sym_trait_item] = STATE(4),
    [sym_let_declaration] = STATE(4),
    [sym__cairo_1_generic_function] = STATE(100),
    [sym_generic_type_with_turbofish] = STATE(1827),
    [sym__cairo_1_expression_statement] = STATE(4),
    [sym__cairo_1_expression] = STATE(172),
    [sym__cairo_1_return_expression] = STATE(97),
    [sym__cairo_1_if_expression] = STATE(101),
    [sym_match_expression] = STATE(97),
    [sym__cairo_1_loop_expression] = STATE(102),
    [sym__cairo_1_at_expression] = STATE(97),
    [sym__cairo_1_unary_expression] = STATE(97),
    [sym__cairo_1_binary_expression] = STATE(103),
    [sym__cairo_1_assignment_expression] = STATE(104),
    [sym__cairo_1_compound_assignment_expression] = STATE(105),
    [sym__cairo_1_try_expression] = STATE(97),
    [sym__cairo_1_call_expression] = STATE(106),
    [sym__cairo_1_index_expression] = STATE(97),
    [sym__cairo_1_field_expression] = STATE(107),
    [sym__cairo_1_parenthesized_expression] = STATE(97),
    [sym__cairo_1_tuple_expression] = STATE(97),
    [sym__cairo_1_unit_expression] = STATE(97),
    [sym__cairo_1_struct_expression] = STATE(108),
    [sym__literal] = STATE(97),
    [sym_scoped_identifier] = STATE(109),
    [sym_boolean] = STATE(97),
    [aux_sym_block_repeat1] = STATE(4),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_AT] = ACTIONS(99),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(266),
    [anon_sym_struct] = ACTIONS(242),
    [anon_sym_let] = ACTIONS(244),
    [anon_sym_const] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_return] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_DASH] = ACTIONS(109),
    [sym_number] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(248),
    [anon_sym_extern] = ACTIONS(250),
    [anon_sym_type] = ACTIONS(252),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [anon_sym_fn] = ACTIONS(254),
    [anon_sym_POUND] = ACTIONS(256),
    [anon_sym_mod] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(260),
    [anon_sym_impl] = ACTIONS(262),
    [anon_sym_trait] = ACTIONS(264),
    [anon_sym_u8] = ACTIONS(115),
    [anon_sym_i8] = ACTIONS(115),
    [anon_sym_u16] = ACTIONS(115),
    [anon_sym_i16] = ACTIONS(115),
    [anon_sym_u32] = ACTIONS(115),
    [anon_sym_i32] = ACTIONS(115),
    [anon_sym_u64] = ACTIONS(115),
    [anon_sym_i64] = ACTIONS(115),
    [anon_sym_u128] = ACTIONS(115),
    [anon_sym_i128] = ACTIONS(115),
    [anon_sym_u256] = ACTIONS(115),
    [anon_sym_i256] = ACTIONS(115),
    [anon_sym_isize] = ACTIONS(115),
    [anon_sym_usize] = ACTIONS(115),
    [anon_sym_f32] = ACTIONS(115),
    [anon_sym_f64] = ACTIONS(115),
    [anon_sym_felt252] = ACTIONS(115),
    [anon_sym_bool] = ACTIONS(115),
    [anon_sym_str] = ACTIONS(115),
    [anon_sym_char] = ACTIONS(115),
    [anon_sym_match] = ACTIONS(117),
    [anon_sym_loop] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [sym__cairo_1_short_string] = ACTIONS(111),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [sym_self] = ACTIONS(125),
  },
  [7] = {
    [sym__cairo_1_statement] = STATE(9),
    [sym_use_declaration] = STATE(9),
    [sym_extern_type_statement] = STATE(9),
    [sym_extern_function_statement] = STATE(9),
    [sym_attribute_item] = STATE(9),
    [sym_mod_item] = STATE(9),
    [sym_struct_item] = STATE(9),
    [sym_enum_item] = STATE(9),
    [sym_const_item] = STATE(9),
    [sym_type_item] = STATE(9),
    [sym_block] = STATE(97),
    [sym__cairo_1_function_definition] = STATE(315),
    [sym__cairo_1_function_signature] = STATE(316),
    [sym_impl_item] = STATE(9),
    [sym_trait_item] = STATE(9),
    [sym_let_declaration] = STATE(9),
    [sym__cairo_1_generic_function] = STATE(100),
    [sym_generic_type_with_turbofish] = STATE(1827),
    [sym__cairo_1_expression_statement] = STATE(9),
    [sym__cairo_1_expression] = STATE(172),
    [sym__cairo_1_return_expression] = STATE(97),
    [sym__cairo_1_if_expression] = STATE(101),
    [sym_match_expression] = STATE(97),
    [sym__cairo_1_loop_expression] = STATE(102),
    [sym__cairo_1_at_expression] = STATE(97),
    [sym__cairo_1_unary_expression] = STATE(97),
    [sym__cairo_1_binary_expression] = STATE(103),
    [sym__cairo_1_assignment_expression] = STATE(104),
    [sym__cairo_1_compound_assignment_expression] = STATE(105),
    [sym__cairo_1_try_expression] = STATE(97),
    [sym__cairo_1_call_expression] = STATE(106),
    [sym__cairo_1_index_expression] = STATE(97),
    [sym__cairo_1_field_expression] = STATE(107),
    [sym__cairo_1_parenthesized_expression] = STATE(97),
    [sym__cairo_1_tuple_expression] = STATE(97),
    [sym__cairo_1_unit_expression] = STATE(97),
    [sym__cairo_1_struct_expression] = STATE(108),
    [sym__literal] = STATE(97),
    [sym_scoped_identifier] = STATE(109),
    [sym_boolean] = STATE(97),
    [aux_sym_block_repeat1] = STATE(9),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_AT] = ACTIONS(99),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(268),
    [anon_sym_struct] = ACTIONS(242),
    [anon_sym_let] = ACTIONS(244),
    [anon_sym_const] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_return] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_DASH] = ACTIONS(109),
    [sym_number] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(248),
    [anon_sym_extern] = ACTIONS(250),
    [anon_sym_type] = ACTIONS(252),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [anon_sym_fn] = ACTIONS(254),
    [anon_sym_POUND] = ACTIONS(256),
    [anon_sym_mod] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(260),
    [anon_sym_impl] = ACTIONS(262),
    [anon_sym_trait] = ACTIONS(264),
    [anon_sym_u8] = ACTIONS(115),
    [anon_sym_i8] = ACTIONS(115),
    [anon_sym_u16] = ACTIONS(115),
    [anon_sym_i16] = ACTIONS(115),
    [anon_sym_u32] = ACTIONS(115),
    [anon_sym_i32] = ACTIONS(115),
    [anon_sym_u64] = ACTIONS(115),
    [anon_sym_i64] = ACTIONS(115),
    [anon_sym_u128] = ACTIONS(115),
    [anon_sym_i128] = ACTIONS(115),
    [anon_sym_u256] = ACTIONS(115),
    [anon_sym_i256] = ACTIONS(115),
    [anon_sym_isize] = ACTIONS(115),
    [anon_sym_usize] = ACTIONS(115),
    [anon_sym_f32] = ACTIONS(115),
    [anon_sym_f64] = ACTIONS(115),
    [anon_sym_felt252] = ACTIONS(115),
    [anon_sym_bool] = ACTIONS(115),
    [anon_sym_str] = ACTIONS(115),
    [anon_sym_char] = ACTIONS(115),
    [anon_sym_match] = ACTIONS(117),
    [anon_sym_loop] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [sym__cairo_1_short_string] = ACTIONS(111),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [sym_self] = ACTIONS(125),
  },
  [8] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(775),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(97),
    [anon_sym_AT] = ACTIONS(272),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(103),
    [anon_sym_PLUS_EQ] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(274),
    [anon_sym_STAR] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(97),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(97),
    [anon_sym_SLASH] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_DOT] = ACTIONS(103),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(278),
    [anon_sym_i8] = ACTIONS(278),
    [anon_sym_u16] = ACTIONS(278),
    [anon_sym_i16] = ACTIONS(278),
    [anon_sym_u32] = ACTIONS(278),
    [anon_sym_i32] = ACTIONS(278),
    [anon_sym_u64] = ACTIONS(278),
    [anon_sym_i64] = ACTIONS(278),
    [anon_sym_u128] = ACTIONS(278),
    [anon_sym_i128] = ACTIONS(278),
    [anon_sym_u256] = ACTIONS(278),
    [anon_sym_i256] = ACTIONS(278),
    [anon_sym_isize] = ACTIONS(278),
    [anon_sym_usize] = ACTIONS(278),
    [anon_sym_f32] = ACTIONS(278),
    [anon_sym_f64] = ACTIONS(278),
    [anon_sym_felt252] = ACTIONS(278),
    [anon_sym_bool] = ACTIONS(278),
    [anon_sym_str] = ACTIONS(278),
    [anon_sym_char] = ACTIONS(278),
    [anon_sym_GT] = ACTIONS(97),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(276),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_PIPE_PIPE] = ACTIONS(103),
    [anon_sym_PIPE] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(97),
    [anon_sym_LT2] = ACTIONS(97),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(103),
    [anon_sym_LT_LT] = ACTIONS(97),
    [anon_sym_GT_GT] = ACTIONS(97),
    [anon_sym_PERCENT] = ACTIONS(97),
    [anon_sym_DASH_EQ] = ACTIONS(103),
    [anon_sym_STAR_EQ] = ACTIONS(103),
    [anon_sym_SLASH_EQ] = ACTIONS(103),
    [anon_sym_PERCENT_EQ] = ACTIONS(103),
    [anon_sym_AMP_EQ] = ACTIONS(103),
    [anon_sym_PIPE_EQ] = ACTIONS(103),
    [anon_sym_CARET_EQ] = ACTIONS(103),
    [anon_sym_LT_LT_EQ] = ACTIONS(103),
    [anon_sym_GT_GT_EQ] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(103),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [9] = {
    [sym__cairo_1_statement] = STATE(4),
    [sym_use_declaration] = STATE(4),
    [sym_extern_type_statement] = STATE(4),
    [sym_extern_function_statement] = STATE(4),
    [sym_attribute_item] = STATE(4),
    [sym_mod_item] = STATE(4),
    [sym_struct_item] = STATE(4),
    [sym_enum_item] = STATE(4),
    [sym_const_item] = STATE(4),
    [sym_type_item] = STATE(4),
    [sym_block] = STATE(97),
    [sym__cairo_1_function_definition] = STATE(315),
    [sym__cairo_1_function_signature] = STATE(316),
    [sym_impl_item] = STATE(4),
    [sym_trait_item] = STATE(4),
    [sym_let_declaration] = STATE(4),
    [sym__cairo_1_generic_function] = STATE(100),
    [sym_generic_type_with_turbofish] = STATE(1827),
    [sym__cairo_1_expression_statement] = STATE(4),
    [sym__cairo_1_expression] = STATE(172),
    [sym__cairo_1_return_expression] = STATE(97),
    [sym__cairo_1_if_expression] = STATE(101),
    [sym_match_expression] = STATE(97),
    [sym__cairo_1_loop_expression] = STATE(102),
    [sym__cairo_1_at_expression] = STATE(97),
    [sym__cairo_1_unary_expression] = STATE(97),
    [sym__cairo_1_binary_expression] = STATE(103),
    [sym__cairo_1_assignment_expression] = STATE(104),
    [sym__cairo_1_compound_assignment_expression] = STATE(105),
    [sym__cairo_1_try_expression] = STATE(97),
    [sym__cairo_1_call_expression] = STATE(106),
    [sym__cairo_1_index_expression] = STATE(97),
    [sym__cairo_1_field_expression] = STATE(107),
    [sym__cairo_1_parenthesized_expression] = STATE(97),
    [sym__cairo_1_tuple_expression] = STATE(97),
    [sym__cairo_1_unit_expression] = STATE(97),
    [sym__cairo_1_struct_expression] = STATE(108),
    [sym__literal] = STATE(97),
    [sym_scoped_identifier] = STATE(109),
    [sym_boolean] = STATE(97),
    [aux_sym_block_repeat1] = STATE(4),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_AT] = ACTIONS(99),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(282),
    [anon_sym_struct] = ACTIONS(242),
    [anon_sym_let] = ACTIONS(244),
    [anon_sym_const] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_return] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_DASH] = ACTIONS(109),
    [sym_number] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(248),
    [anon_sym_extern] = ACTIONS(250),
    [anon_sym_type] = ACTIONS(252),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [anon_sym_fn] = ACTIONS(254),
    [anon_sym_POUND] = ACTIONS(256),
    [anon_sym_mod] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(260),
    [anon_sym_impl] = ACTIONS(262),
    [anon_sym_trait] = ACTIONS(264),
    [anon_sym_u8] = ACTIONS(115),
    [anon_sym_i8] = ACTIONS(115),
    [anon_sym_u16] = ACTIONS(115),
    [anon_sym_i16] = ACTIONS(115),
    [anon_sym_u32] = ACTIONS(115),
    [anon_sym_i32] = ACTIONS(115),
    [anon_sym_u64] = ACTIONS(115),
    [anon_sym_i64] = ACTIONS(115),
    [anon_sym_u128] = ACTIONS(115),
    [anon_sym_i128] = ACTIONS(115),
    [anon_sym_u256] = ACTIONS(115),
    [anon_sym_i256] = ACTIONS(115),
    [anon_sym_isize] = ACTIONS(115),
    [anon_sym_usize] = ACTIONS(115),
    [anon_sym_f32] = ACTIONS(115),
    [anon_sym_f64] = ACTIONS(115),
    [anon_sym_felt252] = ACTIONS(115),
    [anon_sym_bool] = ACTIONS(115),
    [anon_sym_str] = ACTIONS(115),
    [anon_sym_char] = ACTIONS(115),
    [anon_sym_match] = ACTIONS(117),
    [anon_sym_loop] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [sym__cairo_1_short_string] = ACTIONS(111),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [sym_self] = ACTIONS(125),
  },
  [10] = {
    [sym__cairo_1_statement] = STATE(6),
    [sym_use_declaration] = STATE(6),
    [sym_extern_type_statement] = STATE(6),
    [sym_extern_function_statement] = STATE(6),
    [sym_attribute_item] = STATE(6),
    [sym_mod_item] = STATE(6),
    [sym_struct_item] = STATE(6),
    [sym_enum_item] = STATE(6),
    [sym_const_item] = STATE(6),
    [sym_type_item] = STATE(6),
    [sym_block] = STATE(97),
    [sym__cairo_1_function_definition] = STATE(315),
    [sym__cairo_1_function_signature] = STATE(316),
    [sym_impl_item] = STATE(6),
    [sym_trait_item] = STATE(6),
    [sym_let_declaration] = STATE(6),
    [sym__cairo_1_generic_function] = STATE(100),
    [sym_generic_type_with_turbofish] = STATE(1827),
    [sym__cairo_1_expression_statement] = STATE(6),
    [sym__cairo_1_expression] = STATE(172),
    [sym__cairo_1_return_expression] = STATE(97),
    [sym__cairo_1_if_expression] = STATE(101),
    [sym_match_expression] = STATE(97),
    [sym__cairo_1_loop_expression] = STATE(102),
    [sym__cairo_1_at_expression] = STATE(97),
    [sym__cairo_1_unary_expression] = STATE(97),
    [sym__cairo_1_binary_expression] = STATE(103),
    [sym__cairo_1_assignment_expression] = STATE(104),
    [sym__cairo_1_compound_assignment_expression] = STATE(105),
    [sym__cairo_1_try_expression] = STATE(97),
    [sym__cairo_1_call_expression] = STATE(106),
    [sym__cairo_1_index_expression] = STATE(97),
    [sym__cairo_1_field_expression] = STATE(107),
    [sym__cairo_1_parenthesized_expression] = STATE(97),
    [sym__cairo_1_tuple_expression] = STATE(97),
    [sym__cairo_1_unit_expression] = STATE(97),
    [sym__cairo_1_struct_expression] = STATE(108),
    [sym__literal] = STATE(97),
    [sym_scoped_identifier] = STATE(109),
    [sym_boolean] = STATE(97),
    [aux_sym_block_repeat1] = STATE(6),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_AT] = ACTIONS(99),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(284),
    [anon_sym_struct] = ACTIONS(242),
    [anon_sym_let] = ACTIONS(244),
    [anon_sym_const] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_return] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_DASH] = ACTIONS(109),
    [sym_number] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(248),
    [anon_sym_extern] = ACTIONS(250),
    [anon_sym_type] = ACTIONS(252),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [anon_sym_fn] = ACTIONS(254),
    [anon_sym_POUND] = ACTIONS(256),
    [anon_sym_mod] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(260),
    [anon_sym_impl] = ACTIONS(262),
    [anon_sym_trait] = ACTIONS(264),
    [anon_sym_u8] = ACTIONS(115),
    [anon_sym_i8] = ACTIONS(115),
    [anon_sym_u16] = ACTIONS(115),
    [anon_sym_i16] = ACTIONS(115),
    [anon_sym_u32] = ACTIONS(115),
    [anon_sym_i32] = ACTIONS(115),
    [anon_sym_u64] = ACTIONS(115),
    [anon_sym_i64] = ACTIONS(115),
    [anon_sym_u128] = ACTIONS(115),
    [anon_sym_i128] = ACTIONS(115),
    [anon_sym_u256] = ACTIONS(115),
    [anon_sym_i256] = ACTIONS(115),
    [anon_sym_isize] = ACTIONS(115),
    [anon_sym_usize] = ACTIONS(115),
    [anon_sym_f32] = ACTIONS(115),
    [anon_sym_f64] = ACTIONS(115),
    [anon_sym_felt252] = ACTIONS(115),
    [anon_sym_bool] = ACTIONS(115),
    [anon_sym_str] = ACTIONS(115),
    [anon_sym_char] = ACTIONS(115),
    [anon_sym_match] = ACTIONS(117),
    [anon_sym_loop] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [sym__cairo_1_short_string] = ACTIONS(111),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [sym_self] = ACTIONS(125),
  },
  [11] = {
    [sym__cairo_1_statement] = STATE(4),
    [sym_use_declaration] = STATE(4),
    [sym_extern_type_statement] = STATE(4),
    [sym_extern_function_statement] = STATE(4),
    [sym_attribute_item] = STATE(4),
    [sym_mod_item] = STATE(4),
    [sym_struct_item] = STATE(4),
    [sym_enum_item] = STATE(4),
    [sym_const_item] = STATE(4),
    [sym_type_item] = STATE(4),
    [sym_block] = STATE(97),
    [sym__cairo_1_function_definition] = STATE(315),
    [sym__cairo_1_function_signature] = STATE(316),
    [sym_impl_item] = STATE(4),
    [sym_trait_item] = STATE(4),
    [sym_let_declaration] = STATE(4),
    [sym__cairo_1_generic_function] = STATE(100),
    [sym_generic_type_with_turbofish] = STATE(1827),
    [sym__cairo_1_expression_statement] = STATE(4),
    [sym__cairo_1_expression] = STATE(172),
    [sym__cairo_1_return_expression] = STATE(97),
    [sym__cairo_1_if_expression] = STATE(101),
    [sym_match_expression] = STATE(97),
    [sym__cairo_1_loop_expression] = STATE(102),
    [sym__cairo_1_at_expression] = STATE(97),
    [sym__cairo_1_unary_expression] = STATE(97),
    [sym__cairo_1_binary_expression] = STATE(103),
    [sym__cairo_1_assignment_expression] = STATE(104),
    [sym__cairo_1_compound_assignment_expression] = STATE(105),
    [sym__cairo_1_try_expression] = STATE(97),
    [sym__cairo_1_call_expression] = STATE(106),
    [sym__cairo_1_index_expression] = STATE(97),
    [sym__cairo_1_field_expression] = STATE(107),
    [sym__cairo_1_parenthesized_expression] = STATE(97),
    [sym__cairo_1_tuple_expression] = STATE(97),
    [sym__cairo_1_unit_expression] = STATE(97),
    [sym__cairo_1_struct_expression] = STATE(108),
    [sym__literal] = STATE(97),
    [sym_scoped_identifier] = STATE(109),
    [sym_boolean] = STATE(97),
    [aux_sym_block_repeat1] = STATE(4),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_AT] = ACTIONS(99),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(286),
    [anon_sym_struct] = ACTIONS(242),
    [anon_sym_let] = ACTIONS(244),
    [anon_sym_const] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_return] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_DASH] = ACTIONS(109),
    [sym_number] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(248),
    [anon_sym_extern] = ACTIONS(250),
    [anon_sym_type] = ACTIONS(252),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [anon_sym_fn] = ACTIONS(254),
    [anon_sym_POUND] = ACTIONS(256),
    [anon_sym_mod] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(260),
    [anon_sym_impl] = ACTIONS(262),
    [anon_sym_trait] = ACTIONS(264),
    [anon_sym_u8] = ACTIONS(115),
    [anon_sym_i8] = ACTIONS(115),
    [anon_sym_u16] = ACTIONS(115),
    [anon_sym_i16] = ACTIONS(115),
    [anon_sym_u32] = ACTIONS(115),
    [anon_sym_i32] = ACTIONS(115),
    [anon_sym_u64] = ACTIONS(115),
    [anon_sym_i64] = ACTIONS(115),
    [anon_sym_u128] = ACTIONS(115),
    [anon_sym_i128] = ACTIONS(115),
    [anon_sym_u256] = ACTIONS(115),
    [anon_sym_i256] = ACTIONS(115),
    [anon_sym_isize] = ACTIONS(115),
    [anon_sym_usize] = ACTIONS(115),
    [anon_sym_f32] = ACTIONS(115),
    [anon_sym_f64] = ACTIONS(115),
    [anon_sym_felt252] = ACTIONS(115),
    [anon_sym_bool] = ACTIONS(115),
    [anon_sym_str] = ACTIONS(115),
    [anon_sym_char] = ACTIONS(115),
    [anon_sym_match] = ACTIONS(117),
    [anon_sym_loop] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [sym__cairo_1_short_string] = ACTIONS(111),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [sym_self] = ACTIONS(125),
  },
  [12] = {
    [sym__cairo_1_statement] = STATE(13),
    [sym_use_declaration] = STATE(13),
    [sym_extern_type_statement] = STATE(13),
    [sym_extern_function_statement] = STATE(13),
    [sym_attribute_item] = STATE(13),
    [sym_mod_item] = STATE(13),
    [sym_struct_item] = STATE(13),
    [sym_enum_item] = STATE(13),
    [sym_const_item] = STATE(13),
    [sym_type_item] = STATE(13),
    [sym_block] = STATE(97),
    [sym__cairo_1_function_definition] = STATE(315),
    [sym__cairo_1_function_signature] = STATE(316),
    [sym_impl_item] = STATE(13),
    [sym_trait_item] = STATE(13),
    [sym_let_declaration] = STATE(13),
    [sym__cairo_1_generic_function] = STATE(100),
    [sym_generic_type_with_turbofish] = STATE(1827),
    [sym__cairo_1_expression_statement] = STATE(13),
    [sym__cairo_1_expression] = STATE(172),
    [sym__cairo_1_return_expression] = STATE(97),
    [sym__cairo_1_if_expression] = STATE(101),
    [sym_match_expression] = STATE(97),
    [sym__cairo_1_loop_expression] = STATE(102),
    [sym__cairo_1_at_expression] = STATE(97),
    [sym__cairo_1_unary_expression] = STATE(97),
    [sym__cairo_1_binary_expression] = STATE(103),
    [sym__cairo_1_assignment_expression] = STATE(104),
    [sym__cairo_1_compound_assignment_expression] = STATE(105),
    [sym__cairo_1_try_expression] = STATE(97),
    [sym__cairo_1_call_expression] = STATE(106),
    [sym__cairo_1_index_expression] = STATE(97),
    [sym__cairo_1_field_expression] = STATE(107),
    [sym__cairo_1_parenthesized_expression] = STATE(97),
    [sym__cairo_1_tuple_expression] = STATE(97),
    [sym__cairo_1_unit_expression] = STATE(97),
    [sym__cairo_1_struct_expression] = STATE(108),
    [sym__literal] = STATE(97),
    [sym_scoped_identifier] = STATE(109),
    [sym_boolean] = STATE(97),
    [aux_sym_block_repeat1] = STATE(13),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_AT] = ACTIONS(99),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(288),
    [anon_sym_struct] = ACTIONS(242),
    [anon_sym_let] = ACTIONS(244),
    [anon_sym_const] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_return] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_DASH] = ACTIONS(109),
    [sym_number] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(248),
    [anon_sym_extern] = ACTIONS(250),
    [anon_sym_type] = ACTIONS(252),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [anon_sym_fn] = ACTIONS(254),
    [anon_sym_POUND] = ACTIONS(256),
    [anon_sym_mod] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(260),
    [anon_sym_impl] = ACTIONS(262),
    [anon_sym_trait] = ACTIONS(264),
    [anon_sym_u8] = ACTIONS(115),
    [anon_sym_i8] = ACTIONS(115),
    [anon_sym_u16] = ACTIONS(115),
    [anon_sym_i16] = ACTIONS(115),
    [anon_sym_u32] = ACTIONS(115),
    [anon_sym_i32] = ACTIONS(115),
    [anon_sym_u64] = ACTIONS(115),
    [anon_sym_i64] = ACTIONS(115),
    [anon_sym_u128] = ACTIONS(115),
    [anon_sym_i128] = ACTIONS(115),
    [anon_sym_u256] = ACTIONS(115),
    [anon_sym_i256] = ACTIONS(115),
    [anon_sym_isize] = ACTIONS(115),
    [anon_sym_usize] = ACTIONS(115),
    [anon_sym_f32] = ACTIONS(115),
    [anon_sym_f64] = ACTIONS(115),
    [anon_sym_felt252] = ACTIONS(115),
    [anon_sym_bool] = ACTIONS(115),
    [anon_sym_str] = ACTIONS(115),
    [anon_sym_char] = ACTIONS(115),
    [anon_sym_match] = ACTIONS(117),
    [anon_sym_loop] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [sym__cairo_1_short_string] = ACTIONS(111),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [sym_self] = ACTIONS(125),
  },
  [13] = {
    [sym__cairo_1_statement] = STATE(4),
    [sym_use_declaration] = STATE(4),
    [sym_extern_type_statement] = STATE(4),
    [sym_extern_function_statement] = STATE(4),
    [sym_attribute_item] = STATE(4),
    [sym_mod_item] = STATE(4),
    [sym_struct_item] = STATE(4),
    [sym_enum_item] = STATE(4),
    [sym_const_item] = STATE(4),
    [sym_type_item] = STATE(4),
    [sym_block] = STATE(97),
    [sym__cairo_1_function_definition] = STATE(315),
    [sym__cairo_1_function_signature] = STATE(316),
    [sym_impl_item] = STATE(4),
    [sym_trait_item] = STATE(4),
    [sym_let_declaration] = STATE(4),
    [sym__cairo_1_generic_function] = STATE(100),
    [sym_generic_type_with_turbofish] = STATE(1827),
    [sym__cairo_1_expression_statement] = STATE(4),
    [sym__cairo_1_expression] = STATE(172),
    [sym__cairo_1_return_expression] = STATE(97),
    [sym__cairo_1_if_expression] = STATE(101),
    [sym_match_expression] = STATE(97),
    [sym__cairo_1_loop_expression] = STATE(102),
    [sym__cairo_1_at_expression] = STATE(97),
    [sym__cairo_1_unary_expression] = STATE(97),
    [sym__cairo_1_binary_expression] = STATE(103),
    [sym__cairo_1_assignment_expression] = STATE(104),
    [sym__cairo_1_compound_assignment_expression] = STATE(105),
    [sym__cairo_1_try_expression] = STATE(97),
    [sym__cairo_1_call_expression] = STATE(106),
    [sym__cairo_1_index_expression] = STATE(97),
    [sym__cairo_1_field_expression] = STATE(107),
    [sym__cairo_1_parenthesized_expression] = STATE(97),
    [sym__cairo_1_tuple_expression] = STATE(97),
    [sym__cairo_1_unit_expression] = STATE(97),
    [sym__cairo_1_struct_expression] = STATE(108),
    [sym__literal] = STATE(97),
    [sym_scoped_identifier] = STATE(109),
    [sym_boolean] = STATE(97),
    [aux_sym_block_repeat1] = STATE(4),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_AT] = ACTIONS(99),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(290),
    [anon_sym_struct] = ACTIONS(242),
    [anon_sym_let] = ACTIONS(244),
    [anon_sym_const] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_return] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_DASH] = ACTIONS(109),
    [sym_number] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(248),
    [anon_sym_extern] = ACTIONS(250),
    [anon_sym_type] = ACTIONS(252),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [anon_sym_fn] = ACTIONS(254),
    [anon_sym_POUND] = ACTIONS(256),
    [anon_sym_mod] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(260),
    [anon_sym_impl] = ACTIONS(262),
    [anon_sym_trait] = ACTIONS(264),
    [anon_sym_u8] = ACTIONS(115),
    [anon_sym_i8] = ACTIONS(115),
    [anon_sym_u16] = ACTIONS(115),
    [anon_sym_i16] = ACTIONS(115),
    [anon_sym_u32] = ACTIONS(115),
    [anon_sym_i32] = ACTIONS(115),
    [anon_sym_u64] = ACTIONS(115),
    [anon_sym_i64] = ACTIONS(115),
    [anon_sym_u128] = ACTIONS(115),
    [anon_sym_i128] = ACTIONS(115),
    [anon_sym_u256] = ACTIONS(115),
    [anon_sym_i256] = ACTIONS(115),
    [anon_sym_isize] = ACTIONS(115),
    [anon_sym_usize] = ACTIONS(115),
    [anon_sym_f32] = ACTIONS(115),
    [anon_sym_f64] = ACTIONS(115),
    [anon_sym_felt252] = ACTIONS(115),
    [anon_sym_bool] = ACTIONS(115),
    [anon_sym_str] = ACTIONS(115),
    [anon_sym_char] = ACTIONS(115),
    [anon_sym_match] = ACTIONS(117),
    [anon_sym_loop] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [sym__cairo_1_short_string] = ACTIONS(111),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [sym_self] = ACTIONS(125),
  },
  [14] = {
    [sym__cairo_1_statement] = STATE(15),
    [sym_use_declaration] = STATE(15),
    [sym_extern_type_statement] = STATE(15),
    [sym_extern_function_statement] = STATE(15),
    [sym_attribute_item] = STATE(15),
    [sym_mod_item] = STATE(15),
    [sym_struct_item] = STATE(15),
    [sym_enum_item] = STATE(15),
    [sym_const_item] = STATE(15),
    [sym_type_item] = STATE(15),
    [sym_block] = STATE(97),
    [sym__cairo_1_function_definition] = STATE(315),
    [sym__cairo_1_function_signature] = STATE(316),
    [sym_impl_item] = STATE(15),
    [sym_trait_item] = STATE(15),
    [sym_let_declaration] = STATE(15),
    [sym__cairo_1_generic_function] = STATE(100),
    [sym_generic_type_with_turbofish] = STATE(1827),
    [sym__cairo_1_expression_statement] = STATE(15),
    [sym__cairo_1_expression] = STATE(172),
    [sym__cairo_1_return_expression] = STATE(97),
    [sym__cairo_1_if_expression] = STATE(101),
    [sym_match_expression] = STATE(97),
    [sym__cairo_1_loop_expression] = STATE(102),
    [sym__cairo_1_at_expression] = STATE(97),
    [sym__cairo_1_unary_expression] = STATE(97),
    [sym__cairo_1_binary_expression] = STATE(103),
    [sym__cairo_1_assignment_expression] = STATE(104),
    [sym__cairo_1_compound_assignment_expression] = STATE(105),
    [sym__cairo_1_try_expression] = STATE(97),
    [sym__cairo_1_call_expression] = STATE(106),
    [sym__cairo_1_index_expression] = STATE(97),
    [sym__cairo_1_field_expression] = STATE(107),
    [sym__cairo_1_parenthesized_expression] = STATE(97),
    [sym__cairo_1_tuple_expression] = STATE(97),
    [sym__cairo_1_unit_expression] = STATE(97),
    [sym__cairo_1_struct_expression] = STATE(108),
    [sym__literal] = STATE(97),
    [sym_scoped_identifier] = STATE(109),
    [sym_boolean] = STATE(97),
    [aux_sym_block_repeat1] = STATE(15),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_AT] = ACTIONS(99),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(292),
    [anon_sym_struct] = ACTIONS(242),
    [anon_sym_let] = ACTIONS(244),
    [anon_sym_const] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_return] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_DASH] = ACTIONS(109),
    [sym_number] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(248),
    [anon_sym_extern] = ACTIONS(250),
    [anon_sym_type] = ACTIONS(252),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [anon_sym_fn] = ACTIONS(254),
    [anon_sym_POUND] = ACTIONS(256),
    [anon_sym_mod] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(260),
    [anon_sym_impl] = ACTIONS(262),
    [anon_sym_trait] = ACTIONS(264),
    [anon_sym_u8] = ACTIONS(115),
    [anon_sym_i8] = ACTIONS(115),
    [anon_sym_u16] = ACTIONS(115),
    [anon_sym_i16] = ACTIONS(115),
    [anon_sym_u32] = ACTIONS(115),
    [anon_sym_i32] = ACTIONS(115),
    [anon_sym_u64] = ACTIONS(115),
    [anon_sym_i64] = ACTIONS(115),
    [anon_sym_u128] = ACTIONS(115),
    [anon_sym_i128] = ACTIONS(115),
    [anon_sym_u256] = ACTIONS(115),
    [anon_sym_i256] = ACTIONS(115),
    [anon_sym_isize] = ACTIONS(115),
    [anon_sym_usize] = ACTIONS(115),
    [anon_sym_f32] = ACTIONS(115),
    [anon_sym_f64] = ACTIONS(115),
    [anon_sym_felt252] = ACTIONS(115),
    [anon_sym_bool] = ACTIONS(115),
    [anon_sym_str] = ACTIONS(115),
    [anon_sym_char] = ACTIONS(115),
    [anon_sym_match] = ACTIONS(117),
    [anon_sym_loop] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [sym__cairo_1_short_string] = ACTIONS(111),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [sym_self] = ACTIONS(125),
  },
  [15] = {
    [sym__cairo_1_statement] = STATE(4),
    [sym_use_declaration] = STATE(4),
    [sym_extern_type_statement] = STATE(4),
    [sym_extern_function_statement] = STATE(4),
    [sym_attribute_item] = STATE(4),
    [sym_mod_item] = STATE(4),
    [sym_struct_item] = STATE(4),
    [sym_enum_item] = STATE(4),
    [sym_const_item] = STATE(4),
    [sym_type_item] = STATE(4),
    [sym_block] = STATE(97),
    [sym__cairo_1_function_definition] = STATE(315),
    [sym__cairo_1_function_signature] = STATE(316),
    [sym_impl_item] = STATE(4),
    [sym_trait_item] = STATE(4),
    [sym_let_declaration] = STATE(4),
    [sym__cairo_1_generic_function] = STATE(100),
    [sym_generic_type_with_turbofish] = STATE(1827),
    [sym__cairo_1_expression_statement] = STATE(4),
    [sym__cairo_1_expression] = STATE(172),
    [sym__cairo_1_return_expression] = STATE(97),
    [sym__cairo_1_if_expression] = STATE(101),
    [sym_match_expression] = STATE(97),
    [sym__cairo_1_loop_expression] = STATE(102),
    [sym__cairo_1_at_expression] = STATE(97),
    [sym__cairo_1_unary_expression] = STATE(97),
    [sym__cairo_1_binary_expression] = STATE(103),
    [sym__cairo_1_assignment_expression] = STATE(104),
    [sym__cairo_1_compound_assignment_expression] = STATE(105),
    [sym__cairo_1_try_expression] = STATE(97),
    [sym__cairo_1_call_expression] = STATE(106),
    [sym__cairo_1_index_expression] = STATE(97),
    [sym__cairo_1_field_expression] = STATE(107),
    [sym__cairo_1_parenthesized_expression] = STATE(97),
    [sym__cairo_1_tuple_expression] = STATE(97),
    [sym__cairo_1_unit_expression] = STATE(97),
    [sym__cairo_1_struct_expression] = STATE(108),
    [sym__literal] = STATE(97),
    [sym_scoped_identifier] = STATE(109),
    [sym_boolean] = STATE(97),
    [aux_sym_block_repeat1] = STATE(4),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(95),
    [anon_sym_AT] = ACTIONS(99),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(294),
    [anon_sym_struct] = ACTIONS(242),
    [anon_sym_let] = ACTIONS(244),
    [anon_sym_const] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_return] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(121),
    [anon_sym_DASH] = ACTIONS(109),
    [sym_number] = ACTIONS(111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(248),
    [anon_sym_extern] = ACTIONS(250),
    [anon_sym_type] = ACTIONS(252),
    [anon_sym_COLON_COLON] = ACTIONS(113),
    [anon_sym_fn] = ACTIONS(254),
    [anon_sym_POUND] = ACTIONS(256),
    [anon_sym_mod] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(260),
    [anon_sym_impl] = ACTIONS(262),
    [anon_sym_trait] = ACTIONS(264),
    [anon_sym_u8] = ACTIONS(115),
    [anon_sym_i8] = ACTIONS(115),
    [anon_sym_u16] = ACTIONS(115),
    [anon_sym_i16] = ACTIONS(115),
    [anon_sym_u32] = ACTIONS(115),
    [anon_sym_i32] = ACTIONS(115),
    [anon_sym_u64] = ACTIONS(115),
    [anon_sym_i64] = ACTIONS(115),
    [anon_sym_u128] = ACTIONS(115),
    [anon_sym_i128] = ACTIONS(115),
    [anon_sym_u256] = ACTIONS(115),
    [anon_sym_i256] = ACTIONS(115),
    [anon_sym_isize] = ACTIONS(115),
    [anon_sym_usize] = ACTIONS(115),
    [anon_sym_f32] = ACTIONS(115),
    [anon_sym_f64] = ACTIONS(115),
    [anon_sym_felt252] = ACTIONS(115),
    [anon_sym_bool] = ACTIONS(115),
    [anon_sym_str] = ACTIONS(115),
    [anon_sym_char] = ACTIONS(115),
    [anon_sym_match] = ACTIONS(117),
    [anon_sym_loop] = ACTIONS(119),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_TILDE] = ACTIONS(121),
    [sym__cairo_1_short_string] = ACTIONS(111),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [sym_self] = ACTIONS(125),
  },
  [16] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(296),
    [anon_sym_from] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_using] = ACTIONS(305),
    [anon_sym_PERCENTbuiltins] = ACTIONS(308),
    [anon_sym_PERCENTlang] = ACTIONS(311),
    [anon_sym_AT] = ACTIONS(314),
    [anon_sym_namespace] = ACTIONS(317),
    [anon_sym_RBRACE] = ACTIONS(320),
    [anon_sym_struct] = ACTIONS(322),
    [anon_sym_func] = ACTIONS(325),
    [anon_sym_end] = ACTIONS(328),
    [anon_sym_alloc_locals] = ACTIONS(330),
    [anon_sym_assert] = ACTIONS(333),
    [anon_sym_static_assert] = ACTIONS(336),
    [anon_sym_let] = ACTIONS(339),
    [anon_sym_const] = ACTIONS(342),
    [anon_sym_local] = ACTIONS(345),
    [anon_sym_tempvar] = ACTIONS(348),
    [anon_sym_ap] = ACTIONS(351),
    [anon_sym_jmp] = ACTIONS(354),
    [anon_sym_if] = ACTIONS(357),
    [sym_inst_ret] = ACTIONS(360),
    [anon_sym_dw] = ACTIONS(363),
    [anon_sym_with_attr] = ACTIONS(366),
    [anon_sym_with] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(372),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_DASH] = ACTIONS(378),
    [anon_sym_new] = ACTIONS(378),
    [sym_short_string] = ACTIONS(381),
    [anon_sym_nondet] = ACTIONS(384),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(387),
    [anon_sym_fp] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(393),
    [anon_sym_cast] = ACTIONS(396),
    [anon_sym_call] = ACTIONS(399),
    [sym_number] = ACTIONS(381),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__cairo_0_statement] = STATE(72),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(72),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(414),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__cairo_0_statement] = STATE(26),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(26),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(448),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__cairo_0_statement] = STATE(27),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(27),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(450),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(452),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(454),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(456),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym__cairo_0_statement] = STATE(31),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(31),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(458),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym__cairo_0_statement] = STATE(32),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(32),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(460),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [25] = {
    [sym__cairo_0_statement] = STATE(79),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(79),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(462),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(464),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(466),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym__cairo_0_statement] = STATE(33),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(33),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(466),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym__cairo_0_statement] = STATE(34),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(34),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(468),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym__cairo_0_statement] = STATE(35),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(35),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(470),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(472),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(474),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [33] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(476),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [34] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(478),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(480),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym__cairo_0_statement] = STATE(37),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(37),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(482),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(484),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [38] = {
    [sym__cairo_0_statement] = STATE(39),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(39),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(484),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [39] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(488),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [sym__cairo_0_statement] = STATE(83),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(83),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(490),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym__cairo_0_statement] = STATE(45),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(45),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(492),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym__cairo_0_statement] = STATE(50),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(50),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(494),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [44] = {
    [sym__cairo_0_statement] = STATE(86),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(86),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(496),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(498),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym__cairo_0_statement] = STATE(54),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(54),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(500),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym__cairo_0_statement] = STATE(55),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(55),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(502),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [48] = {
    [sym__cairo_0_statement] = STATE(84),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(84),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(504),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [sym__cairo_0_statement] = STATE(49),
    [sym__cairo_0_import_statement] = STATE(631),
    [sym_type_definition] = STATE(628),
    [sym_builtin_directive] = STATE(628),
    [sym_lang_directive] = STATE(628),
    [sym__cairo_0_decorated_definition] = STATE(629),
    [sym_decorator] = STATE(1095),
    [sym__cairo_0_namespace_definition] = STATE(628),
    [sym__cairo_0_struct_definition] = STATE(628),
    [sym__cairo_0_function_definition] = STATE(628),
    [sym__cairo_0_expression_statement] = STATE(628),
    [sym_alloc_locals] = STATE(628),
    [sym__cairo_0_assert_statement] = STATE(628),
    [sym__cairo_0_static_assert_statement] = STATE(628),
    [sym__cairo_0_let_binding] = STATE(650),
    [sym_const_var_declaration] = STATE(628),
    [sym_local_var_declaration] = STATE(628),
    [sym_temp_var_declaration] = STATE(628),
    [sym_instruction] = STATE(628),
    [sym_inst_assert_eq] = STATE(1262),
    [sym_inst_jmp_rel] = STATE(1262),
    [sym_inst_jmp_abs] = STATE(1262),
    [sym_inst_jmp_to_label] = STATE(1262),
    [sym_inst_jnz] = STATE(1262),
    [sym_inst_jnz_to_label] = STATE(1262),
    [sym_inst_add_ap] = STATE(1262),
    [sym_inst_data_word] = STATE(1262),
    [sym_label] = STATE(628),
    [sym__cairo_0_attribute_statement] = STATE(628),
    [sym__cairo_0_if_statement] = STATE(628),
    [sym__cairo_0_with_statement] = STATE(628),
    [sym__cairo_0_return_statement] = STATE(628),
    [sym__cairo_0_expression] = STATE(905),
    [sym_unary_expression] = STATE(905),
    [sym_binary_expression] = STATE(905),
    [sym_assignment_expression] = STATE(905),
    [sym_hint_expression] = STATE(905),
    [sym_hint] = STATE(628),
    [sym_register] = STATE(905),
    [sym_deref_expression] = STATE(905),
    [sym_subscript_expression] = STATE(905),
    [sym_member_expression] = STATE(905),
    [sym_cast_expression] = STATE(905),
    [sym_tuple_expression] = STATE(905),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1262),
    [aux_sym_cairo_0_file_repeat1] = STATE(49),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1095),
    [ts_builtin_sym_end] = ACTIONS(320),
    [sym_identifier] = ACTIONS(506),
    [anon_sym_from] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_using] = ACTIONS(512),
    [anon_sym_PERCENTbuiltins] = ACTIONS(515),
    [anon_sym_PERCENTlang] = ACTIONS(518),
    [anon_sym_AT] = ACTIONS(314),
    [anon_sym_namespace] = ACTIONS(521),
    [anon_sym_struct] = ACTIONS(524),
    [anon_sym_func] = ACTIONS(527),
    [anon_sym_alloc_locals] = ACTIONS(530),
    [anon_sym_assert] = ACTIONS(533),
    [anon_sym_static_assert] = ACTIONS(536),
    [anon_sym_let] = ACTIONS(539),
    [anon_sym_const] = ACTIONS(542),
    [anon_sym_local] = ACTIONS(545),
    [anon_sym_tempvar] = ACTIONS(548),
    [anon_sym_ap] = ACTIONS(351),
    [anon_sym_jmp] = ACTIONS(354),
    [anon_sym_if] = ACTIONS(551),
    [sym_inst_ret] = ACTIONS(554),
    [anon_sym_dw] = ACTIONS(363),
    [anon_sym_with_attr] = ACTIONS(557),
    [anon_sym_with] = ACTIONS(560),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_DASH] = ACTIONS(378),
    [anon_sym_new] = ACTIONS(378),
    [sym_short_string] = ACTIONS(566),
    [anon_sym_nondet] = ACTIONS(384),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(569),
    [anon_sym_fp] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(393),
    [anon_sym_cast] = ACTIONS(396),
    [anon_sym_call] = ACTIONS(399),
    [sym_number] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(572),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym__cairo_0_statement] = STATE(59),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(59),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(574),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym__cairo_0_statement] = STATE(60),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(60),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(576),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym__cairo_0_statement] = STATE(61),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(61),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(578),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(576),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [55] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(578),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym__cairo_0_statement] = STATE(40),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(40),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(580),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [57] = {
    [sym__cairo_0_statement] = STATE(64),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(64),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(582),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym__cairo_0_statement] = STATE(65),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(65),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(584),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(586),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(588),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(590),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym__cairo_0_statement] = STATE(69),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(69),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(592),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym__cairo_0_statement] = STATE(70),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(70),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(594),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(596),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [65] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(598),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym__cairo_0_statement] = STATE(71),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(71),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(598),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [sym__cairo_0_statement] = STATE(73),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(73),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(600),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [68] = {
    [sym__cairo_0_statement] = STATE(74),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(74),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(602),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(604),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [70] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(606),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(608),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(610),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [73] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(612),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(614),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym__cairo_0_statement] = STATE(76),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(76),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(616),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(618),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [sym__cairo_0_statement] = STATE(78),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(78),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(618),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(622),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym__cairo_0_statement] = STATE(20),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(20),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(622),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [sym__cairo_0_statement] = STATE(21),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(21),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(624),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [sym__cairo_0_statement] = STATE(22),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(22),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(626),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(624),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [84] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_end] = ACTIONS(626),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [sym__cairo_0_statement] = STATE(49),
    [sym__cairo_0_import_statement] = STATE(631),
    [sym_type_definition] = STATE(628),
    [sym_builtin_directive] = STATE(628),
    [sym_lang_directive] = STATE(628),
    [sym__cairo_0_decorated_definition] = STATE(629),
    [sym_decorator] = STATE(1095),
    [sym__cairo_0_namespace_definition] = STATE(628),
    [sym__cairo_0_struct_definition] = STATE(628),
    [sym__cairo_0_function_definition] = STATE(628),
    [sym__cairo_0_expression_statement] = STATE(628),
    [sym_alloc_locals] = STATE(628),
    [sym__cairo_0_assert_statement] = STATE(628),
    [sym__cairo_0_static_assert_statement] = STATE(628),
    [sym__cairo_0_let_binding] = STATE(650),
    [sym_const_var_declaration] = STATE(628),
    [sym_local_var_declaration] = STATE(628),
    [sym_temp_var_declaration] = STATE(628),
    [sym_instruction] = STATE(628),
    [sym_inst_assert_eq] = STATE(1262),
    [sym_inst_jmp_rel] = STATE(1262),
    [sym_inst_jmp_abs] = STATE(1262),
    [sym_inst_jmp_to_label] = STATE(1262),
    [sym_inst_jnz] = STATE(1262),
    [sym_inst_jnz_to_label] = STATE(1262),
    [sym_inst_add_ap] = STATE(1262),
    [sym_inst_data_word] = STATE(1262),
    [sym_label] = STATE(628),
    [sym__cairo_0_attribute_statement] = STATE(628),
    [sym__cairo_0_if_statement] = STATE(628),
    [sym__cairo_0_with_statement] = STATE(628),
    [sym__cairo_0_return_statement] = STATE(628),
    [sym__cairo_0_expression] = STATE(905),
    [sym_unary_expression] = STATE(905),
    [sym_binary_expression] = STATE(905),
    [sym_assignment_expression] = STATE(905),
    [sym_hint_expression] = STATE(905),
    [sym_hint] = STATE(628),
    [sym_register] = STATE(905),
    [sym_deref_expression] = STATE(905),
    [sym_subscript_expression] = STATE(905),
    [sym_member_expression] = STATE(905),
    [sym_cast_expression] = STATE(905),
    [sym_tuple_expression] = STATE(905),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1262),
    [aux_sym_cairo_0_file_repeat1] = STATE(49),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1095),
    [ts_builtin_sym_end] = ACTIONS(628),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_from] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(13),
    [anon_sym_PERCENTbuiltins] = ACTIONS(15),
    [anon_sym_PERCENTlang] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_struct] = ACTIONS(630),
    [anon_sym_func] = ACTIONS(25),
    [anon_sym_alloc_locals] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_static_assert] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(632),
    [anon_sym_const] = ACTIONS(634),
    [anon_sym_local] = ACTIONS(37),
    [anon_sym_tempvar] = ACTIONS(39),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [sym_inst_ret] = ACTIONS(47),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(61),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(65),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym__cairo_0_statement] = STATE(16),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym_cairo_0_file_repeat1] = STATE(16),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_RBRACE] = ACTIONS(574),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym__cairo_1_else_clause] = STATE(137),
    [sym_identifier] = ACTIONS(636),
    [anon_sym_LPAREN] = ACTIONS(638),
    [anon_sym_EQ] = ACTIONS(636),
    [anon_sym_AT] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(638),
    [anon_sym_RBRACE] = ACTIONS(638),
    [anon_sym_struct] = ACTIONS(636),
    [anon_sym_EQ_EQ] = ACTIONS(638),
    [anon_sym_let] = ACTIONS(636),
    [anon_sym_const] = ACTIONS(636),
    [anon_sym_if] = ACTIONS(636),
    [anon_sym_BANG_EQ] = ACTIONS(638),
    [anon_sym_PLUS_EQ] = ACTIONS(638),
    [anon_sym_else] = ACTIONS(640),
    [anon_sym_return] = ACTIONS(636),
    [anon_sym_STAR] = ACTIONS(636),
    [anon_sym_AMP] = ACTIONS(636),
    [anon_sym_DASH] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_DOT] = ACTIONS(638),
    [sym_number] = ACTIONS(638),
    [anon_sym_SEMI] = ACTIONS(638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(636),
    [anon_sym_extern] = ACTIONS(636),
    [anon_sym_type] = ACTIONS(636),
    [anon_sym_COLON_COLON] = ACTIONS(638),
    [anon_sym_fn] = ACTIONS(636),
    [anon_sym_POUND] = ACTIONS(638),
    [anon_sym_mod] = ACTIONS(636),
    [anon_sym_enum] = ACTIONS(636),
    [anon_sym_impl] = ACTIONS(636),
    [anon_sym_trait] = ACTIONS(636),
    [anon_sym_u8] = ACTIONS(636),
    [anon_sym_i8] = ACTIONS(636),
    [anon_sym_u16] = ACTIONS(636),
    [anon_sym_i16] = ACTIONS(636),
    [anon_sym_u32] = ACTIONS(636),
    [anon_sym_i32] = ACTIONS(636),
    [anon_sym_u64] = ACTIONS(636),
    [anon_sym_i64] = ACTIONS(636),
    [anon_sym_u128] = ACTIONS(636),
    [anon_sym_i128] = ACTIONS(636),
    [anon_sym_u256] = ACTIONS(636),
    [anon_sym_i256] = ACTIONS(636),
    [anon_sym_isize] = ACTIONS(636),
    [anon_sym_usize] = ACTIONS(636),
    [anon_sym_f32] = ACTIONS(636),
    [anon_sym_f64] = ACTIONS(636),
    [anon_sym_felt252] = ACTIONS(636),
    [anon_sym_bool] = ACTIONS(636),
    [anon_sym_str] = ACTIONS(636),
    [anon_sym_char] = ACTIONS(636),
    [anon_sym_GT] = ACTIONS(636),
    [anon_sym_match] = ACTIONS(636),
    [anon_sym_loop] = ACTIONS(636),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_TILDE] = ACTIONS(638),
    [anon_sym_AMP_AMP] = ACTIONS(638),
    [anon_sym_PIPE_PIPE] = ACTIONS(638),
    [anon_sym_PIPE] = ACTIONS(636),
    [anon_sym_CARET] = ACTIONS(636),
    [anon_sym_LT2] = ACTIONS(636),
    [anon_sym_LT_EQ] = ACTIONS(638),
    [anon_sym_GT_EQ] = ACTIONS(638),
    [anon_sym_LT_LT] = ACTIONS(636),
    [anon_sym_GT_GT] = ACTIONS(636),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_DASH_EQ] = ACTIONS(638),
    [anon_sym_STAR_EQ] = ACTIONS(638),
    [anon_sym_SLASH_EQ] = ACTIONS(638),
    [anon_sym_PERCENT_EQ] = ACTIONS(638),
    [anon_sym_AMP_EQ] = ACTIONS(638),
    [anon_sym_PIPE_EQ] = ACTIONS(638),
    [anon_sym_CARET_EQ] = ACTIONS(638),
    [anon_sym_LT_LT_EQ] = ACTIONS(638),
    [anon_sym_GT_GT_EQ] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(638),
    [sym__cairo_1_short_string] = ACTIONS(638),
    [anon_sym_true] = ACTIONS(636),
    [anon_sym_false] = ACTIONS(636),
    [sym_self] = ACTIONS(636),
  },
  [88] = {
    [sym_identifier] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(644),
    [anon_sym_EQ] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_RBRACE] = ACTIONS(644),
    [anon_sym_struct] = ACTIONS(642),
    [anon_sym_EQ_EQ] = ACTIONS(644),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_BANG_EQ] = ACTIONS(644),
    [anon_sym_PLUS_EQ] = ACTIONS(644),
    [anon_sym_else] = ACTIONS(642),
    [anon_sym_return] = ACTIONS(642),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_AMP] = ACTIONS(642),
    [anon_sym_DASH] = ACTIONS(642),
    [anon_sym_PLUS] = ACTIONS(642),
    [anon_sym_SLASH] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(644),
    [anon_sym_DOT] = ACTIONS(644),
    [sym_number] = ACTIONS(644),
    [anon_sym_SEMI] = ACTIONS(644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(642),
    [anon_sym_extern] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(642),
    [anon_sym_COLON_COLON] = ACTIONS(644),
    [anon_sym_fn] = ACTIONS(642),
    [anon_sym_POUND] = ACTIONS(644),
    [anon_sym_mod] = ACTIONS(642),
    [anon_sym_enum] = ACTIONS(642),
    [anon_sym_impl] = ACTIONS(642),
    [anon_sym_trait] = ACTIONS(642),
    [anon_sym_u8] = ACTIONS(642),
    [anon_sym_i8] = ACTIONS(642),
    [anon_sym_u16] = ACTIONS(642),
    [anon_sym_i16] = ACTIONS(642),
    [anon_sym_u32] = ACTIONS(642),
    [anon_sym_i32] = ACTIONS(642),
    [anon_sym_u64] = ACTIONS(642),
    [anon_sym_i64] = ACTIONS(642),
    [anon_sym_u128] = ACTIONS(642),
    [anon_sym_i128] = ACTIONS(642),
    [anon_sym_u256] = ACTIONS(642),
    [anon_sym_i256] = ACTIONS(642),
    [anon_sym_isize] = ACTIONS(642),
    [anon_sym_usize] = ACTIONS(642),
    [anon_sym_f32] = ACTIONS(642),
    [anon_sym_f64] = ACTIONS(642),
    [anon_sym_felt252] = ACTIONS(642),
    [anon_sym_bool] = ACTIONS(642),
    [anon_sym_str] = ACTIONS(642),
    [anon_sym_char] = ACTIONS(642),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_match] = ACTIONS(642),
    [anon_sym_loop] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_TILDE] = ACTIONS(644),
    [anon_sym_AMP_AMP] = ACTIONS(644),
    [anon_sym_PIPE_PIPE] = ACTIONS(644),
    [anon_sym_PIPE] = ACTIONS(642),
    [anon_sym_CARET] = ACTIONS(642),
    [anon_sym_LT2] = ACTIONS(642),
    [anon_sym_LT_EQ] = ACTIONS(644),
    [anon_sym_GT_EQ] = ACTIONS(644),
    [anon_sym_LT_LT] = ACTIONS(642),
    [anon_sym_GT_GT] = ACTIONS(642),
    [anon_sym_PERCENT] = ACTIONS(642),
    [anon_sym_DASH_EQ] = ACTIONS(644),
    [anon_sym_STAR_EQ] = ACTIONS(644),
    [anon_sym_SLASH_EQ] = ACTIONS(644),
    [anon_sym_PERCENT_EQ] = ACTIONS(644),
    [anon_sym_AMP_EQ] = ACTIONS(644),
    [anon_sym_PIPE_EQ] = ACTIONS(644),
    [anon_sym_CARET_EQ] = ACTIONS(644),
    [anon_sym_LT_LT_EQ] = ACTIONS(644),
    [anon_sym_GT_GT_EQ] = ACTIONS(644),
    [anon_sym_QMARK] = ACTIONS(644),
    [sym__cairo_1_short_string] = ACTIONS(644),
    [anon_sym_true] = ACTIONS(642),
    [anon_sym_false] = ACTIONS(642),
    [sym_self] = ACTIONS(642),
  },
  [89] = {
    [sym_identifier] = ACTIONS(646),
    [anon_sym_LPAREN] = ACTIONS(648),
    [anon_sym_EQ] = ACTIONS(646),
    [anon_sym_AT] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(648),
    [anon_sym_RBRACE] = ACTIONS(648),
    [anon_sym_struct] = ACTIONS(646),
    [anon_sym_EQ_EQ] = ACTIONS(648),
    [anon_sym_let] = ACTIONS(646),
    [anon_sym_const] = ACTIONS(646),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_BANG_EQ] = ACTIONS(648),
    [anon_sym_PLUS_EQ] = ACTIONS(648),
    [anon_sym_else] = ACTIONS(646),
    [anon_sym_return] = ACTIONS(646),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_AMP] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(646),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_SLASH] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(648),
    [anon_sym_DOT] = ACTIONS(648),
    [sym_number] = ACTIONS(648),
    [anon_sym_SEMI] = ACTIONS(648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(646),
    [anon_sym_extern] = ACTIONS(646),
    [anon_sym_type] = ACTIONS(646),
    [anon_sym_COLON_COLON] = ACTIONS(648),
    [anon_sym_fn] = ACTIONS(646),
    [anon_sym_POUND] = ACTIONS(648),
    [anon_sym_mod] = ACTIONS(646),
    [anon_sym_enum] = ACTIONS(646),
    [anon_sym_impl] = ACTIONS(646),
    [anon_sym_trait] = ACTIONS(646),
    [anon_sym_u8] = ACTIONS(646),
    [anon_sym_i8] = ACTIONS(646),
    [anon_sym_u16] = ACTIONS(646),
    [anon_sym_i16] = ACTIONS(646),
    [anon_sym_u32] = ACTIONS(646),
    [anon_sym_i32] = ACTIONS(646),
    [anon_sym_u64] = ACTIONS(646),
    [anon_sym_i64] = ACTIONS(646),
    [anon_sym_u128] = ACTIONS(646),
    [anon_sym_i128] = ACTIONS(646),
    [anon_sym_u256] = ACTIONS(646),
    [anon_sym_i256] = ACTIONS(646),
    [anon_sym_isize] = ACTIONS(646),
    [anon_sym_usize] = ACTIONS(646),
    [anon_sym_f32] = ACTIONS(646),
    [anon_sym_f64] = ACTIONS(646),
    [anon_sym_felt252] = ACTIONS(646),
    [anon_sym_bool] = ACTIONS(646),
    [anon_sym_str] = ACTIONS(646),
    [anon_sym_char] = ACTIONS(646),
    [anon_sym_GT] = ACTIONS(646),
    [anon_sym_match] = ACTIONS(646),
    [anon_sym_loop] = ACTIONS(646),
    [anon_sym_BANG] = ACTIONS(646),
    [anon_sym_TILDE] = ACTIONS(648),
    [anon_sym_AMP_AMP] = ACTIONS(648),
    [anon_sym_PIPE_PIPE] = ACTIONS(648),
    [anon_sym_PIPE] = ACTIONS(646),
    [anon_sym_CARET] = ACTIONS(646),
    [anon_sym_LT2] = ACTIONS(646),
    [anon_sym_LT_EQ] = ACTIONS(648),
    [anon_sym_GT_EQ] = ACTIONS(648),
    [anon_sym_LT_LT] = ACTIONS(646),
    [anon_sym_GT_GT] = ACTIONS(646),
    [anon_sym_PERCENT] = ACTIONS(646),
    [anon_sym_DASH_EQ] = ACTIONS(648),
    [anon_sym_STAR_EQ] = ACTIONS(648),
    [anon_sym_SLASH_EQ] = ACTIONS(648),
    [anon_sym_PERCENT_EQ] = ACTIONS(648),
    [anon_sym_AMP_EQ] = ACTIONS(648),
    [anon_sym_PIPE_EQ] = ACTIONS(648),
    [anon_sym_CARET_EQ] = ACTIONS(648),
    [anon_sym_LT_LT_EQ] = ACTIONS(648),
    [anon_sym_GT_GT_EQ] = ACTIONS(648),
    [anon_sym_QMARK] = ACTIONS(648),
    [sym__cairo_1_short_string] = ACTIONS(648),
    [anon_sym_true] = ACTIONS(646),
    [anon_sym_false] = ACTIONS(646),
    [sym_self] = ACTIONS(646),
  },
  [90] = {
    [sym__cairo_0_statement] = STATE(574),
    [sym__cairo_0_import_statement] = STATE(559),
    [sym_type_definition] = STATE(571),
    [sym_builtin_directive] = STATE(571),
    [sym_lang_directive] = STATE(571),
    [sym__cairo_0_decorated_definition] = STATE(576),
    [sym_decorator] = STATE(1096),
    [sym__cairo_0_namespace_definition] = STATE(571),
    [sym__cairo_0_struct_definition] = STATE(571),
    [sym__cairo_0_function_definition] = STATE(571),
    [sym__cairo_0_expression_statement] = STATE(571),
    [sym_alloc_locals] = STATE(571),
    [sym__cairo_0_assert_statement] = STATE(571),
    [sym__cairo_0_static_assert_statement] = STATE(571),
    [sym__cairo_0_let_binding] = STATE(577),
    [sym_const_var_declaration] = STATE(571),
    [sym_local_var_declaration] = STATE(571),
    [sym_temp_var_declaration] = STATE(571),
    [sym_instruction] = STATE(571),
    [sym_inst_assert_eq] = STATE(1252),
    [sym_inst_jmp_rel] = STATE(1252),
    [sym_inst_jmp_abs] = STATE(1252),
    [sym_inst_jmp_to_label] = STATE(1252),
    [sym_inst_jnz] = STATE(1252),
    [sym_inst_jnz_to_label] = STATE(1252),
    [sym_inst_add_ap] = STATE(1252),
    [sym_inst_data_word] = STATE(1252),
    [sym_label] = STATE(571),
    [sym__cairo_0_attribute_statement] = STATE(571),
    [sym__cairo_0_if_statement] = STATE(571),
    [sym__cairo_0_with_statement] = STATE(571),
    [sym__cairo_0_return_statement] = STATE(571),
    [sym__cairo_0_expression] = STATE(902),
    [sym_unary_expression] = STATE(902),
    [sym_binary_expression] = STATE(902),
    [sym_assignment_expression] = STATE(902),
    [sym_hint_expression] = STATE(902),
    [sym_hint] = STATE(571),
    [sym_register] = STATE(902),
    [sym_deref_expression] = STATE(902),
    [sym_subscript_expression] = STATE(902),
    [sym_member_expression] = STATE(902),
    [sym_cast_expression] = STATE(902),
    [sym_tuple_expression] = STATE(902),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1252),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1096),
    [sym_identifier] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_PERCENTbuiltins] = ACTIONS(408),
    [anon_sym_PERCENTlang] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(412),
    [anon_sym_struct] = ACTIONS(416),
    [anon_sym_func] = ACTIONS(418),
    [anon_sym_alloc_locals] = ACTIONS(420),
    [anon_sym_assert] = ACTIONS(422),
    [anon_sym_static_assert] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(426),
    [anon_sym_const] = ACTIONS(428),
    [anon_sym_local] = ACTIONS(430),
    [anon_sym_tempvar] = ACTIONS(432),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(434),
    [sym_inst_ret] = ACTIONS(436),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(438),
    [anon_sym_with] = ACTIONS(440),
    [anon_sym_return] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(444),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(446),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(444),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_field_initializer_list] = STATE(115),
    [sym_identifier] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(652),
    [anon_sym_LBRACE] = ACTIONS(654),
    [anon_sym_RBRACE] = ACTIONS(652),
    [anon_sym_struct] = ACTIONS(650),
    [anon_sym_EQ_EQ] = ACTIONS(652),
    [anon_sym_let] = ACTIONS(650),
    [anon_sym_const] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(650),
    [anon_sym_BANG_EQ] = ACTIONS(652),
    [anon_sym_PLUS_EQ] = ACTIONS(652),
    [anon_sym_return] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_LBRACK] = ACTIONS(652),
    [anon_sym_DOT] = ACTIONS(652),
    [sym_number] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(650),
    [anon_sym_extern] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(650),
    [anon_sym_COLON_COLON] = ACTIONS(657),
    [anon_sym_fn] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(652),
    [anon_sym_mod] = ACTIONS(650),
    [anon_sym_enum] = ACTIONS(650),
    [anon_sym_impl] = ACTIONS(650),
    [anon_sym_trait] = ACTIONS(650),
    [anon_sym_u8] = ACTIONS(650),
    [anon_sym_i8] = ACTIONS(650),
    [anon_sym_u16] = ACTIONS(650),
    [anon_sym_i16] = ACTIONS(650),
    [anon_sym_u32] = ACTIONS(650),
    [anon_sym_i32] = ACTIONS(650),
    [anon_sym_u64] = ACTIONS(650),
    [anon_sym_i64] = ACTIONS(650),
    [anon_sym_u128] = ACTIONS(650),
    [anon_sym_i128] = ACTIONS(650),
    [anon_sym_u256] = ACTIONS(650),
    [anon_sym_i256] = ACTIONS(650),
    [anon_sym_isize] = ACTIONS(650),
    [anon_sym_usize] = ACTIONS(650),
    [anon_sym_f32] = ACTIONS(650),
    [anon_sym_f64] = ACTIONS(650),
    [anon_sym_felt252] = ACTIONS(650),
    [anon_sym_bool] = ACTIONS(650),
    [anon_sym_str] = ACTIONS(650),
    [anon_sym_char] = ACTIONS(650),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_match] = ACTIONS(650),
    [anon_sym_loop] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym_LT2] = ACTIONS(650),
    [anon_sym_LT_EQ] = ACTIONS(652),
    [anon_sym_GT_EQ] = ACTIONS(652),
    [anon_sym_LT_LT] = ACTIONS(650),
    [anon_sym_GT_GT] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_DASH_EQ] = ACTIONS(652),
    [anon_sym_STAR_EQ] = ACTIONS(652),
    [anon_sym_SLASH_EQ] = ACTIONS(652),
    [anon_sym_PERCENT_EQ] = ACTIONS(652),
    [anon_sym_AMP_EQ] = ACTIONS(652),
    [anon_sym_PIPE_EQ] = ACTIONS(652),
    [anon_sym_CARET_EQ] = ACTIONS(652),
    [anon_sym_LT_LT_EQ] = ACTIONS(652),
    [anon_sym_GT_GT_EQ] = ACTIONS(652),
    [anon_sym_QMARK] = ACTIONS(652),
    [sym__cairo_1_short_string] = ACTIONS(652),
    [anon_sym_true] = ACTIONS(650),
    [anon_sym_false] = ACTIONS(650),
    [sym_self] = ACTIONS(650),
  },
  [92] = {
    [sym_field_initializer_list] = STATE(116),
    [sym_identifier] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(661),
    [anon_sym_EQ] = ACTIONS(659),
    [anon_sym_AT] = ACTIONS(661),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_RBRACE] = ACTIONS(661),
    [anon_sym_struct] = ACTIONS(659),
    [anon_sym_EQ_EQ] = ACTIONS(661),
    [anon_sym_let] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_BANG_EQ] = ACTIONS(661),
    [anon_sym_PLUS_EQ] = ACTIONS(661),
    [anon_sym_return] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_SLASH] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_DOT] = ACTIONS(661),
    [sym_number] = ACTIONS(661),
    [anon_sym_SEMI] = ACTIONS(661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(659),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_type] = ACTIONS(659),
    [anon_sym_COLON_COLON] = ACTIONS(666),
    [anon_sym_fn] = ACTIONS(659),
    [anon_sym_POUND] = ACTIONS(661),
    [anon_sym_mod] = ACTIONS(659),
    [anon_sym_enum] = ACTIONS(659),
    [anon_sym_impl] = ACTIONS(659),
    [anon_sym_trait] = ACTIONS(659),
    [anon_sym_u8] = ACTIONS(659),
    [anon_sym_i8] = ACTIONS(659),
    [anon_sym_u16] = ACTIONS(659),
    [anon_sym_i16] = ACTIONS(659),
    [anon_sym_u32] = ACTIONS(659),
    [anon_sym_i32] = ACTIONS(659),
    [anon_sym_u64] = ACTIONS(659),
    [anon_sym_i64] = ACTIONS(659),
    [anon_sym_u128] = ACTIONS(659),
    [anon_sym_i128] = ACTIONS(659),
    [anon_sym_u256] = ACTIONS(659),
    [anon_sym_i256] = ACTIONS(659),
    [anon_sym_isize] = ACTIONS(659),
    [anon_sym_usize] = ACTIONS(659),
    [anon_sym_f32] = ACTIONS(659),
    [anon_sym_f64] = ACTIONS(659),
    [anon_sym_felt252] = ACTIONS(659),
    [anon_sym_bool] = ACTIONS(659),
    [anon_sym_str] = ACTIONS(659),
    [anon_sym_char] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(659),
    [anon_sym_match] = ACTIONS(659),
    [anon_sym_loop] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(659),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(661),
    [anon_sym_PIPE_PIPE] = ACTIONS(661),
    [anon_sym_PIPE] = ACTIONS(659),
    [anon_sym_CARET] = ACTIONS(659),
    [anon_sym_LT2] = ACTIONS(659),
    [anon_sym_LT_EQ] = ACTIONS(661),
    [anon_sym_GT_EQ] = ACTIONS(661),
    [anon_sym_LT_LT] = ACTIONS(659),
    [anon_sym_GT_GT] = ACTIONS(659),
    [anon_sym_PERCENT] = ACTIONS(659),
    [anon_sym_DASH_EQ] = ACTIONS(661),
    [anon_sym_STAR_EQ] = ACTIONS(661),
    [anon_sym_SLASH_EQ] = ACTIONS(661),
    [anon_sym_PERCENT_EQ] = ACTIONS(661),
    [anon_sym_AMP_EQ] = ACTIONS(661),
    [anon_sym_PIPE_EQ] = ACTIONS(661),
    [anon_sym_CARET_EQ] = ACTIONS(661),
    [anon_sym_LT_LT_EQ] = ACTIONS(661),
    [anon_sym_GT_GT_EQ] = ACTIONS(661),
    [anon_sym_QMARK] = ACTIONS(661),
    [sym__cairo_1_short_string] = ACTIONS(661),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [sym_self] = ACTIONS(659),
  },
  [93] = {
    [sym__cairo_0_statement] = STATE(603),
    [sym__cairo_0_import_statement] = STATE(631),
    [sym_type_definition] = STATE(628),
    [sym_builtin_directive] = STATE(628),
    [sym_lang_directive] = STATE(628),
    [sym__cairo_0_decorated_definition] = STATE(629),
    [sym_decorator] = STATE(1095),
    [sym__cairo_0_namespace_definition] = STATE(628),
    [sym__cairo_0_struct_definition] = STATE(628),
    [sym__cairo_0_function_definition] = STATE(628),
    [sym__cairo_0_expression_statement] = STATE(628),
    [sym_alloc_locals] = STATE(628),
    [sym__cairo_0_assert_statement] = STATE(628),
    [sym__cairo_0_static_assert_statement] = STATE(628),
    [sym__cairo_0_let_binding] = STATE(650),
    [sym_const_var_declaration] = STATE(628),
    [sym_local_var_declaration] = STATE(628),
    [sym_temp_var_declaration] = STATE(628),
    [sym_instruction] = STATE(628),
    [sym_inst_assert_eq] = STATE(1262),
    [sym_inst_jmp_rel] = STATE(1262),
    [sym_inst_jmp_abs] = STATE(1262),
    [sym_inst_jmp_to_label] = STATE(1262),
    [sym_inst_jnz] = STATE(1262),
    [sym_inst_jnz_to_label] = STATE(1262),
    [sym_inst_add_ap] = STATE(1262),
    [sym_inst_data_word] = STATE(1262),
    [sym_label] = STATE(628),
    [sym__cairo_0_attribute_statement] = STATE(628),
    [sym__cairo_0_if_statement] = STATE(628),
    [sym__cairo_0_with_statement] = STATE(628),
    [sym__cairo_0_return_statement] = STATE(628),
    [sym__cairo_0_expression] = STATE(905),
    [sym_unary_expression] = STATE(905),
    [sym_binary_expression] = STATE(905),
    [sym_assignment_expression] = STATE(905),
    [sym_hint_expression] = STATE(905),
    [sym_hint] = STATE(628),
    [sym_register] = STATE(905),
    [sym_deref_expression] = STATE(905),
    [sym_subscript_expression] = STATE(905),
    [sym_member_expression] = STATE(905),
    [sym_cast_expression] = STATE(905),
    [sym_tuple_expression] = STATE(905),
    [sym__cairo_0_call_expression] = STATE(906),
    [sym_call_instruction] = STATE(1262),
    [aux_sym__cairo_0_decorated_definition_repeat1] = STATE(1095),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_from] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_using] = ACTIONS(13),
    [anon_sym_PERCENTbuiltins] = ACTIONS(15),
    [anon_sym_PERCENTlang] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_struct] = ACTIONS(630),
    [anon_sym_func] = ACTIONS(25),
    [anon_sym_alloc_locals] = ACTIONS(27),
    [anon_sym_assert] = ACTIONS(29),
    [anon_sym_static_assert] = ACTIONS(31),
    [anon_sym_let] = ACTIONS(632),
    [anon_sym_const] = ACTIONS(634),
    [anon_sym_local] = ACTIONS(37),
    [anon_sym_tempvar] = ACTIONS(39),
    [anon_sym_ap] = ACTIONS(41),
    [anon_sym_jmp] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(45),
    [sym_inst_ret] = ACTIONS(47),
    [anon_sym_dw] = ACTIONS(49),
    [anon_sym_with_attr] = ACTIONS(51),
    [anon_sym_with] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(59),
    [anon_sym_new] = ACTIONS(59),
    [sym_short_string] = ACTIONS(61),
    [anon_sym_nondet] = ACTIONS(63),
    [anon_sym_PERCENT_LBRACE] = ACTIONS(65),
    [anon_sym_fp] = ACTIONS(67),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_cast] = ACTIONS(71),
    [anon_sym_call] = ACTIONS(73),
    [sym_number] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_identifier] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(672),
    [anon_sym_struct] = ACTIONS(668),
    [anon_sym_EQ_EQ] = ACTIONS(672),
    [anon_sym_let] = ACTIONS(668),
    [anon_sym_const] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(672),
    [anon_sym_PLUS_EQ] = ACTIONS(672),
    [anon_sym_return] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [sym_number] = ACTIONS(672),
    [anon_sym_SEMI] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(668),
    [anon_sym_extern] = ACTIONS(668),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [anon_sym_fn] = ACTIONS(668),
    [anon_sym_POUND] = ACTIONS(672),
    [anon_sym_mod] = ACTIONS(668),
    [anon_sym_enum] = ACTIONS(668),
    [anon_sym_impl] = ACTIONS(668),
    [anon_sym_trait] = ACTIONS(668),
    [anon_sym_u8] = ACTIONS(668),
    [anon_sym_i8] = ACTIONS(668),
    [anon_sym_u16] = ACTIONS(668),
    [anon_sym_i16] = ACTIONS(668),
    [anon_sym_u32] = ACTIONS(668),
    [anon_sym_i32] = ACTIONS(668),
    [anon_sym_u64] = ACTIONS(668),
    [anon_sym_i64] = ACTIONS(668),
    [anon_sym_u128] = ACTIONS(668),
    [anon_sym_i128] = ACTIONS(668),
    [anon_sym_u256] = ACTIONS(668),
    [anon_sym_i256] = ACTIONS(668),
    [anon_sym_isize] = ACTIONS(668),
    [anon_sym_usize] = ACTIONS(668),
    [anon_sym_f32] = ACTIONS(668),
    [anon_sym_f64] = ACTIONS(668),
    [anon_sym_felt252] = ACTIONS(668),
    [anon_sym_bool] = ACTIONS(668),
    [anon_sym_str] = ACTIONS(668),
    [anon_sym_char] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_match] = ACTIONS(668),
    [anon_sym_loop] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(672),
    [anon_sym_AMP_AMP] = ACTIONS(672),
    [anon_sym_PIPE_PIPE] = ACTIONS(672),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(668),
    [anon_sym_LT2] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_DASH_EQ] = ACTIONS(672),
    [anon_sym_STAR_EQ] = ACTIONS(672),
    [anon_sym_SLASH_EQ] = ACTIONS(672),
    [anon_sym_PERCENT_EQ] = ACTIONS(672),
    [anon_sym_AMP_EQ] = ACTIONS(672),
    [anon_sym_PIPE_EQ] = ACTIONS(672),
    [anon_sym_CARET_EQ] = ACTIONS(672),
    [anon_sym_LT_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_GT_EQ] = ACTIONS(672),
    [anon_sym_QMARK] = ACTIONS(672),
    [sym__cairo_1_short_string] = ACTIONS(672),
    [anon_sym_true] = ACTIONS(668),
    [anon_sym_false] = ACTIONS(668),
    [sym_self] = ACTIONS(668),
  },
  [95] = {
    [sym_identifier] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(682),
    [anon_sym_EQ] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(682),
    [anon_sym_RBRACE] = ACTIONS(682),
    [anon_sym_struct] = ACTIONS(680),
    [anon_sym_EQ_EQ] = ACTIONS(682),
    [anon_sym_let] = ACTIONS(680),
    [anon_sym_const] = ACTIONS(680),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_BANG_EQ] = ACTIONS(682),
    [anon_sym_PLUS_EQ] = ACTIONS(682),
    [anon_sym_return] = ACTIONS(680),
    [anon_sym_STAR] = ACTIONS(680),
    [anon_sym_AMP] = ACTIONS(680),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_SLASH] = ACTIONS(680),
    [anon_sym_LBRACK] = ACTIONS(682),
    [anon_sym_DOT] = ACTIONS(682),
    [sym_number] = ACTIONS(682),
    [anon_sym_SEMI] = ACTIONS(682),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(680),
    [anon_sym_extern] = ACTIONS(680),
    [anon_sym_type] = ACTIONS(680),
    [anon_sym_COLON_COLON] = ACTIONS(682),
    [anon_sym_fn] = ACTIONS(680),
    [anon_sym_POUND] = ACTIONS(682),
    [anon_sym_mod] = ACTIONS(680),
    [anon_sym_enum] = ACTIONS(680),
    [anon_sym_impl] = ACTIONS(680),
    [anon_sym_trait] = ACTIONS(680),
    [anon_sym_u8] = ACTIONS(680),
    [anon_sym_i8] = ACTIONS(680),
    [anon_sym_u16] = ACTIONS(680),
    [anon_sym_i16] = ACTIONS(680),
    [anon_sym_u32] = ACTIONS(680),
    [anon_sym_i32] = ACTIONS(680),
    [anon_sym_u64] = ACTIONS(680),
    [anon_sym_i64] = ACTIONS(680),
    [anon_sym_u128] = ACTIONS(680),
    [anon_sym_i128] = ACTIONS(680),
    [anon_sym_u256] = ACTIONS(680),
    [anon_sym_i256] = ACTIONS(680),
    [anon_sym_isize] = ACTIONS(680),
    [anon_sym_usize] = ACTIONS(680),
    [anon_sym_f32] = ACTIONS(680),
    [anon_sym_f64] = ACTIONS(680),
    [anon_sym_felt252] = ACTIONS(680),
    [anon_sym_bool] = ACTIONS(680),
    [anon_sym_str] = ACTIONS(680),
    [anon_sym_char] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_match] = ACTIONS(680),
    [anon_sym_loop] = ACTIONS(680),
    [anon_sym_BANG] = ACTIONS(680),
    [anon_sym_TILDE] = ACTIONS(682),
    [anon_sym_AMP_AMP] = ACTIONS(682),
    [anon_sym_PIPE_PIPE] = ACTIONS(682),
    [anon_sym_PIPE] = ACTIONS(680),
    [anon_sym_CARET] = ACTIONS(680),
    [anon_sym_LT2] = ACTIONS(680),
    [anon_sym_LT_EQ] = ACTIONS(682),
    [anon_sym_GT_EQ] = ACTIONS(682),
    [anon_sym_LT_LT] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_PERCENT] = ACTIONS(680),
    [anon_sym_DASH_EQ] = ACTIONS(682),
    [anon_sym_STAR_EQ] = ACTIONS(682),
    [anon_sym_SLASH_EQ] = ACTIONS(682),
    [anon_sym_PERCENT_EQ] = ACTIONS(682),
    [anon_sym_AMP_EQ] = ACTIONS(682),
    [anon_sym_PIPE_EQ] = ACTIONS(682),
    [anon_sym_CARET_EQ] = ACTIONS(682),
    [anon_sym_LT_LT_EQ] = ACTIONS(682),
    [anon_sym_GT_GT_EQ] = ACTIONS(682),
    [anon_sym_QMARK] = ACTIONS(682),
    [sym__cairo_1_short_string] = ACTIONS(682),
    [anon_sym_true] = ACTIONS(680),
    [anon_sym_false] = ACTIONS(680),
    [sym_self] = ACTIONS(680),
  },
  [96] = {
    [sym_identifier] = ACTIONS(684),
    [anon_sym_LPAREN] = ACTIONS(686),
    [anon_sym_EQ] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(686),
    [anon_sym_RBRACE] = ACTIONS(686),
    [anon_sym_struct] = ACTIONS(684),
    [anon_sym_EQ_EQ] = ACTIONS(686),
    [anon_sym_let] = ACTIONS(684),
    [anon_sym_const] = ACTIONS(684),
    [anon_sym_if] = ACTIONS(684),
    [anon_sym_BANG_EQ] = ACTIONS(686),
    [anon_sym_PLUS_EQ] = ACTIONS(686),
    [anon_sym_return] = ACTIONS(684),
    [anon_sym_STAR] = ACTIONS(684),
    [anon_sym_AMP] = ACTIONS(684),
    [anon_sym_DASH] = ACTIONS(684),
    [anon_sym_PLUS] = ACTIONS(684),
    [anon_sym_SLASH] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_DOT] = ACTIONS(686),
    [sym_number] = ACTIONS(686),
    [anon_sym_SEMI] = ACTIONS(686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(684),
    [anon_sym_extern] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_COLON_COLON] = ACTIONS(686),
    [anon_sym_fn] = ACTIONS(684),
    [anon_sym_POUND] = ACTIONS(686),
    [anon_sym_mod] = ACTIONS(684),
    [anon_sym_enum] = ACTIONS(684),
    [anon_sym_impl] = ACTIONS(684),
    [anon_sym_trait] = ACTIONS(684),
    [anon_sym_u8] = ACTIONS(684),
    [anon_sym_i8] = ACTIONS(684),
    [anon_sym_u16] = ACTIONS(684),
    [anon_sym_i16] = ACTIONS(684),
    [anon_sym_u32] = ACTIONS(684),
    [anon_sym_i32] = ACTIONS(684),
    [anon_sym_u64] = ACTIONS(684),
    [anon_sym_i64] = ACTIONS(684),
    [anon_sym_u128] = ACTIONS(684),
    [anon_sym_i128] = ACTIONS(684),
    [anon_sym_u256] = ACTIONS(684),
    [anon_sym_i256] = ACTIONS(684),
    [anon_sym_isize] = ACTIONS(684),
    [anon_sym_usize] = ACTIONS(684),
    [anon_sym_f32] = ACTIONS(684),
    [anon_sym_f64] = ACTIONS(684),
    [anon_sym_felt252] = ACTIONS(684),
    [anon_sym_bool] = ACTIONS(684),
    [anon_sym_str] = ACTIONS(684),
    [anon_sym_char] = ACTIONS(684),
    [anon_sym_GT] = ACTIONS(684),
    [anon_sym_match] = ACTIONS(684),
    [anon_sym_loop] = ACTIONS(684),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_AMP_AMP] = ACTIONS(686),
    [anon_sym_PIPE_PIPE] = ACTIONS(686),
    [anon_sym_PIPE] = ACTIONS(684),
    [anon_sym_CARET] = ACTIONS(684),
    [anon_sym_LT2] = ACTIONS(684),
    [anon_sym_LT_EQ] = ACTIONS(686),
    [anon_sym_GT_EQ] = ACTIONS(686),
    [anon_sym_LT_LT] = ACTIONS(684),
    [anon_sym_GT_GT] = ACTIONS(684),
    [anon_sym_PERCENT] = ACTIONS(684),
    [anon_sym_DASH_EQ] = ACTIONS(686),
    [anon_sym_STAR_EQ] = ACTIONS(686),
    [anon_sym_SLASH_EQ] = ACTIONS(686),
    [anon_sym_PERCENT_EQ] = ACTIONS(686),
    [anon_sym_AMP_EQ] = ACTIONS(686),
    [anon_sym_PIPE_EQ] = ACTIONS(686),
    [anon_sym_CARET_EQ] = ACTIONS(686),
    [anon_sym_LT_LT_EQ] = ACTIONS(686),
    [anon_sym_GT_GT_EQ] = ACTIONS(686),
    [anon_sym_QMARK] = ACTIONS(686),
    [sym__cairo_1_short_string] = ACTIONS(686),
    [anon_sym_true] = ACTIONS(684),
    [anon_sym_false] = ACTIONS(684),
    [sym_self] = ACTIONS(684),
  },
  [97] = {
    [sym_identifier] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(652),
    [anon_sym_LBRACE] = ACTIONS(652),
    [anon_sym_RBRACE] = ACTIONS(652),
    [anon_sym_struct] = ACTIONS(650),
    [anon_sym_EQ_EQ] = ACTIONS(652),
    [anon_sym_let] = ACTIONS(650),
    [anon_sym_const] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(650),
    [anon_sym_BANG_EQ] = ACTIONS(652),
    [anon_sym_PLUS_EQ] = ACTIONS(652),
    [anon_sym_return] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_LBRACK] = ACTIONS(652),
    [anon_sym_DOT] = ACTIONS(652),
    [sym_number] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(650),
    [anon_sym_extern] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(650),
    [anon_sym_COLON_COLON] = ACTIONS(652),
    [anon_sym_fn] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(652),
    [anon_sym_mod] = ACTIONS(650),
    [anon_sym_enum] = ACTIONS(650),
    [anon_sym_impl] = ACTIONS(650),
    [anon_sym_trait] = ACTIONS(650),
    [anon_sym_u8] = ACTIONS(650),
    [anon_sym_i8] = ACTIONS(650),
    [anon_sym_u16] = ACTIONS(650),
    [anon_sym_i16] = ACTIONS(650),
    [anon_sym_u32] = ACTIONS(650),
    [anon_sym_i32] = ACTIONS(650),
    [anon_sym_u64] = ACTIONS(650),
    [anon_sym_i64] = ACTIONS(650),
    [anon_sym_u128] = ACTIONS(650),
    [anon_sym_i128] = ACTIONS(650),
    [anon_sym_u256] = ACTIONS(650),
    [anon_sym_i256] = ACTIONS(650),
    [anon_sym_isize] = ACTIONS(650),
    [anon_sym_usize] = ACTIONS(650),
    [anon_sym_f32] = ACTIONS(650),
    [anon_sym_f64] = ACTIONS(650),
    [anon_sym_felt252] = ACTIONS(650),
    [anon_sym_bool] = ACTIONS(650),
    [anon_sym_str] = ACTIONS(650),
    [anon_sym_char] = ACTIONS(650),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_match] = ACTIONS(650),
    [anon_sym_loop] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym_LT2] = ACTIONS(650),
    [anon_sym_LT_EQ] = ACTIONS(652),
    [anon_sym_GT_EQ] = ACTIONS(652),
    [anon_sym_LT_LT] = ACTIONS(650),
    [anon_sym_GT_GT] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_DASH_EQ] = ACTIONS(652),
    [anon_sym_STAR_EQ] = ACTIONS(652),
    [anon_sym_SLASH_EQ] = ACTIONS(652),
    [anon_sym_PERCENT_EQ] = ACTIONS(652),
    [anon_sym_AMP_EQ] = ACTIONS(652),
    [anon_sym_PIPE_EQ] = ACTIONS(652),
    [anon_sym_CARET_EQ] = ACTIONS(652),
    [anon_sym_LT_LT_EQ] = ACTIONS(652),
    [anon_sym_GT_GT_EQ] = ACTIONS(652),
    [anon_sym_QMARK] = ACTIONS(652),
    [sym__cairo_1_short_string] = ACTIONS(652),
    [anon_sym_true] = ACTIONS(650),
    [anon_sym_false] = ACTIONS(650),
    [sym_self] = ACTIONS(650),
  },
  [98] = {
    [sym_identifier] = ACTIONS(688),
    [anon_sym_LPAREN] = ACTIONS(690),
    [anon_sym_EQ] = ACTIONS(688),
    [anon_sym_AT] = ACTIONS(690),
    [anon_sym_LBRACE] = ACTIONS(690),
    [anon_sym_RBRACE] = ACTIONS(690),
    [anon_sym_struct] = ACTIONS(688),
    [anon_sym_EQ_EQ] = ACTIONS(690),
    [anon_sym_let] = ACTIONS(688),
    [anon_sym_const] = ACTIONS(688),
    [anon_sym_if] = ACTIONS(688),
    [anon_sym_BANG_EQ] = ACTIONS(690),
    [anon_sym_PLUS_EQ] = ACTIONS(690),
    [anon_sym_return] = ACTIONS(688),
    [anon_sym_STAR] = ACTIONS(688),
    [anon_sym_AMP] = ACTIONS(688),
    [anon_sym_DASH] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(688),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_DOT] = ACTIONS(690),
    [sym_number] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(690),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(688),
    [anon_sym_extern] = ACTIONS(688),
    [anon_sym_type] = ACTIONS(688),
    [anon_sym_COLON_COLON] = ACTIONS(690),
    [anon_sym_fn] = ACTIONS(688),
    [anon_sym_POUND] = ACTIONS(690),
    [anon_sym_mod] = ACTIONS(688),
    [anon_sym_enum] = ACTIONS(688),
    [anon_sym_impl] = ACTIONS(688),
    [anon_sym_trait] = ACTIONS(688),
    [anon_sym_u8] = ACTIONS(688),
    [anon_sym_i8] = ACTIONS(688),
    [anon_sym_u16] = ACTIONS(688),
    [anon_sym_i16] = ACTIONS(688),
    [anon_sym_u32] = ACTIONS(688),
    [anon_sym_i32] = ACTIONS(688),
    [anon_sym_u64] = ACTIONS(688),
    [anon_sym_i64] = ACTIONS(688),
    [anon_sym_u128] = ACTIONS(688),
    [anon_sym_i128] = ACTIONS(688),
    [anon_sym_u256] = ACTIONS(688),
    [anon_sym_i256] = ACTIONS(688),
    [anon_sym_isize] = ACTIONS(688),
    [anon_sym_usize] = ACTIONS(688),
    [anon_sym_f32] = ACTIONS(688),
    [anon_sym_f64] = ACTIONS(688),
    [anon_sym_felt252] = ACTIONS(688),
    [anon_sym_bool] = ACTIONS(688),
    [anon_sym_str] = ACTIONS(688),
    [anon_sym_char] = ACTIONS(688),
    [anon_sym_GT] = ACTIONS(688),
    [anon_sym_match] = ACTIONS(688),
    [anon_sym_loop] = ACTIONS(688),
    [anon_sym_BANG] = ACTIONS(688),
    [anon_sym_TILDE] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_CARET] = ACTIONS(688),
    [anon_sym_LT2] = ACTIONS(688),
    [anon_sym_LT_EQ] = ACTIONS(690),
    [anon_sym_GT_EQ] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(688),
    [anon_sym_GT_GT] = ACTIONS(688),
    [anon_sym_PERCENT] = ACTIONS(688),
    [anon_sym_DASH_EQ] = ACTIONS(690),
    [anon_sym_STAR_EQ] = ACTIONS(690),
    [anon_sym_SLASH_EQ] = ACTIONS(690),
    [anon_sym_PERCENT_EQ] = ACTIONS(690),
    [anon_sym_AMP_EQ] = ACTIONS(690),
    [anon_sym_PIPE_EQ] = ACTIONS(690),
    [anon_sym_CARET_EQ] = ACTIONS(690),
    [anon_sym_LT_LT_EQ] = ACTIONS(690),
    [anon_sym_GT_GT_EQ] = ACTIONS(690),
    [anon_sym_QMARK] = ACTIONS(690),
    [sym__cairo_1_short_string] = ACTIONS(690),
    [anon_sym_true] = ACTIONS(688),
    [anon_sym_false] = ACTIONS(688),
    [sym_self] = ACTIONS(688),
  },
  [99] = {
    [sym_identifier] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(652),
    [anon_sym_LBRACE] = ACTIONS(652),
    [anon_sym_RBRACE] = ACTIONS(652),
    [anon_sym_struct] = ACTIONS(650),
    [anon_sym_EQ_EQ] = ACTIONS(652),
    [anon_sym_let] = ACTIONS(650),
    [anon_sym_const] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(650),
    [anon_sym_BANG_EQ] = ACTIONS(652),
    [anon_sym_PLUS_EQ] = ACTIONS(652),
    [anon_sym_return] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_LBRACK] = ACTIONS(652),
    [anon_sym_DOT] = ACTIONS(652),
    [sym_number] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(650),
    [anon_sym_extern] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(650),
    [anon_sym_COLON_COLON] = ACTIONS(692),
    [anon_sym_fn] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(652),
    [anon_sym_mod] = ACTIONS(650),
    [anon_sym_enum] = ACTIONS(650),
    [anon_sym_impl] = ACTIONS(650),
    [anon_sym_trait] = ACTIONS(650),
    [anon_sym_u8] = ACTIONS(650),
    [anon_sym_i8] = ACTIONS(650),
    [anon_sym_u16] = ACTIONS(650),
    [anon_sym_i16] = ACTIONS(650),
    [anon_sym_u32] = ACTIONS(650),
    [anon_sym_i32] = ACTIONS(650),
    [anon_sym_u64] = ACTIONS(650),
    [anon_sym_i64] = ACTIONS(650),
    [anon_sym_u128] = ACTIONS(650),
    [anon_sym_i128] = ACTIONS(650),
    [anon_sym_u256] = ACTIONS(650),
    [anon_sym_i256] = ACTIONS(650),
    [anon_sym_isize] = ACTIONS(650),
    [anon_sym_usize] = ACTIONS(650),
    [anon_sym_f32] = ACTIONS(650),
    [anon_sym_f64] = ACTIONS(650),
    [anon_sym_felt252] = ACTIONS(650),
    [anon_sym_bool] = ACTIONS(650),
    [anon_sym_str] = ACTIONS(650),
    [anon_sym_char] = ACTIONS(650),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_match] = ACTIONS(650),
    [anon_sym_loop] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym_LT2] = ACTIONS(650),
    [anon_sym_LT_EQ] = ACTIONS(652),
    [anon_sym_GT_EQ] = ACTIONS(652),
    [anon_sym_LT_LT] = ACTIONS(650),
    [anon_sym_GT_GT] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_DASH_EQ] = ACTIONS(652),
    [anon_sym_STAR_EQ] = ACTIONS(652),
    [anon_sym_SLASH_EQ] = ACTIONS(652),
    [anon_sym_PERCENT_EQ] = ACTIONS(652),
    [anon_sym_AMP_EQ] = ACTIONS(652),
    [anon_sym_PIPE_EQ] = ACTIONS(652),
    [anon_sym_CARET_EQ] = ACTIONS(652),
    [anon_sym_LT_LT_EQ] = ACTIONS(652),
    [anon_sym_GT_GT_EQ] = ACTIONS(652),
    [anon_sym_QMARK] = ACTIONS(652),
    [sym__cairo_1_short_string] = ACTIONS(652),
    [anon_sym_true] = ACTIONS(650),
    [anon_sym_false] = ACTIONS(650),
    [sym_self] = ACTIONS(650),
  },
  [100] = {
    [sym_identifier] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_EQ] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(696),
    [anon_sym_LBRACE] = ACTIONS(696),
    [anon_sym_RBRACE] = ACTIONS(696),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_EQ_EQ] = ACTIONS(696),
    [anon_sym_let] = ACTIONS(694),
    [anon_sym_const] = ACTIONS(694),
    [anon_sym_if] = ACTIONS(694),
    [anon_sym_BANG_EQ] = ACTIONS(696),
    [anon_sym_PLUS_EQ] = ACTIONS(696),
    [anon_sym_return] = ACTIONS(694),
    [anon_sym_STAR] = ACTIONS(694),
    [anon_sym_AMP] = ACTIONS(694),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_SLASH] = ACTIONS(694),
    [anon_sym_LBRACK] = ACTIONS(696),
    [anon_sym_DOT] = ACTIONS(696),
    [sym_number] = ACTIONS(696),
    [anon_sym_SEMI] = ACTIONS(696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(694),
    [anon_sym_extern] = ACTIONS(694),
    [anon_sym_type] = ACTIONS(694),
    [anon_sym_COLON_COLON] = ACTIONS(696),
    [anon_sym_fn] = ACTIONS(694),
    [anon_sym_POUND] = ACTIONS(696),
    [anon_sym_mod] = ACTIONS(694),
    [anon_sym_enum] = ACTIONS(694),
    [anon_sym_impl] = ACTIONS(694),
    [anon_sym_trait] = ACTIONS(694),
    [anon_sym_u8] = ACTIONS(694),
    [anon_sym_i8] = ACTIONS(694),
    [anon_sym_u16] = ACTIONS(694),
    [anon_sym_i16] = ACTIONS(694),
    [anon_sym_u32] = ACTIONS(694),
    [anon_sym_i32] = ACTIONS(694),
    [anon_sym_u64] = ACTIONS(694),
    [anon_sym_i64] = ACTIONS(694),
    [anon_sym_u128] = ACTIONS(694),
    [anon_sym_i128] = ACTIONS(694),
    [anon_sym_u256] = ACTIONS(694),
    [anon_sym_i256] = ACTIONS(694),
    [anon_sym_isize] = ACTIONS(694),
    [anon_sym_usize] = ACTIONS(694),
    [anon_sym_f32] = ACTIONS(694),
    [anon_sym_f64] = ACTIONS(694),
    [anon_sym_felt252] = ACTIONS(694),
    [anon_sym_bool] = ACTIONS(694),
    [anon_sym_str] = ACTIONS(694),
    [anon_sym_char] = ACTIONS(694),
    [anon_sym_GT] = ACTIONS(694),
    [anon_sym_match] = ACTIONS(694),
    [anon_sym_loop] = ACTIONS(694),
    [anon_sym_BANG] = ACTIONS(694),
    [anon_sym_TILDE] = ACTIONS(696),
    [anon_sym_AMP_AMP] = ACTIONS(696),
    [anon_sym_PIPE_PIPE] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(694),
    [anon_sym_LT2] = ACTIONS(694),
    [anon_sym_LT_EQ] = ACTIONS(696),
    [anon_sym_GT_EQ] = ACTIONS(696),
    [anon_sym_LT_LT] = ACTIONS(694),
    [anon_sym_GT_GT] = ACTIONS(694),
    [anon_sym_PERCENT] = ACTIONS(694),
    [anon_sym_DASH_EQ] = ACTIONS(696),
    [anon_sym_STAR_EQ] = ACTIONS(696),
    [anon_sym_SLASH_EQ] = ACTIONS(696),
    [anon_sym_PERCENT_EQ] = ACTIONS(696),
    [anon_sym_AMP_EQ] = ACTIONS(696),
    [anon_sym_PIPE_EQ] = ACTIONS(696),
    [anon_sym_CARET_EQ] = ACTIONS(696),
    [anon_sym_LT_LT_EQ] = ACTIONS(696),
    [anon_sym_GT_GT_EQ] = ACTIONS(696),
    [anon_sym_QMARK] = ACTIONS(696),
    [sym__cairo_1_short_string] = ACTIONS(696),
    [anon_sym_true] = ACTIONS(694),
    [anon_sym_false] = ACTIONS(694),
    [sym_self] = ACTIONS(694),
  },
  [101] = {
    [sym_identifier] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_EQ] = ACTIONS(698),
    [anon_sym_AT] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(700),
    [anon_sym_RBRACE] = ACTIONS(700),
    [anon_sym_struct] = ACTIONS(698),
    [anon_sym_EQ_EQ] = ACTIONS(700),
    [anon_sym_let] = ACTIONS(698),
    [anon_sym_const] = ACTIONS(698),
    [anon_sym_if] = ACTIONS(698),
    [anon_sym_BANG_EQ] = ACTIONS(700),
    [anon_sym_PLUS_EQ] = ACTIONS(700),
    [anon_sym_return] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_PLUS] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_LBRACK] = ACTIONS(700),
    [anon_sym_DOT] = ACTIONS(700),
    [sym_number] = ACTIONS(700),
    [anon_sym_SEMI] = ACTIONS(700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(698),
    [anon_sym_extern] = ACTIONS(698),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_COLON_COLON] = ACTIONS(700),
    [anon_sym_fn] = ACTIONS(698),
    [anon_sym_POUND] = ACTIONS(700),
    [anon_sym_mod] = ACTIONS(698),
    [anon_sym_enum] = ACTIONS(698),
    [anon_sym_impl] = ACTIONS(698),
    [anon_sym_trait] = ACTIONS(698),
    [anon_sym_u8] = ACTIONS(698),
    [anon_sym_i8] = ACTIONS(698),
    [anon_sym_u16] = ACTIONS(698),
    [anon_sym_i16] = ACTIONS(698),
    [anon_sym_u32] = ACTIONS(698),
    [anon_sym_i32] = ACTIONS(698),
    [anon_sym_u64] = ACTIONS(698),
    [anon_sym_i64] = ACTIONS(698),
    [anon_sym_u128] = ACTIONS(698),
    [anon_sym_i128] = ACTIONS(698),
    [anon_sym_u256] = ACTIONS(698),
    [anon_sym_i256] = ACTIONS(698),
    [anon_sym_isize] = ACTIONS(698),
    [anon_sym_usize] = ACTIONS(698),
    [anon_sym_f32] = ACTIONS(698),
    [anon_sym_f64] = ACTIONS(698),
    [anon_sym_felt252] = ACTIONS(698),
    [anon_sym_bool] = ACTIONS(698),
    [anon_sym_str] = ACTIONS(698),
    [anon_sym_char] = ACTIONS(698),
    [anon_sym_GT] = ACTIONS(698),
    [anon_sym_match] = ACTIONS(698),
    [anon_sym_loop] = ACTIONS(698),
    [anon_sym_BANG] = ACTIONS(698),
    [anon_sym_TILDE] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_CARET] = ACTIONS(698),
    [anon_sym_LT2] = ACTIONS(698),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_LT_LT] = ACTIONS(698),
    [anon_sym_GT_GT] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_DASH_EQ] = ACTIONS(700),
    [anon_sym_STAR_EQ] = ACTIONS(700),
    [anon_sym_SLASH_EQ] = ACTIONS(700),
    [anon_sym_PERCENT_EQ] = ACTIONS(700),
    [anon_sym_AMP_EQ] = ACTIONS(700),
    [anon_sym_PIPE_EQ] = ACTIONS(700),
    [anon_sym_CARET_EQ] = ACTIONS(700),
    [anon_sym_LT_LT_EQ] = ACTIONS(700),
    [anon_sym_GT_GT_EQ] = ACTIONS(700),
    [anon_sym_QMARK] = ACTIONS(700),
    [sym__cairo_1_short_string] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(698),
    [anon_sym_false] = ACTIONS(698),
    [sym_self] = ACTIONS(698),
  },
  [102] = {
    [sym_identifier] = ACTIONS(702),
    [anon_sym_LPAREN] = ACTIONS(704),
    [anon_sym_EQ] = ACTIONS(702),
    [anon_sym_AT] = ACTIONS(704),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_RBRACE] = ACTIONS(704),
    [anon_sym_struct] = ACTIONS(702),
    [anon_sym_EQ_EQ] = ACTIONS(704),
    [anon_sym_let] = ACTIONS(702),
    [anon_sym_const] = ACTIONS(702),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(704),
    [anon_sym_PLUS_EQ] = ACTIONS(704),
    [anon_sym_return] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_SLASH] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(704),
    [anon_sym_DOT] = ACTIONS(704),
    [sym_number] = ACTIONS(704),
    [anon_sym_SEMI] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(702),
    [anon_sym_extern] = ACTIONS(702),
    [anon_sym_type] = ACTIONS(702),
    [anon_sym_COLON_COLON] = ACTIONS(704),
    [anon_sym_fn] = ACTIONS(702),
    [anon_sym_POUND] = ACTIONS(704),
    [anon_sym_mod] = ACTIONS(702),
    [anon_sym_enum] = ACTIONS(702),
    [anon_sym_impl] = ACTIONS(702),
    [anon_sym_trait] = ACTIONS(702),
    [anon_sym_u8] = ACTIONS(702),
    [anon_sym_i8] = ACTIONS(702),
    [anon_sym_u16] = ACTIONS(702),
    [anon_sym_i16] = ACTIONS(702),
    [anon_sym_u32] = ACTIONS(702),
    [anon_sym_i32] = ACTIONS(702),
    [anon_sym_u64] = ACTIONS(702),
    [anon_sym_i64] = ACTIONS(702),
    [anon_sym_u128] = ACTIONS(702),
    [anon_sym_i128] = ACTIONS(702),
    [anon_sym_u256] = ACTIONS(702),
    [anon_sym_i256] = ACTIONS(702),
    [anon_sym_isize] = ACTIONS(702),
    [anon_sym_usize] = ACTIONS(702),
    [anon_sym_f32] = ACTIONS(702),
    [anon_sym_f64] = ACTIONS(702),
    [anon_sym_felt252] = ACTIONS(702),
    [anon_sym_bool] = ACTIONS(702),
    [anon_sym_str] = ACTIONS(702),
    [anon_sym_char] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_match] = ACTIONS(702),
    [anon_sym_loop] = ACTIONS(702),
    [anon_sym_BANG] = ACTIONS(702),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_AMP_AMP] = ACTIONS(704),
    [anon_sym_PIPE_PIPE] = ACTIONS(704),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_CARET] = ACTIONS(702),
    [anon_sym_LT2] = ACTIONS(702),
    [anon_sym_LT_EQ] = ACTIONS(704),
    [anon_sym_GT_EQ] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(702),
    [anon_sym_DASH_EQ] = ACTIONS(704),
    [anon_sym_STAR_EQ] = ACTIONS(704),
    [anon_sym_SLASH_EQ] = ACTIONS(704),
    [anon_sym_PERCENT_EQ] = ACTIONS(704),
    [anon_sym_AMP_EQ] = ACTIONS(704),
    [anon_sym_PIPE_EQ] = ACTIONS(704),
    [anon_sym_CARET_EQ] = ACTIONS(704),
    [anon_sym_LT_LT_EQ] = ACTIONS(704),
    [anon_sym_GT_GT_EQ] = ACTIONS(704),
    [anon_sym_QMARK] = ACTIONS(704),
    [sym__cairo_1_short_string] = ACTIONS(704),
    [anon_sym_true] = ACTIONS(702),
    [anon_sym_false] = ACTIONS(702),
    [sym_self] = ACTIONS(702),
  },
  [103] = {
    [sym_identifier] = ACTIONS(706),
    [anon_sym_LPAREN] = ACTIONS(708),
    [anon_sym_EQ] = ACTIONS(706),
    [anon_sym_AT] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(708),
    [anon_sym_RBRACE] = ACTIONS(708),
    [anon_sym_struct] = ACTIONS(706),
    [anon_sym_EQ_EQ] = ACTIONS(708),
    [anon_sym_let] = ACTIONS(706),
    [anon_sym_const] = ACTIONS(706),
    [anon_sym_if] = ACTIONS(706),
    [anon_sym_BANG_EQ] = ACTIONS(708),
    [anon_sym_PLUS_EQ] = ACTIONS(708),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(706),
    [anon_sym_AMP] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(706),
    [anon_sym_LBRACK] = ACTIONS(708),
    [anon_sym_DOT] = ACTIONS(708),
    [sym_number] = ACTIONS(708),
    [anon_sym_SEMI] = ACTIONS(708),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(706),
    [anon_sym_extern] = ACTIONS(706),
    [anon_sym_type] = ACTIONS(706),
    [anon_sym_COLON_COLON] = ACTIONS(708),
    [anon_sym_fn] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_mod] = ACTIONS(706),
    [anon_sym_enum] = ACTIONS(706),
    [anon_sym_impl] = ACTIONS(706),
    [anon_sym_trait] = ACTIONS(706),
    [anon_sym_u8] = ACTIONS(706),
    [anon_sym_i8] = ACTIONS(706),
    [anon_sym_u16] = ACTIONS(706),
    [anon_sym_i16] = ACTIONS(706),
    [anon_sym_u32] = ACTIONS(706),
    [anon_sym_i32] = ACTIONS(706),
    [anon_sym_u64] = ACTIONS(706),
    [anon_sym_i64] = ACTIONS(706),
    [anon_sym_u128] = ACTIONS(706),
    [anon_sym_i128] = ACTIONS(706),
    [anon_sym_u256] = ACTIONS(706),
    [anon_sym_i256] = ACTIONS(706),
    [anon_sym_isize] = ACTIONS(706),
    [anon_sym_usize] = ACTIONS(706),
    [anon_sym_f32] = ACTIONS(706),
    [anon_sym_f64] = ACTIONS(706),
    [anon_sym_felt252] = ACTIONS(706),
    [anon_sym_bool] = ACTIONS(706),
    [anon_sym_str] = ACTIONS(706),
    [anon_sym_char] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(706),
    [anon_sym_match] = ACTIONS(706),
    [anon_sym_loop] = ACTIONS(706),
    [anon_sym_BANG] = ACTIONS(706),
    [anon_sym_TILDE] = ACTIONS(708),
    [anon_sym_AMP_AMP] = ACTIONS(708),
    [anon_sym_PIPE_PIPE] = ACTIONS(708),
    [anon_sym_PIPE] = ACTIONS(706),
    [anon_sym_CARET] = ACTIONS(706),
    [anon_sym_LT2] = ACTIONS(706),
    [anon_sym_LT_EQ] = ACTIONS(708),
    [anon_sym_GT_EQ] = ACTIONS(708),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_GT_GT] = ACTIONS(706),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_DASH_EQ] = ACTIONS(708),
    [anon_sym_STAR_EQ] = ACTIONS(708),
    [anon_sym_SLASH_EQ] = ACTIONS(708),
    [anon_sym_PERCENT_EQ] = ACTIONS(708),
    [anon_sym_AMP_EQ] = ACTIONS(708),
    [anon_sym_PIPE_EQ] = ACTIONS(708),
    [anon_sym_CARET_EQ] = ACTIONS(708),
    [anon_sym_LT_LT_EQ] = ACTIONS(708),
    [anon_sym_GT_GT_EQ] = ACTIONS(708),
    [anon_sym_QMARK] = ACTIONS(708),
    [sym__cairo_1_short_string] = ACTIONS(708),
    [anon_sym_true] = ACTIONS(706),
    [anon_sym_false] = ACTIONS(706),
    [sym_self] = ACTIONS(706),
  },
  [104] = {
    [sym_identifier] = ACTIONS(710),
    [anon_sym_LPAREN] = ACTIONS(712),
    [anon_sym_EQ] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(712),
    [anon_sym_LBRACE] = ACTIONS(712),
    [anon_sym_RBRACE] = ACTIONS(712),
    [anon_sym_struct] = ACTIONS(710),
    [anon_sym_EQ_EQ] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(710),
    [anon_sym_const] = ACTIONS(710),
    [anon_sym_if] = ACTIONS(710),
    [anon_sym_BANG_EQ] = ACTIONS(712),
    [anon_sym_PLUS_EQ] = ACTIONS(712),
    [anon_sym_return] = ACTIONS(710),
    [anon_sym_STAR] = ACTIONS(710),
    [anon_sym_AMP] = ACTIONS(710),
    [anon_sym_DASH] = ACTIONS(710),
    [anon_sym_PLUS] = ACTIONS(710),
    [anon_sym_SLASH] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(712),
    [anon_sym_DOT] = ACTIONS(712),
    [sym_number] = ACTIONS(712),
    [anon_sym_SEMI] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(710),
    [anon_sym_extern] = ACTIONS(710),
    [anon_sym_type] = ACTIONS(710),
    [anon_sym_COLON_COLON] = ACTIONS(712),
    [anon_sym_fn] = ACTIONS(710),
    [anon_sym_POUND] = ACTIONS(712),
    [anon_sym_mod] = ACTIONS(710),
    [anon_sym_enum] = ACTIONS(710),
    [anon_sym_impl] = ACTIONS(710),
    [anon_sym_trait] = ACTIONS(710),
    [anon_sym_u8] = ACTIONS(710),
    [anon_sym_i8] = ACTIONS(710),
    [anon_sym_u16] = ACTIONS(710),
    [anon_sym_i16] = ACTIONS(710),
    [anon_sym_u32] = ACTIONS(710),
    [anon_sym_i32] = ACTIONS(710),
    [anon_sym_u64] = ACTIONS(710),
    [anon_sym_i64] = ACTIONS(710),
    [anon_sym_u128] = ACTIONS(710),
    [anon_sym_i128] = ACTIONS(710),
    [anon_sym_u256] = ACTIONS(710),
    [anon_sym_i256] = ACTIONS(710),
    [anon_sym_isize] = ACTIONS(710),
    [anon_sym_usize] = ACTIONS(710),
    [anon_sym_f32] = ACTIONS(710),
    [anon_sym_f64] = ACTIONS(710),
    [anon_sym_felt252] = ACTIONS(710),
    [anon_sym_bool] = ACTIONS(710),
    [anon_sym_str] = ACTIONS(710),
    [anon_sym_char] = ACTIONS(710),
    [anon_sym_GT] = ACTIONS(710),
    [anon_sym_match] = ACTIONS(710),
    [anon_sym_loop] = ACTIONS(710),
    [anon_sym_BANG] = ACTIONS(710),
    [anon_sym_TILDE] = ACTIONS(712),
    [anon_sym_AMP_AMP] = ACTIONS(712),
    [anon_sym_PIPE_PIPE] = ACTIONS(712),
    [anon_sym_PIPE] = ACTIONS(710),
    [anon_sym_CARET] = ACTIONS(710),
    [anon_sym_LT2] = ACTIONS(710),
    [anon_sym_LT_EQ] = ACTIONS(712),
    [anon_sym_GT_EQ] = ACTIONS(712),
    [anon_sym_LT_LT] = ACTIONS(710),
    [anon_sym_GT_GT] = ACTIONS(710),
    [anon_sym_PERCENT] = ACTIONS(710),
    [anon_sym_DASH_EQ] = ACTIONS(712),
    [anon_sym_STAR_EQ] = ACTIONS(712),
    [anon_sym_SLASH_EQ] = ACTIONS(712),
    [anon_sym_PERCENT_EQ] = ACTIONS(712),
    [anon_sym_AMP_EQ] = ACTIONS(712),
    [anon_sym_PIPE_EQ] = ACTIONS(712),
    [anon_sym_CARET_EQ] = ACTIONS(712),
    [anon_sym_LT_LT_EQ] = ACTIONS(712),
    [anon_sym_GT_GT_EQ] = ACTIONS(712),
    [anon_sym_QMARK] = ACTIONS(712),
    [sym__cairo_1_short_string] = ACTIONS(712),
    [anon_sym_true] = ACTIONS(710),
    [anon_sym_false] = ACTIONS(710),
    [sym_self] = ACTIONS(710),
  },
  [105] = {
    [sym_identifier] = ACTIONS(706),
    [anon_sym_LPAREN] = ACTIONS(708),
    [anon_sym_EQ] = ACTIONS(706),
    [anon_sym_AT] = ACTIONS(708),
    [anon_sym_LBRACE] = ACTIONS(708),
    [anon_sym_RBRACE] = ACTIONS(708),
    [anon_sym_struct] = ACTIONS(706),
    [anon_sym_EQ_EQ] = ACTIONS(708),
    [anon_sym_let] = ACTIONS(706),
    [anon_sym_const] = ACTIONS(706),
    [anon_sym_if] = ACTIONS(706),
    [anon_sym_BANG_EQ] = ACTIONS(708),
    [anon_sym_PLUS_EQ] = ACTIONS(708),
    [anon_sym_return] = ACTIONS(706),
    [anon_sym_STAR] = ACTIONS(706),
    [anon_sym_AMP] = ACTIONS(706),
    [anon_sym_DASH] = ACTIONS(706),
    [anon_sym_PLUS] = ACTIONS(706),
    [anon_sym_SLASH] = ACTIONS(706),
    [anon_sym_LBRACK] = ACTIONS(708),
    [anon_sym_DOT] = ACTIONS(708),
    [sym_number] = ACTIONS(708),
    [anon_sym_SEMI] = ACTIONS(708),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(706),
    [anon_sym_extern] = ACTIONS(706),
    [anon_sym_type] = ACTIONS(706),
    [anon_sym_COLON_COLON] = ACTIONS(708),
    [anon_sym_fn] = ACTIONS(706),
    [anon_sym_POUND] = ACTIONS(708),
    [anon_sym_mod] = ACTIONS(706),
    [anon_sym_enum] = ACTIONS(706),
    [anon_sym_impl] = ACTIONS(706),
    [anon_sym_trait] = ACTIONS(706),
    [anon_sym_u8] = ACTIONS(706),
    [anon_sym_i8] = ACTIONS(706),
    [anon_sym_u16] = ACTIONS(706),
    [anon_sym_i16] = ACTIONS(706),
    [anon_sym_u32] = ACTIONS(706),
    [anon_sym_i32] = ACTIONS(706),
    [anon_sym_u64] = ACTIONS(706),
    [anon_sym_i64] = ACTIONS(706),
    [anon_sym_u128] = ACTIONS(706),
    [anon_sym_i128] = ACTIONS(706),
    [anon_sym_u256] = ACTIONS(706),
    [anon_sym_i256] = ACTIONS(706),
    [anon_sym_isize] = ACTIONS(706),
    [anon_sym_usize] = ACTIONS(706),
    [anon_sym_f32] = ACTIONS(706),
    [anon_sym_f64] = ACTIONS(706),
    [anon_sym_felt252] = ACTIONS(706),
    [anon_sym_bool] = ACTIONS(706),
    [anon_sym_str] = ACTIONS(706),
    [anon_sym_char] = ACTIONS(706),
    [anon_sym_GT] = ACTIONS(706),
    [anon_sym_match] = ACTIONS(706),
    [anon_sym_loop] = ACTIONS(706),
    [anon_sym_BANG] = ACTIONS(706),
    [anon_sym_TILDE] = ACTIONS(708),
    [anon_sym_AMP_AMP] = ACTIONS(708),
    [anon_sym_PIPE_PIPE] = ACTIONS(708),
    [anon_sym_PIPE] = ACTIONS(706),
    [anon_sym_CARET] = ACTIONS(706),
    [anon_sym_LT2] = ACTIONS(706),
    [anon_sym_LT_EQ] = ACTIONS(708),
    [anon_sym_GT_EQ] = ACTIONS(708),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_GT_GT] = ACTIONS(706),
    [anon_sym_PERCENT] = ACTIONS(706),
    [anon_sym_DASH_EQ] = ACTIONS(708),
    [anon_sym_STAR_EQ] = ACTIONS(708),
    [anon_sym_SLASH_EQ] = ACTIONS(708),
    [anon_sym_PERCENT_EQ] = ACTIONS(708),
    [anon_sym_AMP_EQ] = ACTIONS(708),
    [anon_sym_PIPE_EQ] = ACTIONS(708),
    [anon_sym_CARET_EQ] = ACTIONS(708),
    [anon_sym_LT_LT_EQ] = ACTIONS(708),
    [anon_sym_GT_GT_EQ] = ACTIONS(708),
    [anon_sym_QMARK] = ACTIONS(708),
    [sym__cairo_1_short_string] = ACTIONS(708),
    [anon_sym_true] = ACTIONS(706),
    [anon_sym_false] = ACTIONS(706),
    [sym_self] = ACTIONS(706),
  },
  [106] = {
    [sym_identifier] = ACTIONS(714),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_EQ] = ACTIONS(714),
    [anon_sym_AT] = ACTIONS(716),
    [anon_sym_LBRACE] = ACTIONS(716),
    [anon_sym_RBRACE] = ACTIONS(716),
    [anon_sym_struct] = ACTIONS(714),
    [anon_sym_EQ_EQ] = ACTIONS(716),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(714),
    [anon_sym_if] = ACTIONS(714),
    [anon_sym_BANG_EQ] = ACTIONS(716),
    [anon_sym_PLUS_EQ] = ACTIONS(716),
    [anon_sym_return] = ACTIONS(714),
    [anon_sym_STAR] = ACTIONS(714),
    [anon_sym_AMP] = ACTIONS(714),
    [anon_sym_DASH] = ACTIONS(714),
    [anon_sym_PLUS] = ACTIONS(714),
    [anon_sym_SLASH] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_DOT] = ACTIONS(716),
    [sym_number] = ACTIONS(716),
    [anon_sym_SEMI] = ACTIONS(716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(714),
    [anon_sym_extern] = ACTIONS(714),
    [anon_sym_type] = ACTIONS(714),
    [anon_sym_COLON_COLON] = ACTIONS(716),
    [anon_sym_fn] = ACTIONS(714),
    [anon_sym_POUND] = ACTIONS(716),
    [anon_sym_mod] = ACTIONS(714),
    [anon_sym_enum] = ACTIONS(714),
    [anon_sym_impl] = ACTIONS(714),
    [anon_sym_trait] = ACTIONS(714),
    [anon_sym_u8] = ACTIONS(714),
    [anon_sym_i8] = ACTIONS(714),
    [anon_sym_u16] = ACTIONS(714),
    [anon_sym_i16] = ACTIONS(714),
    [anon_sym_u32] = ACTIONS(714),
    [anon_sym_i32] = ACTIONS(714),
    [anon_sym_u64] = ACTIONS(714),
    [anon_sym_i64] = ACTIONS(714),
    [anon_sym_u128] = ACTIONS(714),
    [anon_sym_i128] = ACTIONS(714),
    [anon_sym_u256] = ACTIONS(714),
    [anon_sym_i256] = ACTIONS(714),
    [anon_sym_isize] = ACTIONS(714),
    [anon_sym_usize] = ACTIONS(714),
    [anon_sym_f32] = ACTIONS(714),
    [anon_sym_f64] = ACTIONS(714),
    [anon_sym_felt252] = ACTIONS(714),
    [anon_sym_bool] = ACTIONS(714),
    [anon_sym_str] = ACTIONS(714),
    [anon_sym_char] = ACTIONS(714),
    [anon_sym_GT] = ACTIONS(714),
    [anon_sym_match] = ACTIONS(714),
    [anon_sym_loop] = ACTIONS(714),
    [anon_sym_BANG] = ACTIONS(714),
    [anon_sym_TILDE] = ACTIONS(716),
    [anon_sym_AMP_AMP] = ACTIONS(716),
    [anon_sym_PIPE_PIPE] = ACTIONS(716),
    [anon_sym_PIPE] = ACTIONS(714),
    [anon_sym_CARET] = ACTIONS(714),
    [anon_sym_LT2] = ACTIONS(714),
    [anon_sym_LT_EQ] = ACTIONS(716),
    [anon_sym_GT_EQ] = ACTIONS(716),
    [anon_sym_LT_LT] = ACTIONS(714),
    [anon_sym_GT_GT] = ACTIONS(714),
    [anon_sym_PERCENT] = ACTIONS(714),
    [anon_sym_DASH_EQ] = ACTIONS(716),
    [anon_sym_STAR_EQ] = ACTIONS(716),
    [anon_sym_SLASH_EQ] = ACTIONS(716),
    [anon_sym_PERCENT_EQ] = ACTIONS(716),
    [anon_sym_AMP_EQ] = ACTIONS(716),
    [anon_sym_PIPE_EQ] = ACTIONS(716),
    [anon_sym_CARET_EQ] = ACTIONS(716),
    [anon_sym_LT_LT_EQ] = ACTIONS(716),
    [anon_sym_GT_GT_EQ] = ACTIONS(716),
    [anon_sym_QMARK] = ACTIONS(716),
    [sym__cairo_1_short_string] = ACTIONS(716),
    [anon_sym_true] = ACTIONS(714),
    [anon_sym_false] = ACTIONS(714),
    [sym_self] = ACTIONS(714),
  },
  [107] = {
    [sym_identifier] = ACTIONS(718),
    [anon_sym_LPAREN] = ACTIONS(720),
    [anon_sym_EQ] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(720),
    [anon_sym_LBRACE] = ACTIONS(720),
    [anon_sym_RBRACE] = ACTIONS(720),
    [anon_sym_struct] = ACTIONS(718),
    [anon_sym_EQ_EQ] = ACTIONS(720),
    [anon_sym_let] = ACTIONS(718),
    [anon_sym_const] = ACTIONS(718),
    [anon_sym_if] = ACTIONS(718),
    [anon_sym_BANG_EQ] = ACTIONS(720),
    [anon_sym_PLUS_EQ] = ACTIONS(720),
    [anon_sym_return] = ACTIONS(718),
    [anon_sym_STAR] = ACTIONS(718),
    [anon_sym_AMP] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_SLASH] = ACTIONS(718),
    [anon_sym_LBRACK] = ACTIONS(720),
    [anon_sym_DOT] = ACTIONS(720),
    [sym_number] = ACTIONS(720),
    [anon_sym_SEMI] = ACTIONS(720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(718),
    [anon_sym_extern] = ACTIONS(718),
    [anon_sym_type] = ACTIONS(718),
    [anon_sym_COLON_COLON] = ACTIONS(722),
    [anon_sym_fn] = ACTIONS(718),
    [anon_sym_POUND] = ACTIONS(720),
    [anon_sym_mod] = ACTIONS(718),
    [anon_sym_enum] = ACTIONS(718),
    [anon_sym_impl] = ACTIONS(718),
    [anon_sym_trait] = ACTIONS(718),
    [anon_sym_u8] = ACTIONS(718),
    [anon_sym_i8] = ACTIONS(718),
    [anon_sym_u16] = ACTIONS(718),
    [anon_sym_i16] = ACTIONS(718),
    [anon_sym_u32] = ACTIONS(718),
    [anon_sym_i32] = ACTIONS(718),
    [anon_sym_u64] = ACTIONS(718),
    [anon_sym_i64] = ACTIONS(718),
    [anon_sym_u128] = ACTIONS(718),
    [anon_sym_i128] = ACTIONS(718),
    [anon_sym_u256] = ACTIONS(718),
    [anon_sym_i256] = ACTIONS(718),
    [anon_sym_isize] = ACTIONS(718),
    [anon_sym_usize] = ACTIONS(718),
    [anon_sym_f32] = ACTIONS(718),
    [anon_sym_f64] = ACTIONS(718),
    [anon_sym_felt252] = ACTIONS(718),
    [anon_sym_bool] = ACTIONS(718),
    [anon_sym_str] = ACTIONS(718),
    [anon_sym_char] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(718),
    [anon_sym_match] = ACTIONS(718),
    [anon_sym_loop] = ACTIONS(718),
    [anon_sym_BANG] = ACTIONS(718),
    [anon_sym_TILDE] = ACTIONS(720),
    [anon_sym_AMP_AMP] = ACTIONS(720),
    [anon_sym_PIPE_PIPE] = ACTIONS(720),
    [anon_sym_PIPE] = ACTIONS(718),
    [anon_sym_CARET] = ACTIONS(718),
    [anon_sym_LT2] = ACTIONS(718),
    [anon_sym_LT_EQ] = ACTIONS(720),
    [anon_sym_GT_EQ] = ACTIONS(720),
    [anon_sym_LT_LT] = ACTIONS(718),
    [anon_sym_GT_GT] = ACTIONS(718),
    [anon_sym_PERCENT] = ACTIONS(718),
    [anon_sym_DASH_EQ] = ACTIONS(720),
    [anon_sym_STAR_EQ] = ACTIONS(720),
    [anon_sym_SLASH_EQ] = ACTIONS(720),
    [anon_sym_PERCENT_EQ] = ACTIONS(720),
    [anon_sym_AMP_EQ] = ACTIONS(720),
    [anon_sym_PIPE_EQ] = ACTIONS(720),
    [anon_sym_CARET_EQ] = ACTIONS(720),
    [anon_sym_LT_LT_EQ] = ACTIONS(720),
    [anon_sym_GT_GT_EQ] = ACTIONS(720),
    [anon_sym_QMARK] = ACTIONS(720),
    [sym__cairo_1_short_string] = ACTIONS(720),
    [anon_sym_true] = ACTIONS(718),
    [anon_sym_false] = ACTIONS(718),
    [sym_self] = ACTIONS(718),
  },
  [108] = {
    [sym_identifier] = ACTIONS(724),
    [anon_sym_LPAREN] = ACTIONS(726),
    [anon_sym_EQ] = ACTIONS(724),
    [anon_sym_AT] = ACTIONS(726),
    [anon_sym_LBRACE] = ACTIONS(726),
    [anon_sym_RBRACE] = ACTIONS(726),
    [anon_sym_struct] = ACTIONS(724),
    [anon_sym_EQ_EQ] = ACTIONS(726),
    [anon_sym_let] = ACTIONS(724),
    [anon_sym_const] = ACTIONS(724),
    [anon_sym_if] = ACTIONS(724),
    [anon_sym_BANG_EQ] = ACTIONS(726),
    [anon_sym_PLUS_EQ] = ACTIONS(726),
    [anon_sym_return] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(724),
    [anon_sym_AMP] = ACTIONS(724),
    [anon_sym_DASH] = ACTIONS(724),
    [anon_sym_PLUS] = ACTIONS(724),
    [anon_sym_SLASH] = ACTIONS(724),
    [anon_sym_LBRACK] = ACTIONS(726),
    [anon_sym_DOT] = ACTIONS(726),
    [sym_number] = ACTIONS(726),
    [anon_sym_SEMI] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(724),
    [anon_sym_extern] = ACTIONS(724),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_COLON_COLON] = ACTIONS(726),
    [anon_sym_fn] = ACTIONS(724),
    [anon_sym_POUND] = ACTIONS(726),
    [anon_sym_mod] = ACTIONS(724),
    [anon_sym_enum] = ACTIONS(724),
    [anon_sym_impl] = ACTIONS(724),
    [anon_sym_trait] = ACTIONS(724),
    [anon_sym_u8] = ACTIONS(724),
    [anon_sym_i8] = ACTIONS(724),
    [anon_sym_u16] = ACTIONS(724),
    [anon_sym_i16] = ACTIONS(724),
    [anon_sym_u32] = ACTIONS(724),
    [anon_sym_i32] = ACTIONS(724),
    [anon_sym_u64] = ACTIONS(724),
    [anon_sym_i64] = ACTIONS(724),
    [anon_sym_u128] = ACTIONS(724),
    [anon_sym_i128] = ACTIONS(724),
    [anon_sym_u256] = ACTIONS(724),
    [anon_sym_i256] = ACTIONS(724),
    [anon_sym_isize] = ACTIONS(724),
    [anon_sym_usize] = ACTIONS(724),
    [anon_sym_f32] = ACTIONS(724),
    [anon_sym_f64] = ACTIONS(724),
    [anon_sym_felt252] = ACTIONS(724),
    [anon_sym_bool] = ACTIONS(724),
    [anon_sym_str] = ACTIONS(724),
    [anon_sym_char] = ACTIONS(724),
    [anon_sym_GT] = ACTIONS(724),
    [anon_sym_match] = ACTIONS(724),
    [anon_sym_loop] = ACTIONS(724),
    [anon_sym_BANG] = ACTIONS(724),
    [anon_sym_TILDE] = ACTIONS(726),
    [anon_sym_AMP_AMP] = ACTIONS(726),
    [anon_sym_PIPE_PIPE] = ACTIONS(726),
    [anon_sym_PIPE] = ACTIONS(724),
    [anon_sym_CARET] = ACTIONS(724),
    [anon_sym_LT2] = ACTIONS(724),
    [anon_sym_LT_EQ] = ACTIONS(726),
    [anon_sym_GT_EQ] = ACTIONS(726),
    [anon_sym_LT_LT] = ACTIONS(724),
    [anon_sym_GT_GT] = ACTIONS(724),
    [anon_sym_PERCENT] = ACTIONS(724),
    [anon_sym_DASH_EQ] = ACTIONS(726),
    [anon_sym_STAR_EQ] = ACTIONS(726),
    [anon_sym_SLASH_EQ] = ACTIONS(726),
    [anon_sym_PERCENT_EQ] = ACTIONS(726),
    [anon_sym_AMP_EQ] = ACTIONS(726),
    [anon_sym_PIPE_EQ] = ACTIONS(726),
    [anon_sym_CARET_EQ] = ACTIONS(726),
    [anon_sym_LT_LT_EQ] = ACTIONS(726),
    [anon_sym_GT_GT_EQ] = ACTIONS(726),
    [anon_sym_QMARK] = ACTIONS(726),
    [sym__cairo_1_short_string] = ACTIONS(726),
    [anon_sym_true] = ACTIONS(724),
    [anon_sym_false] = ACTIONS(724),
    [sym_self] = ACTIONS(724),
  },
  [109] = {
    [sym_identifier] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(652),
    [anon_sym_LBRACE] = ACTIONS(652),
    [anon_sym_RBRACE] = ACTIONS(652),
    [anon_sym_struct] = ACTIONS(650),
    [anon_sym_EQ_EQ] = ACTIONS(652),
    [anon_sym_let] = ACTIONS(650),
    [anon_sym_const] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(650),
    [anon_sym_BANG_EQ] = ACTIONS(652),
    [anon_sym_PLUS_EQ] = ACTIONS(652),
    [anon_sym_return] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(650),
    [anon_sym_LBRACK] = ACTIONS(652),
    [anon_sym_DOT] = ACTIONS(652),
    [sym_number] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(650),
    [anon_sym_extern] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(650),
    [anon_sym_COLON_COLON] = ACTIONS(728),
    [anon_sym_fn] = ACTIONS(650),
    [anon_sym_POUND] = ACTIONS(652),
    [anon_sym_mod] = ACTIONS(650),
    [anon_sym_enum] = ACTIONS(650),
    [anon_sym_impl] = ACTIONS(650),
    [anon_sym_trait] = ACTIONS(650),
    [anon_sym_u8] = ACTIONS(650),
    [anon_sym_i8] = ACTIONS(650),
    [anon_sym_u16] = ACTIONS(650),
    [anon_sym_i16] = ACTIONS(650),
    [anon_sym_u32] = ACTIONS(650),
    [anon_sym_i32] = ACTIONS(650),
    [anon_sym_u64] = ACTIONS(650),
    [anon_sym_i64] = ACTIONS(650),
    [anon_sym_u128] = ACTIONS(650),
    [anon_sym_i128] = ACTIONS(650),
    [anon_sym_u256] = ACTIONS(650),
    [anon_sym_i256] = ACTIONS(650),
    [anon_sym_isize] = ACTIONS(650),
    [anon_sym_usize] = ACTIONS(650),
    [anon_sym_f32] = ACTIONS(650),
    [anon_sym_f64] = ACTIONS(650),
    [anon_sym_felt252] = ACTIONS(650),
    [anon_sym_bool] = ACTIONS(650),
    [anon_sym_str] = ACTIONS(650),
    [anon_sym_char] = ACTIONS(650),
    [anon_sym_GT] = ACTIONS(650),
    [anon_sym_match] = ACTIONS(650),
    [anon_sym_loop] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(650),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_AMP_AMP] = ACTIONS(652),
    [anon_sym_PIPE_PIPE] = ACTIONS(652),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym_LT2] = ACTIONS(650),
    [anon_sym_LT_EQ] = ACTIONS(652),
    [anon_sym_GT_EQ] = ACTIONS(652),
    [anon_sym_LT_LT] = ACTIONS(650),
    [anon_sym_GT_GT] = ACTIONS(650),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_DASH_EQ] = ACTIONS(652),
    [anon_sym_STAR_EQ] = ACTIONS(652),
    [anon_sym_SLASH_EQ] = ACTIONS(652),
    [anon_sym_PERCENT_EQ] = ACTIONS(652),
    [anon_sym_AMP_EQ] = ACTIONS(652),
    [anon_sym_PIPE_EQ] = ACTIONS(652),
    [anon_sym_CARET_EQ] = ACTIONS(652),
    [anon_sym_LT_LT_EQ] = ACTIONS(652),
    [anon_sym_GT_GT_EQ] = ACTIONS(652),
    [anon_sym_QMARK] = ACTIONS(652),
    [sym__cairo_1_short_string] = ACTIONS(652),
    [anon_sym_true] = ACTIONS(650),
    [anon_sym_false] = ACTIONS(650),
    [sym_self] = ACTIONS(650),
  },
  [110] = {
    [sym_identifier] = ACTIONS(730),
    [anon_sym_LPAREN] = ACTIONS(732),
    [anon_sym_EQ] = ACTIONS(730),
    [anon_sym_AT] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(732),
    [anon_sym_RBRACE] = ACTIONS(732),
    [anon_sym_struct] = ACTIONS(730),
    [anon_sym_EQ_EQ] = ACTIONS(732),
    [anon_sym_let] = ACTIONS(730),
    [anon_sym_const] = ACTIONS(730),
    [anon_sym_if] = ACTIONS(730),
    [anon_sym_BANG_EQ] = ACTIONS(732),
    [anon_sym_PLUS_EQ] = ACTIONS(732),
    [anon_sym_return] = ACTIONS(730),
    [anon_sym_STAR] = ACTIONS(730),
    [anon_sym_AMP] = ACTIONS(730),
    [anon_sym_DASH] = ACTIONS(730),
    [anon_sym_PLUS] = ACTIONS(730),
    [anon_sym_SLASH] = ACTIONS(730),
    [anon_sym_LBRACK] = ACTIONS(732),
    [anon_sym_DOT] = ACTIONS(732),
    [sym_number] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(732),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(730),
    [anon_sym_extern] = ACTIONS(730),
    [anon_sym_type] = ACTIONS(730),
    [anon_sym_COLON_COLON] = ACTIONS(732),
    [anon_sym_fn] = ACTIONS(730),
    [anon_sym_POUND] = ACTIONS(732),
    [anon_sym_mod] = ACTIONS(730),
    [anon_sym_enum] = ACTIONS(730),
    [anon_sym_impl] = ACTIONS(730),
    [anon_sym_trait] = ACTIONS(730),
    [anon_sym_u8] = ACTIONS(730),
    [anon_sym_i8] = ACTIONS(730),
    [anon_sym_u16] = ACTIONS(730),
    [anon_sym_i16] = ACTIONS(730),
    [anon_sym_u32] = ACTIONS(730),
    [anon_sym_i32] = ACTIONS(730),
    [anon_sym_u64] = ACTIONS(730),
    [anon_sym_i64] = ACTIONS(730),
    [anon_sym_u128] = ACTIONS(730),
    [anon_sym_i128] = ACTIONS(730),
    [anon_sym_u256] = ACTIONS(730),
    [anon_sym_i256] = ACTIONS(730),
    [anon_sym_isize] = ACTIONS(730),
    [anon_sym_usize] = ACTIONS(730),
    [anon_sym_f32] = ACTIONS(730),
    [anon_sym_f64] = ACTIONS(730),
    [anon_sym_felt252] = ACTIONS(730),
    [anon_sym_bool] = ACTIONS(730),
    [anon_sym_str] = ACTIONS(730),
    [anon_sym_char] = ACTIONS(730),
    [anon_sym_GT] = ACTIONS(730),
    [anon_sym_match] = ACTIONS(730),
    [anon_sym_loop] = ACTIONS(730),
    [anon_sym_BANG] = ACTIONS(730),
    [anon_sym_TILDE] = ACTIONS(732),
    [anon_sym_AMP_AMP] = ACTIONS(732),
    [anon_sym_PIPE_PIPE] = ACTIONS(732),
    [anon_sym_PIPE] = ACTIONS(730),
    [anon_sym_CARET] = ACTIONS(730),
    [anon_sym_LT2] = ACTIONS(730),
    [anon_sym_LT_EQ] = ACTIONS(732),
    [anon_sym_GT_EQ] = ACTIONS(732),
    [anon_sym_LT_LT] = ACTIONS(730),
    [anon_sym_GT_GT] = ACTIONS(730),
    [anon_sym_PERCENT] = ACTIONS(730),
    [anon_sym_DASH_EQ] = ACTIONS(732),
    [anon_sym_STAR_EQ] = ACTIONS(732),
    [anon_sym_SLASH_EQ] = ACTIONS(732),
    [anon_sym_PERCENT_EQ] = ACTIONS(732),
    [anon_sym_AMP_EQ] = ACTIONS(732),
    [anon_sym_PIPE_EQ] = ACTIONS(732),
    [anon_sym_CARET_EQ] = ACTIONS(732),
    [anon_sym_LT_LT_EQ] = ACTIONS(732),
    [anon_sym_GT_GT_EQ] = ACTIONS(732),
    [anon_sym_QMARK] = ACTIONS(732),
    [sym__cairo_1_short_string] = ACTIONS(732),
    [anon_sym_true] = ACTIONS(730),
    [anon_sym_false] = ACTIONS(730),
    [sym_self] = ACTIONS(730),
  },
  [111] = {
    [sym_identifier] = ACTIONS(734),
    [anon_sym_LPAREN] = ACTIONS(736),
    [anon_sym_EQ] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_LBRACE] = ACTIONS(736),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_struct] = ACTIONS(734),
    [anon_sym_EQ_EQ] = ACTIONS(736),
    [anon_sym_let] = ACTIONS(734),
    [anon_sym_const] = ACTIONS(734),
    [anon_sym_if] = ACTIONS(734),
    [anon_sym_BANG_EQ] = ACTIONS(736),
    [anon_sym_PLUS_EQ] = ACTIONS(736),
    [anon_sym_return] = ACTIONS(734),
    [anon_sym_STAR] = ACTIONS(734),
    [anon_sym_AMP] = ACTIONS(734),
    [anon_sym_DASH] = ACTIONS(734),
    [anon_sym_PLUS] = ACTIONS(734),
    [anon_sym_SLASH] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(736),
    [sym_number] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(734),
    [anon_sym_extern] = ACTIONS(734),
    [anon_sym_type] = ACTIONS(734),
    [anon_sym_COLON_COLON] = ACTIONS(736),
    [anon_sym_fn] = ACTIONS(734),
    [anon_sym_POUND] = ACTIONS(736),
    [anon_sym_mod] = ACTIONS(734),
    [anon_sym_enum] = ACTIONS(734),
    [anon_sym_impl] = ACTIONS(734),
    [anon_sym_trait] = ACTIONS(734),
    [anon_sym_u8] = ACTIONS(734),
    [anon_sym_i8] = ACTIONS(734),
    [anon_sym_u16] = ACTIONS(734),
    [anon_sym_i16] = ACTIONS(734),
    [anon_sym_u32] = ACTIONS(734),
    [anon_sym_i32] = ACTIONS(734),
    [anon_sym_u64] = ACTIONS(734),
    [anon_sym_i64] = ACTIONS(734),
    [anon_sym_u128] = ACTIONS(734),
    [anon_sym_i128] = ACTIONS(734),
    [anon_sym_u256] = ACTIONS(734),
    [anon_sym_i256] = ACTIONS(734),
    [anon_sym_isize] = ACTIONS(734),
    [anon_sym_usize] = ACTIONS(734),
    [anon_sym_f32] = ACTIONS(734),
    [anon_sym_f64] = ACTIONS(734),
    [anon_sym_felt252] = ACTIONS(734),
    [anon_sym_bool] = ACTIONS(734),
    [anon_sym_str] = ACTIONS(734),
    [anon_sym_char] = ACTIONS(734),
    [anon_sym_GT] = ACTIONS(734),
    [anon_sym_match] = ACTIONS(734),
    [anon_sym_loop] = ACTIONS(734),
    [anon_sym_BANG] = ACTIONS(734),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_AMP_AMP] = ACTIONS(736),
    [anon_sym_PIPE_PIPE] = ACTIONS(736),
    [anon_sym_PIPE] = ACTIONS(734),
    [anon_sym_CARET] = ACTIONS(734),
    [anon_sym_LT2] = ACTIONS(734),
    [anon_sym_LT_EQ] = ACTIONS(736),
    [anon_sym_GT_EQ] = ACTIONS(736),
    [anon_sym_LT_LT] = ACTIONS(734),
    [anon_sym_GT_GT] = ACTIONS(734),
    [anon_sym_PERCENT] = ACTIONS(734),
    [anon_sym_DASH_EQ] = ACTIONS(736),
    [anon_sym_STAR_EQ] = ACTIONS(736),
    [anon_sym_SLASH_EQ] = ACTIONS(736),
    [anon_sym_PERCENT_EQ] = ACTIONS(736),
    [anon_sym_AMP_EQ] = ACTIONS(736),
    [anon_sym_PIPE_EQ] = ACTIONS(736),
    [anon_sym_CARET_EQ] = ACTIONS(736),
    [anon_sym_LT_LT_EQ] = ACTIONS(736),
    [anon_sym_GT_GT_EQ] = ACTIONS(736),
    [anon_sym_QMARK] = ACTIONS(736),
    [sym__cairo_1_short_string] = ACTIONS(736),
    [anon_sym_true] = ACTIONS(734),
    [anon_sym_false] = ACTIONS(734),
    [sym_self] = ACTIONS(734),
  },
  [112] = {
    [sym_identifier] = ACTIONS(738),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_AT] = ACTIONS(742),
    [anon_sym_LBRACE] = ACTIONS(742),
    [anon_sym_RBRACE] = ACTIONS(742),
    [anon_sym_struct] = ACTIONS(738),
    [anon_sym_EQ_EQ] = ACTIONS(744),
    [anon_sym_let] = ACTIONS(738),
    [anon_sym_const] = ACTIONS(738),
    [anon_sym_if] = ACTIONS(738),
    [anon_sym_BANG_EQ] = ACTIONS(744),
    [anon_sym_PLUS_EQ] = ACTIONS(746),
    [anon_sym_return] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_AMP] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [sym_number] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(738),
    [anon_sym_extern] = ACTIONS(738),
    [anon_sym_type] = ACTIONS(738),
    [anon_sym_COLON_COLON] = ACTIONS(742),
    [anon_sym_fn] = ACTIONS(738),
    [anon_sym_POUND] = ACTIONS(742),
    [anon_sym_mod] = ACTIONS(738),
    [anon_sym_enum] = ACTIONS(738),
    [anon_sym_impl] = ACTIONS(738),
    [anon_sym_trait] = ACTIONS(738),
    [anon_sym_u8] = ACTIONS(738),
    [anon_sym_i8] = ACTIONS(738),
    [anon_sym_u16] = ACTIONS(738),
    [anon_sym_i16] = ACTIONS(738),
    [anon_sym_u32] = ACTIONS(738),
    [anon_sym_i32] = ACTIONS(738),
    [anon_sym_u64] = ACTIONS(738),
    [anon_sym_i64] = ACTIONS(738),
    [anon_sym_u128] = ACTIONS(738),
    [anon_sym_i128] = ACTIONS(738),
    [anon_sym_u256] = ACTIONS(738),
    [anon_sym_i256] = ACTIONS(738),
    [anon_sym_isize] = ACTIONS(738),
    [anon_sym_usize] = ACTIONS(738),
    [anon_sym_f32] = ACTIONS(738),
    [anon_sym_f64] = ACTIONS(738),
    [anon_sym_felt252] = ACTIONS(738),
    [anon_sym_bool] = ACTIONS(738),
    [anon_sym_str] = ACTIONS(738),
    [anon_sym_char] = ACTIONS(738),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_match] = ACTIONS(738),
    [anon_sym_loop] = ACTIONS(738),
    [anon_sym_BANG] = ACTIONS(738),
    [anon_sym_TILDE] = ACTIONS(742),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_PIPE_PIPE] = ACTIONS(758),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_LT2] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(744),
    [anon_sym_GT_EQ] = ACTIONS(744),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(748),
    [anon_sym_DASH_EQ] = ACTIONS(746),
    [anon_sym_STAR_EQ] = ACTIONS(746),
    [anon_sym_SLASH_EQ] = ACTIONS(746),
    [anon_sym_PERCENT_EQ] = ACTIONS(746),
    [anon_sym_AMP_EQ] = ACTIONS(746),
    [anon_sym_PIPE_EQ] = ACTIONS(746),
    [anon_sym_CARET_EQ] = ACTIONS(746),
    [anon_sym_LT_LT_EQ] = ACTIONS(746),
    [anon_sym_GT_GT_EQ] = ACTIONS(746),
    [anon_sym_QMARK] = ACTIONS(764),
    [sym__cairo_1_short_string] = ACTIONS(742),
    [anon_sym_true] = ACTIONS(738),
    [anon_sym_false] = ACTIONS(738),
    [sym_self] = ACTIONS(738),
  },
  [113] = {
    [sym_identifier] = ACTIONS(766),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_AT] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(768),
    [anon_sym_RBRACE] = ACTIONS(768),
    [anon_sym_struct] = ACTIONS(766),
    [anon_sym_EQ_EQ] = ACTIONS(744),
    [anon_sym_let] = ACTIONS(766),
    [anon_sym_const] = ACTIONS(766),
    [anon_sym_if] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(744),
    [anon_sym_PLUS_EQ] = ACTIONS(746),
    [anon_sym_return] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_AMP] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [sym_number] = ACTIONS(768),
    [anon_sym_SEMI] = ACTIONS(768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(766),
    [anon_sym_extern] = ACTIONS(766),
    [anon_sym_type] = ACTIONS(766),
    [anon_sym_COLON_COLON] = ACTIONS(768),
    [anon_sym_fn] = ACTIONS(766),
    [anon_sym_POUND] = ACTIONS(768),
    [anon_sym_mod] = ACTIONS(766),
    [anon_sym_enum] = ACTIONS(766),
    [anon_sym_impl] = ACTIONS(766),
    [anon_sym_trait] = ACTIONS(766),
    [anon_sym_u8] = ACTIONS(766),
    [anon_sym_i8] = ACTIONS(766),
    [anon_sym_u16] = ACTIONS(766),
    [anon_sym_i16] = ACTIONS(766),
    [anon_sym_u32] = ACTIONS(766),
    [anon_sym_i32] = ACTIONS(766),
    [anon_sym_u64] = ACTIONS(766),
    [anon_sym_i64] = ACTIONS(766),
    [anon_sym_u128] = ACTIONS(766),
    [anon_sym_i128] = ACTIONS(766),
    [anon_sym_u256] = ACTIONS(766),
    [anon_sym_i256] = ACTIONS(766),
    [anon_sym_isize] = ACTIONS(766),
    [anon_sym_usize] = ACTIONS(766),
    [anon_sym_f32] = ACTIONS(766),
    [anon_sym_f64] = ACTIONS(766),
    [anon_sym_felt252] = ACTIONS(766),
    [anon_sym_bool] = ACTIONS(766),
    [anon_sym_str] = ACTIONS(766),
    [anon_sym_char] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_match] = ACTIONS(766),
    [anon_sym_loop] = ACTIONS(766),
    [anon_sym_BANG] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(768),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_PIPE_PIPE] = ACTIONS(758),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_LT2] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(744),
    [anon_sym_GT_EQ] = ACTIONS(744),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(748),
    [anon_sym_DASH_EQ] = ACTIONS(746),
    [anon_sym_STAR_EQ] = ACTIONS(746),
    [anon_sym_SLASH_EQ] = ACTIONS(746),
    [anon_sym_PERCENT_EQ] = ACTIONS(746),
    [anon_sym_AMP_EQ] = ACTIONS(746),
    [anon_sym_PIPE_EQ] = ACTIONS(746),
    [anon_sym_CARET_EQ] = ACTIONS(746),
    [anon_sym_LT_LT_EQ] = ACTIONS(746),
    [anon_sym_GT_GT_EQ] = ACTIONS(746),
    [anon_sym_QMARK] = ACTIONS(768),
    [sym__cairo_1_short_string] = ACTIONS(768),
    [anon_sym_true] = ACTIONS(766),
    [anon_sym_false] = ACTIONS(766),
    [sym_self] = ACTIONS(766),
  },
  [114] = {
    [sym_identifier] = ACTIONS(770),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(770),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_RBRACE] = ACTIONS(772),
    [anon_sym_struct] = ACTIONS(770),
    [anon_sym_EQ_EQ] = ACTIONS(772),
    [anon_sym_let] = ACTIONS(770),
    [anon_sym_const] = ACTIONS(770),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_BANG_EQ] = ACTIONS(772),
    [anon_sym_PLUS_EQ] = ACTIONS(772),
    [anon_sym_return] = ACTIONS(770),
    [anon_sym_STAR] = ACTIONS(770),
    [anon_sym_AMP] = ACTIONS(770),
    [anon_sym_DASH] = ACTIONS(770),
    [anon_sym_PLUS] = ACTIONS(770),
    [anon_sym_SLASH] = ACTIONS(770),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [sym_number] = ACTIONS(772),
    [anon_sym_SEMI] = ACTIONS(772),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(770),
    [anon_sym_extern] = ACTIONS(770),
    [anon_sym_type] = ACTIONS(770),
    [anon_sym_COLON_COLON] = ACTIONS(772),
    [anon_sym_fn] = ACTIONS(770),
    [anon_sym_POUND] = ACTIONS(772),
    [anon_sym_mod] = ACTIONS(770),
    [anon_sym_enum] = ACTIONS(770),
    [anon_sym_impl] = ACTIONS(770),
    [anon_sym_trait] = ACTIONS(770),
    [anon_sym_u8] = ACTIONS(770),
    [anon_sym_i8] = ACTIONS(770),
    [anon_sym_u16] = ACTIONS(770),
    [anon_sym_i16] = ACTIONS(770),
    [anon_sym_u32] = ACTIONS(770),
    [anon_sym_i32] = ACTIONS(770),
    [anon_sym_u64] = ACTIONS(770),
    [anon_sym_i64] = ACTIONS(770),
    [anon_sym_u128] = ACTIONS(770),
    [anon_sym_i128] = ACTIONS(770),
    [anon_sym_u256] = ACTIONS(770),
    [anon_sym_i256] = ACTIONS(770),
    [anon_sym_isize] = ACTIONS(770),
    [anon_sym_usize] = ACTIONS(770),
    [anon_sym_f32] = ACTIONS(770),
    [anon_sym_f64] = ACTIONS(770),
    [anon_sym_felt252] = ACTIONS(770),
    [anon_sym_bool] = ACTIONS(770),
    [anon_sym_str] = ACTIONS(770),
    [anon_sym_char] = ACTIONS(770),
    [anon_sym_GT] = ACTIONS(770),
    [anon_sym_match] = ACTIONS(770),
    [anon_sym_loop] = ACTIONS(770),
    [anon_sym_BANG] = ACTIONS(770),
    [anon_sym_TILDE] = ACTIONS(772),
    [anon_sym_AMP_AMP] = ACTIONS(772),
    [anon_sym_PIPE_PIPE] = ACTIONS(772),
    [anon_sym_PIPE] = ACTIONS(770),
    [anon_sym_CARET] = ACTIONS(770),
    [anon_sym_LT2] = ACTIONS(770),
    [anon_sym_LT_EQ] = ACTIONS(772),
    [anon_sym_GT_EQ] = ACTIONS(772),
    [anon_sym_LT_LT] = ACTIONS(770),
    [anon_sym_GT_GT] = ACTIONS(770),
    [anon_sym_PERCENT] = ACTIONS(770),
    [anon_sym_DASH_EQ] = ACTIONS(772),
    [anon_sym_STAR_EQ] = ACTIONS(772),
    [anon_sym_SLASH_EQ] = ACTIONS(772),
    [anon_sym_PERCENT_EQ] = ACTIONS(772),
    [anon_sym_AMP_EQ] = ACTIONS(772),
    [anon_sym_PIPE_EQ] = ACTIONS(772),
    [anon_sym_CARET_EQ] = ACTIONS(772),
    [anon_sym_LT_LT_EQ] = ACTIONS(772),
    [anon_sym_GT_GT_EQ] = ACTIONS(772),
    [anon_sym_QMARK] = ACTIONS(772),
    [sym__cairo_1_short_string] = ACTIONS(772),
    [anon_sym_true] = ACTIONS(770),
    [anon_sym_false] = ACTIONS(770),
    [sym_self] = ACTIONS(770),
  },
  [115] = {
    [sym_identifier] = ACTIONS(774),
    [anon_sym_LPAREN] = ACTIONS(776),
    [anon_sym_EQ] = ACTIONS(774),
    [anon_sym_AT] = ACTIONS(776),
    [anon_sym_LBRACE] = ACTIONS(776),
    [anon_sym_RBRACE] = ACTIONS(776),
    [anon_sym_struct] = ACTIONS(774),
    [anon_sym_EQ_EQ] = ACTIONS(776),
    [anon_sym_let] = ACTIONS(774),
    [anon_sym_const] = ACTIONS(774),
    [anon_sym_if] = ACTIONS(774),
    [anon_sym_BANG_EQ] = ACTIONS(776),
    [anon_sym_PLUS_EQ] = ACTIONS(776),
    [anon_sym_return] = ACTIONS(774),
    [anon_sym_STAR] = ACTIONS(774),
    [anon_sym_AMP] = ACTIONS(774),
    [anon_sym_DASH] = ACTIONS(774),
    [anon_sym_PLUS] = ACTIONS(774),
    [anon_sym_SLASH] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_DOT] = ACTIONS(776),
    [sym_number] = ACTIONS(776),
    [anon_sym_SEMI] = ACTIONS(776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(774),
    [anon_sym_extern] = ACTIONS(774),
    [anon_sym_type] = ACTIONS(774),
    [anon_sym_COLON_COLON] = ACTIONS(776),
    [anon_sym_fn] = ACTIONS(774),
    [anon_sym_POUND] = ACTIONS(776),
    [anon_sym_mod] = ACTIONS(774),
    [anon_sym_enum] = ACTIONS(774),
    [anon_sym_impl] = ACTIONS(774),
    [anon_sym_trait] = ACTIONS(774),
    [anon_sym_u8] = ACTIONS(774),
    [anon_sym_i8] = ACTIONS(774),
    [anon_sym_u16] = ACTIONS(774),
    [anon_sym_i16] = ACTIONS(774),
    [anon_sym_u32] = ACTIONS(774),
    [anon_sym_i32] = ACTIONS(774),
    [anon_sym_u64] = ACTIONS(774),
    [anon_sym_i64] = ACTIONS(774),
    [anon_sym_u128] = ACTIONS(774),
    [anon_sym_i128] = ACTIONS(774),
    [anon_sym_u256] = ACTIONS(774),
    [anon_sym_i256] = ACTIONS(774),
    [anon_sym_isize] = ACTIONS(774),
    [anon_sym_usize] = ACTIONS(774),
    [anon_sym_f32] = ACTIONS(774),
    [anon_sym_f64] = ACTIONS(774),
    [anon_sym_felt252] = ACTIONS(774),
    [anon_sym_bool] = ACTIONS(774),
    [anon_sym_str] = ACTIONS(774),
    [anon_sym_char] = ACTIONS(774),
    [anon_sym_GT] = ACTIONS(774),
    [anon_sym_match] = ACTIONS(774),
    [anon_sym_loop] = ACTIONS(774),
    [anon_sym_BANG] = ACTIONS(774),
    [anon_sym_TILDE] = ACTIONS(776),
    [anon_sym_AMP_AMP] = ACTIONS(776),
    [anon_sym_PIPE_PIPE] = ACTIONS(776),
    [anon_sym_PIPE] = ACTIONS(774),
    [anon_sym_CARET] = ACTIONS(774),
    [anon_sym_LT2] = ACTIONS(774),
    [anon_sym_LT_EQ] = ACTIONS(776),
    [anon_sym_GT_EQ] = ACTIONS(776),
    [anon_sym_LT_LT] = ACTIONS(774),
    [anon_sym_GT_GT] = ACTIONS(774),
    [anon_sym_PERCENT] = ACTIONS(774),
    [anon_sym_DASH_EQ] = ACTIONS(776),
    [anon_sym_STAR_EQ] = ACTIONS(776),
    [anon_sym_SLASH_EQ] = ACTIONS(776),
    [anon_sym_PERCENT_EQ] = ACTIONS(776),
    [anon_sym_AMP_EQ] = ACTIONS(776),
    [anon_sym_PIPE_EQ] = ACTIONS(776),
    [anon_sym_CARET_EQ] = ACTIONS(776),
    [anon_sym_LT_LT_EQ] = ACTIONS(776),
    [anon_sym_GT_GT_EQ] = ACTIONS(776),
    [anon_sym_QMARK] = ACTIONS(776),
    [sym__cairo_1_short_string] = ACTIONS(776),
    [anon_sym_true] = ACTIONS(774),
    [anon_sym_false] = ACTIONS(774),
    [sym_self] = ACTIONS(774),
  },
  [116] = {
    [sym_identifier] = ACTIONS(778),
    [anon_sym_LPAREN] = ACTIONS(780),
    [anon_sym_EQ] = ACTIONS(778),
    [anon_sym_AT] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(780),
    [anon_sym_RBRACE] = ACTIONS(780),
    [anon_sym_struct] = ACTIONS(778),
    [anon_sym_EQ_EQ] = ACTIONS(780),
    [anon_sym_let] = ACTIONS(778),
    [anon_sym_const] = ACTIONS(778),
    [anon_sym_if] = ACTIONS(778),
    [anon_sym_BANG_EQ] = ACTIONS(780),
    [anon_sym_PLUS_EQ] = ACTIONS(780),
    [anon_sym_return] = ACTIONS(778),
    [anon_sym_STAR] = ACTIONS(778),
    [anon_sym_AMP] = ACTIONS(778),
    [anon_sym_DASH] = ACTIONS(778),
    [anon_sym_PLUS] = ACTIONS(778),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(780),
    [anon_sym_DOT] = ACTIONS(780),
    [sym_number] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(778),
    [anon_sym_extern] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(778),
    [anon_sym_COLON_COLON] = ACTIONS(780),
    [anon_sym_fn] = ACTIONS(778),
    [anon_sym_POUND] = ACTIONS(780),
    [anon_sym_mod] = ACTIONS(778),
    [anon_sym_enum] = ACTIONS(778),
    [anon_sym_impl] = ACTIONS(778),
    [anon_sym_trait] = ACTIONS(778),
    [anon_sym_u8] = ACTIONS(778),
    [anon_sym_i8] = ACTIONS(778),
    [anon_sym_u16] = ACTIONS(778),
    [anon_sym_i16] = ACTIONS(778),
    [anon_sym_u32] = ACTIONS(778),
    [anon_sym_i32] = ACTIONS(778),
    [anon_sym_u64] = ACTIONS(778),
    [anon_sym_i64] = ACTIONS(778),
    [anon_sym_u128] = ACTIONS(778),
    [anon_sym_i128] = ACTIONS(778),
    [anon_sym_u256] = ACTIONS(778),
    [anon_sym_i256] = ACTIONS(778),
    [anon_sym_isize] = ACTIONS(778),
    [anon_sym_usize] = ACTIONS(778),
    [anon_sym_f32] = ACTIONS(778),
    [anon_sym_f64] = ACTIONS(778),
    [anon_sym_felt252] = ACTIONS(778),
    [anon_sym_bool] = ACTIONS(778),
    [anon_sym_str] = ACTIONS(778),
    [anon_sym_char] = ACTIONS(778),
    [anon_sym_GT] = ACTIONS(778),
    [anon_sym_match] = ACTIONS(778),
    [anon_sym_loop] = ACTIONS(778),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_AMP_AMP] = ACTIONS(780),
    [anon_sym_PIPE_PIPE] = ACTIONS(780),
    [anon_sym_PIPE] = ACTIONS(778),
    [anon_sym_CARET] = ACTIONS(778),
    [anon_sym_LT2] = ACTIONS(778),
    [anon_sym_LT_EQ] = ACTIONS(780),
    [anon_sym_GT_EQ] = ACTIONS(780),
    [anon_sym_LT_LT] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(778),
    [anon_sym_PERCENT] = ACTIONS(778),
    [anon_sym_DASH_EQ] = ACTIONS(780),
    [anon_sym_STAR_EQ] = ACTIONS(780),
    [anon_sym_SLASH_EQ] = ACTIONS(780),
    [anon_sym_PERCENT_EQ] = ACTIONS(780),
    [anon_sym_AMP_EQ] = ACTIONS(780),
    [anon_sym_PIPE_EQ] = ACTIONS(780),
    [anon_sym_CARET_EQ] = ACTIONS(780),
    [anon_sym_LT_LT_EQ] = ACTIONS(780),
    [anon_sym_GT_GT_EQ] = ACTIONS(780),
    [anon_sym_QMARK] = ACTIONS(780),
    [sym__cairo_1_short_string] = ACTIONS(780),
    [anon_sym_true] = ACTIONS(778),
    [anon_sym_false] = ACTIONS(778),
    [sym_self] = ACTIONS(778),
  },
  [117] = {
    [sym_identifier] = ACTIONS(782),
    [anon_sym_LPAREN] = ACTIONS(784),
    [anon_sym_EQ] = ACTIONS(782),
    [anon_sym_AT] = ACTIONS(784),
    [anon_sym_LBRACE] = ACTIONS(784),
    [anon_sym_RBRACE] = ACTIONS(784),
    [anon_sym_struct] = ACTIONS(782),
    [anon_sym_EQ_EQ] = ACTIONS(784),
    [anon_sym_let] = ACTIONS(782),
    [anon_sym_const] = ACTIONS(782),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_BANG_EQ] = ACTIONS(784),
    [anon_sym_PLUS_EQ] = ACTIONS(784),
    [anon_sym_return] = ACTIONS(782),
    [anon_sym_STAR] = ACTIONS(782),
    [anon_sym_AMP] = ACTIONS(782),
    [anon_sym_DASH] = ACTIONS(782),
    [anon_sym_PLUS] = ACTIONS(782),
    [anon_sym_SLASH] = ACTIONS(782),
    [anon_sym_LBRACK] = ACTIONS(784),
    [anon_sym_DOT] = ACTIONS(784),
    [sym_number] = ACTIONS(784),
    [anon_sym_SEMI] = ACTIONS(784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(782),
    [anon_sym_extern] = ACTIONS(782),
    [anon_sym_type] = ACTIONS(782),
    [anon_sym_COLON_COLON] = ACTIONS(784),
    [anon_sym_fn] = ACTIONS(782),
    [anon_sym_POUND] = ACTIONS(784),
    [anon_sym_mod] = ACTIONS(782),
    [anon_sym_enum] = ACTIONS(782),
    [anon_sym_impl] = ACTIONS(782),
    [anon_sym_trait] = ACTIONS(782),
    [anon_sym_u8] = ACTIONS(782),
    [anon_sym_i8] = ACTIONS(782),
    [anon_sym_u16] = ACTIONS(782),
    [anon_sym_i16] = ACTIONS(782),
    [anon_sym_u32] = ACTIONS(782),
    [anon_sym_i32] = ACTIONS(782),
    [anon_sym_u64] = ACTIONS(782),
    [anon_sym_i64] = ACTIONS(782),
    [anon_sym_u128] = ACTIONS(782),
    [anon_sym_i128] = ACTIONS(782),
    [anon_sym_u256] = ACTIONS(782),
    [anon_sym_i256] = ACTIONS(782),
    [anon_sym_isize] = ACTIONS(782),
    [anon_sym_usize] = ACTIONS(782),
    [anon_sym_f32] = ACTIONS(782),
    [anon_sym_f64] = ACTIONS(782),
    [anon_sym_felt252] = ACTIONS(782),
    [anon_sym_bool] = ACTIONS(782),
    [anon_sym_str] = ACTIONS(782),
    [anon_sym_char] = ACTIONS(782),
    [anon_sym_GT] = ACTIONS(782),
    [anon_sym_match] = ACTIONS(782),
    [anon_sym_loop] = ACTIONS(782),
    [anon_sym_BANG] = ACTIONS(782),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_AMP_AMP] = ACTIONS(784),
    [anon_sym_PIPE_PIPE] = ACTIONS(784),
    [anon_sym_PIPE] = ACTIONS(782),
    [anon_sym_CARET] = ACTIONS(782),
    [anon_sym_LT2] = ACTIONS(782),
    [anon_sym_LT_EQ] = ACTIONS(784),
    [anon_sym_GT_EQ] = ACTIONS(784),
    [anon_sym_LT_LT] = ACTIONS(782),
    [anon_sym_GT_GT] = ACTIONS(782),
    [anon_sym_PERCENT] = ACTIONS(782),
    [anon_sym_DASH_EQ] = ACTIONS(784),
    [anon_sym_STAR_EQ] = ACTIONS(784),
    [anon_sym_SLASH_EQ] = ACTIONS(784),
    [anon_sym_PERCENT_EQ] = ACTIONS(784),
    [anon_sym_AMP_EQ] = ACTIONS(784),
    [anon_sym_PIPE_EQ] = ACTIONS(784),
    [anon_sym_CARET_EQ] = ACTIONS(784),
    [anon_sym_LT_LT_EQ] = ACTIONS(784),
    [anon_sym_GT_GT_EQ] = ACTIONS(784),
    [anon_sym_QMARK] = ACTIONS(784),
    [sym__cairo_1_short_string] = ACTIONS(784),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(782),
    [sym_self] = ACTIONS(782),
  },
  [118] = {
    [sym_identifier] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(788),
    [anon_sym_EQ] = ACTIONS(786),
    [anon_sym_AT] = ACTIONS(788),
    [anon_sym_LBRACE] = ACTIONS(788),
    [anon_sym_RBRACE] = ACTIONS(788),
    [anon_sym_struct] = ACTIONS(786),
    [anon_sym_EQ_EQ] = ACTIONS(788),
    [anon_sym_let] = ACTIONS(786),
    [anon_sym_const] = ACTIONS(786),
    [anon_sym_if] = ACTIONS(786),
    [anon_sym_BANG_EQ] = ACTIONS(788),
    [anon_sym_PLUS_EQ] = ACTIONS(788),
    [anon_sym_return] = ACTIONS(786),
    [anon_sym_STAR] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(786),
    [anon_sym_DASH] = ACTIONS(786),
    [anon_sym_PLUS] = ACTIONS(786),
    [anon_sym_SLASH] = ACTIONS(786),
    [anon_sym_LBRACK] = ACTIONS(788),
    [anon_sym_DOT] = ACTIONS(788),
    [sym_number] = ACTIONS(788),
    [anon_sym_SEMI] = ACTIONS(788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(786),
    [anon_sym_extern] = ACTIONS(786),
    [anon_sym_type] = ACTIONS(786),
    [anon_sym_COLON_COLON] = ACTIONS(788),
    [anon_sym_fn] = ACTIONS(786),
    [anon_sym_POUND] = ACTIONS(788),
    [anon_sym_mod] = ACTIONS(786),
    [anon_sym_enum] = ACTIONS(786),
    [anon_sym_impl] = ACTIONS(786),
    [anon_sym_trait] = ACTIONS(786),
    [anon_sym_u8] = ACTIONS(786),
    [anon_sym_i8] = ACTIONS(786),
    [anon_sym_u16] = ACTIONS(786),
    [anon_sym_i16] = ACTIONS(786),
    [anon_sym_u32] = ACTIONS(786),
    [anon_sym_i32] = ACTIONS(786),
    [anon_sym_u64] = ACTIONS(786),
    [anon_sym_i64] = ACTIONS(786),
    [anon_sym_u128] = ACTIONS(786),
    [anon_sym_i128] = ACTIONS(786),
    [anon_sym_u256] = ACTIONS(786),
    [anon_sym_i256] = ACTIONS(786),
    [anon_sym_isize] = ACTIONS(786),
    [anon_sym_usize] = ACTIONS(786),
    [anon_sym_f32] = ACTIONS(786),
    [anon_sym_f64] = ACTIONS(786),
    [anon_sym_felt252] = ACTIONS(786),
    [anon_sym_bool] = ACTIONS(786),
    [anon_sym_str] = ACTIONS(786),
    [anon_sym_char] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(786),
    [anon_sym_match] = ACTIONS(786),
    [anon_sym_loop] = ACTIONS(786),
    [anon_sym_BANG] = ACTIONS(786),
    [anon_sym_TILDE] = ACTIONS(788),
    [anon_sym_AMP_AMP] = ACTIONS(788),
    [anon_sym_PIPE_PIPE] = ACTIONS(788),
    [anon_sym_PIPE] = ACTIONS(786),
    [anon_sym_CARET] = ACTIONS(786),
    [anon_sym_LT2] = ACTIONS(786),
    [anon_sym_LT_EQ] = ACTIONS(788),
    [anon_sym_GT_EQ] = ACTIONS(788),
    [anon_sym_LT_LT] = ACTIONS(786),
    [anon_sym_GT_GT] = ACTIONS(786),
    [anon_sym_PERCENT] = ACTIONS(786),
    [anon_sym_DASH_EQ] = ACTIONS(788),
    [anon_sym_STAR_EQ] = ACTIONS(788),
    [anon_sym_SLASH_EQ] = ACTIONS(788),
    [anon_sym_PERCENT_EQ] = ACTIONS(788),
    [anon_sym_AMP_EQ] = ACTIONS(788),
    [anon_sym_PIPE_EQ] = ACTIONS(788),
    [anon_sym_CARET_EQ] = ACTIONS(788),
    [anon_sym_LT_LT_EQ] = ACTIONS(788),
    [anon_sym_GT_GT_EQ] = ACTIONS(788),
    [anon_sym_QMARK] = ACTIONS(788),
    [sym__cairo_1_short_string] = ACTIONS(788),
    [anon_sym_true] = ACTIONS(786),
    [anon_sym_false] = ACTIONS(786),
    [sym_self] = ACTIONS(786),
  },
  [119] = {
    [sym_identifier] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_EQ] = ACTIONS(790),
    [anon_sym_AT] = ACTIONS(792),
    [anon_sym_LBRACE] = ACTIONS(792),
    [anon_sym_RBRACE] = ACTIONS(792),
    [anon_sym_struct] = ACTIONS(790),
    [anon_sym_EQ_EQ] = ACTIONS(792),
    [anon_sym_let] = ACTIONS(790),
    [anon_sym_const] = ACTIONS(790),
    [anon_sym_if] = ACTIONS(790),
    [anon_sym_BANG_EQ] = ACTIONS(792),
    [anon_sym_PLUS_EQ] = ACTIONS(792),
    [anon_sym_return] = ACTIONS(790),
    [anon_sym_STAR] = ACTIONS(790),
    [anon_sym_AMP] = ACTIONS(790),
    [anon_sym_DASH] = ACTIONS(790),
    [anon_sym_PLUS] = ACTIONS(790),
    [anon_sym_SLASH] = ACTIONS(790),
    [anon_sym_LBRACK] = ACTIONS(792),
    [anon_sym_DOT] = ACTIONS(792),
    [sym_number] = ACTIONS(792),
    [anon_sym_SEMI] = ACTIONS(792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(790),
    [anon_sym_extern] = ACTIONS(790),
    [anon_sym_type] = ACTIONS(790),
    [anon_sym_COLON_COLON] = ACTIONS(792),
    [anon_sym_fn] = ACTIONS(790),
    [anon_sym_POUND] = ACTIONS(792),
    [anon_sym_mod] = ACTIONS(790),
    [anon_sym_enum] = ACTIONS(790),
    [anon_sym_impl] = ACTIONS(790),
    [anon_sym_trait] = ACTIONS(790),
    [anon_sym_u8] = ACTIONS(790),
    [anon_sym_i8] = ACTIONS(790),
    [anon_sym_u16] = ACTIONS(790),
    [anon_sym_i16] = ACTIONS(790),
    [anon_sym_u32] = ACTIONS(790),
    [anon_sym_i32] = ACTIONS(790),
    [anon_sym_u64] = ACTIONS(790),
    [anon_sym_i64] = ACTIONS(790),
    [anon_sym_u128] = ACTIONS(790),
    [anon_sym_i128] = ACTIONS(790),
    [anon_sym_u256] = ACTIONS(790),
    [anon_sym_i256] = ACTIONS(790),
    [anon_sym_isize] = ACTIONS(790),
    [anon_sym_usize] = ACTIONS(790),
    [anon_sym_f32] = ACTIONS(790),
    [anon_sym_f64] = ACTIONS(790),
    [anon_sym_felt252] = ACTIONS(790),
    [anon_sym_bool] = ACTIONS(790),
    [anon_sym_str] = ACTIONS(790),
    [anon_sym_char] = ACTIONS(790),
    [anon_sym_GT] = ACTIONS(790),
    [anon_sym_match] = ACTIONS(790),
    [anon_sym_loop] = ACTIONS(790),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_TILDE] = ACTIONS(792),
    [anon_sym_AMP_AMP] = ACTIONS(792),
    [anon_sym_PIPE_PIPE] = ACTIONS(792),
    [anon_sym_PIPE] = ACTIONS(790),
    [anon_sym_CARET] = ACTIONS(790),
    [anon_sym_LT2] = ACTIONS(790),
    [anon_sym_LT_EQ] = ACTIONS(792),
    [anon_sym_GT_EQ] = ACTIONS(792),
    [anon_sym_LT_LT] = ACTIONS(790),
    [anon_sym_GT_GT] = ACTIONS(790),
    [anon_sym_PERCENT] = ACTIONS(790),
    [anon_sym_DASH_EQ] = ACTIONS(792),
    [anon_sym_STAR_EQ] = ACTIONS(792),
    [anon_sym_SLASH_EQ] = ACTIONS(792),
    [anon_sym_PERCENT_EQ] = ACTIONS(792),
    [anon_sym_AMP_EQ] = ACTIONS(792),
    [anon_sym_PIPE_EQ] = ACTIONS(792),
    [anon_sym_CARET_EQ] = ACTIONS(792),
    [anon_sym_LT_LT_EQ] = ACTIONS(792),
    [anon_sym_GT_GT_EQ] = ACTIONS(792),
    [anon_sym_QMARK] = ACTIONS(792),
    [sym__cairo_1_short_string] = ACTIONS(792),
    [anon_sym_true] = ACTIONS(790),
    [anon_sym_false] = ACTIONS(790),
    [sym_self] = ACTIONS(790),
  },
  [120] = {
    [sym_identifier] = ACTIONS(794),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_EQ] = ACTIONS(794),
    [anon_sym_AT] = ACTIONS(796),
    [anon_sym_LBRACE] = ACTIONS(796),
    [anon_sym_RBRACE] = ACTIONS(796),
    [anon_sym_struct] = ACTIONS(794),
    [anon_sym_EQ_EQ] = ACTIONS(796),
    [anon_sym_let] = ACTIONS(794),
    [anon_sym_const] = ACTIONS(794),
    [anon_sym_if] = ACTIONS(794),
    [anon_sym_BANG_EQ] = ACTIONS(796),
    [anon_sym_PLUS_EQ] = ACTIONS(796),
    [anon_sym_return] = ACTIONS(794),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_AMP] = ACTIONS(794),
    [anon_sym_DASH] = ACTIONS(794),
    [anon_sym_PLUS] = ACTIONS(794),
    [anon_sym_SLASH] = ACTIONS(794),
    [anon_sym_LBRACK] = ACTIONS(796),
    [anon_sym_DOT] = ACTIONS(796),
    [sym_number] = ACTIONS(796),
    [anon_sym_SEMI] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(794),
    [anon_sym_extern] = ACTIONS(794),
    [anon_sym_type] = ACTIONS(794),
    [anon_sym_COLON_COLON] = ACTIONS(796),
    [anon_sym_fn] = ACTIONS(794),
    [anon_sym_POUND] = ACTIONS(796),
    [anon_sym_mod] = ACTIONS(794),
    [anon_sym_enum] = ACTIONS(794),
    [anon_sym_impl] = ACTIONS(794),
    [anon_sym_trait] = ACTIONS(794),
    [anon_sym_u8] = ACTIONS(794),
    [anon_sym_i8] = ACTIONS(794),
    [anon_sym_u16] = ACTIONS(794),
    [anon_sym_i16] = ACTIONS(794),
    [anon_sym_u32] = ACTIONS(794),
    [anon_sym_i32] = ACTIONS(794),
    [anon_sym_u64] = ACTIONS(794),
    [anon_sym_i64] = ACTIONS(794),
    [anon_sym_u128] = ACTIONS(794),
    [anon_sym_i128] = ACTIONS(794),
    [anon_sym_u256] = ACTIONS(794),
    [anon_sym_i256] = ACTIONS(794),
    [anon_sym_isize] = ACTIONS(794),
    [anon_sym_usize] = ACTIONS(794),
    [anon_sym_f32] = ACTIONS(794),
    [anon_sym_f64] = ACTIONS(794),
    [anon_sym_felt252] = ACTIONS(794),
    [anon_sym_bool] = ACTIONS(794),
    [anon_sym_str] = ACTIONS(794),
    [anon_sym_char] = ACTIONS(794),
    [anon_sym_GT] = ACTIONS(794),
    [anon_sym_match] = ACTIONS(794),
    [anon_sym_loop] = ACTIONS(794),
    [anon_sym_BANG] = ACTIONS(794),
    [anon_sym_TILDE] = ACTIONS(796),
    [anon_sym_AMP_AMP] = ACTIONS(796),
    [anon_sym_PIPE_PIPE] = ACTIONS(796),
    [anon_sym_PIPE] = ACTIONS(794),
    [anon_sym_CARET] = ACTIONS(794),
    [anon_sym_LT2] = ACTIONS(794),
    [anon_sym_LT_EQ] = ACTIONS(796),
    [anon_sym_GT_EQ] = ACTIONS(796),
    [anon_sym_LT_LT] = ACTIONS(794),
    [anon_sym_GT_GT] = ACTIONS(794),
    [anon_sym_PERCENT] = ACTIONS(794),
    [anon_sym_DASH_EQ] = ACTIONS(796),
    [anon_sym_STAR_EQ] = ACTIONS(796),
    [anon_sym_SLASH_EQ] = ACTIONS(796),
    [anon_sym_PERCENT_EQ] = ACTIONS(796),
    [anon_sym_AMP_EQ] = ACTIONS(796),
    [anon_sym_PIPE_EQ] = ACTIONS(796),
    [anon_sym_CARET_EQ] = ACTIONS(796),
    [anon_sym_LT_LT_EQ] = ACTIONS(796),
    [anon_sym_GT_GT_EQ] = ACTIONS(796),
    [anon_sym_QMARK] = ACTIONS(796),
    [sym__cairo_1_short_string] = ACTIONS(796),
    [anon_sym_true] = ACTIONS(794),
    [anon_sym_false] = ACTIONS(794),
    [sym_self] = ACTIONS(794),
  },
  [121] = {
    [sym_identifier] = ACTIONS(798),
    [anon_sym_LPAREN] = ACTIONS(800),
    [anon_sym_EQ] = ACTIONS(798),
    [anon_sym_AT] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(800),
    [anon_sym_RBRACE] = ACTIONS(800),
    [anon_sym_struct] = ACTIONS(798),
    [anon_sym_EQ_EQ] = ACTIONS(800),
    [anon_sym_let] = ACTIONS(798),
    [anon_sym_const] = ACTIONS(798),
    [anon_sym_if] = ACTIONS(798),
    [anon_sym_BANG_EQ] = ACTIONS(800),
    [anon_sym_PLUS_EQ] = ACTIONS(800),
    [anon_sym_return] = ACTIONS(798),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LBRACK] = ACTIONS(800),
    [anon_sym_DOT] = ACTIONS(800),
    [sym_number] = ACTIONS(800),
    [anon_sym_SEMI] = ACTIONS(800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(798),
    [anon_sym_extern] = ACTIONS(798),
    [anon_sym_type] = ACTIONS(798),
    [anon_sym_COLON_COLON] = ACTIONS(800),
    [anon_sym_fn] = ACTIONS(798),
    [anon_sym_POUND] = ACTIONS(800),
    [anon_sym_mod] = ACTIONS(798),
    [anon_sym_enum] = ACTIONS(798),
    [anon_sym_impl] = ACTIONS(798),
    [anon_sym_trait] = ACTIONS(798),
    [anon_sym_u8] = ACTIONS(798),
    [anon_sym_i8] = ACTIONS(798),
    [anon_sym_u16] = ACTIONS(798),
    [anon_sym_i16] = ACTIONS(798),
    [anon_sym_u32] = ACTIONS(798),
    [anon_sym_i32] = ACTIONS(798),
    [anon_sym_u64] = ACTIONS(798),
    [anon_sym_i64] = ACTIONS(798),
    [anon_sym_u128] = ACTIONS(798),
    [anon_sym_i128] = ACTIONS(798),
    [anon_sym_u256] = ACTIONS(798),
    [anon_sym_i256] = ACTIONS(798),
    [anon_sym_isize] = ACTIONS(798),
    [anon_sym_usize] = ACTIONS(798),
    [anon_sym_f32] = ACTIONS(798),
    [anon_sym_f64] = ACTIONS(798),
    [anon_sym_felt252] = ACTIONS(798),
    [anon_sym_bool] = ACTIONS(798),
    [anon_sym_str] = ACTIONS(798),
    [anon_sym_char] = ACTIONS(798),
    [anon_sym_GT] = ACTIONS(798),
    [anon_sym_match] = ACTIONS(798),
    [anon_sym_loop] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(800),
    [anon_sym_PIPE_PIPE] = ACTIONS(800),
    [anon_sym_PIPE] = ACTIONS(798),
    [anon_sym_CARET] = ACTIONS(798),
    [anon_sym_LT2] = ACTIONS(798),
    [anon_sym_LT_EQ] = ACTIONS(800),
    [anon_sym_GT_EQ] = ACTIONS(800),
    [anon_sym_LT_LT] = ACTIONS(798),
    [anon_sym_GT_GT] = ACTIONS(798),
    [anon_sym_PERCENT] = ACTIONS(798),
    [anon_sym_DASH_EQ] = ACTIONS(800),
    [anon_sym_STAR_EQ] = ACTIONS(800),
    [anon_sym_SLASH_EQ] = ACTIONS(800),
    [anon_sym_PERCENT_EQ] = ACTIONS(800),
    [anon_sym_AMP_EQ] = ACTIONS(800),
    [anon_sym_PIPE_EQ] = ACTIONS(800),
    [anon_sym_CARET_EQ] = ACTIONS(800),
    [anon_sym_LT_LT_EQ] = ACTIONS(800),
    [anon_sym_GT_GT_EQ] = ACTIONS(800),
    [anon_sym_QMARK] = ACTIONS(800),
    [sym__cairo_1_short_string] = ACTIONS(800),
    [anon_sym_true] = ACTIONS(798),
    [anon_sym_false] = ACTIONS(798),
    [sym_self] = ACTIONS(798),
  },
  [122] = {
    [sym_identifier] = ACTIONS(802),
    [anon_sym_LPAREN] = ACTIONS(804),
    [anon_sym_EQ] = ACTIONS(802),
    [anon_sym_AT] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(804),
    [anon_sym_RBRACE] = ACTIONS(804),
    [anon_sym_struct] = ACTIONS(802),
    [anon_sym_EQ_EQ] = ACTIONS(804),
    [anon_sym_let] = ACTIONS(802),
    [anon_sym_const] = ACTIONS(802),
    [anon_sym_if] = ACTIONS(802),
    [anon_sym_BANG_EQ] = ACTIONS(804),
    [anon_sym_PLUS_EQ] = ACTIONS(804),
    [anon_sym_return] = ACTIONS(802),
    [anon_sym_STAR] = ACTIONS(802),
    [anon_sym_AMP] = ACTIONS(802),
    [anon_sym_DASH] = ACTIONS(802),
    [anon_sym_PLUS] = ACTIONS(802),
    [anon_sym_SLASH] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_DOT] = ACTIONS(804),
    [sym_number] = ACTIONS(804),
    [anon_sym_SEMI] = ACTIONS(804),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(802),
    [anon_sym_extern] = ACTIONS(802),
    [anon_sym_type] = ACTIONS(802),
    [anon_sym_COLON_COLON] = ACTIONS(804),
    [anon_sym_fn] = ACTIONS(802),
    [anon_sym_POUND] = ACTIONS(804),
    [anon_sym_mod] = ACTIONS(802),
    [anon_sym_enum] = ACTIONS(802),
    [anon_sym_impl] = ACTIONS(802),
    [anon_sym_trait] = ACTIONS(802),
    [anon_sym_u8] = ACTIONS(802),
    [anon_sym_i8] = ACTIONS(802),
    [anon_sym_u16] = ACTIONS(802),
    [anon_sym_i16] = ACTIONS(802),
    [anon_sym_u32] = ACTIONS(802),
    [anon_sym_i32] = ACTIONS(802),
    [anon_sym_u64] = ACTIONS(802),
    [anon_sym_i64] = ACTIONS(802),
    [anon_sym_u128] = ACTIONS(802),
    [anon_sym_i128] = ACTIONS(802),
    [anon_sym_u256] = ACTIONS(802),
    [anon_sym_i256] = ACTIONS(802),
    [anon_sym_isize] = ACTIONS(802),
    [anon_sym_usize] = ACTIONS(802),
    [anon_sym_f32] = ACTIONS(802),
    [anon_sym_f64] = ACTIONS(802),
    [anon_sym_felt252] = ACTIONS(802),
    [anon_sym_bool] = ACTIONS(802),
    [anon_sym_str] = ACTIONS(802),
    [anon_sym_char] = ACTIONS(802),
    [anon_sym_GT] = ACTIONS(802),
    [anon_sym_match] = ACTIONS(802),
    [anon_sym_loop] = ACTIONS(802),
    [anon_sym_BANG] = ACTIONS(802),
    [anon_sym_TILDE] = ACTIONS(804),
    [anon_sym_AMP_AMP] = ACTIONS(804),
    [anon_sym_PIPE_PIPE] = ACTIONS(804),
    [anon_sym_PIPE] = ACTIONS(802),
    [anon_sym_CARET] = ACTIONS(802),
    [anon_sym_LT2] = ACTIONS(802),
    [anon_sym_LT_EQ] = ACTIONS(804),
    [anon_sym_GT_EQ] = ACTIONS(804),
    [anon_sym_LT_LT] = ACTIONS(802),
    [anon_sym_GT_GT] = ACTIONS(802),
    [anon_sym_PERCENT] = ACTIONS(802),
    [anon_sym_DASH_EQ] = ACTIONS(804),
    [anon_sym_STAR_EQ] = ACTIONS(804),
    [anon_sym_SLASH_EQ] = ACTIONS(804),
    [anon_sym_PERCENT_EQ] = ACTIONS(804),
    [anon_sym_AMP_EQ] = ACTIONS(804),
    [anon_sym_PIPE_EQ] = ACTIONS(804),
    [anon_sym_CARET_EQ] = ACTIONS(804),
    [anon_sym_LT_LT_EQ] = ACTIONS(804),
    [anon_sym_GT_GT_EQ] = ACTIONS(804),
    [anon_sym_QMARK] = ACTIONS(804),
    [sym__cairo_1_short_string] = ACTIONS(804),
    [anon_sym_true] = ACTIONS(802),
    [anon_sym_false] = ACTIONS(802),
    [sym_self] = ACTIONS(802),
  },
  [123] = {
    [sym_identifier] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_EQ] = ACTIONS(806),
    [anon_sym_AT] = ACTIONS(808),
    [anon_sym_LBRACE] = ACTIONS(808),
    [anon_sym_RBRACE] = ACTIONS(808),
    [anon_sym_struct] = ACTIONS(806),
    [anon_sym_EQ_EQ] = ACTIONS(808),
    [anon_sym_let] = ACTIONS(806),
    [anon_sym_const] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_BANG_EQ] = ACTIONS(808),
    [anon_sym_PLUS_EQ] = ACTIONS(808),
    [anon_sym_return] = ACTIONS(806),
    [anon_sym_STAR] = ACTIONS(806),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_SLASH] = ACTIONS(806),
    [anon_sym_LBRACK] = ACTIONS(808),
    [anon_sym_DOT] = ACTIONS(808),
    [sym_number] = ACTIONS(808),
    [anon_sym_SEMI] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(806),
    [anon_sym_extern] = ACTIONS(806),
    [anon_sym_type] = ACTIONS(806),
    [anon_sym_COLON_COLON] = ACTIONS(808),
    [anon_sym_fn] = ACTIONS(806),
    [anon_sym_POUND] = ACTIONS(808),
    [anon_sym_mod] = ACTIONS(806),
    [anon_sym_enum] = ACTIONS(806),
    [anon_sym_impl] = ACTIONS(806),
    [anon_sym_trait] = ACTIONS(806),
    [anon_sym_u8] = ACTIONS(806),
    [anon_sym_i8] = ACTIONS(806),
    [anon_sym_u16] = ACTIONS(806),
    [anon_sym_i16] = ACTIONS(806),
    [anon_sym_u32] = ACTIONS(806),
    [anon_sym_i32] = ACTIONS(806),
    [anon_sym_u64] = ACTIONS(806),
    [anon_sym_i64] = ACTIONS(806),
    [anon_sym_u128] = ACTIONS(806),
    [anon_sym_i128] = ACTIONS(806),
    [anon_sym_u256] = ACTIONS(806),
    [anon_sym_i256] = ACTIONS(806),
    [anon_sym_isize] = ACTIONS(806),
    [anon_sym_usize] = ACTIONS(806),
    [anon_sym_f32] = ACTIONS(806),
    [anon_sym_f64] = ACTIONS(806),
    [anon_sym_felt252] = ACTIONS(806),
    [anon_sym_bool] = ACTIONS(806),
    [anon_sym_str] = ACTIONS(806),
    [anon_sym_char] = ACTIONS(806),
    [anon_sym_GT] = ACTIONS(806),
    [anon_sym_match] = ACTIONS(806),
    [anon_sym_loop] = ACTIONS(806),
    [anon_sym_BANG] = ACTIONS(806),
    [anon_sym_TILDE] = ACTIONS(808),
    [anon_sym_AMP_AMP] = ACTIONS(808),
    [anon_sym_PIPE_PIPE] = ACTIONS(808),
    [anon_sym_PIPE] = ACTIONS(806),
    [anon_sym_CARET] = ACTIONS(806),
    [anon_sym_LT2] = ACTIONS(806),
    [anon_sym_LT_EQ] = ACTIONS(808),
    [anon_sym_GT_EQ] = ACTIONS(808),
    [anon_sym_LT_LT] = ACTIONS(806),
    [anon_sym_GT_GT] = ACTIONS(806),
    [anon_sym_PERCENT] = ACTIONS(806),
    [anon_sym_DASH_EQ] = ACTIONS(808),
    [anon_sym_STAR_EQ] = ACTIONS(808),
    [anon_sym_SLASH_EQ] = ACTIONS(808),
    [anon_sym_PERCENT_EQ] = ACTIONS(808),
    [anon_sym_AMP_EQ] = ACTIONS(808),
    [anon_sym_PIPE_EQ] = ACTIONS(808),
    [anon_sym_CARET_EQ] = ACTIONS(808),
    [anon_sym_LT_LT_EQ] = ACTIONS(808),
    [anon_sym_GT_GT_EQ] = ACTIONS(808),
    [anon_sym_QMARK] = ACTIONS(808),
    [sym__cairo_1_short_string] = ACTIONS(808),
    [anon_sym_true] = ACTIONS(806),
    [anon_sym_false] = ACTIONS(806),
    [sym_self] = ACTIONS(806),
  },
  [124] = {
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(810),
    [anon_sym_AT] = ACTIONS(812),
    [anon_sym_LBRACE] = ACTIONS(812),
    [anon_sym_RBRACE] = ACTIONS(812),
    [anon_sym_struct] = ACTIONS(810),
    [anon_sym_EQ_EQ] = ACTIONS(744),
    [anon_sym_let] = ACTIONS(810),
    [anon_sym_const] = ACTIONS(810),
    [anon_sym_if] = ACTIONS(810),
    [anon_sym_BANG_EQ] = ACTIONS(744),
    [anon_sym_PLUS_EQ] = ACTIONS(812),
    [anon_sym_return] = ACTIONS(810),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_AMP] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [sym_number] = ACTIONS(812),
    [anon_sym_SEMI] = ACTIONS(812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(810),
    [anon_sym_extern] = ACTIONS(810),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_COLON_COLON] = ACTIONS(812),
    [anon_sym_fn] = ACTIONS(810),
    [anon_sym_POUND] = ACTIONS(812),
    [anon_sym_mod] = ACTIONS(810),
    [anon_sym_enum] = ACTIONS(810),
    [anon_sym_impl] = ACTIONS(810),
    [anon_sym_trait] = ACTIONS(810),
    [anon_sym_u8] = ACTIONS(810),
    [anon_sym_i8] = ACTIONS(810),
    [anon_sym_u16] = ACTIONS(810),
    [anon_sym_i16] = ACTIONS(810),
    [anon_sym_u32] = ACTIONS(810),
    [anon_sym_i32] = ACTIONS(810),
    [anon_sym_u64] = ACTIONS(810),
    [anon_sym_i64] = ACTIONS(810),
    [anon_sym_u128] = ACTIONS(810),
    [anon_sym_i128] = ACTIONS(810),
    [anon_sym_u256] = ACTIONS(810),
    [anon_sym_i256] = ACTIONS(810),
    [anon_sym_isize] = ACTIONS(810),
    [anon_sym_usize] = ACTIONS(810),
    [anon_sym_f32] = ACTIONS(810),
    [anon_sym_f64] = ACTIONS(810),
    [anon_sym_felt252] = ACTIONS(810),
    [anon_sym_bool] = ACTIONS(810),
    [anon_sym_str] = ACTIONS(810),
    [anon_sym_char] = ACTIONS(810),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_match] = ACTIONS(810),
    [anon_sym_loop] = ACTIONS(810),
    [anon_sym_BANG] = ACTIONS(810),
    [anon_sym_TILDE] = ACTIONS(812),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_PIPE_PIPE] = ACTIONS(758),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_LT2] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(744),
    [anon_sym_GT_EQ] = ACTIONS(744),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(748),
    [anon_sym_DASH_EQ] = ACTIONS(812),
    [anon_sym_STAR_EQ] = ACTIONS(812),
    [anon_sym_SLASH_EQ] = ACTIONS(812),
    [anon_sym_PERCENT_EQ] = ACTIONS(812),
    [anon_sym_AMP_EQ] = ACTIONS(812),
    [anon_sym_PIPE_EQ] = ACTIONS(812),
    [anon_sym_CARET_EQ] = ACTIONS(812),
    [anon_sym_LT_LT_EQ] = ACTIONS(812),
    [anon_sym_GT_GT_EQ] = ACTIONS(812),
    [anon_sym_QMARK] = ACTIONS(812),
    [sym__cairo_1_short_string] = ACTIONS(812),
    [anon_sym_true] = ACTIONS(810),
    [anon_sym_false] = ACTIONS(810),
    [sym_self] = ACTIONS(810),
  },
  [125] = {
    [sym_identifier] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(672),
    [anon_sym_struct] = ACTIONS(668),
    [anon_sym_EQ_EQ] = ACTIONS(672),
    [anon_sym_let] = ACTIONS(668),
    [anon_sym_const] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(672),
    [anon_sym_PLUS_EQ] = ACTIONS(672),
    [anon_sym_return] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_AMP] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [sym_number] = ACTIONS(672),
    [anon_sym_SEMI] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(668),
    [anon_sym_extern] = ACTIONS(668),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [anon_sym_fn] = ACTIONS(668),
    [anon_sym_POUND] = ACTIONS(672),
    [anon_sym_mod] = ACTIONS(668),
    [anon_sym_enum] = ACTIONS(668),
    [anon_sym_impl] = ACTIONS(668),
    [anon_sym_trait] = ACTIONS(668),
    [anon_sym_u8] = ACTIONS(668),
    [anon_sym_i8] = ACTIONS(668),
    [anon_sym_u16] = ACTIONS(668),
    [anon_sym_i16] = ACTIONS(668),
    [anon_sym_u32] = ACTIONS(668),
    [anon_sym_i32] = ACTIONS(668),
    [anon_sym_u64] = ACTIONS(668),
    [anon_sym_i64] = ACTIONS(668),
    [anon_sym_u128] = ACTIONS(668),
    [anon_sym_i128] = ACTIONS(668),
    [anon_sym_u256] = ACTIONS(668),
    [anon_sym_i256] = ACTIONS(668),
    [anon_sym_isize] = ACTIONS(668),
    [anon_sym_usize] = ACTIONS(668),
    [anon_sym_f32] = ACTIONS(668),
    [anon_sym_f64] = ACTIONS(668),
    [anon_sym_felt252] = ACTIONS(668),
    [anon_sym_bool] = ACTIONS(668),
    [anon_sym_str] = ACTIONS(668),
    [anon_sym_char] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_match] = ACTIONS(668),
    [anon_sym_loop] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(672),
    [anon_sym_AMP_AMP] = ACTIONS(672),
    [anon_sym_PIPE_PIPE] = ACTIONS(672),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_LT2] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(748),
    [anon_sym_DASH_EQ] = ACTIONS(672),
    [anon_sym_STAR_EQ] = ACTIONS(672),
    [anon_sym_SLASH_EQ] = ACTIONS(672),
    [anon_sym_PERCENT_EQ] = ACTIONS(672),
    [anon_sym_AMP_EQ] = ACTIONS(672),
    [anon_sym_PIPE_EQ] = ACTIONS(672),
    [anon_sym_CARET_EQ] = ACTIONS(672),
    [anon_sym_LT_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_GT_EQ] = ACTIONS(672),
    [anon_sym_QMARK] = ACTIONS(672),
    [sym__cairo_1_short_string] = ACTIONS(672),
    [anon_sym_true] = ACTIONS(668),
    [anon_sym_false] = ACTIONS(668),
    [sym_self] = ACTIONS(668),
  },
  [126] = {
    [sym_identifier] = ACTIONS(814),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(814),
    [anon_sym_AT] = ACTIONS(816),
    [anon_sym_LBRACE] = ACTIONS(816),
    [anon_sym_RBRACE] = ACTIONS(816),
    [anon_sym_struct] = ACTIONS(814),
    [anon_sym_EQ_EQ] = ACTIONS(744),
    [anon_sym_let] = ACTIONS(814),
    [anon_sym_const] = ACTIONS(814),
    [anon_sym_if] = ACTIONS(814),
    [anon_sym_BANG_EQ] = ACTIONS(744),
    [anon_sym_PLUS_EQ] = ACTIONS(816),
    [anon_sym_return] = ACTIONS(814),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_AMP] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [sym_number] = ACTIONS(816),
    [anon_sym_SEMI] = ACTIONS(816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(814),
    [anon_sym_extern] = ACTIONS(814),
    [anon_sym_type] = ACTIONS(814),
    [anon_sym_COLON_COLON] = ACTIONS(816),
    [anon_sym_fn] = ACTIONS(814),
    [anon_sym_POUND] = ACTIONS(816),
    [anon_sym_mod] = ACTIONS(814),
    [anon_sym_enum] = ACTIONS(814),
    [anon_sym_impl] = ACTIONS(814),
    [anon_sym_trait] = ACTIONS(814),
    [anon_sym_u8] = ACTIONS(814),
    [anon_sym_i8] = ACTIONS(814),
    [anon_sym_u16] = ACTIONS(814),
    [anon_sym_i16] = ACTIONS(814),
    [anon_sym_u32] = ACTIONS(814),
    [anon_sym_i32] = ACTIONS(814),
    [anon_sym_u64] = ACTIONS(814),
    [anon_sym_i64] = ACTIONS(814),
    [anon_sym_u128] = ACTIONS(814),
    [anon_sym_i128] = ACTIONS(814),
    [anon_sym_u256] = ACTIONS(814),
    [anon_sym_i256] = ACTIONS(814),
    [anon_sym_isize] = ACTIONS(814),
    [anon_sym_usize] = ACTIONS(814),
    [anon_sym_f32] = ACTIONS(814),
    [anon_sym_f64] = ACTIONS(814),
    [anon_sym_felt252] = ACTIONS(814),
    [anon_sym_bool] = ACTIONS(814),
    [anon_sym_str] = ACTIONS(814),
    [anon_sym_char] = ACTIONS(814),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_match] = ACTIONS(814),
    [anon_sym_loop] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(816),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_PIPE_PIPE] = ACTIONS(758),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_LT2] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(744),
    [anon_sym_GT_EQ] = ACTIONS(744),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(748),
    [anon_sym_DASH_EQ] = ACTIONS(816),
    [anon_sym_STAR_EQ] = ACTIONS(816),
    [anon_sym_SLASH_EQ] = ACTIONS(816),
    [anon_sym_PERCENT_EQ] = ACTIONS(816),
    [anon_sym_AMP_EQ] = ACTIONS(816),
    [anon_sym_PIPE_EQ] = ACTIONS(816),
    [anon_sym_CARET_EQ] = ACTIONS(816),
    [anon_sym_LT_LT_EQ] = ACTIONS(816),
    [anon_sym_GT_GT_EQ] = ACTIONS(816),
    [anon_sym_QMARK] = ACTIONS(816),
    [sym__cairo_1_short_string] = ACTIONS(816),
    [anon_sym_true] = ACTIONS(814),
    [anon_sym_false] = ACTIONS(814),
    [sym_self] = ACTIONS(814),
  },
  [127] = {
    [sym_identifier] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(672),
    [anon_sym_struct] = ACTIONS(668),
    [anon_sym_EQ_EQ] = ACTIONS(672),
    [anon_sym_let] = ACTIONS(668),
    [anon_sym_const] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(672),
    [anon_sym_PLUS_EQ] = ACTIONS(672),
    [anon_sym_return] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [sym_number] = ACTIONS(672),
    [anon_sym_SEMI] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(668),
    [anon_sym_extern] = ACTIONS(668),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [anon_sym_fn] = ACTIONS(668),
    [anon_sym_POUND] = ACTIONS(672),
    [anon_sym_mod] = ACTIONS(668),
    [anon_sym_enum] = ACTIONS(668),
    [anon_sym_impl] = ACTIONS(668),
    [anon_sym_trait] = ACTIONS(668),
    [anon_sym_u8] = ACTIONS(668),
    [anon_sym_i8] = ACTIONS(668),
    [anon_sym_u16] = ACTIONS(668),
    [anon_sym_i16] = ACTIONS(668),
    [anon_sym_u32] = ACTIONS(668),
    [anon_sym_i32] = ACTIONS(668),
    [anon_sym_u64] = ACTIONS(668),
    [anon_sym_i64] = ACTIONS(668),
    [anon_sym_u128] = ACTIONS(668),
    [anon_sym_i128] = ACTIONS(668),
    [anon_sym_u256] = ACTIONS(668),
    [anon_sym_i256] = ACTIONS(668),
    [anon_sym_isize] = ACTIONS(668),
    [anon_sym_usize] = ACTIONS(668),
    [anon_sym_f32] = ACTIONS(668),
    [anon_sym_f64] = ACTIONS(668),
    [anon_sym_felt252] = ACTIONS(668),
    [anon_sym_bool] = ACTIONS(668),
    [anon_sym_str] = ACTIONS(668),
    [anon_sym_char] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_match] = ACTIONS(668),
    [anon_sym_loop] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(672),
    [anon_sym_AMP_AMP] = ACTIONS(672),
    [anon_sym_PIPE_PIPE] = ACTIONS(672),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_LT2] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_DASH_EQ] = ACTIONS(672),
    [anon_sym_STAR_EQ] = ACTIONS(672),
    [anon_sym_SLASH_EQ] = ACTIONS(672),
    [anon_sym_PERCENT_EQ] = ACTIONS(672),
    [anon_sym_AMP_EQ] = ACTIONS(672),
    [anon_sym_PIPE_EQ] = ACTIONS(672),
    [anon_sym_CARET_EQ] = ACTIONS(672),
    [anon_sym_LT_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_GT_EQ] = ACTIONS(672),
    [anon_sym_QMARK] = ACTIONS(672),
    [sym__cairo_1_short_string] = ACTIONS(672),
    [anon_sym_true] = ACTIONS(668),
    [anon_sym_false] = ACTIONS(668),
    [sym_self] = ACTIONS(668),
  },
  [128] = {
    [sym_identifier] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(672),
    [anon_sym_struct] = ACTIONS(668),
    [anon_sym_EQ_EQ] = ACTIONS(672),
    [anon_sym_let] = ACTIONS(668),
    [anon_sym_const] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(672),
    [anon_sym_PLUS_EQ] = ACTIONS(672),
    [anon_sym_return] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [sym_number] = ACTIONS(672),
    [anon_sym_SEMI] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(668),
    [anon_sym_extern] = ACTIONS(668),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [anon_sym_fn] = ACTIONS(668),
    [anon_sym_POUND] = ACTIONS(672),
    [anon_sym_mod] = ACTIONS(668),
    [anon_sym_enum] = ACTIONS(668),
    [anon_sym_impl] = ACTIONS(668),
    [anon_sym_trait] = ACTIONS(668),
    [anon_sym_u8] = ACTIONS(668),
    [anon_sym_i8] = ACTIONS(668),
    [anon_sym_u16] = ACTIONS(668),
    [anon_sym_i16] = ACTIONS(668),
    [anon_sym_u32] = ACTIONS(668),
    [anon_sym_i32] = ACTIONS(668),
    [anon_sym_u64] = ACTIONS(668),
    [anon_sym_i64] = ACTIONS(668),
    [anon_sym_u128] = ACTIONS(668),
    [anon_sym_i128] = ACTIONS(668),
    [anon_sym_u256] = ACTIONS(668),
    [anon_sym_i256] = ACTIONS(668),
    [anon_sym_isize] = ACTIONS(668),
    [anon_sym_usize] = ACTIONS(668),
    [anon_sym_f32] = ACTIONS(668),
    [anon_sym_f64] = ACTIONS(668),
    [anon_sym_felt252] = ACTIONS(668),
    [anon_sym_bool] = ACTIONS(668),
    [anon_sym_str] = ACTIONS(668),
    [anon_sym_char] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_match] = ACTIONS(668),
    [anon_sym_loop] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(672),
    [anon_sym_AMP_AMP] = ACTIONS(672),
    [anon_sym_PIPE_PIPE] = ACTIONS(672),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_LT2] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_DASH_EQ] = ACTIONS(672),
    [anon_sym_STAR_EQ] = ACTIONS(672),
    [anon_sym_SLASH_EQ] = ACTIONS(672),
    [anon_sym_PERCENT_EQ] = ACTIONS(672),
    [anon_sym_AMP_EQ] = ACTIONS(672),
    [anon_sym_PIPE_EQ] = ACTIONS(672),
    [anon_sym_CARET_EQ] = ACTIONS(672),
    [anon_sym_LT_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_GT_EQ] = ACTIONS(672),
    [anon_sym_QMARK] = ACTIONS(672),
    [sym__cairo_1_short_string] = ACTIONS(672),
    [anon_sym_true] = ACTIONS(668),
    [anon_sym_false] = ACTIONS(668),
    [sym_self] = ACTIONS(668),
  },
  [129] = {
    [sym_identifier] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(672),
    [anon_sym_struct] = ACTIONS(668),
    [anon_sym_EQ_EQ] = ACTIONS(672),
    [anon_sym_let] = ACTIONS(668),
    [anon_sym_const] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(672),
    [anon_sym_PLUS_EQ] = ACTIONS(672),
    [anon_sym_return] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_AMP] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [sym_number] = ACTIONS(672),
    [anon_sym_SEMI] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(668),
    [anon_sym_extern] = ACTIONS(668),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [anon_sym_fn] = ACTIONS(668),
    [anon_sym_POUND] = ACTIONS(672),
    [anon_sym_mod] = ACTIONS(668),
    [anon_sym_enum] = ACTIONS(668),
    [anon_sym_impl] = ACTIONS(668),
    [anon_sym_trait] = ACTIONS(668),
    [anon_sym_u8] = ACTIONS(668),
    [anon_sym_i8] = ACTIONS(668),
    [anon_sym_u16] = ACTIONS(668),
    [anon_sym_i16] = ACTIONS(668),
    [anon_sym_u32] = ACTIONS(668),
    [anon_sym_i32] = ACTIONS(668),
    [anon_sym_u64] = ACTIONS(668),
    [anon_sym_i64] = ACTIONS(668),
    [anon_sym_u128] = ACTIONS(668),
    [anon_sym_i128] = ACTIONS(668),
    [anon_sym_u256] = ACTIONS(668),
    [anon_sym_i256] = ACTIONS(668),
    [anon_sym_isize] = ACTIONS(668),
    [anon_sym_usize] = ACTIONS(668),
    [anon_sym_f32] = ACTIONS(668),
    [anon_sym_f64] = ACTIONS(668),
    [anon_sym_felt252] = ACTIONS(668),
    [anon_sym_bool] = ACTIONS(668),
    [anon_sym_str] = ACTIONS(668),
    [anon_sym_char] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_match] = ACTIONS(668),
    [anon_sym_loop] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(672),
    [anon_sym_AMP_AMP] = ACTIONS(672),
    [anon_sym_PIPE_PIPE] = ACTIONS(672),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_LT2] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(748),
    [anon_sym_DASH_EQ] = ACTIONS(672),
    [anon_sym_STAR_EQ] = ACTIONS(672),
    [anon_sym_SLASH_EQ] = ACTIONS(672),
    [anon_sym_PERCENT_EQ] = ACTIONS(672),
    [anon_sym_AMP_EQ] = ACTIONS(672),
    [anon_sym_PIPE_EQ] = ACTIONS(672),
    [anon_sym_CARET_EQ] = ACTIONS(672),
    [anon_sym_LT_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_GT_EQ] = ACTIONS(672),
    [anon_sym_QMARK] = ACTIONS(672),
    [sym__cairo_1_short_string] = ACTIONS(672),
    [anon_sym_true] = ACTIONS(668),
    [anon_sym_false] = ACTIONS(668),
    [sym_self] = ACTIONS(668),
  },
  [130] = {
    [sym_identifier] = ACTIONS(818),
    [anon_sym_LPAREN] = ACTIONS(820),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_AT] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(820),
    [anon_sym_RBRACE] = ACTIONS(820),
    [anon_sym_struct] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(820),
    [anon_sym_let] = ACTIONS(818),
    [anon_sym_const] = ACTIONS(818),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_BANG_EQ] = ACTIONS(820),
    [anon_sym_PLUS_EQ] = ACTIONS(820),
    [anon_sym_return] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(818),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(820),
    [anon_sym_DOT] = ACTIONS(820),
    [sym_number] = ACTIONS(820),
    [anon_sym_SEMI] = ACTIONS(820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(818),
    [anon_sym_extern] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(818),
    [anon_sym_COLON_COLON] = ACTIONS(820),
    [anon_sym_fn] = ACTIONS(818),
    [anon_sym_POUND] = ACTIONS(820),
    [anon_sym_mod] = ACTIONS(818),
    [anon_sym_enum] = ACTIONS(818),
    [anon_sym_impl] = ACTIONS(818),
    [anon_sym_trait] = ACTIONS(818),
    [anon_sym_u8] = ACTIONS(818),
    [anon_sym_i8] = ACTIONS(818),
    [anon_sym_u16] = ACTIONS(818),
    [anon_sym_i16] = ACTIONS(818),
    [anon_sym_u32] = ACTIONS(818),
    [anon_sym_i32] = ACTIONS(818),
    [anon_sym_u64] = ACTIONS(818),
    [anon_sym_i64] = ACTIONS(818),
    [anon_sym_u128] = ACTIONS(818),
    [anon_sym_i128] = ACTIONS(818),
    [anon_sym_u256] = ACTIONS(818),
    [anon_sym_i256] = ACTIONS(818),
    [anon_sym_isize] = ACTIONS(818),
    [anon_sym_usize] = ACTIONS(818),
    [anon_sym_f32] = ACTIONS(818),
    [anon_sym_f64] = ACTIONS(818),
    [anon_sym_felt252] = ACTIONS(818),
    [anon_sym_bool] = ACTIONS(818),
    [anon_sym_str] = ACTIONS(818),
    [anon_sym_char] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_match] = ACTIONS(818),
    [anon_sym_loop] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_AMP_AMP] = ACTIONS(820),
    [anon_sym_PIPE_PIPE] = ACTIONS(820),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(818),
    [anon_sym_LT2] = ACTIONS(818),
    [anon_sym_LT_EQ] = ACTIONS(820),
    [anon_sym_GT_EQ] = ACTIONS(820),
    [anon_sym_LT_LT] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_DASH_EQ] = ACTIONS(820),
    [anon_sym_STAR_EQ] = ACTIONS(820),
    [anon_sym_SLASH_EQ] = ACTIONS(820),
    [anon_sym_PERCENT_EQ] = ACTIONS(820),
    [anon_sym_AMP_EQ] = ACTIONS(820),
    [anon_sym_PIPE_EQ] = ACTIONS(820),
    [anon_sym_CARET_EQ] = ACTIONS(820),
    [anon_sym_LT_LT_EQ] = ACTIONS(820),
    [anon_sym_GT_GT_EQ] = ACTIONS(820),
    [anon_sym_QMARK] = ACTIONS(820),
    [sym__cairo_1_short_string] = ACTIONS(820),
    [anon_sym_true] = ACTIONS(818),
    [anon_sym_false] = ACTIONS(818),
    [sym_self] = ACTIONS(818),
  },
  [131] = {
    [sym_identifier] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(672),
    [anon_sym_struct] = ACTIONS(668),
    [anon_sym_EQ_EQ] = ACTIONS(744),
    [anon_sym_let] = ACTIONS(668),
    [anon_sym_const] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(744),
    [anon_sym_PLUS_EQ] = ACTIONS(672),
    [anon_sym_return] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_AMP] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [sym_number] = ACTIONS(672),
    [anon_sym_SEMI] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(668),
    [anon_sym_extern] = ACTIONS(668),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [anon_sym_fn] = ACTIONS(668),
    [anon_sym_POUND] = ACTIONS(672),
    [anon_sym_mod] = ACTIONS(668),
    [anon_sym_enum] = ACTIONS(668),
    [anon_sym_impl] = ACTIONS(668),
    [anon_sym_trait] = ACTIONS(668),
    [anon_sym_u8] = ACTIONS(668),
    [anon_sym_i8] = ACTIONS(668),
    [anon_sym_u16] = ACTIONS(668),
    [anon_sym_i16] = ACTIONS(668),
    [anon_sym_u32] = ACTIONS(668),
    [anon_sym_i32] = ACTIONS(668),
    [anon_sym_u64] = ACTIONS(668),
    [anon_sym_i64] = ACTIONS(668),
    [anon_sym_u128] = ACTIONS(668),
    [anon_sym_i128] = ACTIONS(668),
    [anon_sym_u256] = ACTIONS(668),
    [anon_sym_i256] = ACTIONS(668),
    [anon_sym_isize] = ACTIONS(668),
    [anon_sym_usize] = ACTIONS(668),
    [anon_sym_f32] = ACTIONS(668),
    [anon_sym_f64] = ACTIONS(668),
    [anon_sym_felt252] = ACTIONS(668),
    [anon_sym_bool] = ACTIONS(668),
    [anon_sym_str] = ACTIONS(668),
    [anon_sym_char] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_match] = ACTIONS(668),
    [anon_sym_loop] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(672),
    [anon_sym_AMP_AMP] = ACTIONS(672),
    [anon_sym_PIPE_PIPE] = ACTIONS(672),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_LT2] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(744),
    [anon_sym_GT_EQ] = ACTIONS(744),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(748),
    [anon_sym_DASH_EQ] = ACTIONS(672),
    [anon_sym_STAR_EQ] = ACTIONS(672),
    [anon_sym_SLASH_EQ] = ACTIONS(672),
    [anon_sym_PERCENT_EQ] = ACTIONS(672),
    [anon_sym_AMP_EQ] = ACTIONS(672),
    [anon_sym_PIPE_EQ] = ACTIONS(672),
    [anon_sym_CARET_EQ] = ACTIONS(672),
    [anon_sym_LT_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_GT_EQ] = ACTIONS(672),
    [anon_sym_QMARK] = ACTIONS(672),
    [sym__cairo_1_short_string] = ACTIONS(672),
    [anon_sym_true] = ACTIONS(668),
    [anon_sym_false] = ACTIONS(668),
    [sym_self] = ACTIONS(668),
  },
  [132] = {
    [sym_identifier] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(672),
    [anon_sym_struct] = ACTIONS(668),
    [anon_sym_EQ_EQ] = ACTIONS(744),
    [anon_sym_let] = ACTIONS(668),
    [anon_sym_const] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(744),
    [anon_sym_PLUS_EQ] = ACTIONS(672),
    [anon_sym_return] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_AMP] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [sym_number] = ACTIONS(672),
    [anon_sym_SEMI] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(668),
    [anon_sym_extern] = ACTIONS(668),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [anon_sym_fn] = ACTIONS(668),
    [anon_sym_POUND] = ACTIONS(672),
    [anon_sym_mod] = ACTIONS(668),
    [anon_sym_enum] = ACTIONS(668),
    [anon_sym_impl] = ACTIONS(668),
    [anon_sym_trait] = ACTIONS(668),
    [anon_sym_u8] = ACTIONS(668),
    [anon_sym_i8] = ACTIONS(668),
    [anon_sym_u16] = ACTIONS(668),
    [anon_sym_i16] = ACTIONS(668),
    [anon_sym_u32] = ACTIONS(668),
    [anon_sym_i32] = ACTIONS(668),
    [anon_sym_u64] = ACTIONS(668),
    [anon_sym_i64] = ACTIONS(668),
    [anon_sym_u128] = ACTIONS(668),
    [anon_sym_i128] = ACTIONS(668),
    [anon_sym_u256] = ACTIONS(668),
    [anon_sym_i256] = ACTIONS(668),
    [anon_sym_isize] = ACTIONS(668),
    [anon_sym_usize] = ACTIONS(668),
    [anon_sym_f32] = ACTIONS(668),
    [anon_sym_f64] = ACTIONS(668),
    [anon_sym_felt252] = ACTIONS(668),
    [anon_sym_bool] = ACTIONS(668),
    [anon_sym_str] = ACTIONS(668),
    [anon_sym_char] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_match] = ACTIONS(668),
    [anon_sym_loop] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(672),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_PIPE_PIPE] = ACTIONS(672),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_LT2] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(744),
    [anon_sym_GT_EQ] = ACTIONS(744),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(748),
    [anon_sym_DASH_EQ] = ACTIONS(672),
    [anon_sym_STAR_EQ] = ACTIONS(672),
    [anon_sym_SLASH_EQ] = ACTIONS(672),
    [anon_sym_PERCENT_EQ] = ACTIONS(672),
    [anon_sym_AMP_EQ] = ACTIONS(672),
    [anon_sym_PIPE_EQ] = ACTIONS(672),
    [anon_sym_CARET_EQ] = ACTIONS(672),
    [anon_sym_LT_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_GT_EQ] = ACTIONS(672),
    [anon_sym_QMARK] = ACTIONS(672),
    [sym__cairo_1_short_string] = ACTIONS(672),
    [anon_sym_true] = ACTIONS(668),
    [anon_sym_false] = ACTIONS(668),
    [sym_self] = ACTIONS(668),
  },
  [133] = {
    [sym_identifier] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(672),
    [anon_sym_struct] = ACTIONS(668),
    [anon_sym_EQ_EQ] = ACTIONS(672),
    [anon_sym_let] = ACTIONS(668),
    [anon_sym_const] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(672),
    [anon_sym_PLUS_EQ] = ACTIONS(672),
    [anon_sym_return] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [sym_number] = ACTIONS(672),
    [anon_sym_SEMI] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(668),
    [anon_sym_extern] = ACTIONS(668),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [anon_sym_fn] = ACTIONS(668),
    [anon_sym_POUND] = ACTIONS(672),
    [anon_sym_mod] = ACTIONS(668),
    [anon_sym_enum] = ACTIONS(668),
    [anon_sym_impl] = ACTIONS(668),
    [anon_sym_trait] = ACTIONS(668),
    [anon_sym_u8] = ACTIONS(668),
    [anon_sym_i8] = ACTIONS(668),
    [anon_sym_u16] = ACTIONS(668),
    [anon_sym_i16] = ACTIONS(668),
    [anon_sym_u32] = ACTIONS(668),
    [anon_sym_i32] = ACTIONS(668),
    [anon_sym_u64] = ACTIONS(668),
    [anon_sym_i64] = ACTIONS(668),
    [anon_sym_u128] = ACTIONS(668),
    [anon_sym_i128] = ACTIONS(668),
    [anon_sym_u256] = ACTIONS(668),
    [anon_sym_i256] = ACTIONS(668),
    [anon_sym_isize] = ACTIONS(668),
    [anon_sym_usize] = ACTIONS(668),
    [anon_sym_f32] = ACTIONS(668),
    [anon_sym_f64] = ACTIONS(668),
    [anon_sym_felt252] = ACTIONS(668),
    [anon_sym_bool] = ACTIONS(668),
    [anon_sym_str] = ACTIONS(668),
    [anon_sym_char] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_match] = ACTIONS(668),
    [anon_sym_loop] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(672),
    [anon_sym_AMP_AMP] = ACTIONS(672),
    [anon_sym_PIPE_PIPE] = ACTIONS(672),
    [anon_sym_PIPE] = ACTIONS(668),
    [anon_sym_CARET] = ACTIONS(668),
    [anon_sym_LT2] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_DASH_EQ] = ACTIONS(672),
    [anon_sym_STAR_EQ] = ACTIONS(672),
    [anon_sym_SLASH_EQ] = ACTIONS(672),
    [anon_sym_PERCENT_EQ] = ACTIONS(672),
    [anon_sym_AMP_EQ] = ACTIONS(672),
    [anon_sym_PIPE_EQ] = ACTIONS(672),
    [anon_sym_CARET_EQ] = ACTIONS(672),
    [anon_sym_LT_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_GT_EQ] = ACTIONS(672),
    [anon_sym_QMARK] = ACTIONS(672),
    [sym__cairo_1_short_string] = ACTIONS(672),
    [anon_sym_true] = ACTIONS(668),
    [anon_sym_false] = ACTIONS(668),
    [sym_self] = ACTIONS(668),
  },
  [134] = {
    [sym_identifier] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(672),
    [anon_sym_struct] = ACTIONS(668),
    [anon_sym_EQ_EQ] = ACTIONS(672),
    [anon_sym_let] = ACTIONS(668),
    [anon_sym_const] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_BANG_EQ] = ACTIONS(672),
    [anon_sym_PLUS_EQ] = ACTIONS(672),
    [anon_sym_return] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [sym_number] = ACTIONS(672),
    [anon_sym_SEMI] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(668),
    [anon_sym_extern] = ACTIONS(668),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_COLON_COLON] = ACTIONS(672),
    [anon_sym_fn] = ACTIONS(668),
    [anon_sym_POUND] = ACTIONS(672),
    [anon_sym_mod] = ACTIONS(668),
    [anon_sym_enum] = ACTIONS(668),
    [anon_sym_impl] = ACTIONS(668),
    [anon_sym_trait] = ACTIONS(668),
    [anon_sym_u8] = ACTIONS(668),
    [anon_sym_i8] = ACTIONS(668),
    [anon_sym_u16] = ACTIONS(668),
    [anon_sym_i16] = ACTIONS(668),
    [anon_sym_u32] = ACTIONS(668),
    [anon_sym_i32] = ACTIONS(668),
    [anon_sym_u64] = ACTIONS(668),
    [anon_sym_i64] = ACTIONS(668),
    [anon_sym_u128] = ACTIONS(668),
    [anon_sym_i128] = ACTIONS(668),
    [anon_sym_u256] = ACTIONS(668),
    [anon_sym_i256] = ACTIONS(668),
    [anon_sym_isize] = ACTIONS(668),
    [anon_sym_usize] = ACTIONS(668),
    [anon_sym_f32] = ACTIONS(668),
    [anon_sym_f64] = ACTIONS(668),
    [anon_sym_felt252] = ACTIONS(668),
    [anon_sym_bool] = ACTIONS(668),
    [anon_sym_str] = ACTIONS(668),
    [anon_sym_char] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_match] = ACTIONS(668),
    [anon_sym_loop] = ACTIONS(668),
    [anon_sym_BANG] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(672),
    [anon_sym_AMP_AMP] = ACTIONS(672),
    [anon_sym_PIPE_PIPE] = ACTIONS(672),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_LT2] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_DASH_EQ] = ACTIONS(672),
    [anon_sym_STAR_EQ] = ACTIONS(672),
    [anon_sym_SLASH_EQ] = ACTIONS(672),
    [anon_sym_PERCENT_EQ] = ACTIONS(672),
    [anon_sym_AMP_EQ] = ACTIONS(672),
    [anon_sym_PIPE_EQ] = ACTIONS(672),
    [anon_sym_CARET_EQ] = ACTIONS(672),
    [anon_sym_LT_LT_EQ] = ACTIONS(672),
    [anon_sym_GT_GT_EQ] = ACTIONS(672),
    [anon_sym_QMARK] = ACTIONS(672),
    [sym__cairo_1_short_string] = ACTIONS(672),
    [anon_sym_true] = ACTIONS(668),
    [anon_sym_false] = ACTIONS(668),
    [sym_self] = ACTIONS(668),
  },
  [135] = {
    [sym_identifier] = ACTIONS(822),
    [anon_sym_LPAREN] = ACTIONS(824),
    [anon_sym_EQ] = ACTIONS(822),
    [anon_sym_AT] = ACTIONS(824),
    [anon_sym_LBRACE] = ACTIONS(824),
    [anon_sym_RBRACE] = ACTIONS(824),
    [anon_sym_struct] = ACTIONS(822),
    [anon_sym_EQ_EQ] = ACTIONS(824),
    [anon_sym_let] = ACTIONS(822),
    [anon_sym_const] = ACTIONS(822),
    [anon_sym_if] = ACTIONS(822),
    [anon_sym_BANG_EQ] = ACTIONS(824),
    [anon_sym_PLUS_EQ] = ACTIONS(824),
    [anon_sym_return] = ACTIONS(822),
    [anon_sym_STAR] = ACTIONS(822),
    [anon_sym_AMP] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(822),
    [anon_sym_PLUS] = ACTIONS(822),
    [anon_sym_SLASH] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [anon_sym_DOT] = ACTIONS(824),
    [sym_number] = ACTIONS(824),
    [anon_sym_SEMI] = ACTIONS(824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(822),
    [anon_sym_extern] = ACTIONS(822),
    [anon_sym_type] = ACTIONS(822),
    [anon_sym_COLON_COLON] = ACTIONS(824),
    [anon_sym_fn] = ACTIONS(822),
    [anon_sym_POUND] = ACTIONS(824),
    [anon_sym_mod] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(822),
    [anon_sym_impl] = ACTIONS(822),
    [anon_sym_trait] = ACTIONS(822),
    [anon_sym_u8] = ACTIONS(822),
    [anon_sym_i8] = ACTIONS(822),
    [anon_sym_u16] = ACTIONS(822),
    [anon_sym_i16] = ACTIONS(822),
    [anon_sym_u32] = ACTIONS(822),
    [anon_sym_i32] = ACTIONS(822),
    [anon_sym_u64] = ACTIONS(822),
    [anon_sym_i64] = ACTIONS(822),
    [anon_sym_u128] = ACTIONS(822),
    [anon_sym_i128] = ACTIONS(822),
    [anon_sym_u256] = ACTIONS(822),
    [anon_sym_i256] = ACTIONS(822),
    [anon_sym_isize] = ACTIONS(822),
    [anon_sym_usize] = ACTIONS(822),
    [anon_sym_f32] = ACTIONS(822),
    [anon_sym_f64] = ACTIONS(822),
    [anon_sym_felt252] = ACTIONS(822),
    [anon_sym_bool] = ACTIONS(822),
    [anon_sym_str] = ACTIONS(822),
    [anon_sym_char] = ACTIONS(822),
    [anon_sym_GT] = ACTIONS(822),
    [anon_sym_match] = ACTIONS(822),
    [anon_sym_loop] = ACTIONS(822),
    [anon_sym_BANG] = ACTIONS(822),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AMP_AMP] = ACTIONS(824),
    [anon_sym_PIPE_PIPE] = ACTIONS(824),
    [anon_sym_PIPE] = ACTIONS(822),
    [anon_sym_CARET] = ACTIONS(822),
    [anon_sym_LT2] = ACTIONS(822),
    [anon_sym_LT_EQ] = ACTIONS(824),
    [anon_sym_GT_EQ] = ACTIONS(824),
    [anon_sym_LT_LT] = ACTIONS(822),
    [anon_sym_GT_GT] = ACTIONS(822),
    [anon_sym_PERCENT] = ACTIONS(822),
    [anon_sym_DASH_EQ] = ACTIONS(824),
    [anon_sym_STAR_EQ] = ACTIONS(824),
    [anon_sym_SLASH_EQ] = ACTIONS(824),
    [anon_sym_PERCENT_EQ] = ACTIONS(824),
    [anon_sym_AMP_EQ] = ACTIONS(824),
    [anon_sym_PIPE_EQ] = ACTIONS(824),
    [anon_sym_CARET_EQ] = ACTIONS(824),
    [anon_sym_LT_LT_EQ] = ACTIONS(824),
    [anon_sym_GT_GT_EQ] = ACTIONS(824),
    [anon_sym_QMARK] = ACTIONS(824),
    [sym__cairo_1_short_string] = ACTIONS(824),
    [anon_sym_true] = ACTIONS(822),
    [anon_sym_false] = ACTIONS(822),
    [sym_self] = ACTIONS(822),
  },
  [136] = {
    [sym_identifier] = ACTIONS(798),
    [anon_sym_LPAREN] = ACTIONS(800),
    [anon_sym_EQ] = ACTIONS(798),
    [anon_sym_AT] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(800),
    [anon_sym_RBRACE] = ACTIONS(800),
    [anon_sym_struct] = ACTIONS(798),
    [anon_sym_EQ_EQ] = ACTIONS(800),
    [anon_sym_let] = ACTIONS(798),
    [anon_sym_const] = ACTIONS(798),
    [anon_sym_if] = ACTIONS(798),
    [anon_sym_BANG_EQ] = ACTIONS(800),
    [anon_sym_PLUS_EQ] = ACTIONS(800),
    [anon_sym_return] = ACTIONS(798),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_AMP] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(798),
    [anon_sym_PLUS] = ACTIONS(798),
    [anon_sym_SLASH] = ACTIONS(798),
    [anon_sym_LBRACK] = ACTIONS(800),
    [anon_sym_DOT] = ACTIONS(800),
    [sym_number] = ACTIONS(800),
    [anon_sym_SEMI] = ACTIONS(800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(798),
    [anon_sym_extern] = ACTIONS(798),
    [anon_sym_type] = ACTIONS(798),
    [anon_sym_COLON_COLON] = ACTIONS(800),
    [anon_sym_fn] = ACTIONS(798),
    [anon_sym_POUND] = ACTIONS(800),
    [anon_sym_mod] = ACTIONS(798),
    [anon_sym_enum] = ACTIONS(798),
    [anon_sym_impl] = ACTIONS(798),
    [anon_sym_trait] = ACTIONS(798),
    [anon_sym_u8] = ACTIONS(798),
    [anon_sym_i8] = ACTIONS(798),
    [anon_sym_u16] = ACTIONS(798),
    [anon_sym_i16] = ACTIONS(798),
    [anon_sym_u32] = ACTIONS(798),
    [anon_sym_i32] = ACTIONS(798),
    [anon_sym_u64] = ACTIONS(798),
    [anon_sym_i64] = ACTIONS(798),
    [anon_sym_u128] = ACTIONS(798),
    [anon_sym_i128] = ACTIONS(798),
    [anon_sym_u256] = ACTIONS(798),
    [anon_sym_i256] = ACTIONS(798),
    [anon_sym_isize] = ACTIONS(798),
    [anon_sym_usize] = ACTIONS(798),
    [anon_sym_f32] = ACTIONS(798),
    [anon_sym_f64] = ACTIONS(798),
    [anon_sym_felt252] = ACTIONS(798),
    [anon_sym_bool] = ACTIONS(798),
    [anon_sym_str] = ACTIONS(798),
    [anon_sym_char] = ACTIONS(798),
    [anon_sym_GT] = ACTIONS(798),
    [anon_sym_match] = ACTIONS(798),
    [anon_sym_loop] = ACTIONS(798),
    [anon_sym_BANG] = ACTIONS(798),
    [anon_sym_TILDE] = ACTIONS(800),
    [anon_sym_AMP_AMP] = ACTIONS(800),
    [anon_sym_PIPE_PIPE] = ACTIONS(800),
    [anon_sym_PIPE] = ACTIONS(798),
    [anon_sym_CARET] = ACTIONS(798),
    [anon_sym_LT2] = ACTIONS(798),
    [anon_sym_LT_EQ] = ACTIONS(800),
    [anon_sym_GT_EQ] = ACTIONS(800),
    [anon_sym_LT_LT] = ACTIONS(798),
    [anon_sym_GT_GT] = ACTIONS(798),
    [anon_sym_PERCENT] = ACTIONS(798),
    [anon_sym_DASH_EQ] = ACTIONS(800),
    [anon_sym_STAR_EQ] = ACTIONS(800),
    [anon_sym_SLASH_EQ] = ACTIONS(800),
    [anon_sym_PERCENT_EQ] = ACTIONS(800),
    [anon_sym_AMP_EQ] = ACTIONS(800),
    [anon_sym_PIPE_EQ] = ACTIONS(800),
    [anon_sym_CARET_EQ] = ACTIONS(800),
    [anon_sym_LT_LT_EQ] = ACTIONS(800),
    [anon_sym_GT_GT_EQ] = ACTIONS(800),
    [anon_sym_QMARK] = ACTIONS(800),
    [sym__cairo_1_short_string] = ACTIONS(800),
    [anon_sym_true] = ACTIONS(798),
    [anon_sym_false] = ACTIONS(798),
    [sym_self] = ACTIONS(798),
  },
  [137] = {
    [sym_identifier] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(828),
    [anon_sym_EQ] = ACTIONS(826),
    [anon_sym_AT] = ACTIONS(828),
    [anon_sym_LBRACE] = ACTIONS(828),
    [anon_sym_RBRACE] = ACTIONS(828),
    [anon_sym_struct] = ACTIONS(826),
    [anon_sym_EQ_EQ] = ACTIONS(828),
    [anon_sym_let] = ACTIONS(826),
    [anon_sym_const] = ACTIONS(826),
    [anon_sym_if] = ACTIONS(826),
    [anon_sym_BANG_EQ] = ACTIONS(828),
    [anon_sym_PLUS_EQ] = ACTIONS(828),
    [anon_sym_return] = ACTIONS(826),
    [anon_sym_STAR] = ACTIONS(826),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_DASH] = ACTIONS(826),
    [anon_sym_PLUS] = ACTIONS(826),
    [anon_sym_SLASH] = ACTIONS(826),
    [anon_sym_LBRACK] = ACTIONS(828),
    [anon_sym_DOT] = ACTIONS(828),
    [sym_number] = ACTIONS(828),
    [anon_sym_SEMI] = ACTIONS(828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(826),
    [anon_sym_extern] = ACTIONS(826),
    [anon_sym_type] = ACTIONS(826),
    [anon_sym_COLON_COLON] = ACTIONS(828),
    [anon_sym_fn] = ACTIONS(826),
    [anon_sym_POUND] = ACTIONS(828),
    [anon_sym_mod] = ACTIONS(826),
    [anon_sym_enum] = ACTIONS(826),
    [anon_sym_impl] = ACTIONS(826),
    [anon_sym_trait] = ACTIONS(826),
    [anon_sym_u8] = ACTIONS(826),
    [anon_sym_i8] = ACTIONS(826),
    [anon_sym_u16] = ACTIONS(826),
    [anon_sym_i16] = ACTIONS(826),
    [anon_sym_u32] = ACTIONS(826),
    [anon_sym_i32] = ACTIONS(826),
    [anon_sym_u64] = ACTIONS(826),
    [anon_sym_i64] = ACTIONS(826),
    [anon_sym_u128] = ACTIONS(826),
    [anon_sym_i128] = ACTIONS(826),
    [anon_sym_u256] = ACTIONS(826),
    [anon_sym_i256] = ACTIONS(826),
    [anon_sym_isize] = ACTIONS(826),
    [anon_sym_usize] = ACTIONS(826),
    [anon_sym_f32] = ACTIONS(826),
    [anon_sym_f64] = ACTIONS(826),
    [anon_sym_felt252] = ACTIONS(826),
    [anon_sym_bool] = ACTIONS(826),
    [anon_sym_str] = ACTIONS(826),
    [anon_sym_char] = ACTIONS(826),
    [anon_sym_GT] = ACTIONS(826),
    [anon_sym_match] = ACTIONS(826),
    [anon_sym_loop] = ACTIONS(826),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_TILDE] = ACTIONS(828),
    [anon_sym_AMP_AMP] = ACTIONS(828),
    [anon_sym_PIPE_PIPE] = ACTIONS(828),
    [anon_sym_PIPE] = ACTIONS(826),
    [anon_sym_CARET] = ACTIONS(826),
    [anon_sym_LT2] = ACTIONS(826),
    [anon_sym_LT_EQ] = ACTIONS(828),
    [anon_sym_GT_EQ] = ACTIONS(828),
    [anon_sym_LT_LT] = ACTIONS(826),
    [anon_sym_GT_GT] = ACTIONS(826),
    [anon_sym_PERCENT] = ACTIONS(826),
    [anon_sym_DASH_EQ] = ACTIONS(828),
    [anon_sym_STAR_EQ] = ACTIONS(828),
    [anon_sym_SLASH_EQ] = ACTIONS(828),
    [anon_sym_PERCENT_EQ] = ACTIONS(828),
    [anon_sym_AMP_EQ] = ACTIONS(828),
    [anon_sym_PIPE_EQ] = ACTIONS(828),
    [anon_sym_CARET_EQ] = ACTIONS(828),
    [anon_sym_LT_LT_EQ] = ACTIONS(828),
    [anon_sym_GT_GT_EQ] = ACTIONS(828),
    [anon_sym_QMARK] = ACTIONS(828),
    [sym__cairo_1_short_string] = ACTIONS(828),
    [anon_sym_true] = ACTIONS(826),
    [anon_sym_false] = ACTIONS(826),
    [sym_self] = ACTIONS(826),
  },
  [138] = {
    [sym_identifier] = ACTIONS(830),
    [anon_sym_LPAREN] = ACTIONS(832),
    [anon_sym_EQ] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(832),
    [anon_sym_RBRACE] = ACTIONS(832),
    [anon_sym_struct] = ACTIONS(830),
    [anon_sym_EQ_EQ] = ACTIONS(832),
    [anon_sym_let] = ACTIONS(830),
    [anon_sym_const] = ACTIONS(830),
    [anon_sym_if] = ACTIONS(830),
    [anon_sym_BANG_EQ] = ACTIONS(832),
    [anon_sym_PLUS_EQ] = ACTIONS(832),
    [anon_sym_return] = ACTIONS(830),
    [anon_sym_STAR] = ACTIONS(830),
    [anon_sym_AMP] = ACTIONS(830),
    [anon_sym_DASH] = ACTIONS(830),
    [anon_sym_PLUS] = ACTIONS(830),
    [anon_sym_SLASH] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(832),
    [anon_sym_DOT] = ACTIONS(832),
    [sym_number] = ACTIONS(832),
    [anon_sym_SEMI] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(830),
    [anon_sym_extern] = ACTIONS(830),
    [anon_sym_type] = ACTIONS(830),
    [anon_sym_COLON_COLON] = ACTIONS(832),
    [anon_sym_fn] = ACTIONS(830),
    [anon_sym_POUND] = ACTIONS(832),
    [anon_sym_mod] = ACTIONS(830),
    [anon_sym_enum] = ACTIONS(830),
    [anon_sym_impl] = ACTIONS(830),
    [anon_sym_trait] = ACTIONS(830),
    [anon_sym_u8] = ACTIONS(830),
    [anon_sym_i8] = ACTIONS(830),
    [anon_sym_u16] = ACTIONS(830),
    [anon_sym_i16] = ACTIONS(830),
    [anon_sym_u32] = ACTIONS(830),
    [anon_sym_i32] = ACTIONS(830),
    [anon_sym_u64] = ACTIONS(830),
    [anon_sym_i64] = ACTIONS(830),
    [anon_sym_u128] = ACTIONS(830),
    [anon_sym_i128] = ACTIONS(830),
    [anon_sym_u256] = ACTIONS(830),
    [anon_sym_i256] = ACTIONS(830),
    [anon_sym_isize] = ACTIONS(830),
    [anon_sym_usize] = ACTIONS(830),
    [anon_sym_f32] = ACTIONS(830),
    [anon_sym_f64] = ACTIONS(830),
    [anon_sym_felt252] = ACTIONS(830),
    [anon_sym_bool] = ACTIONS(830),
    [anon_sym_str] = ACTIONS(830),
    [anon_sym_char] = ACTIONS(830),
    [anon_sym_GT] = ACTIONS(830),
    [anon_sym_match] = ACTIONS(830),
    [anon_sym_loop] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(830),
    [anon_sym_TILDE] = ACTIONS(832),
    [anon_sym_AMP_AMP] = ACTIONS(832),
    [anon_sym_PIPE_PIPE] = ACTIONS(832),
    [anon_sym_PIPE] = ACTIONS(830),
    [anon_sym_CARET] = ACTIONS(830),
    [anon_sym_LT2] = ACTIONS(830),
    [anon_sym_LT_EQ] = ACTIONS(832),
    [anon_sym_GT_EQ] = ACTIONS(832),
    [anon_sym_LT_LT] = ACTIONS(830),
    [anon_sym_GT_GT] = ACTIONS(830),
    [anon_sym_PERCENT] = ACTIONS(830),
    [anon_sym_DASH_EQ] = ACTIONS(832),
    [anon_sym_STAR_EQ] = ACTIONS(832),
    [anon_sym_SLASH_EQ] = ACTIONS(832),
    [anon_sym_PERCENT_EQ] = ACTIONS(832),
    [anon_sym_AMP_EQ] = ACTIONS(832),
    [anon_sym_PIPE_EQ] = ACTIONS(832),
    [anon_sym_CARET_EQ] = ACTIONS(832),
    [anon_sym_LT_LT_EQ] = ACTIONS(832),
    [anon_sym_GT_GT_EQ] = ACTIONS(832),
    [anon_sym_QMARK] = ACTIONS(832),
    [sym__cairo_1_short_string] = ACTIONS(832),
    [anon_sym_true] = ACTIONS(830),
    [anon_sym_false] = ACTIONS(830),
    [sym_self] = ACTIONS(830),
  },
  [139] = {
    [sym_identifier] = ACTIONS(834),
    [anon_sym_LPAREN] = ACTIONS(836),
    [anon_sym_EQ] = ACTIONS(834),
    [anon_sym_AT] = ACTIONS(836),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_RBRACE] = ACTIONS(836),
    [anon_sym_struct] = ACTIONS(834),
    [anon_sym_EQ_EQ] = ACTIONS(836),
    [anon_sym_let] = ACTIONS(834),
    [anon_sym_const] = ACTIONS(834),
    [anon_sym_if] = ACTIONS(834),
    [anon_sym_BANG_EQ] = ACTIONS(836),
    [anon_sym_PLUS_EQ] = ACTIONS(836),
    [anon_sym_return] = ACTIONS(834),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_AMP] = ACTIONS(834),
    [anon_sym_DASH] = ACTIONS(834),
    [anon_sym_PLUS] = ACTIONS(834),
    [anon_sym_SLASH] = ACTIONS(834),
    [anon_sym_LBRACK] = ACTIONS(836),
    [anon_sym_DOT] = ACTIONS(836),
    [sym_number] = ACTIONS(836),
    [anon_sym_SEMI] = ACTIONS(836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(834),
    [anon_sym_extern] = ACTIONS(834),
    [anon_sym_type] = ACTIONS(834),
    [anon_sym_COLON_COLON] = ACTIONS(836),
    [anon_sym_fn] = ACTIONS(834),
    [anon_sym_POUND] = ACTIONS(836),
    [anon_sym_mod] = ACTIONS(834),
    [anon_sym_enum] = ACTIONS(834),
    [anon_sym_impl] = ACTIONS(834),
    [anon_sym_trait] = ACTIONS(834),
    [anon_sym_u8] = ACTIONS(834),
    [anon_sym_i8] = ACTIONS(834),
    [anon_sym_u16] = ACTIONS(834),
    [anon_sym_i16] = ACTIONS(834),
    [anon_sym_u32] = ACTIONS(834),
    [anon_sym_i32] = ACTIONS(834),
    [anon_sym_u64] = ACTIONS(834),
    [anon_sym_i64] = ACTIONS(834),
    [anon_sym_u128] = ACTIONS(834),
    [anon_sym_i128] = ACTIONS(834),
    [anon_sym_u256] = ACTIONS(834),
    [anon_sym_i256] = ACTIONS(834),
    [anon_sym_isize] = ACTIONS(834),
    [anon_sym_usize] = ACTIONS(834),
    [anon_sym_f32] = ACTIONS(834),
    [anon_sym_f64] = ACTIONS(834),
    [anon_sym_felt252] = ACTIONS(834),
    [anon_sym_bool] = ACTIONS(834),
    [anon_sym_str] = ACTIONS(834),
    [anon_sym_char] = ACTIONS(834),
    [anon_sym_GT] = ACTIONS(834),
    [anon_sym_match] = ACTIONS(834),
    [anon_sym_loop] = ACTIONS(834),
    [anon_sym_BANG] = ACTIONS(834),
    [anon_sym_TILDE] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(836),
    [anon_sym_PIPE_PIPE] = ACTIONS(836),
    [anon_sym_PIPE] = ACTIONS(834),
    [anon_sym_CARET] = ACTIONS(834),
    [anon_sym_LT2] = ACTIONS(834),
    [anon_sym_LT_EQ] = ACTIONS(836),
    [anon_sym_GT_EQ] = ACTIONS(836),
    [anon_sym_LT_LT] = ACTIONS(834),
    [anon_sym_GT_GT] = ACTIONS(834),
    [anon_sym_PERCENT] = ACTIONS(834),
    [anon_sym_DASH_EQ] = ACTIONS(836),
    [anon_sym_STAR_EQ] = ACTIONS(836),
    [anon_sym_SLASH_EQ] = ACTIONS(836),
    [anon_sym_PERCENT_EQ] = ACTIONS(836),
    [anon_sym_AMP_EQ] = ACTIONS(836),
    [anon_sym_PIPE_EQ] = ACTIONS(836),
    [anon_sym_CARET_EQ] = ACTIONS(836),
    [anon_sym_LT_LT_EQ] = ACTIONS(836),
    [anon_sym_GT_GT_EQ] = ACTIONS(836),
    [anon_sym_QMARK] = ACTIONS(836),
    [sym__cairo_1_short_string] = ACTIONS(836),
    [anon_sym_true] = ACTIONS(834),
    [anon_sym_false] = ACTIONS(834),
    [sym_self] = ACTIONS(834),
  },
  [140] = {
    [sym_identifier] = ACTIONS(838),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_EQ] = ACTIONS(838),
    [anon_sym_AT] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(840),
    [anon_sym_RBRACE] = ACTIONS(840),
    [anon_sym_struct] = ACTIONS(838),
    [anon_sym_EQ_EQ] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(838),
    [anon_sym_const] = ACTIONS(838),
    [anon_sym_if] = ACTIONS(838),
    [anon_sym_BANG_EQ] = ACTIONS(840),
    [anon_sym_PLUS_EQ] = ACTIONS(840),
    [anon_sym_return] = ACTIONS(838),
    [anon_sym_STAR] = ACTIONS(838),
    [anon_sym_AMP] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(838),
    [anon_sym_PLUS] = ACTIONS(838),
    [anon_sym_SLASH] = ACTIONS(838),
    [anon_sym_LBRACK] = ACTIONS(840),
    [anon_sym_DOT] = ACTIONS(840),
    [sym_number] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(838),
    [anon_sym_extern] = ACTIONS(838),
    [anon_sym_type] = ACTIONS(838),
    [anon_sym_COLON_COLON] = ACTIONS(840),
    [anon_sym_fn] = ACTIONS(838),
    [anon_sym_POUND] = ACTIONS(840),
    [anon_sym_mod] = ACTIONS(838),
    [anon_sym_enum] = ACTIONS(838),
    [anon_sym_impl] = ACTIONS(838),
    [anon_sym_trait] = ACTIONS(838),
    [anon_sym_u8] = ACTIONS(838),
    [anon_sym_i8] = ACTIONS(838),
    [anon_sym_u16] = ACTIONS(838),
    [anon_sym_i16] = ACTIONS(838),
    [anon_sym_u32] = ACTIONS(838),
    [anon_sym_i32] = ACTIONS(838),
    [anon_sym_u64] = ACTIONS(838),
    [anon_sym_i64] = ACTIONS(838),
    [anon_sym_u128] = ACTIONS(838),
    [anon_sym_i128] = ACTIONS(838),
    [anon_sym_u256] = ACTIONS(838),
    [anon_sym_i256] = ACTIONS(838),
    [anon_sym_isize] = ACTIONS(838),
    [anon_sym_usize] = ACTIONS(838),
    [anon_sym_f32] = ACTIONS(838),
    [anon_sym_f64] = ACTIONS(838),
    [anon_sym_felt252] = ACTIONS(838),
    [anon_sym_bool] = ACTIONS(838),
    [anon_sym_str] = ACTIONS(838),
    [anon_sym_char] = ACTIONS(838),
    [anon_sym_GT] = ACTIONS(838),
    [anon_sym_match] = ACTIONS(838),
    [anon_sym_loop] = ACTIONS(838),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(838),
    [anon_sym_CARET] = ACTIONS(838),
    [anon_sym_LT2] = ACTIONS(838),
    [anon_sym_LT_EQ] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(840),
    [anon_sym_LT_LT] = ACTIONS(838),
    [anon_sym_GT_GT] = ACTIONS(838),
    [anon_sym_PERCENT] = ACTIONS(838),
    [anon_sym_DASH_EQ] = ACTIONS(840),
    [anon_sym_STAR_EQ] = ACTIONS(840),
    [anon_sym_SLASH_EQ] = ACTIONS(840),
    [anon_sym_PERCENT_EQ] = ACTIONS(840),
    [anon_sym_AMP_EQ] = ACTIONS(840),
    [anon_sym_PIPE_EQ] = ACTIONS(840),
    [anon_sym_CARET_EQ] = ACTIONS(840),
    [anon_sym_LT_LT_EQ] = ACTIONS(840),
    [anon_sym_GT_GT_EQ] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(840),
    [sym__cairo_1_short_string] = ACTIONS(840),
    [anon_sym_true] = ACTIONS(838),
    [anon_sym_false] = ACTIONS(838),
    [sym_self] = ACTIONS(838),
  },
  [141] = {
    [sym_identifier] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(844),
    [anon_sym_EQ] = ACTIONS(842),
    [anon_sym_AT] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(844),
    [anon_sym_RBRACE] = ACTIONS(844),
    [anon_sym_struct] = ACTIONS(842),
    [anon_sym_EQ_EQ] = ACTIONS(844),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(842),
    [anon_sym_if] = ACTIONS(842),
    [anon_sym_BANG_EQ] = ACTIONS(844),
    [anon_sym_PLUS_EQ] = ACTIONS(844),
    [anon_sym_return] = ACTIONS(842),
    [anon_sym_STAR] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_SLASH] = ACTIONS(842),
    [anon_sym_LBRACK] = ACTIONS(844),
    [anon_sym_DOT] = ACTIONS(844),
    [sym_number] = ACTIONS(844),
    [anon_sym_SEMI] = ACTIONS(844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(842),
    [anon_sym_extern] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_COLON_COLON] = ACTIONS(844),
    [anon_sym_fn] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(844),
    [anon_sym_mod] = ACTIONS(842),
    [anon_sym_enum] = ACTIONS(842),
    [anon_sym_impl] = ACTIONS(842),
    [anon_sym_trait] = ACTIONS(842),
    [anon_sym_u8] = ACTIONS(842),
    [anon_sym_i8] = ACTIONS(842),
    [anon_sym_u16] = ACTIONS(842),
    [anon_sym_i16] = ACTIONS(842),
    [anon_sym_u32] = ACTIONS(842),
    [anon_sym_i32] = ACTIONS(842),
    [anon_sym_u64] = ACTIONS(842),
    [anon_sym_i64] = ACTIONS(842),
    [anon_sym_u128] = ACTIONS(842),
    [anon_sym_i128] = ACTIONS(842),
    [anon_sym_u256] = ACTIONS(842),
    [anon_sym_i256] = ACTIONS(842),
    [anon_sym_isize] = ACTIONS(842),
    [anon_sym_usize] = ACTIONS(842),
    [anon_sym_f32] = ACTIONS(842),
    [anon_sym_f64] = ACTIONS(842),
    [anon_sym_felt252] = ACTIONS(842),
    [anon_sym_bool] = ACTIONS(842),
    [anon_sym_str] = ACTIONS(842),
    [anon_sym_char] = ACTIONS(842),
    [anon_sym_GT] = ACTIONS(842),
    [anon_sym_match] = ACTIONS(842),
    [anon_sym_loop] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(842),
    [anon_sym_TILDE] = ACTIONS(844),
    [anon_sym_AMP_AMP] = ACTIONS(844),
    [anon_sym_PIPE_PIPE] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(842),
    [anon_sym_CARET] = ACTIONS(842),
    [anon_sym_LT2] = ACTIONS(842),
    [anon_sym_LT_EQ] = ACTIONS(844),
    [anon_sym_GT_EQ] = ACTIONS(844),
    [anon_sym_LT_LT] = ACTIONS(842),
    [anon_sym_GT_GT] = ACTIONS(842),
    [anon_sym_PERCENT] = ACTIONS(842),
    [anon_sym_DASH_EQ] = ACTIONS(844),
    [anon_sym_STAR_EQ] = ACTIONS(844),
    [anon_sym_SLASH_EQ] = ACTIONS(844),
    [anon_sym_PERCENT_EQ] = ACTIONS(844),
    [anon_sym_AMP_EQ] = ACTIONS(844),
    [anon_sym_PIPE_EQ] = ACTIONS(844),
    [anon_sym_CARET_EQ] = ACTIONS(844),
    [anon_sym_LT_LT_EQ] = ACTIONS(844),
    [anon_sym_GT_GT_EQ] = ACTIONS(844),
    [anon_sym_QMARK] = ACTIONS(844),
    [sym__cairo_1_short_string] = ACTIONS(844),
    [anon_sym_true] = ACTIONS(842),
    [anon_sym_false] = ACTIONS(842),
    [sym_self] = ACTIONS(842),
  },
  [142] = {
    [sym_identifier] = ACTIONS(846),
    [anon_sym_LPAREN] = ACTIONS(848),
    [anon_sym_EQ] = ACTIONS(846),
    [anon_sym_AT] = ACTIONS(848),
    [anon_sym_LBRACE] = ACTIONS(848),
    [anon_sym_RBRACE] = ACTIONS(848),
    [anon_sym_struct] = ACTIONS(846),
    [anon_sym_EQ_EQ] = ACTIONS(848),
    [anon_sym_let] = ACTIONS(846),
    [anon_sym_const] = ACTIONS(846),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_BANG_EQ] = ACTIONS(848),
    [anon_sym_PLUS_EQ] = ACTIONS(848),
    [anon_sym_return] = ACTIONS(846),
    [anon_sym_STAR] = ACTIONS(846),
    [anon_sym_AMP] = ACTIONS(846),
    [anon_sym_DASH] = ACTIONS(846),
    [anon_sym_PLUS] = ACTIONS(846),
    [anon_sym_SLASH] = ACTIONS(846),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_DOT] = ACTIONS(848),
    [sym_number] = ACTIONS(848),
    [anon_sym_SEMI] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(846),
    [anon_sym_extern] = ACTIONS(846),
    [anon_sym_type] = ACTIONS(846),
    [anon_sym_COLON_COLON] = ACTIONS(848),
    [anon_sym_fn] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(848),
    [anon_sym_mod] = ACTIONS(846),
    [anon_sym_enum] = ACTIONS(846),
    [anon_sym_impl] = ACTIONS(846),
    [anon_sym_trait] = ACTIONS(846),
    [anon_sym_u8] = ACTIONS(846),
    [anon_sym_i8] = ACTIONS(846),
    [anon_sym_u16] = ACTIONS(846),
    [anon_sym_i16] = ACTIONS(846),
    [anon_sym_u32] = ACTIONS(846),
    [anon_sym_i32] = ACTIONS(846),
    [anon_sym_u64] = ACTIONS(846),
    [anon_sym_i64] = ACTIONS(846),
    [anon_sym_u128] = ACTIONS(846),
    [anon_sym_i128] = ACTIONS(846),
    [anon_sym_u256] = ACTIONS(846),
    [anon_sym_i256] = ACTIONS(846),
    [anon_sym_isize] = ACTIONS(846),
    [anon_sym_usize] = ACTIONS(846),
    [anon_sym_f32] = ACTIONS(846),
    [anon_sym_f64] = ACTIONS(846),
    [anon_sym_felt252] = ACTIONS(846),
    [anon_sym_bool] = ACTIONS(846),
    [anon_sym_str] = ACTIONS(846),
    [anon_sym_char] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(846),
    [anon_sym_match] = ACTIONS(846),
    [anon_sym_loop] = ACTIONS(846),
    [anon_sym_BANG] = ACTIONS(846),
    [anon_sym_TILDE] = ACTIONS(848),
    [anon_sym_AMP_AMP] = ACTIONS(848),
    [anon_sym_PIPE_PIPE] = ACTIONS(848),
    [anon_sym_PIPE] = ACTIONS(846),
    [anon_sym_CARET] = ACTIONS(846),
    [anon_sym_LT2] = ACTIONS(846),
    [anon_sym_LT_EQ] = ACTIONS(848),
    [anon_sym_GT_EQ] = ACTIONS(848),
    [anon_sym_LT_LT] = ACTIONS(846),
    [anon_sym_GT_GT] = ACTIONS(846),
    [anon_sym_PERCENT] = ACTIONS(846),
    [anon_sym_DASH_EQ] = ACTIONS(848),
    [anon_sym_STAR_EQ] = ACTIONS(848),
    [anon_sym_SLASH_EQ] = ACTIONS(848),
    [anon_sym_PERCENT_EQ] = ACTIONS(848),
    [anon_sym_AMP_EQ] = ACTIONS(848),
    [anon_sym_PIPE_EQ] = ACTIONS(848),
    [anon_sym_CARET_EQ] = ACTIONS(848),
    [anon_sym_LT_LT_EQ] = ACTIONS(848),
    [anon_sym_GT_GT_EQ] = ACTIONS(848),
    [anon_sym_QMARK] = ACTIONS(848),
    [sym__cairo_1_short_string] = ACTIONS(848),
    [anon_sym_true] = ACTIONS(846),
    [anon_sym_false] = ACTIONS(846),
    [sym_self] = ACTIONS(846),
  },
  [143] = {
    [sym_identifier] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(852),
    [anon_sym_EQ] = ACTIONS(850),
    [anon_sym_AT] = ACTIONS(852),
    [anon_sym_LBRACE] = ACTIONS(852),
    [anon_sym_RBRACE] = ACTIONS(852),
    [anon_sym_struct] = ACTIONS(850),
    [anon_sym_EQ_EQ] = ACTIONS(852),
    [anon_sym_let] = ACTIONS(850),
    [anon_sym_const] = ACTIONS(850),
    [anon_sym_if] = ACTIONS(850),
    [anon_sym_BANG_EQ] = ACTIONS(852),
    [anon_sym_PLUS_EQ] = ACTIONS(852),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_STAR] = ACTIONS(850),
    [anon_sym_AMP] = ACTIONS(850),
    [anon_sym_DASH] = ACTIONS(850),
    [anon_sym_PLUS] = ACTIONS(850),
    [anon_sym_SLASH] = ACTIONS(850),
    [anon_sym_LBRACK] = ACTIONS(852),
    [anon_sym_DOT] = ACTIONS(852),
    [sym_number] = ACTIONS(852),
    [anon_sym_SEMI] = ACTIONS(852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(850),
    [anon_sym_extern] = ACTIONS(850),
    [anon_sym_type] = ACTIONS(850),
    [anon_sym_COLON_COLON] = ACTIONS(852),
    [anon_sym_fn] = ACTIONS(850),
    [anon_sym_POUND] = ACTIONS(852),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_enum] = ACTIONS(850),
    [anon_sym_impl] = ACTIONS(850),
    [anon_sym_trait] = ACTIONS(850),
    [anon_sym_u8] = ACTIONS(850),
    [anon_sym_i8] = ACTIONS(850),
    [anon_sym_u16] = ACTIONS(850),
    [anon_sym_i16] = ACTIONS(850),
    [anon_sym_u32] = ACTIONS(850),
    [anon_sym_i32] = ACTIONS(850),
    [anon_sym_u64] = ACTIONS(850),
    [anon_sym_i64] = ACTIONS(850),
    [anon_sym_u128] = ACTIONS(850),
    [anon_sym_i128] = ACTIONS(850),
    [anon_sym_u256] = ACTIONS(850),
    [anon_sym_i256] = ACTIONS(850),
    [anon_sym_isize] = ACTIONS(850),
    [anon_sym_usize] = ACTIONS(850),
    [anon_sym_f32] = ACTIONS(850),
    [anon_sym_f64] = ACTIONS(850),
    [anon_sym_felt252] = ACTIONS(850),
    [anon_sym_bool] = ACTIONS(850),
    [anon_sym_str] = ACTIONS(850),
    [anon_sym_char] = ACTIONS(850),
    [anon_sym_GT] = ACTIONS(850),
    [anon_sym_match] = ACTIONS(850),
    [anon_sym_loop] = ACTIONS(850),
    [anon_sym_BANG] = ACTIONS(850),
    [anon_sym_TILDE] = ACTIONS(852),
    [anon_sym_AMP_AMP] = ACTIONS(852),
    [anon_sym_PIPE_PIPE] = ACTIONS(852),
    [anon_sym_PIPE] = ACTIONS(850),
    [anon_sym_CARET] = ACTIONS(850),
    [anon_sym_LT2] = ACTIONS(850),
    [anon_sym_LT_EQ] = ACTIONS(852),
    [anon_sym_GT_EQ] = ACTIONS(852),
    [anon_sym_LT_LT] = ACTIONS(850),
    [anon_sym_GT_GT] = ACTIONS(850),
    [anon_sym_PERCENT] = ACTIONS(850),
    [anon_sym_DASH_EQ] = ACTIONS(852),
    [anon_sym_STAR_EQ] = ACTIONS(852),
    [anon_sym_SLASH_EQ] = ACTIONS(852),
    [anon_sym_PERCENT_EQ] = ACTIONS(852),
    [anon_sym_AMP_EQ] = ACTIONS(852),
    [anon_sym_PIPE_EQ] = ACTIONS(852),
    [anon_sym_CARET_EQ] = ACTIONS(852),
    [anon_sym_LT_LT_EQ] = ACTIONS(852),
    [anon_sym_GT_GT_EQ] = ACTIONS(852),
    [anon_sym_QMARK] = ACTIONS(852),
    [sym__cairo_1_short_string] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(850),
    [anon_sym_false] = ACTIONS(850),
    [sym_self] = ACTIONS(850),
  },
  [144] = {
    [sym_identifier] = ACTIONS(854),
    [anon_sym_LPAREN] = ACTIONS(856),
    [anon_sym_EQ] = ACTIONS(854),
    [anon_sym_AT] = ACTIONS(856),
    [anon_sym_LBRACE] = ACTIONS(856),
    [anon_sym_RBRACE] = ACTIONS(856),
    [anon_sym_struct] = ACTIONS(854),
    [anon_sym_EQ_EQ] = ACTIONS(856),
    [anon_sym_let] = ACTIONS(854),
    [anon_sym_const] = ACTIONS(854),
    [anon_sym_if] = ACTIONS(854),
    [anon_sym_BANG_EQ] = ACTIONS(856),
    [anon_sym_PLUS_EQ] = ACTIONS(856),
    [anon_sym_return] = ACTIONS(854),
    [anon_sym_STAR] = ACTIONS(854),
    [anon_sym_AMP] = ACTIONS(854),
    [anon_sym_DASH] = ACTIONS(854),
    [anon_sym_PLUS] = ACTIONS(854),
    [anon_sym_SLASH] = ACTIONS(854),
    [anon_sym_LBRACK] = ACTIONS(856),
    [anon_sym_DOT] = ACTIONS(856),
    [sym_number] = ACTIONS(856),
    [anon_sym_SEMI] = ACTIONS(856),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(854),
    [anon_sym_extern] = ACTIONS(854),
    [anon_sym_type] = ACTIONS(854),
    [anon_sym_COLON_COLON] = ACTIONS(856),
    [anon_sym_fn] = ACTIONS(854),
    [anon_sym_POUND] = ACTIONS(856),
    [anon_sym_mod] = ACTIONS(854),
    [anon_sym_enum] = ACTIONS(854),
    [anon_sym_impl] = ACTIONS(854),
    [anon_sym_trait] = ACTIONS(854),
    [anon_sym_u8] = ACTIONS(854),
    [anon_sym_i8] = ACTIONS(854),
    [anon_sym_u16] = ACTIONS(854),
    [anon_sym_i16] = ACTIONS(854),
    [anon_sym_u32] = ACTIONS(854),
    [anon_sym_i32] = ACTIONS(854),
    [anon_sym_u64] = ACTIONS(854),
    [anon_sym_i64] = ACTIONS(854),
    [anon_sym_u128] = ACTIONS(854),
    [anon_sym_i128] = ACTIONS(854),
    [anon_sym_u256] = ACTIONS(854),
    [anon_sym_i256] = ACTIONS(854),
    [anon_sym_isize] = ACTIONS(854),
    [anon_sym_usize] = ACTIONS(854),
    [anon_sym_f32] = ACTIONS(854),
    [anon_sym_f64] = ACTIONS(854),
    [anon_sym_felt252] = ACTIONS(854),
    [anon_sym_bool] = ACTIONS(854),
    [anon_sym_str] = ACTIONS(854),
    [anon_sym_char] = ACTIONS(854),
    [anon_sym_GT] = ACTIONS(854),
    [anon_sym_match] = ACTIONS(854),
    [anon_sym_loop] = ACTIONS(854),
    [anon_sym_BANG] = ACTIONS(854),
    [anon_sym_TILDE] = ACTIONS(856),
    [anon_sym_AMP_AMP] = ACTIONS(856),
    [anon_sym_PIPE_PIPE] = ACTIONS(856),
    [anon_sym_PIPE] = ACTIONS(854),
    [anon_sym_CARET] = ACTIONS(854),
    [anon_sym_LT2] = ACTIONS(854),
    [anon_sym_LT_EQ] = ACTIONS(856),
    [anon_sym_GT_EQ] = ACTIONS(856),
    [anon_sym_LT_LT] = ACTIONS(854),
    [anon_sym_GT_GT] = ACTIONS(854),
    [anon_sym_PERCENT] = ACTIONS(854),
    [anon_sym_DASH_EQ] = ACTIONS(856),
    [anon_sym_STAR_EQ] = ACTIONS(856),
    [anon_sym_SLASH_EQ] = ACTIONS(856),
    [anon_sym_PERCENT_EQ] = ACTIONS(856),
    [anon_sym_AMP_EQ] = ACTIONS(856),
    [anon_sym_PIPE_EQ] = ACTIONS(856),
    [anon_sym_CARET_EQ] = ACTIONS(856),
    [anon_sym_LT_LT_EQ] = ACTIONS(856),
    [anon_sym_GT_GT_EQ] = ACTIONS(856),
    [anon_sym_QMARK] = ACTIONS(856),
    [sym__cairo_1_short_string] = ACTIONS(856),
    [anon_sym_true] = ACTIONS(854),
    [anon_sym_false] = ACTIONS(854),
    [sym_self] = ACTIONS(854),
  },
  [145] = {
    [sym_identifier] = ACTIONS(858),
    [anon_sym_LPAREN] = ACTIONS(860),
    [anon_sym_EQ] = ACTIONS(858),
    [anon_sym_AT] = ACTIONS(860),
    [anon_sym_LBRACE] = ACTIONS(860),
    [anon_sym_RBRACE] = ACTIONS(860),
    [anon_sym_struct] = ACTIONS(858),
    [anon_sym_EQ_EQ] = ACTIONS(860),
    [anon_sym_let] = ACTIONS(858),
    [anon_sym_const] = ACTIONS(858),
    [anon_sym_if] = ACTIONS(858),
    [anon_sym_BANG_EQ] = ACTIONS(860),
    [anon_sym_PLUS_EQ] = ACTIONS(860),
    [anon_sym_return] = ACTIONS(858),
    [anon_sym_STAR] = ACTIONS(858),
    [anon_sym_AMP] = ACTIONS(858),
    [anon_sym_DASH] = ACTIONS(858),
    [anon_sym_PLUS] = ACTIONS(858),
    [anon_sym_SLASH] = ACTIONS(858),
    [anon_sym_LBRACK] = ACTIONS(860),
    [anon_sym_DOT] = ACTIONS(860),
    [sym_number] = ACTIONS(860),
    [anon_sym_SEMI] = ACTIONS(860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(858),
    [anon_sym_extern] = ACTIONS(858),
    [anon_sym_type] = ACTIONS(858),
    [anon_sym_COLON_COLON] = ACTIONS(860),
    [anon_sym_fn] = ACTIONS(858),
    [anon_sym_POUND] = ACTIONS(860),
    [anon_sym_mod] = ACTIONS(858),
    [anon_sym_enum] = ACTIONS(858),
    [anon_sym_impl] = ACTIONS(858),
    [anon_sym_trait] = ACTIONS(858),
    [anon_sym_u8] = ACTIONS(858),
    [anon_sym_i8] = ACTIONS(858),
    [anon_sym_u16] = ACTIONS(858),
    [anon_sym_i16] = ACTIONS(858),
    [anon_sym_u32] = ACTIONS(858),
    [anon_sym_i32] = ACTIONS(858),
    [anon_sym_u64] = ACTIONS(858),
    [anon_sym_i64] = ACTIONS(858),
    [anon_sym_u128] = ACTIONS(858),
    [anon_sym_i128] = ACTIONS(858),
    [anon_sym_u256] = ACTIONS(858),
    [anon_sym_i256] = ACTIONS(858),
    [anon_sym_isize] = ACTIONS(858),
    [anon_sym_usize] = ACTIONS(858),
    [anon_sym_f32] = ACTIONS(858),
    [anon_sym_f64] = ACTIONS(858),
    [anon_sym_felt252] = ACTIONS(858),
    [anon_sym_bool] = ACTIONS(858),
    [anon_sym_str] = ACTIONS(858),
    [anon_sym_char] = ACTIONS(858),
    [anon_sym_GT] = ACTIONS(858),
    [anon_sym_match] = ACTIONS(858),
    [anon_sym_loop] = ACTIONS(858),
    [anon_sym_BANG] = ACTIONS(858),
    [anon_sym_TILDE] = ACTIONS(860),
    [anon_sym_AMP_AMP] = ACTIONS(860),
    [anon_sym_PIPE_PIPE] = ACTIONS(860),
    [anon_sym_PIPE] = ACTIONS(858),
    [anon_sym_CARET] = ACTIONS(858),
    [anon_sym_LT2] = ACTIONS(858),
    [anon_sym_LT_EQ] = ACTIONS(860),
    [anon_sym_GT_EQ] = ACTIONS(860),
    [anon_sym_LT_LT] = ACTIONS(858),
    [anon_sym_GT_GT] = ACTIONS(858),
    [anon_sym_PERCENT] = ACTIONS(858),
    [anon_sym_DASH_EQ] = ACTIONS(860),
    [anon_sym_STAR_EQ] = ACTIONS(860),
    [anon_sym_SLASH_EQ] = ACTIONS(860),
    [anon_sym_PERCENT_EQ] = ACTIONS(860),
    [anon_sym_AMP_EQ] = ACTIONS(860),
    [anon_sym_PIPE_EQ] = ACTIONS(860),
    [anon_sym_CARET_EQ] = ACTIONS(860),
    [anon_sym_LT_LT_EQ] = ACTIONS(860),
    [anon_sym_GT_GT_EQ] = ACTIONS(860),
    [anon_sym_QMARK] = ACTIONS(860),
    [sym__cairo_1_short_string] = ACTIONS(860),
    [anon_sym_true] = ACTIONS(858),
    [anon_sym_false] = ACTIONS(858),
    [sym_self] = ACTIONS(858),
  },
  [146] = {
    [sym_identifier] = ACTIONS(862),
    [anon_sym_LPAREN] = ACTIONS(864),
    [anon_sym_EQ] = ACTIONS(862),
    [anon_sym_AT] = ACTIONS(864),
    [anon_sym_LBRACE] = ACTIONS(864),
    [anon_sym_RBRACE] = ACTIONS(864),
    [anon_sym_struct] = ACTIONS(862),
    [anon_sym_EQ_EQ] = ACTIONS(864),
    [anon_sym_let] = ACTIONS(862),
    [anon_sym_const] = ACTIONS(862),
    [anon_sym_if] = ACTIONS(862),
    [anon_sym_BANG_EQ] = ACTIONS(864),
    [anon_sym_PLUS_EQ] = ACTIONS(864),
    [anon_sym_return] = ACTIONS(862),
    [anon_sym_STAR] = ACTIONS(862),
    [anon_sym_AMP] = ACTIONS(862),
    [anon_sym_DASH] = ACTIONS(862),
    [anon_sym_PLUS] = ACTIONS(862),
    [anon_sym_SLASH] = ACTIONS(862),
    [anon_sym_LBRACK] = ACTIONS(864),
    [anon_sym_DOT] = ACTIONS(864),
    [sym_number] = ACTIONS(864),
    [anon_sym_SEMI] = ACTIONS(864),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(862),
    [anon_sym_extern] = ACTIONS(862),
    [anon_sym_type] = ACTIONS(862),
    [anon_sym_COLON_COLON] = ACTIONS(864),
    [anon_sym_fn] = ACTIONS(862),
    [anon_sym_POUND] = ACTIONS(864),
    [anon_sym_mod] = ACTIONS(862),
    [anon_sym_enum] = ACTIONS(862),
    [anon_sym_impl] = ACTIONS(862),
    [anon_sym_trait] = ACTIONS(862),
    [anon_sym_u8] = ACTIONS(862),
    [anon_sym_i8] = ACTIONS(862),
    [anon_sym_u16] = ACTIONS(862),
    [anon_sym_i16] = ACTIONS(862),
    [anon_sym_u32] = ACTIONS(862),
    [anon_sym_i32] = ACTIONS(862),
    [anon_sym_u64] = ACTIONS(862),
    [anon_sym_i64] = ACTIONS(862),
    [anon_sym_u128] = ACTIONS(862),
    [anon_sym_i128] = ACTIONS(862),
    [anon_sym_u256] = ACTIONS(862),
    [anon_sym_i256] = ACTIONS(862),
    [anon_sym_isize] = ACTIONS(862),
    [anon_sym_usize] = ACTIONS(862),
    [anon_sym_f32] = ACTIONS(862),
    [anon_sym_f64] = ACTIONS(862),
    [anon_sym_felt252] = ACTIONS(862),
    [anon_sym_bool] = ACTIONS(862),
    [anon_sym_str] = ACTIONS(862),
    [anon_sym_char] = ACTIONS(862),
    [anon_sym_GT] = ACTIONS(862),
    [anon_sym_match] = ACTIONS(862),
    [anon_sym_loop] = ACTIONS(862),
    [anon_sym_BANG] = ACTIONS(862),
    [anon_sym_TILDE] = ACTIONS(864),
    [anon_sym_AMP_AMP] = ACTIONS(864),
    [anon_sym_PIPE_PIPE] = ACTIONS(864),
    [anon_sym_PIPE] = ACTIONS(862),
    [anon_sym_CARET] = ACTIONS(862),
    [anon_sym_LT2] = ACTIONS(862),
    [anon_sym_LT_EQ] = ACTIONS(864),
    [anon_sym_GT_EQ] = ACTIONS(864),
    [anon_sym_LT_LT] = ACTIONS(862),
    [anon_sym_GT_GT] = ACTIONS(862),
    [anon_sym_PERCENT] = ACTIONS(862),
    [anon_sym_DASH_EQ] = ACTIONS(864),
    [anon_sym_STAR_EQ] = ACTIONS(864),
    [anon_sym_SLASH_EQ] = ACTIONS(864),
    [anon_sym_PERCENT_EQ] = ACTIONS(864),
    [anon_sym_AMP_EQ] = ACTIONS(864),
    [anon_sym_PIPE_EQ] = ACTIONS(864),
    [anon_sym_CARET_EQ] = ACTIONS(864),
    [anon_sym_LT_LT_EQ] = ACTIONS(864),
    [anon_sym_GT_GT_EQ] = ACTIONS(864),
    [anon_sym_QMARK] = ACTIONS(864),
    [sym__cairo_1_short_string] = ACTIONS(864),
    [anon_sym_true] = ACTIONS(862),
    [anon_sym_false] = ACTIONS(862),
    [sym_self] = ACTIONS(862),
  },
  [147] = {
    [sym_identifier] = ACTIONS(866),
    [anon_sym_LPAREN] = ACTIONS(868),
    [anon_sym_EQ] = ACTIONS(866),
    [anon_sym_AT] = ACTIONS(868),
    [anon_sym_LBRACE] = ACTIONS(868),
    [anon_sym_RBRACE] = ACTIONS(868),
    [anon_sym_struct] = ACTIONS(866),
    [anon_sym_EQ_EQ] = ACTIONS(868),
    [anon_sym_let] = ACTIONS(866),
    [anon_sym_const] = ACTIONS(866),
    [anon_sym_if] = ACTIONS(866),
    [anon_sym_BANG_EQ] = ACTIONS(868),
    [anon_sym_PLUS_EQ] = ACTIONS(868),
    [anon_sym_return] = ACTIONS(866),
    [anon_sym_STAR] = ACTIONS(866),
    [anon_sym_AMP] = ACTIONS(866),
    [anon_sym_DASH] = ACTIONS(866),
    [anon_sym_PLUS] = ACTIONS(866),
    [anon_sym_SLASH] = ACTIONS(866),
    [anon_sym_LBRACK] = ACTIONS(868),
    [anon_sym_DOT] = ACTIONS(868),
    [sym_number] = ACTIONS(868),
    [anon_sym_SEMI] = ACTIONS(868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(866),
    [anon_sym_extern] = ACTIONS(866),
    [anon_sym_type] = ACTIONS(866),
    [anon_sym_COLON_COLON] = ACTIONS(868),
    [anon_sym_fn] = ACTIONS(866),
    [anon_sym_POUND] = ACTIONS(868),
    [anon_sym_mod] = ACTIONS(866),
    [anon_sym_enum] = ACTIONS(866),
    [anon_sym_impl] = ACTIONS(866),
    [anon_sym_trait] = ACTIONS(866),
    [anon_sym_u8] = ACTIONS(866),
    [anon_sym_i8] = ACTIONS(866),
    [anon_sym_u16] = ACTIONS(866),
    [anon_sym_i16] = ACTIONS(866),
    [anon_sym_u32] = ACTIONS(866),
    [anon_sym_i32] = ACTIONS(866),
    [anon_sym_u64] = ACTIONS(866),
    [anon_sym_i64] = ACTIONS(866),
    [anon_sym_u128] = ACTIONS(866),
    [anon_sym_i128] = ACTIONS(866),
    [anon_sym_u256] = ACTIONS(866),
    [anon_sym_i256] = ACTIONS(866),
    [anon_sym_isize] = ACTIONS(866),
    [anon_sym_usize] = ACTIONS(866),
    [anon_sym_f32] = ACTIONS(866),
    [anon_sym_f64] = ACTIONS(866),
    [anon_sym_felt252] = ACTIONS(866),
    [anon_sym_bool] = ACTIONS(866),
    [anon_sym_str] = ACTIONS(866),
    [anon_sym_char] = ACTIONS(866),
    [anon_sym_GT] = ACTIONS(866),
    [anon_sym_match] = ACTIONS(866),
    [anon_sym_loop] = ACTIONS(866),
    [anon_sym_BANG] = ACTIONS(866),
    [anon_sym_TILDE] = ACTIONS(868),
    [anon_sym_AMP_AMP] = ACTIONS(868),
    [anon_sym_PIPE_PIPE] = ACTIONS(868),
    [anon_sym_PIPE] = ACTIONS(866),
    [anon_sym_CARET] = ACTIONS(866),
    [anon_sym_LT2] = ACTIONS(866),
    [anon_sym_LT_EQ] = ACTIONS(868),
    [anon_sym_GT_EQ] = ACTIONS(868),
    [anon_sym_LT_LT] = ACTIONS(866),
    [anon_sym_GT_GT] = ACTIONS(866),
    [anon_sym_PERCENT] = ACTIONS(866),
    [anon_sym_DASH_EQ] = ACTIONS(868),
    [anon_sym_STAR_EQ] = ACTIONS(868),
    [anon_sym_SLASH_EQ] = ACTIONS(868),
    [anon_sym_PERCENT_EQ] = ACTIONS(868),
    [anon_sym_AMP_EQ] = ACTIONS(868),
    [anon_sym_PIPE_EQ] = ACTIONS(868),
    [anon_sym_CARET_EQ] = ACTIONS(868),
    [anon_sym_LT_LT_EQ] = ACTIONS(868),
    [anon_sym_GT_GT_EQ] = ACTIONS(868),
    [anon_sym_QMARK] = ACTIONS(868),
    [sym__cairo_1_short_string] = ACTIONS(868),
    [anon_sym_true] = ACTIONS(866),
    [anon_sym_false] = ACTIONS(866),
    [sym_self] = ACTIONS(866),
  },
  [148] = {
    [sym_identifier] = ACTIONS(870),
    [anon_sym_LPAREN] = ACTIONS(872),
    [anon_sym_EQ] = ACTIONS(870),
    [anon_sym_AT] = ACTIONS(872),
    [anon_sym_LBRACE] = ACTIONS(872),
    [anon_sym_RBRACE] = ACTIONS(872),
    [anon_sym_struct] = ACTIONS(870),
    [anon_sym_EQ_EQ] = ACTIONS(872),
    [anon_sym_let] = ACTIONS(870),
    [anon_sym_const] = ACTIONS(870),
    [anon_sym_if] = ACTIONS(870),
    [anon_sym_BANG_EQ] = ACTIONS(872),
    [anon_sym_PLUS_EQ] = ACTIONS(872),
    [anon_sym_return] = ACTIONS(870),
    [anon_sym_STAR] = ACTIONS(870),
    [anon_sym_AMP] = ACTIONS(870),
    [anon_sym_DASH] = ACTIONS(870),
    [anon_sym_PLUS] = ACTIONS(870),
    [anon_sym_SLASH] = ACTIONS(870),
    [anon_sym_LBRACK] = ACTIONS(872),
    [anon_sym_DOT] = ACTIONS(872),
    [sym_number] = ACTIONS(872),
    [anon_sym_SEMI] = ACTIONS(872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(870),
    [anon_sym_extern] = ACTIONS(870),
    [anon_sym_type] = ACTIONS(870),
    [anon_sym_COLON_COLON] = ACTIONS(872),
    [anon_sym_fn] = ACTIONS(870),
    [anon_sym_POUND] = ACTIONS(872),
    [anon_sym_mod] = ACTIONS(870),
    [anon_sym_enum] = ACTIONS(870),
    [anon_sym_impl] = ACTIONS(870),
    [anon_sym_trait] = ACTIONS(870),
    [anon_sym_u8] = ACTIONS(870),
    [anon_sym_i8] = ACTIONS(870),
    [anon_sym_u16] = ACTIONS(870),
    [anon_sym_i16] = ACTIONS(870),
    [anon_sym_u32] = ACTIONS(870),
    [anon_sym_i32] = ACTIONS(870),
    [anon_sym_u64] = ACTIONS(870),
    [anon_sym_i64] = ACTIONS(870),
    [anon_sym_u128] = ACTIONS(870),
    [anon_sym_i128] = ACTIONS(870),
    [anon_sym_u256] = ACTIONS(870),
    [anon_sym_i256] = ACTIONS(870),
    [anon_sym_isize] = ACTIONS(870),
    [anon_sym_usize] = ACTIONS(870),
    [anon_sym_f32] = ACTIONS(870),
    [anon_sym_f64] = ACTIONS(870),
    [anon_sym_felt252] = ACTIONS(870),
    [anon_sym_bool] = ACTIONS(870),
    [anon_sym_str] = ACTIONS(870),
    [anon_sym_char] = ACTIONS(870),
    [anon_sym_GT] = ACTIONS(870),
    [anon_sym_match] = ACTIONS(870),
    [anon_sym_loop] = ACTIONS(870),
    [anon_sym_BANG] = ACTIONS(870),
    [anon_sym_TILDE] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(872),
    [anon_sym_PIPE_PIPE] = ACTIONS(872),
    [anon_sym_PIPE] = ACTIONS(870),
    [anon_sym_CARET] = ACTIONS(870),
    [anon_sym_LT2] = ACTIONS(870),
    [anon_sym_LT_EQ] = ACTIONS(872),
    [anon_sym_GT_EQ] = ACTIONS(872),
    [anon_sym_LT_LT] = ACTIONS(870),
    [anon_sym_GT_GT] = ACTIONS(870),
    [anon_sym_PERCENT] = ACTIONS(870),
    [anon_sym_DASH_EQ] = ACTIONS(872),
    [anon_sym_STAR_EQ] = ACTIONS(872),
    [anon_sym_SLASH_EQ] = ACTIONS(872),
    [anon_sym_PERCENT_EQ] = ACTIONS(872),
    [anon_sym_AMP_EQ] = ACTIONS(872),
    [anon_sym_PIPE_EQ] = ACTIONS(872),
    [anon_sym_CARET_EQ] = ACTIONS(872),
    [anon_sym_LT_LT_EQ] = ACTIONS(872),
    [anon_sym_GT_GT_EQ] = ACTIONS(872),
    [anon_sym_QMARK] = ACTIONS(872),
    [sym__cairo_1_short_string] = ACTIONS(872),
    [anon_sym_true] = ACTIONS(870),
    [anon_sym_false] = ACTIONS(870),
    [sym_self] = ACTIONS(870),
  },
  [149] = {
    [sym_identifier] = ACTIONS(874),
    [anon_sym_LPAREN] = ACTIONS(876),
    [anon_sym_EQ] = ACTIONS(874),
    [anon_sym_AT] = ACTIONS(876),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_RBRACE] = ACTIONS(876),
    [anon_sym_struct] = ACTIONS(874),
    [anon_sym_EQ_EQ] = ACTIONS(876),
    [anon_sym_let] = ACTIONS(874),
    [anon_sym_const] = ACTIONS(874),
    [anon_sym_if] = ACTIONS(874),
    [anon_sym_BANG_EQ] = ACTIONS(876),
    [anon_sym_PLUS_EQ] = ACTIONS(876),
    [anon_sym_return] = ACTIONS(874),
    [anon_sym_STAR] = ACTIONS(874),
    [anon_sym_AMP] = ACTIONS(874),
    [anon_sym_DASH] = ACTIONS(874),
    [anon_sym_PLUS] = ACTIONS(874),
    [anon_sym_SLASH] = ACTIONS(874),
    [anon_sym_LBRACK] = ACTIONS(876),
    [anon_sym_DOT] = ACTIONS(876),
    [sym_number] = ACTIONS(876),
    [anon_sym_SEMI] = ACTIONS(876),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(874),
    [anon_sym_extern] = ACTIONS(874),
    [anon_sym_type] = ACTIONS(874),
    [anon_sym_COLON_COLON] = ACTIONS(876),
    [anon_sym_fn] = ACTIONS(874),
    [anon_sym_POUND] = ACTIONS(876),
    [anon_sym_mod] = ACTIONS(874),
    [anon_sym_enum] = ACTIONS(874),
    [anon_sym_impl] = ACTIONS(874),
    [anon_sym_trait] = ACTIONS(874),
    [anon_sym_u8] = ACTIONS(874),
    [anon_sym_i8] = ACTIONS(874),
    [anon_sym_u16] = ACTIONS(874),
    [anon_sym_i16] = ACTIONS(874),
    [anon_sym_u32] = ACTIONS(874),
    [anon_sym_i32] = ACTIONS(874),
    [anon_sym_u64] = ACTIONS(874),
    [anon_sym_i64] = ACTIONS(874),
    [anon_sym_u128] = ACTIONS(874),
    [anon_sym_i128] = ACTIONS(874),
    [anon_sym_u256] = ACTIONS(874),
    [anon_sym_i256] = ACTIONS(874),
    [anon_sym_isize] = ACTIONS(874),
    [anon_sym_usize] = ACTIONS(874),
    [anon_sym_f32] = ACTIONS(874),
    [anon_sym_f64] = ACTIONS(874),
    [anon_sym_felt252] = ACTIONS(874),
    [anon_sym_bool] = ACTIONS(874),
    [anon_sym_str] = ACTIONS(874),
    [anon_sym_char] = ACTIONS(874),
    [anon_sym_GT] = ACTIONS(874),
    [anon_sym_match] = ACTIONS(874),
    [anon_sym_loop] = ACTIONS(874),
    [anon_sym_BANG] = ACTIONS(874),
    [anon_sym_TILDE] = ACTIONS(876),
    [anon_sym_AMP_AMP] = ACTIONS(876),
    [anon_sym_PIPE_PIPE] = ACTIONS(876),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_CARET] = ACTIONS(874),
    [anon_sym_LT2] = ACTIONS(874),
    [anon_sym_LT_EQ] = ACTIONS(876),
    [anon_sym_GT_EQ] = ACTIONS(876),
    [anon_sym_LT_LT] = ACTIONS(874),
    [anon_sym_GT_GT] = ACTIONS(874),
    [anon_sym_PERCENT] = ACTIONS(874),
    [anon_sym_DASH_EQ] = ACTIONS(876),
    [anon_sym_STAR_EQ] = ACTIONS(876),
    [anon_sym_SLASH_EQ] = ACTIONS(876),
    [anon_sym_PERCENT_EQ] = ACTIONS(876),
    [anon_sym_AMP_EQ] = ACTIONS(876),
    [anon_sym_PIPE_EQ] = ACTIONS(876),
    [anon_sym_CARET_EQ] = ACTIONS(876),
    [anon_sym_LT_LT_EQ] = ACTIONS(876),
    [anon_sym_GT_GT_EQ] = ACTIONS(876),
    [anon_sym_QMARK] = ACTIONS(876),
    [sym__cairo_1_short_string] = ACTIONS(876),
    [anon_sym_true] = ACTIONS(874),
    [anon_sym_false] = ACTIONS(874),
    [sym_self] = ACTIONS(874),
  },
  [150] = {
    [sym_identifier] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(880),
    [anon_sym_EQ] = ACTIONS(878),
    [anon_sym_AT] = ACTIONS(880),
    [anon_sym_LBRACE] = ACTIONS(880),
    [anon_sym_RBRACE] = ACTIONS(880),
    [anon_sym_struct] = ACTIONS(878),
    [anon_sym_EQ_EQ] = ACTIONS(880),
    [anon_sym_let] = ACTIONS(878),
    [anon_sym_const] = ACTIONS(878),
    [anon_sym_if] = ACTIONS(878),
    [anon_sym_BANG_EQ] = ACTIONS(880),
    [anon_sym_PLUS_EQ] = ACTIONS(880),
    [anon_sym_return] = ACTIONS(878),
    [anon_sym_STAR] = ACTIONS(878),
    [anon_sym_AMP] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_SLASH] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_DOT] = ACTIONS(880),
    [sym_number] = ACTIONS(880),
    [anon_sym_SEMI] = ACTIONS(880),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(878),
    [anon_sym_extern] = ACTIONS(878),
    [anon_sym_type] = ACTIONS(878),
    [anon_sym_COLON_COLON] = ACTIONS(880),
    [anon_sym_fn] = ACTIONS(878),
    [anon_sym_POUND] = ACTIONS(880),
    [anon_sym_mod] = ACTIONS(878),
    [anon_sym_enum] = ACTIONS(878),
    [anon_sym_impl] = ACTIONS(878),
    [anon_sym_trait] = ACTIONS(878),
    [anon_sym_u8] = ACTIONS(878),
    [anon_sym_i8] = ACTIONS(878),
    [anon_sym_u16] = ACTIONS(878),
    [anon_sym_i16] = ACTIONS(878),
    [anon_sym_u32] = ACTIONS(878),
    [anon_sym_i32] = ACTIONS(878),
    [anon_sym_u64] = ACTIONS(878),
    [anon_sym_i64] = ACTIONS(878),
    [anon_sym_u128] = ACTIONS(878),
    [anon_sym_i128] = ACTIONS(878),
    [anon_sym_u256] = ACTIONS(878),
    [anon_sym_i256] = ACTIONS(878),
    [anon_sym_isize] = ACTIONS(878),
    [anon_sym_usize] = ACTIONS(878),
    [anon_sym_f32] = ACTIONS(878),
    [anon_sym_f64] = ACTIONS(878),
    [anon_sym_felt252] = ACTIONS(878),
    [anon_sym_bool] = ACTIONS(878),
    [anon_sym_str] = ACTIONS(878),
    [anon_sym_char] = ACTIONS(878),
    [anon_sym_GT] = ACTIONS(878),
    [anon_sym_match] = ACTIONS(878),
    [anon_sym_loop] = ACTIONS(878),
    [anon_sym_BANG] = ACTIONS(878),
    [anon_sym_TILDE] = ACTIONS(880),
    [anon_sym_AMP_AMP] = ACTIONS(880),
    [anon_sym_PIPE_PIPE] = ACTIONS(880),
    [anon_sym_PIPE] = ACTIONS(878),
    [anon_sym_CARET] = ACTIONS(878),
    [anon_sym_LT2] = ACTIONS(878),
    [anon_sym_LT_EQ] = ACTIONS(880),
    [anon_sym_GT_EQ] = ACTIONS(880),
    [anon_sym_LT_LT] = ACTIONS(878),
    [anon_sym_GT_GT] = ACTIONS(878),
    [anon_sym_PERCENT] = ACTIONS(878),
    [anon_sym_DASH_EQ] = ACTIONS(880),
    [anon_sym_STAR_EQ] = ACTIONS(880),
    [anon_sym_SLASH_EQ] = ACTIONS(880),
    [anon_sym_PERCENT_EQ] = ACTIONS(880),
    [anon_sym_AMP_EQ] = ACTIONS(880),
    [anon_sym_PIPE_EQ] = ACTIONS(880),
    [anon_sym_CARET_EQ] = ACTIONS(880),
    [anon_sym_LT_LT_EQ] = ACTIONS(880),
    [anon_sym_GT_GT_EQ] = ACTIONS(880),
    [anon_sym_QMARK] = ACTIONS(880),
    [sym__cairo_1_short_string] = ACTIONS(880),
    [anon_sym_true] = ACTIONS(878),
    [anon_sym_false] = ACTIONS(878),
    [sym_self] = ACTIONS(878),
  },
  [151] = {
    [sym_identifier] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [anon_sym_EQ] = ACTIONS(882),
    [anon_sym_AT] = ACTIONS(884),
    [anon_sym_LBRACE] = ACTIONS(884),
    [anon_sym_RBRACE] = ACTIONS(884),
    [anon_sym_struct] = ACTIONS(882),
    [anon_sym_EQ_EQ] = ACTIONS(884),
    [anon_sym_let] = ACTIONS(882),
    [anon_sym_const] = ACTIONS(882),
    [anon_sym_if] = ACTIONS(882),
    [anon_sym_BANG_EQ] = ACTIONS(884),
    [anon_sym_PLUS_EQ] = ACTIONS(884),
    [anon_sym_return] = ACTIONS(882),
    [anon_sym_STAR] = ACTIONS(882),
    [anon_sym_AMP] = ACTIONS(882),
    [anon_sym_DASH] = ACTIONS(882),
    [anon_sym_PLUS] = ACTIONS(882),
    [anon_sym_SLASH] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_DOT] = ACTIONS(884),
    [sym_number] = ACTIONS(884),
    [anon_sym_SEMI] = ACTIONS(884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(882),
    [anon_sym_extern] = ACTIONS(882),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_COLON_COLON] = ACTIONS(884),
    [anon_sym_fn] = ACTIONS(882),
    [anon_sym_POUND] = ACTIONS(884),
    [anon_sym_mod] = ACTIONS(882),
    [anon_sym_enum] = ACTIONS(882),
    [anon_sym_impl] = ACTIONS(882),
    [anon_sym_trait] = ACTIONS(882),
    [anon_sym_u8] = ACTIONS(882),
    [anon_sym_i8] = ACTIONS(882),
    [anon_sym_u16] = ACTIONS(882),
    [anon_sym_i16] = ACTIONS(882),
    [anon_sym_u32] = ACTIONS(882),
    [anon_sym_i32] = ACTIONS(882),
    [anon_sym_u64] = ACTIONS(882),
    [anon_sym_i64] = ACTIONS(882),
    [anon_sym_u128] = ACTIONS(882),
    [anon_sym_i128] = ACTIONS(882),
    [anon_sym_u256] = ACTIONS(882),
    [anon_sym_i256] = ACTIONS(882),
    [anon_sym_isize] = ACTIONS(882),
    [anon_sym_usize] = ACTIONS(882),
    [anon_sym_f32] = ACTIONS(882),
    [anon_sym_f64] = ACTIONS(882),
    [anon_sym_felt252] = ACTIONS(882),
    [anon_sym_bool] = ACTIONS(882),
    [anon_sym_str] = ACTIONS(882),
    [anon_sym_char] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(882),
    [anon_sym_match] = ACTIONS(882),
    [anon_sym_loop] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(882),
    [anon_sym_TILDE] = ACTIONS(884),
    [anon_sym_AMP_AMP] = ACTIONS(884),
    [anon_sym_PIPE_PIPE] = ACTIONS(884),
    [anon_sym_PIPE] = ACTIONS(882),
    [anon_sym_CARET] = ACTIONS(882),
    [anon_sym_LT2] = ACTIONS(882),
    [anon_sym_LT_EQ] = ACTIONS(884),
    [anon_sym_GT_EQ] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(882),
    [anon_sym_GT_GT] = ACTIONS(882),
    [anon_sym_PERCENT] = ACTIONS(882),
    [anon_sym_DASH_EQ] = ACTIONS(884),
    [anon_sym_STAR_EQ] = ACTIONS(884),
    [anon_sym_SLASH_EQ] = ACTIONS(884),
    [anon_sym_PERCENT_EQ] = ACTIONS(884),
    [anon_sym_AMP_EQ] = ACTIONS(884),
    [anon_sym_PIPE_EQ] = ACTIONS(884),
    [anon_sym_CARET_EQ] = ACTIONS(884),
    [anon_sym_LT_LT_EQ] = ACTIONS(884),
    [anon_sym_GT_GT_EQ] = ACTIONS(884),
    [anon_sym_QMARK] = ACTIONS(884),
    [sym__cairo_1_short_string] = ACTIONS(884),
    [anon_sym_true] = ACTIONS(882),
    [anon_sym_false] = ACTIONS(882),
    [sym_self] = ACTIONS(882),
  },
  [152] = {
    [sym_identifier] = ACTIONS(886),
    [anon_sym_LPAREN] = ACTIONS(888),
    [anon_sym_EQ] = ACTIONS(886),
    [anon_sym_AT] = ACTIONS(888),
    [anon_sym_LBRACE] = ACTIONS(888),
    [anon_sym_RBRACE] = ACTIONS(888),
    [anon_sym_struct] = ACTIONS(886),
    [anon_sym_EQ_EQ] = ACTIONS(888),
    [anon_sym_let] = ACTIONS(886),
    [anon_sym_const] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(886),
    [anon_sym_BANG_EQ] = ACTIONS(888),
    [anon_sym_PLUS_EQ] = ACTIONS(888),
    [anon_sym_return] = ACTIONS(886),
    [anon_sym_STAR] = ACTIONS(886),
    [anon_sym_AMP] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_SLASH] = ACTIONS(886),
    [anon_sym_LBRACK] = ACTIONS(888),
    [anon_sym_DOT] = ACTIONS(888),
    [sym_number] = ACTIONS(888),
    [anon_sym_SEMI] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(886),
    [anon_sym_extern] = ACTIONS(886),
    [anon_sym_type] = ACTIONS(886),
    [anon_sym_COLON_COLON] = ACTIONS(888),
    [anon_sym_fn] = ACTIONS(886),
    [anon_sym_POUND] = ACTIONS(888),
    [anon_sym_mod] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(886),
    [anon_sym_impl] = ACTIONS(886),
    [anon_sym_trait] = ACTIONS(886),
    [anon_sym_u8] = ACTIONS(886),
    [anon_sym_i8] = ACTIONS(886),
    [anon_sym_u16] = ACTIONS(886),
    [anon_sym_i16] = ACTIONS(886),
    [anon_sym_u32] = ACTIONS(886),
    [anon_sym_i32] = ACTIONS(886),
    [anon_sym_u64] = ACTIONS(886),
    [anon_sym_i64] = ACTIONS(886),
    [anon_sym_u128] = ACTIONS(886),
    [anon_sym_i128] = ACTIONS(886),
    [anon_sym_u256] = ACTIONS(886),
    [anon_sym_i256] = ACTIONS(886),
    [anon_sym_isize] = ACTIONS(886),
    [anon_sym_usize] = ACTIONS(886),
    [anon_sym_f32] = ACTIONS(886),
    [anon_sym_f64] = ACTIONS(886),
    [anon_sym_felt252] = ACTIONS(886),
    [anon_sym_bool] = ACTIONS(886),
    [anon_sym_str] = ACTIONS(886),
    [anon_sym_char] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(886),
    [anon_sym_match] = ACTIONS(886),
    [anon_sym_loop] = ACTIONS(886),
    [anon_sym_BANG] = ACTIONS(886),
    [anon_sym_TILDE] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(888),
    [anon_sym_PIPE_PIPE] = ACTIONS(888),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(886),
    [anon_sym_LT2] = ACTIONS(886),
    [anon_sym_LT_EQ] = ACTIONS(888),
    [anon_sym_GT_EQ] = ACTIONS(888),
    [anon_sym_LT_LT] = ACTIONS(886),
    [anon_sym_GT_GT] = ACTIONS(886),
    [anon_sym_PERCENT] = ACTIONS(886),
    [anon_sym_DASH_EQ] = ACTIONS(888),
    [anon_sym_STAR_EQ] = ACTIONS(888),
    [anon_sym_SLASH_EQ] = ACTIONS(888),
    [anon_sym_PERCENT_EQ] = ACTIONS(888),
    [anon_sym_AMP_EQ] = ACTIONS(888),
    [anon_sym_PIPE_EQ] = ACTIONS(888),
    [anon_sym_CARET_EQ] = ACTIONS(888),
    [anon_sym_LT_LT_EQ] = ACTIONS(888),
    [anon_sym_GT_GT_EQ] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(888),
    [sym__cairo_1_short_string] = ACTIONS(888),
    [anon_sym_true] = ACTIONS(886),
    [anon_sym_false] = ACTIONS(886),
    [sym_self] = ACTIONS(886),
  },
  [153] = {
    [sym_identifier] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_EQ] = ACTIONS(890),
    [anon_sym_AT] = ACTIONS(892),
    [anon_sym_LBRACE] = ACTIONS(892),
    [anon_sym_RBRACE] = ACTIONS(892),
    [anon_sym_struct] = ACTIONS(890),
    [anon_sym_EQ_EQ] = ACTIONS(892),
    [anon_sym_let] = ACTIONS(890),
    [anon_sym_const] = ACTIONS(890),
    [anon_sym_if] = ACTIONS(890),
    [anon_sym_BANG_EQ] = ACTIONS(892),
    [anon_sym_PLUS_EQ] = ACTIONS(892),
    [anon_sym_return] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(890),
    [anon_sym_AMP] = ACTIONS(890),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_SLASH] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(892),
    [anon_sym_DOT] = ACTIONS(892),
    [sym_number] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(890),
    [anon_sym_extern] = ACTIONS(890),
    [anon_sym_type] = ACTIONS(890),
    [anon_sym_COLON_COLON] = ACTIONS(892),
    [anon_sym_fn] = ACTIONS(890),
    [anon_sym_POUND] = ACTIONS(892),
    [anon_sym_mod] = ACTIONS(890),
    [anon_sym_enum] = ACTIONS(890),
    [anon_sym_impl] = ACTIONS(890),
    [anon_sym_trait] = ACTIONS(890),
    [anon_sym_u8] = ACTIONS(890),
    [anon_sym_i8] = ACTIONS(890),
    [anon_sym_u16] = ACTIONS(890),
    [anon_sym_i16] = ACTIONS(890),
    [anon_sym_u32] = ACTIONS(890),
    [anon_sym_i32] = ACTIONS(890),
    [anon_sym_u64] = ACTIONS(890),
    [anon_sym_i64] = ACTIONS(890),
    [anon_sym_u128] = ACTIONS(890),
    [anon_sym_i128] = ACTIONS(890),
    [anon_sym_u256] = ACTIONS(890),
    [anon_sym_i256] = ACTIONS(890),
    [anon_sym_isize] = ACTIONS(890),
    [anon_sym_usize] = ACTIONS(890),
    [anon_sym_f32] = ACTIONS(890),
    [anon_sym_f64] = ACTIONS(890),
    [anon_sym_felt252] = ACTIONS(890),
    [anon_sym_bool] = ACTIONS(890),
    [anon_sym_str] = ACTIONS(890),
    [anon_sym_char] = ACTIONS(890),
    [anon_sym_GT] = ACTIONS(890),
    [anon_sym_match] = ACTIONS(890),
    [anon_sym_loop] = ACTIONS(890),
    [anon_sym_BANG] = ACTIONS(890),
    [anon_sym_TILDE] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(892),
    [anon_sym_PIPE_PIPE] = ACTIONS(892),
    [anon_sym_PIPE] = ACTIONS(890),
    [anon_sym_CARET] = ACTIONS(890),
    [anon_sym_LT2] = ACTIONS(890),
    [anon_sym_LT_EQ] = ACTIONS(892),
    [anon_sym_GT_EQ] = ACTIONS(892),
    [anon_sym_LT_LT] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(890),
    [anon_sym_PERCENT] = ACTIONS(890),
    [anon_sym_DASH_EQ] = ACTIONS(892),
    [anon_sym_STAR_EQ] = ACTIONS(892),
    [anon_sym_SLASH_EQ] = ACTIONS(892),
    [anon_sym_PERCENT_EQ] = ACTIONS(892),
    [anon_sym_AMP_EQ] = ACTIONS(892),
    [anon_sym_PIPE_EQ] = ACTIONS(892),
    [anon_sym_CARET_EQ] = ACTIONS(892),
    [anon_sym_LT_LT_EQ] = ACTIONS(892),
    [anon_sym_GT_GT_EQ] = ACTIONS(892),
    [anon_sym_QMARK] = ACTIONS(892),
    [sym__cairo_1_short_string] = ACTIONS(892),
    [anon_sym_true] = ACTIONS(890),
    [anon_sym_false] = ACTIONS(890),
    [sym_self] = ACTIONS(890),
  },
  [154] = {
    [sym_identifier] = ACTIONS(894),
    [anon_sym_LPAREN] = ACTIONS(896),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_AT] = ACTIONS(896),
    [anon_sym_LBRACE] = ACTIONS(896),
    [anon_sym_RBRACE] = ACTIONS(896),
    [anon_sym_struct] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_let] = ACTIONS(894),
    [anon_sym_const] = ACTIONS(894),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_PLUS_EQ] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(894),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(896),
    [anon_sym_DOT] = ACTIONS(896),
    [sym_number] = ACTIONS(896),
    [anon_sym_SEMI] = ACTIONS(896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(894),
    [anon_sym_extern] = ACTIONS(894),
    [anon_sym_type] = ACTIONS(894),
    [anon_sym_COLON_COLON] = ACTIONS(896),
    [anon_sym_fn] = ACTIONS(894),
    [anon_sym_POUND] = ACTIONS(896),
    [anon_sym_mod] = ACTIONS(894),
    [anon_sym_enum] = ACTIONS(894),
    [anon_sym_impl] = ACTIONS(894),
    [anon_sym_trait] = ACTIONS(894),
    [anon_sym_u8] = ACTIONS(894),
    [anon_sym_i8] = ACTIONS(894),
    [anon_sym_u16] = ACTIONS(894),
    [anon_sym_i16] = ACTIONS(894),
    [anon_sym_u32] = ACTIONS(894),
    [anon_sym_i32] = ACTIONS(894),
    [anon_sym_u64] = ACTIONS(894),
    [anon_sym_i64] = ACTIONS(894),
    [anon_sym_u128] = ACTIONS(894),
    [anon_sym_i128] = ACTIONS(894),
    [anon_sym_u256] = ACTIONS(894),
    [anon_sym_i256] = ACTIONS(894),
    [anon_sym_isize] = ACTIONS(894),
    [anon_sym_usize] = ACTIONS(894),
    [anon_sym_f32] = ACTIONS(894),
    [anon_sym_f64] = ACTIONS(894),
    [anon_sym_felt252] = ACTIONS(894),
    [anon_sym_bool] = ACTIONS(894),
    [anon_sym_str] = ACTIONS(894),
    [anon_sym_char] = ACTIONS(894),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_match] = ACTIONS(894),
    [anon_sym_loop] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(896),
    [anon_sym_AMP_AMP] = ACTIONS(896),
    [anon_sym_PIPE_PIPE] = ACTIONS(896),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(894),
    [anon_sym_LT2] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(896),
    [anon_sym_LT_LT] = ACTIONS(894),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_DASH_EQ] = ACTIONS(896),
    [anon_sym_STAR_EQ] = ACTIONS(896),
    [anon_sym_SLASH_EQ] = ACTIONS(896),
    [anon_sym_PERCENT_EQ] = ACTIONS(896),
    [anon_sym_AMP_EQ] = ACTIONS(896),
    [anon_sym_PIPE_EQ] = ACTIONS(896),
    [anon_sym_CARET_EQ] = ACTIONS(896),
    [anon_sym_LT_LT_EQ] = ACTIONS(896),
    [anon_sym_GT_GT_EQ] = ACTIONS(896),
    [anon_sym_QMARK] = ACTIONS(896),
    [sym__cairo_1_short_string] = ACTIONS(896),
    [anon_sym_true] = ACTIONS(894),
    [anon_sym_false] = ACTIONS(894),
    [sym_self] = ACTIONS(894),
  },
  [155] = {
    [sym_identifier] = ACTIONS(898),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_EQ] = ACTIONS(898),
    [anon_sym_AT] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_RBRACE] = ACTIONS(900),
    [anon_sym_struct] = ACTIONS(898),
    [anon_sym_EQ_EQ] = ACTIONS(900),
    [anon_sym_let] = ACTIONS(898),
    [anon_sym_const] = ACTIONS(898),
    [anon_sym_if] = ACTIONS(898),
    [anon_sym_BANG_EQ] = ACTIONS(900),
    [anon_sym_PLUS_EQ] = ACTIONS(900),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_STAR] = ACTIONS(898),
    [anon_sym_AMP] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_SLASH] = ACTIONS(898),
    [anon_sym_LBRACK] = ACTIONS(900),
    [anon_sym_DOT] = ACTIONS(900),
    [sym_number] = ACTIONS(900),
    [anon_sym_SEMI] = ACTIONS(900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(898),
    [anon_sym_extern] = ACTIONS(898),
    [anon_sym_type] = ACTIONS(898),
    [anon_sym_COLON_COLON] = ACTIONS(900),
    [anon_sym_fn] = ACTIONS(898),
    [anon_sym_POUND] = ACTIONS(900),
    [anon_sym_mod] = ACTIONS(898),
    [anon_sym_enum] = ACTIONS(898),
    [anon_sym_impl] = ACTIONS(898),
    [anon_sym_trait] = ACTIONS(898),
    [anon_sym_u8] = ACTIONS(898),
    [anon_sym_i8] = ACTIONS(898),
    [anon_sym_u16] = ACTIONS(898),
    [anon_sym_i16] = ACTIONS(898),
    [anon_sym_u32] = ACTIONS(898),
    [anon_sym_i32] = ACTIONS(898),
    [anon_sym_u64] = ACTIONS(898),
    [anon_sym_i64] = ACTIONS(898),
    [anon_sym_u128] = ACTIONS(898),
    [anon_sym_i128] = ACTIONS(898),
    [anon_sym_u256] = ACTIONS(898),
    [anon_sym_i256] = ACTIONS(898),
    [anon_sym_isize] = ACTIONS(898),
    [anon_sym_usize] = ACTIONS(898),
    [anon_sym_f32] = ACTIONS(898),
    [anon_sym_f64] = ACTIONS(898),
    [anon_sym_felt252] = ACTIONS(898),
    [anon_sym_bool] = ACTIONS(898),
    [anon_sym_str] = ACTIONS(898),
    [anon_sym_char] = ACTIONS(898),
    [anon_sym_GT] = ACTIONS(898),
    [anon_sym_match] = ACTIONS(898),
    [anon_sym_loop] = ACTIONS(898),
    [anon_sym_BANG] = ACTIONS(898),
    [anon_sym_TILDE] = ACTIONS(900),
    [anon_sym_AMP_AMP] = ACTIONS(900),
    [anon_sym_PIPE_PIPE] = ACTIONS(900),
    [anon_sym_PIPE] = ACTIONS(898),
    [anon_sym_CARET] = ACTIONS(898),
    [anon_sym_LT2] = ACTIONS(898),
    [anon_sym_LT_EQ] = ACTIONS(900),
    [anon_sym_GT_EQ] = ACTIONS(900),
    [anon_sym_LT_LT] = ACTIONS(898),
    [anon_sym_GT_GT] = ACTIONS(898),
    [anon_sym_PERCENT] = ACTIONS(898),
    [anon_sym_DASH_EQ] = ACTIONS(900),
    [anon_sym_STAR_EQ] = ACTIONS(900),
    [anon_sym_SLASH_EQ] = ACTIONS(900),
    [anon_sym_PERCENT_EQ] = ACTIONS(900),
    [anon_sym_AMP_EQ] = ACTIONS(900),
    [anon_sym_PIPE_EQ] = ACTIONS(900),
    [anon_sym_CARET_EQ] = ACTIONS(900),
    [anon_sym_LT_LT_EQ] = ACTIONS(900),
    [anon_sym_GT_GT_EQ] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(900),
    [sym__cairo_1_short_string] = ACTIONS(900),
    [anon_sym_true] = ACTIONS(898),
    [anon_sym_false] = ACTIONS(898),
    [sym_self] = ACTIONS(898),
  },
  [156] = {
    [sym_identifier] = ACTIONS(902),
    [anon_sym_LPAREN] = ACTIONS(904),
    [anon_sym_EQ] = ACTIONS(902),
    [anon_sym_AT] = ACTIONS(904),
    [anon_sym_LBRACE] = ACTIONS(904),
    [anon_sym_RBRACE] = ACTIONS(904),
    [anon_sym_struct] = ACTIONS(902),
    [anon_sym_EQ_EQ] = ACTIONS(904),
    [anon_sym_let] = ACTIONS(902),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(902),
    [anon_sym_BANG_EQ] = ACTIONS(904),
    [anon_sym_PLUS_EQ] = ACTIONS(904),
    [anon_sym_return] = ACTIONS(902),
    [anon_sym_STAR] = ACTIONS(902),
    [anon_sym_AMP] = ACTIONS(902),
    [anon_sym_DASH] = ACTIONS(902),
    [anon_sym_PLUS] = ACTIONS(902),
    [anon_sym_SLASH] = ACTIONS(902),
    [anon_sym_LBRACK] = ACTIONS(904),
    [anon_sym_DOT] = ACTIONS(904),
    [sym_number] = ACTIONS(904),
    [anon_sym_SEMI] = ACTIONS(904),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(902),
    [anon_sym_extern] = ACTIONS(902),
    [anon_sym_type] = ACTIONS(902),
    [anon_sym_COLON_COLON] = ACTIONS(904),
    [anon_sym_fn] = ACTIONS(902),
    [anon_sym_POUND] = ACTIONS(904),
    [anon_sym_mod] = ACTIONS(902),
    [anon_sym_enum] = ACTIONS(902),
    [anon_sym_impl] = ACTIONS(902),
    [anon_sym_trait] = ACTIONS(902),
    [anon_sym_u8] = ACTIONS(902),
    [anon_sym_i8] = ACTIONS(902),
    [anon_sym_u16] = ACTIONS(902),
    [anon_sym_i16] = ACTIONS(902),
    [anon_sym_u32] = ACTIONS(902),
    [anon_sym_i32] = ACTIONS(902),
    [anon_sym_u64] = ACTIONS(902),
    [anon_sym_i64] = ACTIONS(902),
    [anon_sym_u128] = ACTIONS(902),
    [anon_sym_i128] = ACTIONS(902),
    [anon_sym_u256] = ACTIONS(902),
    [anon_sym_i256] = ACTIONS(902),
    [anon_sym_isize] = ACTIONS(902),
    [anon_sym_usize] = ACTIONS(902),
    [anon_sym_f32] = ACTIONS(902),
    [anon_sym_f64] = ACTIONS(902),
    [anon_sym_felt252] = ACTIONS(902),
    [anon_sym_bool] = ACTIONS(902),
    [anon_sym_str] = ACTIONS(902),
    [anon_sym_char] = ACTIONS(902),
    [anon_sym_GT] = ACTIONS(902),
    [anon_sym_match] = ACTIONS(902),
    [anon_sym_loop] = ACTIONS(902),
    [anon_sym_BANG] = ACTIONS(902),
    [anon_sym_TILDE] = ACTIONS(904),
    [anon_sym_AMP_AMP] = ACTIONS(904),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_PIPE] = ACTIONS(902),
    [anon_sym_CARET] = ACTIONS(902),
    [anon_sym_LT2] = ACTIONS(902),
    [anon_sym_LT_EQ] = ACTIONS(904),
    [anon_sym_GT_EQ] = ACTIONS(904),
    [anon_sym_LT_LT] = ACTIONS(902),
    [anon_sym_GT_GT] = ACTIONS(902),
    [anon_sym_PERCENT] = ACTIONS(902),
    [anon_sym_DASH_EQ] = ACTIONS(904),
    [anon_sym_STAR_EQ] = ACTIONS(904),
    [anon_sym_SLASH_EQ] = ACTIONS(904),
    [anon_sym_PERCENT_EQ] = ACTIONS(904),
    [anon_sym_AMP_EQ] = ACTIONS(904),
    [anon_sym_PIPE_EQ] = ACTIONS(904),
    [anon_sym_CARET_EQ] = ACTIONS(904),
    [anon_sym_LT_LT_EQ] = ACTIONS(904),
    [anon_sym_GT_GT_EQ] = ACTIONS(904),
    [anon_sym_QMARK] = ACTIONS(904),
    [sym__cairo_1_short_string] = ACTIONS(904),
    [anon_sym_true] = ACTIONS(902),
    [anon_sym_false] = ACTIONS(902),
    [sym_self] = ACTIONS(902),
  },
  [157] = {
    [sym_identifier] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(908),
    [anon_sym_EQ] = ACTIONS(906),
    [anon_sym_AT] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(908),
    [anon_sym_RBRACE] = ACTIONS(908),
    [anon_sym_struct] = ACTIONS(906),
    [anon_sym_EQ_EQ] = ACTIONS(908),
    [anon_sym_let] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(906),
    [anon_sym_if] = ACTIONS(906),
    [anon_sym_BANG_EQ] = ACTIONS(908),
    [anon_sym_PLUS_EQ] = ACTIONS(908),
    [anon_sym_return] = ACTIONS(906),
    [anon_sym_STAR] = ACTIONS(906),
    [anon_sym_AMP] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_SLASH] = ACTIONS(906),
    [anon_sym_LBRACK] = ACTIONS(908),
    [anon_sym_DOT] = ACTIONS(908),
    [sym_number] = ACTIONS(908),
    [anon_sym_SEMI] = ACTIONS(908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(906),
    [anon_sym_extern] = ACTIONS(906),
    [anon_sym_type] = ACTIONS(906),
    [anon_sym_COLON_COLON] = ACTIONS(908),
    [anon_sym_fn] = ACTIONS(906),
    [anon_sym_POUND] = ACTIONS(908),
    [anon_sym_mod] = ACTIONS(906),
    [anon_sym_enum] = ACTIONS(906),
    [anon_sym_impl] = ACTIONS(906),
    [anon_sym_trait] = ACTIONS(906),
    [anon_sym_u8] = ACTIONS(906),
    [anon_sym_i8] = ACTIONS(906),
    [anon_sym_u16] = ACTIONS(906),
    [anon_sym_i16] = ACTIONS(906),
    [anon_sym_u32] = ACTIONS(906),
    [anon_sym_i32] = ACTIONS(906),
    [anon_sym_u64] = ACTIONS(906),
    [anon_sym_i64] = ACTIONS(906),
    [anon_sym_u128] = ACTIONS(906),
    [anon_sym_i128] = ACTIONS(906),
    [anon_sym_u256] = ACTIONS(906),
    [anon_sym_i256] = ACTIONS(906),
    [anon_sym_isize] = ACTIONS(906),
    [anon_sym_usize] = ACTIONS(906),
    [anon_sym_f32] = ACTIONS(906),
    [anon_sym_f64] = ACTIONS(906),
    [anon_sym_felt252] = ACTIONS(906),
    [anon_sym_bool] = ACTIONS(906),
    [anon_sym_str] = ACTIONS(906),
    [anon_sym_char] = ACTIONS(906),
    [anon_sym_GT] = ACTIONS(906),
    [anon_sym_match] = ACTIONS(906),
    [anon_sym_loop] = ACTIONS(906),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_TILDE] = ACTIONS(908),
    [anon_sym_AMP_AMP] = ACTIONS(908),
    [anon_sym_PIPE_PIPE] = ACTIONS(908),
    [anon_sym_PIPE] = ACTIONS(906),
    [anon_sym_CARET] = ACTIONS(906),
    [anon_sym_LT2] = ACTIONS(906),
    [anon_sym_LT_EQ] = ACTIONS(908),
    [anon_sym_GT_EQ] = ACTIONS(908),
    [anon_sym_LT_LT] = ACTIONS(906),
    [anon_sym_GT_GT] = ACTIONS(906),
    [anon_sym_PERCENT] = ACTIONS(906),
    [anon_sym_DASH_EQ] = ACTIONS(908),
    [anon_sym_STAR_EQ] = ACTIONS(908),
    [anon_sym_SLASH_EQ] = ACTIONS(908),
    [anon_sym_PERCENT_EQ] = ACTIONS(908),
    [anon_sym_AMP_EQ] = ACTIONS(908),
    [anon_sym_PIPE_EQ] = ACTIONS(908),
    [anon_sym_CARET_EQ] = ACTIONS(908),
    [anon_sym_LT_LT_EQ] = ACTIONS(908),
    [anon_sym_GT_GT_EQ] = ACTIONS(908),
    [anon_sym_QMARK] = ACTIONS(908),
    [sym__cairo_1_short_string] = ACTIONS(908),
    [anon_sym_true] = ACTIONS(906),
    [anon_sym_false] = ACTIONS(906),
    [sym_self] = ACTIONS(906),
  },
  [158] = {
    [sym_identifier] = ACTIONS(910),
    [anon_sym_LPAREN] = ACTIONS(912),
    [anon_sym_EQ] = ACTIONS(910),
    [anon_sym_AT] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(912),
    [anon_sym_RBRACE] = ACTIONS(912),
    [anon_sym_struct] = ACTIONS(910),
    [anon_sym_EQ_EQ] = ACTIONS(912),
    [anon_sym_let] = ACTIONS(910),
    [anon_sym_const] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_BANG_EQ] = ACTIONS(912),
    [anon_sym_PLUS_EQ] = ACTIONS(912),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_STAR] = ACTIONS(910),
    [anon_sym_AMP] = ACTIONS(910),
    [anon_sym_DASH] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(912),
    [anon_sym_DOT] = ACTIONS(912),
    [sym_number] = ACTIONS(912),
    [anon_sym_SEMI] = ACTIONS(912),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(910),
    [anon_sym_extern] = ACTIONS(910),
    [anon_sym_type] = ACTIONS(910),
    [anon_sym_COLON_COLON] = ACTIONS(912),
    [anon_sym_fn] = ACTIONS(910),
    [anon_sym_POUND] = ACTIONS(912),
    [anon_sym_mod] = ACTIONS(910),
    [anon_sym_enum] = ACTIONS(910),
    [anon_sym_impl] = ACTIONS(910),
    [anon_sym_trait] = ACTIONS(910),
    [anon_sym_u8] = ACTIONS(910),
    [anon_sym_i8] = ACTIONS(910),
    [anon_sym_u16] = ACTIONS(910),
    [anon_sym_i16] = ACTIONS(910),
    [anon_sym_u32] = ACTIONS(910),
    [anon_sym_i32] = ACTIONS(910),
    [anon_sym_u64] = ACTIONS(910),
    [anon_sym_i64] = ACTIONS(910),
    [anon_sym_u128] = ACTIONS(910),
    [anon_sym_i128] = ACTIONS(910),
    [anon_sym_u256] = ACTIONS(910),
    [anon_sym_i256] = ACTIONS(910),
    [anon_sym_isize] = ACTIONS(910),
    [anon_sym_usize] = ACTIONS(910),
    [anon_sym_f32] = ACTIONS(910),
    [anon_sym_f64] = ACTIONS(910),
    [anon_sym_felt252] = ACTIONS(910),
    [anon_sym_bool] = ACTIONS(910),
    [anon_sym_str] = ACTIONS(910),
    [anon_sym_char] = ACTIONS(910),
    [anon_sym_GT] = ACTIONS(910),
    [anon_sym_match] = ACTIONS(910),
    [anon_sym_loop] = ACTIONS(910),
    [anon_sym_BANG] = ACTIONS(910),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_AMP_AMP] = ACTIONS(912),
    [anon_sym_PIPE_PIPE] = ACTIONS(912),
    [anon_sym_PIPE] = ACTIONS(910),
    [anon_sym_CARET] = ACTIONS(910),
    [anon_sym_LT2] = ACTIONS(910),
    [anon_sym_LT_EQ] = ACTIONS(912),
    [anon_sym_GT_EQ] = ACTIONS(912),
    [anon_sym_LT_LT] = ACTIONS(910),
    [anon_sym_GT_GT] = ACTIONS(910),
    [anon_sym_PERCENT] = ACTIONS(910),
    [anon_sym_DASH_EQ] = ACTIONS(912),
    [anon_sym_STAR_EQ] = ACTIONS(912),
    [anon_sym_SLASH_EQ] = ACTIONS(912),
    [anon_sym_PERCENT_EQ] = ACTIONS(912),
    [anon_sym_AMP_EQ] = ACTIONS(912),
    [anon_sym_PIPE_EQ] = ACTIONS(912),
    [anon_sym_CARET_EQ] = ACTIONS(912),
    [anon_sym_LT_LT_EQ] = ACTIONS(912),
    [anon_sym_GT_GT_EQ] = ACTIONS(912),
    [anon_sym_QMARK] = ACTIONS(912),
    [sym__cairo_1_short_string] = ACTIONS(912),
    [anon_sym_true] = ACTIONS(910),
    [anon_sym_false] = ACTIONS(910),
    [sym_self] = ACTIONS(910),
  },
  [159] = {
    [sym_identifier] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(916),
    [anon_sym_EQ] = ACTIONS(914),
    [anon_sym_AT] = ACTIONS(916),
    [anon_sym_LBRACE] = ACTIONS(916),
    [anon_sym_RBRACE] = ACTIONS(916),
    [anon_sym_struct] = ACTIONS(914),
    [anon_sym_EQ_EQ] = ACTIONS(916),
    [anon_sym_let] = ACTIONS(914),
    [anon_sym_const] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_BANG_EQ] = ACTIONS(916),
    [anon_sym_PLUS_EQ] = ACTIONS(916),
    [anon_sym_return] = ACTIONS(914),
    [anon_sym_STAR] = ACTIONS(914),
    [anon_sym_AMP] = ACTIONS(914),
    [anon_sym_DASH] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(914),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_LBRACK] = ACTIONS(916),
    [anon_sym_DOT] = ACTIONS(916),
    [sym_number] = ACTIONS(916),
    [anon_sym_SEMI] = ACTIONS(916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(914),
    [anon_sym_extern] = ACTIONS(914),
    [anon_sym_type] = ACTIONS(914),
    [anon_sym_COLON_COLON] = ACTIONS(916),
    [anon_sym_fn] = ACTIONS(914),
    [anon_sym_POUND] = ACTIONS(916),
    [anon_sym_mod] = ACTIONS(914),
    [anon_sym_enum] = ACTIONS(914),
    [anon_sym_impl] = ACTIONS(914),
    [anon_sym_trait] = ACTIONS(914),
    [anon_sym_u8] = ACTIONS(914),
    [anon_sym_i8] = ACTIONS(914),
    [anon_sym_u16] = ACTIONS(914),
    [anon_sym_i16] = ACTIONS(914),
    [anon_sym_u32] = ACTIONS(914),
    [anon_sym_i32] = ACTIONS(914),
    [anon_sym_u64] = ACTIONS(914),
    [anon_sym_i64] = ACTIONS(914),
    [anon_sym_u128] = ACTIONS(914),
    [anon_sym_i128] = ACTIONS(914),
    [anon_sym_u256] = ACTIONS(914),
    [anon_sym_i256] = ACTIONS(914),
    [anon_sym_isize] = ACTIONS(914),
    [anon_sym_usize] = ACTIONS(914),
    [anon_sym_f32] = ACTIONS(914),
    [anon_sym_f64] = ACTIONS(914),
    [anon_sym_felt252] = ACTIONS(914),
    [anon_sym_bool] = ACTIONS(914),
    [anon_sym_str] = ACTIONS(914),
    [anon_sym_char] = ACTIONS(914),
    [anon_sym_GT] = ACTIONS(914),
    [anon_sym_match] = ACTIONS(914),
    [anon_sym_loop] = ACTIONS(914),
    [anon_sym_BANG] = ACTIONS(914),
    [anon_sym_TILDE] = ACTIONS(916),
    [anon_sym_AMP_AMP] = ACTIONS(916),
    [anon_sym_PIPE_PIPE] = ACTIONS(916),
    [anon_sym_PIPE] = ACTIONS(914),
    [anon_sym_CARET] = ACTIONS(914),
    [anon_sym_LT2] = ACTIONS(914),
    [anon_sym_LT_EQ] = ACTIONS(916),
    [anon_sym_GT_EQ] = ACTIONS(916),
    [anon_sym_LT_LT] = ACTIONS(914),
    [anon_sym_GT_GT] = ACTIONS(914),
    [anon_sym_PERCENT] = ACTIONS(914),
    [anon_sym_DASH_EQ] = ACTIONS(916),
    [anon_sym_STAR_EQ] = ACTIONS(916),
    [anon_sym_SLASH_EQ] = ACTIONS(916),
    [anon_sym_PERCENT_EQ] = ACTIONS(916),
    [anon_sym_AMP_EQ] = ACTIONS(916),
    [anon_sym_PIPE_EQ] = ACTIONS(916),
    [anon_sym_CARET_EQ] = ACTIONS(916),
    [anon_sym_LT_LT_EQ] = ACTIONS(916),
    [anon_sym_GT_GT_EQ] = ACTIONS(916),
    [anon_sym_QMARK] = ACTIONS(916),
    [sym__cairo_1_short_string] = ACTIONS(916),
    [anon_sym_true] = ACTIONS(914),
    [anon_sym_false] = ACTIONS(914),
    [sym_self] = ACTIONS(914),
  },
  [160] = {
    [sym_identifier] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(920),
    [anon_sym_EQ] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_RBRACE] = ACTIONS(920),
    [anon_sym_struct] = ACTIONS(918),
    [anon_sym_EQ_EQ] = ACTIONS(920),
    [anon_sym_let] = ACTIONS(918),
    [anon_sym_const] = ACTIONS(918),
    [anon_sym_if] = ACTIONS(918),
    [anon_sym_BANG_EQ] = ACTIONS(920),
    [anon_sym_PLUS_EQ] = ACTIONS(920),
    [anon_sym_return] = ACTIONS(918),
    [anon_sym_STAR] = ACTIONS(918),
    [anon_sym_AMP] = ACTIONS(918),
    [anon_sym_DASH] = ACTIONS(918),
    [anon_sym_PLUS] = ACTIONS(918),
    [anon_sym_SLASH] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(920),
    [anon_sym_DOT] = ACTIONS(920),
    [sym_number] = ACTIONS(920),
    [anon_sym_SEMI] = ACTIONS(920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(918),
    [anon_sym_extern] = ACTIONS(918),
    [anon_sym_type] = ACTIONS(918),
    [anon_sym_COLON_COLON] = ACTIONS(920),
    [anon_sym_fn] = ACTIONS(918),
    [anon_sym_POUND] = ACTIONS(920),
    [anon_sym_mod] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(918),
    [anon_sym_impl] = ACTIONS(918),
    [anon_sym_trait] = ACTIONS(918),
    [anon_sym_u8] = ACTIONS(918),
    [anon_sym_i8] = ACTIONS(918),
    [anon_sym_u16] = ACTIONS(918),
    [anon_sym_i16] = ACTIONS(918),
    [anon_sym_u32] = ACTIONS(918),
    [anon_sym_i32] = ACTIONS(918),
    [anon_sym_u64] = ACTIONS(918),
    [anon_sym_i64] = ACTIONS(918),
    [anon_sym_u128] = ACTIONS(918),
    [anon_sym_i128] = ACTIONS(918),
    [anon_sym_u256] = ACTIONS(918),
    [anon_sym_i256] = ACTIONS(918),
    [anon_sym_isize] = ACTIONS(918),
    [anon_sym_usize] = ACTIONS(918),
    [anon_sym_f32] = ACTIONS(918),
    [anon_sym_f64] = ACTIONS(918),
    [anon_sym_felt252] = ACTIONS(918),
    [anon_sym_bool] = ACTIONS(918),
    [anon_sym_str] = ACTIONS(918),
    [anon_sym_char] = ACTIONS(918),
    [anon_sym_GT] = ACTIONS(918),
    [anon_sym_match] = ACTIONS(918),
    [anon_sym_loop] = ACTIONS(918),
    [anon_sym_BANG] = ACTIONS(918),
    [anon_sym_TILDE] = ACTIONS(920),
    [anon_sym_AMP_AMP] = ACTIONS(920),
    [anon_sym_PIPE_PIPE] = ACTIONS(920),
    [anon_sym_PIPE] = ACTIONS(918),
    [anon_sym_CARET] = ACTIONS(918),
    [anon_sym_LT2] = ACTIONS(918),
    [anon_sym_LT_EQ] = ACTIONS(920),
    [anon_sym_GT_EQ] = ACTIONS(920),
    [anon_sym_LT_LT] = ACTIONS(918),
    [anon_sym_GT_GT] = ACTIONS(918),
    [anon_sym_PERCENT] = ACTIONS(918),
    [anon_sym_DASH_EQ] = ACTIONS(920),
    [anon_sym_STAR_EQ] = ACTIONS(920),
    [anon_sym_SLASH_EQ] = ACTIONS(920),
    [anon_sym_PERCENT_EQ] = ACTIONS(920),
    [anon_sym_AMP_EQ] = ACTIONS(920),
    [anon_sym_PIPE_EQ] = ACTIONS(920),
    [anon_sym_CARET_EQ] = ACTIONS(920),
    [anon_sym_LT_LT_EQ] = ACTIONS(920),
    [anon_sym_GT_GT_EQ] = ACTIONS(920),
    [anon_sym_QMARK] = ACTIONS(920),
    [sym__cairo_1_short_string] = ACTIONS(920),
    [anon_sym_true] = ACTIONS(918),
    [anon_sym_false] = ACTIONS(918),
    [sym_self] = ACTIONS(918),
  },
  [161] = {
    [sym_identifier] = ACTIONS(922),
    [anon_sym_LPAREN] = ACTIONS(924),
    [anon_sym_EQ] = ACTIONS(922),
    [anon_sym_AT] = ACTIONS(924),
    [anon_sym_LBRACE] = ACTIONS(924),
    [anon_sym_RBRACE] = ACTIONS(924),
    [anon_sym_struct] = ACTIONS(922),
    [anon_sym_EQ_EQ] = ACTIONS(924),
    [anon_sym_let] = ACTIONS(922),
    [anon_sym_const] = ACTIONS(922),
    [anon_sym_if] = ACTIONS(922),
    [anon_sym_BANG_EQ] = ACTIONS(924),
    [anon_sym_PLUS_EQ] = ACTIONS(924),
    [anon_sym_return] = ACTIONS(922),
    [anon_sym_STAR] = ACTIONS(922),
    [anon_sym_AMP] = ACTIONS(922),
    [anon_sym_DASH] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(922),
    [anon_sym_SLASH] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(924),
    [anon_sym_DOT] = ACTIONS(924),
    [sym_number] = ACTIONS(924),
    [anon_sym_SEMI] = ACTIONS(924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(922),
    [anon_sym_extern] = ACTIONS(922),
    [anon_sym_type] = ACTIONS(922),
    [anon_sym_COLON_COLON] = ACTIONS(924),
    [anon_sym_fn] = ACTIONS(922),
    [anon_sym_POUND] = ACTIONS(924),
    [anon_sym_mod] = ACTIONS(922),
    [anon_sym_enum] = ACTIONS(922),
    [anon_sym_impl] = ACTIONS(922),
    [anon_sym_trait] = ACTIONS(922),
    [anon_sym_u8] = ACTIONS(922),
    [anon_sym_i8] = ACTIONS(922),
    [anon_sym_u16] = ACTIONS(922),
    [anon_sym_i16] = ACTIONS(922),
    [anon_sym_u32] = ACTIONS(922),
    [anon_sym_i32] = ACTIONS(922),
    [anon_sym_u64] = ACTIONS(922),
    [anon_sym_i64] = ACTIONS(922),
    [anon_sym_u128] = ACTIONS(922),
    [anon_sym_i128] = ACTIONS(922),
    [anon_sym_u256] = ACTIONS(922),
    [anon_sym_i256] = ACTIONS(922),
    [anon_sym_isize] = ACTIONS(922),
    [anon_sym_usize] = ACTIONS(922),
    [anon_sym_f32] = ACTIONS(922),
    [anon_sym_f64] = ACTIONS(922),
    [anon_sym_felt252] = ACTIONS(922),
    [anon_sym_bool] = ACTIONS(922),
    [anon_sym_str] = ACTIONS(922),
    [anon_sym_char] = ACTIONS(922),
    [anon_sym_GT] = ACTIONS(922),
    [anon_sym_match] = ACTIONS(922),
    [anon_sym_loop] = ACTIONS(922),
    [anon_sym_BANG] = ACTIONS(922),
    [anon_sym_TILDE] = ACTIONS(924),
    [anon_sym_AMP_AMP] = ACTIONS(924),
    [anon_sym_PIPE_PIPE] = ACTIONS(924),
    [anon_sym_PIPE] = ACTIONS(922),
    [anon_sym_CARET] = ACTIONS(922),
    [anon_sym_LT2] = ACTIONS(922),
    [anon_sym_LT_EQ] = ACTIONS(924),
    [anon_sym_GT_EQ] = ACTIONS(924),
    [anon_sym_LT_LT] = ACTIONS(922),
    [anon_sym_GT_GT] = ACTIONS(922),
    [anon_sym_PERCENT] = ACTIONS(922),
    [anon_sym_DASH_EQ] = ACTIONS(924),
    [anon_sym_STAR_EQ] = ACTIONS(924),
    [anon_sym_SLASH_EQ] = ACTIONS(924),
    [anon_sym_PERCENT_EQ] = ACTIONS(924),
    [anon_sym_AMP_EQ] = ACTIONS(924),
    [anon_sym_PIPE_EQ] = ACTIONS(924),
    [anon_sym_CARET_EQ] = ACTIONS(924),
    [anon_sym_LT_LT_EQ] = ACTIONS(924),
    [anon_sym_GT_GT_EQ] = ACTIONS(924),
    [anon_sym_QMARK] = ACTIONS(924),
    [sym__cairo_1_short_string] = ACTIONS(924),
    [anon_sym_true] = ACTIONS(922),
    [anon_sym_false] = ACTIONS(922),
    [sym_self] = ACTIONS(922),
  },
  [162] = {
    [sym_identifier] = ACTIONS(926),
    [anon_sym_LPAREN] = ACTIONS(928),
    [anon_sym_EQ] = ACTIONS(926),
    [anon_sym_AT] = ACTIONS(928),
    [anon_sym_LBRACE] = ACTIONS(928),
    [anon_sym_RBRACE] = ACTIONS(928),
    [anon_sym_struct] = ACTIONS(926),
    [anon_sym_EQ_EQ] = ACTIONS(928),
    [anon_sym_let] = ACTIONS(926),
    [anon_sym_const] = ACTIONS(926),
    [anon_sym_if] = ACTIONS(926),
    [anon_sym_BANG_EQ] = ACTIONS(928),
    [anon_sym_PLUS_EQ] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(926),
    [anon_sym_STAR] = ACTIONS(926),
    [anon_sym_AMP] = ACTIONS(926),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_SLASH] = ACTIONS(926),
    [anon_sym_LBRACK] = ACTIONS(928),
    [anon_sym_DOT] = ACTIONS(928),
    [sym_number] = ACTIONS(928),
    [anon_sym_SEMI] = ACTIONS(928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(926),
    [anon_sym_extern] = ACTIONS(926),
    [anon_sym_type] = ACTIONS(926),
    [anon_sym_COLON_COLON] = ACTIONS(928),
    [anon_sym_fn] = ACTIONS(926),
    [anon_sym_POUND] = ACTIONS(928),
    [anon_sym_mod] = ACTIONS(926),
    [anon_sym_enum] = ACTIONS(926),
    [anon_sym_impl] = ACTIONS(926),
    [anon_sym_trait] = ACTIONS(926),
    [anon_sym_u8] = ACTIONS(926),
    [anon_sym_i8] = ACTIONS(926),
    [anon_sym_u16] = ACTIONS(926),
    [anon_sym_i16] = ACTIONS(926),
    [anon_sym_u32] = ACTIONS(926),
    [anon_sym_i32] = ACTIONS(926),
    [anon_sym_u64] = ACTIONS(926),
    [anon_sym_i64] = ACTIONS(926),
    [anon_sym_u128] = ACTIONS(926),
    [anon_sym_i128] = ACTIONS(926),
    [anon_sym_u256] = ACTIONS(926),
    [anon_sym_i256] = ACTIONS(926),
    [anon_sym_isize] = ACTIONS(926),
    [anon_sym_usize] = ACTIONS(926),
    [anon_sym_f32] = ACTIONS(926),
    [anon_sym_f64] = ACTIONS(926),
    [anon_sym_felt252] = ACTIONS(926),
    [anon_sym_bool] = ACTIONS(926),
    [anon_sym_str] = ACTIONS(926),
    [anon_sym_char] = ACTIONS(926),
    [anon_sym_GT] = ACTIONS(926),
    [anon_sym_match] = ACTIONS(926),
    [anon_sym_loop] = ACTIONS(926),
    [anon_sym_BANG] = ACTIONS(926),
    [anon_sym_TILDE] = ACTIONS(928),
    [anon_sym_AMP_AMP] = ACTIONS(928),
    [anon_sym_PIPE_PIPE] = ACTIONS(928),
    [anon_sym_PIPE] = ACTIONS(926),
    [anon_sym_CARET] = ACTIONS(926),
    [anon_sym_LT2] = ACTIONS(926),
    [anon_sym_LT_EQ] = ACTIONS(928),
    [anon_sym_GT_EQ] = ACTIONS(928),
    [anon_sym_LT_LT] = ACTIONS(926),
    [anon_sym_GT_GT] = ACTIONS(926),
    [anon_sym_PERCENT] = ACTIONS(926),
    [anon_sym_DASH_EQ] = ACTIONS(928),
    [anon_sym_STAR_EQ] = ACTIONS(928),
    [anon_sym_SLASH_EQ] = ACTIONS(928),
    [anon_sym_PERCENT_EQ] = ACTIONS(928),
    [anon_sym_AMP_EQ] = ACTIONS(928),
    [anon_sym_PIPE_EQ] = ACTIONS(928),
    [anon_sym_CARET_EQ] = ACTIONS(928),
    [anon_sym_LT_LT_EQ] = ACTIONS(928),
    [anon_sym_GT_GT_EQ] = ACTIONS(928),
    [anon_sym_QMARK] = ACTIONS(928),
    [sym__cairo_1_short_string] = ACTIONS(928),
    [anon_sym_true] = ACTIONS(926),
    [anon_sym_false] = ACTIONS(926),
    [sym_self] = ACTIONS(926),
  },
  [163] = {
    [sym_identifier] = ACTIONS(930),
    [anon_sym_LPAREN] = ACTIONS(932),
    [anon_sym_EQ] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_RBRACE] = ACTIONS(932),
    [anon_sym_struct] = ACTIONS(930),
    [anon_sym_EQ_EQ] = ACTIONS(932),
    [anon_sym_let] = ACTIONS(930),
    [anon_sym_const] = ACTIONS(930),
    [anon_sym_if] = ACTIONS(930),
    [anon_sym_BANG_EQ] = ACTIONS(932),
    [anon_sym_PLUS_EQ] = ACTIONS(932),
    [anon_sym_return] = ACTIONS(930),
    [anon_sym_STAR] = ACTIONS(930),
    [anon_sym_AMP] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_SLASH] = ACTIONS(930),
    [anon_sym_LBRACK] = ACTIONS(932),
    [anon_sym_DOT] = ACTIONS(932),
    [sym_number] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(932),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(930),
    [anon_sym_extern] = ACTIONS(930),
    [anon_sym_type] = ACTIONS(930),
    [anon_sym_COLON_COLON] = ACTIONS(932),
    [anon_sym_fn] = ACTIONS(930),
    [anon_sym_POUND] = ACTIONS(932),
    [anon_sym_mod] = ACTIONS(930),
    [anon_sym_enum] = ACTIONS(930),
    [anon_sym_impl] = ACTIONS(930),
    [anon_sym_trait] = ACTIONS(930),
    [anon_sym_u8] = ACTIONS(930),
    [anon_sym_i8] = ACTIONS(930),
    [anon_sym_u16] = ACTIONS(930),
    [anon_sym_i16] = ACTIONS(930),
    [anon_sym_u32] = ACTIONS(930),
    [anon_sym_i32] = ACTIONS(930),
    [anon_sym_u64] = ACTIONS(930),
    [anon_sym_i64] = ACTIONS(930),
    [anon_sym_u128] = ACTIONS(930),
    [anon_sym_i128] = ACTIONS(930),
    [anon_sym_u256] = ACTIONS(930),
    [anon_sym_i256] = ACTIONS(930),
    [anon_sym_isize] = ACTIONS(930),
    [anon_sym_usize] = ACTIONS(930),
    [anon_sym_f32] = ACTIONS(930),
    [anon_sym_f64] = ACTIONS(930),
    [anon_sym_felt252] = ACTIONS(930),
    [anon_sym_bool] = ACTIONS(930),
    [anon_sym_str] = ACTIONS(930),
    [anon_sym_char] = ACTIONS(930),
    [anon_sym_GT] = ACTIONS(930),
    [anon_sym_match] = ACTIONS(930),
    [anon_sym_loop] = ACTIONS(930),
    [anon_sym_BANG] = ACTIONS(930),
    [anon_sym_TILDE] = ACTIONS(932),
    [anon_sym_AMP_AMP] = ACTIONS(932),
    [anon_sym_PIPE_PIPE] = ACTIONS(932),
    [anon_sym_PIPE] = ACTIONS(930),
    [anon_sym_CARET] = ACTIONS(930),
    [anon_sym_LT2] = ACTIONS(930),
    [anon_sym_LT_EQ] = ACTIONS(932),
    [anon_sym_GT_EQ] = ACTIONS(932),
    [anon_sym_LT_LT] = ACTIONS(930),
    [anon_sym_GT_GT] = ACTIONS(930),
    [anon_sym_PERCENT] = ACTIONS(930),
    [anon_sym_DASH_EQ] = ACTIONS(932),
    [anon_sym_STAR_EQ] = ACTIONS(932),
    [anon_sym_SLASH_EQ] = ACTIONS(932),
    [anon_sym_PERCENT_EQ] = ACTIONS(932),
    [anon_sym_AMP_EQ] = ACTIONS(932),
    [anon_sym_PIPE_EQ] = ACTIONS(932),
    [anon_sym_CARET_EQ] = ACTIONS(932),
    [anon_sym_LT_LT_EQ] = ACTIONS(932),
    [anon_sym_GT_GT_EQ] = ACTIONS(932),
    [anon_sym_QMARK] = ACTIONS(932),
    [sym__cairo_1_short_string] = ACTIONS(932),
    [anon_sym_true] = ACTIONS(930),
    [anon_sym_false] = ACTIONS(930),
    [sym_self] = ACTIONS(930),
  },
  [164] = {
    [sym_identifier] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(936),
    [anon_sym_EQ] = ACTIONS(934),
    [anon_sym_AT] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(936),
    [anon_sym_RBRACE] = ACTIONS(936),
    [anon_sym_struct] = ACTIONS(934),
    [anon_sym_EQ_EQ] = ACTIONS(936),
    [anon_sym_let] = ACTIONS(934),
    [anon_sym_const] = ACTIONS(934),
    [anon_sym_if] = ACTIONS(934),
    [anon_sym_BANG_EQ] = ACTIONS(936),
    [anon_sym_PLUS_EQ] = ACTIONS(936),
    [anon_sym_return] = ACTIONS(934),
    [anon_sym_STAR] = ACTIONS(934),
    [anon_sym_AMP] = ACTIONS(934),
    [anon_sym_DASH] = ACTIONS(934),
    [anon_sym_PLUS] = ACTIONS(934),
    [anon_sym_SLASH] = ACTIONS(934),
    [anon_sym_LBRACK] = ACTIONS(936),
    [anon_sym_DOT] = ACTIONS(936),
    [sym_number] = ACTIONS(936),
    [anon_sym_SEMI] = ACTIONS(936),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(934),
    [anon_sym_extern] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_COLON_COLON] = ACTIONS(936),
    [anon_sym_fn] = ACTIONS(934),
    [anon_sym_POUND] = ACTIONS(936),
    [anon_sym_mod] = ACTIONS(934),
    [anon_sym_enum] = ACTIONS(934),
    [anon_sym_impl] = ACTIONS(934),
    [anon_sym_trait] = ACTIONS(934),
    [anon_sym_u8] = ACTIONS(934),
    [anon_sym_i8] = ACTIONS(934),
    [anon_sym_u16] = ACTIONS(934),
    [anon_sym_i16] = ACTIONS(934),
    [anon_sym_u32] = ACTIONS(934),
    [anon_sym_i32] = ACTIONS(934),
    [anon_sym_u64] = ACTIONS(934),
    [anon_sym_i64] = ACTIONS(934),
    [anon_sym_u128] = ACTIONS(934),
    [anon_sym_i128] = ACTIONS(934),
    [anon_sym_u256] = ACTIONS(934),
    [anon_sym_i256] = ACTIONS(934),
    [anon_sym_isize] = ACTIONS(934),
    [anon_sym_usize] = ACTIONS(934),
    [anon_sym_f32] = ACTIONS(934),
    [anon_sym_f64] = ACTIONS(934),
    [anon_sym_felt252] = ACTIONS(934),
    [anon_sym_bool] = ACTIONS(934),
    [anon_sym_str] = ACTIONS(934),
    [anon_sym_char] = ACTIONS(934),
    [anon_sym_GT] = ACTIONS(934),
    [anon_sym_match] = ACTIONS(934),
    [anon_sym_loop] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(934),
    [anon_sym_TILDE] = ACTIONS(936),
    [anon_sym_AMP_AMP] = ACTIONS(936),
    [anon_sym_PIPE_PIPE] = ACTIONS(936),
    [anon_sym_PIPE] = ACTIONS(934),
    [anon_sym_CARET] = ACTIONS(934),
    [anon_sym_LT2] = ACTIONS(934),
    [anon_sym_LT_EQ] = ACTIONS(936),
    [anon_sym_GT_EQ] = ACTIONS(936),
    [anon_sym_LT_LT] = ACTIONS(934),
    [anon_sym_GT_GT] = ACTIONS(934),
    [anon_sym_PERCENT] = ACTIONS(934),
    [anon_sym_DASH_EQ] = ACTIONS(936),
    [anon_sym_STAR_EQ] = ACTIONS(936),
    [anon_sym_SLASH_EQ] = ACTIONS(936),
    [anon_sym_PERCENT_EQ] = ACTIONS(936),
    [anon_sym_AMP_EQ] = ACTIONS(936),
    [anon_sym_PIPE_EQ] = ACTIONS(936),
    [anon_sym_CARET_EQ] = ACTIONS(936),
    [anon_sym_LT_LT_EQ] = ACTIONS(936),
    [anon_sym_GT_GT_EQ] = ACTIONS(936),
    [anon_sym_QMARK] = ACTIONS(936),
    [sym__cairo_1_short_string] = ACTIONS(936),
    [anon_sym_true] = ACTIONS(934),
    [anon_sym_false] = ACTIONS(934),
    [sym_self] = ACTIONS(934),
  },
  [165] = {
    [sym_identifier] = ACTIONS(938),
    [anon_sym_LPAREN] = ACTIONS(940),
    [anon_sym_EQ] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(940),
    [anon_sym_LBRACE] = ACTIONS(940),
    [anon_sym_RBRACE] = ACTIONS(940),
    [anon_sym_struct] = ACTIONS(938),
    [anon_sym_EQ_EQ] = ACTIONS(940),
    [anon_sym_let] = ACTIONS(938),
    [anon_sym_const] = ACTIONS(938),
    [anon_sym_if] = ACTIONS(938),
    [anon_sym_BANG_EQ] = ACTIONS(940),
    [anon_sym_PLUS_EQ] = ACTIONS(940),
    [anon_sym_return] = ACTIONS(938),
    [anon_sym_STAR] = ACTIONS(938),
    [anon_sym_AMP] = ACTIONS(938),
    [anon_sym_DASH] = ACTIONS(938),
    [anon_sym_PLUS] = ACTIONS(938),
    [anon_sym_SLASH] = ACTIONS(938),
    [anon_sym_LBRACK] = ACTIONS(940),
    [anon_sym_DOT] = ACTIONS(940),
    [sym_number] = ACTIONS(940),
    [anon_sym_SEMI] = ACTIONS(940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(938),
    [anon_sym_extern] = ACTIONS(938),
    [anon_sym_type] = ACTIONS(938),
    [anon_sym_COLON_COLON] = ACTIONS(940),
    [anon_sym_fn] = ACTIONS(938),
    [anon_sym_POUND] = ACTIONS(940),
    [anon_sym_mod] = ACTIONS(938),
    [anon_sym_enum] = ACTIONS(938),
    [anon_sym_impl] = ACTIONS(938),
    [anon_sym_trait] = ACTIONS(938),
    [anon_sym_u8] = ACTIONS(938),
    [anon_sym_i8] = ACTIONS(938),
    [anon_sym_u16] = ACTIONS(938),
    [anon_sym_i16] = ACTIONS(938),
    [anon_sym_u32] = ACTIONS(938),
    [anon_sym_i32] = ACTIONS(938),
    [anon_sym_u64] = ACTIONS(938),
    [anon_sym_i64] = ACTIONS(938),
    [anon_sym_u128] = ACTIONS(938),
    [anon_sym_i128] = ACTIONS(938),
    [anon_sym_u256] = ACTIONS(938),
    [anon_sym_i256] = ACTIONS(938),
    [anon_sym_isize] = ACTIONS(938),
    [anon_sym_usize] = ACTIONS(938),
    [anon_sym_f32] = ACTIONS(938),
    [anon_sym_f64] = ACTIONS(938),
    [anon_sym_felt252] = ACTIONS(938),
    [anon_sym_bool] = ACTIONS(938),
    [anon_sym_str] = ACTIONS(938),
    [anon_sym_char] = ACTIONS(938),
    [anon_sym_GT] = ACTIONS(938),
    [anon_sym_match] = ACTIONS(938),
    [anon_sym_loop] = ACTIONS(938),
    [anon_sym_BANG] = ACTIONS(938),
    [anon_sym_TILDE] = ACTIONS(940),
    [anon_sym_AMP_AMP] = ACTIONS(940),
    [anon_sym_PIPE_PIPE] = ACTIONS(940),
    [anon_sym_PIPE] = ACTIONS(938),
    [anon_sym_CARET] = ACTIONS(938),
    [anon_sym_LT2] = ACTIONS(938),
    [anon_sym_LT_EQ] = ACTIONS(940),
    [anon_sym_GT_EQ] = ACTIONS(940),
    [anon_sym_LT_LT] = ACTIONS(938),
    [anon_sym_GT_GT] = ACTIONS(938),
    [anon_sym_PERCENT] = ACTIONS(938),
    [anon_sym_DASH_EQ] = ACTIONS(940),
    [anon_sym_STAR_EQ] = ACTIONS(940),
    [anon_sym_SLASH_EQ] = ACTIONS(940),
    [anon_sym_PERCENT_EQ] = ACTIONS(940),
    [anon_sym_AMP_EQ] = ACTIONS(940),
    [anon_sym_PIPE_EQ] = ACTIONS(940),
    [anon_sym_CARET_EQ] = ACTIONS(940),
    [anon_sym_LT_LT_EQ] = ACTIONS(940),
    [anon_sym_GT_GT_EQ] = ACTIONS(940),
    [anon_sym_QMARK] = ACTIONS(940),
    [sym__cairo_1_short_string] = ACTIONS(940),
    [anon_sym_true] = ACTIONS(938),
    [anon_sym_false] = ACTIONS(938),
    [sym_self] = ACTIONS(938),
  },
  [166] = {
    [sym_identifier] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(944),
    [anon_sym_EQ] = ACTIONS(942),
    [anon_sym_AT] = ACTIONS(944),
    [anon_sym_LBRACE] = ACTIONS(944),
    [anon_sym_RBRACE] = ACTIONS(944),
    [anon_sym_struct] = ACTIONS(942),
    [anon_sym_EQ_EQ] = ACTIONS(944),
    [anon_sym_let] = ACTIONS(942),
    [anon_sym_const] = ACTIONS(942),
    [anon_sym_if] = ACTIONS(942),
    [anon_sym_BANG_EQ] = ACTIONS(944),
    [anon_sym_PLUS_EQ] = ACTIONS(944),
    [anon_sym_return] = ACTIONS(942),
    [anon_sym_STAR] = ACTIONS(942),
    [anon_sym_AMP] = ACTIONS(942),
    [anon_sym_DASH] = ACTIONS(942),
    [anon_sym_PLUS] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(942),
    [anon_sym_LBRACK] = ACTIONS(944),
    [anon_sym_DOT] = ACTIONS(944),
    [sym_number] = ACTIONS(944),
    [anon_sym_SEMI] = ACTIONS(944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(942),
    [anon_sym_extern] = ACTIONS(942),
    [anon_sym_type] = ACTIONS(942),
    [anon_sym_COLON_COLON] = ACTIONS(944),
    [anon_sym_fn] = ACTIONS(942),
    [anon_sym_POUND] = ACTIONS(944),
    [anon_sym_mod] = ACTIONS(942),
    [anon_sym_enum] = ACTIONS(942),
    [anon_sym_impl] = ACTIONS(942),
    [anon_sym_trait] = ACTIONS(942),
    [anon_sym_u8] = ACTIONS(942),
    [anon_sym_i8] = ACTIONS(942),
    [anon_sym_u16] = ACTIONS(942),
    [anon_sym_i16] = ACTIONS(942),
    [anon_sym_u32] = ACTIONS(942),
    [anon_sym_i32] = ACTIONS(942),
    [anon_sym_u64] = ACTIONS(942),
    [anon_sym_i64] = ACTIONS(942),
    [anon_sym_u128] = ACTIONS(942),
    [anon_sym_i128] = ACTIONS(942),
    [anon_sym_u256] = ACTIONS(942),
    [anon_sym_i256] = ACTIONS(942),
    [anon_sym_isize] = ACTIONS(942),
    [anon_sym_usize] = ACTIONS(942),
    [anon_sym_f32] = ACTIONS(942),
    [anon_sym_f64] = ACTIONS(942),
    [anon_sym_felt252] = ACTIONS(942),
    [anon_sym_bool] = ACTIONS(942),
    [anon_sym_str] = ACTIONS(942),
    [anon_sym_char] = ACTIONS(942),
    [anon_sym_GT] = ACTIONS(942),
    [anon_sym_match] = ACTIONS(942),
    [anon_sym_loop] = ACTIONS(942),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_TILDE] = ACTIONS(944),
    [anon_sym_AMP_AMP] = ACTIONS(944),
    [anon_sym_PIPE_PIPE] = ACTIONS(944),
    [anon_sym_PIPE] = ACTIONS(942),
    [anon_sym_CARET] = ACTIONS(942),
    [anon_sym_LT2] = ACTIONS(942),
    [anon_sym_LT_EQ] = ACTIONS(944),
    [anon_sym_GT_EQ] = ACTIONS(944),
    [anon_sym_LT_LT] = ACTIONS(942),
    [anon_sym_GT_GT] = ACTIONS(942),
    [anon_sym_PERCENT] = ACTIONS(942),
    [anon_sym_DASH_EQ] = ACTIONS(944),
    [anon_sym_STAR_EQ] = ACTIONS(944),
    [anon_sym_SLASH_EQ] = ACTIONS(944),
    [anon_sym_PERCENT_EQ] = ACTIONS(944),
    [anon_sym_AMP_EQ] = ACTIONS(944),
    [anon_sym_PIPE_EQ] = ACTIONS(944),
    [anon_sym_CARET_EQ] = ACTIONS(944),
    [anon_sym_LT_LT_EQ] = ACTIONS(944),
    [anon_sym_GT_GT_EQ] = ACTIONS(944),
    [anon_sym_QMARK] = ACTIONS(944),
    [sym__cairo_1_short_string] = ACTIONS(944),
    [anon_sym_true] = ACTIONS(942),
    [anon_sym_false] = ACTIONS(942),
    [sym_self] = ACTIONS(942),
  },
  [167] = {
    [sym_identifier] = ACTIONS(946),
    [anon_sym_LPAREN] = ACTIONS(948),
    [anon_sym_EQ] = ACTIONS(946),
    [anon_sym_AT] = ACTIONS(948),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_RBRACE] = ACTIONS(948),
    [anon_sym_struct] = ACTIONS(946),
    [anon_sym_EQ_EQ] = ACTIONS(948),
    [anon_sym_let] = ACTIONS(946),
    [anon_sym_const] = ACTIONS(946),
    [anon_sym_if] = ACTIONS(946),
    [anon_sym_BANG_EQ] = ACTIONS(948),
    [anon_sym_PLUS_EQ] = ACTIONS(948),
    [anon_sym_return] = ACTIONS(946),
    [anon_sym_STAR] = ACTIONS(946),
    [anon_sym_AMP] = ACTIONS(946),
    [anon_sym_DASH] = ACTIONS(946),
    [anon_sym_PLUS] = ACTIONS(946),
    [anon_sym_SLASH] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(948),
    [anon_sym_DOT] = ACTIONS(948),
    [sym_number] = ACTIONS(948),
    [anon_sym_SEMI] = ACTIONS(948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(946),
    [anon_sym_extern] = ACTIONS(946),
    [anon_sym_type] = ACTIONS(946),
    [anon_sym_COLON_COLON] = ACTIONS(948),
    [anon_sym_fn] = ACTIONS(946),
    [anon_sym_POUND] = ACTIONS(948),
    [anon_sym_mod] = ACTIONS(946),
    [anon_sym_enum] = ACTIONS(946),
    [anon_sym_impl] = ACTIONS(946),
    [anon_sym_trait] = ACTIONS(946),
    [anon_sym_u8] = ACTIONS(946),
    [anon_sym_i8] = ACTIONS(946),
    [anon_sym_u16] = ACTIONS(946),
    [anon_sym_i16] = ACTIONS(946),
    [anon_sym_u32] = ACTIONS(946),
    [anon_sym_i32] = ACTIONS(946),
    [anon_sym_u64] = ACTIONS(946),
    [anon_sym_i64] = ACTIONS(946),
    [anon_sym_u128] = ACTIONS(946),
    [anon_sym_i128] = ACTIONS(946),
    [anon_sym_u256] = ACTIONS(946),
    [anon_sym_i256] = ACTIONS(946),
    [anon_sym_isize] = ACTIONS(946),
    [anon_sym_usize] = ACTIONS(946),
    [anon_sym_f32] = ACTIONS(946),
    [anon_sym_f64] = ACTIONS(946),
    [anon_sym_felt252] = ACTIONS(946),
    [anon_sym_bool] = ACTIONS(946),
    [anon_sym_str] = ACTIONS(946),
    [anon_sym_char] = ACTIONS(946),
    [anon_sym_GT] = ACTIONS(946),
    [anon_sym_match] = ACTIONS(946),
    [anon_sym_loop] = ACTIONS(946),
    [anon_sym_BANG] = ACTIONS(946),
    [anon_sym_TILDE] = ACTIONS(948),
    [anon_sym_AMP_AMP] = ACTIONS(948),
    [anon_sym_PIPE_PIPE] = ACTIONS(948),
    [anon_sym_PIPE] = ACTIONS(946),
    [anon_sym_CARET] = ACTIONS(946),
    [anon_sym_LT2] = ACTIONS(946),
    [anon_sym_LT_EQ] = ACTIONS(948),
    [anon_sym_GT_EQ] = ACTIONS(948),
    [anon_sym_LT_LT] = ACTIONS(946),
    [anon_sym_GT_GT] = ACTIONS(946),
    [anon_sym_PERCENT] = ACTIONS(946),
    [anon_sym_DASH_EQ] = ACTIONS(948),
    [anon_sym_STAR_EQ] = ACTIONS(948),
    [anon_sym_SLASH_EQ] = ACTIONS(948),
    [anon_sym_PERCENT_EQ] = ACTIONS(948),
    [anon_sym_AMP_EQ] = ACTIONS(948),
    [anon_sym_PIPE_EQ] = ACTIONS(948),
    [anon_sym_CARET_EQ] = ACTIONS(948),
    [anon_sym_LT_LT_EQ] = ACTIONS(948),
    [anon_sym_GT_GT_EQ] = ACTIONS(948),
    [anon_sym_QMARK] = ACTIONS(948),
    [sym__cairo_1_short_string] = ACTIONS(948),
    [anon_sym_true] = ACTIONS(946),
    [anon_sym_false] = ACTIONS(946),
    [sym_self] = ACTIONS(946),
  },
  [168] = {
    [sym_identifier] = ACTIONS(950),
    [anon_sym_LPAREN] = ACTIONS(952),
    [anon_sym_EQ] = ACTIONS(950),
    [anon_sym_AT] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(952),
    [anon_sym_RBRACE] = ACTIONS(952),
    [anon_sym_struct] = ACTIONS(950),
    [anon_sym_EQ_EQ] = ACTIONS(952),
    [anon_sym_let] = ACTIONS(950),
    [anon_sym_const] = ACTIONS(950),
    [anon_sym_if] = ACTIONS(950),
    [anon_sym_BANG_EQ] = ACTIONS(952),
    [anon_sym_PLUS_EQ] = ACTIONS(952),
    [anon_sym_return] = ACTIONS(950),
    [anon_sym_STAR] = ACTIONS(950),
    [anon_sym_AMP] = ACTIONS(950),
    [anon_sym_DASH] = ACTIONS(950),
    [anon_sym_PLUS] = ACTIONS(950),
    [anon_sym_SLASH] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_DOT] = ACTIONS(952),
    [sym_number] = ACTIONS(952),
    [anon_sym_SEMI] = ACTIONS(952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(950),
    [anon_sym_extern] = ACTIONS(950),
    [anon_sym_type] = ACTIONS(950),
    [anon_sym_COLON_COLON] = ACTIONS(952),
    [anon_sym_fn] = ACTIONS(950),
    [anon_sym_POUND] = ACTIONS(952),
    [anon_sym_mod] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(950),
    [anon_sym_impl] = ACTIONS(950),
    [anon_sym_trait] = ACTIONS(950),
    [anon_sym_u8] = ACTIONS(950),
    [anon_sym_i8] = ACTIONS(950),
    [anon_sym_u16] = ACTIONS(950),
    [anon_sym_i16] = ACTIONS(950),
    [anon_sym_u32] = ACTIONS(950),
    [anon_sym_i32] = ACTIONS(950),
    [anon_sym_u64] = ACTIONS(950),
    [anon_sym_i64] = ACTIONS(950),
    [anon_sym_u128] = ACTIONS(950),
    [anon_sym_i128] = ACTIONS(950),
    [anon_sym_u256] = ACTIONS(950),
    [anon_sym_i256] = ACTIONS(950),
    [anon_sym_isize] = ACTIONS(950),
    [anon_sym_usize] = ACTIONS(950),
    [anon_sym_f32] = ACTIONS(950),
    [anon_sym_f64] = ACTIONS(950),
    [anon_sym_felt252] = ACTIONS(950),
    [anon_sym_bool] = ACTIONS(950),
    [anon_sym_str] = ACTIONS(950),
    [anon_sym_char] = ACTIONS(950),
    [anon_sym_GT] = ACTIONS(950),
    [anon_sym_match] = ACTIONS(950),
    [anon_sym_loop] = ACTIONS(950),
    [anon_sym_BANG] = ACTIONS(950),
    [anon_sym_TILDE] = ACTIONS(952),
    [anon_sym_AMP_AMP] = ACTIONS(952),
    [anon_sym_PIPE_PIPE] = ACTIONS(952),
    [anon_sym_PIPE] = ACTIONS(950),
    [anon_sym_CARET] = ACTIONS(950),
    [anon_sym_LT2] = ACTIONS(950),
    [anon_sym_LT_EQ] = ACTIONS(952),
    [anon_sym_GT_EQ] = ACTIONS(952),
    [anon_sym_LT_LT] = ACTIONS(950),
    [anon_sym_GT_GT] = ACTIONS(950),
    [anon_sym_PERCENT] = ACTIONS(950),
    [anon_sym_DASH_EQ] = ACTIONS(952),
    [anon_sym_STAR_EQ] = ACTIONS(952),
    [anon_sym_SLASH_EQ] = ACTIONS(952),
    [anon_sym_PERCENT_EQ] = ACTIONS(952),
    [anon_sym_AMP_EQ] = ACTIONS(952),
    [anon_sym_PIPE_EQ] = ACTIONS(952),
    [anon_sym_CARET_EQ] = ACTIONS(952),
    [anon_sym_LT_LT_EQ] = ACTIONS(952),
    [anon_sym_GT_GT_EQ] = ACTIONS(952),
    [anon_sym_QMARK] = ACTIONS(952),
    [sym__cairo_1_short_string] = ACTIONS(952),
    [anon_sym_true] = ACTIONS(950),
    [anon_sym_false] = ACTIONS(950),
    [sym_self] = ACTIONS(950),
  },
  [169] = {
    [sym_identifier] = ACTIONS(954),
    [anon_sym_LPAREN] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(954),
    [anon_sym_AT] = ACTIONS(956),
    [anon_sym_LBRACE] = ACTIONS(956),
    [anon_sym_RBRACE] = ACTIONS(956),
    [anon_sym_struct] = ACTIONS(954),
    [anon_sym_EQ_EQ] = ACTIONS(956),
    [anon_sym_let] = ACTIONS(954),
    [anon_sym_const] = ACTIONS(954),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_BANG_EQ] = ACTIONS(956),
    [anon_sym_PLUS_EQ] = ACTIONS(956),
    [anon_sym_return] = ACTIONS(954),
    [anon_sym_STAR] = ACTIONS(954),
    [anon_sym_AMP] = ACTIONS(954),
    [anon_sym_DASH] = ACTIONS(954),
    [anon_sym_PLUS] = ACTIONS(954),
    [anon_sym_SLASH] = ACTIONS(954),
    [anon_sym_LBRACK] = ACTIONS(956),
    [anon_sym_DOT] = ACTIONS(956),
    [sym_number] = ACTIONS(956),
    [anon_sym_SEMI] = ACTIONS(956),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(954),
    [anon_sym_extern] = ACTIONS(954),
    [anon_sym_type] = ACTIONS(954),
    [anon_sym_COLON_COLON] = ACTIONS(956),
    [anon_sym_fn] = ACTIONS(954),
    [anon_sym_POUND] = ACTIONS(956),
    [anon_sym_mod] = ACTIONS(954),
    [anon_sym_enum] = ACTIONS(954),
    [anon_sym_impl] = ACTIONS(954),
    [anon_sym_trait] = ACTIONS(954),
    [anon_sym_u8] = ACTIONS(954),
    [anon_sym_i8] = ACTIONS(954),
    [anon_sym_u16] = ACTIONS(954),
    [anon_sym_i16] = ACTIONS(954),
    [anon_sym_u32] = ACTIONS(954),
    [anon_sym_i32] = ACTIONS(954),
    [anon_sym_u64] = ACTIONS(954),
    [anon_sym_i64] = ACTIONS(954),
    [anon_sym_u128] = ACTIONS(954),
    [anon_sym_i128] = ACTIONS(954),
    [anon_sym_u256] = ACTIONS(954),
    [anon_sym_i256] = ACTIONS(954),
    [anon_sym_isize] = ACTIONS(954),
    [anon_sym_usize] = ACTIONS(954),
    [anon_sym_f32] = ACTIONS(954),
    [anon_sym_f64] = ACTIONS(954),
    [anon_sym_felt252] = ACTIONS(954),
    [anon_sym_bool] = ACTIONS(954),
    [anon_sym_str] = ACTIONS(954),
    [anon_sym_char] = ACTIONS(954),
    [anon_sym_GT] = ACTIONS(954),
    [anon_sym_match] = ACTIONS(954),
    [anon_sym_loop] = ACTIONS(954),
    [anon_sym_BANG] = ACTIONS(954),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_AMP_AMP] = ACTIONS(956),
    [anon_sym_PIPE_PIPE] = ACTIONS(956),
    [anon_sym_PIPE] = ACTIONS(954),
    [anon_sym_CARET] = ACTIONS(954),
    [anon_sym_LT2] = ACTIONS(954),
    [anon_sym_LT_EQ] = ACTIONS(956),
    [anon_sym_GT_EQ] = ACTIONS(956),
    [anon_sym_LT_LT] = ACTIONS(954),
    [anon_sym_GT_GT] = ACTIONS(954),
    [anon_sym_PERCENT] = ACTIONS(954),
    [anon_sym_DASH_EQ] = ACTIONS(956),
    [anon_sym_STAR_EQ] = ACTIONS(956),
    [anon_sym_SLASH_EQ] = ACTIONS(956),
    [anon_sym_PERCENT_EQ] = ACTIONS(956),
    [anon_sym_AMP_EQ] = ACTIONS(956),
    [anon_sym_PIPE_EQ] = ACTIONS(956),
    [anon_sym_CARET_EQ] = ACTIONS(956),
    [anon_sym_LT_LT_EQ] = ACTIONS(956),
    [anon_sym_GT_GT_EQ] = ACTIONS(956),
    [anon_sym_QMARK] = ACTIONS(956),
    [sym__cairo_1_short_string] = ACTIONS(956),
    [anon_sym_true] = ACTIONS(954),
    [anon_sym_false] = ACTIONS(954),
    [sym_self] = ACTIONS(954),
  },
  [170] = {
    [sym_identifier] = ACTIONS(958),
    [anon_sym_LPAREN] = ACTIONS(960),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_AT] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(960),
    [anon_sym_RBRACE] = ACTIONS(960),
    [anon_sym_struct] = ACTIONS(958),
    [anon_sym_EQ_EQ] = ACTIONS(960),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_const] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(958),
    [anon_sym_BANG_EQ] = ACTIONS(960),
    [anon_sym_PLUS_EQ] = ACTIONS(960),
    [anon_sym_return] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(958),
    [anon_sym_AMP] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_SLASH] = ACTIONS(958),
    [anon_sym_LBRACK] = ACTIONS(960),
    [anon_sym_DOT] = ACTIONS(960),
    [sym_number] = ACTIONS(960),
    [anon_sym_SEMI] = ACTIONS(960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(958),
    [anon_sym_extern] = ACTIONS(958),
    [anon_sym_type] = ACTIONS(958),
    [anon_sym_COLON_COLON] = ACTIONS(960),
    [anon_sym_fn] = ACTIONS(958),
    [anon_sym_POUND] = ACTIONS(960),
    [anon_sym_mod] = ACTIONS(958),
    [anon_sym_enum] = ACTIONS(958),
    [anon_sym_impl] = ACTIONS(958),
    [anon_sym_trait] = ACTIONS(958),
    [anon_sym_u8] = ACTIONS(958),
    [anon_sym_i8] = ACTIONS(958),
    [anon_sym_u16] = ACTIONS(958),
    [anon_sym_i16] = ACTIONS(958),
    [anon_sym_u32] = ACTIONS(958),
    [anon_sym_i32] = ACTIONS(958),
    [anon_sym_u64] = ACTIONS(958),
    [anon_sym_i64] = ACTIONS(958),
    [anon_sym_u128] = ACTIONS(958),
    [anon_sym_i128] = ACTIONS(958),
    [anon_sym_u256] = ACTIONS(958),
    [anon_sym_i256] = ACTIONS(958),
    [anon_sym_isize] = ACTIONS(958),
    [anon_sym_usize] = ACTIONS(958),
    [anon_sym_f32] = ACTIONS(958),
    [anon_sym_f64] = ACTIONS(958),
    [anon_sym_felt252] = ACTIONS(958),
    [anon_sym_bool] = ACTIONS(958),
    [anon_sym_str] = ACTIONS(958),
    [anon_sym_char] = ACTIONS(958),
    [anon_sym_GT] = ACTIONS(958),
    [anon_sym_match] = ACTIONS(958),
    [anon_sym_loop] = ACTIONS(958),
    [anon_sym_BANG] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(960),
    [anon_sym_AMP_AMP] = ACTIONS(960),
    [anon_sym_PIPE_PIPE] = ACTIONS(960),
    [anon_sym_PIPE] = ACTIONS(958),
    [anon_sym_CARET] = ACTIONS(958),
    [anon_sym_LT2] = ACTIONS(958),
    [anon_sym_LT_EQ] = ACTIONS(960),
    [anon_sym_GT_EQ] = ACTIONS(960),
    [anon_sym_LT_LT] = ACTIONS(958),
    [anon_sym_GT_GT] = ACTIONS(958),
    [anon_sym_PERCENT] = ACTIONS(958),
    [anon_sym_DASH_EQ] = ACTIONS(960),
    [anon_sym_STAR_EQ] = ACTIONS(960),
    [anon_sym_SLASH_EQ] = ACTIONS(960),
    [anon_sym_PERCENT_EQ] = ACTIONS(960),
    [anon_sym_AMP_EQ] = ACTIONS(960),
    [anon_sym_PIPE_EQ] = ACTIONS(960),
    [anon_sym_CARET_EQ] = ACTIONS(960),
    [anon_sym_LT_LT_EQ] = ACTIONS(960),
    [anon_sym_GT_GT_EQ] = ACTIONS(960),
    [anon_sym_QMARK] = ACTIONS(960),
    [sym__cairo_1_short_string] = ACTIONS(960),
    [anon_sym_true] = ACTIONS(958),
    [anon_sym_false] = ACTIONS(958),
    [sym_self] = ACTIONS(958),
  },
  [171] = {
    [sym_identifier] = ACTIONS(962),
    [anon_sym_LPAREN] = ACTIONS(964),
    [anon_sym_EQ] = ACTIONS(962),
    [anon_sym_AT] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(964),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_struct] = ACTIONS(962),
    [anon_sym_EQ_EQ] = ACTIONS(964),
    [anon_sym_let] = ACTIONS(962),
    [anon_sym_const] = ACTIONS(962),
    [anon_sym_if] = ACTIONS(962),
    [anon_sym_BANG_EQ] = ACTIONS(964),
    [anon_sym_PLUS_EQ] = ACTIONS(964),
    [anon_sym_return] = ACTIONS(962),
    [anon_sym_STAR] = ACTIONS(962),
    [anon_sym_AMP] = ACTIONS(962),
    [anon_sym_DASH] = ACTIONS(962),
    [anon_sym_PLUS] = ACTIONS(962),
    [anon_sym_SLASH] = ACTIONS(962),
    [anon_sym_LBRACK] = ACTIONS(964),
    [anon_sym_DOT] = ACTIONS(964),
    [sym_number] = ACTIONS(964),
    [anon_sym_SEMI] = ACTIONS(964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(962),
    [anon_sym_extern] = ACTIONS(962),
    [anon_sym_type] = ACTIONS(962),
    [anon_sym_COLON_COLON] = ACTIONS(964),
    [anon_sym_fn] = ACTIONS(962),
    [anon_sym_POUND] = ACTIONS(964),
    [anon_sym_mod] = ACTIONS(962),
    [anon_sym_enum] = ACTIONS(962),
    [anon_sym_impl] = ACTIONS(962),
    [anon_sym_trait] = ACTIONS(962),
    [anon_sym_u8] = ACTIONS(962),
    [anon_sym_i8] = ACTIONS(962),
    [anon_sym_u16] = ACTIONS(962),
    [anon_sym_i16] = ACTIONS(962),
    [anon_sym_u32] = ACTIONS(962),
    [anon_sym_i32] = ACTIONS(962),
    [anon_sym_u64] = ACTIONS(962),
    [anon_sym_i64] = ACTIONS(962),
    [anon_sym_u128] = ACTIONS(962),
    [anon_sym_i128] = ACTIONS(962),
    [anon_sym_u256] = ACTIONS(962),
    [anon_sym_i256] = ACTIONS(962),
    [anon_sym_isize] = ACTIONS(962),
    [anon_sym_usize] = ACTIONS(962),
    [anon_sym_f32] = ACTIONS(962),
    [anon_sym_f64] = ACTIONS(962),
    [anon_sym_felt252] = ACTIONS(962),
    [anon_sym_bool] = ACTIONS(962),
    [anon_sym_str] = ACTIONS(962),
    [anon_sym_char] = ACTIONS(962),
    [anon_sym_GT] = ACTIONS(962),
    [anon_sym_match] = ACTIONS(962),
    [anon_sym_loop] = ACTIONS(962),
    [anon_sym_BANG] = ACTIONS(962),
    [anon_sym_TILDE] = ACTIONS(964),
    [anon_sym_AMP_AMP] = ACTIONS(964),
    [anon_sym_PIPE_PIPE] = ACTIONS(964),
    [anon_sym_PIPE] = ACTIONS(962),
    [anon_sym_CARET] = ACTIONS(962),
    [anon_sym_LT2] = ACTIONS(962),
    [anon_sym_LT_EQ] = ACTIONS(964),
    [anon_sym_GT_EQ] = ACTIONS(964),
    [anon_sym_LT_LT] = ACTIONS(962),
    [anon_sym_GT_GT] = ACTIONS(962),
    [anon_sym_PERCENT] = ACTIONS(962),
    [anon_sym_DASH_EQ] = ACTIONS(964),
    [anon_sym_STAR_EQ] = ACTIONS(964),
    [anon_sym_SLASH_EQ] = ACTIONS(964),
    [anon_sym_PERCENT_EQ] = ACTIONS(964),
    [anon_sym_AMP_EQ] = ACTIONS(964),
    [anon_sym_PIPE_EQ] = ACTIONS(964),
    [anon_sym_CARET_EQ] = ACTIONS(964),
    [anon_sym_LT_LT_EQ] = ACTIONS(964),
    [anon_sym_GT_GT_EQ] = ACTIONS(964),
    [anon_sym_QMARK] = ACTIONS(964),
    [sym__cairo_1_short_string] = ACTIONS(964),
    [anon_sym_true] = ACTIONS(962),
    [anon_sym_false] = ACTIONS(962),
    [sym_self] = ACTIONS(962),
  },
  [172] = {
    [sym_identifier] = ACTIONS(966),
    [anon_sym_LPAREN] = ACTIONS(670),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_AT] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_RBRACE] = ACTIONS(968),
    [anon_sym_struct] = ACTIONS(966),
    [anon_sym_EQ_EQ] = ACTIONS(744),
    [anon_sym_let] = ACTIONS(966),
    [anon_sym_const] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(966),
    [anon_sym_BANG_EQ] = ACTIONS(744),
    [anon_sym_PLUS_EQ] = ACTIONS(746),
    [anon_sym_return] = ACTIONS(966),
    [anon_sym_STAR] = ACTIONS(748),
    [anon_sym_AMP] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(752),
    [anon_sym_PLUS] = ACTIONS(752),
    [anon_sym_SLASH] = ACTIONS(748),
    [anon_sym_LBRACK] = ACTIONS(674),
    [anon_sym_DOT] = ACTIONS(676),
    [sym_number] = ACTIONS(968),
    [anon_sym_SEMI] = ACTIONS(970),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(966),
    [anon_sym_extern] = ACTIONS(966),
    [anon_sym_type] = ACTIONS(966),
    [anon_sym_COLON_COLON] = ACTIONS(968),
    [anon_sym_fn] = ACTIONS(966),
    [anon_sym_POUND] = ACTIONS(968),
    [anon_sym_mod] = ACTIONS(966),
    [anon_sym_enum] = ACTIONS(966),
    [anon_sym_impl] = ACTIONS(966),
    [anon_sym_trait] = ACTIONS(966),
    [anon_sym_u8] = ACTIONS(966),
    [anon_sym_i8] = ACTIONS(966),
    [anon_sym_u16] = ACTIONS(966),
    [anon_sym_i16] = ACTIONS(966),
    [anon_sym_u32] = ACTIONS(966),
    [anon_sym_i32] = ACTIONS(966),
    [anon_sym_u64] = ACTIONS(966),
    [anon_sym_i64] = ACTIONS(966),
    [anon_sym_u128] = ACTIONS(966),
    [anon_sym_i128] = ACTIONS(966),
    [anon_sym_u256] = ACTIONS(966),
    [anon_sym_i256] = ACTIONS(966),
    [anon_sym_isize] = ACTIONS(966),
    [anon_sym_usize] = ACTIONS(966),
    [anon_sym_f32] = ACTIONS(966),
    [anon_sym_f64] = ACTIONS(966),
    [anon_sym_felt252] = ACTIONS(966),
    [anon_sym_bool] = ACTIONS(966),
    [anon_sym_str] = ACTIONS(966),
    [anon_sym_char] = ACTIONS(966),
    [anon_sym_GT] = ACTIONS(754),
    [anon_sym_match] = ACTIONS(966),
    [anon_sym_loop] = ACTIONS(966),
    [anon_sym_BANG] = ACTIONS(966),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_PIPE_PIPE] = ACTIONS(758),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(760),
    [anon_sym_LT2] = ACTIONS(754),
    [anon_sym_LT_EQ] = ACTIONS(744),
    [anon_sym_GT_EQ] = ACTIONS(744),
    [anon_sym_LT_LT] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_PERCENT] = ACTIONS(748),
    [anon_sym_DASH_EQ] = ACTIONS(746),
    [anon_sym_STAR_EQ] = ACTIONS(746),
    [anon_sym_SLASH_EQ] = ACTIONS(746),
    [anon_sym_PERCENT_EQ] = ACTIONS(746),
    [anon_sym_AMP_EQ] = ACTIONS(746),
    [anon_sym_PIPE_EQ] = ACTIONS(746),
    [anon_sym_CARET_EQ] = ACTIONS(746),
    [anon_sym_LT_LT_EQ] = ACTIONS(746),
    [anon_sym_GT_GT_EQ] = ACTIONS(746),
    [anon_sym_QMARK] = ACTIONS(764),
    [sym__cairo_1_short_string] = ACTIONS(968),
    [anon_sym_true] = ACTIONS(966),
    [anon_sym_false] = ACTIONS(966),
    [sym_self] = ACTIONS(966),
  },
  [173] = {
    [sym_identifier] = ACTIONS(972),
    [anon_sym_LPAREN] = ACTIONS(974),
    [anon_sym_EQ] = ACTIONS(972),
    [anon_sym_AT] = ACTIONS(974),
    [anon_sym_LBRACE] = ACTIONS(974),
    [anon_sym_RBRACE] = ACTIONS(974),
    [anon_sym_struct] = ACTIONS(972),
    [anon_sym_EQ_EQ] = ACTIONS(974),
    [anon_sym_let] = ACTIONS(972),
    [anon_sym_const] = ACTIONS(972),
    [anon_sym_if] = ACTIONS(972),
    [anon_sym_BANG_EQ] = ACTIONS(974),
    [anon_sym_PLUS_EQ] = ACTIONS(974),
    [anon_sym_return] = ACTIONS(972),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_AMP] = ACTIONS(972),
    [anon_sym_DASH] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(972),
    [anon_sym_SLASH] = ACTIONS(972),
    [anon_sym_LBRACK] = ACTIONS(974),
    [anon_sym_DOT] = ACTIONS(974),
    [sym_number] = ACTIONS(974),
    [anon_sym_SEMI] = ACTIONS(974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_use] = ACTIONS(972),
    [anon_sym_extern] = ACTIONS(972),
    [anon_sym_type] = ACTIONS(972),
    [anon_sym_COLON_COLON] = ACTIONS(974),
    [anon_sym_fn] = ACTIONS(972),
    [anon_sym_POUND] = ACTIONS(974),
    [anon_sym_mod] = ACTIONS(972),
    [anon_sym_enum] = ACTIONS(972),
    [anon_sym_impl] = ACTIONS(972),
    [anon_sym_trait] = ACTIONS(972),
    [anon_sym_u8] = ACTIONS(972),
    [anon_sym_i8] = ACTIONS(972),
    [anon_sym_u16] = ACTIONS(972),
    [anon_sym_i16] = ACTIONS(972),
    [anon_sym_u32] = ACTIONS(972),
    [anon_sym_i32] = ACTIONS(972),
    [anon_sym_u64] = ACTIONS(972),
    [anon_sym_i64] = ACTIONS(972),
    [anon_sym_u128] = ACTIONS(972),
    [anon_sym_i128] = ACTIONS(972),
    [anon_sym_u256] = ACTIONS(972),
    [anon_sym_i256] = ACTIONS(972),
    [anon_sym_isize] = ACTIONS(972),
    [anon_sym_usize] = ACTIONS(972),
    [anon_sym_f32] = ACTIONS(972),
    [anon_sym_f64] = ACTIONS(972),
    [anon_sym_felt252] = ACTIONS(972),
    [anon_sym_bool] = ACTIONS(972),
    [anon_sym_str] = ACTIONS(972),
    [anon_sym_char] = ACTIONS(972),
    [anon_sym_GT] = ACTIONS(972),
    [anon_sym_match] = ACTIONS(972),
    [anon_sym_loop] = ACTIONS(972),
    [anon_sym_BANG] = ACTIONS(972),
    [anon_sym_TILDE] = ACTIONS(974),
    [anon_sym_AMP_AMP] = ACTIONS(974),
    [anon_sym_PIPE_PIPE] = ACTIONS(974),
    [anon_sym_PIPE] = ACTIONS(972),
    [anon_sym_CARET] = ACTIONS(972),
    [anon_sym_LT2] = ACTIONS(972),
    [anon_sym_LT_EQ] = ACTIONS(974),
    [anon_sym_GT_EQ] = ACTIONS(974),
    [anon_sym_LT_LT] = ACTIONS(972),
    [anon_sym_GT_GT] = ACTIONS(972),
    [anon_sym_PERCENT] = ACTIONS(972),
    [anon_sym_DASH_EQ] = ACTIONS(974),
    [anon_sym_STAR_EQ] = ACTIONS(974),
    [anon_sym_SLASH_EQ] = ACTIONS(974),
    [anon_sym_PERCENT_EQ] = ACTIONS(974),
    [anon_sym_AMP_EQ] = ACTIONS(974),
    [anon_sym_PIPE_EQ] = ACTIONS(974),
    [anon_sym_CARET_EQ] = ACTIONS(974),
    [anon_sym_LT_LT_EQ] = ACTIONS(974),
    [anon_sym_GT_GT_EQ] = ACTIONS(974),
    [anon_sym_QMARK] = ACTIONS(974),
    [sym__cairo_1_short_string] = ACTIONS(974),
    [anon_sym_true] = ACTIONS(972),
    [anon_sym_false] = ACTIONS(972),
    [sym_self] = ACTIONS(972),
  },
  [174] = {
    [sym_attribute_item] = STATE(183),
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(682),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [aux_sym_enum_variant_list_repeat1] = STATE(183),
    [sym_identifier] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(976),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(978),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [175] = {
    [sym_attribute_item] = STATE(181),
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(747),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [aux_sym_enum_variant_list_repeat1] = STATE(181),
    [sym_identifier] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(980),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(978),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [176] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(984),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [177] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(990),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [178] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(992),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [179] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(994),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [180] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(996),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [181] = {
    [sym_attribute_item] = STATE(400),
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(759),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [aux_sym_enum_variant_list_repeat1] = STATE(400),
    [sym_identifier] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(978),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [182] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(998),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [183] = {
    [sym_attribute_item] = STATE(400),
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(766),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [aux_sym_enum_variant_list_repeat1] = STATE(400),
    [sym_identifier] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_POUND] = ACTIONS(978),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [184] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(672),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1002),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(1004),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(1006),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [185] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(669),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1010),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(1012),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(1014),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [186] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1016),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [187] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1018),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [188] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1020),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [189] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [190] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1024),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [191] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1026),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [192] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1028),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [193] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1030),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [194] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1032),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [195] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1034),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [196] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [197] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1038),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [198] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1040),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [199] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1042),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [200] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(694),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [aux_sym__cairo_1_tuple_expression_repeat1] = STATE(208),
    [sym_identifier] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [201] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(694),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [aux_sym__cairo_1_tuple_expression_repeat1] = STATE(204),
    [sym_identifier] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [202] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(703),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [sym_identifier] = ACTIONS(982),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_ref] = ACTIONS(988),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [203] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(718),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [aux_sym__cairo_1_tuple_expression_repeat1] = STATE(208),
    [sym_identifier] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1046),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [204] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(700),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [aux_sym__cairo_1_tuple_expression_repeat1] = STATE(208),
    [sym_identifier] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1048),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [205] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(673),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [aux_sym__cairo_1_tuple_expression_repeat1] = STATE(200),
    [sym_identifier] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1050),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [206] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(681),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [aux_sym__cairo_1_tuple_expression_repeat1] = STATE(208),
    [sym_identifier] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [207] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(681),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [aux_sym__cairo_1_tuple_expression_repeat1] = STATE(203),
    [sym_identifier] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
  [208] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(769),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [aux_sym__cairo_1_tuple_expression_repeat1] = STATE(208),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(1060),
    [anon_sym_AT] = ACTIONS(1062),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1071),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1077),
    [sym_number] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(1083),
    [anon_sym_u8] = ACTIONS(1086),
    [anon_sym_i8] = ACTIONS(1086),
    [anon_sym_u16] = ACTIONS(1086),
    [anon_sym_i16] = ACTIONS(1086),
    [anon_sym_u32] = ACTIONS(1086),
    [anon_sym_i32] = ACTIONS(1086),
    [anon_sym_u64] = ACTIONS(1086),
    [anon_sym_i64] = ACTIONS(1086),
    [anon_sym_u128] = ACTIONS(1086),
    [anon_sym_i128] = ACTIONS(1086),
    [anon_sym_u256] = ACTIONS(1086),
    [anon_sym_i256] = ACTIONS(1086),
    [anon_sym_isize] = ACTIONS(1086),
    [anon_sym_usize] = ACTIONS(1086),
    [anon_sym_f32] = ACTIONS(1086),
    [anon_sym_f64] = ACTIONS(1086),
    [anon_sym_felt252] = ACTIONS(1086),
    [anon_sym_bool] = ACTIONS(1086),
    [anon_sym_str] = ACTIONS(1086),
    [anon_sym_char] = ACTIONS(1086),
    [anon_sym_match] = ACTIONS(1089),
    [anon_sym_loop] = ACTIONS(1092),
    [anon_sym_BANG] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1074),
    [sym__cairo_1_short_string] = ACTIONS(1080),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [sym_self] = ACTIONS(1098),
  },
  [209] = {
    [sym_block] = STATE(448),
    [sym__cairo_1_generic_function] = STATE(451),
    [sym_generic_type_with_turbofish] = STATE(1758),
    [sym__cairo_1_expression] = STATE(685),
    [sym__cairo_1_return_expression] = STATE(448),
    [sym__cairo_1_if_expression] = STATE(458),
    [sym_match_expression] = STATE(448),
    [sym__cairo_1_loop_expression] = STATE(459),
    [sym__cairo_1_at_expression] = STATE(448),
    [sym__cairo_1_unary_expression] = STATE(448),
    [sym__cairo_1_binary_expression] = STATE(461),
    [sym__cairo_1_assignment_expression] = STATE(462),
    [sym__cairo_1_compound_assignment_expression] = STATE(499),
    [sym__cairo_1_try_expression] = STATE(448),
    [sym__cairo_1_call_expression] = STATE(470),
    [sym__cairo_1_index_expression] = STATE(448),
    [sym__cairo_1_field_expression] = STATE(423),
    [sym__cairo_1_parenthesized_expression] = STATE(448),
    [sym__cairo_1_tuple_expression] = STATE(448),
    [sym__cairo_1_unit_expression] = STATE(448),
    [sym__cairo_1_struct_expression] = STATE(473),
    [sym__literal] = STATE(448),
    [sym_scoped_identifier] = STATE(408),
    [sym_boolean] = STATE(448),
    [aux_sym__cairo_1_tuple_expression_repeat1] = STATE(206),
    [sym_identifier] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(137),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(139),
    [sym_number] = ACTIONS(141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(143),
    [anon_sym_u8] = ACTIONS(145),
    [anon_sym_i8] = ACTIONS(145),
    [anon_sym_u16] = ACTIONS(145),
    [anon_sym_i16] = ACTIONS(145),
    [anon_sym_u32] = ACTIONS(145),
    [anon_sym_i32] = ACTIONS(145),
    [anon_sym_u64] = ACTIONS(145),
    [anon_sym_i64] = ACTIONS(145),
    [anon_sym_u128] = ACTIONS(145),
    [anon_sym_i128] = ACTIONS(145),
    [anon_sym_u256] = ACTIONS(145),
    [anon_sym_i256] = ACTIONS(145),
    [anon_sym_isize] = ACTIONS(145),
    [anon_sym_usize] = ACTIONS(145),
    [anon_sym_f32] = ACTIONS(145),
    [anon_sym_f64] = ACTIONS(145),
    [anon_sym_felt252] = ACTIONS(145),
    [anon_sym_bool] = ACTIONS(145),
    [anon_sym_str] = ACTIONS(145),
    [anon_sym_char] = ACTIONS(145),
    [anon_sym_match] = ACTIONS(147),
    [anon_sym_loop] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(151),
    [anon_sym_TILDE] = ACTIONS(151),
    [sym__cairo_1_short_string] = ACTIONS(141),
    [anon_sym_true] = ACTIONS(153),
    [anon_sym_false] = ACTIONS(153),
    [sym_self] = ACTIONS(155),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(1103), 1,
      sym_identifier,
    ACTIONS(1105), 1,
      anon_sym_COLON,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(661), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 1,
      anon_sym_else,
    STATE(312), 1,
      sym__cairo_1_else_clause,
    ACTIONS(638), 25,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
    ACTIONS(636), 36,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_GT,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
      sym_self,
  [200] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(1109), 1,
      sym_identifier,
    ACTIONS(1111), 1,
      anon_sym_RPAREN,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(655), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [325] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_RPAREN,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(739), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [450] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1117), 1,
      anon_sym_RPAREN,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(739), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [575] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1119), 1,
      anon_sym_RPAREN,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(739), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [700] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(1121), 1,
      sym_identifier,
    ACTIONS(1123), 1,
      anon_sym_COLON,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(690), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [825] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_RPAREN,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(739), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [950] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(1127), 1,
      sym_identifier,
    ACTIONS(1129), 1,
      anon_sym_COLON,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(657), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [1075] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(753), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [1197] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(772), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [1319] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(687), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [1441] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(529), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [1563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 25,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
    ACTIONS(642), 37,
      anon_sym_EQ,
      anon_sym_else,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_GT,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
      sym_self,
  [1633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(648), 25,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
    ACTIONS(646), 37,
      anon_sym_EQ,
      anon_sym_else,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_GT,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
      sym_self,
  [1703] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(765), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [1825] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(495), 1,
      sym__cairo_1_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [1947] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(726), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2069] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_identifier,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(99), 1,
      anon_sym_AT,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    ACTIONS(105), 1,
      anon_sym_if,
    ACTIONS(107), 1,
      anon_sym_return,
    ACTIONS(109), 1,
      anon_sym_DASH,
    ACTIONS(113), 1,
      anon_sym_COLON_COLON,
    ACTIONS(117), 1,
      anon_sym_match,
    ACTIONS(119), 1,
      anon_sym_loop,
    ACTIONS(125), 1,
      sym_self,
    STATE(100), 1,
      sym__cairo_1_generic_function,
    STATE(101), 1,
      sym__cairo_1_if_expression,
    STATE(102), 1,
      sym__cairo_1_loop_expression,
    STATE(103), 1,
      sym__cairo_1_binary_expression,
    STATE(104), 1,
      sym__cairo_1_assignment_expression,
    STATE(105), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(106), 1,
      sym__cairo_1_call_expression,
    STATE(107), 1,
      sym__cairo_1_field_expression,
    STATE(108), 1,
      sym__cairo_1_struct_expression,
    STATE(109), 1,
      sym_scoped_identifier,
    STATE(112), 1,
      sym__cairo_1_expression,
    STATE(1827), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(111), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(123), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(121), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(97), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(115), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2191] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(755), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2313] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(757), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2435] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(697), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2557] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(661), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2679] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_identifier,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(99), 1,
      anon_sym_AT,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    ACTIONS(105), 1,
      anon_sym_if,
    ACTIONS(107), 1,
      anon_sym_return,
    ACTIONS(109), 1,
      anon_sym_DASH,
    ACTIONS(113), 1,
      anon_sym_COLON_COLON,
    ACTIONS(117), 1,
      anon_sym_match,
    ACTIONS(119), 1,
      anon_sym_loop,
    ACTIONS(125), 1,
      sym_self,
    STATE(100), 1,
      sym__cairo_1_generic_function,
    STATE(101), 1,
      sym__cairo_1_if_expression,
    STATE(102), 1,
      sym__cairo_1_loop_expression,
    STATE(103), 1,
      sym__cairo_1_binary_expression,
    STATE(104), 1,
      sym__cairo_1_assignment_expression,
    STATE(105), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(106), 1,
      sym__cairo_1_call_expression,
    STATE(107), 1,
      sym__cairo_1_field_expression,
    STATE(108), 1,
      sym__cairo_1_struct_expression,
    STATE(109), 1,
      sym_scoped_identifier,
    STATE(114), 1,
      sym__cairo_1_expression,
    STATE(1827), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(111), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(123), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(121), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(97), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(115), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2801] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(749), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2923] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(758), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3045] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(495), 1,
      sym__cairo_1_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3167] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(776), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3289] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(1131), 1,
      anon_sym_LBRACE,
    ACTIONS(1133), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_match,
    STATE(309), 1,
      sym__cairo_1_if_expression,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(777), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(308), 2,
      sym_block,
      sym_match_expression,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 10,
      sym__cairo_1_return_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3413] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(678), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3535] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(668), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3657] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(512), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3779] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(677), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3901] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(505), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4023] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(506), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4145] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(426), 1,
      sym__cairo_1_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4267] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(507), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4389] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(508), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4511] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(691), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4633] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(513), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4755] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(684), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4877] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(664), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4999] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(665), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5121] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(1131), 1,
      anon_sym_LBRACE,
    ACTIONS(1133), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_match,
    STATE(311), 1,
      sym__cairo_1_if_expression,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(760), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(307), 2,
      sym_block,
      sym_match_expression,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 10,
      sym__cairo_1_return_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5245] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_identifier,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(99), 1,
      anon_sym_AT,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    ACTIONS(105), 1,
      anon_sym_if,
    ACTIONS(107), 1,
      anon_sym_return,
    ACTIONS(109), 1,
      anon_sym_DASH,
    ACTIONS(113), 1,
      anon_sym_COLON_COLON,
    ACTIONS(117), 1,
      anon_sym_match,
    ACTIONS(119), 1,
      anon_sym_loop,
    ACTIONS(125), 1,
      sym_self,
    STATE(100), 1,
      sym__cairo_1_generic_function,
    STATE(101), 1,
      sym__cairo_1_if_expression,
    STATE(102), 1,
      sym__cairo_1_loop_expression,
    STATE(103), 1,
      sym__cairo_1_binary_expression,
    STATE(104), 1,
      sym__cairo_1_assignment_expression,
    STATE(105), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(106), 1,
      sym__cairo_1_call_expression,
    STATE(107), 1,
      sym__cairo_1_field_expression,
    STATE(108), 1,
      sym__cairo_1_struct_expression,
    STATE(109), 1,
      sym_scoped_identifier,
    STATE(124), 1,
      sym__cairo_1_expression,
    STATE(1827), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(111), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(123), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(121), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(97), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(115), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5367] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(509), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5489] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_identifier,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(99), 1,
      anon_sym_AT,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    ACTIONS(105), 1,
      anon_sym_if,
    ACTIONS(107), 1,
      anon_sym_return,
    ACTIONS(109), 1,
      anon_sym_DASH,
    ACTIONS(113), 1,
      anon_sym_COLON_COLON,
    ACTIONS(117), 1,
      anon_sym_match,
    ACTIONS(119), 1,
      anon_sym_loop,
    ACTIONS(125), 1,
      sym_self,
    STATE(100), 1,
      sym__cairo_1_generic_function,
    STATE(101), 1,
      sym__cairo_1_if_expression,
    STATE(102), 1,
      sym__cairo_1_loop_expression,
    STATE(103), 1,
      sym__cairo_1_binary_expression,
    STATE(104), 1,
      sym__cairo_1_assignment_expression,
    STATE(105), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(106), 1,
      sym__cairo_1_call_expression,
    STATE(107), 1,
      sym__cairo_1_field_expression,
    STATE(108), 1,
      sym__cairo_1_struct_expression,
    STATE(109), 1,
      sym_scoped_identifier,
    STATE(125), 1,
      sym__cairo_1_expression,
    STATE(1827), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(111), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(123), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(121), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(97), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(115), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5611] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(715), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5733] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(767), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5855] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(751), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5977] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_identifier,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(99), 1,
      anon_sym_AT,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    ACTIONS(105), 1,
      anon_sym_if,
    ACTIONS(107), 1,
      anon_sym_return,
    ACTIONS(109), 1,
      anon_sym_DASH,
    ACTIONS(113), 1,
      anon_sym_COLON_COLON,
    ACTIONS(117), 1,
      anon_sym_match,
    ACTIONS(119), 1,
      anon_sym_loop,
    ACTIONS(125), 1,
      sym_self,
    STATE(100), 1,
      sym__cairo_1_generic_function,
    STATE(101), 1,
      sym__cairo_1_if_expression,
    STATE(102), 1,
      sym__cairo_1_loop_expression,
    STATE(103), 1,
      sym__cairo_1_binary_expression,
    STATE(104), 1,
      sym__cairo_1_assignment_expression,
    STATE(105), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(106), 1,
      sym__cairo_1_call_expression,
    STATE(107), 1,
      sym__cairo_1_field_expression,
    STATE(108), 1,
      sym__cairo_1_struct_expression,
    STATE(109), 1,
      sym_scoped_identifier,
    STATE(126), 1,
      sym__cairo_1_expression,
    STATE(1827), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(111), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(123), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(121), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(97), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(115), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6099] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_identifier,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(99), 1,
      anon_sym_AT,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    ACTIONS(105), 1,
      anon_sym_if,
    ACTIONS(107), 1,
      anon_sym_return,
    ACTIONS(109), 1,
      anon_sym_DASH,
    ACTIONS(113), 1,
      anon_sym_COLON_COLON,
    ACTIONS(117), 1,
      anon_sym_match,
    ACTIONS(119), 1,
      anon_sym_loop,
    ACTIONS(125), 1,
      sym_self,
    STATE(100), 1,
      sym__cairo_1_generic_function,
    STATE(101), 1,
      sym__cairo_1_if_expression,
    STATE(102), 1,
      sym__cairo_1_loop_expression,
    STATE(103), 1,
      sym__cairo_1_binary_expression,
    STATE(104), 1,
      sym__cairo_1_assignment_expression,
    STATE(105), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(106), 1,
      sym__cairo_1_call_expression,
    STATE(107), 1,
      sym__cairo_1_field_expression,
    STATE(108), 1,
      sym__cairo_1_struct_expression,
    STATE(109), 1,
      sym_scoped_identifier,
    STATE(127), 1,
      sym__cairo_1_expression,
    STATE(1827), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(111), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(123), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(121), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(97), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(115), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6221] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_identifier,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(99), 1,
      anon_sym_AT,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    ACTIONS(105), 1,
      anon_sym_if,
    ACTIONS(107), 1,
      anon_sym_return,
    ACTIONS(109), 1,
      anon_sym_DASH,
    ACTIONS(113), 1,
      anon_sym_COLON_COLON,
    ACTIONS(117), 1,
      anon_sym_match,
    ACTIONS(119), 1,
      anon_sym_loop,
    ACTIONS(125), 1,
      sym_self,
    STATE(100), 1,
      sym__cairo_1_generic_function,
    STATE(101), 1,
      sym__cairo_1_if_expression,
    STATE(102), 1,
      sym__cairo_1_loop_expression,
    STATE(103), 1,
      sym__cairo_1_binary_expression,
    STATE(104), 1,
      sym__cairo_1_assignment_expression,
    STATE(105), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(106), 1,
      sym__cairo_1_call_expression,
    STATE(107), 1,
      sym__cairo_1_field_expression,
    STATE(108), 1,
      sym__cairo_1_struct_expression,
    STATE(109), 1,
      sym_scoped_identifier,
    STATE(128), 1,
      sym__cairo_1_expression,
    STATE(1827), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(111), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(123), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(121), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(97), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(115), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6343] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_identifier,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(99), 1,
      anon_sym_AT,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    ACTIONS(105), 1,
      anon_sym_if,
    ACTIONS(107), 1,
      anon_sym_return,
    ACTIONS(109), 1,
      anon_sym_DASH,
    ACTIONS(113), 1,
      anon_sym_COLON_COLON,
    ACTIONS(117), 1,
      anon_sym_match,
    ACTIONS(119), 1,
      anon_sym_loop,
    ACTIONS(125), 1,
      sym_self,
    STATE(100), 1,
      sym__cairo_1_generic_function,
    STATE(101), 1,
      sym__cairo_1_if_expression,
    STATE(102), 1,
      sym__cairo_1_loop_expression,
    STATE(103), 1,
      sym__cairo_1_binary_expression,
    STATE(104), 1,
      sym__cairo_1_assignment_expression,
    STATE(105), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(106), 1,
      sym__cairo_1_call_expression,
    STATE(107), 1,
      sym__cairo_1_field_expression,
    STATE(108), 1,
      sym__cairo_1_struct_expression,
    STATE(109), 1,
      sym_scoped_identifier,
    STATE(129), 1,
      sym__cairo_1_expression,
    STATE(1827), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(111), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(123), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(121), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(97), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(115), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6465] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_identifier,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(99), 1,
      anon_sym_AT,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    ACTIONS(105), 1,
      anon_sym_if,
    ACTIONS(107), 1,
      anon_sym_return,
    ACTIONS(109), 1,
      anon_sym_DASH,
    ACTIONS(113), 1,
      anon_sym_COLON_COLON,
    ACTIONS(117), 1,
      anon_sym_match,
    ACTIONS(119), 1,
      anon_sym_loop,
    ACTIONS(125), 1,
      sym_self,
    STATE(100), 1,
      sym__cairo_1_generic_function,
    STATE(101), 1,
      sym__cairo_1_if_expression,
    STATE(102), 1,
      sym__cairo_1_loop_expression,
    STATE(103), 1,
      sym__cairo_1_binary_expression,
    STATE(104), 1,
      sym__cairo_1_assignment_expression,
    STATE(105), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(106), 1,
      sym__cairo_1_call_expression,
    STATE(107), 1,
      sym__cairo_1_field_expression,
    STATE(108), 1,
      sym__cairo_1_struct_expression,
    STATE(109), 1,
      sym_scoped_identifier,
    STATE(131), 1,
      sym__cairo_1_expression,
    STATE(1827), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(111), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(123), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(121), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(97), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(115), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6587] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(725), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6709] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(1131), 1,
      anon_sym_LBRACE,
    ACTIONS(1133), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_match,
    STATE(309), 1,
      sym__cairo_1_if_expression,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(728), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(308), 2,
      sym_block,
      sym_match_expression,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 10,
      sym__cairo_1_return_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6833] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(756), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6955] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_identifier,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(99), 1,
      anon_sym_AT,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    ACTIONS(105), 1,
      anon_sym_if,
    ACTIONS(107), 1,
      anon_sym_return,
    ACTIONS(109), 1,
      anon_sym_DASH,
    ACTIONS(113), 1,
      anon_sym_COLON_COLON,
    ACTIONS(117), 1,
      anon_sym_match,
    ACTIONS(119), 1,
      anon_sym_loop,
    ACTIONS(125), 1,
      sym_self,
    STATE(100), 1,
      sym__cairo_1_generic_function,
    STATE(101), 1,
      sym__cairo_1_if_expression,
    STATE(102), 1,
      sym__cairo_1_loop_expression,
    STATE(103), 1,
      sym__cairo_1_binary_expression,
    STATE(104), 1,
      sym__cairo_1_assignment_expression,
    STATE(105), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(106), 1,
      sym__cairo_1_call_expression,
    STATE(107), 1,
      sym__cairo_1_field_expression,
    STATE(108), 1,
      sym__cairo_1_struct_expression,
    STATE(109), 1,
      sym_scoped_identifier,
    STATE(132), 1,
      sym__cairo_1_expression,
    STATE(1827), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(111), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(123), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(121), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(97), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(115), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7077] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_identifier,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(99), 1,
      anon_sym_AT,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    ACTIONS(105), 1,
      anon_sym_if,
    ACTIONS(107), 1,
      anon_sym_return,
    ACTIONS(109), 1,
      anon_sym_DASH,
    ACTIONS(113), 1,
      anon_sym_COLON_COLON,
    ACTIONS(117), 1,
      anon_sym_match,
    ACTIONS(119), 1,
      anon_sym_loop,
    ACTIONS(125), 1,
      sym_self,
    STATE(100), 1,
      sym__cairo_1_generic_function,
    STATE(101), 1,
      sym__cairo_1_if_expression,
    STATE(102), 1,
      sym__cairo_1_loop_expression,
    STATE(103), 1,
      sym__cairo_1_binary_expression,
    STATE(104), 1,
      sym__cairo_1_assignment_expression,
    STATE(105), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(106), 1,
      sym__cairo_1_call_expression,
    STATE(107), 1,
      sym__cairo_1_field_expression,
    STATE(108), 1,
      sym__cairo_1_struct_expression,
    STATE(109), 1,
      sym_scoped_identifier,
    STATE(133), 1,
      sym__cairo_1_expression,
    STATE(1827), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(111), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(123), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(121), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(97), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(115), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7199] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_identifier,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(99), 1,
      anon_sym_AT,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    ACTIONS(105), 1,
      anon_sym_if,
    ACTIONS(107), 1,
      anon_sym_return,
    ACTIONS(109), 1,
      anon_sym_DASH,
    ACTIONS(113), 1,
      anon_sym_COLON_COLON,
    ACTIONS(117), 1,
      anon_sym_match,
    ACTIONS(119), 1,
      anon_sym_loop,
    ACTIONS(125), 1,
      sym_self,
    STATE(94), 1,
      sym__cairo_1_expression,
    STATE(100), 1,
      sym__cairo_1_generic_function,
    STATE(101), 1,
      sym__cairo_1_if_expression,
    STATE(102), 1,
      sym__cairo_1_loop_expression,
    STATE(103), 1,
      sym__cairo_1_binary_expression,
    STATE(104), 1,
      sym__cairo_1_assignment_expression,
    STATE(105), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(106), 1,
      sym__cairo_1_call_expression,
    STATE(107), 1,
      sym__cairo_1_field_expression,
    STATE(108), 1,
      sym__cairo_1_struct_expression,
    STATE(109), 1,
      sym_scoped_identifier,
    STATE(1827), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(111), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(123), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(121), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(97), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(115), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7321] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 1,
      sym_identifier,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(99), 1,
      anon_sym_AT,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    ACTIONS(105), 1,
      anon_sym_if,
    ACTIONS(107), 1,
      anon_sym_return,
    ACTIONS(109), 1,
      anon_sym_DASH,
    ACTIONS(113), 1,
      anon_sym_COLON_COLON,
    ACTIONS(117), 1,
      anon_sym_match,
    ACTIONS(119), 1,
      anon_sym_loop,
    ACTIONS(125), 1,
      sym_self,
    STATE(100), 1,
      sym__cairo_1_generic_function,
    STATE(101), 1,
      sym__cairo_1_if_expression,
    STATE(102), 1,
      sym__cairo_1_loop_expression,
    STATE(103), 1,
      sym__cairo_1_binary_expression,
    STATE(104), 1,
      sym__cairo_1_assignment_expression,
    STATE(105), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(106), 1,
      sym__cairo_1_call_expression,
    STATE(107), 1,
      sym__cairo_1_field_expression,
    STATE(108), 1,
      sym__cairo_1_struct_expression,
    STATE(109), 1,
      sym_scoped_identifier,
    STATE(134), 1,
      sym__cairo_1_expression,
    STATE(1827), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(111), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(123), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(121), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(97), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(115), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7443] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(679), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7565] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(514), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7687] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(771), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7809] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(662), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7931] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(690), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8053] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(763), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8175] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(773), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8297] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(778), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8419] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(754), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8541] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(761), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8663] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(762), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8785] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(511), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8907] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(764), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9029] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(688), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9151] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(1113), 1,
      sym_identifier,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(739), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9273] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(768), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9395] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(774), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9517] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(675), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9639] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(676), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9761] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(750), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9883] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(752), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10005] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(1131), 1,
      anon_sym_LBRACE,
    ACTIONS(1133), 1,
      anon_sym_if,
    ACTIONS(1135), 1,
      anon_sym_match,
    STATE(311), 1,
      sym__cairo_1_if_expression,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(686), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(307), 2,
      sym_block,
      sym_match_expression,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 10,
      sym__cairo_1_return_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10129] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(770), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10251] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(657), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10373] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(426), 1,
      sym__cairo_1_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10495] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(666), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10617] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(667), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10739] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(670), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10861] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(711), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10983] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    ACTIONS(270), 1,
      sym_identifier,
    ACTIONS(272), 1,
      anon_sym_AT,
    ACTIONS(274), 1,
      anon_sym_return,
    ACTIONS(276), 1,
      anon_sym_DASH,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(712), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(280), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(278), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [11105] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      sym_identifier,
    ACTIONS(129), 1,
      anon_sym_LPAREN,
    ACTIONS(131), 1,
      anon_sym_AT,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(135), 1,
      anon_sym_if,
    ACTIONS(137), 1,
      anon_sym_return,
    ACTIONS(139), 1,
      anon_sym_DASH,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(147), 1,
      anon_sym_match,
    ACTIONS(149), 1,
      anon_sym_loop,
    ACTIONS(155), 1,
      sym_self,
    STATE(408), 1,
      sym_scoped_identifier,
    STATE(423), 1,
      sym__cairo_1_field_expression,
    STATE(451), 1,
      sym__cairo_1_generic_function,
    STATE(458), 1,
      sym__cairo_1_if_expression,
    STATE(459), 1,
      sym__cairo_1_loop_expression,
    STATE(461), 1,
      sym__cairo_1_binary_expression,
    STATE(462), 1,
      sym__cairo_1_assignment_expression,
    STATE(470), 1,
      sym__cairo_1_call_expression,
    STATE(473), 1,
      sym__cairo_1_struct_expression,
    STATE(499), 1,
      sym__cairo_1_compound_assignment_expression,
    STATE(510), 1,
      sym__cairo_1_expression,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(141), 2,
      sym_number,
      sym__cairo_1_short_string,
    ACTIONS(153), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(151), 3,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(448), 12,
      sym_block,
      sym__cairo_1_return_expression,
      sym_match_expression,
      sym__cairo_1_at_expression,
      sym__cairo_1_unary_expression,
      sym__cairo_1_try_expression,
      sym__cairo_1_index_expression,
      sym__cairo_1_parenthesized_expression,
      sym__cairo_1_tuple_expression,
      sym__cairo_1_unit_expression,
      sym__literal,
      sym_boolean,
    ACTIONS(145), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [11227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 25,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
    ACTIONS(850), 36,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_GT,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
      sym_self,
  [11296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(856), 25,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
    ACTIONS(854), 36,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_GT,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
      sym_self,
  [11365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(864), 25,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
    ACTIONS(862), 36,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_GT,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
      sym_self,
  [11434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(884), 25,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
    ACTIONS(882), 36,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_GT,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
      sym_self,
  [11503] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1139), 4,
      anon_sym_LPAREN,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
    ACTIONS(650), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(652), 21,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
    ACTIONS(1137), 23,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      sym_self,
  [11576] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1143), 4,
      anon_sym_LPAREN,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
    ACTIONS(650), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(652), 21,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
    ACTIONS(1141), 23,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      sym_self,
  [11649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 4,
      anon_sym_LPAREN,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
    ACTIONS(698), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(700), 21,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
    ACTIONS(1145), 23,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      sym_self,
  [11722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(804), 25,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
    ACTIONS(802), 36,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_GT,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
      sym_self,
  [11791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 4,
      anon_sym_LPAREN,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
    ACTIONS(698), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(700), 21,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
    ACTIONS(1149), 23,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      sym_self,
  [11864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(828), 25,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
    ACTIONS(826), 36,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_GT,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
      sym_self,
  [11933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(836), 25,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
    ACTIONS(834), 36,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_GT,
      anon_sym__,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
      sym_self,
  [12002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1155), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1153), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1157), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1157), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1161), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1165), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1171), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1169), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1175), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1173), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1179), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1177), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1181), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1187), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1185), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1191), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1189), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1195), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1193), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1197), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1201), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1207), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1205), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1211), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1209), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [12946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1215), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1213), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1217), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1221), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1225), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1231), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1229), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1233), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1239), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1237), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1243), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1241), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1245), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1251), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1249), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1253), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1259), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1257), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1263), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1261), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1267), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1265), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1271), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1269), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1275), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1273), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1277), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [13949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1283), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1281), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1285), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1289), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1295), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1293), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1299), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1297), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1301), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1307), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1305), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1311), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1309), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1315), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1313), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1319), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1317), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1323), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1321), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1327), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1325), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1331), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1329), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1335), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1333), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1339), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1337), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1341), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1347), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1345), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [14952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1349), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1355), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1353), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1359), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1357), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1363), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1361), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1365), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1369), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1375), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1373), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1379), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1377), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1381), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1387), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1385), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1391), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1389), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1395), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1393), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1397), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1403), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1401), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1407), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1405), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1411), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1409), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1413), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [15955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1417), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [16014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1423), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1421), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [16073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1427), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1425), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [16132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1431), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1429), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [16191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1435), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1433), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [16250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(642), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [16309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(648), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(646), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [16368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 11,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1437), 40,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [16427] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1251), 1,
      anon_sym_POUND,
    ACTIONS(1441), 1,
      ts_builtin_sym_end,
    ACTIONS(1448), 3,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
    ACTIONS(1249), 8,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
    ACTIONS(1446), 9,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1444), 24,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [16489] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1451), 1,
      sym_identifier,
    ACTIONS(1453), 1,
      anon_sym_LPAREN,
    ACTIONS(1455), 1,
      anon_sym_RPAREN,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1163), 1,
      sym_named_type,
    STATE(1347), 1,
      sym__cairo_0_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
    STATE(1468), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [16575] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1451), 1,
      sym_identifier,
    ACTIONS(1453), 1,
      anon_sym_LPAREN,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1163), 1,
      sym_named_type,
    STATE(1306), 1,
      sym__cairo_0_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
    STATE(1701), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [16658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(684), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(686), 30,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [16710] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 1,
      anon_sym_POUND,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1475), 1,
      anon_sym_RBRACE,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1576), 1,
      sym__pattern,
    STATE(1723), 1,
      sym_last_match_arm,
    STATE(1736), 1,
      sym_match_pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(397), 2,
      sym_match_arm,
      aux_sym_match_block_repeat1,
    STATE(526), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [16795] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 1,
      anon_sym_POUND,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1487), 1,
      anon_sym_RBRACE,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1576), 1,
      sym__pattern,
    STATE(1726), 1,
      sym_last_match_arm,
    STATE(1736), 1,
      sym_match_pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(407), 2,
      sym_match_arm,
      aux_sym_match_block_repeat1,
    STATE(526), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [16880] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 1,
      anon_sym_POUND,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1489), 1,
      anon_sym_RBRACE,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1576), 1,
      sym__pattern,
    STATE(1736), 1,
      sym_match_pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1805), 1,
      sym_last_match_arm,
    STATE(405), 2,
      sym_match_arm,
      aux_sym_match_block_repeat1,
    STATE(526), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [16965] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_LBRACE,
    ACTIONS(1493), 1,
      anon_sym_COLON_COLON,
    STATE(450), 1,
      sym_field_initializer_list,
    ACTIONS(650), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(652), 26,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [17021] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 1,
      anon_sym_POUND,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1576), 1,
      sym__pattern,
    STATE(1736), 1,
      sym_match_pattern,
    STATE(1745), 1,
      sym_last_match_arm,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(409), 2,
      sym_match_arm,
      aux_sym_match_block_repeat1,
    STATE(526), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [17103] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_COLON_COLON,
    STATE(430), 1,
      sym_field_initializer_list,
    ACTIONS(659), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(661), 26,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [17159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(680), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(682), 29,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [17209] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1501), 1,
      anon_sym_POUND,
    STATE(400), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    ACTIONS(1499), 9,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1497), 30,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym__,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [17263] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1508), 1,
      anon_sym_DOT,
    STATE(402), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(1506), 11,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1504), 29,
      anon_sym_from,
      anon_sym_as,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [17317] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1508), 1,
      anon_sym_DOT,
    STATE(403), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(1512), 11,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1510), 29,
      anon_sym_from,
      anon_sym_as,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [17371] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1518), 1,
      anon_sym_DOT,
    STATE(403), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(1516), 11,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1514), 29,
      anon_sym_from,
      anon_sym_as,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [17425] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1521), 1,
      anon_sym_else,
    STATE(463), 1,
      sym__cairo_1_else_clause,
    ACTIONS(636), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(638), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [17479] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 1,
      anon_sym_POUND,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1576), 1,
      sym__pattern,
    STATE(1736), 1,
      sym_match_pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1806), 1,
      sym_last_match_arm,
    STATE(409), 2,
      sym_match_arm,
      aux_sym_match_block_repeat1,
    STATE(526), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [17561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(732), 29,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [17611] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 1,
      anon_sym_POUND,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1576), 1,
      sym__pattern,
    STATE(1736), 1,
      sym_match_pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1777), 1,
      sym_last_match_arm,
    STATE(409), 2,
      sym_match_arm,
      aux_sym_match_block_repeat1,
    STATE(526), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [17693] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 1,
      anon_sym_COLON_COLON,
    ACTIONS(650), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(652), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [17744] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1525), 1,
      sym_identifier,
    ACTIONS(1528), 1,
      anon_sym_LPAREN,
    ACTIONS(1531), 1,
      sym_number,
    ACTIONS(1534), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1537), 1,
      anon_sym_POUND,
    ACTIONS(1543), 1,
      anon_sym__,
    ACTIONS(1546), 1,
      sym_self,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1576), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1879), 1,
      sym_match_pattern,
    STATE(409), 2,
      sym_match_arm,
      aux_sym_match_block_repeat1,
    STATE(539), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1540), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [17823] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 1,
      anon_sym_DOT,
    STATE(410), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(1516), 11,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1514), 28,
      anon_sym_from,
      anon_sym_as,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [17876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(818), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(820), 28,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [17925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 1,
      anon_sym_DOT,
    STATE(416), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(1506), 11,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1504), 28,
      anon_sym_from,
      anon_sym_as,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [17978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(648), 28,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1554), 1,
      anon_sym_COLON_COLON,
    ACTIONS(798), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(800), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(958), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(960), 28,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18127] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 1,
      anon_sym_DOT,
    STATE(410), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(1512), 11,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1510), 28,
      anon_sym_from,
      anon_sym_as,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [18180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 12,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_number,
    ACTIONS(1514), 29,
      anon_sym_from,
      anon_sym_as,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [18229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 1,
      anon_sym_COMMA,
    ACTIONS(1562), 1,
      anon_sym_as,
    STATE(447), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(1558), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1556), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [18284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 1,
      anon_sym_COLON_COLON,
    ACTIONS(650), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(652), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(642), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(644), 28,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_else,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(954), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(956), 28,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(962), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(964), 28,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1566), 1,
      anon_sym_COLON_COLON,
    ACTIONS(718), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(720), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      anon_sym_COLON_COLON,
    ACTIONS(798), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(800), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_COMMA,
    STATE(425), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(1572), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1570), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [18636] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(668), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(672), 24,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(822), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(824), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(782), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(784), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(808), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(778), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(780), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(946), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(948), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(906), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(908), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [18978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(736), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [19026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(910), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(912), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [19074] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      sym_number,
    ACTIONS(1591), 1,
      anon_sym_GT,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1591), 7,
      sym_block,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
      sym__literal,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [19148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(790), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(792), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [19196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(914), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(916), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [19244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(918), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(920), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [19292] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    ACTIONS(1595), 1,
      anon_sym_as,
    STATE(535), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(1558), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1556), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [19346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(924), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [19394] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 1,
      anon_sym_COMMA,
    STATE(446), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(1558), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1556), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [19446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(786), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(788), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [19494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1211), 10,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1209), 30,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym__,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [19542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1215), 10,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1213), 30,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym__,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [19590] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      sym_identifier,
    STATE(454), 1,
      sym_dotted_name,
    STATE(519), 1,
      sym_aliased_import,
    ACTIONS(1601), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1599), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
  [19644] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 1,
      anon_sym_COMMA,
    STATE(425), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(1605), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1603), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [19696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1609), 1,
      anon_sym_COMMA,
    STATE(425), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(1605), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1603), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [19748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(650), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(652), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [19796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(688), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(690), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [19844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(774), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(776), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [19892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(694), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(696), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [19940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 10,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1285), 30,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym__,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [19988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 10,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1289), 30,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym__,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [20036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1562), 1,
      anon_sym_as,
    ACTIONS(1613), 11,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1611), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [20086] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      sym_identifier,
    STATE(454), 1,
      sym_dotted_name,
    STATE(519), 1,
      sym_aliased_import,
    ACTIONS(1617), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1615), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
  [20140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(898), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(900), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [20188] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      sym_identifier,
    STATE(454), 1,
      sym_dotted_name,
    STATE(519), 1,
      sym_aliased_import,
    ACTIONS(1617), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1615), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
  [20242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(698), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(700), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [20290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(702), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(704), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [20338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(974), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [20386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(706), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(708), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [20434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(710), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(712), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [20482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(828), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [20530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(830), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(832), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [20578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 12,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
      sym_number,
    ACTIONS(1514), 28,
      anon_sym_from,
      anon_sym_as,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [20626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(952), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [20674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(934), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(936), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [20722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(834), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(836), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [20770] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      sym_number,
    ACTIONS(1619), 1,
      anon_sym_GT,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1591), 7,
      sym_block,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
      sym__literal,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [20844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(714), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(716), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [20892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(902), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(904), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [20940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(838), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(840), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [20988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(724), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(726), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [21036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(842), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(844), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [21084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(926), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(928), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [21132] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      sym_number,
    ACTIONS(1621), 1,
      anon_sym_GT,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1591), 7,
      sym_block,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
      sym__literal,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [21206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(848), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [21254] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      sym_number,
    ACTIONS(1623), 1,
      anon_sym_GT,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1591), 7,
      sym_block,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
      sym__literal,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [21328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(794), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(796), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [21376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(852), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [21424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(854), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(856), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [21472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(858), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(860), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [21520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(940), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [21568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(862), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(864), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [21616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(944), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [21664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(868), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [21712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(872), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [21760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(930), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(932), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [21808] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      sym_number,
    ACTIONS(1625), 1,
      anon_sym_GT,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1591), 7,
      sym_block,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
      sym__literal,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [21882] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      sym_number,
    ACTIONS(1627), 1,
      anon_sym_GT,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1591), 7,
      sym_block,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
      sym__literal,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [21956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(804), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [22004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(876), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [22052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(878), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(880), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [22100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(882), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(884), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [22148] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(770), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(772), 24,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [22202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(886), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(888), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [22250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(890), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(892), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [22298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(894), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(896), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [22346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(706), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(708), 27,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [22394] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1629), 1,
      sym_identifier,
    ACTIONS(1631), 1,
      anon_sym_LPAREN,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(1635), 1,
      anon_sym_mut,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1385), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1749), 2,
      sym__ref_binding,
      sym_typed_identifier,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [22469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1641), 1,
      anon_sym_else,
    ACTIONS(1639), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1637), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [22518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 1,
      anon_sym_COMMA,
    STATE(533), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(1558), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1556), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [22569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_else,
    ACTIONS(1645), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1643), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [22618] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_LBRACE,
    ACTIONS(1493), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1649), 1,
      anon_sym_COLON,
    STATE(450), 1,
      sym_field_initializer_list,
    ACTIONS(650), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(652), 22,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [22673] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_EQ,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(812), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [22746] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(668), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(672), 23,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [22811] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(814), 1,
      anon_sym_EQ,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(816), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [22884] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(668), 8,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_PERCENT,
    ACTIONS(672), 23,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [22945] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(668), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(672), 23,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [23002] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(668), 5,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(672), 23,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [23065] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(668), 1,
      anon_sym_EQ,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(672), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [23134] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(668), 1,
      anon_sym_EQ,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(672), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [23205] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(668), 12,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(672), 23,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [23260] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(668), 10,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(672), 23,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [23319] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1671), 1,
      sym_identifier,
    STATE(525), 1,
      aux_sym_builtin_directive_repeat1,
    ACTIONS(1675), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1673), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
  [23370] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(1677), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_RPAREN,
    ACTIONS(1681), 1,
      anon_sym_COMMA,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1446), 1,
      sym_typed_identifier,
    STATE(1569), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [23447] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_LBRACE,
    ACTIONS(1493), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1683), 1,
      anon_sym_COLON,
    STATE(450), 1,
      sym_field_initializer_list,
    ACTIONS(650), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(652), 22,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [23502] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_LBRACE,
    ACTIONS(1493), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1685), 1,
      anon_sym_COLON,
    STATE(450), 1,
      sym_field_initializer_list,
    ACTIONS(650), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(652), 22,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [23557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 11,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1611), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [23604] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_LBRACE,
    ACTIONS(1493), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1687), 1,
      anon_sym_COLON,
    STATE(450), 1,
      sym_field_initializer_list,
    ACTIONS(650), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(652), 22,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [23659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 1,
      anon_sym_as,
    ACTIONS(1613), 11,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1611), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [23708] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1689), 1,
      sym_identifier,
    STATE(521), 1,
      sym_dotted_name,
    STATE(554), 1,
      sym_aliased_import,
    ACTIONS(1617), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1615), 26,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
  [23761] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1691), 1,
      anon_sym_COMMA,
    STATE(523), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(1572), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1570), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [23812] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      sym_number,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1591), 7,
      sym_block,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
      sym__literal,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [23883] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_identifier,
    STATE(525), 1,
      aux_sym_builtin_directive_repeat1,
    ACTIONS(1699), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1697), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
  [23934] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 1,
      anon_sym_POUND,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1576), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1776), 1,
      sym_match_pattern,
    STATE(400), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [24009] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_LBRACE,
    ACTIONS(1493), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1701), 1,
      anon_sym_COLON,
    STATE(450), 1,
      sym_field_initializer_list,
    ACTIONS(650), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(652), 22,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [24064] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_LBRACE,
    ACTIONS(1493), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1703), 1,
      anon_sym_COLON,
    STATE(450), 1,
      sym_field_initializer_list,
    ACTIONS(650), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(652), 22,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [24119] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(742), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [24196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1060), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_AT,
      anon_sym_LBRACE,
      anon_sym_STAR,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_BANG,
      anon_sym_TILDE,
      sym__cairo_1_short_string,
    ACTIONS(1711), 29,
      anon_sym_if,
      anon_sym_return,
      anon_sym_DASH,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_true,
      anon_sym_false,
      sym_self,
  [24243] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(768), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [24318] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1689), 1,
      sym_identifier,
    STATE(521), 1,
      sym_dotted_name,
    STATE(554), 1,
      sym_aliased_import,
    ACTIONS(1601), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1599), 26,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
  [24371] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1713), 1,
      anon_sym_COMMA,
    STATE(523), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(1605), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1603), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [24422] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_LBRACE,
    ACTIONS(1493), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1715), 1,
      anon_sym_COLON,
    STATE(450), 1,
      sym_field_initializer_list,
    ACTIONS(650), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(652), 22,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [24477] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1717), 1,
      anon_sym_COMMA,
    STATE(523), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(1605), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1603), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [24528] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1689), 1,
      sym_identifier,
    STATE(521), 1,
      sym_dotted_name,
    STATE(554), 1,
      sym_aliased_import,
    ACTIONS(1617), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1615), 26,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
  [24581] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1719), 1,
      sym_number,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1460), 7,
      sym_block,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
      sym__literal,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [24652] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1721), 1,
      sym_number,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1474), 7,
      sym_block,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
      sym__literal,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [24723] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 1,
      anon_sym_POUND,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1576), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1932), 1,
      sym_match_pattern,
    STATE(400), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [24798] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1723), 1,
      sym_number,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1463), 7,
      sym_block,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
      sym__literal,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [24869] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_LBRACE,
    ACTIONS(1493), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1725), 1,
      anon_sym_COLON,
    STATE(450), 1,
      sym_field_initializer_list,
    ACTIONS(650), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(652), 22,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [24924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1729), 11,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1727), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [24971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1733), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1731), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1737), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1735), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1741), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1739), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1745), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1743), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1749), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1747), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1753), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1751), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1757), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1755), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1759), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25339] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(1765), 1,
      anon_sym_EQ,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    ACTIONS(1763), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1441), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [25409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1769), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1767), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1773), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1771), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 11,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1611), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1777), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1775), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1781), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1779), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1785), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1783), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1789), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1787), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1793), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1791), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1797), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1795), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1801), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1799), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1805), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1803), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1809), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1807), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [25961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1813), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1811), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1817), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1815), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1821), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1819), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1825), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1823), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1827), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1831), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1837), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1835), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1841), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1839), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1845), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1843), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1849), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1847), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1853), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1851), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1855), 1,
      anon_sym_else,
    ACTIONS(1645), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1643), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1857), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1861), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1865), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      sym_identifier,
    STATE(579), 1,
      aux_sym_builtin_directive_repeat1,
    ACTIONS(1699), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1697), 26,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
  [26703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1444), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1874), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1872), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1878), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1876), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1882), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1880), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1886), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1884), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [26933] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1888), 1,
      sym_identifier,
    STATE(579), 1,
      aux_sym_builtin_directive_repeat1,
    ACTIONS(1675), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1673), 26,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
  [26983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1892), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1890), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1896), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1894), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1900), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1898), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1904), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1902), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1729), 11,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1727), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1908), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1906), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1912), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1910), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1916), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1914), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1918), 1,
      anon_sym_else,
    ACTIONS(1639), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1637), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1920), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1926), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1924), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1930), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1928), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1934), 10,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_RBRACE,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1932), 28,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_end,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1849), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1847), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1753), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1751), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1892), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1890), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1785), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1783), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1853), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1851), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1444), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1874), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1872), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1777), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1775), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1904), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1902), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [27988] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1936), 1,
      anon_sym_RPAREN,
    ACTIONS(1938), 1,
      anon_sym_COMMA,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1695), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [28059] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1940), 1,
      anon_sym_RPAREN,
    ACTIONS(1942), 1,
      anon_sym_COMMA,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1695), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [28130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1912), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1910), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1797), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1795), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1831), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1916), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1914), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1837), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1835), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1845), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1843), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1805), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1803), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1809), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1807), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1789), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1787), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1886), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1884), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1801), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1799), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1769), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1767), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1733), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1731), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1865), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1781), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1779), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1749), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1747), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1813), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1811), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [28895] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1944), 1,
      anon_sym_RPAREN,
    ACTIONS(1946), 1,
      anon_sym_COMMA,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1695), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [28966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1841), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1839), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1857), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1896), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1894), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1793), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1791), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1817), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1815), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1930), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1928), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1900), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1898), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1908), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1906), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1759), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1821), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1819), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1920), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1926), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1924), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29506] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1681), 1,
      anon_sym_COMMA,
    ACTIONS(1948), 1,
      anon_sym_RPAREN,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1569), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [29577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1773), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1771), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1878), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1876), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1934), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1932), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29712] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1950), 1,
      anon_sym_RPAREN,
    ACTIONS(1952), 1,
      anon_sym_COMMA,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1439), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [29783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1825), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1823), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1827), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1882), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1880), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [29918] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1954), 1,
      anon_sym_RPAREN,
    ACTIONS(1956), 1,
      anon_sym_COMMA,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1695), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [29989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1745), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1743), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [30034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1861), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [30079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1737), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1735), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [30124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1741), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1739), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [30169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1757), 10,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_PERCENTbuiltins,
      anon_sym_PERCENTlang,
      anon_sym_AT,
      anon_sym_AMP,
      sym_short_string,
      anon_sym_PERCENT_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1755), 27,
      anon_sym_from,
      anon_sym_using,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
      anon_sym_alloc_locals,
      anon_sym_assert,
      anon_sym_static_assert,
      anon_sym_let,
      anon_sym_const,
      anon_sym_local,
      anon_sym_tempvar,
      anon_sym_ap,
      anon_sym_jmp,
      anon_sym_if,
      sym_inst_ret,
      anon_sym_dw,
      anon_sym_with_attr,
      anon_sym_with,
      anon_sym_return,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_nondet,
      anon_sym_fp,
      anon_sym_cast,
      anon_sym_call,
      sym_identifier,
  [30214] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1635), 1,
      anon_sym_mut,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1385), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [30282] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1958), 1,
      anon_sym_RPAREN,
    ACTIONS(1960), 1,
      anon_sym_COMMA,
    STATE(1412), 1,
      aux_sym_attribute_arguments_repeat1,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [30360] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1962), 1,
      anon_sym_mut,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1422), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [30428] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1018), 1,
      anon_sym_RPAREN,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1964), 1,
      anon_sym_COMMA,
    STATE(1431), 1,
      aux_sym__cairo_1_call_expression_repeat1,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [30506] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1493), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1966), 1,
      anon_sym_LBRACE,
    STATE(450), 1,
      sym_field_initializer_list,
    ACTIONS(650), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(652), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [30556] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1969), 1,
      anon_sym_LBRACE,
    STATE(430), 1,
      sym_field_initializer_list,
    ACTIONS(659), 13,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(661), 20,
      anon_sym_LPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [30606] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(1972), 1,
      anon_sym_RPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1679), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [30672] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1042), 1,
      anon_sym_RPAREN,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1974), 1,
      anon_sym_COMMA,
    STATE(1513), 1,
      aux_sym__cairo_1_call_expression_repeat1,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [30750] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1976), 1,
      anon_sym_RPAREN,
    ACTIONS(1978), 1,
      anon_sym_COMMA,
    STATE(1549), 1,
      aux_sym__cairo_1_call_expression_repeat1,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [30828] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(1980), 1,
      anon_sym_RPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1679), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [30894] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1982), 1,
      anon_sym_RPAREN,
    ACTIONS(1984), 1,
      anon_sym_COMMA,
    STATE(1530), 1,
      aux_sym__cairo_1_call_expression_repeat1,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [30972] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 1,
      anon_sym_RPAREN,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1986), 1,
      anon_sym_COMMA,
    STATE(1445), 1,
      aux_sym__cairo_1_call_expression_repeat1,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31050] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1988), 1,
      anon_sym_RPAREN,
    ACTIONS(1990), 1,
      anon_sym_COMMA,
    STATE(1332), 1,
      aux_sym__cairo_1_call_expression_repeat1,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31128] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1020), 1,
      anon_sym_RPAREN,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    STATE(1444), 1,
      aux_sym__cairo_1_call_expression_repeat1,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31206] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_RPAREN,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1994), 1,
      anon_sym_COMMA,
    STATE(1568), 1,
      aux_sym_attribute_arguments_repeat1,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31284] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1996), 1,
      anon_sym_RPAREN,
    ACTIONS(1998), 1,
      anon_sym_COMMA,
    STATE(1417), 1,
      aux_sym__cairo_1_call_expression_repeat1,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31362] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2000), 1,
      anon_sym_RPAREN,
    ACTIONS(2002), 1,
      anon_sym_COMMA,
    STATE(1453), 1,
      aux_sym__cairo_1_call_expression_repeat1,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31440] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(2004), 1,
      anon_sym_RPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1468), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [31506] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2006), 1,
      anon_sym_RPAREN,
    ACTIONS(2008), 1,
      anon_sym_COMMA,
    STATE(1386), 1,
      aux_sym__cairo_1_call_expression_repeat1,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31584] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1044), 1,
      anon_sym_RPAREN,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_COMMA,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31659] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(2012), 1,
      sym_identifier,
    ACTIONS(2014), 1,
      anon_sym_AT,
    ACTIONS(2016), 1,
      anon_sym_impl,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1854), 1,
      sym_scoped_identifier,
    STATE(1929), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(2018), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [31722] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2020), 1,
      anon_sym_EQ,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    STATE(87), 1,
      sym_block,
    ACTIONS(2030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2032), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(2042), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2026), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2022), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2024), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31797] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2020), 1,
      anon_sym_EQ,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    ACTIONS(2044), 1,
      anon_sym_LBRACE,
    STATE(122), 1,
      sym_match_block,
    ACTIONS(2030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2032), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(2042), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2026), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2022), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2024), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31872] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2046), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [31945] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2048), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32018] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2050), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32091] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1280), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [32154] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1046), 1,
      anon_sym_RPAREN,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_COMMA,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32229] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2052), 1,
      anon_sym_RPAREN,
    ACTIONS(2054), 1,
      anon_sym_COMMA,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32304] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1709), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [32369] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2056), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32442] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1052), 1,
      anon_sym_RPAREN,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_COMMA,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32517] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2058), 1,
      anon_sym_COMMA,
    ACTIONS(2060), 1,
      anon_sym_RBRACE,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32592] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2020), 1,
      anon_sym_EQ,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    STATE(404), 1,
      sym_block,
    ACTIONS(2030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2032), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(2042), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2026), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2022), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2024), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32667] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2062), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32740] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1760), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [32803] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2064), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32876] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2066), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32949] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1578), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [33014] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1904), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [33077] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1048), 1,
      anon_sym_RPAREN,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_COMMA,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33152] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1679), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [33215] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1283), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [33278] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2068), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33351] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1083), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [33414] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1672), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [33477] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_COMMA,
    ACTIONS(2070), 1,
      anon_sym_RPAREN,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33552] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1670), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [33615] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1669), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [33678] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2072), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33751] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1426), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [33814] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1397), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [33877] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(2012), 1,
      sym_identifier,
    ACTIONS(2014), 1,
      anon_sym_AT,
    ACTIONS(2016), 1,
      anon_sym_impl,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1854), 1,
      sym_scoped_identifier,
    STATE(1093), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(2018), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [33940] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1526), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [34003] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1265), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [34066] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1329), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [34129] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1395), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [34192] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 1,
      anon_sym_LBRACE,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2020), 1,
      anon_sym_EQ,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    STATE(211), 1,
      sym_block,
    ACTIONS(2030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2032), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(2042), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2026), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2022), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2024), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34267] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2020), 1,
      anon_sym_EQ,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    STATE(310), 1,
      sym_match_block,
    ACTIONS(2030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2032), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(2042), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2026), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2022), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2024), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34342] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1093), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [34405] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(2012), 1,
      sym_identifier,
    ACTIONS(2014), 1,
      anon_sym_AT,
    ACTIONS(2016), 1,
      anon_sym_impl,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1854), 1,
      sym_scoped_identifier,
    STATE(1837), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(2018), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [34468] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2076), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34541] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1651), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [34606] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1459), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [34671] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_COMMA,
    ACTIONS(2078), 1,
      anon_sym_RPAREN,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34746] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1585), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [34809] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1586), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [34872] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1888), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [34935] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1344), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [34998] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1701), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [35061] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1600), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [35124] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2080), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35197] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2020), 1,
      anon_sym_EQ,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    ACTIONS(2082), 1,
      anon_sym_LBRACE,
    STATE(491), 1,
      sym_match_block,
    ACTIONS(2030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2032), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(2042), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2026), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2022), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2024), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35272] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1784), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [35335] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2084), 1,
      anon_sym_COMMA,
    ACTIONS(2086), 1,
      anon_sym_RBRACE,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35410] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1538), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [35473] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1277), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [35536] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1325), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [35599] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1330), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [35662] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1284), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [35725] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1285), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [35788] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1373), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [35853] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1485), 1,
      sym_self,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    ACTIONS(2012), 1,
      sym_identifier,
    ACTIONS(2014), 1,
      anon_sym_AT,
    ACTIONS(2016), 1,
      anon_sym_impl,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1854), 1,
      sym_scoped_identifier,
    STATE(1083), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(2018), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [35916] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1331), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [35979] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1292), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [36042] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2088), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36115] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1297), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [36178] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1298), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [36241] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1300), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [36304] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1719), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [36367] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1251), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [36430] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      sym_identifier,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1477), 1,
      sym_number,
    ACTIONS(1479), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1483), 1,
      anon_sym__,
    ACTIONS(1485), 1,
      sym_self,
    STATE(1091), 1,
      sym_scoped_identifier,
    STATE(1289), 1,
      sym_scoped_type_identifier,
    STATE(1695), 1,
      sym__pattern,
    STATE(1753), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1126), 4,
      sym_tuple_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym__literal_pattern,
    ACTIONS(1481), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [36495] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1326), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [36558] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2090), 1,
      anon_sym_RPAREN,
    ACTIONS(2092), 1,
      anon_sym_COMMA,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36633] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_AT,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(1583), 1,
      sym_identifier,
    ACTIONS(1585), 1,
      anon_sym_LPAREN,
    STATE(1041), 1,
      sym_scoped_type_identifier,
    STATE(1076), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    STATE(1599), 5,
      sym__cairo_1_type,
      sym_at_type,
      sym__cairo_1_tuple_type,
      sym_unit_type,
      sym_abstract_type,
    ACTIONS(1467), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [36696] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2020), 1,
      anon_sym_EQ,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    ACTIONS(2030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2032), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(2042), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2026), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2022), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2024), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36768] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2094), 1,
      anon_sym_RBRACK,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36840] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2096), 1,
      anon_sym_RBRACK,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36912] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2098), 1,
      anon_sym_SEMI,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36984] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2100), 1,
      anon_sym_SEMI,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37056] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    ACTIONS(668), 11,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(672), 18,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [37108] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2102), 1,
      anon_sym_SEMI,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37180] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2104), 1,
      anon_sym_EQ_GT,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37252] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2106), 1,
      anon_sym_SEMI,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37324] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2108), 1,
      anon_sym_SEMI,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37396] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2110), 1,
      anon_sym_COMMA,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37468] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2112), 1,
      anon_sym_COMMA,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37540] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    ACTIONS(2042), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2026), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(668), 5,
      anon_sym_EQ,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(672), 18,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [37598] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(668), 1,
      anon_sym_EQ,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    ACTIONS(2030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2032), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(2042), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2026), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2022), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(672), 14,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [37662] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    ACTIONS(2030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2042), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(668), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(2026), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(672), 18,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [37722] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(668), 1,
      anon_sym_EQ,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    ACTIONS(2030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2032), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(2042), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2026), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2022), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(672), 13,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [37788] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2114), 1,
      anon_sym_SEMI,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37860] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2116), 1,
      anon_sym_COMMA,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37932] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(668), 12,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_CARET,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(672), 18,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [37982] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2118), 1,
      anon_sym_SEMI,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38054] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2010), 1,
      anon_sym_COMMA,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38126] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2120), 1,
      anon_sym_SEMI,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38198] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_EQ,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    ACTIONS(2030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2032), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(2042), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2026), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2022), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(812), 12,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [38266] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    ACTIONS(668), 10,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PERCENT,
    ACTIONS(672), 18,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [38320] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(814), 1,
      anon_sym_EQ,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    ACTIONS(2030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2032), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(2042), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2026), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2022), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(816), 12,
      anon_sym_LBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [38388] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2122), 1,
      anon_sym_SEMI,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38460] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(2020), 1,
      anon_sym_EQ,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    ACTIONS(768), 2,
      anon_sym_LBRACE,
      anon_sym_QMARK,
    ACTIONS(2030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2032), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(2042), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2026), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2022), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2024), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38530] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2124), 1,
      anon_sym_SEMI,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38602] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(1655), 1,
      anon_sym_AMP,
    ACTIONS(1661), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1663), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1665), 1,
      anon_sym_PIPE,
    ACTIONS(1667), 1,
      anon_sym_CARET,
    ACTIONS(1705), 1,
      anon_sym_EQ,
    ACTIONS(1709), 1,
      anon_sym_QMARK,
    ACTIONS(2126), 1,
      anon_sym_COMMA,
    ACTIONS(1657), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1659), 2,
      anon_sym_GT,
      anon_sym_LT2,
    ACTIONS(1669), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1653), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1651), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1707), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38674] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_LPAREN,
    ACTIONS(1579), 1,
      anon_sym_LBRACK,
    ACTIONS(1581), 1,
      anon_sym_DOT,
    ACTIONS(2028), 1,
      anon_sym_AMP,
    ACTIONS(2038), 1,
      anon_sym_PIPE,
    ACTIONS(2040), 1,
      anon_sym_CARET,
    ACTIONS(2042), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(668), 8,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_PERCENT,
    ACTIONS(672), 18,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK,
  [38730] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 1,
      sym_identifier,
    ACTIONS(2130), 1,
      anon_sym_LBRACE,
    ACTIONS(2132), 1,
      anon_sym_RBRACE,
    ACTIONS(2134), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2138), 1,
      sym_self,
    STATE(1183), 1,
      sym_scoped_identifier,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1721), 4,
      sym__use_clause,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
    ACTIONS(2136), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [38783] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 1,
      sym_identifier,
    ACTIONS(2130), 1,
      anon_sym_LBRACE,
    ACTIONS(2134), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2138), 1,
      sym_self,
    ACTIONS(2140), 1,
      anon_sym_RBRACE,
    STATE(1183), 1,
      sym_scoped_identifier,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1721), 4,
      sym__use_clause,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
    ACTIONS(2136), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [38836] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 1,
      sym_identifier,
    ACTIONS(2130), 1,
      anon_sym_LBRACE,
    ACTIONS(2134), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2138), 1,
      sym_self,
    STATE(1183), 1,
      sym_scoped_identifier,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1928), 4,
      sym__use_clause,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
    ACTIONS(2136), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [38886] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2144), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_let,
    ACTIONS(2150), 1,
      anon_sym_const,
    ACTIONS(2153), 1,
      anon_sym_use,
    ACTIONS(2156), 1,
      anon_sym_extern,
    ACTIONS(2159), 1,
      anon_sym_type,
    ACTIONS(2162), 1,
      anon_sym_fn,
    ACTIONS(2165), 1,
      anon_sym_POUND,
    ACTIONS(2168), 1,
      anon_sym_mod,
    ACTIONS(2171), 1,
      anon_sym_enum,
    ACTIONS(2174), 1,
      anon_sym_impl,
    ACTIONS(2177), 1,
      anon_sym_trait,
    STATE(972), 1,
      sym__cairo_1_function_definition,
    STATE(977), 1,
      sym__cairo_1_function_signature,
    ACTIONS(2142), 2,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
    STATE(782), 14,
      sym__cairo_1_statement,
      sym_use_declaration,
      sym_extern_type_statement,
      sym_extern_function_statement,
      sym_attribute_item,
      sym_mod_item,
      sym_struct_item,
      sym_enum_item,
      sym_const_item,
      sym_type_item,
      sym_impl_item,
      sym_trait_item,
      sym_let_declaration,
      aux_sym_cairo_1_file_repeat1,
  [38952] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 1,
      sym_identifier,
    ACTIONS(2130), 1,
      anon_sym_LBRACE,
    ACTIONS(2134), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2138), 1,
      sym_self,
    STATE(1183), 1,
      sym_scoped_identifier,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1748), 4,
      sym__use_clause,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
    ACTIONS(2136), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [39002] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 1,
      sym_identifier,
    ACTIONS(2130), 1,
      anon_sym_LBRACE,
    ACTIONS(2134), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2138), 1,
      sym_self,
    STATE(1183), 1,
      sym_scoped_identifier,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1376), 4,
      sym__use_clause,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
    ACTIONS(2136), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [39052] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 1,
      sym_identifier,
    ACTIONS(2130), 1,
      anon_sym_LBRACE,
    ACTIONS(2134), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2138), 1,
      sym_self,
    STATE(1183), 1,
      sym_scoped_identifier,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1721), 4,
      sym__use_clause,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
    ACTIONS(2136), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [39102] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_POUND,
    ACTIONS(2180), 1,
      anon_sym_RBRACE,
    ACTIONS(2182), 1,
      anon_sym_struct,
    ACTIONS(2184), 1,
      anon_sym_let,
    ACTIONS(2186), 1,
      anon_sym_const,
    ACTIONS(2188), 1,
      anon_sym_use,
    ACTIONS(2190), 1,
      anon_sym_extern,
    ACTIONS(2192), 1,
      anon_sym_type,
    ACTIONS(2194), 1,
      anon_sym_fn,
    ACTIONS(2196), 1,
      anon_sym_mod,
    ACTIONS(2198), 1,
      anon_sym_enum,
    ACTIONS(2200), 1,
      anon_sym_impl,
    ACTIONS(2202), 1,
      anon_sym_trait,
    STATE(972), 1,
      sym__cairo_1_function_definition,
    STATE(977), 1,
      sym__cairo_1_function_signature,
    STATE(782), 14,
      sym__cairo_1_statement,
      sym_use_declaration,
      sym_extern_type_statement,
      sym_extern_function_statement,
      sym_attribute_item,
      sym_mod_item,
      sym_struct_item,
      sym_enum_item,
      sym_const_item,
      sym_type_item,
      sym_impl_item,
      sym_trait_item,
      sym_let_declaration,
      aux_sym_cairo_1_file_repeat1,
  [39167] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_POUND,
    ACTIONS(2182), 1,
      anon_sym_struct,
    ACTIONS(2184), 1,
      anon_sym_let,
    ACTIONS(2186), 1,
      anon_sym_const,
    ACTIONS(2188), 1,
      anon_sym_use,
    ACTIONS(2190), 1,
      anon_sym_extern,
    ACTIONS(2192), 1,
      anon_sym_type,
    ACTIONS(2194), 1,
      anon_sym_fn,
    ACTIONS(2196), 1,
      anon_sym_mod,
    ACTIONS(2198), 1,
      anon_sym_enum,
    ACTIONS(2200), 1,
      anon_sym_impl,
    ACTIONS(2202), 1,
      anon_sym_trait,
    ACTIONS(2204), 1,
      ts_builtin_sym_end,
    STATE(972), 1,
      sym__cairo_1_function_definition,
    STATE(977), 1,
      sym__cairo_1_function_signature,
    STATE(782), 14,
      sym__cairo_1_statement,
      sym_use_declaration,
      sym_extern_type_statement,
      sym_extern_function_statement,
      sym_attribute_item,
      sym_mod_item,
      sym_struct_item,
      sym_enum_item,
      sym_const_item,
      sym_type_item,
      sym_impl_item,
      sym_trait_item,
      sym_let_declaration,
      aux_sym_cairo_1_file_repeat1,
  [39232] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_POUND,
    ACTIONS(2182), 1,
      anon_sym_struct,
    ACTIONS(2184), 1,
      anon_sym_let,
    ACTIONS(2186), 1,
      anon_sym_const,
    ACTIONS(2188), 1,
      anon_sym_use,
    ACTIONS(2190), 1,
      anon_sym_extern,
    ACTIONS(2192), 1,
      anon_sym_type,
    ACTIONS(2194), 1,
      anon_sym_fn,
    ACTIONS(2196), 1,
      anon_sym_mod,
    ACTIONS(2198), 1,
      anon_sym_enum,
    ACTIONS(2200), 1,
      anon_sym_impl,
    ACTIONS(2202), 1,
      anon_sym_trait,
    ACTIONS(2206), 1,
      anon_sym_RBRACE,
    STATE(972), 1,
      sym__cairo_1_function_definition,
    STATE(977), 1,
      sym__cairo_1_function_signature,
    STATE(786), 14,
      sym__cairo_1_statement,
      sym_use_declaration,
      sym_extern_type_statement,
      sym_extern_function_statement,
      sym_attribute_item,
      sym_mod_item,
      sym_struct_item,
      sym_enum_item,
      sym_const_item,
      sym_type_item,
      sym_impl_item,
      sym_trait_item,
      sym_let_declaration,
      aux_sym_cairo_1_file_repeat1,
  [39297] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_POUND,
    ACTIONS(2182), 1,
      anon_sym_struct,
    ACTIONS(2184), 1,
      anon_sym_let,
    ACTIONS(2186), 1,
      anon_sym_const,
    ACTIONS(2188), 1,
      anon_sym_use,
    ACTIONS(2190), 1,
      anon_sym_extern,
    ACTIONS(2192), 1,
      anon_sym_type,
    ACTIONS(2194), 1,
      anon_sym_fn,
    ACTIONS(2196), 1,
      anon_sym_mod,
    ACTIONS(2198), 1,
      anon_sym_enum,
    ACTIONS(2200), 1,
      anon_sym_impl,
    ACTIONS(2202), 1,
      anon_sym_trait,
    ACTIONS(2208), 1,
      anon_sym_RBRACE,
    STATE(972), 1,
      sym__cairo_1_function_definition,
    STATE(977), 1,
      sym__cairo_1_function_signature,
    STATE(790), 14,
      sym__cairo_1_statement,
      sym_use_declaration,
      sym_extern_type_statement,
      sym_extern_function_statement,
      sym_attribute_item,
      sym_mod_item,
      sym_struct_item,
      sym_enum_item,
      sym_const_item,
      sym_type_item,
      sym_impl_item,
      sym_trait_item,
      sym_let_declaration,
      aux_sym_cairo_1_file_repeat1,
  [39362] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_POUND,
    ACTIONS(2182), 1,
      anon_sym_struct,
    ACTIONS(2184), 1,
      anon_sym_let,
    ACTIONS(2186), 1,
      anon_sym_const,
    ACTIONS(2188), 1,
      anon_sym_use,
    ACTIONS(2190), 1,
      anon_sym_extern,
    ACTIONS(2192), 1,
      anon_sym_type,
    ACTIONS(2194), 1,
      anon_sym_fn,
    ACTIONS(2196), 1,
      anon_sym_mod,
    ACTIONS(2198), 1,
      anon_sym_enum,
    ACTIONS(2200), 1,
      anon_sym_impl,
    ACTIONS(2202), 1,
      anon_sym_trait,
    ACTIONS(2210), 1,
      anon_sym_RBRACE,
    STATE(972), 1,
      sym__cairo_1_function_definition,
    STATE(977), 1,
      sym__cairo_1_function_signature,
    STATE(782), 14,
      sym__cairo_1_statement,
      sym_use_declaration,
      sym_extern_type_statement,
      sym_extern_function_statement,
      sym_attribute_item,
      sym_mod_item,
      sym_struct_item,
      sym_enum_item,
      sym_const_item,
      sym_type_item,
      sym_impl_item,
      sym_trait_item,
      sym_let_declaration,
      aux_sym_cairo_1_file_repeat1,
  [39427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2216), 1,
      anon_sym_RBRACE,
    ACTIONS(2214), 4,
      anon_sym_LPAREN,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
    ACTIONS(2212), 23,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      sym_self,
  [39465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_RBRACE,
    ACTIONS(2220), 4,
      anon_sym_LPAREN,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
    ACTIONS(2218), 23,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      sym_self,
  [39503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 4,
      anon_sym_LPAREN,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
    ACTIONS(2218), 23,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      sym_self,
  [39538] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(2224), 1,
      sym_identifier,
    STATE(1203), 1,
      sym_scoped_type_identifier,
    STATE(1479), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    ACTIONS(2226), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [39585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2214), 4,
      anon_sym_LPAREN,
      sym_number,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
    ACTIONS(2212), 23,
      sym_identifier,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym__,
      sym_self,
  [39620] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1469), 1,
      sym_self,
    ACTIONS(2228), 1,
      sym_identifier,
    STATE(1219), 1,
      sym_scoped_type_identifier,
    STATE(1501), 1,
      sym_generic_type,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    STATE(1836), 1,
      sym_scoped_identifier,
    ACTIONS(2226), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [39667] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      sym_identifier,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2234), 1,
      anon_sym_COMMA,
    ACTIONS(2236), 1,
      anon_sym_RBRACE,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    STATE(958), 1,
      sym_assignment_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2244), 2,
      sym_short_string,
      sym_number,
    STATE(1009), 10,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [39725] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      sym_identifier,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2252), 1,
      anon_sym_COMMA,
    ACTIONS(2254), 1,
      anon_sym_RBRACE,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    STATE(943), 1,
      sym_assignment_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2244), 2,
      sym_short_string,
      sym_number,
    STATE(1009), 10,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [39783] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(73), 1,
      anon_sym_call,
    ACTIONS(2256), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    STATE(1503), 1,
      sym_call_instruction,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2258), 2,
      sym_short_string,
      sym_number,
    STATE(921), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [39839] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      sym_identifier,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2260), 1,
      anon_sym_COMMA,
    ACTIONS(2262), 1,
      anon_sym_RBRACE,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    STATE(958), 1,
      sym_assignment_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2244), 2,
      sym_short_string,
      sym_number,
    STATE(1009), 10,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [39897] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      sym_identifier,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2264), 1,
      anon_sym_COMMA,
    ACTIONS(2266), 1,
      anon_sym_RBRACE,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    STATE(946), 1,
      sym_assignment_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2244), 2,
      sym_short_string,
      sym_number,
    STATE(1009), 10,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [39955] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      sym_identifier,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2268), 1,
      anon_sym_COMMA,
    ACTIONS(2270), 1,
      anon_sym_RBRACE,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    STATE(958), 1,
      sym_assignment_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2244), 2,
      sym_short_string,
      sym_number,
    STATE(1009), 10,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40013] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(73), 1,
      anon_sym_call,
    ACTIONS(2272), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    STATE(1379), 1,
      sym_call_instruction,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2274), 2,
      sym_short_string,
      sym_number,
    STATE(925), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40069] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      sym_identifier,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2276), 1,
      anon_sym_COMMA,
    ACTIONS(2278), 1,
      anon_sym_RBRACE,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    STATE(958), 1,
      sym_assignment_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2244), 2,
      sym_short_string,
      sym_number,
    STATE(1009), 10,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40127] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2280), 1,
      sym_identifier,
    ACTIONS(2284), 1,
      sym_self,
    STATE(1296), 1,
      sym_scoped_identifier,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(2282), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [40168] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2286), 1,
      sym_identifier,
    ACTIONS(2288), 1,
      anon_sym_RPAREN,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2290), 2,
      sym_short_string,
      sym_number,
    STATE(932), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40221] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2294), 1,
      anon_sym_RPAREN,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2296), 2,
      sym_short_string,
      sym_number,
    STATE(947), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40274] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2298), 1,
      sym_identifier,
    ACTIONS(2300), 1,
      anon_sym_RPAREN,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2302), 2,
      sym_short_string,
      sym_number,
    STATE(903), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40327] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2304), 1,
      anon_sym_RPAREN,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2296), 2,
      sym_short_string,
      sym_number,
    STATE(947), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40380] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2306), 1,
      sym_identifier,
    ACTIONS(2310), 1,
      sym_self,
    STATE(1260), 1,
      sym_scoped_identifier,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(2308), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [40421] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2312), 1,
      anon_sym_RPAREN,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2296), 2,
      sym_short_string,
      sym_number,
    STATE(947), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40474] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2314), 1,
      anon_sym_RPAREN,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2296), 2,
      sym_short_string,
      sym_number,
    STATE(947), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40527] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(143), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2316), 1,
      sym_identifier,
    ACTIONS(2320), 1,
      sym_self,
    STATE(1305), 1,
      sym_scoped_identifier,
    STATE(1758), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(2318), 20,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_u256,
      anon_sym_i256,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_felt252,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [40568] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2322), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2324), 2,
      sym_short_string,
      sym_number,
    STATE(923), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40618] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2326), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2328), 2,
      sym_short_string,
      sym_number,
    STATE(875), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40668] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2330), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2332), 2,
      sym_short_string,
      sym_number,
    STATE(869), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40718] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2334), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2336), 2,
      sym_short_string,
      sym_number,
    STATE(878), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40768] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2338), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2340), 2,
      sym_short_string,
      sym_number,
    STATE(879), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40818] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2342), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2344), 2,
      sym_short_string,
      sym_number,
    STATE(880), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40868] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2346), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2348), 2,
      sym_short_string,
      sym_number,
    STATE(952), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40918] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2350), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2352), 2,
      sym_short_string,
      sym_number,
    STATE(1005), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [40968] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2354), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2356), 2,
      sym_short_string,
      sym_number,
    STATE(1015), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41018] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2358), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2360), 2,
      sym_short_string,
      sym_number,
    STATE(975), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41068] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2362), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2364), 2,
      sym_short_string,
      sym_number,
    STATE(876), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41118] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2366), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2368), 2,
      sym_short_string,
      sym_number,
    STATE(915), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41168] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2370), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2372), 2,
      sym_short_string,
      sym_number,
    STATE(916), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41218] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2374), 1,
      sym_identifier,
    ACTIONS(2376), 1,
      sym_short_string,
    ACTIONS(2378), 1,
      sym_number,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    STATE(866), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41270] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2380), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2382), 2,
      sym_short_string,
      sym_number,
    STATE(882), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41320] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2384), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2386), 2,
      sym_short_string,
      sym_number,
    STATE(912), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41370] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2388), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2390), 2,
      sym_short_string,
      sym_number,
    STATE(939), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41420] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2392), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2394), 2,
      sym_short_string,
      sym_number,
    STATE(997), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41470] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2396), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2398), 2,
      sym_short_string,
      sym_number,
    STATE(881), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41520] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2374), 1,
      sym_identifier,
    ACTIONS(2376), 1,
      sym_short_string,
    ACTIONS(2400), 1,
      sym_number,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    STATE(866), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41572] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2402), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2404), 2,
      sym_short_string,
      sym_number,
    STATE(928), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41622] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 1,
      sym_identifier,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    STATE(958), 1,
      sym_assignment_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2244), 2,
      sym_short_string,
      sym_number,
    STATE(1009), 10,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41674] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2406), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2408), 2,
      sym_short_string,
      sym_number,
    STATE(865), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41724] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2410), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2412), 2,
      sym_short_string,
      sym_number,
    STATE(864), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41774] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2292), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2296), 2,
      sym_short_string,
      sym_number,
    STATE(947), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41824] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2414), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2416), 2,
      sym_short_string,
      sym_number,
    STATE(914), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41874] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2418), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2420), 2,
      sym_short_string,
      sym_number,
    STATE(918), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41924] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2422), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2424), 2,
      sym_short_string,
      sym_number,
    STATE(886), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [41974] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2426), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2428), 2,
      sym_short_string,
      sym_number,
    STATE(887), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42024] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2430), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2432), 2,
      sym_short_string,
      sym_number,
    STATE(888), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42074] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2434), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2436), 2,
      sym_short_string,
      sym_number,
    STATE(885), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42124] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2438), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2440), 2,
      sym_short_string,
      sym_number,
    STATE(874), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42174] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2442), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2444), 2,
      sym_short_string,
      sym_number,
    STATE(871), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42224] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2446), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2448), 2,
      sym_short_string,
      sym_number,
    STATE(950), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42274] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2450), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2452), 2,
      sym_short_string,
      sym_number,
    STATE(954), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42324] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2454), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2456), 2,
      sym_short_string,
      sym_number,
    STATE(868), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42374] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2458), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2460), 2,
      sym_short_string,
      sym_number,
    STATE(926), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42424] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2462), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2464), 2,
      sym_short_string,
      sym_number,
    STATE(951), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42474] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2466), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2468), 2,
      sym_short_string,
      sym_number,
    STATE(877), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42524] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2374), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2376), 2,
      sym_short_string,
      sym_number,
    STATE(866), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42574] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2470), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2472), 2,
      sym_short_string,
      sym_number,
    STATE(957), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42624] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2474), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2476), 2,
      sym_short_string,
      sym_number,
    STATE(867), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42674] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2478), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2480), 2,
      sym_short_string,
      sym_number,
    STATE(937), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42724] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2482), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2484), 2,
      sym_short_string,
      sym_number,
    STATE(1029), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42774] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2486), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2488), 2,
      sym_short_string,
      sym_number,
    STATE(1030), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42824] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2490), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2492), 2,
      sym_short_string,
      sym_number,
    STATE(870), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42874] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2494), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2496), 2,
      sym_short_string,
      sym_number,
    STATE(953), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42924] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2498), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2500), 2,
      sym_short_string,
      sym_number,
    STATE(955), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [42974] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2240), 1,
      anon_sym_AMP,
    ACTIONS(2246), 1,
      anon_sym_nondet,
    ACTIONS(2248), 1,
      anon_sym_LBRACK,
    ACTIONS(2250), 1,
      anon_sym_cast,
    ACTIONS(2502), 1,
      sym_identifier,
    STATE(907), 1,
      sym__cairo_0_call_expression,
    ACTIONS(2238), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2242), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(2504), 2,
      sym_short_string,
      sym_number,
    STATE(956), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [43024] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(57), 1,
      anon_sym_AMP,
    ACTIONS(63), 1,
      anon_sym_nondet,
    ACTIONS(69), 1,
      anon_sym_LBRACK,
    ACTIONS(71), 1,
      anon_sym_cast,
    ACTIONS(2506), 1,
      sym_identifier,
    STATE(906), 1,
      sym__cairo_0_call_expression,
    ACTIONS(59), 2,
      anon_sym_DASH,
      anon_sym_new,
    ACTIONS(67), 2,
      anon_sym_ap,
      anon_sym_fp,
    ACTIONS(2508), 2,
      sym_short_string,
      sym_number,
    STATE(919), 11,
      sym__cairo_0_expression,
      sym_unary_expression,
      sym_binary_expression,
      sym_assignment_expression,
      sym_hint_expression,
      sym_register,
      sym_deref_expression,
      sym_subscript_expression,
      sym_member_expression,
      sym_cast_expression,
      sym_tuple_expression,
  [43074] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2512), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2510), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_RBRACK,
  [43112] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2524), 1,
      anon_sym_EQ,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2522), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_RBRACK,
  [43156] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2524), 1,
      anon_sym_EQ,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2522), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_RBRACK,
  [43198] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2524), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2522), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_RBRACK,
  [43236] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2542), 1,
      anon_sym_if,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2556), 1,
      anon_sym_LF,
    ACTIONS(2558), 1,
      sym_comment,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2534), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [43286] = 14,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2562), 1,
      anon_sym_LF,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2560), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_SEMI,
  [43334] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2524), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2522), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_RBRACK,
  [43372] = 9,
    ACTIONS(2510), 1,
      anon_sym_LF,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2512), 11,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_SEMI,
  [43410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1807), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1809), 15,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [43436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1811), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1813), 15,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [43462] = 11,
    ACTIONS(2522), 1,
      anon_sym_LF,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2524), 7,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_SEMI,
  [43504] = 9,
    ACTIONS(2522), 1,
      anon_sym_LF,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2524), 11,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_SEMI,
  [43542] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2562), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [43588] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2524), 1,
      anon_sym_EQ,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2522), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_RBRACK,
  [43628] = 9,
    ACTIONS(2522), 1,
      anon_sym_LF,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2524), 11,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_SEMI,
  [43666] = 10,
    ACTIONS(2522), 1,
      anon_sym_LF,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2524), 9,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_SEMI,
  [43706] = 12,
    ACTIONS(2522), 1,
      anon_sym_LF,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2524), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_and,
      anon_sym_SEMI,
  [43750] = 14,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LF,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2568), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [43797] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2572), 1,
      anon_sym_SEMI,
    ACTIONS(2574), 1,
      anon_sym_LF,
    STATE(611), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [43846] = 3,
    ACTIONS(1813), 1,
      anon_sym_LF,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(1811), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [43871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2578), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2576), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [43896] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2560), 1,
      anon_sym_SEMI,
    ACTIONS(2562), 1,
      anon_sym_LF,
    ACTIONS(2580), 1,
      anon_sym_COMMA,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [43945] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2582), 1,
      anon_sym_SEMI,
    ACTIONS(2584), 1,
      anon_sym_LF,
    STATE(560), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [43994] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_SEMI,
    ACTIONS(2588), 1,
      anon_sym_LF,
    STATE(562), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [44043] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_SEMI,
    ACTIONS(2592), 1,
      anon_sym_LF,
    STATE(565), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [44092] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2596), 1,
      anon_sym_LF,
    ACTIONS(2594), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [44117] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2600), 1,
      anon_sym_LF,
    ACTIONS(2598), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [44142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2602), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [44167] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2608), 1,
      anon_sym_LF,
    ACTIONS(2606), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [44192] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2612), 1,
      anon_sym_LF,
    ACTIONS(2610), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [44217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2616), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2614), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [44242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2600), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [44267] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2602), 1,
      anon_sym_LF,
    ACTIONS(2604), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [44292] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2620), 1,
      anon_sym_LF,
    ACTIONS(2618), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [44317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2622), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [44342] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_LF,
    ACTIONS(2626), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [44367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2626), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2628), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [44392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2594), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2596), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [44417] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2630), 1,
      anon_sym_EQ,
    ACTIONS(2632), 1,
      anon_sym_SEMI,
    ACTIONS(2634), 1,
      anon_sym_LF,
    STATE(547), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [44466] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2636), 1,
      anon_sym_RPAREN,
    ACTIONS(2638), 1,
      anon_sym_COMMA,
    STATE(904), 1,
      sym_tuple_expression,
    STATE(1443), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [44515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2642), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2640), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [44540] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2630), 1,
      anon_sym_EQ,
    ACTIONS(2644), 1,
      anon_sym_SEMI,
    ACTIONS(2646), 1,
      anon_sym_LF,
    STATE(625), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [44589] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2650), 1,
      anon_sym_LF,
    ACTIONS(2648), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [44614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2648), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2650), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [44639] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2640), 1,
      anon_sym_LF,
    ACTIONS(2642), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [44664] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2654), 1,
      anon_sym_LF,
    ACTIONS(2652), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [44689] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2622), 1,
      anon_sym_LF,
    ACTIONS(2624), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [44714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2658), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2656), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [44739] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2660), 1,
      anon_sym_SEMI,
    ACTIONS(2662), 1,
      anon_sym_LF,
    STATE(616), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [44788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2666), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2664), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [44813] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_SEMI,
    ACTIONS(2670), 1,
      anon_sym_LF,
    STATE(544), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [44862] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2672), 1,
      anon_sym_SEMI,
    ACTIONS(2674), 1,
      anon_sym_LF,
    STATE(651), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [44911] = 13,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2676), 1,
      anon_sym_SEMI,
    ACTIONS(2678), 1,
      anon_sym_LF,
    STATE(652), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2524), 4,
      anon_sym_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
  [44956] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2682), 1,
      anon_sym_LF,
    ACTIONS(2680), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [44981] = 13,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2684), 1,
      anon_sym_SEMI,
    ACTIONS(2686), 1,
      anon_sym_LF,
    STATE(545), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2524), 4,
      anon_sym_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
  [45026] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2688), 1,
      anon_sym_SEMI,
    ACTIONS(2690), 1,
      anon_sym_LF,
    STATE(573), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [45075] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2664), 1,
      anon_sym_LF,
    ACTIONS(2666), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [45100] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2692), 1,
      anon_sym_SEMI,
    ACTIONS(2694), 1,
      anon_sym_LF,
    STATE(600), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [45149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2698), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2696), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [45174] = 14,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2702), 1,
      anon_sym_LF,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2700), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [45221] = 3,
    ACTIONS(1809), 1,
      anon_sym_LF,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(1807), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [45246] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_SEMI,
    ACTIONS(2706), 1,
      anon_sym_LF,
    STATE(548), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [45295] = 14,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2710), 1,
      anon_sym_LF,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2708), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [45342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2608), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [45367] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2712), 1,
      anon_sym_SEMI,
    ACTIONS(2714), 1,
      anon_sym_LF,
    STATE(599), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [45416] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2696), 1,
      anon_sym_LF,
    ACTIONS(2698), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [45441] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_LF,
    ACTIONS(2616), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [45466] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_LF,
    ACTIONS(2658), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [45491] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2716), 1,
      anon_sym_RPAREN,
    ACTIONS(2718), 1,
      anon_sym_COMMA,
    STATE(904), 1,
      sym_tuple_expression,
    STATE(1423), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [45540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2612), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [45565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2618), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2620), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [45590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2682), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [45615] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2576), 1,
      anon_sym_LF,
    ACTIONS(2578), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_if,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [45640] = 14,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2722), 1,
      anon_sym_LF,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2720), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [45687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2652), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2654), 14,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
  [45712] = 15,
    ACTIONS(2532), 1,
      anon_sym_LPAREN,
    ACTIONS(2536), 1,
      anon_sym_EQ,
    ACTIONS(2538), 1,
      anon_sym_LBRACE,
    ACTIONS(2546), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2550), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_LBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2724), 1,
      anon_sym_SEMI,
    ACTIONS(2726), 1,
      anon_sym_LF,
    STATE(632), 1,
      sym__separator,
    STATE(908), 1,
      sym_tuple_expression,
    ACTIONS(2540), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2548), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [45761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(648), 16,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_GT,
  [45783] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_LF,
    ACTIONS(2728), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(2616), 14,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [45809] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2732), 1,
      anon_sym_COLON,
    ACTIONS(2734), 1,
      anon_sym_LF,
    ACTIONS(2730), 14,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [45835] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_COMMA,
    ACTIONS(2738), 1,
      anon_sym_RBRACE,
    STATE(1475), 1,
      aux_sym__cairo_0_call_expression_repeat1,
    ACTIONS(2730), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2734), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
  [45865] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_LF,
    ACTIONS(2740), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2730), 13,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
  [45891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 16,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_GT,
  [45913] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_COMMA,
    ACTIONS(2746), 1,
      anon_sym_RBRACE,
    STATE(1518), 1,
      aux_sym__cairo_0_call_expression_repeat1,
    ACTIONS(2730), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2734), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
  [45943] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2748), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [45987] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_LF,
    ACTIONS(2750), 1,
      anon_sym_COLON,
    ACTIONS(2730), 14,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_SEMI,
  [46013] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2754), 1,
      anon_sym_LF,
    ACTIONS(2752), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2730), 13,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
  [46039] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2756), 1,
      anon_sym_RBRACK,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [46082] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2758), 1,
      anon_sym_RPAREN,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [46125] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2760), 1,
      anon_sym_RBRACK,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [46168] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2762), 1,
      anon_sym_RBRACK,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [46211] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2764), 1,
      anon_sym_RBRACK,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [46254] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2766), 1,
      anon_sym_RPAREN,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [46297] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2768), 1,
      anon_sym_COMMA,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [46340] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [46383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2730), 3,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2734), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_LBRACK,
      anon_sym_DOT,
  [46408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1391), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1407), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1207), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1411), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1211), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1215), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1231), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1259), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1263), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46728] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2526), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2774), 1,
      anon_sym_BANG_EQ,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [46770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1267), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1271), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1275), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1283), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1295), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [46990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1299), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1415), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1307), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1311), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1423), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1395), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1239), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1243), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47190] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2526), 1,
      anon_sym_EQ_EQ,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2776), 1,
      anon_sym_BANG_EQ,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [47232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1315), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1403), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1171), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1323), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1175), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1179), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1155), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47372] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2778), 1,
      anon_sym_EQ,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [47412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1427), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1187), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47472] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [47512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1431), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1435), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1331), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1335), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1339), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47612] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2526), 1,
      anon_sym_BANG_EQ,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2780), 1,
      anon_sym_EQ_EQ,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [47654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1343), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1347), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1191), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1195), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1355), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1359), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1363), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1375), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [47914] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2782), 1,
      anon_sym_EQ,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2526), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [47954] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    ACTIONS(2514), 1,
      anon_sym_LBRACE,
    ACTIONS(2516), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2518), 1,
      anon_sym_LBRACK,
    ACTIONS(2520), 1,
      anon_sym_DOT,
    ACTIONS(2526), 1,
      anon_sym_BANG_EQ,
    ACTIONS(2564), 1,
      anon_sym_EQ,
    ACTIONS(2566), 1,
      anon_sym_and,
    ACTIONS(2784), 1,
      anon_sym_EQ_EQ,
    STATE(904), 1,
      sym_tuple_expression,
    ACTIONS(2528), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2530), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [47996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [48016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [48036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1379), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [48056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1383), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [48076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1387), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [48096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1251), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [48116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1319), 14,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_struct,
      anon_sym_let,
      anon_sym_const,
      anon_sym_use,
      anon_sym_extern,
      anon_sym_type,
      anon_sym_fn,
      anon_sym_POUND,
      anon_sym_mod,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
  [48136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2786), 3,
      anon_sym_LBRACE,
      anon_sym_of,
      anon_sym_LT,
    ACTIONS(732), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ_GT,
  [48159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(680), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2788), 3,
      anon_sym_LBRACE,
      anon_sym_of,
      anon_sym_LT,
    ACTIONS(682), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ_GT,
  [48182] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LPAREN,
    ACTIONS(2796), 1,
      anon_sym_LBRACE,
    ACTIONS(2798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2800), 1,
      anon_sym_LT,
    STATE(1074), 1,
      sym__cairo_1_type_arguments,
    ACTIONS(2794), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2792), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [48213] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_COLON_COLON,
    STATE(1053), 1,
      sym__cairo_1_type_arguments,
    ACTIONS(2802), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [48238] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    ACTIONS(2810), 1,
      anon_sym_RPAREN,
    STATE(1163), 1,
      sym_named_type,
    STATE(1696), 1,
      sym__cairo_0_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48271] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    ACTIONS(2812), 1,
      anon_sym_RPAREN,
    STATE(1163), 1,
      sym_named_type,
    STATE(1347), 1,
      sym__cairo_0_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48304] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    ACTIONS(2814), 1,
      anon_sym_RPAREN,
    STATE(1163), 1,
      sym_named_type,
    STATE(1455), 1,
      sym__cairo_0_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48337] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    ACTIONS(2816), 1,
      anon_sym_RPAREN,
    STATE(1163), 1,
      sym_named_type,
    STATE(1696), 1,
      sym__cairo_0_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48370] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    ACTIONS(2818), 1,
      anon_sym_RPAREN,
    STATE(1163), 1,
      sym_named_type,
    STATE(1696), 1,
      sym__cairo_0_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48403] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(684), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2820), 3,
      anon_sym_LBRACE,
      anon_sym_of,
      anon_sym_LT,
    ACTIONS(686), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ_GT,
  [48426] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    ACTIONS(2822), 1,
      anon_sym_RPAREN,
    STATE(1163), 1,
      sym_named_type,
    STATE(1696), 1,
      sym__cairo_0_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2824), 1,
      anon_sym_COLON,
    ACTIONS(2820), 12,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
  [48480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(962), 1,
      anon_sym_COLON,
    ACTIONS(964), 11,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [48500] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_LPAREN,
    ACTIONS(2832), 1,
      anon_sym_PERCENT_LBRACE,
    STATE(1339), 1,
      sym_named_type,
    STATE(1471), 1,
      sym__cairo_0_type,
    ACTIONS(2830), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1200), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48530] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    STATE(1163), 1,
      sym_named_type,
    STATE(1741), 1,
      sym__cairo_0_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2836), 1,
      anon_sym_COLON,
    ACTIONS(2834), 11,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [48580] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_LPAREN,
    ACTIONS(2832), 1,
      anon_sym_PERCENT_LBRACE,
    STATE(1338), 1,
      sym__cairo_0_type,
    STATE(1339), 1,
      sym_named_type,
    ACTIONS(2830), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1200), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(958), 1,
      anon_sym_COLON,
    ACTIONS(960), 11,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [48630] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    STATE(1163), 1,
      sym_named_type,
    STATE(1573), 1,
      sym__cairo_0_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48660] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    STATE(1163), 1,
      sym_named_type,
    STATE(1687), 1,
      sym__cairo_0_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48690] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_LPAREN,
    ACTIONS(2832), 1,
      anon_sym_PERCENT_LBRACE,
    STATE(1339), 1,
      sym_named_type,
    STATE(1346), 1,
      sym__cairo_0_type,
    ACTIONS(2830), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1200), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(686), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2824), 1,
      anon_sym_COLON,
    ACTIONS(2820), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_LT,
      anon_sym_GT,
  [48742] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    STATE(1150), 1,
      sym__cairo_0_type,
    STATE(1163), 1,
      sym_named_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48772] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    STATE(1163), 1,
      sym_named_type,
    STATE(1327), 1,
      sym__cairo_0_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(732), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2838), 1,
      anon_sym_COLON,
    ACTIONS(2786), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_LT,
      anon_sym_GT,
  [48824] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    STATE(1163), 1,
      sym_named_type,
    STATE(1696), 1,
      sym__cairo_0_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48854] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    STATE(1163), 1,
      sym_named_type,
    STATE(1306), 1,
      sym__cairo_0_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(954), 1,
      anon_sym_COLON,
    ACTIONS(956), 11,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [48904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_COLON,
    ACTIONS(2840), 11,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [48924] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_LPAREN,
    ACTIONS(2832), 1,
      anon_sym_PERCENT_LBRACE,
    STATE(1339), 1,
      sym_named_type,
    STATE(1450), 1,
      sym__cairo_0_type,
    ACTIONS(2830), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1200), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [48954] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(2846), 1,
      anon_sym_COLON_COLON,
    STATE(1074), 1,
      sym__cairo_1_type_arguments,
    ACTIONS(2844), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_GT,
  [48978] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    STATE(1163), 1,
      sym_named_type,
    STATE(1700), 1,
      sym__cairo_0_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [49008] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 1,
      sym_identifier,
    ACTIONS(2828), 1,
      anon_sym_LPAREN,
    ACTIONS(2832), 1,
      anon_sym_PERCENT_LBRACE,
    STATE(1339), 1,
      sym_named_type,
    STATE(1552), 1,
      sym__cairo_0_type,
    ACTIONS(2830), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1200), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [49038] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    STATE(1163), 1,
      sym_named_type,
    STATE(1781), 1,
      sym__cairo_0_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [49068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_COLON,
    ACTIONS(2848), 11,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [49088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(682), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2852), 1,
      anon_sym_COLON,
    ACTIONS(2788), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_LT,
      anon_sym_GT,
  [49110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_COLON,
    ACTIONS(2854), 11,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [49130] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_LPAREN,
    STATE(1163), 1,
      sym_named_type,
    STATE(1697), 1,
      sym__cairo_0_type,
    ACTIONS(1459), 2,
      anon_sym_felt,
      anon_sym_codeoffset,
    STATE(1104), 5,
      sym__non_identifier_type,
      sym__cairo_0_builtin_type,
      sym__cairo_0_pointer_type,
      sym__cairo_0_tuple_type,
      sym_hint,
  [49160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2802), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [49179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2802), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_GT,
  [49197] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(2862), 1,
      sym_identifier,
    ACTIONS(2864), 1,
      anon_sym_COMMA,
    ACTIONS(2866), 1,
      anon_sym_RBRACE,
    ACTIONS(2868), 1,
      anon_sym_DOT_DOT,
    STATE(1293), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1657), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [49225] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(2862), 1,
      sym_identifier,
    ACTIONS(2868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2870), 1,
      anon_sym_COMMA,
    ACTIONS(2872), 1,
      anon_sym_RBRACE,
    STATE(1293), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1657), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [49253] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(2862), 1,
      sym_identifier,
    ACTIONS(2868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2874), 1,
      anon_sym_COMMA,
    ACTIONS(2876), 1,
      anon_sym_RBRACE,
    STATE(1293), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1438), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [49281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2878), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [49297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2880), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [49313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2882), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [49329] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2888), 1,
      anon_sym_LBRACE,
    ACTIONS(2890), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2886), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2884), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49351] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(2862), 1,
      sym_identifier,
    ACTIONS(2868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2892), 1,
      anon_sym_COMMA,
    ACTIONS(2894), 1,
      anon_sym_RBRACE,
    STATE(1293), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1657), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [49379] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(2862), 1,
      sym_identifier,
    ACTIONS(2868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2896), 1,
      anon_sym_COMMA,
    ACTIONS(2898), 1,
      anon_sym_RBRACE,
    STATE(1293), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1387), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [49407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2900), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [49423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2902), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [49439] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(2862), 1,
      sym_identifier,
    ACTIONS(2868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2904), 1,
      anon_sym_COMMA,
    ACTIONS(2906), 1,
      anon_sym_RBRACE,
    STATE(1293), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1657), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [49467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2908), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [49483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LPAREN,
    ACTIONS(2910), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2794), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(2792), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2912), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [49521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2914), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_implicits,
      anon_sym_nopanic,
      anon_sym_of,
      anon_sym_GT,
  [49537] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(2846), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2918), 1,
      anon_sym_COLON,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2922), 1,
      anon_sym_STAR_STAR,
    STATE(1074), 1,
      sym__cairo_1_type_arguments,
    ACTIONS(2916), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [49564] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_AT,
    ACTIONS(2924), 1,
      anon_sym_namespace,
    ACTIONS(2926), 1,
      anon_sym_struct,
    ACTIONS(2928), 1,
      anon_sym_func,
    STATE(1166), 2,
      sym_decorator,
      aux_sym__cairo_0_decorated_definition_repeat1,
    STATE(622), 3,
      sym__cairo_0_namespace_definition,
      sym__cairo_0_struct_definition,
      sym__cairo_0_function_definition,
  [49589] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(19), 1,
      anon_sym_AT,
    ACTIONS(2930), 1,
      anon_sym_namespace,
    ACTIONS(2932), 1,
      anon_sym_struct,
    ACTIONS(2934), 1,
      anon_sym_func,
    STATE(1166), 2,
      sym_decorator,
      aux_sym__cairo_0_decorated_definition_repeat1,
    STATE(543), 3,
      sym__cairo_0_namespace_definition,
      sym__cairo_0_struct_definition,
      sym__cairo_0_function_definition,
  [49614] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(2936), 1,
      sym_identifier,
    ACTIONS(2938), 1,
      anon_sym_COMMA,
    ACTIONS(2940), 1,
      anon_sym_RBRACE,
    STATE(1358), 1,
      sym_typed_identifier,
    STATE(1360), 1,
      sym_field_declaration,
    STATE(1242), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [49643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_EQ,
    ACTIONS(2942), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 1,
      anon_sym_STAR,
    ACTIONS(2946), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_STAR,
  [49675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 1,
      anon_sym_EQ,
    ACTIONS(2950), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2956), 1,
      anon_sym_EQ,
    ACTIONS(2954), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2960), 1,
      anon_sym_EQ,
    ACTIONS(2958), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2964), 1,
      anon_sym_STAR,
    ACTIONS(2962), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_STAR,
  [49739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2922), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2966), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [49757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2970), 1,
      anon_sym_EQ,
    ACTIONS(2968), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2974), 1,
      anon_sym_EQ,
    ACTIONS(2972), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49789] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LPAREN,
    ACTIONS(2796), 1,
      anon_sym_LBRACE,
    ACTIONS(2798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(2979), 1,
      anon_sym_COLON,
    STATE(1074), 1,
      sym__cairo_1_type_arguments,
    ACTIONS(2976), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [49815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 1,
      anon_sym_EQ,
    ACTIONS(2981), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2987), 1,
      anon_sym_EQ,
    ACTIONS(2985), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_STAR,
    ACTIONS(2989), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_STAR,
  [49863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2995), 1,
      anon_sym_EQ,
    ACTIONS(2993), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2999), 1,
      anon_sym_EQ,
    ACTIONS(2997), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 1,
      anon_sym_EQ,
    ACTIONS(3001), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3007), 1,
      anon_sym_EQ,
    ACTIONS(3005), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3011), 1,
      anon_sym_EQ,
    ACTIONS(3009), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 1,
      anon_sym_EQ,
    ACTIONS(3013), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_EQ,
    ACTIONS(3017), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [49975] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2922), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3021), 1,
      anon_sym_COLON,
    ACTIONS(2916), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [49995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3025), 1,
      anon_sym_EQ,
    ACTIONS(3023), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [50011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3029), 1,
      anon_sym_EQ,
    ACTIONS(3027), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [50027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3033), 1,
      anon_sym_EQ,
    ACTIONS(3031), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [50043] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LPAREN,
    ACTIONS(2792), 1,
      anon_sym_SEMI,
    ACTIONS(2796), 1,
      anon_sym_LBRACE,
    ACTIONS(2798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(2976), 1,
      anon_sym_EQ,
    ACTIONS(3035), 1,
      anon_sym_COLON,
    STATE(1074), 1,
      sym__cairo_1_type_arguments,
  [50071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3040), 1,
      anon_sym_EQ,
    ACTIONS(3038), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [50087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_STAR,
    ACTIONS(3042), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_STAR,
  [50103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3048), 1,
      anon_sym_STAR,
    ACTIONS(3046), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_STAR,
  [50119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 1,
      anon_sym_EQ,
    ACTIONS(2792), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [50135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3052), 1,
      anon_sym_STAR,
    ACTIONS(3050), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR_STAR,
  [50151] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(2862), 1,
      sym_identifier,
    ACTIONS(2868), 1,
      anon_sym_DOT_DOT,
    STATE(1293), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1657), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [50173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_EQ,
    ACTIONS(3054), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
  [50189] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3058), 1,
      sym_identifier,
    ACTIONS(3060), 1,
      anon_sym_COMMA,
    ACTIONS(3062), 1,
      anon_sym_RBRACE,
    STATE(1703), 1,
      sym_field_declaration,
    STATE(1207), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50212] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3064), 1,
      sym_identifier,
    ACTIONS(3066), 1,
      anon_sym_COMMA,
    ACTIONS(3068), 1,
      anon_sym_RBRACE,
    STATE(1343), 1,
      sym_enum_variant,
    STATE(1226), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50235] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_LBRACE,
    ACTIONS(3072), 1,
      anon_sym_COLON,
    ACTIONS(3074), 1,
      anon_sym_SEMI,
    ACTIONS(3076), 1,
      anon_sym_LT2,
    STATE(323), 1,
      sym_declaration_list,
    STATE(1227), 1,
      sym_type_parameters,
    STATE(1521), 1,
      sym_trait_bounds,
  [50260] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3058), 1,
      sym_identifier,
    ACTIONS(3078), 1,
      anon_sym_COMMA,
    ACTIONS(3080), 1,
      anon_sym_RBRACE,
    STATE(1551), 1,
      sym_field_declaration,
    STATE(1220), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50283] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3058), 1,
      sym_identifier,
    ACTIONS(3082), 1,
      anon_sym_COMMA,
    ACTIONS(3084), 1,
      anon_sym_RBRACE,
    STATE(1703), 1,
      sym_field_declaration,
    STATE(1207), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50306] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3058), 1,
      sym_identifier,
    ACTIONS(3086), 1,
      anon_sym_COMMA,
    ACTIONS(3088), 1,
      anon_sym_RBRACE,
    STATE(1703), 1,
      sym_field_declaration,
    STATE(1207), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50329] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3064), 1,
      sym_identifier,
    ACTIONS(3090), 1,
      anon_sym_COMMA,
    ACTIONS(3092), 1,
      anon_sym_RBRACE,
    STATE(1690), 1,
      sym_enum_variant,
    STATE(1192), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50352] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3064), 1,
      sym_identifier,
    ACTIONS(3094), 1,
      anon_sym_COMMA,
    ACTIONS(3096), 1,
      anon_sym_RBRACE,
    STATE(1690), 1,
      sym_enum_variant,
    STATE(1192), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50375] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3064), 1,
      sym_identifier,
    ACTIONS(3098), 1,
      anon_sym_COMMA,
    ACTIONS(3100), 1,
      anon_sym_RBRACE,
    STATE(1690), 1,
      sym_enum_variant,
    STATE(1192), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50398] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3058), 1,
      sym_identifier,
    ACTIONS(3102), 1,
      anon_sym_COMMA,
    ACTIONS(3104), 1,
      anon_sym_RBRACE,
    STATE(1703), 1,
      sym_field_declaration,
    STATE(1207), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50421] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3064), 1,
      sym_identifier,
    ACTIONS(3106), 1,
      anon_sym_COMMA,
    ACTIONS(3108), 1,
      anon_sym_RBRACE,
    STATE(1553), 1,
      sym_enum_variant,
    STATE(1239), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50444] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(2938), 1,
      anon_sym_COMMA,
    ACTIONS(3058), 1,
      sym_identifier,
    ACTIONS(3110), 1,
      anon_sym_RBRACE,
    STATE(1360), 1,
      sym_field_declaration,
    STATE(1242), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50467] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3064), 1,
      sym_identifier,
    ACTIONS(3112), 1,
      anon_sym_COMMA,
    ACTIONS(3114), 1,
      anon_sym_RBRACE,
    STATE(1690), 1,
      sym_enum_variant,
    STATE(1192), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50490] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3058), 1,
      sym_identifier,
    ACTIONS(3116), 1,
      anon_sym_COMMA,
    ACTIONS(3118), 1,
      anon_sym_RBRACE,
    STATE(1703), 1,
      sym_field_declaration,
    STATE(1207), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50513] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3072), 1,
      anon_sym_COLON,
    ACTIONS(3076), 1,
      anon_sym_LT2,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3122), 1,
      anon_sym_SEMI,
    STATE(1008), 1,
      sym_declaration_list,
    STATE(1190), 1,
      sym_type_parameters,
    STATE(1495), 1,
      sym_trait_bounds,
  [50538] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3058), 1,
      sym_identifier,
    ACTIONS(3124), 1,
      anon_sym_COMMA,
    ACTIONS(3126), 1,
      anon_sym_RBRACE,
    STATE(1703), 1,
      sym_field_declaration,
    STATE(1207), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50561] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3064), 1,
      sym_identifier,
    ACTIONS(3128), 1,
      anon_sym_COMMA,
    ACTIONS(3130), 1,
      anon_sym_RBRACE,
    STATE(1690), 1,
      sym_enum_variant,
    STATE(1192), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50584] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3064), 1,
      sym_identifier,
    ACTIONS(3132), 1,
      anon_sym_COMMA,
    ACTIONS(3134), 1,
      anon_sym_RBRACE,
    STATE(1690), 1,
      sym_enum_variant,
    STATE(1192), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [50607] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3138), 1,
      anon_sym_RPAREN,
    STATE(1675), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [50625] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_RPAREN,
    STATE(1675), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [50643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3144), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [50655] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3146), 1,
      anon_sym_RPAREN,
    STATE(1542), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [50673] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 1,
      anon_sym_RPAREN,
    STATE(1675), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [50691] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(3150), 1,
      sym_identifier,
    ACTIONS(3152), 1,
      anon_sym_const,
    ACTIONS(3154), 1,
      anon_sym_GT,
    STATE(1713), 2,
      sym_abstract_type,
      sym_constrained_type_parameter,
  [50711] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(3150), 1,
      sym_identifier,
    ACTIONS(3152), 1,
      anon_sym_const,
    ACTIONS(3156), 1,
      anon_sym_GT,
    STATE(1713), 2,
      sym_abstract_type,
      sym_constrained_type_parameter,
  [50731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3158), 1,
      anon_sym_DOT,
    STATE(1155), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(1516), 4,
      anon_sym_import,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [50747] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_RPAREN,
    STATE(1675), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [50765] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_RPAREN,
    STATE(1675), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [50783] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_RPAREN,
    STATE(1675), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [50801] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3167), 1,
      sym_identifier,
    ACTIONS(3169), 1,
      anon_sym_COMMA,
    ACTIONS(3171), 1,
      anon_sym_RBRACE,
    ACTIONS(3173), 1,
      anon_sym_ref,
    ACTIONS(3175), 1,
      anon_sym_mut,
    STATE(1579), 1,
      sym_field_pattern,
  [50823] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3177), 1,
      anon_sym_RPAREN,
    STATE(1675), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [50841] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3167), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_ref,
    ACTIONS(3175), 1,
      anon_sym_mut,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3181), 1,
      anon_sym_RBRACE,
    STATE(1492), 1,
      sym_field_pattern,
  [50863] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3167), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_ref,
    ACTIONS(3175), 1,
      anon_sym_mut,
    ACTIONS(3183), 1,
      anon_sym_COMMA,
    ACTIONS(3185), 1,
      anon_sym_RBRACE,
    STATE(1579), 1,
      sym_field_pattern,
  [50885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2966), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [50897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_DOT,
    STATE(1175), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(1506), 4,
      anon_sym_import,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [50913] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3167), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_ref,
    ACTIONS(3175), 1,
      anon_sym_mut,
    ACTIONS(3189), 1,
      anon_sym_COMMA,
    ACTIONS(3191), 1,
      anon_sym_RBRACE,
    STATE(1579), 1,
      sym_field_pattern,
  [50935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3193), 1,
      anon_sym_AT,
    STATE(1166), 2,
      sym_decorator,
      aux_sym__cairo_0_decorated_definition_repeat1,
    ACTIONS(3196), 3,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
  [50951] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3198), 1,
      anon_sym_RPAREN,
    STATE(1514), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [50969] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3167), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_ref,
    ACTIONS(3175), 1,
      anon_sym_mut,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    ACTIONS(3202), 1,
      anon_sym_RBRACE,
    STATE(1579), 1,
      sym_field_pattern,
  [50991] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3204), 1,
      anon_sym_RPAREN,
    STATE(1464), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [51009] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_RPAREN,
    STATE(1525), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [51027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3208), 1,
      anon_sym_RPAREN,
    STATE(1510), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [51045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3210), 1,
      anon_sym_RPAREN,
    STATE(1675), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [51063] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(3150), 1,
      sym_identifier,
    ACTIONS(3152), 1,
      anon_sym_const,
    ACTIONS(3212), 1,
      anon_sym_GT,
    STATE(1713), 2,
      sym_abstract_type,
      sym_constrained_type_parameter,
  [51083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 1,
      anon_sym_RPAREN,
    STATE(1675), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [51101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_DOT,
    STATE(1155), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(1512), 4,
      anon_sym_import,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [51117] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 1,
      anon_sym_RPAREN,
    STATE(1675), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [51135] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3167), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_ref,
    ACTIONS(3175), 1,
      anon_sym_mut,
    ACTIONS(3218), 1,
      anon_sym_COMMA,
    ACTIONS(3220), 1,
      anon_sym_RBRACE,
    STATE(1456), 1,
      sym_field_pattern,
  [51157] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(3150), 1,
      sym_identifier,
    ACTIONS(3152), 1,
      anon_sym_const,
    ACTIONS(3222), 1,
      anon_sym_GT,
    STATE(1713), 2,
      sym_abstract_type,
      sym_constrained_type_parameter,
  [51177] = 5,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2916), 1,
      anon_sym_LF,
    ACTIONS(3226), 1,
      anon_sym_COLON,
    ACTIONS(3224), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
    ACTIONS(3228), 2,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
  [51195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2989), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2991), 1,
      anon_sym_STAR,
    ACTIONS(3230), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [51210] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3072), 1,
      anon_sym_COLON,
    ACTIONS(3233), 1,
      anon_sym_COMMA,
    ACTIONS(3235), 1,
      anon_sym_GT,
    STATE(1546), 1,
      aux_sym_type_parameters_repeat1,
    STATE(1667), 1,
      sym_trait_bounds,
  [51229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3239), 1,
      anon_sym_RPAREN,
    ACTIONS(3241), 1,
      anon_sym_COMMA,
    STATE(1392), 1,
      sym_typed_identifier,
  [51248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3245), 1,
      anon_sym_as,
    ACTIONS(3247), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3243), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [51263] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 1,
      anon_sym_LBRACE,
    ACTIONS(3251), 1,
      anon_sym_DASH_GT,
    ACTIONS(3253), 1,
      anon_sym_SEMI,
    ACTIONS(3255), 1,
      anon_sym_implicits,
    ACTIONS(3257), 1,
      anon_sym_nopanic,
  [51282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1675), 1,
      sym_parameter,
    ACTIONS(3136), 2,
      sym_identifier,
      sym_self,
    ACTIONS(3140), 2,
      anon_sym_ref,
      anon_sym_mut,
  [51297] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 1,
      anon_sym_LBRACE,
    ACTIONS(3255), 1,
      anon_sym_implicits,
    ACTIONS(3259), 1,
      anon_sym_DASH_GT,
    ACTIONS(3261), 1,
      anon_sym_SEMI,
    ACTIONS(3263), 1,
      anon_sym_nopanic,
  [51316] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 1,
      anon_sym_SEMI,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3267), 1,
      anon_sym_DASH_GT,
    ACTIONS(3269), 1,
      anon_sym_implicits,
    ACTIONS(3271), 1,
      anon_sym_nopanic,
  [51335] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(2846), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3273), 1,
      anon_sym_COLON,
    STATE(1074), 1,
      sym__cairo_1_type_arguments,
    STATE(1088), 1,
      sym_trait_bounds,
  [51354] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3253), 1,
      anon_sym_SEMI,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3269), 1,
      anon_sym_implicits,
    ACTIONS(3275), 1,
      anon_sym_DASH_GT,
    ACTIONS(3277), 1,
      anon_sym_nopanic,
  [51373] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3072), 1,
      anon_sym_COLON,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3279), 1,
      anon_sym_SEMI,
    STATE(996), 1,
      sym_declaration_list,
    STATE(1440), 1,
      sym_trait_bounds,
  [51392] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(3152), 1,
      anon_sym_const,
    ACTIONS(3281), 1,
      sym_identifier,
    STATE(1367), 2,
      sym_abstract_type,
      sym_constrained_type_parameter,
  [51409] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3064), 1,
      sym_identifier,
    STATE(1626), 1,
      sym_enum_variant,
    STATE(1320), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [51426] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3283), 1,
      anon_sym_LPAREN,
    STATE(1749), 2,
      sym__ref_binding,
      sym_typed_identifier,
  [51443] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 1,
      anon_sym_LBRACE,
    ACTIONS(3255), 1,
      anon_sym_implicits,
    ACTIONS(3285), 1,
      anon_sym_DASH_GT,
    ACTIONS(3287), 1,
      anon_sym_SEMI,
    ACTIONS(3289), 1,
      anon_sym_nopanic,
  [51462] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3291), 1,
      anon_sym_RPAREN,
    ACTIONS(3293), 1,
      anon_sym_COMMA,
    STATE(1382), 1,
      sym_typed_identifier,
  [51481] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3064), 1,
      sym_identifier,
    STATE(1690), 1,
      sym_enum_variant,
    STATE(1192), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [51498] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3042), 1,
      anon_sym_LF,
    ACTIONS(3044), 4,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_SEMI,
  [51511] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3050), 1,
      anon_sym_LF,
    ACTIONS(3052), 4,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_SEMI,
  [51524] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2130), 1,
      anon_sym_LBRACE,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(3295), 1,
      sym_identifier,
    STATE(1488), 1,
      sym_use_list,
    STATE(1881), 1,
      sym__cairo_1_type_arguments,
  [51543] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2966), 1,
      anon_sym_LF,
    ACTIONS(3228), 2,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
    ACTIONS(3297), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
  [51558] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_LT2,
    ACTIONS(3299), 1,
      anon_sym_LBRACE,
    ACTIONS(3301), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_field_declaration_list,
    STATE(1473), 1,
      sym_type_parameters,
  [51577] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3058), 1,
      sym_identifier,
    STATE(1703), 1,
      sym_field_declaration,
    STATE(1207), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [51594] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3273), 1,
      anon_sym_COLON,
    STATE(1053), 1,
      sym__cairo_1_type_arguments,
    STATE(1092), 1,
      sym_trait_bounds,
  [51613] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3303), 1,
      sym_identifier,
    ACTIONS(3305), 1,
      anon_sym_LPAREN,
    STATE(439), 1,
      sym_dotted_name,
    STATE(502), 1,
      sym_aliased_import,
    STATE(607), 1,
      sym__import_list,
  [51632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3307), 5,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
  [51643] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 1,
      anon_sym_impl,
    ACTIONS(3150), 1,
      sym_identifier,
    ACTIONS(3152), 1,
      anon_sym_const,
    STATE(1713), 2,
      sym_abstract_type,
      sym_constrained_type_parameter,
  [51660] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3058), 1,
      sym_identifier,
    STATE(1699), 1,
      sym_field_declaration,
    STATE(1320), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [51677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3309), 5,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
  [51688] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3311), 1,
      sym_identifier,
    ACTIONS(3313), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      sym_dotted_name,
    STATE(441), 1,
      sym_aliased_import,
    STATE(589), 1,
      sym__import_list,
  [51707] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_LBRACE,
    ACTIONS(3317), 1,
      anon_sym_DASH_GT,
    ACTIONS(3319), 1,
      anon_sym_SEMI,
    ACTIONS(3321), 1,
      anon_sym_implicits,
    ACTIONS(3323), 1,
      anon_sym_nopanic,
  [51726] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2989), 1,
      anon_sym_LF,
    ACTIONS(2991), 4,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_SEMI,
  [51739] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      anon_sym_SEMI,
    ACTIONS(3325), 1,
      anon_sym_LBRACE,
    ACTIONS(3327), 1,
      anon_sym_DASH_GT,
    ACTIONS(3329), 1,
      anon_sym_implicits,
    ACTIONS(3331), 1,
      anon_sym_nopanic,
  [51758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3245), 1,
      anon_sym_as,
    ACTIONS(3333), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3243), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [51773] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3283), 1,
      anon_sym_LPAREN,
    STATE(1826), 2,
      sym__ref_binding,
      sym_typed_identifier,
  [51790] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_LT2,
    ACTIONS(3335), 1,
      anon_sym_LBRACE,
    ACTIONS(3337), 1,
      anon_sym_SEMI,
    STATE(388), 1,
      sym_field_declaration_list,
    STATE(1449), 1,
      sym_type_parameters,
  [51809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3341), 1,
      anon_sym_as,
    ACTIONS(3343), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3339), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [51824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 5,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
  [51835] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(2846), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3347), 1,
      anon_sym_COLON,
    STATE(1074), 1,
      sym__cairo_1_type_arguments,
    STATE(1088), 1,
      sym_trait_bounds,
  [51854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3347), 1,
      anon_sym_COLON,
    STATE(1053), 1,
      sym__cairo_1_type_arguments,
    STATE(1092), 1,
      sym_trait_bounds,
  [51873] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3058), 1,
      sym_identifier,
    STATE(1352), 1,
      sym_field_declaration,
    STATE(1320), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [51890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3351), 1,
      anon_sym_COLON,
    ACTIONS(3349), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [51903] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_LT2,
    ACTIONS(3301), 1,
      anon_sym_SEMI,
    ACTIONS(3353), 1,
      anon_sym_LBRACE,
    STATE(969), 1,
      sym_field_declaration_list,
    STATE(1473), 1,
      sym_type_parameters,
  [51922] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3325), 1,
      anon_sym_LBRACE,
    ACTIONS(3329), 1,
      anon_sym_implicits,
    ACTIONS(3355), 1,
      anon_sym_DASH_GT,
    ACTIONS(3357), 1,
      anon_sym_SEMI,
    ACTIONS(3359), 1,
      anon_sym_nopanic,
  [51941] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2130), 1,
      anon_sym_LBRACE,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(3295), 1,
      sym_identifier,
    STATE(1488), 1,
      sym_use_list,
    STATE(1789), 1,
      sym__cairo_1_type_arguments,
  [51960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3363), 1,
      anon_sym_COLON,
    ACTIONS(3361), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [51973] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3064), 1,
      sym_identifier,
    STATE(1375), 1,
      sym_enum_variant,
    STATE(1320), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [51990] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_LBRACE,
    ACTIONS(3072), 1,
      anon_sym_COLON,
    ACTIONS(3365), 1,
      anon_sym_SEMI,
    STATE(337), 1,
      sym_declaration_list,
    STATE(1345), 1,
      sym_trait_bounds,
  [52009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3367), 5,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
  [52020] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3325), 1,
      anon_sym_LBRACE,
    ACTIONS(3329), 1,
      anon_sym_implicits,
    ACTIONS(3369), 1,
      anon_sym_DASH_GT,
    ACTIONS(3371), 1,
      anon_sym_SEMI,
    ACTIONS(3373), 1,
      anon_sym_nopanic,
  [52039] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3269), 1,
      anon_sym_implicits,
    ACTIONS(3375), 1,
      anon_sym_DASH_GT,
    ACTIONS(3377), 1,
      anon_sym_SEMI,
    ACTIONS(3379), 1,
      anon_sym_nopanic,
  [52058] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_LBRACE,
    ACTIONS(3321), 1,
      anon_sym_implicits,
    ACTIONS(3377), 1,
      anon_sym_SEMI,
    ACTIONS(3381), 1,
      anon_sym_DASH_GT,
    ACTIONS(3383), 1,
      anon_sym_nopanic,
  [52077] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3385), 1,
      anon_sym_RPAREN,
    ACTIONS(3387), 1,
      anon_sym_COMMA,
    STATE(1392), 1,
      sym_typed_identifier,
  [52096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 5,
      anon_sym_import,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_DOT,
  [52107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 5,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
  [52118] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2962), 1,
      anon_sym_LF,
    ACTIONS(2964), 4,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_SEMI,
  [52131] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3269), 1,
      anon_sym_implicits,
    ACTIONS(3391), 1,
      anon_sym_DASH_GT,
    ACTIONS(3393), 1,
      anon_sym_SEMI,
    ACTIONS(3395), 1,
      anon_sym_nopanic,
  [52150] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3245), 1,
      anon_sym_as,
    ACTIONS(3397), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3243), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [52165] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3046), 1,
      anon_sym_LF,
    ACTIONS(3048), 4,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_SEMI,
  [52178] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3064), 1,
      sym_identifier,
    STATE(1405), 1,
      sym_enum_variant,
    STATE(1320), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [52195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3399), 5,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
  [52206] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3325), 1,
      anon_sym_LBRACE,
    ACTIONS(3329), 1,
      anon_sym_implicits,
    ACTIONS(3401), 1,
      anon_sym_DASH_GT,
    ACTIONS(3403), 1,
      anon_sym_SEMI,
    ACTIONS(3405), 1,
      anon_sym_nopanic,
  [52225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3058), 1,
      sym_identifier,
    STATE(1528), 1,
      sym_field_declaration,
    STATE(1320), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [52242] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_LBRACE,
    ACTIONS(3321), 1,
      anon_sym_implicits,
    ACTIONS(3371), 1,
      anon_sym_SEMI,
    ACTIONS(3407), 1,
      anon_sym_DASH_GT,
    ACTIONS(3409), 1,
      anon_sym_nopanic,
  [52261] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_LBRACE,
    ACTIONS(3321), 1,
      anon_sym_implicits,
    ACTIONS(3393), 1,
      anon_sym_SEMI,
    ACTIONS(3411), 1,
      anon_sym_DASH_GT,
    ACTIONS(3413), 1,
      anon_sym_nopanic,
  [52280] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 1,
      anon_sym_LBRACE,
    ACTIONS(3255), 1,
      anon_sym_implicits,
    ACTIONS(3415), 1,
      anon_sym_DASH_GT,
    ACTIONS(3417), 1,
      anon_sym_SEMI,
    ACTIONS(3419), 1,
      anon_sym_nopanic,
  [52299] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2946), 1,
      anon_sym_LF,
    ACTIONS(2948), 4,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_STAR_STAR,
      anon_sym_SEMI,
  [52312] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3349), 1,
      anon_sym_LF,
    ACTIONS(3423), 1,
      anon_sym_COLON,
    ACTIONS(3421), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
  [52326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(2844), 1,
      anon_sym_of,
    STATE(1074), 1,
      sym__cairo_1_type_arguments,
  [52342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1558), 1,
      anon_sym_RPAREN,
    ACTIONS(3425), 1,
      anon_sym_COMMA,
    ACTIONS(3427), 1,
      anon_sym_as,
    STATE(1539), 1,
      aux_sym__import_list_repeat1,
  [52358] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3429), 1,
      anon_sym_RBRACE,
    STATE(1383), 1,
      sym_typed_identifier,
  [52374] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_LBRACE,
    ACTIONS(3433), 1,
      anon_sym_SEMI,
    ACTIONS(3435), 1,
      anon_sym_implicits,
    ACTIONS(3437), 1,
      anon_sym_nopanic,
  [52390] = 5,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_COMMA,
    ACTIONS(3441), 1,
      anon_sym_SEMI,
    ACTIONS(3443), 1,
      anon_sym_LF,
    STATE(546), 1,
      sym__separator,
  [52406] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3445), 1,
      anon_sym_PERCENT_RBRACE,
    ACTIONS(3447), 1,
      sym_code_line,
    STATE(1536), 1,
      aux_sym_python_code_repeat1,
    STATE(1722), 1,
      sym_python_code,
  [52422] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_LT2,
    ACTIONS(3449), 1,
      anon_sym_LBRACE,
    STATE(314), 1,
      sym_enum_variant_list,
    STATE(1575), 1,
      sym_type_parameters,
  [52438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_LT2,
    ACTIONS(3451), 1,
      anon_sym_LPAREN,
    STATE(1691), 1,
      sym__function_signature,
    STATE(1692), 1,
      sym_type_parameters,
  [52454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 1,
      anon_sym_COMMA,
    STATE(1256), 1,
      aux_sym__cairo_0_with_statement_repeat1,
    ACTIONS(3453), 2,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
  [52468] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_RBRACK,
    ACTIONS(3462), 1,
      anon_sym_COLON_COLON,
    STATE(1907), 1,
      sym_attribute_arguments,
  [52484] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3464), 1,
      anon_sym_RBRACK,
    STATE(1910), 1,
      sym_attribute_arguments,
  [52500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_RBRACK,
    STATE(1907), 1,
      sym_attribute_arguments,
  [52516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3460), 1,
      anon_sym_RBRACK,
    ACTIONS(3466), 1,
      anon_sym_COLON_COLON,
    STATE(1907), 1,
      sym_attribute_arguments,
  [52532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3468), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_typed_identifier,
  [52548] = 5,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COMMA,
    ACTIONS(3472), 1,
      anon_sym_SEMI,
    ACTIONS(3474), 1,
      anon_sym_LF,
    STATE(649), 1,
      sym__separator,
  [52564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3072), 1,
      anon_sym_COLON,
    STATE(1667), 1,
      sym_trait_bounds,
    ACTIONS(3476), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [52578] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3167), 1,
      sym_identifier,
    ACTIONS(3173), 1,
      anon_sym_ref,
    ACTIONS(3175), 1,
      anon_sym_mut,
    STATE(1579), 1,
      sym_field_pattern,
  [52594] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_LBRACE,
    ACTIONS(3435), 1,
      anon_sym_implicits,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3480), 1,
      anon_sym_nopanic,
  [52610] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3482), 1,
      anon_sym_RBRACE,
    STATE(1548), 1,
      sym_typed_identifier,
  [52626] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3484), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_typed_identifier,
  [52642] = 5,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3486), 1,
      anon_sym_EQ,
    ACTIONS(3488), 1,
      anon_sym_SEMI,
    ACTIONS(3490), 1,
      anon_sym_LF,
    STATE(570), 1,
      sym__separator,
  [52658] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    ACTIONS(3492), 1,
      anon_sym_if,
    STATE(480), 1,
      sym_block,
    STATE(481), 1,
      sym__cairo_1_if_expression,
  [52674] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3494), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_typed_identifier,
  [52690] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3496), 1,
      anon_sym_RBRACE,
    STATE(1358), 1,
      sym_typed_identifier,
  [52706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3498), 4,
      anon_sym_AT,
      anon_sym_namespace,
      anon_sym_struct,
      anon_sym_func,
  [52716] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3500), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_typed_identifier,
  [52732] = 5,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3502), 1,
      anon_sym_EQ,
    ACTIONS(3504), 1,
      anon_sym_SEMI,
    ACTIONS(3506), 1,
      anon_sym_LF,
    STATE(572), 1,
      sym__separator,
  [52748] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3508), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_typed_identifier,
  [52764] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_LT2,
    ACTIONS(3510), 1,
      anon_sym_LBRACE,
    STATE(1004), 1,
      sym_enum_variant_list,
    STATE(1708), 1,
      sym_type_parameters,
  [52780] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 1,
      anon_sym_LBRACE,
    ACTIONS(3514), 1,
      anon_sym_SEMI,
    ACTIONS(3516), 1,
      anon_sym_implicits,
    ACTIONS(3518), 1,
      anon_sym_nopanic,
  [52796] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 1,
      anon_sym_SEMI,
    ACTIONS(3269), 1,
      anon_sym_implicits,
    ACTIONS(3520), 1,
      anon_sym_DASH_GT,
    ACTIONS(3522), 1,
      anon_sym_nopanic,
  [52812] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3524), 1,
      anon_sym_RPAREN,
    STATE(1392), 1,
      sym_typed_identifier,
  [52828] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3526), 1,
      anon_sym_LBRACE,
    ACTIONS(3528), 1,
      anon_sym_SEMI,
    ACTIONS(3530), 1,
      anon_sym_implicits,
    ACTIONS(3532), 1,
      anon_sym_nopanic,
  [52844] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    ACTIONS(3534), 1,
      anon_sym_if,
    STATE(143), 1,
      sym_block,
    STATE(144), 1,
      sym__cairo_1_if_expression,
  [52860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3538), 1,
      anon_sym_COMMA,
    STATE(1282), 1,
      aux_sym__cairo_0_struct_definition_repeat1,
    ACTIONS(3536), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [52874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 1,
      anon_sym_LBRACE,
    ACTIONS(3516), 1,
      anon_sym_implicits,
    ACTIONS(3528), 1,
      anon_sym_SEMI,
    ACTIONS(3541), 1,
      anon_sym_nopanic,
  [52890] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3526), 1,
      anon_sym_LBRACE,
    ACTIONS(3530), 1,
      anon_sym_implicits,
    ACTIONS(3543), 1,
      anon_sym_SEMI,
    ACTIONS(3545), 1,
      anon_sym_nopanic,
  [52906] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 1,
      anon_sym_LBRACE,
    ACTIONS(3516), 1,
      anon_sym_implicits,
    ACTIONS(3543), 1,
      anon_sym_SEMI,
    ACTIONS(3547), 1,
      anon_sym_nopanic,
  [52922] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3549), 1,
      anon_sym_RPAREN,
    STATE(1392), 1,
      sym_typed_identifier,
  [52938] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_LT2,
    ACTIONS(3551), 1,
      anon_sym_LPAREN,
    STATE(1705), 1,
      sym_type_parameters,
    STATE(1902), 1,
      sym__function_signature,
  [52954] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 1,
      anon_sym_LPAREN,
    ACTIONS(3555), 1,
      anon_sym_LBRACE,
    STATE(1357), 1,
      sym_arguments,
    STATE(1663), 1,
      sym_implicit_arguments,
  [52970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(2804), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2888), 1,
      anon_sym_LBRACE,
    STATE(1053), 1,
      sym__cairo_1_type_arguments,
  [52986] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3557), 1,
      anon_sym_RBRACK,
    STATE(1853), 1,
      sym_attribute_arguments,
  [53002] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3559), 1,
      sym_identifier,
    STATE(1249), 1,
      sym_dotted_name,
    STATE(1497), 1,
      sym_aliased_import,
    STATE(1878), 1,
      sym__import_list,
  [53018] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3526), 1,
      anon_sym_LBRACE,
    ACTIONS(3530), 1,
      anon_sym_implicits,
    ACTIONS(3561), 1,
      anon_sym_SEMI,
    ACTIONS(3563), 1,
      anon_sym_nopanic,
  [53034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(256), 1,
      anon_sym_POUND,
    ACTIONS(3565), 1,
      sym_identifier,
    STATE(1320), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [53048] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3567), 1,
      anon_sym_RBRACK,
    STATE(1940), 1,
      sym_attribute_arguments,
  [53064] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3557), 1,
      anon_sym_RBRACK,
    STATE(1853), 1,
      sym_attribute_arguments,
  [53080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3557), 1,
      anon_sym_RBRACK,
    STATE(1853), 1,
      sym_attribute_arguments,
  [53096] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_LBRACE,
    ACTIONS(3435), 1,
      anon_sym_implicits,
    ACTIONS(3569), 1,
      anon_sym_SEMI,
    ACTIONS(3571), 1,
      anon_sym_nopanic,
  [53112] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_SEMI,
    ACTIONS(3573), 1,
      anon_sym_LBRACE,
    ACTIONS(3575), 1,
      anon_sym_implicits,
    ACTIONS(3577), 1,
      anon_sym_nopanic,
  [53128] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3325), 1,
      anon_sym_SEMI,
    ACTIONS(3329), 1,
      anon_sym_implicits,
    ACTIONS(3579), 1,
      anon_sym_DASH_GT,
    ACTIONS(3581), 1,
      anon_sym_nopanic,
  [53144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_LBRACE,
    ACTIONS(3435), 1,
      anon_sym_implicits,
    ACTIONS(3583), 1,
      anon_sym_SEMI,
    ACTIONS(3585), 1,
      anon_sym_nopanic,
  [53160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3447), 1,
      sym_code_line,
    ACTIONS(3587), 1,
      anon_sym_PERCENT_RBRACE,
    STATE(1536), 1,
      aux_sym_python_code_repeat1,
    STATE(1786), 1,
      sym_python_code,
  [53176] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3462), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3589), 1,
      anon_sym_RBRACK,
    STATE(1794), 1,
      sym_attribute_arguments,
  [53192] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3591), 1,
      anon_sym_RBRACK,
    STATE(1795), 1,
      sym_attribute_arguments,
  [53208] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3589), 1,
      anon_sym_RBRACK,
    STATE(1794), 1,
      sym_attribute_arguments,
  [53224] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_LPAREN,
    ACTIONS(3466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3589), 1,
      anon_sym_RBRACK,
    STATE(1794), 1,
      sym_attribute_arguments,
  [53240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3593), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [53250] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 1,
      anon_sym_LBRACE,
    ACTIONS(3595), 1,
      anon_sym_if,
    STATE(303), 1,
      sym_block,
    STATE(304), 1,
      sym__cairo_1_if_expression,
  [53266] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3447), 1,
      sym_code_line,
    ACTIONS(3597), 1,
      anon_sym_PERCENT_RBRACE,
    STATE(1536), 1,
      aux_sym_python_code_repeat1,
    STATE(1808), 1,
      sym_python_code,
  [53282] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3361), 1,
      anon_sym_LF,
    ACTIONS(3601), 1,
      anon_sym_COLON,
    ACTIONS(3599), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
  [53296] = 5,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3603), 1,
      anon_sym_EQ,
    ACTIONS(3605), 1,
      anon_sym_SEMI,
    ACTIONS(3607), 1,
      anon_sym_LF,
    STATE(614), 1,
      sym__separator,
  [53312] = 5,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3609), 1,
      anon_sym_EQ,
    ACTIONS(3611), 1,
      anon_sym_SEMI,
    ACTIONS(3613), 1,
      anon_sym_LF,
    STATE(615), 1,
      sym__separator,
  [53328] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_LT2,
    ACTIONS(3615), 1,
      anon_sym_LPAREN,
    STATE(1574), 1,
      sym__function_signature,
    STATE(1689), 1,
      sym_type_parameters,
  [53344] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_LT2,
    ACTIONS(3551), 1,
      anon_sym_LPAREN,
    STATE(1694), 1,
      sym_type_parameters,
    STATE(1883), 1,
      sym__function_signature,
  [53360] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1601), 1,
      anon_sym_RPAREN,
    ACTIONS(3559), 1,
      sym_identifier,
    STATE(1502), 1,
      sym_dotted_name,
    STATE(1595), 1,
      sym_aliased_import,
  [53376] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3559), 1,
      sym_identifier,
    STATE(1249), 1,
      sym_dotted_name,
    STATE(1497), 1,
      sym_aliased_import,
    STATE(1846), 1,
      sym__import_list,
  [53392] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1617), 1,
      anon_sym_RPAREN,
    ACTIONS(3559), 1,
      sym_identifier,
    STATE(1502), 1,
      sym_dotted_name,
    STATE(1595), 1,
      sym_aliased_import,
  [53408] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1617), 1,
      anon_sym_RPAREN,
    ACTIONS(3559), 1,
      sym_identifier,
    STATE(1502), 1,
      sym_dotted_name,
    STATE(1595), 1,
      sym_aliased_import,
  [53424] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_if,
    ACTIONS(3621), 1,
      anon_sym_LF,
    ACTIONS(3617), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [53438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3447), 1,
      sym_code_line,
    ACTIONS(3623), 1,
      anon_sym_PERCENT_RBRACE,
    STATE(1536), 1,
      aux_sym_python_code_repeat1,
    STATE(1730), 1,
      sym_python_code,
  [53454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1499), 1,
      sym_identifier,
    ACTIONS(3625), 1,
      anon_sym_POUND,
    STATE(1320), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [53468] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3628), 1,
      anon_sym_RPAREN,
    STATE(1446), 1,
      sym_typed_identifier,
  [53484] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    ACTIONS(3630), 1,
      anon_sym_RBRACE,
    STATE(1392), 1,
      sym_typed_identifier,
  [53500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 1,
      anon_sym_SEMI,
    ACTIONS(3255), 1,
      anon_sym_implicits,
    ACTIONS(3632), 1,
      anon_sym_DASH_GT,
    ACTIONS(3634), 1,
      anon_sym_nopanic,
  [53516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_SEMI,
    ACTIONS(3321), 1,
      anon_sym_implicits,
    ACTIONS(3636), 1,
      anon_sym_DASH_GT,
    ACTIONS(3638), 1,
      anon_sym_nopanic,
  [53532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 1,
      anon_sym_LBRACE,
    ACTIONS(3575), 1,
      anon_sym_implicits,
    ACTIONS(3640), 1,
      anon_sym_SEMI,
    ACTIONS(3642), 1,
      anon_sym_nopanic,
  [53548] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 1,
      anon_sym_LBRACE,
    ACTIONS(3516), 1,
      anon_sym_implicits,
    ACTIONS(3644), 1,
      anon_sym_SEMI,
    ACTIONS(3646), 1,
      anon_sym_nopanic,
  [53564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3648), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [53574] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 1,
      anon_sym_LPAREN,
    ACTIONS(3555), 1,
      anon_sym_LBRACE,
    STATE(1491), 1,
      sym_arguments,
    STATE(1714), 1,
      sym_implicit_arguments,
  [53590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3478), 1,
      anon_sym_SEMI,
    ACTIONS(3573), 1,
      anon_sym_LBRACE,
    ACTIONS(3575), 1,
      anon_sym_implicits,
    ACTIONS(3650), 1,
      anon_sym_nopanic,
  [53606] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3526), 1,
      anon_sym_LBRACE,
    ACTIONS(3530), 1,
      anon_sym_implicits,
    ACTIONS(3640), 1,
      anon_sym_SEMI,
    ACTIONS(3652), 1,
      anon_sym_nopanic,
  [53622] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 1,
      anon_sym_SEMI,
    ACTIONS(3573), 1,
      anon_sym_LBRACE,
    ACTIONS(3575), 1,
      anon_sym_implicits,
    ACTIONS(3654), 1,
      anon_sym_nopanic,
  [53638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3656), 1,
      anon_sym_RPAREN,
    ACTIONS(3658), 1,
      anon_sym_COMMA,
    STATE(1533), 1,
      aux_sym__cairo_1_call_expression_repeat1,
  [53651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_nopanic,
    ACTIONS(3660), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [53662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3118), 1,
      anon_sym_RBRACE,
    ACTIONS(3664), 1,
      anon_sym_COMMA,
    STATE(1562), 1,
      aux_sym_field_declaration_list_repeat1,
  [53675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3668), 1,
      anon_sym_nopanic,
    ACTIONS(3666), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [53686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3672), 1,
      anon_sym_nopanic,
    ACTIONS(3670), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [53697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3295), 1,
      sym_identifier,
    ACTIONS(3674), 1,
      anon_sym_LT,
    STATE(414), 1,
      sym__cairo_1_type_arguments,
  [53710] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3676), 1,
      anon_sym_SEMI,
    ACTIONS(3678), 1,
      anon_sym_LF,
    STATE(634), 1,
      sym__separator,
  [53723] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2966), 1,
      anon_sym_LF,
    ACTIONS(3297), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
  [53734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3303), 1,
      sym_identifier,
    STATE(521), 1,
      sym_dotted_name,
    STATE(554), 1,
      sym_aliased_import,
  [53747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3680), 1,
      anon_sym_COMMA,
    ACTIONS(3683), 1,
      anon_sym_GT,
    STATE(1341), 1,
      aux_sym_type_parameters_repeat1,
  [53760] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3685), 1,
      anon_sym_SEMI,
    ACTIONS(3687), 1,
      anon_sym_LF,
    STATE(566), 1,
      sym__separator,
  [53773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3689), 1,
      anon_sym_COMMA,
    ACTIONS(3691), 1,
      anon_sym_RBRACE,
    STATE(1374), 1,
      aux_sym_enum_variant_list_repeat2,
  [53786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_LBRACE,
    ACTIONS(3695), 1,
      anon_sym_SEMI,
    STATE(352), 1,
      sym_block,
  [53799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_LBRACE,
    ACTIONS(3697), 1,
      anon_sym_SEMI,
    STATE(354), 1,
      sym_declaration_list,
  [53812] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3648), 1,
      anon_sym_LF,
    ACTIONS(3699), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
  [53823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3701), 1,
      anon_sym_RPAREN,
    ACTIONS(3703), 1,
      anon_sym_COMMA,
    STATE(1377), 1,
      aux_sym__cairo_0_tuple_type_repeat1,
  [53836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 1,
      anon_sym_RPAREN,
    ACTIONS(3707), 1,
      anon_sym_COMMA,
    STATE(1256), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [53849] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3484), 1,
      anon_sym_RBRACE,
    ACTIONS(3709), 1,
      anon_sym_COMMA,
    STATE(1282), 1,
      aux_sym__cairo_0_struct_definition_repeat1,
  [53862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym_RPAREN,
    ACTIONS(3713), 1,
      anon_sym_COMMA,
    STATE(1469), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [53875] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3084), 1,
      anon_sym_RBRACE,
    ACTIONS(3715), 1,
      anon_sym_COMMA,
    STATE(1562), 1,
      aux_sym_field_declaration_list_repeat1,
  [53888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3084), 1,
      anon_sym_RBRACE,
    ACTIONS(3715), 1,
      anon_sym_COMMA,
    STATE(1380), 1,
      aux_sym_field_declaration_list_repeat1,
  [53901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3717), 1,
      anon_sym_RPAREN,
    ACTIONS(3719), 1,
      anon_sym_COMMA,
    STATE(1353), 1,
      aux_sym__cairo_0_tuple_type_repeat1,
  [53914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3722), 3,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [53923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1619), 1,
      anon_sym_GT,
    ACTIONS(3724), 1,
      anon_sym_COMMA,
    STATE(1411), 1,
      aux_sym__cairo_1_type_arguments_repeat1,
  [53936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3726), 1,
      anon_sym_COLON,
    ACTIONS(3361), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [53947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3728), 1,
      anon_sym_LBRACE,
    ACTIONS(3730), 1,
      anon_sym_DASH_GT,
    ACTIONS(3732), 1,
      anon_sym_COLON,
  [53960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 1,
      anon_sym_COMMA,
    ACTIONS(3736), 1,
      anon_sym_RBRACE,
    STATE(1511), 1,
      aux_sym__cairo_0_struct_definition_repeat1,
  [53973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1621), 1,
      anon_sym_GT,
    ACTIONS(3738), 1,
      anon_sym_COMMA,
    STATE(1411), 1,
      aux_sym__cairo_1_type_arguments_repeat1,
  [53986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3740), 1,
      anon_sym_COMMA,
    ACTIONS(3742), 1,
      anon_sym_RBRACE,
    STATE(1520), 1,
      aux_sym_field_declaration_list_repeat1,
  [53999] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3744), 1,
      anon_sym_SEMI,
    ACTIONS(3746), 1,
      anon_sym_LF,
    STATE(637), 1,
      sym__separator,
  [54012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 1,
      anon_sym_RPAREN,
    ACTIONS(3750), 1,
      anon_sym_COMMA,
    STATE(1256), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [54025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_RPAREN,
    ACTIONS(3754), 1,
      anon_sym_COMMA,
    STATE(1256), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [54038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_RBRACE,
    ACTIONS(3756), 1,
      anon_sym_COMMA,
    STATE(1494), 1,
      aux_sym_field_initializer_list_repeat1,
  [54051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3758), 1,
      anon_sym_PERCENT_RBRACE,
    ACTIONS(3760), 1,
      sym_code_line,
    STATE(1365), 1,
      aux_sym_python_code_repeat1,
  [54064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3765), 1,
      anon_sym_COLON,
    ACTIONS(3763), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [54075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3767), 1,
      anon_sym_COMMA,
    ACTIONS(3769), 1,
      anon_sym_GT,
    STATE(1556), 1,
      aux_sym_type_parameters_repeat1,
  [54088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 1,
      anon_sym_RPAREN,
    ACTIONS(3707), 1,
      anon_sym_COMMA,
    STATE(1500), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [54101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(3295), 1,
      sym_identifier,
    STATE(1881), 1,
      sym__cairo_1_type_arguments,
  [54114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3773), 1,
      anon_sym_nopanic,
    ACTIONS(3771), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [54125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_RBRACE,
    ACTIONS(3775), 1,
      anon_sym_COMMA,
    STATE(1371), 1,
      aux_sym__cairo_0_call_expression_repeat1,
  [54138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 1,
      anon_sym_local,
    ACTIONS(3237), 1,
      sym_identifier,
    STATE(1392), 1,
      sym_typed_identifier,
  [54151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3778), 1,
      anon_sym_EQ,
    ACTIONS(3780), 1,
      anon_sym_COLON,
    ACTIONS(3782), 1,
      anon_sym_SEMI,
  [54164] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3130), 1,
      anon_sym_RBRACE,
    ACTIONS(3784), 1,
      anon_sym_COMMA,
    STATE(1499), 1,
      aux_sym_enum_variant_list_repeat2,
  [54177] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3130), 1,
      anon_sym_RBRACE,
    ACTIONS(3784), 1,
      anon_sym_COMMA,
    STATE(1400), 1,
      aux_sym_enum_variant_list_repeat2,
  [54190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3786), 1,
      anon_sym_COMMA,
    ACTIONS(3788), 1,
      anon_sym_RBRACE,
    STATE(1478), 1,
      aux_sym_use_list_repeat1,
  [54203] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2816), 1,
      anon_sym_RPAREN,
    ACTIONS(3790), 1,
      anon_sym_COMMA,
    STATE(1353), 1,
      aux_sym__cairo_0_tuple_type_repeat1,
  [54216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3114), 1,
      anon_sym_RBRACE,
    ACTIONS(3792), 1,
      anon_sym_COMMA,
    STATE(1499), 1,
      aux_sym_enum_variant_list_repeat2,
  [54229] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_SEMI,
    ACTIONS(2706), 1,
      anon_sym_LF,
    STATE(548), 1,
      sym__separator,
  [54242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_RBRACE,
    ACTIONS(3794), 1,
      anon_sym_COMMA,
    STATE(1562), 1,
      aux_sym_field_declaration_list_repeat1,
  [54255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3796), 3,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [54264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_RPAREN,
    ACTIONS(3800), 1,
      anon_sym_COMMA,
    STATE(1567), 1,
      aux_sym__cairo_0_struct_definition_repeat1,
  [54277] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3802), 1,
      anon_sym_COMMA,
    ACTIONS(3804), 1,
      anon_sym_RBRACE,
    STATE(1442), 1,
      aux_sym__cairo_0_struct_definition_repeat1,
  [54290] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3806), 1,
      anon_sym_LBRACE,
    ACTIONS(3808), 1,
      anon_sym_DASH_GT,
    ACTIONS(3810), 1,
      anon_sym_COLON,
  [54303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3812), 1,
      anon_sym_EQ,
    ACTIONS(3814), 1,
      anon_sym_COLON,
    ACTIONS(3816), 1,
      anon_sym_SEMI,
  [54316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3818), 1,
      anon_sym_RPAREN,
    ACTIONS(3820), 1,
      anon_sym_COMMA,
    STATE(1533), 1,
      aux_sym__cairo_1_call_expression_repeat1,
  [54329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 1,
      anon_sym_COMMA,
    ACTIONS(3824), 1,
      anon_sym_RBRACE,
    STATE(1414), 1,
      aux_sym_field_initializer_list_repeat1,
  [54342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_RBRACE,
    ACTIONS(3826), 1,
      anon_sym_COMMA,
    STATE(1398), 1,
      aux_sym_struct_pattern_repeat1,
  [54355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 1,
      sym_identifier,
    ACTIONS(3830), 1,
      anon_sym_LT,
    STATE(136), 1,
      sym__cairo_1_type_arguments,
  [54368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3834), 1,
      anon_sym_COLON,
    ACTIONS(3832), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [54379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3838), 1,
      anon_sym_nopanic,
    ACTIONS(3836), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [54390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3536), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [54399] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3840), 1,
      anon_sym_SEMI,
    ACTIONS(3842), 1,
      anon_sym_LF,
    STATE(596), 1,
      sym__separator,
  [54412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 1,
      sym_identifier,
    ACTIONS(3846), 1,
      anon_sym_local,
    STATE(1268), 1,
      sym_typed_identifier,
  [54425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3512), 1,
      anon_sym_SEMI,
    ACTIONS(3516), 1,
      anon_sym_implicits,
    ACTIONS(3848), 1,
      anon_sym_nopanic,
  [54438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 1,
      sym_identifier,
    ACTIONS(3846), 1,
      anon_sym_local,
    STATE(1274), 1,
      sym_typed_identifier,
  [54451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_SEMI,
    ACTIONS(3435), 1,
      anon_sym_implicits,
    ACTIONS(3850), 1,
      anon_sym_nopanic,
  [54464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3852), 1,
      anon_sym_COMMA,
    ACTIONS(3855), 1,
      anon_sym_RBRACE,
    STATE(1398), 1,
      aux_sym_struct_pattern_repeat1,
  [54477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3859), 1,
      anon_sym_nopanic,
    ACTIONS(3857), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [54488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_RBRACE,
    ACTIONS(3861), 1,
      anon_sym_COMMA,
    STATE(1499), 1,
      aux_sym_enum_variant_list_repeat2,
  [54501] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3311), 1,
      sym_identifier,
    STATE(454), 1,
      sym_dotted_name,
    STATE(519), 1,
      sym_aliased_import,
  [54514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3863), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [54523] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3865), 1,
      anon_sym_RPAREN,
    ACTIONS(3867), 1,
      anon_sym_COMMA,
    STATE(1256), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [54536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2130), 1,
      anon_sym_LBRACE,
    ACTIONS(3869), 1,
      sym_identifier,
    STATE(1504), 1,
      sym_use_list,
  [54549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3114), 1,
      anon_sym_RBRACE,
    ACTIONS(3792), 1,
      anon_sym_COMMA,
    STATE(1505), 1,
      aux_sym_enum_variant_list_repeat2,
  [54562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3873), 1,
      anon_sym_nopanic,
    ACTIONS(3871), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [54573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2130), 1,
      anon_sym_LBRACE,
    ACTIONS(3295), 1,
      sym_identifier,
    STATE(1488), 1,
      sym_use_list,
  [54586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3634), 1,
      anon_sym_nopanic,
    ACTIONS(3249), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [54597] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3875), 1,
      anon_sym_RPAREN,
    ACTIONS(3877), 1,
      anon_sym_COMMA,
    STATE(1544), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [54610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3881), 1,
      anon_sym_nopanic,
    ACTIONS(3879), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [54621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3883), 1,
      anon_sym_COMMA,
    ACTIONS(3886), 1,
      anon_sym_GT,
    STATE(1411), 1,
      aux_sym__cairo_1_type_arguments_repeat1,
  [54634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_RPAREN,
    ACTIONS(3888), 1,
      anon_sym_COMMA,
    STATE(1434), 1,
      aux_sym_attribute_arguments_repeat1,
  [54647] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3890), 1,
      anon_sym_RPAREN,
    ACTIONS(3892), 1,
      sym_string,
    STATE(1413), 1,
      aux_sym__cairo_0_attribute_statement_repeat1,
  [54660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 1,
      anon_sym_RBRACE,
    ACTIONS(3895), 1,
      anon_sym_COMMA,
    STATE(1494), 1,
      aux_sym_field_initializer_list_repeat1,
  [54673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3899), 1,
      anon_sym_nopanic,
    ACTIONS(3897), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [54684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_nopanic,
    ACTIONS(3901), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [54695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3905), 1,
      anon_sym_RPAREN,
    ACTIONS(3907), 1,
      anon_sym_COMMA,
    STATE(1533), 1,
      aux_sym__cairo_1_call_expression_repeat1,
  [54708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(3909), 1,
      sym_identifier,
    STATE(1789), 1,
      sym__cairo_1_type_arguments,
  [54721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3191), 1,
      anon_sym_RBRACE,
    ACTIONS(3911), 1,
      anon_sym_COMMA,
    STATE(1398), 1,
      aux_sym_struct_pattern_repeat1,
  [54734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_LT2,
    ACTIONS(3913), 1,
      anon_sym_EQ,
    STATE(1852), 1,
      sym_type_parameters,
  [54747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3915), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [54756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3917), 1,
      anon_sym_EQ,
    ACTIONS(3919), 1,
      anon_sym_COLON,
    ACTIONS(3921), 1,
      anon_sym_SEMI,
  [54769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2294), 1,
      anon_sym_RPAREN,
    ACTIONS(3923), 1,
      anon_sym_COMMA,
    STATE(1519), 1,
      aux_sym_tuple_expression_repeat1,
  [54782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_LT2,
    ACTIONS(3925), 1,
      anon_sym_SEMI,
    STATE(1896), 1,
      sym_type_parameters,
  [54795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3453), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [54804] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(3927), 1,
      anon_sym_SEMI,
    STATE(989), 1,
      sym_block,
  [54817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_LBRACE,
    ACTIONS(3929), 1,
      anon_sym_SEMI,
    STATE(321), 1,
      sym_declaration_list,
  [54830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 1,
      anon_sym_RPAREN,
    ACTIONS(3931), 1,
      anon_sym_COMMA,
    STATE(1282), 1,
      aux_sym__cairo_0_struct_definition_repeat1,
  [54843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3933), 1,
      anon_sym_COMMA,
    ACTIONS(3936), 1,
      anon_sym_RBRACE,
    STATE(1429), 1,
      aux_sym_use_list_repeat1,
  [54856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COLON,
    ACTIONS(3938), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [54867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_RPAREN,
    ACTIONS(3944), 1,
      anon_sym_COMMA,
    STATE(1533), 1,
      aux_sym__cairo_1_call_expression_repeat1,
  [54880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1954), 1,
      anon_sym_RPAREN,
    ACTIONS(3946), 1,
      anon_sym_COMMA,
    STATE(1487), 1,
      aux_sym_tuple_pattern_repeat1,
  [54893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3950), 1,
      anon_sym_COLON,
    ACTIONS(3948), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [54904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2088), 1,
      anon_sym_RPAREN,
    ACTIONS(3952), 1,
      anon_sym_COMMA,
    STATE(1434), 1,
      aux_sym_attribute_arguments_repeat1,
  [54917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2130), 1,
      anon_sym_LBRACE,
    ACTIONS(3955), 1,
      sym_identifier,
    STATE(1402), 1,
      sym_use_list,
  [54930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3957), 1,
      anon_sym_EQ,
    ACTIONS(2958), 2,
      anon_sym_COLON,
      anon_sym_SEMI,
  [54941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 1,
      anon_sym_RPAREN,
    ACTIONS(3962), 1,
      sym_string,
    STATE(1508), 1,
      aux_sym__cairo_0_attribute_statement_repeat1,
  [54954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3964), 1,
      anon_sym_COMMA,
    ACTIONS(3966), 1,
      anon_sym_RBRACE,
    STATE(1364), 1,
      aux_sym_field_initializer_list_repeat1,
  [54967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3968), 1,
      anon_sym_RPAREN,
    ACTIONS(3970), 1,
      anon_sym_COMMA,
    STATE(1561), 1,
      aux_sym_tuple_pattern_repeat1,
  [54980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3972), 1,
      anon_sym_SEMI,
    STATE(991), 1,
      sym_declaration_list,
  [54993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3976), 1,
      anon_sym_EQ,
    ACTIONS(3974), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [55004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3630), 1,
      anon_sym_RBRACE,
    ACTIONS(3978), 1,
      anon_sym_COMMA,
    STATE(1282), 1,
      aux_sym__cairo_0_struct_definition_repeat1,
  [55017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2304), 1,
      anon_sym_RPAREN,
    ACTIONS(3980), 1,
      anon_sym_COMMA,
    STATE(1519), 1,
      aux_sym_tuple_expression_repeat1,
  [55030] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3982), 1,
      anon_sym_RPAREN,
    ACTIONS(3984), 1,
      anon_sym_COMMA,
    STATE(1533), 1,
      aux_sym__cairo_1_call_expression_repeat1,
  [55043] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3986), 1,
      anon_sym_RPAREN,
    ACTIONS(3988), 1,
      anon_sym_COMMA,
    STATE(1533), 1,
      aux_sym__cairo_1_call_expression_repeat1,
  [55056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3990), 1,
      anon_sym_RPAREN,
    ACTIONS(3992), 1,
      anon_sym_COMMA,
    STATE(1428), 1,
      aux_sym__cairo_0_struct_definition_repeat1,
  [55069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 1,
      anon_sym_nopanic,
    ACTIONS(3994), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [55080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 3,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [55089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 1,
      anon_sym_LBRACE,
    ACTIONS(4000), 1,
      anon_sym_SEMI,
    STATE(325), 1,
      sym_field_declaration_list,
  [55102] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(4002), 1,
      anon_sym_SEMI,
    ACTIONS(4004), 1,
      anon_sym_LF,
    STATE(588), 1,
      sym__separator,
  [55115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4006), 3,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [55124] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(4008), 1,
      anon_sym_SEMI,
    ACTIONS(4010), 1,
      anon_sym_LF,
    STATE(639), 1,
      sym__separator,
  [55137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4012), 1,
      anon_sym_RPAREN,
    ACTIONS(4014), 1,
      anon_sym_COMMA,
    STATE(1533), 1,
      aux_sym__cairo_1_call_expression_repeat1,
  [55150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4018), 1,
      anon_sym_COLON,
    ACTIONS(4016), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [55161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4020), 1,
      anon_sym_RPAREN,
    ACTIONS(4022), 1,
      anon_sym_COMMA,
    STATE(1462), 1,
      aux_sym__cairo_0_tuple_type_repeat1,
  [55174] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_COMMA,
    ACTIONS(4026), 1,
      anon_sym_RBRACE,
    STATE(1419), 1,
      aux_sym_struct_pattern_repeat1,
  [55187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 1,
      sym_identifier,
    ACTIONS(3830), 1,
      anon_sym_LT,
    STATE(121), 1,
      sym__cairo_1_type_arguments,
  [55200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(4028), 1,
      sym_identifier,
    STATE(1066), 1,
      sym__cairo_1_type_arguments,
  [55213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4030), 1,
      anon_sym_EQ,
    ACTIONS(4032), 1,
      anon_sym_COLON,
    ACTIONS(4034), 1,
      anon_sym_SEMI,
  [55226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4036), 1,
      anon_sym_COMMA,
    ACTIONS(4038), 1,
      anon_sym_GT,
    STATE(1359), 1,
      aux_sym__cairo_1_type_arguments_repeat1,
  [55239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(4028), 1,
      sym_identifier,
    STATE(1789), 1,
      sym__cairo_1_type_arguments,
  [55252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2822), 1,
      anon_sym_RPAREN,
    ACTIONS(4040), 1,
      anon_sym_COMMA,
    STATE(1353), 1,
      aux_sym__cairo_0_tuple_type_repeat1,
  [55265] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_COMMA,
    ACTIONS(4044), 1,
      anon_sym_GT,
    STATE(1466), 1,
      aux_sym__cairo_1_type_arguments_repeat1,
  [55278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4046), 1,
      anon_sym_RPAREN,
    ACTIONS(4048), 1,
      anon_sym_COMMA,
    STATE(1545), 1,
      aux_sym__function_signature_repeat1,
  [55291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 1,
      sym_identifier,
    ACTIONS(3846), 1,
      anon_sym_local,
    STATE(1310), 1,
      sym_typed_identifier,
  [55304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1625), 1,
      anon_sym_GT,
    ACTIONS(4050), 1,
      anon_sym_COMMA,
    STATE(1411), 1,
      aux_sym__cairo_1_type_arguments_repeat1,
  [55317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 1,
      sym_identifier,
    ACTIONS(3846), 1,
      anon_sym_local,
    STATE(1311), 1,
      sym_typed_identifier,
  [55330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4052), 1,
      anon_sym_RPAREN,
    ACTIONS(4054), 1,
      anon_sym_COMMA,
    STATE(1482), 1,
      aux_sym__cairo_1_tuple_type_repeat1,
  [55343] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_RPAREN,
    ACTIONS(4058), 1,
      anon_sym_COMMA,
    STATE(1256), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [55356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4062), 1,
      anon_sym_nopanic,
    ACTIONS(4060), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [55367] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3144), 1,
      anon_sym_LF,
    ACTIONS(4064), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
  [55378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(4066), 1,
      anon_sym_SEMI,
    STATE(1003), 1,
      sym_declaration_list,
  [55391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3353), 1,
      anon_sym_LBRACE,
    ACTIONS(4068), 1,
      anon_sym_SEMI,
    STATE(1020), 1,
      sym_field_declaration_list,
  [55404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4070), 1,
      anon_sym_COMMA,
    ACTIONS(4072), 1,
      anon_sym_GT,
    STATE(1355), 1,
      aux_sym__cairo_1_type_arguments_repeat1,
  [55417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_RBRACE,
    ACTIONS(4074), 1,
      anon_sym_COMMA,
    STATE(1371), 1,
      aux_sym__cairo_0_call_expression_repeat1,
  [55430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_LT2,
    ACTIONS(4076), 1,
      anon_sym_SEMI,
    STATE(1874), 1,
      sym_type_parameters,
  [55443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4078), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [55452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2132), 1,
      anon_sym_RBRACE,
    ACTIONS(4080), 1,
      anon_sym_COMMA,
    STATE(1429), 1,
      aux_sym_use_list_repeat1,
  [55465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3273), 1,
      anon_sym_COLON,
    STATE(1092), 1,
      sym_trait_bounds,
  [55478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_nopanic,
    ACTIONS(4082), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [55489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4088), 1,
      anon_sym_nopanic,
    ACTIONS(4086), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [55500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1980), 1,
      anon_sym_RPAREN,
    ACTIONS(4090), 1,
      anon_sym_COMMA,
    STATE(1484), 1,
      aux_sym__cairo_1_tuple_type_repeat1,
  [55513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4092), 1,
      anon_sym_COMMA,
    ACTIONS(4094), 1,
      anon_sym_LBRACE,
    STATE(1496), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [55526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_RPAREN,
    ACTIONS(4098), 1,
      anon_sym_COMMA,
    STATE(1484), 1,
      aux_sym__cairo_1_tuple_type_repeat1,
  [55539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4101), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [55548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4103), 1,
      anon_sym_RPAREN,
    ACTIONS(4105), 1,
      anon_sym_COMMA,
    STATE(1517), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [55561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4107), 1,
      anon_sym_RPAREN,
    ACTIONS(4109), 1,
      anon_sym_COMMA,
    STATE(1487), 1,
      aux_sym_tuple_pattern_repeat1,
  [55574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4112), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [55583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4114), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [55592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4118), 1,
      anon_sym_nopanic,
    ACTIONS(4116), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [55603] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4120), 1,
      anon_sym_LBRACE,
    ACTIONS(4122), 1,
      anon_sym_DASH_GT,
    ACTIONS(4124), 1,
      anon_sym_COLON,
  [55616] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4126), 1,
      anon_sym_COMMA,
    ACTIONS(4128), 1,
      anon_sym_RBRACE,
    STATE(1388), 1,
      aux_sym_struct_pattern_repeat1,
  [55629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3142), 1,
      anon_sym_RPAREN,
    ACTIONS(4130), 1,
      anon_sym_COMMA,
    STATE(1566), 1,
      aux_sym__function_signature_repeat1,
  [55642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4132), 1,
      anon_sym_COMMA,
    ACTIONS(4135), 1,
      anon_sym_RBRACE,
    STATE(1494), 1,
      aux_sym_field_initializer_list_repeat1,
  [55655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(4137), 1,
      anon_sym_SEMI,
    STATE(976), 1,
      sym_declaration_list,
  [55668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4092), 1,
      anon_sym_COMMA,
    ACTIONS(4139), 1,
      anon_sym_LBRACE,
    STATE(1256), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [55681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1558), 1,
      anon_sym_RPAREN,
    ACTIONS(3425), 1,
      anon_sym_COMMA,
    STATE(1537), 1,
      aux_sym__import_list_repeat1,
  [55694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4141), 1,
      sym_identifier,
    ACTIONS(4143), 2,
      anon_sym_rel,
      anon_sym_abs,
  [55705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4145), 1,
      anon_sym_COMMA,
    ACTIONS(4148), 1,
      anon_sym_RBRACE,
    STATE(1499), 1,
      aux_sym_enum_variant_list_repeat2,
  [55718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4150), 1,
      anon_sym_RPAREN,
    ACTIONS(4152), 1,
      anon_sym_COMMA,
    STATE(1256), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [55731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3347), 1,
      anon_sym_COLON,
    STATE(1092), 1,
      sym_trait_bounds,
  [55744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_as,
    ACTIONS(1613), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [55755] = 4,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(2692), 1,
      anon_sym_SEMI,
    ACTIONS(2694), 1,
      anon_sym_LF,
    STATE(600), 1,
      sym__separator,
  [55768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4154), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [55777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_RBRACE,
    ACTIONS(4156), 1,
      anon_sym_COMMA,
    STATE(1499), 1,
      aux_sym_enum_variant_list_repeat2,
  [55790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3559), 1,
      sym_identifier,
    STATE(1502), 1,
      sym_dotted_name,
    STATE(1595), 1,
      sym_aliased_import,
  [55803] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4158), 1,
      anon_sym_LBRACE,
    ACTIONS(4160), 1,
      anon_sym_DASH_GT,
    ACTIONS(4162), 1,
      anon_sym_COLON,
  [55816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4164), 1,
      anon_sym_RPAREN,
    ACTIONS(4166), 1,
      sym_string,
    STATE(1413), 1,
      aux_sym__cairo_0_attribute_statement_repeat1,
  [55829] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1572), 1,
      anon_sym_RPAREN,
    ACTIONS(4168), 1,
      anon_sym_COMMA,
    STATE(1509), 1,
      aux_sym__import_list_repeat1,
  [55842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4171), 1,
      anon_sym_RPAREN,
    ACTIONS(4173), 1,
      anon_sym_COMMA,
    STATE(1493), 1,
      aux_sym__function_signature_repeat1,
  [55855] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3508), 1,
      anon_sym_RBRACE,
    ACTIONS(4175), 1,
      anon_sym_COMMA,
    STATE(1282), 1,
      aux_sym__cairo_0_struct_definition_repeat1,
  [55868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4179), 1,
      anon_sym_nopanic,
    ACTIONS(4177), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [55879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4181), 1,
      anon_sym_RPAREN,
    ACTIONS(4183), 1,
      anon_sym_COMMA,
    STATE(1533), 1,
      aux_sym__cairo_1_call_expression_repeat1,
  [55892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_RPAREN,
    ACTIONS(4187), 1,
      anon_sym_COMMA,
    STATE(1524), 1,
      aux_sym__function_signature_repeat1,
  [55905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4191), 1,
      anon_sym_nopanic,
    ACTIONS(4189), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [55916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4195), 1,
      anon_sym_nopanic,
    ACTIONS(4193), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [55927] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4197), 1,
      anon_sym_RPAREN,
    ACTIONS(4199), 1,
      anon_sym_COMMA,
    STATE(1256), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [55940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 1,
      anon_sym_RBRACE,
    ACTIONS(4201), 1,
      anon_sym_COMMA,
    STATE(1371), 1,
      aux_sym__cairo_0_call_expression_repeat1,
  [55953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2748), 1,
      anon_sym_RPAREN,
    ACTIONS(4203), 1,
      anon_sym_COMMA,
    STATE(1519), 1,
      aux_sym_tuple_expression_repeat1,
  [55966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3104), 1,
      anon_sym_RBRACE,
    ACTIONS(4206), 1,
      anon_sym_COMMA,
    STATE(1562), 1,
      aux_sym_field_declaration_list_repeat1,
  [55979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_LBRACE,
    ACTIONS(4208), 1,
      anon_sym_SEMI,
    STATE(335), 1,
      sym_declaration_list,
  [55992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4212), 1,
      anon_sym_nopanic,
    ACTIONS(4210), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [56003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_nopanic,
    ACTIONS(4214), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [56014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3210), 1,
      anon_sym_RPAREN,
    ACTIONS(4218), 1,
      anon_sym_COMMA,
    STATE(1566), 1,
      aux_sym__function_signature_repeat1,
  [56027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4220), 1,
      anon_sym_RPAREN,
    ACTIONS(4222), 1,
      anon_sym_COMMA,
    STATE(1535), 1,
      aux_sym__function_signature_repeat1,
  [56040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 1,
      anon_sym_SEMI,
    ACTIONS(3575), 1,
      anon_sym_implicits,
    ACTIONS(4224), 1,
      anon_sym_nopanic,
  [56053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4092), 1,
      anon_sym_COMMA,
    ACTIONS(4226), 1,
      anon_sym_LBRACE,
    STATE(1529), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [56066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3104), 1,
      anon_sym_RBRACE,
    ACTIONS(4206), 1,
      anon_sym_COMMA,
    STATE(1334), 1,
      aux_sym_field_declaration_list_repeat1,
  [56079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4092), 1,
      anon_sym_COMMA,
    ACTIONS(4228), 1,
      anon_sym_LBRACE,
    STATE(1256), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [56092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4230), 1,
      anon_sym_RPAREN,
    ACTIONS(4232), 1,
      anon_sym_COMMA,
    STATE(1533), 1,
      aux_sym__cairo_1_call_expression_repeat1,
  [56105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 1,
      anon_sym_RPAREN,
    ACTIONS(3750), 1,
      anon_sym_COMMA,
    STATE(1348), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [56118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4234), 1,
      anon_sym_RPAREN,
    ACTIONS(4236), 1,
      anon_sym_COMMA,
    STATE(1363), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [56131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4238), 1,
      anon_sym_RPAREN,
    ACTIONS(4240), 1,
      anon_sym_COMMA,
    STATE(1533), 1,
      aux_sym__cairo_1_call_expression_repeat1,
  [56144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4243), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [56153] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3138), 1,
      anon_sym_RPAREN,
    ACTIONS(4245), 1,
      anon_sym_COMMA,
    STATE(1566), 1,
      aux_sym__function_signature_repeat1,
  [56166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4247), 1,
      anon_sym_PERCENT_RBRACE,
    ACTIONS(4249), 1,
      sym_code_line,
    STATE(1365), 1,
      aux_sym_python_code_repeat1,
  [56179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1605), 1,
      anon_sym_RPAREN,
    ACTIONS(4251), 1,
      anon_sym_COMMA,
    STATE(1509), 1,
      aux_sym__import_list_repeat1,
  [56192] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3526), 1,
      anon_sym_SEMI,
    ACTIONS(3530), 1,
      anon_sym_implicits,
    ACTIONS(4253), 1,
      anon_sym_nopanic,
  [56205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1605), 1,
      anon_sym_RPAREN,
    ACTIONS(4255), 1,
      anon_sym_COMMA,
    STATE(1509), 1,
      aux_sym__import_list_repeat1,
  [56218] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4257), 1,
      sym_identifier,
    ACTIONS(4259), 1,
      anon_sym_rel,
    ACTIONS(4261), 1,
      anon_sym_abs,
  [56231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_RPAREN,
    ACTIONS(4263), 1,
      anon_sym_COMMA,
    STATE(1566), 1,
      aux_sym__function_signature_repeat1,
  [56244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4265), 1,
      anon_sym_RPAREN,
    ACTIONS(4267), 1,
      anon_sym_COMMA,
    STATE(1541), 1,
      aux_sym__function_signature_repeat1,
  [56257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4271), 1,
      anon_sym_nopanic,
    ACTIONS(4269), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [56268] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_RPAREN,
    ACTIONS(4275), 1,
      anon_sym_COMMA,
    STATE(1256), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [56281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 1,
      anon_sym_RPAREN,
    ACTIONS(4277), 1,
      anon_sym_COMMA,
    STATE(1566), 1,
      aux_sym__function_signature_repeat1,
  [56294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_GT,
    ACTIONS(4279), 1,
      anon_sym_COMMA,
    STATE(1341), 1,
      aux_sym_type_parameters_repeat1,
  [56307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_RPAREN,
    ACTIONS(4275), 1,
      anon_sym_COMMA,
    STATE(1362), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [56320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4281), 1,
      anon_sym_COMMA,
    ACTIONS(4283), 1,
      anon_sym_RBRACE,
    STATE(1349), 1,
      aux_sym__cairo_0_struct_definition_repeat1,
  [56333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4285), 1,
      anon_sym_RPAREN,
    ACTIONS(4287), 1,
      anon_sym_COMMA,
    STATE(1533), 1,
      aux_sym__cairo_1_call_expression_repeat1,
  [56346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4289), 1,
      anon_sym_RPAREN,
    ACTIONS(4291), 1,
      anon_sym_COMMA,
    STATE(1403), 1,
      aux_sym__cairo_0_with_statement_repeat1,
  [56359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4293), 1,
      anon_sym_COMMA,
    ACTIONS(4295), 1,
      anon_sym_RBRACE,
    STATE(1351), 1,
      aux_sym_field_declaration_list_repeat1,
  [56372] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(3593), 1,
      anon_sym_LF,
    ACTIONS(4297), 2,
      anon_sym_EQ,
      anon_sym_SEMI,
  [56383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_COMMA,
    ACTIONS(4301), 1,
      anon_sym_RBRACE,
    STATE(1378), 1,
      aux_sym_enum_variant_list_repeat2,
  [56396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_LT2,
    ACTIONS(4303), 1,
      anon_sym_EQ,
    STATE(1936), 1,
      sym_type_parameters,
  [56409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4307), 1,
      anon_sym_nopanic,
    ACTIONS(4305), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [56420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3222), 1,
      anon_sym_GT,
    ACTIONS(4309), 1,
      anon_sym_COMMA,
    STATE(1341), 1,
      aux_sym_type_parameters_repeat1,
  [56433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4311), 1,
      anon_sym_RPAREN,
    ACTIONS(4313), 1,
      sym_string,
    STATE(1560), 1,
      aux_sym__cairo_0_attribute_statement_repeat1,
  [56446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(3909), 1,
      sym_identifier,
    STATE(1066), 1,
      sym__cairo_1_type_arguments,
  [56459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_LT,
    ACTIONS(3295), 1,
      sym_identifier,
    STATE(1789), 1,
      sym__cairo_1_type_arguments,
  [56472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4166), 1,
      sym_string,
    ACTIONS(4315), 1,
      anon_sym_RPAREN,
    STATE(1413), 1,
      aux_sym__cairo_0_attribute_statement_repeat1,
  [56485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 1,
      anon_sym_RPAREN,
    ACTIONS(4317), 1,
      anon_sym_COMMA,
    STATE(1487), 1,
      aux_sym_tuple_pattern_repeat1,
  [56498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4319), 1,
      anon_sym_COMMA,
    ACTIONS(4322), 1,
      anon_sym_RBRACE,
    STATE(1562), 1,
      aux_sym_field_declaration_list_repeat1,
  [56511] = 3,
    ACTIONS(2558), 1,
      sym_comment,
    ACTIONS(4326), 1,
      anon_sym_LF,
    ACTIONS(4324), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [56522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3295), 1,
      sym_identifier,
    ACTIONS(3674), 1,
      anon_sym_LT,
    STATE(424), 1,
      sym__cairo_1_type_arguments,
  [56535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4328), 3,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [56544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4330), 1,
      anon_sym_RPAREN,
    ACTIONS(4332), 1,
      anon_sym_COMMA,
    STATE(1566), 1,
      aux_sym__function_signature_repeat1,
  [56557] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_RPAREN,
    ACTIONS(4335), 1,
      anon_sym_COMMA,
    STATE(1282), 1,
      aux_sym__cairo_0_struct_definition_repeat1,
  [56570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1125), 1,
      anon_sym_RPAREN,
    ACTIONS(4337), 1,
      anon_sym_COMMA,
    STATE(1434), 1,
      aux_sym_attribute_arguments_repeat1,
  [56583] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4339), 1,
      anon_sym_RPAREN,
    ACTIONS(4341), 1,
      anon_sym_COMMA,
    STATE(1432), 1,
      aux_sym_tuple_pattern_repeat1,
  [56596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4343), 1,
      anon_sym_LBRACE,
    ACTIONS(4345), 1,
      anon_sym_SEMI,
  [56606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4269), 1,
      anon_sym_LBRACE,
    ACTIONS(4347), 1,
      anon_sym_SEMI,
  [56616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    STATE(983), 1,
      sym_block,
  [56626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_LBRACE,
    ACTIONS(4351), 1,
      anon_sym_COLON,
  [56636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_LBRACE,
    STATE(328), 1,
      sym_block,
  [56646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3449), 1,
      anon_sym_LBRACE,
    STATE(333), 1,
      sym_enum_variant_list,
  [56656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4353), 1,
      anon_sym_if,
    ACTIONS(4355), 1,
      anon_sym_EQ_GT,
  [56666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    STATE(895), 1,
      sym_tuple_expression,
  [56676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4357), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [56684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3855), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [56692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3897), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [56700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4359), 1,
      sym_identifier,
    ACTIONS(4361), 1,
      anon_sym_mut,
  [56710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_RPAREN,
    ACTIONS(4363), 1,
      sym_identifier,
  [56720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(101), 1,
      anon_sym_LBRACE,
    STATE(117), 1,
      sym_block,
  [56730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4082), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [56738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4365), 1,
      anon_sym_EQ,
    ACTIONS(4367), 1,
      anon_sym_SEMI,
  [56748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4369), 1,
      anon_sym_EQ,
    ACTIONS(4371), 1,
      anon_sym_SEMI,
  [56758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3705), 1,
      anon_sym_RPAREN,
    ACTIONS(4363), 1,
      sym_identifier,
  [56768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3693), 1,
      anon_sym_LBRACE,
    STATE(347), 1,
      sym_block,
  [56778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      sym_identifier,
    ACTIONS(4375), 1,
      anon_sym_RPAREN,
  [56788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2800), 1,
      anon_sym_LT,
    STATE(1072), 1,
      sym__cairo_1_type_arguments,
  [56798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3886), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [56806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    STATE(913), 1,
      sym_tuple_expression,
  [56816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4377), 1,
      anon_sym_LBRACE,
    ACTIONS(4379), 1,
      anon_sym_SEMI,
  [56826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4379), 1,
      anon_sym_SEMI,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
  [56836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1613), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [56844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4343), 1,
      anon_sym_LBRACE,
    ACTIONS(4383), 1,
      anon_sym_SEMI,
  [56854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    STATE(890), 1,
      sym_tuple_expression,
  [56864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1729), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [56872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4385), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [56880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4387), 1,
      anon_sym_EQ,
    ACTIONS(4389), 1,
      anon_sym_SEMI,
  [56890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3875), 1,
      anon_sym_RPAREN,
    ACTIONS(4391), 1,
      sym_identifier,
  [56900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3559), 1,
      sym_identifier,
    STATE(1875), 1,
      sym_dotted_name,
  [56910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [56918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3830), 1,
      anon_sym_LT,
    STATE(135), 1,
      sym__cairo_1_type_arguments,
  [56928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      sym_identifier,
    ACTIONS(4393), 1,
      anon_sym_RPAREN,
  [56938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3994), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [56946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3857), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [56954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_LBRACE,
    ACTIONS(3319), 1,
      anon_sym_SEMI,
  [56964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 1,
      anon_sym_LBRACE,
    ACTIONS(3253), 1,
      anon_sym_SEMI,
  [56974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3865), 1,
      anon_sym_RPAREN,
    ACTIONS(4363), 1,
      sym_identifier,
  [56984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    STATE(934), 1,
      sym_tuple_expression,
  [56994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3674), 1,
      anon_sym_LT,
    STATE(427), 1,
      sym__cairo_1_type_arguments,
  [57004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4150), 1,
      anon_sym_RPAREN,
    ACTIONS(4363), 1,
      sym_identifier,
  [57014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4395), 1,
      sym_identifier,
    ACTIONS(4397), 1,
      anon_sym_RPAREN,
  [57024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3253), 1,
      anon_sym_SEMI,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
  [57034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    STATE(920), 1,
      sym_tuple_expression,
  [57044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4377), 1,
      anon_sym_LBRACE,
    ACTIONS(4399), 1,
      anon_sym_SEMI,
  [57054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4177), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4189), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      sym_identifier,
    ACTIONS(4401), 1,
      anon_sym_RPAREN,
  [57080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4210), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4193), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4197), 1,
      anon_sym_RPAREN,
    ACTIONS(4363), 1,
      sym_identifier,
  [57106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3377), 1,
      anon_sym_SEMI,
  [57116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_LBRACE,
    ACTIONS(3377), 1,
      anon_sym_SEMI,
  [57126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4403), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [57134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      sym_identifier,
    ACTIONS(4405), 1,
      anon_sym_RPAREN,
  [57144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    STATE(935), 1,
      sym_tuple_expression,
  [57154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4407), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3660), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3666), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      sym_identifier,
    ACTIONS(4409), 1,
      anon_sym_RPAREN,
  [57188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3836), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3670), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    STATE(909), 1,
      sym_tuple_expression,
  [57214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_RPAREN,
    ACTIONS(4363), 1,
      sym_identifier,
  [57224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4411), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3871), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3879), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      sym_identifier,
    ACTIONS(4413), 1,
      anon_sym_RPAREN,
  [57258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4415), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 1,
      anon_sym_LBRACE,
    ACTIONS(3261), 1,
      anon_sym_SEMI,
  [57276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4417), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3901), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 1,
      anon_sym_SEMI,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
  [57302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4419), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_LPAREN,
    STATE(938), 1,
      sym_tuple_expression,
  [57320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_LBRACE,
    STATE(428), 1,
      sym_block,
  [57330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4421), 1,
      sym_identifier,
    STATE(585), 1,
      aux_sym_builtin_directive_repeat1,
  [57340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4423), 1,
      anon_sym_LBRACE,
    ACTIONS(4425), 1,
      anon_sym_SEMI,
  [57350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [57358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4423), 1,
      anon_sym_LBRACE,
    ACTIONS(4429), 1,
      anon_sym_SEMI,
  [57368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3287), 1,
      anon_sym_SEMI,
    ACTIONS(4269), 1,
      anon_sym_LBRACE,
  [57378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4343), 1,
      anon_sym_LBRACE,
    ACTIONS(4429), 1,
      anon_sym_SEMI,
  [57388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 1,
      anon_sym_LBRACE,
    ACTIONS(3287), 1,
      anon_sym_SEMI,
  [57398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2832), 1,
      anon_sym_PERCENT_LBRACE,
    STATE(929), 1,
      sym_hint,
  [57408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4135), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [57416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_LBRACE,
    ACTIONS(3371), 1,
      anon_sym_SEMI,
  [57426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4431), 1,
      anon_sym_SEMI,
  [57436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4423), 1,
      anon_sym_LBRACE,
    ACTIONS(4431), 1,
      anon_sym_SEMI,
  [57446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4269), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_SEMI,
  [57456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3072), 1,
      anon_sym_COLON,
    STATE(1706), 1,
      sym_trait_bounds,
  [57466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 1,
      anon_sym_LPAREN,
    STATE(1384), 1,
      sym_arguments,
  [57476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_EQ,
    ACTIONS(4437), 1,
      anon_sym_COLON,
  [57486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4377), 1,
      anon_sym_LBRACE,
    ACTIONS(4439), 1,
      anon_sym_SEMI,
  [57496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4439), 1,
      anon_sym_SEMI,
  [57506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [57514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4377), 1,
      anon_sym_LBRACE,
    ACTIONS(4443), 1,
      anon_sym_SEMI,
  [57524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4445), 1,
      anon_sym_EQ,
    ACTIONS(4447), 1,
      anon_sym_SEMI,
  [57534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4449), 1,
      anon_sym_EQ,
    ACTIONS(4451), 1,
      anon_sym_SEMI,
  [57544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      sym_identifier,
    ACTIONS(4455), 1,
      anon_sym_RPAREN,
  [57554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4457), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [57562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3393), 1,
      anon_sym_SEMI,
  [57572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2802), 1,
      anon_sym_of,
    ACTIONS(2890), 1,
      anon_sym_COLON_COLON,
  [57582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4330), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [57590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      sym_identifier,
    ACTIONS(4461), 1,
      anon_sym_RPAREN,
  [57600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4269), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_RPAREN,
    ACTIONS(4363), 1,
      sym_identifier,
  [57618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4096), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [57626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_LBRACE,
    ACTIONS(3393), 1,
      anon_sym_SEMI,
  [57636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4463), 1,
      anon_sym_LPAREN,
    ACTIONS(4465), 1,
      anon_sym_LBRACE,
  [57646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4423), 1,
      anon_sym_LBRACE,
    ACTIONS(4467), 1,
      anon_sym_SEMI,
  [57656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_RPAREN,
    ACTIONS(4469), 1,
      sym_identifier,
  [57666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3417), 1,
      anon_sym_SEMI,
    ACTIONS(4269), 1,
      anon_sym_LBRACE,
  [57676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4343), 1,
      anon_sym_LBRACE,
    ACTIONS(4467), 1,
      anon_sym_SEMI,
  [57686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 1,
      anon_sym_LBRACE,
    ACTIONS(3417), 1,
      anon_sym_SEMI,
  [57696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4471), 1,
      anon_sym_LBRACE,
    ACTIONS(4473), 1,
      anon_sym_COLON,
  [57706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    STATE(897), 1,
      sym_tuple_expression,
  [57716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4475), 1,
      anon_sym_LPAREN,
    STATE(1588), 1,
      sym__function_signature,
  [57726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4148), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [57734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    STATE(961), 1,
      sym_block,
  [57744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4477), 1,
      anon_sym_LPAREN,
    STATE(1572), 1,
      sym__function_signature,
  [57754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    STATE(917), 1,
      sym_tuple_expression,
  [57764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_LPAREN,
    STATE(1782), 1,
      sym__function_signature,
  [57774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4107), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [57782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3717), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [57790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4479), 1,
      anon_sym_LBRACE,
    ACTIONS(4481), 1,
      anon_sym_COLON,
  [57800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4483), 1,
      anon_sym_type,
    ACTIONS(4485), 1,
      anon_sym_fn,
  [57810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4487), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [57818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4489), 1,
      anon_sym_LBRACE,
    ACTIONS(4491), 1,
      anon_sym_COLON,
  [57828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4493), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [57836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4495), 1,
      anon_sym_LPAREN,
    ACTIONS(4497), 1,
      anon_sym_LBRACE,
  [57846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4322), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [57854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4499), 1,
      sym_identifier,
    STATE(515), 1,
      aux_sym_builtin_directive_repeat1,
  [57864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3551), 1,
      anon_sym_LPAREN,
    STATE(1756), 1,
      sym__function_signature,
  [57874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4501), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [57882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_PERCENT_LBRACE,
    STATE(922), 1,
      sym_hint,
  [57892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3510), 1,
      anon_sym_LBRACE,
    STATE(967), 1,
      sym_enum_variant_list,
  [57902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4503), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [57910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3559), 1,
      sym_identifier,
    STATE(1819), 1,
      sym_dotted_name,
  [57920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4505), 1,
      anon_sym_type,
    ACTIONS(4507), 1,
      anon_sym_fn,
  [57930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4060), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [57938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3683), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [57946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 1,
      anon_sym_LPAREN,
    STATE(1507), 1,
      sym_arguments,
  [57956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 1,
      anon_sym_RPAREN,
    ACTIONS(4363), 1,
      sym_identifier,
  [57966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4509), 1,
      sym_identifier,
    ACTIONS(4511), 1,
      anon_sym_RPAREN,
  [57976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4513), 2,
      sym_identifier,
      sym_self,
  [57984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_LBRACE,
    ACTIONS(4425), 1,
      anon_sym_SEMI,
  [57994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4515), 1,
      anon_sym_EQ,
    ACTIONS(4517), 1,
      anon_sym_SEMI,
  [58004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 1,
      anon_sym_RPAREN,
    ACTIONS(4519), 1,
      sym_identifier,
  [58014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3936), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [58022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4521), 1,
      anon_sym_PERCENT_RBRACE,
  [58029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_RBRACE,
  [58036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4525), 1,
      sym_identifier,
  [58043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4527), 1,
      sym_identifier,
  [58050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4529), 1,
      anon_sym_RBRACE,
  [58057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4531), 1,
      anon_sym_RBRACE,
  [58064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 1,
      anon_sym_SEMI,
  [58071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4533), 1,
      sym_identifier,
  [58078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4535), 1,
      anon_sym_PERCENT_RBRACE,
  [58085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_RBRACE,
  [58092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4537), 1,
      anon_sym_RBRACK,
  [58099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4539), 1,
      sym_identifier,
  [58106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4541), 1,
      sym_identifier,
  [58113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3134), 1,
      anon_sym_RBRACE,
  [58120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 1,
      anon_sym_EQ_GT,
  [58127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4545), 1,
      anon_sym_LPAREN,
  [58134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4547), 1,
      anon_sym_RBRACE,
  [58141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4363), 1,
      sym_identifier,
  [58148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4028), 1,
      sym_identifier,
  [58155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4549), 1,
      anon_sym_RPAREN,
  [58162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4551), 1,
      anon_sym_RPAREN,
  [58169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2872), 1,
      anon_sym_RBRACE,
  [58176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3909), 1,
      sym_identifier,
  [58183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4553), 1,
      anon_sym_RBRACE,
  [58190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4555), 1,
      sym_identifier,
  [58197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4557), 1,
      anon_sym_COLON_COLON,
  [58204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4559), 1,
      anon_sym_SEMI,
  [58211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4561), 1,
      anon_sym_EQ,
  [58218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4563), 1,
      sym_identifier,
  [58225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4565), 1,
      sym_identifier,
  [58232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3295), 1,
      sym_identifier,
  [58239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 1,
      anon_sym_COLON_COLON,
  [58246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4567), 1,
      anon_sym_EQ,
  [58253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 1,
      anon_sym_RBRACE,
  [58260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4569), 1,
      anon_sym_SEMI,
  [58267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4026), 1,
      anon_sym_RBRACE,
  [58274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 1,
      anon_sym_COLON_COLON,
  [58281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4571), 1,
      anon_sym_RBRACE,
  [58288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4573), 1,
      anon_sym_SEMI,
  [58295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4575), 1,
      anon_sym_RBRACE,
  [58302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 1,
      sym_identifier,
  [58309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1944), 1,
      anon_sym_RPAREN,
  [58316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_RBRACE,
  [58323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4579), 1,
      anon_sym_LPAREN,
  [58330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4128), 1,
      anon_sym_RBRACE,
  [58337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4377), 1,
      anon_sym_SEMI,
  [58344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_COLON,
  [58351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_COLON,
  [58358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4585), 1,
      anon_sym_LBRACE,
  [58365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4587), 1,
      sym_identifier,
  [58372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4589), 1,
      anon_sym_LPAREN,
  [58379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      sym_identifier,
  [58386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4593), 1,
      sym_identifier,
  [58393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4295), 1,
      anon_sym_RBRACE,
  [58400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4595), 1,
      anon_sym_EQ_GT,
  [58407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4597), 1,
      anon_sym_RBRACE,
  [58414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 1,
      sym_identifier,
  [58421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4301), 1,
      anon_sym_RBRACE,
  [58428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4599), 1,
      sym_identifier,
  [58435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_RPAREN,
  [58442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4603), 1,
      anon_sym_SEMI,
  [58449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_SEMI,
  [58456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4605), 1,
      anon_sym_SEMI,
  [58463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4607), 1,
      anon_sym_RBRACK,
  [58470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4609), 1,
      anon_sym_PERCENT_RBRACE,
  [58477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4611), 1,
      sym_identifier,
  [58484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 1,
      anon_sym_RBRACE,
  [58491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1554), 1,
      anon_sym_COLON_COLON,
  [58498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4613), 1,
      sym_identifier,
  [58505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      sym_identifier,
  [58512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4617), 1,
      anon_sym_COLON,
  [58519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_SEMI,
  [58526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4619), 1,
      anon_sym_RBRACK,
  [58533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4621), 1,
      anon_sym_RBRACK,
  [58540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4623), 1,
      sym_identifier,
  [58547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3742), 1,
      anon_sym_RBRACE,
  [58554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      sym_identifier,
  [58561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4627), 1,
      sym_identifier,
  [58568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4629), 1,
      anon_sym_LPAREN,
  [58575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4631), 1,
      anon_sym_LBRACE,
  [58582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LPAREN,
  [58589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4343), 1,
      anon_sym_SEMI,
  [58596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4635), 1,
      sym_identifier,
  [58603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4637), 1,
      anon_sym_RBRACE,
  [58610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4639), 1,
      anon_sym_RBRACE,
  [58617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4641), 1,
      ts_builtin_sym_end,
  [58624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4643), 1,
      anon_sym_PERCENT_RBRACE,
  [58631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4645), 1,
      sym_identifier,
  [58638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 1,
      anon_sym_SEMI,
  [58645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4647), 1,
      anon_sym_LPAREN,
  [58652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3239), 1,
      anon_sym_RPAREN,
  [58659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4649), 1,
      anon_sym_LPAREN,
  [58666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4651), 1,
      sym_identifier,
  [58673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4653), 1,
      anon_sym_LBRACE,
  [58680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4655), 1,
      sym_identifier,
  [58687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4657), 1,
      sym_identifier,
  [58694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4659), 1,
      sym_identifier,
  [58701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4661), 1,
      anon_sym_import,
  [58708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4663), 1,
      anon_sym_EQ,
  [58715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4665), 1,
      anon_sym_LBRACE,
  [58722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_COLON_COLON,
  [58729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_RBRACE,
  [58736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4667), 1,
      sym_identifier,
  [58743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4669), 1,
      anon_sym_COLON_COLON,
  [58750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4671), 1,
      anon_sym_EQ,
  [58757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(692), 1,
      anon_sym_COLON_COLON,
  [58764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4673), 1,
      anon_sym_ap,
  [58771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3966), 1,
      anon_sym_RBRACE,
  [58778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4675), 1,
      anon_sym_LPAREN,
  [58785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4677), 1,
      sym_identifier,
  [58792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4679), 1,
      anon_sym_PLUS_PLUS,
  [58799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4339), 1,
      anon_sym_RPAREN,
  [58806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4681), 1,
      anon_sym_LBRACE,
  [58813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4683), 1,
      anon_sym_RBRACE,
  [58820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4685), 1,
      anon_sym_COLON_COLON,
  [58827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4687), 1,
      anon_sym_of,
  [58834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4689), 1,
      sym_identifier,
  [58841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4691), 1,
      anon_sym_LPAREN,
  [58848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4693), 1,
      sym_identifier,
  [58855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4695), 1,
      ts_builtin_sym_end,
  [58862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4697), 1,
      anon_sym_RBRACK,
  [58869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4699), 1,
      anon_sym_RBRACK,
  [58876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4701), 1,
      sym_identifier,
  [58883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4703), 1,
      sym_identifier,
  [58890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4705), 1,
      anon_sym_RPAREN,
  [58897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4707), 1,
      anon_sym_RBRACK,
  [58904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_RBRACE,
  [58911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3824), 1,
      anon_sym_RBRACE,
  [58918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4709), 1,
      sym_identifier,
  [58925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_RBRACE,
  [58932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4711), 1,
      anon_sym_EQ,
  [58939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4713), 1,
      anon_sym_RBRACK,
  [58946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_COLON_COLON,
  [58953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2746), 1,
      anon_sym_RBRACE,
  [58960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4715), 1,
      anon_sym_RBRACE,
  [58967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4717), 1,
      anon_sym_LBRACE,
  [58974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4719), 1,
      anon_sym_COLON,
  [58981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4721), 1,
      sym_identifier,
  [58988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4723), 1,
      anon_sym_EQ,
  [58995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4725), 1,
      anon_sym_LBRACE,
  [59002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4727), 1,
      sym_identifier,
  [59009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_RPAREN,
  [59016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4729), 1,
      sym_identifier,
  [59023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3955), 1,
      sym_identifier,
  [59030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4731), 1,
      anon_sym_LBRACE,
  [59037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
  [59044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4735), 1,
      anon_sym_RBRACE,
  [59051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      sym_identifier,
  [59058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 1,
      anon_sym_RBRACE,
  [59065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym_RPAREN,
  [59072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4741), 1,
      anon_sym_LBRACE,
  [59079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4743), 1,
      anon_sym_LPAREN,
  [59086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4745), 1,
      anon_sym_SEMI,
  [59093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4747), 1,
      anon_sym_import,
  [59100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4749), 1,
      anon_sym_EQ,
  [59107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
  [59114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4753), 1,
      anon_sym_RPAREN,
  [59121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4755), 1,
      anon_sym_EQ_GT,
  [59128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4757), 1,
      anon_sym_LBRACE,
  [59135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 1,
      anon_sym_COLON_COLON,
  [59142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4759), 1,
      anon_sym_ap,
  [59149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_SEMI,
  [59156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3088), 1,
      anon_sym_RBRACE,
  [59163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 1,
      anon_sym_RBRACE,
  [59170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4763), 1,
      anon_sym_EQ,
  [59177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4765), 1,
      sym_identifier,
  [59184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4767), 1,
      anon_sym_SEMI,
  [59191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4769), 1,
      sym_identifier,
  [59198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4771), 1,
      anon_sym_RBRACK,
  [59205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3118), 1,
      anon_sym_RBRACE,
  [59212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4773), 1,
      sym_identifier,
  [59219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4775), 1,
      anon_sym_RPAREN,
  [59226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4777), 1,
      anon_sym_LPAREN,
  [59233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3092), 1,
      anon_sym_RBRACE,
  [59240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4779), 1,
      anon_sym_SEMI,
  [59247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4781), 1,
      anon_sym_RBRACE,
  [59254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3968), 1,
      anon_sym_RPAREN,
  [59261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4783), 1,
      sym_identifier,
  [59268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4785), 1,
      sym_identifier,
  [59275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4787), 1,
      anon_sym_LBRACE,
  [59282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4789), 1,
      anon_sym_SEMI,
  [59289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 1,
      anon_sym_RBRACE,
  [59296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4791), 1,
      anon_sym_SEMI,
  [59303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4793), 1,
      sym_identifier,
  [59310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4795), 1,
      anon_sym_LBRACE,
  [59317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_RBRACK,
  [59324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_EQ,
  [59331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4423), 1,
      anon_sym_SEMI,
  [59338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4799), 1,
      anon_sym_RBRACK,
  [59345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4801), 1,
      anon_sym_RPAREN,
  [59352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3126), 1,
      anon_sym_RBRACE,
  [59359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4803), 1,
      sym_identifier,
  [59366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4805), 1,
      sym_identifier,
  [59373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_EQ,
  [59380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4809), 1,
      sym_identifier,
  [59387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4811), 1,
      sym_identifier,
  [59394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4813), 1,
      anon_sym_EQ,
  [59401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4815), 1,
      sym_identifier,
  [59408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4817), 1,
      sym_identifier,
  [59415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4819), 1,
      sym_identifier,
  [59422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4821), 1,
      sym_identifier,
  [59429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4823), 1,
      sym_identifier,
  [59436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4825), 1,
      anon_sym_LBRACK,
  [59443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3691), 1,
      anon_sym_RBRACE,
  [59450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4827), 1,
      sym_identifier,
  [59457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4829), 1,
      anon_sym_PLUS_PLUS,
  [59464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4831), 1,
      anon_sym_SEMI,
  [59471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 1,
      anon_sym_of,
  [59478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4835), 1,
      sym_identifier,
  [59485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4837), 1,
      sym_identifier,
  [59492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4839), 1,
      anon_sym_EQ_GT,
  [59499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4841), 1,
      sym_identifier,
  [59506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3869), 1,
      sym_identifier,
  [59513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4843), 1,
      anon_sym_RBRACE,
  [59520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4845), 1,
      anon_sym_EQ,
  [59527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym_COLON,
  [59534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4849), 1,
      sym_identifier,
  [59541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4851), 1,
      sym_identifier,
  [59548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_RBRACK,
  [59555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 1,
      sym_identifier,
  [59562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 1,
      anon_sym_LPAREN,
  [59569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 1,
      anon_sym_LBRACK,
  [59576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4861), 1,
      sym_identifier,
  [59583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 1,
      sym_identifier,
  [59590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4865), 1,
      anon_sym_LPAREN,
  [59597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4437), 1,
      anon_sym_COLON,
  [59604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_LBRACK,
  [59611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4869), 1,
      anon_sym_LBRACE,
  [59618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN,
  [59625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4873), 1,
      anon_sym_LPAREN,
  [59632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4875), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(210)] = 0,
  [SMALL_STATE(211)] = 125,
  [SMALL_STATE(212)] = 200,
  [SMALL_STATE(213)] = 325,
  [SMALL_STATE(214)] = 450,
  [SMALL_STATE(215)] = 575,
  [SMALL_STATE(216)] = 700,
  [SMALL_STATE(217)] = 825,
  [SMALL_STATE(218)] = 950,
  [SMALL_STATE(219)] = 1075,
  [SMALL_STATE(220)] = 1197,
  [SMALL_STATE(221)] = 1319,
  [SMALL_STATE(222)] = 1441,
  [SMALL_STATE(223)] = 1563,
  [SMALL_STATE(224)] = 1633,
  [SMALL_STATE(225)] = 1703,
  [SMALL_STATE(226)] = 1825,
  [SMALL_STATE(227)] = 1947,
  [SMALL_STATE(228)] = 2069,
  [SMALL_STATE(229)] = 2191,
  [SMALL_STATE(230)] = 2313,
  [SMALL_STATE(231)] = 2435,
  [SMALL_STATE(232)] = 2557,
  [SMALL_STATE(233)] = 2679,
  [SMALL_STATE(234)] = 2801,
  [SMALL_STATE(235)] = 2923,
  [SMALL_STATE(236)] = 3045,
  [SMALL_STATE(237)] = 3167,
  [SMALL_STATE(238)] = 3289,
  [SMALL_STATE(239)] = 3413,
  [SMALL_STATE(240)] = 3535,
  [SMALL_STATE(241)] = 3657,
  [SMALL_STATE(242)] = 3779,
  [SMALL_STATE(243)] = 3901,
  [SMALL_STATE(244)] = 4023,
  [SMALL_STATE(245)] = 4145,
  [SMALL_STATE(246)] = 4267,
  [SMALL_STATE(247)] = 4389,
  [SMALL_STATE(248)] = 4511,
  [SMALL_STATE(249)] = 4633,
  [SMALL_STATE(250)] = 4755,
  [SMALL_STATE(251)] = 4877,
  [SMALL_STATE(252)] = 4999,
  [SMALL_STATE(253)] = 5121,
  [SMALL_STATE(254)] = 5245,
  [SMALL_STATE(255)] = 5367,
  [SMALL_STATE(256)] = 5489,
  [SMALL_STATE(257)] = 5611,
  [SMALL_STATE(258)] = 5733,
  [SMALL_STATE(259)] = 5855,
  [SMALL_STATE(260)] = 5977,
  [SMALL_STATE(261)] = 6099,
  [SMALL_STATE(262)] = 6221,
  [SMALL_STATE(263)] = 6343,
  [SMALL_STATE(264)] = 6465,
  [SMALL_STATE(265)] = 6587,
  [SMALL_STATE(266)] = 6709,
  [SMALL_STATE(267)] = 6833,
  [SMALL_STATE(268)] = 6955,
  [SMALL_STATE(269)] = 7077,
  [SMALL_STATE(270)] = 7199,
  [SMALL_STATE(271)] = 7321,
  [SMALL_STATE(272)] = 7443,
  [SMALL_STATE(273)] = 7565,
  [SMALL_STATE(274)] = 7687,
  [SMALL_STATE(275)] = 7809,
  [SMALL_STATE(276)] = 7931,
  [SMALL_STATE(277)] = 8053,
  [SMALL_STATE(278)] = 8175,
  [SMALL_STATE(279)] = 8297,
  [SMALL_STATE(280)] = 8419,
  [SMALL_STATE(281)] = 8541,
  [SMALL_STATE(282)] = 8663,
  [SMALL_STATE(283)] = 8785,
  [SMALL_STATE(284)] = 8907,
  [SMALL_STATE(285)] = 9029,
  [SMALL_STATE(286)] = 9151,
  [SMALL_STATE(287)] = 9273,
  [SMALL_STATE(288)] = 9395,
  [SMALL_STATE(289)] = 9517,
  [SMALL_STATE(290)] = 9639,
  [SMALL_STATE(291)] = 9761,
  [SMALL_STATE(292)] = 9883,
  [SMALL_STATE(293)] = 10005,
  [SMALL_STATE(294)] = 10129,
  [SMALL_STATE(295)] = 10251,
  [SMALL_STATE(296)] = 10373,
  [SMALL_STATE(297)] = 10495,
  [SMALL_STATE(298)] = 10617,
  [SMALL_STATE(299)] = 10739,
  [SMALL_STATE(300)] = 10861,
  [SMALL_STATE(301)] = 10983,
  [SMALL_STATE(302)] = 11105,
  [SMALL_STATE(303)] = 11227,
  [SMALL_STATE(304)] = 11296,
  [SMALL_STATE(305)] = 11365,
  [SMALL_STATE(306)] = 11434,
  [SMALL_STATE(307)] = 11503,
  [SMALL_STATE(308)] = 11576,
  [SMALL_STATE(309)] = 11649,
  [SMALL_STATE(310)] = 11722,
  [SMALL_STATE(311)] = 11791,
  [SMALL_STATE(312)] = 11864,
  [SMALL_STATE(313)] = 11933,
  [SMALL_STATE(314)] = 12002,
  [SMALL_STATE(315)] = 12061,
  [SMALL_STATE(316)] = 12120,
  [SMALL_STATE(317)] = 12179,
  [SMALL_STATE(318)] = 12238,
  [SMALL_STATE(319)] = 12297,
  [SMALL_STATE(320)] = 12356,
  [SMALL_STATE(321)] = 12415,
  [SMALL_STATE(322)] = 12474,
  [SMALL_STATE(323)] = 12533,
  [SMALL_STATE(324)] = 12592,
  [SMALL_STATE(325)] = 12651,
  [SMALL_STATE(326)] = 12710,
  [SMALL_STATE(327)] = 12769,
  [SMALL_STATE(328)] = 12828,
  [SMALL_STATE(329)] = 12887,
  [SMALL_STATE(330)] = 12946,
  [SMALL_STATE(331)] = 13005,
  [SMALL_STATE(332)] = 13064,
  [SMALL_STATE(333)] = 13123,
  [SMALL_STATE(334)] = 13182,
  [SMALL_STATE(335)] = 13241,
  [SMALL_STATE(336)] = 13300,
  [SMALL_STATE(337)] = 13359,
  [SMALL_STATE(338)] = 13418,
  [SMALL_STATE(339)] = 13477,
  [SMALL_STATE(340)] = 13536,
  [SMALL_STATE(341)] = 13595,
  [SMALL_STATE(342)] = 13654,
  [SMALL_STATE(343)] = 13713,
  [SMALL_STATE(344)] = 13772,
  [SMALL_STATE(345)] = 13831,
  [SMALL_STATE(346)] = 13890,
  [SMALL_STATE(347)] = 13949,
  [SMALL_STATE(348)] = 14008,
  [SMALL_STATE(349)] = 14067,
  [SMALL_STATE(350)] = 14126,
  [SMALL_STATE(351)] = 14185,
  [SMALL_STATE(352)] = 14244,
  [SMALL_STATE(353)] = 14303,
  [SMALL_STATE(354)] = 14362,
  [SMALL_STATE(355)] = 14421,
  [SMALL_STATE(356)] = 14480,
  [SMALL_STATE(357)] = 14539,
  [SMALL_STATE(358)] = 14598,
  [SMALL_STATE(359)] = 14657,
  [SMALL_STATE(360)] = 14716,
  [SMALL_STATE(361)] = 14775,
  [SMALL_STATE(362)] = 14834,
  [SMALL_STATE(363)] = 14893,
  [SMALL_STATE(364)] = 14952,
  [SMALL_STATE(365)] = 15011,
  [SMALL_STATE(366)] = 15070,
  [SMALL_STATE(367)] = 15129,
  [SMALL_STATE(368)] = 15188,
  [SMALL_STATE(369)] = 15247,
  [SMALL_STATE(370)] = 15306,
  [SMALL_STATE(371)] = 15365,
  [SMALL_STATE(372)] = 15424,
  [SMALL_STATE(373)] = 15483,
  [SMALL_STATE(374)] = 15542,
  [SMALL_STATE(375)] = 15601,
  [SMALL_STATE(376)] = 15660,
  [SMALL_STATE(377)] = 15719,
  [SMALL_STATE(378)] = 15778,
  [SMALL_STATE(379)] = 15837,
  [SMALL_STATE(380)] = 15896,
  [SMALL_STATE(381)] = 15955,
  [SMALL_STATE(382)] = 16014,
  [SMALL_STATE(383)] = 16073,
  [SMALL_STATE(384)] = 16132,
  [SMALL_STATE(385)] = 16191,
  [SMALL_STATE(386)] = 16250,
  [SMALL_STATE(387)] = 16309,
  [SMALL_STATE(388)] = 16368,
  [SMALL_STATE(389)] = 16427,
  [SMALL_STATE(390)] = 16489,
  [SMALL_STATE(391)] = 16575,
  [SMALL_STATE(392)] = 16658,
  [SMALL_STATE(393)] = 16710,
  [SMALL_STATE(394)] = 16795,
  [SMALL_STATE(395)] = 16880,
  [SMALL_STATE(396)] = 16965,
  [SMALL_STATE(397)] = 17021,
  [SMALL_STATE(398)] = 17103,
  [SMALL_STATE(399)] = 17159,
  [SMALL_STATE(400)] = 17209,
  [SMALL_STATE(401)] = 17263,
  [SMALL_STATE(402)] = 17317,
  [SMALL_STATE(403)] = 17371,
  [SMALL_STATE(404)] = 17425,
  [SMALL_STATE(405)] = 17479,
  [SMALL_STATE(406)] = 17561,
  [SMALL_STATE(407)] = 17611,
  [SMALL_STATE(408)] = 17693,
  [SMALL_STATE(409)] = 17744,
  [SMALL_STATE(410)] = 17823,
  [SMALL_STATE(411)] = 17876,
  [SMALL_STATE(412)] = 17925,
  [SMALL_STATE(413)] = 17978,
  [SMALL_STATE(414)] = 18027,
  [SMALL_STATE(415)] = 18078,
  [SMALL_STATE(416)] = 18127,
  [SMALL_STATE(417)] = 18180,
  [SMALL_STATE(418)] = 18229,
  [SMALL_STATE(419)] = 18284,
  [SMALL_STATE(420)] = 18335,
  [SMALL_STATE(421)] = 18384,
  [SMALL_STATE(422)] = 18433,
  [SMALL_STATE(423)] = 18482,
  [SMALL_STATE(424)] = 18533,
  [SMALL_STATE(425)] = 18584,
  [SMALL_STATE(426)] = 18636,
  [SMALL_STATE(427)] = 18690,
  [SMALL_STATE(428)] = 18738,
  [SMALL_STATE(429)] = 18786,
  [SMALL_STATE(430)] = 18834,
  [SMALL_STATE(431)] = 18882,
  [SMALL_STATE(432)] = 18930,
  [SMALL_STATE(433)] = 18978,
  [SMALL_STATE(434)] = 19026,
  [SMALL_STATE(435)] = 19074,
  [SMALL_STATE(436)] = 19148,
  [SMALL_STATE(437)] = 19196,
  [SMALL_STATE(438)] = 19244,
  [SMALL_STATE(439)] = 19292,
  [SMALL_STATE(440)] = 19346,
  [SMALL_STATE(441)] = 19394,
  [SMALL_STATE(442)] = 19446,
  [SMALL_STATE(443)] = 19494,
  [SMALL_STATE(444)] = 19542,
  [SMALL_STATE(445)] = 19590,
  [SMALL_STATE(446)] = 19644,
  [SMALL_STATE(447)] = 19696,
  [SMALL_STATE(448)] = 19748,
  [SMALL_STATE(449)] = 19796,
  [SMALL_STATE(450)] = 19844,
  [SMALL_STATE(451)] = 19892,
  [SMALL_STATE(452)] = 19940,
  [SMALL_STATE(453)] = 19988,
  [SMALL_STATE(454)] = 20036,
  [SMALL_STATE(455)] = 20086,
  [SMALL_STATE(456)] = 20140,
  [SMALL_STATE(457)] = 20188,
  [SMALL_STATE(458)] = 20242,
  [SMALL_STATE(459)] = 20290,
  [SMALL_STATE(460)] = 20338,
  [SMALL_STATE(461)] = 20386,
  [SMALL_STATE(462)] = 20434,
  [SMALL_STATE(463)] = 20482,
  [SMALL_STATE(464)] = 20530,
  [SMALL_STATE(465)] = 20578,
  [SMALL_STATE(466)] = 20626,
  [SMALL_STATE(467)] = 20674,
  [SMALL_STATE(468)] = 20722,
  [SMALL_STATE(469)] = 20770,
  [SMALL_STATE(470)] = 20844,
  [SMALL_STATE(471)] = 20892,
  [SMALL_STATE(472)] = 20940,
  [SMALL_STATE(473)] = 20988,
  [SMALL_STATE(474)] = 21036,
  [SMALL_STATE(475)] = 21084,
  [SMALL_STATE(476)] = 21132,
  [SMALL_STATE(477)] = 21206,
  [SMALL_STATE(478)] = 21254,
  [SMALL_STATE(479)] = 21328,
  [SMALL_STATE(480)] = 21376,
  [SMALL_STATE(481)] = 21424,
  [SMALL_STATE(482)] = 21472,
  [SMALL_STATE(483)] = 21520,
  [SMALL_STATE(484)] = 21568,
  [SMALL_STATE(485)] = 21616,
  [SMALL_STATE(486)] = 21664,
  [SMALL_STATE(487)] = 21712,
  [SMALL_STATE(488)] = 21760,
  [SMALL_STATE(489)] = 21808,
  [SMALL_STATE(490)] = 21882,
  [SMALL_STATE(491)] = 21956,
  [SMALL_STATE(492)] = 22004,
  [SMALL_STATE(493)] = 22052,
  [SMALL_STATE(494)] = 22100,
  [SMALL_STATE(495)] = 22148,
  [SMALL_STATE(496)] = 22202,
  [SMALL_STATE(497)] = 22250,
  [SMALL_STATE(498)] = 22298,
  [SMALL_STATE(499)] = 22346,
  [SMALL_STATE(500)] = 22394,
  [SMALL_STATE(501)] = 22469,
  [SMALL_STATE(502)] = 22518,
  [SMALL_STATE(503)] = 22569,
  [SMALL_STATE(504)] = 22618,
  [SMALL_STATE(505)] = 22673,
  [SMALL_STATE(506)] = 22746,
  [SMALL_STATE(507)] = 22811,
  [SMALL_STATE(508)] = 22884,
  [SMALL_STATE(509)] = 22945,
  [SMALL_STATE(510)] = 23002,
  [SMALL_STATE(511)] = 23065,
  [SMALL_STATE(512)] = 23134,
  [SMALL_STATE(513)] = 23205,
  [SMALL_STATE(514)] = 23260,
  [SMALL_STATE(515)] = 23319,
  [SMALL_STATE(516)] = 23370,
  [SMALL_STATE(517)] = 23447,
  [SMALL_STATE(518)] = 23502,
  [SMALL_STATE(519)] = 23557,
  [SMALL_STATE(520)] = 23604,
  [SMALL_STATE(521)] = 23659,
  [SMALL_STATE(522)] = 23708,
  [SMALL_STATE(523)] = 23761,
  [SMALL_STATE(524)] = 23812,
  [SMALL_STATE(525)] = 23883,
  [SMALL_STATE(526)] = 23934,
  [SMALL_STATE(527)] = 24009,
  [SMALL_STATE(528)] = 24064,
  [SMALL_STATE(529)] = 24119,
  [SMALL_STATE(530)] = 24196,
  [SMALL_STATE(531)] = 24243,
  [SMALL_STATE(532)] = 24318,
  [SMALL_STATE(533)] = 24371,
  [SMALL_STATE(534)] = 24422,
  [SMALL_STATE(535)] = 24477,
  [SMALL_STATE(536)] = 24528,
  [SMALL_STATE(537)] = 24581,
  [SMALL_STATE(538)] = 24652,
  [SMALL_STATE(539)] = 24723,
  [SMALL_STATE(540)] = 24798,
  [SMALL_STATE(541)] = 24869,
  [SMALL_STATE(542)] = 24924,
  [SMALL_STATE(543)] = 24971,
  [SMALL_STATE(544)] = 25017,
  [SMALL_STATE(545)] = 25063,
  [SMALL_STATE(546)] = 25109,
  [SMALL_STATE(547)] = 25155,
  [SMALL_STATE(548)] = 25201,
  [SMALL_STATE(549)] = 25247,
  [SMALL_STATE(550)] = 25293,
  [SMALL_STATE(551)] = 25339,
  [SMALL_STATE(552)] = 25409,
  [SMALL_STATE(553)] = 25455,
  [SMALL_STATE(554)] = 25501,
  [SMALL_STATE(555)] = 25547,
  [SMALL_STATE(556)] = 25593,
  [SMALL_STATE(557)] = 25639,
  [SMALL_STATE(558)] = 25685,
  [SMALL_STATE(559)] = 25731,
  [SMALL_STATE(560)] = 25777,
  [SMALL_STATE(561)] = 25823,
  [SMALL_STATE(562)] = 25869,
  [SMALL_STATE(563)] = 25915,
  [SMALL_STATE(564)] = 25961,
  [SMALL_STATE(565)] = 26007,
  [SMALL_STATE(566)] = 26053,
  [SMALL_STATE(567)] = 26099,
  [SMALL_STATE(568)] = 26145,
  [SMALL_STATE(569)] = 26191,
  [SMALL_STATE(570)] = 26237,
  [SMALL_STATE(571)] = 26283,
  [SMALL_STATE(572)] = 26329,
  [SMALL_STATE(573)] = 26375,
  [SMALL_STATE(574)] = 26421,
  [SMALL_STATE(575)] = 26467,
  [SMALL_STATE(576)] = 26515,
  [SMALL_STATE(577)] = 26561,
  [SMALL_STATE(578)] = 26607,
  [SMALL_STATE(579)] = 26653,
  [SMALL_STATE(580)] = 26703,
  [SMALL_STATE(581)] = 26749,
  [SMALL_STATE(582)] = 26795,
  [SMALL_STATE(583)] = 26841,
  [SMALL_STATE(584)] = 26887,
  [SMALL_STATE(585)] = 26933,
  [SMALL_STATE(586)] = 26983,
  [SMALL_STATE(587)] = 27029,
  [SMALL_STATE(588)] = 27075,
  [SMALL_STATE(589)] = 27121,
  [SMALL_STATE(590)] = 27167,
  [SMALL_STATE(591)] = 27213,
  [SMALL_STATE(592)] = 27259,
  [SMALL_STATE(593)] = 27305,
  [SMALL_STATE(594)] = 27351,
  [SMALL_STATE(595)] = 27399,
  [SMALL_STATE(596)] = 27445,
  [SMALL_STATE(597)] = 27491,
  [SMALL_STATE(598)] = 27537,
  [SMALL_STATE(599)] = 27583,
  [SMALL_STATE(600)] = 27628,
  [SMALL_STATE(601)] = 27673,
  [SMALL_STATE(602)] = 27718,
  [SMALL_STATE(603)] = 27763,
  [SMALL_STATE(604)] = 27808,
  [SMALL_STATE(605)] = 27853,
  [SMALL_STATE(606)] = 27898,
  [SMALL_STATE(607)] = 27943,
  [SMALL_STATE(608)] = 27988,
  [SMALL_STATE(609)] = 28059,
  [SMALL_STATE(610)] = 28130,
  [SMALL_STATE(611)] = 28175,
  [SMALL_STATE(612)] = 28220,
  [SMALL_STATE(613)] = 28265,
  [SMALL_STATE(614)] = 28310,
  [SMALL_STATE(615)] = 28355,
  [SMALL_STATE(616)] = 28400,
  [SMALL_STATE(617)] = 28445,
  [SMALL_STATE(618)] = 28490,
  [SMALL_STATE(619)] = 28535,
  [SMALL_STATE(620)] = 28580,
  [SMALL_STATE(621)] = 28625,
  [SMALL_STATE(622)] = 28670,
  [SMALL_STATE(623)] = 28715,
  [SMALL_STATE(624)] = 28760,
  [SMALL_STATE(625)] = 28805,
  [SMALL_STATE(626)] = 28850,
  [SMALL_STATE(627)] = 28895,
  [SMALL_STATE(628)] = 28966,
  [SMALL_STATE(629)] = 29011,
  [SMALL_STATE(630)] = 29056,
  [SMALL_STATE(631)] = 29101,
  [SMALL_STATE(632)] = 29146,
  [SMALL_STATE(633)] = 29191,
  [SMALL_STATE(634)] = 29236,
  [SMALL_STATE(635)] = 29281,
  [SMALL_STATE(636)] = 29326,
  [SMALL_STATE(637)] = 29371,
  [SMALL_STATE(638)] = 29416,
  [SMALL_STATE(639)] = 29461,
  [SMALL_STATE(640)] = 29506,
  [SMALL_STATE(641)] = 29577,
  [SMALL_STATE(642)] = 29622,
  [SMALL_STATE(643)] = 29667,
  [SMALL_STATE(644)] = 29712,
  [SMALL_STATE(645)] = 29783,
  [SMALL_STATE(646)] = 29828,
  [SMALL_STATE(647)] = 29873,
  [SMALL_STATE(648)] = 29918,
  [SMALL_STATE(649)] = 29989,
  [SMALL_STATE(650)] = 30034,
  [SMALL_STATE(651)] = 30079,
  [SMALL_STATE(652)] = 30124,
  [SMALL_STATE(653)] = 30169,
  [SMALL_STATE(654)] = 30214,
  [SMALL_STATE(655)] = 30282,
  [SMALL_STATE(656)] = 30360,
  [SMALL_STATE(657)] = 30428,
  [SMALL_STATE(658)] = 30506,
  [SMALL_STATE(659)] = 30556,
  [SMALL_STATE(660)] = 30606,
  [SMALL_STATE(661)] = 30672,
  [SMALL_STATE(662)] = 30750,
  [SMALL_STATE(663)] = 30828,
  [SMALL_STATE(664)] = 30894,
  [SMALL_STATE(665)] = 30972,
  [SMALL_STATE(666)] = 31050,
  [SMALL_STATE(667)] = 31128,
  [SMALL_STATE(668)] = 31206,
  [SMALL_STATE(669)] = 31284,
  [SMALL_STATE(670)] = 31362,
  [SMALL_STATE(671)] = 31440,
  [SMALL_STATE(672)] = 31506,
  [SMALL_STATE(673)] = 31584,
  [SMALL_STATE(674)] = 31659,
  [SMALL_STATE(675)] = 31722,
  [SMALL_STATE(676)] = 31797,
  [SMALL_STATE(677)] = 31872,
  [SMALL_STATE(678)] = 31945,
  [SMALL_STATE(679)] = 32018,
  [SMALL_STATE(680)] = 32091,
  [SMALL_STATE(681)] = 32154,
  [SMALL_STATE(682)] = 32229,
  [SMALL_STATE(683)] = 32304,
  [SMALL_STATE(684)] = 32369,
  [SMALL_STATE(685)] = 32442,
  [SMALL_STATE(686)] = 32517,
  [SMALL_STATE(687)] = 32592,
  [SMALL_STATE(688)] = 32667,
  [SMALL_STATE(689)] = 32740,
  [SMALL_STATE(690)] = 32803,
  [SMALL_STATE(691)] = 32876,
  [SMALL_STATE(692)] = 32949,
  [SMALL_STATE(693)] = 33014,
  [SMALL_STATE(694)] = 33077,
  [SMALL_STATE(695)] = 33152,
  [SMALL_STATE(696)] = 33215,
  [SMALL_STATE(697)] = 33278,
  [SMALL_STATE(698)] = 33351,
  [SMALL_STATE(699)] = 33414,
  [SMALL_STATE(700)] = 33477,
  [SMALL_STATE(701)] = 33552,
  [SMALL_STATE(702)] = 33615,
  [SMALL_STATE(703)] = 33678,
  [SMALL_STATE(704)] = 33751,
  [SMALL_STATE(705)] = 33814,
  [SMALL_STATE(706)] = 33877,
  [SMALL_STATE(707)] = 33940,
  [SMALL_STATE(708)] = 34003,
  [SMALL_STATE(709)] = 34066,
  [SMALL_STATE(710)] = 34129,
  [SMALL_STATE(711)] = 34192,
  [SMALL_STATE(712)] = 34267,
  [SMALL_STATE(713)] = 34342,
  [SMALL_STATE(714)] = 34405,
  [SMALL_STATE(715)] = 34468,
  [SMALL_STATE(716)] = 34541,
  [SMALL_STATE(717)] = 34606,
  [SMALL_STATE(718)] = 34671,
  [SMALL_STATE(719)] = 34746,
  [SMALL_STATE(720)] = 34809,
  [SMALL_STATE(721)] = 34872,
  [SMALL_STATE(722)] = 34935,
  [SMALL_STATE(723)] = 34998,
  [SMALL_STATE(724)] = 35061,
  [SMALL_STATE(725)] = 35124,
  [SMALL_STATE(726)] = 35197,
  [SMALL_STATE(727)] = 35272,
  [SMALL_STATE(728)] = 35335,
  [SMALL_STATE(729)] = 35410,
  [SMALL_STATE(730)] = 35473,
  [SMALL_STATE(731)] = 35536,
  [SMALL_STATE(732)] = 35599,
  [SMALL_STATE(733)] = 35662,
  [SMALL_STATE(734)] = 35725,
  [SMALL_STATE(735)] = 35788,
  [SMALL_STATE(736)] = 35853,
  [SMALL_STATE(737)] = 35916,
  [SMALL_STATE(738)] = 35979,
  [SMALL_STATE(739)] = 36042,
  [SMALL_STATE(740)] = 36115,
  [SMALL_STATE(741)] = 36178,
  [SMALL_STATE(742)] = 36241,
  [SMALL_STATE(743)] = 36304,
  [SMALL_STATE(744)] = 36367,
  [SMALL_STATE(745)] = 36430,
  [SMALL_STATE(746)] = 36495,
  [SMALL_STATE(747)] = 36558,
  [SMALL_STATE(748)] = 36633,
  [SMALL_STATE(749)] = 36696,
  [SMALL_STATE(750)] = 36768,
  [SMALL_STATE(751)] = 36840,
  [SMALL_STATE(752)] = 36912,
  [SMALL_STATE(753)] = 36984,
  [SMALL_STATE(754)] = 37056,
  [SMALL_STATE(755)] = 37108,
  [SMALL_STATE(756)] = 37180,
  [SMALL_STATE(757)] = 37252,
  [SMALL_STATE(758)] = 37324,
  [SMALL_STATE(759)] = 37396,
  [SMALL_STATE(760)] = 37468,
  [SMALL_STATE(761)] = 37540,
  [SMALL_STATE(762)] = 37598,
  [SMALL_STATE(763)] = 37662,
  [SMALL_STATE(764)] = 37722,
  [SMALL_STATE(765)] = 37788,
  [SMALL_STATE(766)] = 37860,
  [SMALL_STATE(767)] = 37932,
  [SMALL_STATE(768)] = 37982,
  [SMALL_STATE(769)] = 38054,
  [SMALL_STATE(770)] = 38126,
  [SMALL_STATE(771)] = 38198,
  [SMALL_STATE(772)] = 38266,
  [SMALL_STATE(773)] = 38320,
  [SMALL_STATE(774)] = 38388,
  [SMALL_STATE(775)] = 38460,
  [SMALL_STATE(776)] = 38530,
  [SMALL_STATE(777)] = 38602,
  [SMALL_STATE(778)] = 38674,
  [SMALL_STATE(779)] = 38730,
  [SMALL_STATE(780)] = 38783,
  [SMALL_STATE(781)] = 38836,
  [SMALL_STATE(782)] = 38886,
  [SMALL_STATE(783)] = 38952,
  [SMALL_STATE(784)] = 39002,
  [SMALL_STATE(785)] = 39052,
  [SMALL_STATE(786)] = 39102,
  [SMALL_STATE(787)] = 39167,
  [SMALL_STATE(788)] = 39232,
  [SMALL_STATE(789)] = 39297,
  [SMALL_STATE(790)] = 39362,
  [SMALL_STATE(791)] = 39427,
  [SMALL_STATE(792)] = 39465,
  [SMALL_STATE(793)] = 39503,
  [SMALL_STATE(794)] = 39538,
  [SMALL_STATE(795)] = 39585,
  [SMALL_STATE(796)] = 39620,
  [SMALL_STATE(797)] = 39667,
  [SMALL_STATE(798)] = 39725,
  [SMALL_STATE(799)] = 39783,
  [SMALL_STATE(800)] = 39839,
  [SMALL_STATE(801)] = 39897,
  [SMALL_STATE(802)] = 39955,
  [SMALL_STATE(803)] = 40013,
  [SMALL_STATE(804)] = 40069,
  [SMALL_STATE(805)] = 40127,
  [SMALL_STATE(806)] = 40168,
  [SMALL_STATE(807)] = 40221,
  [SMALL_STATE(808)] = 40274,
  [SMALL_STATE(809)] = 40327,
  [SMALL_STATE(810)] = 40380,
  [SMALL_STATE(811)] = 40421,
  [SMALL_STATE(812)] = 40474,
  [SMALL_STATE(813)] = 40527,
  [SMALL_STATE(814)] = 40568,
  [SMALL_STATE(815)] = 40618,
  [SMALL_STATE(816)] = 40668,
  [SMALL_STATE(817)] = 40718,
  [SMALL_STATE(818)] = 40768,
  [SMALL_STATE(819)] = 40818,
  [SMALL_STATE(820)] = 40868,
  [SMALL_STATE(821)] = 40918,
  [SMALL_STATE(822)] = 40968,
  [SMALL_STATE(823)] = 41018,
  [SMALL_STATE(824)] = 41068,
  [SMALL_STATE(825)] = 41118,
  [SMALL_STATE(826)] = 41168,
  [SMALL_STATE(827)] = 41218,
  [SMALL_STATE(828)] = 41270,
  [SMALL_STATE(829)] = 41320,
  [SMALL_STATE(830)] = 41370,
  [SMALL_STATE(831)] = 41420,
  [SMALL_STATE(832)] = 41470,
  [SMALL_STATE(833)] = 41520,
  [SMALL_STATE(834)] = 41572,
  [SMALL_STATE(835)] = 41622,
  [SMALL_STATE(836)] = 41674,
  [SMALL_STATE(837)] = 41724,
  [SMALL_STATE(838)] = 41774,
  [SMALL_STATE(839)] = 41824,
  [SMALL_STATE(840)] = 41874,
  [SMALL_STATE(841)] = 41924,
  [SMALL_STATE(842)] = 41974,
  [SMALL_STATE(843)] = 42024,
  [SMALL_STATE(844)] = 42074,
  [SMALL_STATE(845)] = 42124,
  [SMALL_STATE(846)] = 42174,
  [SMALL_STATE(847)] = 42224,
  [SMALL_STATE(848)] = 42274,
  [SMALL_STATE(849)] = 42324,
  [SMALL_STATE(850)] = 42374,
  [SMALL_STATE(851)] = 42424,
  [SMALL_STATE(852)] = 42474,
  [SMALL_STATE(853)] = 42524,
  [SMALL_STATE(854)] = 42574,
  [SMALL_STATE(855)] = 42624,
  [SMALL_STATE(856)] = 42674,
  [SMALL_STATE(857)] = 42724,
  [SMALL_STATE(858)] = 42774,
  [SMALL_STATE(859)] = 42824,
  [SMALL_STATE(860)] = 42874,
  [SMALL_STATE(861)] = 42924,
  [SMALL_STATE(862)] = 42974,
  [SMALL_STATE(863)] = 43024,
  [SMALL_STATE(864)] = 43074,
  [SMALL_STATE(865)] = 43112,
  [SMALL_STATE(866)] = 43156,
  [SMALL_STATE(867)] = 43198,
  [SMALL_STATE(868)] = 43236,
  [SMALL_STATE(869)] = 43286,
  [SMALL_STATE(870)] = 43334,
  [SMALL_STATE(871)] = 43372,
  [SMALL_STATE(872)] = 43410,
  [SMALL_STATE(873)] = 43436,
  [SMALL_STATE(874)] = 43462,
  [SMALL_STATE(875)] = 43504,
  [SMALL_STATE(876)] = 43542,
  [SMALL_STATE(877)] = 43588,
  [SMALL_STATE(878)] = 43628,
  [SMALL_STATE(879)] = 43666,
  [SMALL_STATE(880)] = 43706,
  [SMALL_STATE(881)] = 43750,
  [SMALL_STATE(882)] = 43797,
  [SMALL_STATE(883)] = 43846,
  [SMALL_STATE(884)] = 43871,
  [SMALL_STATE(885)] = 43896,
  [SMALL_STATE(886)] = 43945,
  [SMALL_STATE(887)] = 43994,
  [SMALL_STATE(888)] = 44043,
  [SMALL_STATE(889)] = 44092,
  [SMALL_STATE(890)] = 44117,
  [SMALL_STATE(891)] = 44142,
  [SMALL_STATE(892)] = 44167,
  [SMALL_STATE(893)] = 44192,
  [SMALL_STATE(894)] = 44217,
  [SMALL_STATE(895)] = 44242,
  [SMALL_STATE(896)] = 44267,
  [SMALL_STATE(897)] = 44292,
  [SMALL_STATE(898)] = 44317,
  [SMALL_STATE(899)] = 44342,
  [SMALL_STATE(900)] = 44367,
  [SMALL_STATE(901)] = 44392,
  [SMALL_STATE(902)] = 44417,
  [SMALL_STATE(903)] = 44466,
  [SMALL_STATE(904)] = 44515,
  [SMALL_STATE(905)] = 44540,
  [SMALL_STATE(906)] = 44589,
  [SMALL_STATE(907)] = 44614,
  [SMALL_STATE(908)] = 44639,
  [SMALL_STATE(909)] = 44664,
  [SMALL_STATE(910)] = 44689,
  [SMALL_STATE(911)] = 44714,
  [SMALL_STATE(912)] = 44739,
  [SMALL_STATE(913)] = 44788,
  [SMALL_STATE(914)] = 44813,
  [SMALL_STATE(915)] = 44862,
  [SMALL_STATE(916)] = 44911,
  [SMALL_STATE(917)] = 44956,
  [SMALL_STATE(918)] = 44981,
  [SMALL_STATE(919)] = 45026,
  [SMALL_STATE(920)] = 45075,
  [SMALL_STATE(921)] = 45100,
  [SMALL_STATE(922)] = 45149,
  [SMALL_STATE(923)] = 45174,
  [SMALL_STATE(924)] = 45221,
  [SMALL_STATE(925)] = 45246,
  [SMALL_STATE(926)] = 45295,
  [SMALL_STATE(927)] = 45342,
  [SMALL_STATE(928)] = 45367,
  [SMALL_STATE(929)] = 45416,
  [SMALL_STATE(930)] = 45441,
  [SMALL_STATE(931)] = 45466,
  [SMALL_STATE(932)] = 45491,
  [SMALL_STATE(933)] = 45540,
  [SMALL_STATE(934)] = 45565,
  [SMALL_STATE(935)] = 45590,
  [SMALL_STATE(936)] = 45615,
  [SMALL_STATE(937)] = 45640,
  [SMALL_STATE(938)] = 45687,
  [SMALL_STATE(939)] = 45712,
  [SMALL_STATE(940)] = 45761,
  [SMALL_STATE(941)] = 45783,
  [SMALL_STATE(942)] = 45809,
  [SMALL_STATE(943)] = 45835,
  [SMALL_STATE(944)] = 45865,
  [SMALL_STATE(945)] = 45891,
  [SMALL_STATE(946)] = 45913,
  [SMALL_STATE(947)] = 45943,
  [SMALL_STATE(948)] = 45987,
  [SMALL_STATE(949)] = 46013,
  [SMALL_STATE(950)] = 46039,
  [SMALL_STATE(951)] = 46082,
  [SMALL_STATE(952)] = 46125,
  [SMALL_STATE(953)] = 46168,
  [SMALL_STATE(954)] = 46211,
  [SMALL_STATE(955)] = 46254,
  [SMALL_STATE(956)] = 46297,
  [SMALL_STATE(957)] = 46340,
  [SMALL_STATE(958)] = 46383,
  [SMALL_STATE(959)] = 46408,
  [SMALL_STATE(960)] = 46428,
  [SMALL_STATE(961)] = 46448,
  [SMALL_STATE(962)] = 46468,
  [SMALL_STATE(963)] = 46488,
  [SMALL_STATE(964)] = 46508,
  [SMALL_STATE(965)] = 46528,
  [SMALL_STATE(966)] = 46548,
  [SMALL_STATE(967)] = 46568,
  [SMALL_STATE(968)] = 46588,
  [SMALL_STATE(969)] = 46608,
  [SMALL_STATE(970)] = 46628,
  [SMALL_STATE(971)] = 46648,
  [SMALL_STATE(972)] = 46668,
  [SMALL_STATE(973)] = 46688,
  [SMALL_STATE(974)] = 46708,
  [SMALL_STATE(975)] = 46728,
  [SMALL_STATE(976)] = 46770,
  [SMALL_STATE(977)] = 46790,
  [SMALL_STATE(978)] = 46810,
  [SMALL_STATE(979)] = 46830,
  [SMALL_STATE(980)] = 46850,
  [SMALL_STATE(981)] = 46870,
  [SMALL_STATE(982)] = 46890,
  [SMALL_STATE(983)] = 46910,
  [SMALL_STATE(984)] = 46930,
  [SMALL_STATE(985)] = 46950,
  [SMALL_STATE(986)] = 46970,
  [SMALL_STATE(987)] = 46990,
  [SMALL_STATE(988)] = 47010,
  [SMALL_STATE(989)] = 47030,
  [SMALL_STATE(990)] = 47050,
  [SMALL_STATE(991)] = 47070,
  [SMALL_STATE(992)] = 47090,
  [SMALL_STATE(993)] = 47110,
  [SMALL_STATE(994)] = 47130,
  [SMALL_STATE(995)] = 47150,
  [SMALL_STATE(996)] = 47170,
  [SMALL_STATE(997)] = 47190,
  [SMALL_STATE(998)] = 47232,
  [SMALL_STATE(999)] = 47252,
  [SMALL_STATE(1000)] = 47272,
  [SMALL_STATE(1001)] = 47292,
  [SMALL_STATE(1002)] = 47312,
  [SMALL_STATE(1003)] = 47332,
  [SMALL_STATE(1004)] = 47352,
  [SMALL_STATE(1005)] = 47372,
  [SMALL_STATE(1006)] = 47412,
  [SMALL_STATE(1007)] = 47432,
  [SMALL_STATE(1008)] = 47452,
  [SMALL_STATE(1009)] = 47472,
  [SMALL_STATE(1010)] = 47512,
  [SMALL_STATE(1011)] = 47532,
  [SMALL_STATE(1012)] = 47552,
  [SMALL_STATE(1013)] = 47572,
  [SMALL_STATE(1014)] = 47592,
  [SMALL_STATE(1015)] = 47612,
  [SMALL_STATE(1016)] = 47654,
  [SMALL_STATE(1017)] = 47674,
  [SMALL_STATE(1018)] = 47694,
  [SMALL_STATE(1019)] = 47714,
  [SMALL_STATE(1020)] = 47734,
  [SMALL_STATE(1021)] = 47754,
  [SMALL_STATE(1022)] = 47774,
  [SMALL_STATE(1023)] = 47794,
  [SMALL_STATE(1024)] = 47814,
  [SMALL_STATE(1025)] = 47834,
  [SMALL_STATE(1026)] = 47854,
  [SMALL_STATE(1027)] = 47874,
  [SMALL_STATE(1028)] = 47894,
  [SMALL_STATE(1029)] = 47914,
  [SMALL_STATE(1030)] = 47954,
  [SMALL_STATE(1031)] = 47996,
  [SMALL_STATE(1032)] = 48016,
  [SMALL_STATE(1033)] = 48036,
  [SMALL_STATE(1034)] = 48056,
  [SMALL_STATE(1035)] = 48076,
  [SMALL_STATE(1036)] = 48096,
  [SMALL_STATE(1037)] = 48116,
  [SMALL_STATE(1038)] = 48136,
  [SMALL_STATE(1039)] = 48159,
  [SMALL_STATE(1040)] = 48182,
  [SMALL_STATE(1041)] = 48213,
  [SMALL_STATE(1042)] = 48238,
  [SMALL_STATE(1043)] = 48271,
  [SMALL_STATE(1044)] = 48304,
  [SMALL_STATE(1045)] = 48337,
  [SMALL_STATE(1046)] = 48370,
  [SMALL_STATE(1047)] = 48403,
  [SMALL_STATE(1048)] = 48426,
  [SMALL_STATE(1049)] = 48459,
  [SMALL_STATE(1050)] = 48480,
  [SMALL_STATE(1051)] = 48500,
  [SMALL_STATE(1052)] = 48530,
  [SMALL_STATE(1053)] = 48560,
  [SMALL_STATE(1054)] = 48580,
  [SMALL_STATE(1055)] = 48610,
  [SMALL_STATE(1056)] = 48630,
  [SMALL_STATE(1057)] = 48660,
  [SMALL_STATE(1058)] = 48690,
  [SMALL_STATE(1059)] = 48720,
  [SMALL_STATE(1060)] = 48742,
  [SMALL_STATE(1061)] = 48772,
  [SMALL_STATE(1062)] = 48802,
  [SMALL_STATE(1063)] = 48824,
  [SMALL_STATE(1064)] = 48854,
  [SMALL_STATE(1065)] = 48884,
  [SMALL_STATE(1066)] = 48904,
  [SMALL_STATE(1067)] = 48924,
  [SMALL_STATE(1068)] = 48954,
  [SMALL_STATE(1069)] = 48978,
  [SMALL_STATE(1070)] = 49008,
  [SMALL_STATE(1071)] = 49038,
  [SMALL_STATE(1072)] = 49068,
  [SMALL_STATE(1073)] = 49088,
  [SMALL_STATE(1074)] = 49110,
  [SMALL_STATE(1075)] = 49130,
  [SMALL_STATE(1076)] = 49160,
  [SMALL_STATE(1077)] = 49179,
  [SMALL_STATE(1078)] = 49197,
  [SMALL_STATE(1079)] = 49225,
  [SMALL_STATE(1080)] = 49253,
  [SMALL_STATE(1081)] = 49281,
  [SMALL_STATE(1082)] = 49297,
  [SMALL_STATE(1083)] = 49313,
  [SMALL_STATE(1084)] = 49329,
  [SMALL_STATE(1085)] = 49351,
  [SMALL_STATE(1086)] = 49379,
  [SMALL_STATE(1087)] = 49407,
  [SMALL_STATE(1088)] = 49423,
  [SMALL_STATE(1089)] = 49439,
  [SMALL_STATE(1090)] = 49467,
  [SMALL_STATE(1091)] = 49483,
  [SMALL_STATE(1092)] = 49505,
  [SMALL_STATE(1093)] = 49521,
  [SMALL_STATE(1094)] = 49537,
  [SMALL_STATE(1095)] = 49564,
  [SMALL_STATE(1096)] = 49589,
  [SMALL_STATE(1097)] = 49614,
  [SMALL_STATE(1098)] = 49643,
  [SMALL_STATE(1099)] = 49659,
  [SMALL_STATE(1100)] = 49675,
  [SMALL_STATE(1101)] = 49691,
  [SMALL_STATE(1102)] = 49707,
  [SMALL_STATE(1103)] = 49723,
  [SMALL_STATE(1104)] = 49739,
  [SMALL_STATE(1105)] = 49757,
  [SMALL_STATE(1106)] = 49773,
  [SMALL_STATE(1107)] = 49789,
  [SMALL_STATE(1108)] = 49815,
  [SMALL_STATE(1109)] = 49831,
  [SMALL_STATE(1110)] = 49847,
  [SMALL_STATE(1111)] = 49863,
  [SMALL_STATE(1112)] = 49879,
  [SMALL_STATE(1113)] = 49895,
  [SMALL_STATE(1114)] = 49911,
  [SMALL_STATE(1115)] = 49927,
  [SMALL_STATE(1116)] = 49943,
  [SMALL_STATE(1117)] = 49959,
  [SMALL_STATE(1118)] = 49975,
  [SMALL_STATE(1119)] = 49995,
  [SMALL_STATE(1120)] = 50011,
  [SMALL_STATE(1121)] = 50027,
  [SMALL_STATE(1122)] = 50043,
  [SMALL_STATE(1123)] = 50071,
  [SMALL_STATE(1124)] = 50087,
  [SMALL_STATE(1125)] = 50103,
  [SMALL_STATE(1126)] = 50119,
  [SMALL_STATE(1127)] = 50135,
  [SMALL_STATE(1128)] = 50151,
  [SMALL_STATE(1129)] = 50173,
  [SMALL_STATE(1130)] = 50189,
  [SMALL_STATE(1131)] = 50212,
  [SMALL_STATE(1132)] = 50235,
  [SMALL_STATE(1133)] = 50260,
  [SMALL_STATE(1134)] = 50283,
  [SMALL_STATE(1135)] = 50306,
  [SMALL_STATE(1136)] = 50329,
  [SMALL_STATE(1137)] = 50352,
  [SMALL_STATE(1138)] = 50375,
  [SMALL_STATE(1139)] = 50398,
  [SMALL_STATE(1140)] = 50421,
  [SMALL_STATE(1141)] = 50444,
  [SMALL_STATE(1142)] = 50467,
  [SMALL_STATE(1143)] = 50490,
  [SMALL_STATE(1144)] = 50513,
  [SMALL_STATE(1145)] = 50538,
  [SMALL_STATE(1146)] = 50561,
  [SMALL_STATE(1147)] = 50584,
  [SMALL_STATE(1148)] = 50607,
  [SMALL_STATE(1149)] = 50625,
  [SMALL_STATE(1150)] = 50643,
  [SMALL_STATE(1151)] = 50655,
  [SMALL_STATE(1152)] = 50673,
  [SMALL_STATE(1153)] = 50691,
  [SMALL_STATE(1154)] = 50711,
  [SMALL_STATE(1155)] = 50731,
  [SMALL_STATE(1156)] = 50747,
  [SMALL_STATE(1157)] = 50765,
  [SMALL_STATE(1158)] = 50783,
  [SMALL_STATE(1159)] = 50801,
  [SMALL_STATE(1160)] = 50823,
  [SMALL_STATE(1161)] = 50841,
  [SMALL_STATE(1162)] = 50863,
  [SMALL_STATE(1163)] = 50885,
  [SMALL_STATE(1164)] = 50897,
  [SMALL_STATE(1165)] = 50913,
  [SMALL_STATE(1166)] = 50935,
  [SMALL_STATE(1167)] = 50951,
  [SMALL_STATE(1168)] = 50969,
  [SMALL_STATE(1169)] = 50991,
  [SMALL_STATE(1170)] = 51009,
  [SMALL_STATE(1171)] = 51027,
  [SMALL_STATE(1172)] = 51045,
  [SMALL_STATE(1173)] = 51063,
  [SMALL_STATE(1174)] = 51083,
  [SMALL_STATE(1175)] = 51101,
  [SMALL_STATE(1176)] = 51117,
  [SMALL_STATE(1177)] = 51135,
  [SMALL_STATE(1178)] = 51157,
  [SMALL_STATE(1179)] = 51177,
  [SMALL_STATE(1180)] = 51195,
  [SMALL_STATE(1181)] = 51210,
  [SMALL_STATE(1182)] = 51229,
  [SMALL_STATE(1183)] = 51248,
  [SMALL_STATE(1184)] = 51263,
  [SMALL_STATE(1185)] = 51282,
  [SMALL_STATE(1186)] = 51297,
  [SMALL_STATE(1187)] = 51316,
  [SMALL_STATE(1188)] = 51335,
  [SMALL_STATE(1189)] = 51354,
  [SMALL_STATE(1190)] = 51373,
  [SMALL_STATE(1191)] = 51392,
  [SMALL_STATE(1192)] = 51409,
  [SMALL_STATE(1193)] = 51426,
  [SMALL_STATE(1194)] = 51443,
  [SMALL_STATE(1195)] = 51462,
  [SMALL_STATE(1196)] = 51481,
  [SMALL_STATE(1197)] = 51498,
  [SMALL_STATE(1198)] = 51511,
  [SMALL_STATE(1199)] = 51524,
  [SMALL_STATE(1200)] = 51543,
  [SMALL_STATE(1201)] = 51558,
  [SMALL_STATE(1202)] = 51577,
  [SMALL_STATE(1203)] = 51594,
  [SMALL_STATE(1204)] = 51613,
  [SMALL_STATE(1205)] = 51632,
  [SMALL_STATE(1206)] = 51643,
  [SMALL_STATE(1207)] = 51660,
  [SMALL_STATE(1208)] = 51677,
  [SMALL_STATE(1209)] = 51688,
  [SMALL_STATE(1210)] = 51707,
  [SMALL_STATE(1211)] = 51726,
  [SMALL_STATE(1212)] = 51739,
  [SMALL_STATE(1213)] = 51758,
  [SMALL_STATE(1214)] = 51773,
  [SMALL_STATE(1215)] = 51790,
  [SMALL_STATE(1216)] = 51809,
  [SMALL_STATE(1217)] = 51824,
  [SMALL_STATE(1218)] = 51835,
  [SMALL_STATE(1219)] = 51854,
  [SMALL_STATE(1220)] = 51873,
  [SMALL_STATE(1221)] = 51890,
  [SMALL_STATE(1222)] = 51903,
  [SMALL_STATE(1223)] = 51922,
  [SMALL_STATE(1224)] = 51941,
  [SMALL_STATE(1225)] = 51960,
  [SMALL_STATE(1226)] = 51973,
  [SMALL_STATE(1227)] = 51990,
  [SMALL_STATE(1228)] = 52009,
  [SMALL_STATE(1229)] = 52020,
  [SMALL_STATE(1230)] = 52039,
  [SMALL_STATE(1231)] = 52058,
  [SMALL_STATE(1232)] = 52077,
  [SMALL_STATE(1233)] = 52096,
  [SMALL_STATE(1234)] = 52107,
  [SMALL_STATE(1235)] = 52118,
  [SMALL_STATE(1236)] = 52131,
  [SMALL_STATE(1237)] = 52150,
  [SMALL_STATE(1238)] = 52165,
  [SMALL_STATE(1239)] = 52178,
  [SMALL_STATE(1240)] = 52195,
  [SMALL_STATE(1241)] = 52206,
  [SMALL_STATE(1242)] = 52225,
  [SMALL_STATE(1243)] = 52242,
  [SMALL_STATE(1244)] = 52261,
  [SMALL_STATE(1245)] = 52280,
  [SMALL_STATE(1246)] = 52299,
  [SMALL_STATE(1247)] = 52312,
  [SMALL_STATE(1248)] = 52326,
  [SMALL_STATE(1249)] = 52342,
  [SMALL_STATE(1250)] = 52358,
  [SMALL_STATE(1251)] = 52374,
  [SMALL_STATE(1252)] = 52390,
  [SMALL_STATE(1253)] = 52406,
  [SMALL_STATE(1254)] = 52422,
  [SMALL_STATE(1255)] = 52438,
  [SMALL_STATE(1256)] = 52454,
  [SMALL_STATE(1257)] = 52468,
  [SMALL_STATE(1258)] = 52484,
  [SMALL_STATE(1259)] = 52500,
  [SMALL_STATE(1260)] = 52516,
  [SMALL_STATE(1261)] = 52532,
  [SMALL_STATE(1262)] = 52548,
  [SMALL_STATE(1263)] = 52564,
  [SMALL_STATE(1264)] = 52578,
  [SMALL_STATE(1265)] = 52594,
  [SMALL_STATE(1266)] = 52610,
  [SMALL_STATE(1267)] = 52626,
  [SMALL_STATE(1268)] = 52642,
  [SMALL_STATE(1269)] = 52658,
  [SMALL_STATE(1270)] = 52674,
  [SMALL_STATE(1271)] = 52690,
  [SMALL_STATE(1272)] = 52706,
  [SMALL_STATE(1273)] = 52716,
  [SMALL_STATE(1274)] = 52732,
  [SMALL_STATE(1275)] = 52748,
  [SMALL_STATE(1276)] = 52764,
  [SMALL_STATE(1277)] = 52780,
  [SMALL_STATE(1278)] = 52796,
  [SMALL_STATE(1279)] = 52812,
  [SMALL_STATE(1280)] = 52828,
  [SMALL_STATE(1281)] = 52844,
  [SMALL_STATE(1282)] = 52860,
  [SMALL_STATE(1283)] = 52874,
  [SMALL_STATE(1284)] = 52890,
  [SMALL_STATE(1285)] = 52906,
  [SMALL_STATE(1286)] = 52922,
  [SMALL_STATE(1287)] = 52938,
  [SMALL_STATE(1288)] = 52954,
  [SMALL_STATE(1289)] = 52970,
  [SMALL_STATE(1290)] = 52986,
  [SMALL_STATE(1291)] = 53002,
  [SMALL_STATE(1292)] = 53018,
  [SMALL_STATE(1293)] = 53034,
  [SMALL_STATE(1294)] = 53048,
  [SMALL_STATE(1295)] = 53064,
  [SMALL_STATE(1296)] = 53080,
  [SMALL_STATE(1297)] = 53096,
  [SMALL_STATE(1298)] = 53112,
  [SMALL_STATE(1299)] = 53128,
  [SMALL_STATE(1300)] = 53144,
  [SMALL_STATE(1301)] = 53160,
  [SMALL_STATE(1302)] = 53176,
  [SMALL_STATE(1303)] = 53192,
  [SMALL_STATE(1304)] = 53208,
  [SMALL_STATE(1305)] = 53224,
  [SMALL_STATE(1306)] = 53240,
  [SMALL_STATE(1307)] = 53250,
  [SMALL_STATE(1308)] = 53266,
  [SMALL_STATE(1309)] = 53282,
  [SMALL_STATE(1310)] = 53296,
  [SMALL_STATE(1311)] = 53312,
  [SMALL_STATE(1312)] = 53328,
  [SMALL_STATE(1313)] = 53344,
  [SMALL_STATE(1314)] = 53360,
  [SMALL_STATE(1315)] = 53376,
  [SMALL_STATE(1316)] = 53392,
  [SMALL_STATE(1317)] = 53408,
  [SMALL_STATE(1318)] = 53424,
  [SMALL_STATE(1319)] = 53438,
  [SMALL_STATE(1320)] = 53454,
  [SMALL_STATE(1321)] = 53468,
  [SMALL_STATE(1322)] = 53484,
  [SMALL_STATE(1323)] = 53500,
  [SMALL_STATE(1324)] = 53516,
  [SMALL_STATE(1325)] = 53532,
  [SMALL_STATE(1326)] = 53548,
  [SMALL_STATE(1327)] = 53564,
  [SMALL_STATE(1328)] = 53574,
  [SMALL_STATE(1329)] = 53590,
  [SMALL_STATE(1330)] = 53606,
  [SMALL_STATE(1331)] = 53622,
  [SMALL_STATE(1332)] = 53638,
  [SMALL_STATE(1333)] = 53651,
  [SMALL_STATE(1334)] = 53662,
  [SMALL_STATE(1335)] = 53675,
  [SMALL_STATE(1336)] = 53686,
  [SMALL_STATE(1337)] = 53697,
  [SMALL_STATE(1338)] = 53710,
  [SMALL_STATE(1339)] = 53723,
  [SMALL_STATE(1340)] = 53734,
  [SMALL_STATE(1341)] = 53747,
  [SMALL_STATE(1342)] = 53760,
  [SMALL_STATE(1343)] = 53773,
  [SMALL_STATE(1344)] = 53786,
  [SMALL_STATE(1345)] = 53799,
  [SMALL_STATE(1346)] = 53812,
  [SMALL_STATE(1347)] = 53823,
  [SMALL_STATE(1348)] = 53836,
  [SMALL_STATE(1349)] = 53849,
  [SMALL_STATE(1350)] = 53862,
  [SMALL_STATE(1351)] = 53875,
  [SMALL_STATE(1352)] = 53888,
  [SMALL_STATE(1353)] = 53901,
  [SMALL_STATE(1354)] = 53914,
  [SMALL_STATE(1355)] = 53923,
  [SMALL_STATE(1356)] = 53936,
  [SMALL_STATE(1357)] = 53947,
  [SMALL_STATE(1358)] = 53960,
  [SMALL_STATE(1359)] = 53973,
  [SMALL_STATE(1360)] = 53986,
  [SMALL_STATE(1361)] = 53999,
  [SMALL_STATE(1362)] = 54012,
  [SMALL_STATE(1363)] = 54025,
  [SMALL_STATE(1364)] = 54038,
  [SMALL_STATE(1365)] = 54051,
  [SMALL_STATE(1366)] = 54064,
  [SMALL_STATE(1367)] = 54075,
  [SMALL_STATE(1368)] = 54088,
  [SMALL_STATE(1369)] = 54101,
  [SMALL_STATE(1370)] = 54114,
  [SMALL_STATE(1371)] = 54125,
  [SMALL_STATE(1372)] = 54138,
  [SMALL_STATE(1373)] = 54151,
  [SMALL_STATE(1374)] = 54164,
  [SMALL_STATE(1375)] = 54177,
  [SMALL_STATE(1376)] = 54190,
  [SMALL_STATE(1377)] = 54203,
  [SMALL_STATE(1378)] = 54216,
  [SMALL_STATE(1379)] = 54229,
  [SMALL_STATE(1380)] = 54242,
  [SMALL_STATE(1381)] = 54255,
  [SMALL_STATE(1382)] = 54264,
  [SMALL_STATE(1383)] = 54277,
  [SMALL_STATE(1384)] = 54290,
  [SMALL_STATE(1385)] = 54303,
  [SMALL_STATE(1386)] = 54316,
  [SMALL_STATE(1387)] = 54329,
  [SMALL_STATE(1388)] = 54342,
  [SMALL_STATE(1389)] = 54355,
  [SMALL_STATE(1390)] = 54368,
  [SMALL_STATE(1391)] = 54379,
  [SMALL_STATE(1392)] = 54390,
  [SMALL_STATE(1393)] = 54399,
  [SMALL_STATE(1394)] = 54412,
  [SMALL_STATE(1395)] = 54425,
  [SMALL_STATE(1396)] = 54438,
  [SMALL_STATE(1397)] = 54451,
  [SMALL_STATE(1398)] = 54464,
  [SMALL_STATE(1399)] = 54477,
  [SMALL_STATE(1400)] = 54488,
  [SMALL_STATE(1401)] = 54501,
  [SMALL_STATE(1402)] = 54514,
  [SMALL_STATE(1403)] = 54523,
  [SMALL_STATE(1404)] = 54536,
  [SMALL_STATE(1405)] = 54549,
  [SMALL_STATE(1406)] = 54562,
  [SMALL_STATE(1407)] = 54573,
  [SMALL_STATE(1408)] = 54586,
  [SMALL_STATE(1409)] = 54597,
  [SMALL_STATE(1410)] = 54610,
  [SMALL_STATE(1411)] = 54621,
  [SMALL_STATE(1412)] = 54634,
  [SMALL_STATE(1413)] = 54647,
  [SMALL_STATE(1414)] = 54660,
  [SMALL_STATE(1415)] = 54673,
  [SMALL_STATE(1416)] = 54684,
  [SMALL_STATE(1417)] = 54695,
  [SMALL_STATE(1418)] = 54708,
  [SMALL_STATE(1419)] = 54721,
  [SMALL_STATE(1420)] = 54734,
  [SMALL_STATE(1421)] = 54747,
  [SMALL_STATE(1422)] = 54756,
  [SMALL_STATE(1423)] = 54769,
  [SMALL_STATE(1424)] = 54782,
  [SMALL_STATE(1425)] = 54795,
  [SMALL_STATE(1426)] = 54804,
  [SMALL_STATE(1427)] = 54817,
  [SMALL_STATE(1428)] = 54830,
  [SMALL_STATE(1429)] = 54843,
  [SMALL_STATE(1430)] = 54856,
  [SMALL_STATE(1431)] = 54867,
  [SMALL_STATE(1432)] = 54880,
  [SMALL_STATE(1433)] = 54893,
  [SMALL_STATE(1434)] = 54904,
  [SMALL_STATE(1435)] = 54917,
  [SMALL_STATE(1436)] = 54930,
  [SMALL_STATE(1437)] = 54941,
  [SMALL_STATE(1438)] = 54954,
  [SMALL_STATE(1439)] = 54967,
  [SMALL_STATE(1440)] = 54980,
  [SMALL_STATE(1441)] = 54993,
  [SMALL_STATE(1442)] = 55004,
  [SMALL_STATE(1443)] = 55017,
  [SMALL_STATE(1444)] = 55030,
  [SMALL_STATE(1445)] = 55043,
  [SMALL_STATE(1446)] = 55056,
  [SMALL_STATE(1447)] = 55069,
  [SMALL_STATE(1448)] = 55080,
  [SMALL_STATE(1449)] = 55089,
  [SMALL_STATE(1450)] = 55102,
  [SMALL_STATE(1451)] = 55115,
  [SMALL_STATE(1452)] = 55124,
  [SMALL_STATE(1453)] = 55137,
  [SMALL_STATE(1454)] = 55150,
  [SMALL_STATE(1455)] = 55161,
  [SMALL_STATE(1456)] = 55174,
  [SMALL_STATE(1457)] = 55187,
  [SMALL_STATE(1458)] = 55200,
  [SMALL_STATE(1459)] = 55213,
  [SMALL_STATE(1460)] = 55226,
  [SMALL_STATE(1461)] = 55239,
  [SMALL_STATE(1462)] = 55252,
  [SMALL_STATE(1463)] = 55265,
  [SMALL_STATE(1464)] = 55278,
  [SMALL_STATE(1465)] = 55291,
  [SMALL_STATE(1466)] = 55304,
  [SMALL_STATE(1467)] = 55317,
  [SMALL_STATE(1468)] = 55330,
  [SMALL_STATE(1469)] = 55343,
  [SMALL_STATE(1470)] = 55356,
  [SMALL_STATE(1471)] = 55367,
  [SMALL_STATE(1472)] = 55378,
  [SMALL_STATE(1473)] = 55391,
  [SMALL_STATE(1474)] = 55404,
  [SMALL_STATE(1475)] = 55417,
  [SMALL_STATE(1476)] = 55430,
  [SMALL_STATE(1477)] = 55443,
  [SMALL_STATE(1478)] = 55452,
  [SMALL_STATE(1479)] = 55465,
  [SMALL_STATE(1480)] = 55478,
  [SMALL_STATE(1481)] = 55489,
  [SMALL_STATE(1482)] = 55500,
  [SMALL_STATE(1483)] = 55513,
  [SMALL_STATE(1484)] = 55526,
  [SMALL_STATE(1485)] = 55539,
  [SMALL_STATE(1486)] = 55548,
  [SMALL_STATE(1487)] = 55561,
  [SMALL_STATE(1488)] = 55574,
  [SMALL_STATE(1489)] = 55583,
  [SMALL_STATE(1490)] = 55592,
  [SMALL_STATE(1491)] = 55603,
  [SMALL_STATE(1492)] = 55616,
  [SMALL_STATE(1493)] = 55629,
  [SMALL_STATE(1494)] = 55642,
  [SMALL_STATE(1495)] = 55655,
  [SMALL_STATE(1496)] = 55668,
  [SMALL_STATE(1497)] = 55681,
  [SMALL_STATE(1498)] = 55694,
  [SMALL_STATE(1499)] = 55705,
  [SMALL_STATE(1500)] = 55718,
  [SMALL_STATE(1501)] = 55731,
  [SMALL_STATE(1502)] = 55744,
  [SMALL_STATE(1503)] = 55755,
  [SMALL_STATE(1504)] = 55768,
  [SMALL_STATE(1505)] = 55777,
  [SMALL_STATE(1506)] = 55790,
  [SMALL_STATE(1507)] = 55803,
  [SMALL_STATE(1508)] = 55816,
  [SMALL_STATE(1509)] = 55829,
  [SMALL_STATE(1510)] = 55842,
  [SMALL_STATE(1511)] = 55855,
  [SMALL_STATE(1512)] = 55868,
  [SMALL_STATE(1513)] = 55879,
  [SMALL_STATE(1514)] = 55892,
  [SMALL_STATE(1515)] = 55905,
  [SMALL_STATE(1516)] = 55916,
  [SMALL_STATE(1517)] = 55927,
  [SMALL_STATE(1518)] = 55940,
  [SMALL_STATE(1519)] = 55953,
  [SMALL_STATE(1520)] = 55966,
  [SMALL_STATE(1521)] = 55979,
  [SMALL_STATE(1522)] = 55992,
  [SMALL_STATE(1523)] = 56003,
  [SMALL_STATE(1524)] = 56014,
  [SMALL_STATE(1525)] = 56027,
  [SMALL_STATE(1526)] = 56040,
  [SMALL_STATE(1527)] = 56053,
  [SMALL_STATE(1528)] = 56066,
  [SMALL_STATE(1529)] = 56079,
  [SMALL_STATE(1530)] = 56092,
  [SMALL_STATE(1531)] = 56105,
  [SMALL_STATE(1532)] = 56118,
  [SMALL_STATE(1533)] = 56131,
  [SMALL_STATE(1534)] = 56144,
  [SMALL_STATE(1535)] = 56153,
  [SMALL_STATE(1536)] = 56166,
  [SMALL_STATE(1537)] = 56179,
  [SMALL_STATE(1538)] = 56192,
  [SMALL_STATE(1539)] = 56205,
  [SMALL_STATE(1540)] = 56218,
  [SMALL_STATE(1541)] = 56231,
  [SMALL_STATE(1542)] = 56244,
  [SMALL_STATE(1543)] = 56257,
  [SMALL_STATE(1544)] = 56268,
  [SMALL_STATE(1545)] = 56281,
  [SMALL_STATE(1546)] = 56294,
  [SMALL_STATE(1547)] = 56307,
  [SMALL_STATE(1548)] = 56320,
  [SMALL_STATE(1549)] = 56333,
  [SMALL_STATE(1550)] = 56346,
  [SMALL_STATE(1551)] = 56359,
  [SMALL_STATE(1552)] = 56372,
  [SMALL_STATE(1553)] = 56383,
  [SMALL_STATE(1554)] = 56396,
  [SMALL_STATE(1555)] = 56409,
  [SMALL_STATE(1556)] = 56420,
  [SMALL_STATE(1557)] = 56433,
  [SMALL_STATE(1558)] = 56446,
  [SMALL_STATE(1559)] = 56459,
  [SMALL_STATE(1560)] = 56472,
  [SMALL_STATE(1561)] = 56485,
  [SMALL_STATE(1562)] = 56498,
  [SMALL_STATE(1563)] = 56511,
  [SMALL_STATE(1564)] = 56522,
  [SMALL_STATE(1565)] = 56535,
  [SMALL_STATE(1566)] = 56544,
  [SMALL_STATE(1567)] = 56557,
  [SMALL_STATE(1568)] = 56570,
  [SMALL_STATE(1569)] = 56583,
  [SMALL_STATE(1570)] = 56596,
  [SMALL_STATE(1571)] = 56606,
  [SMALL_STATE(1572)] = 56616,
  [SMALL_STATE(1573)] = 56626,
  [SMALL_STATE(1574)] = 56636,
  [SMALL_STATE(1575)] = 56646,
  [SMALL_STATE(1576)] = 56656,
  [SMALL_STATE(1577)] = 56666,
  [SMALL_STATE(1578)] = 56676,
  [SMALL_STATE(1579)] = 56684,
  [SMALL_STATE(1580)] = 56692,
  [SMALL_STATE(1581)] = 56700,
  [SMALL_STATE(1582)] = 56710,
  [SMALL_STATE(1583)] = 56720,
  [SMALL_STATE(1584)] = 56730,
  [SMALL_STATE(1585)] = 56738,
  [SMALL_STATE(1586)] = 56748,
  [SMALL_STATE(1587)] = 56758,
  [SMALL_STATE(1588)] = 56768,
  [SMALL_STATE(1589)] = 56778,
  [SMALL_STATE(1590)] = 56788,
  [SMALL_STATE(1591)] = 56798,
  [SMALL_STATE(1592)] = 56806,
  [SMALL_STATE(1593)] = 56816,
  [SMALL_STATE(1594)] = 56826,
  [SMALL_STATE(1595)] = 56836,
  [SMALL_STATE(1596)] = 56844,
  [SMALL_STATE(1597)] = 56854,
  [SMALL_STATE(1598)] = 56864,
  [SMALL_STATE(1599)] = 56872,
  [SMALL_STATE(1600)] = 56880,
  [SMALL_STATE(1601)] = 56890,
  [SMALL_STATE(1602)] = 56900,
  [SMALL_STATE(1603)] = 56910,
  [SMALL_STATE(1604)] = 56918,
  [SMALL_STATE(1605)] = 56928,
  [SMALL_STATE(1606)] = 56938,
  [SMALL_STATE(1607)] = 56946,
  [SMALL_STATE(1608)] = 56954,
  [SMALL_STATE(1609)] = 56964,
  [SMALL_STATE(1610)] = 56974,
  [SMALL_STATE(1611)] = 56984,
  [SMALL_STATE(1612)] = 56994,
  [SMALL_STATE(1613)] = 57004,
  [SMALL_STATE(1614)] = 57014,
  [SMALL_STATE(1615)] = 57024,
  [SMALL_STATE(1616)] = 57034,
  [SMALL_STATE(1617)] = 57044,
  [SMALL_STATE(1618)] = 57054,
  [SMALL_STATE(1619)] = 57062,
  [SMALL_STATE(1620)] = 57070,
  [SMALL_STATE(1621)] = 57080,
  [SMALL_STATE(1622)] = 57088,
  [SMALL_STATE(1623)] = 57096,
  [SMALL_STATE(1624)] = 57106,
  [SMALL_STATE(1625)] = 57116,
  [SMALL_STATE(1626)] = 57126,
  [SMALL_STATE(1627)] = 57134,
  [SMALL_STATE(1628)] = 57144,
  [SMALL_STATE(1629)] = 57154,
  [SMALL_STATE(1630)] = 57162,
  [SMALL_STATE(1631)] = 57170,
  [SMALL_STATE(1632)] = 57178,
  [SMALL_STATE(1633)] = 57188,
  [SMALL_STATE(1634)] = 57196,
  [SMALL_STATE(1635)] = 57204,
  [SMALL_STATE(1636)] = 57214,
  [SMALL_STATE(1637)] = 57224,
  [SMALL_STATE(1638)] = 57232,
  [SMALL_STATE(1639)] = 57240,
  [SMALL_STATE(1640)] = 57248,
  [SMALL_STATE(1641)] = 57258,
  [SMALL_STATE(1642)] = 57266,
  [SMALL_STATE(1643)] = 57276,
  [SMALL_STATE(1644)] = 57284,
  [SMALL_STATE(1645)] = 57292,
  [SMALL_STATE(1646)] = 57302,
  [SMALL_STATE(1647)] = 57310,
  [SMALL_STATE(1648)] = 57320,
  [SMALL_STATE(1649)] = 57330,
  [SMALL_STATE(1650)] = 57340,
  [SMALL_STATE(1651)] = 57350,
  [SMALL_STATE(1652)] = 57358,
  [SMALL_STATE(1653)] = 57368,
  [SMALL_STATE(1654)] = 57378,
  [SMALL_STATE(1655)] = 57388,
  [SMALL_STATE(1656)] = 57398,
  [SMALL_STATE(1657)] = 57408,
  [SMALL_STATE(1658)] = 57416,
  [SMALL_STATE(1659)] = 57426,
  [SMALL_STATE(1660)] = 57436,
  [SMALL_STATE(1661)] = 57446,
  [SMALL_STATE(1662)] = 57456,
  [SMALL_STATE(1663)] = 57466,
  [SMALL_STATE(1664)] = 57476,
  [SMALL_STATE(1665)] = 57486,
  [SMALL_STATE(1666)] = 57496,
  [SMALL_STATE(1667)] = 57506,
  [SMALL_STATE(1668)] = 57514,
  [SMALL_STATE(1669)] = 57524,
  [SMALL_STATE(1670)] = 57534,
  [SMALL_STATE(1671)] = 57544,
  [SMALL_STATE(1672)] = 57554,
  [SMALL_STATE(1673)] = 57562,
  [SMALL_STATE(1674)] = 57572,
  [SMALL_STATE(1675)] = 57582,
  [SMALL_STATE(1676)] = 57590,
  [SMALL_STATE(1677)] = 57600,
  [SMALL_STATE(1678)] = 57608,
  [SMALL_STATE(1679)] = 57618,
  [SMALL_STATE(1680)] = 57626,
  [SMALL_STATE(1681)] = 57636,
  [SMALL_STATE(1682)] = 57646,
  [SMALL_STATE(1683)] = 57656,
  [SMALL_STATE(1684)] = 57666,
  [SMALL_STATE(1685)] = 57676,
  [SMALL_STATE(1686)] = 57686,
  [SMALL_STATE(1687)] = 57696,
  [SMALL_STATE(1688)] = 57706,
  [SMALL_STATE(1689)] = 57716,
  [SMALL_STATE(1690)] = 57726,
  [SMALL_STATE(1691)] = 57734,
  [SMALL_STATE(1692)] = 57744,
  [SMALL_STATE(1693)] = 57754,
  [SMALL_STATE(1694)] = 57764,
  [SMALL_STATE(1695)] = 57774,
  [SMALL_STATE(1696)] = 57782,
  [SMALL_STATE(1697)] = 57790,
  [SMALL_STATE(1698)] = 57800,
  [SMALL_STATE(1699)] = 57810,
  [SMALL_STATE(1700)] = 57818,
  [SMALL_STATE(1701)] = 57828,
  [SMALL_STATE(1702)] = 57836,
  [SMALL_STATE(1703)] = 57846,
  [SMALL_STATE(1704)] = 57854,
  [SMALL_STATE(1705)] = 57864,
  [SMALL_STATE(1706)] = 57874,
  [SMALL_STATE(1707)] = 57882,
  [SMALL_STATE(1708)] = 57892,
  [SMALL_STATE(1709)] = 57902,
  [SMALL_STATE(1710)] = 57910,
  [SMALL_STATE(1711)] = 57920,
  [SMALL_STATE(1712)] = 57930,
  [SMALL_STATE(1713)] = 57938,
  [SMALL_STATE(1714)] = 57946,
  [SMALL_STATE(1715)] = 57956,
  [SMALL_STATE(1716)] = 57966,
  [SMALL_STATE(1717)] = 57976,
  [SMALL_STATE(1718)] = 57984,
  [SMALL_STATE(1719)] = 57994,
  [SMALL_STATE(1720)] = 58004,
  [SMALL_STATE(1721)] = 58014,
  [SMALL_STATE(1722)] = 58022,
  [SMALL_STATE(1723)] = 58029,
  [SMALL_STATE(1724)] = 58036,
  [SMALL_STATE(1725)] = 58043,
  [SMALL_STATE(1726)] = 58050,
  [SMALL_STATE(1727)] = 58057,
  [SMALL_STATE(1728)] = 58064,
  [SMALL_STATE(1729)] = 58071,
  [SMALL_STATE(1730)] = 58078,
  [SMALL_STATE(1731)] = 58085,
  [SMALL_STATE(1732)] = 58092,
  [SMALL_STATE(1733)] = 58099,
  [SMALL_STATE(1734)] = 58106,
  [SMALL_STATE(1735)] = 58113,
  [SMALL_STATE(1736)] = 58120,
  [SMALL_STATE(1737)] = 58127,
  [SMALL_STATE(1738)] = 58134,
  [SMALL_STATE(1739)] = 58141,
  [SMALL_STATE(1740)] = 58148,
  [SMALL_STATE(1741)] = 58155,
  [SMALL_STATE(1742)] = 58162,
  [SMALL_STATE(1743)] = 58169,
  [SMALL_STATE(1744)] = 58176,
  [SMALL_STATE(1745)] = 58183,
  [SMALL_STATE(1746)] = 58190,
  [SMALL_STATE(1747)] = 58197,
  [SMALL_STATE(1748)] = 58204,
  [SMALL_STATE(1749)] = 58211,
  [SMALL_STATE(1750)] = 58218,
  [SMALL_STATE(1751)] = 58225,
  [SMALL_STATE(1752)] = 58232,
  [SMALL_STATE(1753)] = 58239,
  [SMALL_STATE(1754)] = 58246,
  [SMALL_STATE(1755)] = 58253,
  [SMALL_STATE(1756)] = 58260,
  [SMALL_STATE(1757)] = 58267,
  [SMALL_STATE(1758)] = 58274,
  [SMALL_STATE(1759)] = 58281,
  [SMALL_STATE(1760)] = 58288,
  [SMALL_STATE(1761)] = 58295,
  [SMALL_STATE(1762)] = 58302,
  [SMALL_STATE(1763)] = 58309,
  [SMALL_STATE(1764)] = 58316,
  [SMALL_STATE(1765)] = 58323,
  [SMALL_STATE(1766)] = 58330,
  [SMALL_STATE(1767)] = 58337,
  [SMALL_STATE(1768)] = 58344,
  [SMALL_STATE(1769)] = 58351,
  [SMALL_STATE(1770)] = 58358,
  [SMALL_STATE(1771)] = 58365,
  [SMALL_STATE(1772)] = 58372,
  [SMALL_STATE(1773)] = 58379,
  [SMALL_STATE(1774)] = 58386,
  [SMALL_STATE(1775)] = 58393,
  [SMALL_STATE(1776)] = 58400,
  [SMALL_STATE(1777)] = 58407,
  [SMALL_STATE(1778)] = 58414,
  [SMALL_STATE(1779)] = 58421,
  [SMALL_STATE(1780)] = 58428,
  [SMALL_STATE(1781)] = 58435,
  [SMALL_STATE(1782)] = 58442,
  [SMALL_STATE(1783)] = 58449,
  [SMALL_STATE(1784)] = 58456,
  [SMALL_STATE(1785)] = 58463,
  [SMALL_STATE(1786)] = 58470,
  [SMALL_STATE(1787)] = 58477,
  [SMALL_STATE(1788)] = 58484,
  [SMALL_STATE(1789)] = 58491,
  [SMALL_STATE(1790)] = 58498,
  [SMALL_STATE(1791)] = 58505,
  [SMALL_STATE(1792)] = 58512,
  [SMALL_STATE(1793)] = 58519,
  [SMALL_STATE(1794)] = 58526,
  [SMALL_STATE(1795)] = 58533,
  [SMALL_STATE(1796)] = 58540,
  [SMALL_STATE(1797)] = 58547,
  [SMALL_STATE(1798)] = 58554,
  [SMALL_STATE(1799)] = 58561,
  [SMALL_STATE(1800)] = 58568,
  [SMALL_STATE(1801)] = 58575,
  [SMALL_STATE(1802)] = 58582,
  [SMALL_STATE(1803)] = 58589,
  [SMALL_STATE(1804)] = 58596,
  [SMALL_STATE(1805)] = 58603,
  [SMALL_STATE(1806)] = 58610,
  [SMALL_STATE(1807)] = 58617,
  [SMALL_STATE(1808)] = 58624,
  [SMALL_STATE(1809)] = 58631,
  [SMALL_STATE(1810)] = 58638,
  [SMALL_STATE(1811)] = 58645,
  [SMALL_STATE(1812)] = 58652,
  [SMALL_STATE(1813)] = 58659,
  [SMALL_STATE(1814)] = 58666,
  [SMALL_STATE(1815)] = 58673,
  [SMALL_STATE(1816)] = 58680,
  [SMALL_STATE(1817)] = 58687,
  [SMALL_STATE(1818)] = 58694,
  [SMALL_STATE(1819)] = 58701,
  [SMALL_STATE(1820)] = 58708,
  [SMALL_STATE(1821)] = 58715,
  [SMALL_STATE(1822)] = 58722,
  [SMALL_STATE(1823)] = 58729,
  [SMALL_STATE(1824)] = 58736,
  [SMALL_STATE(1825)] = 58743,
  [SMALL_STATE(1826)] = 58750,
  [SMALL_STATE(1827)] = 58757,
  [SMALL_STATE(1828)] = 58764,
  [SMALL_STATE(1829)] = 58771,
  [SMALL_STATE(1830)] = 58778,
  [SMALL_STATE(1831)] = 58785,
  [SMALL_STATE(1832)] = 58792,
  [SMALL_STATE(1833)] = 58799,
  [SMALL_STATE(1834)] = 58806,
  [SMALL_STATE(1835)] = 58813,
  [SMALL_STATE(1836)] = 58820,
  [SMALL_STATE(1837)] = 58827,
  [SMALL_STATE(1838)] = 58834,
  [SMALL_STATE(1839)] = 58841,
  [SMALL_STATE(1840)] = 58848,
  [SMALL_STATE(1841)] = 58855,
  [SMALL_STATE(1842)] = 58862,
  [SMALL_STATE(1843)] = 58869,
  [SMALL_STATE(1844)] = 58876,
  [SMALL_STATE(1845)] = 58883,
  [SMALL_STATE(1846)] = 58890,
  [SMALL_STATE(1847)] = 58897,
  [SMALL_STATE(1848)] = 58904,
  [SMALL_STATE(1849)] = 58911,
  [SMALL_STATE(1850)] = 58918,
  [SMALL_STATE(1851)] = 58925,
  [SMALL_STATE(1852)] = 58932,
  [SMALL_STATE(1853)] = 58939,
  [SMALL_STATE(1854)] = 58946,
  [SMALL_STATE(1855)] = 58953,
  [SMALL_STATE(1856)] = 58960,
  [SMALL_STATE(1857)] = 58967,
  [SMALL_STATE(1858)] = 58974,
  [SMALL_STATE(1859)] = 58981,
  [SMALL_STATE(1860)] = 58988,
  [SMALL_STATE(1861)] = 58995,
  [SMALL_STATE(1862)] = 59002,
  [SMALL_STATE(1863)] = 59009,
  [SMALL_STATE(1864)] = 59016,
  [SMALL_STATE(1865)] = 59023,
  [SMALL_STATE(1866)] = 59030,
  [SMALL_STATE(1867)] = 59037,
  [SMALL_STATE(1868)] = 59044,
  [SMALL_STATE(1869)] = 59051,
  [SMALL_STATE(1870)] = 59058,
  [SMALL_STATE(1871)] = 59065,
  [SMALL_STATE(1872)] = 59072,
  [SMALL_STATE(1873)] = 59079,
  [SMALL_STATE(1874)] = 59086,
  [SMALL_STATE(1875)] = 59093,
  [SMALL_STATE(1876)] = 59100,
  [SMALL_STATE(1877)] = 59107,
  [SMALL_STATE(1878)] = 59114,
  [SMALL_STATE(1879)] = 59121,
  [SMALL_STATE(1880)] = 59128,
  [SMALL_STATE(1881)] = 59135,
  [SMALL_STATE(1882)] = 59142,
  [SMALL_STATE(1883)] = 59149,
  [SMALL_STATE(1884)] = 59156,
  [SMALL_STATE(1885)] = 59163,
  [SMALL_STATE(1886)] = 59170,
  [SMALL_STATE(1887)] = 59177,
  [SMALL_STATE(1888)] = 59184,
  [SMALL_STATE(1889)] = 59191,
  [SMALL_STATE(1890)] = 59198,
  [SMALL_STATE(1891)] = 59205,
  [SMALL_STATE(1892)] = 59212,
  [SMALL_STATE(1893)] = 59219,
  [SMALL_STATE(1894)] = 59226,
  [SMALL_STATE(1895)] = 59233,
  [SMALL_STATE(1896)] = 59240,
  [SMALL_STATE(1897)] = 59247,
  [SMALL_STATE(1898)] = 59254,
  [SMALL_STATE(1899)] = 59261,
  [SMALL_STATE(1900)] = 59268,
  [SMALL_STATE(1901)] = 59275,
  [SMALL_STATE(1902)] = 59282,
  [SMALL_STATE(1903)] = 59289,
  [SMALL_STATE(1904)] = 59296,
  [SMALL_STATE(1905)] = 59303,
  [SMALL_STATE(1906)] = 59310,
  [SMALL_STATE(1907)] = 59317,
  [SMALL_STATE(1908)] = 59324,
  [SMALL_STATE(1909)] = 59331,
  [SMALL_STATE(1910)] = 59338,
  [SMALL_STATE(1911)] = 59345,
  [SMALL_STATE(1912)] = 59352,
  [SMALL_STATE(1913)] = 59359,
  [SMALL_STATE(1914)] = 59366,
  [SMALL_STATE(1915)] = 59373,
  [SMALL_STATE(1916)] = 59380,
  [SMALL_STATE(1917)] = 59387,
  [SMALL_STATE(1918)] = 59394,
  [SMALL_STATE(1919)] = 59401,
  [SMALL_STATE(1920)] = 59408,
  [SMALL_STATE(1921)] = 59415,
  [SMALL_STATE(1922)] = 59422,
  [SMALL_STATE(1923)] = 59429,
  [SMALL_STATE(1924)] = 59436,
  [SMALL_STATE(1925)] = 59443,
  [SMALL_STATE(1926)] = 59450,
  [SMALL_STATE(1927)] = 59457,
  [SMALL_STATE(1928)] = 59464,
  [SMALL_STATE(1929)] = 59471,
  [SMALL_STATE(1930)] = 59478,
  [SMALL_STATE(1931)] = 59485,
  [SMALL_STATE(1932)] = 59492,
  [SMALL_STATE(1933)] = 59499,
  [SMALL_STATE(1934)] = 59506,
  [SMALL_STATE(1935)] = 59513,
  [SMALL_STATE(1936)] = 59520,
  [SMALL_STATE(1937)] = 59527,
  [SMALL_STATE(1938)] = 59534,
  [SMALL_STATE(1939)] = 59541,
  [SMALL_STATE(1940)] = 59548,
  [SMALL_STATE(1941)] = 59555,
  [SMALL_STATE(1942)] = 59562,
  [SMALL_STATE(1943)] = 59569,
  [SMALL_STATE(1944)] = 59576,
  [SMALL_STATE(1945)] = 59583,
  [SMALL_STATE(1946)] = 59590,
  [SMALL_STATE(1947)] = 59597,
  [SMALL_STATE(1948)] = 59604,
  [SMALL_STATE(1949)] = 59611,
  [SMALL_STATE(1950)] = 59618,
  [SMALL_STATE(1951)] = 59625,
  [SMALL_STATE(1952)] = 59632,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1602),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [97] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_return_expression, 1, 0, 0),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_return_expression, 1, 0, 0),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(91),
  [160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(175),
  [163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(228),
  [166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5),
  [169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1939),
  [174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(656),
  [177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1931),
  [180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(289),
  [183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2),
  [186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(233),
  [189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(233),
  [192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(97),
  [195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(781),
  [198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1711),
  [201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1945),
  [204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1809),
  [207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1923),
  [210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1924),
  [213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1816),
  [216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1817),
  [219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(674),
  [222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1818),
  [225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(92),
  [228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(290),
  [231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1583),
  [234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(98),
  [237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(99),
  [240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1816),
  [260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(942),
  [299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1710),
  [302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(806),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1916),
  [308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1704),
  [311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1899),
  [314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1791),
  [317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1917),
  [320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0),
  [322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1930),
  [325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1944),
  [328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0),
  [330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1393),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(857),
  [336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(858),
  [339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1214),
  [342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1840),
  [345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1394),
  [348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1396),
  [351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(941),
  [354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1540),
  [357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1950),
  [360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1252),
  [363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(832),
  [366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1920),
  [369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1921),
  [372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(863),
  [375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(846),
  [378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(846),
  [381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(902),
  [384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1656),
  [387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1308),
  [390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(930),
  [393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(860),
  [396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1800),
  [399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1498),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(948),
  [509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1602),
  [512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1859),
  [515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1649),
  [518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1762),
  [521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1799),
  [524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1864),
  [527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1862),
  [530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1452),
  [533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(821),
  [536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(822),
  [539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1193),
  [542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1933),
  [545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1465),
  [548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1467),
  [551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1877),
  [554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1262),
  [557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1725),
  [560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1734),
  [563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(834),
  [566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(905),
  [569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_0_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1319),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cairo_0_file, 1, 0, 0),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_if_expression, 3, 0, 74),
  [638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_if_expression, 3, 0, 74),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_expression, 1, 0, 0),
  [652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_expression, 1, 0, 0),
  [654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cairo_1_expression, 1, 0, 0), SHIFT(1086),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_expression, 1, 0, 6),
  [661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_expression, 1, 0, 6),
  [663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cairo_1_expression, 1, 0, 6), SHIFT(1086),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_binary_expression, 3, 0, 20),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_binary_expression, 3, 0, 20),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 2, 0, 14),
  [682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 2, 0, 14),
  [684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, 0, 27),
  [686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 27),
  [688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1, 0, 0),
  [690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1, 0, 0),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_expression, 1, 0, 4),
  [696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_expression, 1, 0, 4),
  [698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_expression, 1, 0, 32),
  [700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_expression, 1, 0, 32),
  [702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_expression, 1, 0, 33),
  [704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_expression, 1, 0, 33),
  [706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_expression, 1, 0, 34),
  [708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_expression, 1, 0, 34),
  [710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_expression, 1, 0, 3),
  [712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_expression, 1, 0, 3),
  [714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_expression, 1, 0, 35),
  [716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_expression, 1, 0, 35),
  [718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_expression, 1, 0, 36),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_expression, 1, 0, 36),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_expression, 1, 0, 37),
  [726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_expression, 1, 0, 37),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, 0, 30),
  [732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 30),
  [734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_unit_expression, 2, 0, 0),
  [736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_unit_expression, 2, 0, 0),
  [738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_at_expression, 2, 0, 0),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_at_expression, 2, 0, 0),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_return_expression, 2, 0, 0),
  [768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_return_expression, 2, 0, 0),
  [770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_unary_expression, 2, 0, 0),
  [772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_unary_expression, 2, 0, 0),
  [774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_struct_expression, 2, 0, 55),
  [776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_struct_expression, 2, 0, 55),
  [778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_struct_expression, 2, 0, 56),
  [780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_struct_expression, 2, 0, 56),
  [782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_loop_expression, 2, 0, 57),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_loop_expression, 2, 0, 57),
  [786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_try_expression, 2, 0, 0),
  [788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_try_expression, 2, 0, 0),
  [790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_parenthesized_expression, 3, 0, 0),
  [792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_parenthesized_expression, 3, 0, 0),
  [794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 2, 0, 0),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 2, 0, 0),
  [798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_generic_function, 3, 0, 9),
  [800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_generic_function, 3, 0, 9),
  [802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 3, 0, 75),
  [804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 3, 0, 75),
  [806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 3, 0, 9),
  [808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 3, 0, 9),
  [810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_assignment_expression, 3, 0, 76),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_assignment_expression, 3, 0, 76),
  [814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_compound_assignment_expression, 3, 0, 20),
  [816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_compound_assignment_expression, 3, 0, 20),
  [818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_field_expression, 3, 0, 77),
  [820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_field_expression, 3, 0, 77),
  [822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_generic_function, 3, 0, 78),
  [824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_generic_function, 3, 0, 78),
  [826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_if_expression, 4, 0, 86),
  [828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_if_expression, 4, 0, 86),
  [830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 3, 0, 0),
  [832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 3, 0, 0),
  [834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 2, 0, 0),
  [836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 2, 0, 0),
  [838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 4, 0, 9),
  [840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 4, 0, 9),
  [842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_index_expression, 4, 0, 0),
  [844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_index_expression, 4, 0, 0),
  [846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_tuple_expression, 5, 0, 0),
  [848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_tuple_expression, 5, 0, 0),
  [850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_else_clause, 2, 0, 0),
  [852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_else_clause, 2, 0, 0),
  [854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_else_clause, 2, 0, 95),
  [856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_else_clause, 2, 0, 95),
  [858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 4, 0, 0),
  [860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 4, 0, 0),
  [862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 3, 0, 0),
  [864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 3, 0, 0),
  [866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 5, 0, 9),
  [868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 5, 0, 9),
  [870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 5, 0, 97),
  [872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 5, 0, 97),
  [874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_tuple_expression, 6, 0, 0),
  [876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_tuple_expression, 6, 0, 0),
  [878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 5, 0, 0),
  [880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 5, 0, 0),
  [882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 4, 0, 0),
  [884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 4, 0, 0),
  [886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 6, 0, 9),
  [888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 6, 0, 9),
  [890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 6, 0, 104),
  [892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 6, 0, 104),
  [894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 6, 0, 105),
  [896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 6, 0, 105),
  [898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 6, 0, 97),
  [900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 6, 0, 97),
  [902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_tuple_expression, 7, 0, 0),
  [904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_tuple_expression, 7, 0, 0),
  [906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 6, 0, 0),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 6, 0, 0),
  [910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 7, 0, 104),
  [912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 7, 0, 104),
  [914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 7, 0, 105),
  [916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 7, 0, 105),
  [918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 7, 0, 108),
  [920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 7, 0, 108),
  [922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 7, 0, 9),
  [924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 7, 0, 9),
  [926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 7, 0, 109),
  [928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 7, 0, 109),
  [930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 7, 0, 110),
  [932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 7, 0, 110),
  [934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 8, 0, 108),
  [936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 8, 0, 108),
  [938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 8, 0, 109),
  [940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 8, 0, 109),
  [942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 8, 0, 110),
  [944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 8, 0, 110),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 8, 0, 112),
  [948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 8, 0, 112),
  [950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_call_expression, 9, 0, 112),
  [952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_call_expression, 9, 0, 112),
  [954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_type_arguments, 3, 0, 0),
  [956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_type_arguments, 3, 0, 0),
  [958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_type_arguments, 4, 0, 0),
  [960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_type_arguments, 4, 0, 0),
  [962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_type_arguments, 5, 0, 0),
  [964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_type_arguments, 5, 0, 0),
  [966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_expression_statement, 1, 0, 0),
  [968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_expression_statement, 1, 0, 0),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_tuple_expression, 4, 0, 0),
  [974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_tuple_expression, 4, 0, 0),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [1000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [1004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [1006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [1008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [1010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [1014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(396),
  [1057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(174),
  [1060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0),
  [1062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(222),
  [1065] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7),
  [1068] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(221),
  [1071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3),
  [1074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(226),
  [1077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(226),
  [1080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(448),
  [1083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1865),
  [1086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(398),
  [1089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(227),
  [1092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1648),
  [1095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(449),
  [1098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(419),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [1137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 4, 0, 58),
  [1139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 4, 0, 58),
  [1141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 3, 0, 101),
  [1143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 3, 0, 101),
  [1145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 3, 0, 102),
  [1147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 3, 0, 102),
  [1149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 4, 0, 107),
  [1151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 4, 0, 107),
  [1153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 3, 0, 12),
  [1155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 3, 0, 12),
  [1157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_statement, 1, 0, 5),
  [1159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_statement, 1, 0, 5),
  [1161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 3, 0, 11),
  [1163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 3, 0, 11),
  [1165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 3, 0, 15),
  [1167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 3, 0, 15),
  [1169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_declaration, 3, 0, 18),
  [1171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 3, 0, 18),
  [1173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 3, 0, 14),
  [1175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 3, 0, 14),
  [1177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 3, 0, 19),
  [1179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 3, 0, 19),
  [1181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 3, 0, 11),
  [1183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 3, 0, 11),
  [1185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 3, 0, 12),
  [1187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 3, 0, 12),
  [1189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, 0, 23),
  [1191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, 0, 23),
  [1193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, 0, 24),
  [1195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, 0, 24),
  [1197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 4, 0, 29),
  [1199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 4, 0, 29),
  [1201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_type_statement, 4, 0, 42),
  [1203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_type_statement, 4, 0, 42),
  [1205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_definition, 4, 0, 43),
  [1207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_definition, 4, 0, 43),
  [1209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_item, 4, 0, 0),
  [1211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_item, 4, 0, 0),
  [1213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_item, 4, 0, 44),
  [1215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_item, 4, 0, 44),
  [1217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [1219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [1221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 2, 0, 0),
  [1223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 2, 0, 0),
  [1225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 4, 0, 24),
  [1227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 4, 0, 24),
  [1229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, 0, 47),
  [1231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, 0, 47),
  [1233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, 0, 48),
  [1235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, 0, 48),
  [1237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, 0, 23),
  [1239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, 0, 23),
  [1241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, 0, 24),
  [1243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, 0, 24),
  [1245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [1247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [1249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [1251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [1253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 5, 0, 58),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 5, 0, 58),
  [1257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 5, 0, 59),
  [1259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 5, 0, 59),
  [1261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 5, 0, 60),
  [1263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 5, 0, 60),
  [1265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_type_statement, 5, 0, 42),
  [1267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_type_statement, 5, 0, 42),
  [1269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_function_statement, 5, 0, 61),
  [1271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_function_statement, 5, 0, 61),
  [1273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 5, 0, 62),
  [1275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 5, 0, 62),
  [1277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 5, 0, 0),
  [1279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 5, 0, 0),
  [1281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_definition, 5, 0, 61),
  [1283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_definition, 5, 0, 61),
  [1285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_item, 5, 0, 0),
  [1287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_item, 5, 0, 0),
  [1289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_item, 5, 0, 44),
  [1291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_item, 5, 0, 44),
  [1293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [1295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [1297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 3, 0, 0),
  [1299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 3, 0, 0),
  [1301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, 0, 0),
  [1303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, 0, 0),
  [1305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 63),
  [1307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 63),
  [1309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, 0, 64),
  [1311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, 0, 64),
  [1313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 4, 0, 0),
  [1315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 4, 0, 0),
  [1317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 6, 0, 72),
  [1319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 6, 0, 72),
  [1321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 6, 0, 73),
  [1323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 6, 0, 73),
  [1325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_expression_statement, 2, 0, 0),
  [1327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_expression_statement, 2, 0, 0),
  [1329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_function_statement, 6, 0, 80),
  [1331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_function_statement, 6, 0, 80),
  [1333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 6, 0, 81),
  [1335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 6, 0, 81),
  [1337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 6, 0, 0),
  [1339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 6, 0, 0),
  [1341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 4, 0, 0),
  [1343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 4, 0, 0),
  [1345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 5, 0, 0),
  [1347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 5, 0, 0),
  [1349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 7, 0, 87),
  [1351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 7, 0, 87),
  [1353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 7, 0, 88),
  [1355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 7, 0, 88),
  [1357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 7, 0, 89),
  [1359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 7, 0, 89),
  [1361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 7, 0, 0),
  [1363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 7, 0, 0),
  [1365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 5, 0, 0),
  [1367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 5, 0, 0),
  [1369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 6, 0, 0),
  [1371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 6, 0, 0),
  [1373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 8, 0, 94),
  [1375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 8, 0, 94),
  [1377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 8, 0, 89),
  [1379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 8, 0, 89),
  [1381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 8, 0, 98),
  [1383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 8, 0, 98),
  [1385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 8, 0, 0),
  [1387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 8, 0, 0),
  [1389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 6, 0, 0),
  [1391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 6, 0, 0),
  [1393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 7, 0, 0),
  [1395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 7, 0, 0),
  [1397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 9, 0, 98),
  [1399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 9, 0, 98),
  [1401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 9, 0, 106),
  [1403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 9, 0, 106),
  [1405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 9, 0, 0),
  [1407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 9, 0, 0),
  [1409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 7, 0, 0),
  [1411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 7, 0, 0),
  [1413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 10, 0, 106),
  [1415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 10, 0, 106),
  [1417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 10, 0, 111),
  [1419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 10, 0, 111),
  [1421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 10, 0, 0),
  [1423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 10, 0, 0),
  [1425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 11, 0, 111),
  [1427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 11, 0, 111),
  [1429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 11, 0, 113),
  [1431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 11, 0, 113),
  [1433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_1_function_signature, 12, 0, 113),
  [1435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_function_signature, 12, 0, 113),
  [1437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 3, 0, 12),
  [1439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 3, 0, 12),
  [1441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_field_declaration_list, 2, 0, 0), REDUCE(sym__cairo_0_struct_definition, 4, 0, 0),
  [1444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_struct_definition, 4, 0, 0),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_struct_definition, 4, 0, 0),
  [1448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_declaration_list, 2, 0, 0), REDUCE(sym__cairo_0_struct_definition, 4, 0, 0),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [1497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0),
  [1499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0),
  [1501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1943),
  [1504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dotted_name, 1, 0, 0),
  [1506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 1, 0, 0),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [1510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dotted_name, 2, 0, 0),
  [1512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 2, 0, 0),
  [1514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0),
  [1516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0),
  [1518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0), SHIFT_REPEAT(1787),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [1525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1040),
  [1528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(640),
  [1531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1126),
  [1534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1887),
  [1537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1943),
  [1540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1084),
  [1543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1126),
  [1546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1747),
  [1549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0), SHIFT_REPEAT(1941),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [1554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_with_turbofish, 3, 0, 16),
  [1556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_list, 1, 0, 22),
  [1558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 1, 0, 22),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [1562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [1568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_with_turbofish, 3, 0, 13),
  [1570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 66),
  [1572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 66),
  [1574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 66), SHIFT_REPEAT(1401),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [1583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [1599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_list, 2, 0, 22),
  [1601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, 0, 22),
  [1603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_list, 2, 0, 49),
  [1605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, 0, 49),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [1611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 14),
  [1613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 14),
  [1615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_list, 3, 0, 49),
  [1617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 3, 0, 49),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [1635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [1637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_if_statement, 6, 0, 0),
  [1639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_if_statement, 6, 0, 0),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [1643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_if_statement, 7, 0, 0),
  [1645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_if_statement, 7, 0, 0),
  [1647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [1661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [1667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [1671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [1673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_builtin_directive, 2, 0, 0),
  [1675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin_directive, 2, 0, 0),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [1685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [1691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 66), SHIFT_REPEAT(1340),
  [1694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_builtin_directive_repeat1, 2, 0, 0), SHIFT_REPEAT(525),
  [1697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_builtin_directive_repeat1, 2, 0, 0),
  [1699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_builtin_directive_repeat1, 2, 0, 0),
  [1701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [1711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__cairo_1_tuple_expression_repeat1, 2, 0, 0),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [1727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_aliased_import, 3, 0, 67),
  [1729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aliased_import, 3, 0, 67),
  [1731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_decorated_definition, 2, 0, 10),
  [1733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_decorated_definition, 2, 0, 10),
  [1735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_assert_statement, 5, 0, 0),
  [1737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_assert_statement, 5, 0, 0),
  [1739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_static_assert_statement, 5, 0, 0),
  [1741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_static_assert_statement, 5, 0, 0),
  [1743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction, 2, 0, 0),
  [1745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction, 2, 0, 0),
  [1747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_expression_statement, 2, 0, 0),
  [1749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_expression_statement, 2, 0, 0),
  [1751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_let_binding, 5, 0, 54),
  [1753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_let_binding, 5, 0, 54),
  [1755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_function_definition, 7, 0, 0),
  [1757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_function_definition, 7, 0, 0),
  [1759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_attribute_statement, 8, 0, 0),
  [1761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_attribute_statement, 8, 0, 0),
  [1763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 2, 0, 22),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_with_statement, 4, 0, 0),
  [1769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_with_statement, 4, 0, 0),
  [1771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_function_definition, 9, 0, 92),
  [1773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_function_definition, 9, 0, 92),
  [1775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_function_definition, 7, 0, 84),
  [1777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_function_definition, 7, 0, 84),
  [1779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_attribute_statement, 6, 0, 0),
  [1781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_attribute_statement, 6, 0, 0),
  [1783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_with_statement, 6, 0, 0),
  [1785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_with_statement, 6, 0, 0),
  [1787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_attribute_statement, 7, 0, 0),
  [1789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_attribute_statement, 7, 0, 0),
  [1791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_statement, 1, 0, 1),
  [1793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_statement, 1, 0, 1),
  [1795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_var_declaration, 5, 0, 0),
  [1797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_var_declaration, 5, 0, 0),
  [1799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_function_definition, 8, 0, 92),
  [1801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_function_definition, 8, 0, 92),
  [1803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_var_declaration, 5, 0, 0),
  [1805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_var_declaration, 5, 0, 0),
  [1807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hint, 2, 0, 0),
  [1809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hint, 2, 0, 0),
  [1811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hint, 3, 0, 0),
  [1813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hint, 3, 0, 0),
  [1815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_temp_var_declaration, 5, 0, 0),
  [1817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_temp_var_declaration, 5, 0, 0),
  [1819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instruction, 5, 0, 0),
  [1821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instruction, 5, 0, 0),
  [1823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_function_definition, 5, 0, 0),
  [1825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_function_definition, 5, 0, 0),
  [1827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_with_statement, 5, 0, 0),
  [1829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_with_statement, 5, 0, 0),
  [1831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_if_statement, 9, 0, 0),
  [1833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_if_statement, 9, 0, 0),
  [1835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_var_declaration, 3, 0, 0),
  [1837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_var_declaration, 3, 0, 0),
  [1839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_statement, 1, 0, 0),
  [1841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_statement, 1, 0, 0),
  [1843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_temp_var_declaration, 3, 0, 0),
  [1845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_temp_var_declaration, 3, 0, 0),
  [1847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_return_statement, 3, 0, 0),
  [1849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_return_statement, 3, 0, 0),
  [1851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label, 3, 0, 0),
  [1853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 3, 0, 0),
  [1855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [1857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_statement, 1, 0, 2),
  [1859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_statement, 1, 0, 2),
  [1861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_statement, 1, 0, 3),
  [1863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_statement, 1, 0, 3),
  [1865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_function_definition, 8, 0, 84),
  [1867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_function_definition, 8, 0, 84),
  [1869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_builtin_directive_repeat1, 2, 0, 0), SHIFT_REPEAT(579),
  [1872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_import_statement, 6, 0, 65),
  [1874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_import_statement, 6, 0, 65),
  [1876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_struct_definition, 6, 0, 0),
  [1878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_struct_definition, 6, 0, 0),
  [1880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_function_definition, 6, 0, 0),
  [1882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_function_definition, 6, 0, 0),
  [1884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_attribute_statement, 4, 0, 0),
  [1886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_attribute_statement, 4, 0, 0),
  [1888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [1890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_struct_definition, 7, 0, 0),
  [1892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_struct_definition, 7, 0, 0),
  [1894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_if_statement, 10, 0, 0),
  [1896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_if_statement, 10, 0, 0),
  [1898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 50),
  [1900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 50),
  [1902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_import_statement, 4, 0, 21),
  [1904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_import_statement, 4, 0, 21),
  [1906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_namespace_definition, 5, 0, 0),
  [1908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_namespace_definition, 5, 0, 0),
  [1910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_namespace_definition, 4, 0, 0),
  [1912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_namespace_definition, 4, 0, 0),
  [1914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lang_directive, 2, 0, 0),
  [1916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lang_directive, 2, 0, 0),
  [1918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [1920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_struct_definition, 5, 0, 0),
  [1922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_struct_definition, 5, 0, 0),
  [1924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alloc_locals, 2, 0, 0),
  [1926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alloc_locals, 2, 0, 0),
  [1928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_if_statement, 11, 0, 0),
  [1930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_if_statement, 11, 0, 0),
  [1932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_attribute_statement, 5, 0, 0),
  [1934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_attribute_statement, 5, 0, 0),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [1946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [1950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [1960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [1962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [1964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cairo_1_expression, 1, 0, 0), SHIFT(1080),
  [1969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cairo_1_expression, 1, 0, 6), SHIFT(1080),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [2008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [2012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [2016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [2018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [2020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [2022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [2026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [2028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [2030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [2032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [2034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [2038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [2040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [2042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [2046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 4, 0, 91),
  [2048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cairo_1_call_expression_repeat1, 4, 0, 14),
  [2050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cairo_1_call_expression_repeat1, 4, 0, 0),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [2056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 96),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 4, 0, 58),
  [2062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_arguments_repeat1, 4, 0, 0),
  [2064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cairo_1_call_expression_repeat1, 3, 0, 0),
  [2066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cairo_1_call_expression_repeat1, 5, 0, 42),
  [2068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_field_initializer, 2, 0, 0),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [2072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cairo_1_call_expression_repeat1, 2, 0, 0),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [2076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 5, 0, 99),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [2080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 4, 0, 100),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [2084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 3, 0, 101),
  [2088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_arguments_repeat1, 2, 0, 0),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [2104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 3, 0, 103),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [2126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [2128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [2136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [2138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [2142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cairo_1_file_repeat1, 2, 0, 0),
  [2144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_1_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1746),
  [2147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_1_file_repeat1, 2, 0, 0), SHIFT_REPEAT(654),
  [2150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_1_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1798),
  [2153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_1_file_repeat1, 2, 0, 0), SHIFT_REPEAT(783),
  [2156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_1_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1698),
  [2159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_1_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1889),
  [2162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_1_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1900),
  [2165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_1_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1948),
  [2168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_1_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1780),
  [2171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_1_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1869),
  [2174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_1_file_repeat1, 2, 0, 0), SHIFT_REPEAT(714),
  [2177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cairo_1_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1804),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [2204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cairo_1_file, 1, 0, 0),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [2212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 4, 0, 101),
  [2214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 4, 0, 101),
  [2216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 4, 0, 101),
  [2218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 5, 0, 58),
  [2220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 5, 0, 58),
  [2222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 5, 0, 58),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [2226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [2228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [2238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [2246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [2250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [2280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [2282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [2284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [2306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [2322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [2326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [2330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [2334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [2338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [2342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [2346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [2350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [2354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [2358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [2362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [2370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [2374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [2380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [2384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [2388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [2392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [2396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [2402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [2406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [2414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [2418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [2422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [2426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [2430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [2450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [2454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [2458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [2462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [2470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [2474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [2478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [2482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [2486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [2490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [2494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [2498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [2502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [2506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 7),
  [2512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 7),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [2522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 20),
  [2524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 20),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [2528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [2532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [2534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inst_jmp_rel, 3, 0, 0),
  [2536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [2538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [2540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [2542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [2544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [2546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [2548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [2550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [2552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [2554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [2556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_jmp_rel, 3, 0, 0),
  [2558] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [2560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 20),
  [2562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 20),
  [2564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [2568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inst_data_word, 2, 0, 0),
  [2570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_data_word, 2, 0, 0),
  [2572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [2576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deref_expression, 3, 0, 0),
  [2578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_deref_expression, 3, 0, 0),
  [2580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inst_assert_eq, 3, 0, 0),
  [2582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [2586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [2590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [2594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 3, 0, 0),
  [2596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 3, 0, 0),
  [2598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_call_expression, 4, 0, 9),
  [2600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_call_expression, 4, 0, 9),
  [2602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [2604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [2606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 0),
  [2608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 0),
  [2610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 6, 0, 79),
  [2612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 6, 0, 79),
  [2614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_register, 1, 0, 0),
  [2616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_register, 1, 0, 0),
  [2618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_call_expression, 6, 0, 9),
  [2620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_call_expression, 6, 0, 9),
  [2622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, 0, 0),
  [2624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, 0, 0),
  [2626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [2628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [2630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [2632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [2640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_call_expression, 2, 0, 9),
  [2642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_call_expression, 2, 0, 9),
  [2644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [2648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_expression, 1, 0, 4),
  [2650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_expression, 1, 0, 4),
  [2652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_call_expression, 8, 0, 9),
  [2654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_call_expression, 8, 0, 9),
  [2656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 2, 0, 0),
  [2658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 2, 0, 0),
  [2660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [2664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_call_expression, 5, 0, 9),
  [2666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_call_expression, 5, 0, 9),
  [2668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [2672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [2676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_call_expression, 7, 0, 9),
  [2682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_call_expression, 7, 0, 9),
  [2684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [2692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [2696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hint_expression, 2, 0, 0),
  [2698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hint_expression, 2, 0, 0),
  [2700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inst_add_ap, 3, 0, 0),
  [2702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_add_ap, 3, 0, 0),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [2708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inst_jmp_abs, 3, 0, 0),
  [2710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_jmp_abs, 3, 0, 0),
  [2712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_instruction, 3, 0, 0),
  [2722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_instruction, 3, 0, 0),
  [2724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [2728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [2730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_expression, 1, 0, 0),
  [2732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [2734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_expression, 1, 0, 0),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [2740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inst_jnz_to_label, 6, 0, 0),
  [2742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_jnz_to_label, 6, 0, 0),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [2748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0),
  [2750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [2752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inst_jnz, 7, 0, 0),
  [2754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_jnz, 7, 0, 0),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [2772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cairo_0_call_expression_repeat1, 2, 0, 0),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [2778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [2786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, 0, 31),
  [2788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 2, 0, 11),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [2792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 0),
  [2794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1, 0, 0),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [2798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [2800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [2802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_type, 1, 0, 0),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [2806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [2814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [2818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [2820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, 0, 28),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [2824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, 0, 28),
  [2826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [2830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [2832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [2834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 16),
  [2836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 0, 16),
  [2838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, 0, 31),
  [2840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 3, 0, 13),
  [2842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 3, 0, 13),
  [2844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_type, 1, 0, 8),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [2848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 3, 0, 16),
  [2850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 3, 0, 16),
  [2852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 2, 0, 11),
  [2854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 13),
  [2856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 0, 13),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [2878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_tuple_type, 3, 0, 0),
  [2880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_tuple_type, 5, 0, 0),
  [2882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_at_type, 2, 0, 0),
  [2884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 6),
  [2886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1, 0, 6),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_1_tuple_type, 4, 0, 0),
  [2902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 3, 0, 45),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [2908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit_type, 2, 0, 0),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [2912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 3, 0, 46),
  [2914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_bounds, 2, 0, 0),
  [2916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_type, 1, 0, 0),
  [2918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [2920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [2926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [2936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [2942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 5, 0, 16),
  [2944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 5, 0, 16),
  [2946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_pointer_type, 2, 0, 0),
  [2948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_pointer_type, 2, 0, 0),
  [2950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 5, 0, 13),
  [2952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 5, 0, 13),
  [2954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 5, 0, 0),
  [2956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 5, 0, 0),
  [2958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 2, 0, 0),
  [2960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 2, 0, 0),
  [2962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_tuple_type, 3, 0, 0),
  [2964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_tuple_type, 3, 0, 0),
  [2966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_type, 1, 0, 0),
  [2968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 4, 0, 16),
  [2970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 4, 0, 16),
  [2972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3, 0, 0),
  [2974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 3, 0, 0),
  [2976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_typed_identifier, 1, 0, 0), REDUCE(sym__pattern, 1, 0, 0),
  [2979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [2981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 3, 0, 16),
  [2983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_struct_pattern, 3, 0, 16),
  [2985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 4, 0, 13),
  [2987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 4, 0, 13),
  [2989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_tuple_type, 2, 0, 0),
  [2991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_tuple_type, 2, 0, 0),
  [2993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 4, 0, 0),
  [2995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 4, 0, 0),
  [2997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 3, 0, 13),
  [2999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 3, 0, 13),
  [3001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 7, 0, 16),
  [3003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_struct_pattern, 7, 0, 16),
  [3005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 7, 0, 13),
  [3007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 7, 0, 13),
  [3009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 7, 0, 16),
  [3011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 7, 0, 16),
  [3013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 6, 0, 0),
  [3015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 6, 0, 0),
  [3017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 6, 0, 16),
  [3019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_struct_pattern, 6, 0, 16),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [3023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 4, 0, 16),
  [3025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_struct_pattern, 4, 0, 16),
  [3027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 6, 0, 13),
  [3029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 6, 0, 13),
  [3031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 3, 0, 16),
  [3033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 3, 0, 16),
  [3035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__pattern, 1, 0, 0), SHIFT(1064),
  [3038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 6, 0, 16),
  [3040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 6, 0, 16),
  [3042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_tuple_type, 4, 0, 0),
  [3044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_tuple_type, 4, 0, 0),
  [3046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_builtin_type, 1, 0, 0),
  [3048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_builtin_type, 1, 0, 0),
  [3050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cairo_0_tuple_type, 5, 0, 0),
  [3052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_tuple_type, 5, 0, 0),
  [3054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 5, 0, 16),
  [3056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_struct_pattern, 5, 0, 16),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [3066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [3068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [3070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [3074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [3076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [3078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [3080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [3082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [3084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [3090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [3092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [3094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [3102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [3104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [3106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [3110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [3122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [3124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [3130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [3136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [3140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1717),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [3144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_type, 3, 0, 26),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [3148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [3150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [3152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [3156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [3158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0), SHIFT_REPEAT(1845),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [3167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1581),
  [3175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [3193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cairo_0_decorated_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1791),
  [3196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cairo_0_decorated_definition_repeat1, 2, 0, 0),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [3224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_type, 1, 0, 0),
  [3226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [3228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [3230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cairo_0_tuple_type, 2, 0, 0), REDUCE(sym_unit_type, 2, 0, 0),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [3237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [3239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [3241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [3243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__use_clause, 1, 0, 0),
  [3245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [3247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [3249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 5, 0, 0),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [3261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [3263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [3265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 4, 0, 0),
  [3267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [3269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [3271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [3273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [3279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [3281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [3283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [3285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [3287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [3289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [3291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [3293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [3295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [3297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cairo_0_type, 1, 0, 0),
  [3299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [3301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [3303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [3307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5, 0, 51),
  [3309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5, 0, 0),
  [3311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [3313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [3315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 3, 0, 0),
  [3317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [3319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [3325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 2, 0, 0),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [3333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [3335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [3339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__use_clause, 1, 0, 6),
  [3341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [3343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [3345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, 0, 51),
  [3347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [3349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_identifier, 2, 0, 0),
  [3351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [3353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [3355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [3357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [3359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [3361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_identifier, 1, 0, 0),
  [3363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [3365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, 0, 0),
  [3369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [3371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [3373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [3375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [3377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [3379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [3381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [3383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [3385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [3387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [3389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3, 0, 51),
  [3391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [3393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [3395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [3399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3, 0, 0),
  [3401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [3403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [3411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [3413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [3415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [3417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [3419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [3421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_identifier, 2, 0, 0),
  [3423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [3425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [3427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [3431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 7, 0, 98),
  [3433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [3435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [3439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [3441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [3449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [3451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [3453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cairo_0_with_statement_repeat1, 2, 0, 0),
  [3455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cairo_0_with_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1739),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [3470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [3472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [3476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 51),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [3486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [3488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [3498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2, 0, 0),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [3502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [3504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [3512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 4, 0, 82),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [3526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 5, 0, 90),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [3536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cairo_0_struct_definition_repeat1, 2, 0, 0),
  [3538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cairo_0_struct_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(1372),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [3547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [3573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 6, 0, 89),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [3583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [3589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [3593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_identifier, 3, 0, 26),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [3599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_identifier, 1, 0, 0),
  [3601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [3603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [3605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [3609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [3611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [3617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inst_jmp_to_label, 2, 0, 0),
  [3619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [3621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_jmp_to_label, 2, 0, 0),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [3625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1924),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [3634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [3644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [3648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_identifier, 4, 0, 50),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [3660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 11, 0, 90),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [3666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 11, 0, 89),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [3670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 11, 0, 98),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [3676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [3680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(1206),
  [3683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0),
  [3685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [3689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [3699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_identifier, 4, 0, 50),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [3703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [3707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [3711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [3713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [3717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cairo_0_tuple_type_repeat1, 2, 0, 0),
  [3719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cairo_0_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1063),
  [3722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4, 0, 0),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [3734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [3744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [3746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [3758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_python_code_repeat1, 2, 0, 0),
  [3760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_python_code_repeat1, 2, 0, 0), SHIFT_REPEAT(1365),
  [3763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shorthand_field_initializer, 2, 0, 0),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [3771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 9, 0, 82),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [3775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cairo_0_call_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(835),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [3782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [3786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [3790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [3792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [3794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [3796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2, 0, 0),
  [3798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [3814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [3824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [3826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [3828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [3830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [3832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 3, 0, 71),
  [3834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [3836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 11, 0, 0),
  [3838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [3840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [3842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [3844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [3846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [3848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [3850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [3852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(1264),
  [3855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_pattern_repeat1, 2, 0, 0),
  [3857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 9, 0, 90),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [3863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_use_list, 2, 0, 17),
  [3865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [3871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 12, 0, 89),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [3879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 12, 0, 98),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [3883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cairo_1_type_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(524),
  [3886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cairo_1_type_arguments_repeat1, 2, 0, 0),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [3890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cairo_0_attribute_statement_repeat1, 2, 0, 0),
  [3892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cairo_0_attribute_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1413),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [3897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 8, 0, 82),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [3901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 13, 0, 98),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [3915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 4, 0, 0),
  [3917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [3919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [3931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [3933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2, 0, 0), SHIFT_REPEAT(785),
  [3936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2, 0, 0),
  [3938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 2, 0, 53),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [3948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shorthand_field_initializer, 1, 0, 0),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [3952] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(286),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [3957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__ref_binding, 2, 0, 0), REDUCE(sym_tuple_pattern, 2, 0, 0),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [3974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 3, 0, 83),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [3982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [3994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 9, 0, 0),
  [3996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [3998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 5, 0, 0),
  [4000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [4002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [4006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 6, 0, 0),
  [4008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [4012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [4014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [4016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 1, 0, 25),
  [4018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [4030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [4032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [4034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [4060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 7, 0, 0),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [4064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_type, 3, 0, 26),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [4078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 3, 0, 0),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [4082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 8, 0, 0),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [4086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 9, 0, 89),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [4096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cairo_1_tuple_type_repeat1, 2, 0, 0),
  [4098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cairo_1_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(695),
  [4101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 3, 0, 38),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [4107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 0),
  [4109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(745),
  [4112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_use_list, 3, 0, 39),
  [4114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 3, 0, 40),
  [4116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 8, 0, 90),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [4132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1128),
  [4135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [4141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [4143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [4145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat2, 2, 0, 0), SHIFT_REPEAT(1196),
  [4148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat2, 2, 0, 0),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [4154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_use_list, 3, 0, 41),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [4168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 66), SHIFT_REPEAT(1506),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [4175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [4177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 10, 0, 82),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [4189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 10, 0, 90),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [4193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 10, 0, 89),
  [4195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [4203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(838),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [4210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 10, 0, 0),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [4214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 10, 0, 98),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [4236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [4238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__cairo_1_call_expression_repeat1, 2, 0, 66),
  [4240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__cairo_1_call_expression_repeat1, 2, 0, 66), SHIFT_REPEAT(202),
  [4243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 5, 0, 0),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [4247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_python_code, 1, 0, 0),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [4257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [4261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [4269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 6, 0, 0),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [4297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_identifier, 3, 0, 26),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [4305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 7, 0, 82),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [4313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [4315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [4319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1202),
  [4322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2, 0, 0),
  [4324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_instruction, 2, 0, 0),
  [4326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_instruction, 2, 0, 0),
  [4328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3, 0, 0),
  [4330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_signature_repeat1, 2, 0, 0),
  [4332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_signature_repeat1, 2, 0, 0), SHIFT_REPEAT(1185),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [4343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 5, 0, 82),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [4347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [4355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 1, 0, 0),
  [4357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 3, 0, 70),
  [4359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [4361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [4369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [4377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 8, 0, 98),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [4381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 7, 0, 89),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [4385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 0),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [4391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [4393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [4395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [4397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [4403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat2, 3, 0, 0),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [4407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 11, 0, 82),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [4411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 12, 0, 90),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [4415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 12, 0, 0),
  [4417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 13, 0, 89),
  [4419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 14, 0, 98),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [4423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_signature, 6, 0, 90),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [4427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 5, 0, 93),
  [4429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [4437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [4439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [4441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type_parameter, 2, 0, 52),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [4455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [4457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 0),
  [4459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [4465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [4467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [4469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [4473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [4477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [4479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [4481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [4485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [4487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 3, 0, 0),
  [4489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [4491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [4493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 68),
  [4495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [4501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type_parameter, 3, 0, 69),
  [4503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 4, 0, 85),
  [4505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [4509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [4511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [4513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [4515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [4537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_arguments, 7, 0, 0),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [4547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [4551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [4555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [4557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [4559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [4607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_arguments, 2, 0, 0),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [4621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [4641] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [4647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_arguments, 4, 0, 0),
  [4649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_arguments, 3, 0, 0),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [4653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [4669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [4671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [4673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [4677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [4679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [4681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [4685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [4687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [4693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [4695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, 0, 0),
  [4697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_arguments, 4, 0, 0),
  [4699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_arguments, 3, 0, 0),
  [4701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [4707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_arguments, 5, 0, 0),
  [4709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [4715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [4723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ref_binding, 4, 0, 0),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [4743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_arguments, 2, 0, 0),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [4749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ref_binding, 2, 0, 0),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [4759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [4771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_arguments, 6, 0, 0),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [4777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_arguments, 5, 0, 0),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [4807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ref_binding, 5, 0, 0),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [4813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ref_binding, 3, 0, 0),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_PERCENT_LBRACE = 0,
  ts_external_token_code_line = 1,
  ts_external_token__failure = 2,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_PERCENT_LBRACE] = anon_sym_PERCENT_LBRACE,
  [ts_external_token_code_line] = sym_code_line,
  [ts_external_token__failure] = sym__failure,
};

static const bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_code_line] = true,
    [ts_external_token__failure] = true,
  },
  [2] = {
    [ts_external_token_PERCENT_LBRACE] = true,
  },
  [3] = {
    [ts_external_token_code_line] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_cairo_external_scanner_create(void);
void tree_sitter_cairo_external_scanner_destroy(void *);
bool tree_sitter_cairo_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_cairo_external_scanner_serialize(void *, char *);
void tree_sitter_cairo_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_cairo(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_cairo_external_scanner_create,
      tree_sitter_cairo_external_scanner_destroy,
      tree_sitter_cairo_external_scanner_scan,
      tree_sitter_cairo_external_scanner_serialize,
      tree_sitter_cairo_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
